 /* ++ BUILD Version: 0001                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright (c) 1991-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     adserr.mc                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Error codes for ADs                                           */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */


 /*                                                                   */
 /*  Values are 32 bit values layed out as follows:                   */
 /*                                                                   */
 /*   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                     */
 /*   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 */
 /*  +---+-+-+-----------------------+-------------------------------+*/
 /*  |Sev|C|R|     Facility          |               Code            |*/
 /*  +---+-+-+-----------------------+-------------------------------+*/
 /*                                                                   */
 /*  where                                                            */
 /*                                                                   */
 /*      Sev - is the severity code                                   */
 /*                                                                   */
 /*          00 - Success                                             */
 /*          01 - Informational                                       */
 /*          10 - Warning                                             */
 /*          11 - Error                                               */
 /*                                                                   */
 /*      C - is the Customer code flag                                */
 /*                                                                   */
 /*      R - is a reserved bit                                        */
 /*                                                                   */
 /*      Facility - is the facility code                              */
 /*                                                                   */
 /*      Code - is the facility's status code                         */
 /*                                                                   */
 /*                                                                   */

 %if 0 = 1 %then %do; /* see winerror.cpy */
 dcl FACILITY_WINDOWS                  fixed bin(16) unsigned value( 8);
 dcl FACILITY_STORAGE                  fixed bin(16) unsigned value( 3);
 dcl FACILITY_RPC                      fixed bin(16) unsigned value( 1);
 dcl FACILITY_SSPI                     fixed bin(16) unsigned value( 9);
 dcl FACILITY_WIN32                    fixed bin(16) unsigned value( 7);
 dcl FACILITY_CONTROL                  fixed bin(16) unsigned value(10);
 dcl FACILITY_NULL                     fixed bin(16) unsigned value( 0);
 dcl FACILITY_ITF                      fixed bin(16) unsigned value( 4);
 dcl FACILITY_DISPATCH                 fixed bin(16) unsigned value( 2);
 %end;


 /*                                                                   */
 /* MessageId: E_ADS_BAD_PATHNAME                                     */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An invalid directory pathname was passed                         */
 /*                                                                   */
 dcl E_ADS_BAD_PATHNAME                type HRESULT value('80005000'xn);

 /*                                                                   */
 /* MessageId: E_ADS_INVALID_DOMAIN_OBJECT                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unknown directory domain object was requested                 */
 /*                                                                   */
 dcl E_ADS_INVALID_DOMAIN_OBJECT       type HRESULT value('80005001'xn);

 /*                                                                   */
 /* MessageId: E_ADS_INVALID_USER_OBJECT                              */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unknown directory user object was requested                   */
 /*                                                                   */
 dcl E_ADS_INVALID_USER_OBJECT         type HRESULT value('80005002'xn);

 /*                                                                   */
 /* MessageId: E_ADS_INVALID_COMPUTER_OBJECT                          */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unknown directory computer object was requested               */
 /*                                                                   */
 dcl E_ADS_INVALID_COMPUTER_OBJECT     type HRESULT value('80005003'xn);

 /*                                                                   */
 /* MessageId: E_ADS_UNKNOWN_OBJECT                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  An unknown directory object was requested                        */
 /*                                                                   */
 dcl E_ADS_UNKNOWN_OBJECT              type HRESULT value('80005004'xn);

 /*                                                                   */
 /* MessageId: E_ADS_PROPERTY_NOT_SET                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory property was not set                     */
 /*                                                                   */
 dcl E_ADS_PROPERTY_NOT_SET            type HRESULT value('80005005'xn);

 /*                                                                   */
 /* MessageId: E_ADS_PROPERTY_NOT_SUPPORTED                           */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory property is not supported                */
 /*                                                                   */
 dcl E_ADS_PROPERTY_NOT_SUPPORTED      type HRESULT value('80005006'xn);

 /*                                                                   */
 /* MessageId: E_ADS_PROPERTY_INVALID                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory property is invalid                      */
 /*                                                                   */
 dcl E_ADS_PROPERTY_INVALID            type HRESULT value('80005007'xn);

 /*                                                                   */
 /* MessageId: E_ADS_BAD_PARAMETER                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more input parameters are invalid                         */
 /*                                                                   */
 dcl E_ADS_BAD_PARAMETER               type HRESULT value('80005008'xn);

 /*                                                                   */
 /* MessageId: E_ADS_OBJECT_UNBOUND                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory object is not bound to a remote resource */
 /*                                                                   */
 dcl E_ADS_OBJECT_UNBOUND              type HRESULT value('80005009'xn);

 /*                                                                   */
 /* MessageId: E_ADS_PROPERTY_NOT_MODIFIED                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory object has not been modified             */
 /*                                                                   */
 dcl E_ADS_PROPERTY_NOT_MODIFIED       type HRESULT value('8000500A'xn);

 /*                                                                   */
 /* MessageId: E_ADS_PROPERTY_MODIFIED                                */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified directory object has been modified                 */
 /*                                                                   */
 dcl E_ADS_PROPERTY_MODIFIED           type HRESULT value('8000500B'xn);

 /*                                                                   */
 /* MessageId: E_ADS_CANT_CONVERT_DATATYPE                            */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory datatype cannot be converted to/from a native DS data
 type */
 /*                                                                   */
 dcl E_ADS_CANT_CONVERT_DATATYPE       type HRESULT value('8000500C'xn);

 /*                                                                   */
 /* MessageId: E_ADS_PROPERTY_NOT_FOUND                               */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory property cannot be found in the cache.             */
 /*                                                                   */
 dcl E_ADS_PROPERTY_NOT_FOUND          type HRESULT value('8000500D'xn);

 /*                                                                   */
 /* MessageId: E_ADS_OBJECT_EXISTS                                    */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The directory object exists.                                     */
 /*                                                                   */
 dcl E_ADS_OBJECT_EXISTS               type HRESULT value('8000500E'xn);

 /*                                                                   */
 /* MessageId: E_ADS_SCHEMA_VIOLATION                                 */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The attempted action violates the DS schema rules.               */
 /*                                                                   */
 dcl E_ADS_SCHEMA_VIOLATION            type HRESULT value('8000500F'xn);

 /*                                                                   */
 /* MessageId: E_ADS_COLUMN_NOT_SET                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The specified column in the directory was not set.               */
 /*                                                                   */
 dcl E_ADS_COLUMN_NOT_SET              type HRESULT value('80005010'xn);

 /*                                                                   */
 /* MessageId: S_ADS_ERRORSOCCURRED                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  One or more errors occurred                                      */
 /*                                                                   */
 dcl S_ADS_ERRORSOCCURRED              type HRESULT value('00005011'xn);

 /*                                                                   */
 /* MessageId: S_ADS_NOMORE_ROWS                                      */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more rows to be obatained by the search result.               */
 /*                                                                   */
 dcl S_ADS_NOMORE_ROWS                 type HRESULT value('00005012'xn);

 /*                                                                   */
 /* MessageId: S_ADS_NOMORE_COLUMNS                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  No more columns to be obatained for the current row.             */
 /*                                                                   */
 dcl S_ADS_NOMORE_COLUMNS              type HRESULT value('00005013'xn);

 /*                                                                   */
 /* MessageId: E_ADS_INVALID_FILTER                                   */
 /*                                                                   */
 /* MessageText:                                                      */
 /*                                                                   */
 /*  The search filter specified is invalid                           */
 /*                                                                   */
 dcl E_ADS_INVALID_FILTER              type HRESULT value('80005014'xn);
