 /*+----------------------------------------------------------------- */
 /*                                                                   */
 /*  Microsoft Windows                                                */
 /*  Copyright (C) Microsoft Corporation, 1996-1999                   */
 /*                                                                   */
 /*  File:       adshlp.cpy                                           */
 /*                                                                   */
 /*  Contents:   Public header file for all oleds client code         */
 /*                                                                   */
 /*------------------------------------------------------------------ */

 %dcl #ADSHLP_ char ext;
 %if #ADSHLP_ = '' %then %do;
 %#ADSHLP_ = 'Y';


 /* Declaration from oaidl.h needed here, and thus copied. */
 /* Eliminate from here when oaidl.cpy available.          */

 define structure
   1 VARIANT,
    2 __VARIANT_NAME_1 union,
      3 __VARIANT_NAME_2,
        4 vt type VARTYPE,
        4 wReserved1 type WORD,
        4 wReserved2 type WORD,
        4 wReserved3 type WORD,
        4 __VARIANT_NAME_3 union,
          5 llVal type LONGLONG,
          5 lVal type LONG,
          5 bVal type BYTE,
          5 iVal type SHORT,
          5 fltVal type FLOAT,
          5 dblVal type DOUBLE,
          5 boolVal type VARIANT_BOOL,
          /* 5 bool type _VARIANT_BOOL, C expands to comment */
          5 scode type SCODE,
          5 cyVal type CY,
          5 date type DATE,
          5 bstrVal type BSTR,
          5 punkVal pointer,
          5 pdispVal pointer,
          5 parray pointer,
          5 pbVal pointer, /* handle SAFEARRAY */
          5 piVal pointer,
          5 plVal pointer,
          5 pllVal pointer,
          5 pfltVal pointer,
          5 pdblVal pointer,
          5 pboolVal pointer,
          5 pbool pointer,
          5 pscode pointer,
          5 pcyVal handle CY,
          5 pdate pointer,
          5 pbstrVal pointer,
          5 ppunkVal pointer,
          5 ppdispVal pointer,
          5 pparray pointer,
          5 pvarVal handle VARIANT,
          5 byref type PVOID,
          5 cVal char(1),
          5 uiVal type USHORT,
          5 ulVal type ULONG,
          5 ullVal type ULONGLONG,
          5 intVal type INT,
          5 uintVal type UINT,
          5 pdecVal pointer,
          5 pcVal pointer,
          5 puiVal pointer,
          5 pulVal pointer,
          5 pullVal pointer,
          5 pintVal pointer,
          5 puintVal pointer,
          5  __VARIANT_NAME_4,
            6 pvRecord type PVOID,
            6 pRecInfo pointer,
      3 decVal type DECIMAL;

 define alias LPVARIANT  handle VARIANT;

 define alias   VARIANTARG   type VARIANT;
 define alias LPVARIANTARG handle VARIANTARG;


 /* Declarations from iads.h needed here, and thus copied. */
 /* Eliminate from here when iads.cpy available.           */

 define alias ADS_AUTHENTICATION_ENUM type DWORD;
 dcl ( ADS_SECURE_AUTHENTICATION  value (       '1'xu),
       ADS_USE_ENCRYPTION         value (       '2'xu),
       ADS_USE_SSL                value (       '2'xu),
       ADS_READONLY_SERVER        value (       '4'xu),
       ADS_PROMPT_CREDENTIALS     value (       '8'xu),
       ADS_NO_AUTHENTICATION      value (      '10'xu),
       ADS_FAST_BIND              value (      '20'xu),
       ADS_USE_SIGNING            value (      '40'xu),
       ADS_USE_SEALING            value (      '80'xu),
       ADS_USE_DELEGATION         value (     '100'xu),
       ADS_SERVER_BIND            value (     '200'xu),
       ADS_AUTH_RESERVED          value ('80000000'xu)
     ) type ADS_AUTHENTICATION_ENUM;


 /* Start of adshlp.cpy proper */

 dcl ADsGetObject
     entry (WCHAR(*) varz byaddr nonasgn,
            type REFIID,
            pointer byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsGetObject');


 dcl ADsBuildEnumerator
     entry (pointer,                         /* to type IADsContainer */
            pointer byaddr)                  /* to type IEnumVARIANT */
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsBuildEnumerator');

 dcl ADsFreeEnumerator
     entry (pointer)                         /* to type IEnumVARIANT  */
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsFreeEnumerator');

 dcl ADsEnumerateNext
     entry (pointer,                         /* to type IEnumVARIANT  */
            type ULONG,
            type VARIANT byaddr,
            type ULONG byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsEnumerateNext');

 dcl ADsBuildVarArrayStr
     entry ((*) type LPWSTR byaddr,
            type DWORD,
            type VARIANT byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsBuildVarArrayStr');

 dcl ADsBuildVarArrayInt
     entry ((*) type DWORD byaddr,
            type DWORD,
            type VARIANT byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsBuildVarArrayInt');


 dcl ADsOpenObject
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type REFIID,
            pointer byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsOpenObject');

 /*                                             */
 /* Helper functions for extended error support */
 /*                                             */

 dcl ADsGetLastError
     entry (type DWORD byaddr,
            WCHAR(*) varz byaddr,
            type DWORD,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsGetLastError');

 dcl ADsSetLastError
     entry (type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn)
     WINAPI external('ADsSetLastError');

 %if 0 = 1 %then %do; /* obsolete */
 dcl ADsFreeAllErrorRecords
     entry ()
     WINAPI external('ADsFreeAllErrorRecords');
 %end; /* obsolete */

 dcl AllocADsMem
     entry (type DWORD)
     returns (type LPVOID byvalue optional)
     WINAPI external('AllocADsMem');

 dcl FreeADsMem
     entry (type LPVOID)
     returns (type BOOL byvalue optional)
     WINAPI external('FreeADsMem');

 dcl ReallocADsMem
     entry (type LPVOID,
            type DWORD,
            type DWORD)
     returns (type LPVOID byvalue optional)
     WINAPI external('ReallocADsMem');

 dcl AllocADsStr
     entry (WCHAR(*) varz byaddr nonasgn)
     returns (type LPWSTR byvalue optional)
     WINAPI external('AllocADsStr');

 dcl FreeADsStr
     entry (type LPWSTR)
     returns (type BOOL byvalue optional)
     WINAPI external('FreeADsStr');


 dcl ReallocADsStr
     entry (type LPWSTR byaddr,
            WCHAR(*) varz byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('ReallocADsStr');


 dcl ADsEncodeBinaryData
     entry (type PBYTE,
            type DWORD,
            type LPWSTR byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsEncodeBinaryData');

 %if 0 = 1 %then %do; /* obsolete */
 dcl ADsDecodeBinaryData
     entry (WCHAR(*) varz byaddr nonasgn,
            type PBYTE byaddr,
            type ULONG byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('ADsDecodeBinaryData');

 dcl PropVariantToAdsType
     entry (type VARIANT byaddr,
            type DWORD,
            type PADSVALUE byaddr,
            type DWORD byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('PropVariantToAdsType');

 dcl AdsTypeToPropVariant
     entry (type PADSVALUE,
            type DWORD,
            type VARIANT byaddr)
     returns (type HRESULT byvalue optional)
     WINAPI external('AdsTypeToPropVariant');

 dcl AdsFreeAdsValues
     entry (type PADSVALUE,
            type DWORD)
     WINAPI external('AdsFreeAdsValues');
 %end; /* obsolete */

 /*                                                               */
 /* Helper routines to convert IADsSecurityDescriptor to a binary */
 /* security descriptor and also to convert a binary SD to        */
 /* IADsSecurityDescriptor.                                       */
 /*                                                               */
 dcl BinarySDToSecurityDescriptor
     entry (type PSECURITY_DESCRIPTOR,
            type VARIANT byaddr,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type HRESULT byvalue optional)
     WINAPI external('BinarySDToSecurityDescriptor');

 dcl SecurityDescriptorToBinarySD
     entry (type VARIANT,
            type PSECURITY_DESCRIPTOR byaddr,
            type PDWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type HRESULT byvalue optional)
     WINAPI external('SecurityDescriptorToBinarySD');

 %if 0 = 1 %then %do; /* obsolete */
 %dcl DBG fixed ext;
 %if DBG ^= 0 %then %do;

 dcl ADsMemList type LIST_ENTRY
                static external reserved (imported) nonasgn;

 dcl ADsMemCritSect type CRITICAL_SECTION
                    static external reserved (imported) nonasgn;

 dcl InitADsMem
     entry ()
     options (byvalue nodescriptor) external('InitADsMem');

 dcl AssertADsMemLeaks
     entry ()
     options (byvalue nodescriptor) external('AssertADsMemLeaks');


 dcl DumpMemoryTracker
     entry ()
     options (byvalue nodescriptor) external('DumpMemoryTracker');

 %end; %else %do;

 InitADsMem: proc () options (inline);
 end InitADsMem;

 AssertADsMemLeaks: proc () options (inline);
 end AssertADsMemLeaks;

 DumpMemoryTracker: proc () options (inline);
 end DumpMemoryTracker;
 %end;
 %end; /* obsolete */

 %end; /* _ADSHLP_ */

