 /* ++ BUILD Version: 0003                                            */
 /*         -- Increment this if a change has global effects          */
 /*                                                                   */
 /* Copyright (c) 1985-1999, Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     ime.cpy                                                       */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Procedure declarations, constant definitions and macros for   */
 /*     the IME component.                                            */
 /* --                                                                */

 %dcl #IME_ char ext;
 %if #IME_ = '' %then %do;
 %#IME_ = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl UNICODE char ext;
 dcl IME_MAXPROCESS fixed bin(31) value(32);

 dcl SendIMEMessageExA
     entry (type HWND,
            type LPARAM)
     returns (type LRESULT byvalue optional)
     WINAPI external ('SendIMEMessageExA');
 dcl SendIMEMessageExW
     entry (type HWND,
            type LPARAM)
     returns (type LRESULT byvalue optional)
     WINAPI external ('SendIMEMessageExW');

 %dcl SendIMEMessageEx char ext;
 %if UNICODE ^= '' %then %do;
   %SendIMEMessageEx='SendIMEMessageExW';
 %end; %else %do;
   %SendIMEMessageEx='SendIMEMessageExA';
 %end; /* !UNICODE */

 /*                                          */
 /* IMESTRUCT structure for SendIMEMessageEx */
 /*                                          */
 define structure
   1 IMESTRUCT,
     2 fnc       type UINT,   /* function code */
     2 wParam    type WPARAM, /* word parameter */
     2 wCount    type UINT,   /* word counter */
     2 dchSource type UINT,
                 /* offset to Source from top of memory object */
     2 dchDest   type UINT,
                 /* offset to Destination from top of memory object */
     2 lParam1   type LPARAM,
     2 lParam2   type LPARAM,
     2 lParam3   type LPARAM;

 define alias  PIMESTRUCT handle IMESTRUCT;
 define alias NPIMESTRUCT handle IMESTRUCT;
 define alias LPIMESTRUCT handle IMESTRUCT;


 dcl CP_HWND   type UINT value(0);
 dcl CP_OPEN   type UINT value(1);
 dcl CP_DIRECT type UINT value(2);
 dcl CP_LEVEL  type UINT value(3);


 /*                   */
 /*      Virtual Keys */
 /*                   */

 dcl VK_DBE_ALPHANUMERIC           type BYTE value('0f0'xu);
 dcl VK_DBE_KATAKANA               type BYTE value('0f1'xu);
 dcl VK_DBE_HIRAGANA               type BYTE value('0f2'xu);
 dcl VK_DBE_SBCSCHAR               type BYTE value('0f3'xu);
 dcl VK_DBE_DBCSCHAR               type BYTE value('0f4'xu);
 dcl VK_DBE_ROMAN                  type BYTE value('0f5'xu);
 dcl VK_DBE_NOROMAN                type BYTE value('0f6'xu);
 dcl VK_DBE_ENTERWORDREGISTERMODE  type BYTE value('0f7'xu);
 dcl VK_DBE_ENTERIMECONFIGMODE     type BYTE value('0f8'xu);
 dcl VK_DBE_FLUSHSTRING            type BYTE value('0f9'xu);
 dcl VK_DBE_CODEINPUT              type BYTE value('0fa'xu);
 dcl VK_DBE_NOCODEINPUT            type BYTE value('0fb'xu);
 dcl VK_DBE_DETERMINESTRING        type BYTE value('0fc'xu);
 dcl VK_DBE_ENTERDLGCONVERSIONMODE type BYTE value('0fd'xu);



 /*                                                  */
 /*     switch for wParam of IME_SETCONVERSIONWINDOW */
 /*                                                  */
 dcl MCW_DEFAULT               type BYTE value('00'xu);
 dcl MCW_RECT                  type BYTE value('01'xu);
 dcl MCW_WINDOW                type BYTE value('02'xu);
 dcl MCW_SCREEN                type BYTE value('04'xu);
 dcl MCW_VERTICAL              type BYTE value('08'xu);
 dcl MCW_HIDDEN                type BYTE value('10'xu);

 /*                                               */
 /*    switch for wParam of IME_SETCONVERSIONMODE */
 /*       and IME_GETCONVERSIONMODE               */
 /*                                               */
 dcl IME_MODE_ALPHANUMERIC     type USHORT value('0001'xu);

 %dcl KOREA char ext;
 %if KOREA ^= '' %then %do;
 dcl IME_MODE_SBCSCHAR         type USHORT value('0002'xu);
 %end; %else %do;
 dcl IME_MODE_SBCSCHAR         type USHORT value('0008'xu);
 %end;

 dcl IME_MODE_KATAKANA         type USHORT value('0002'xu);
 dcl IME_MODE_HIRAGANA         type USHORT value('0004'xu);
 dcl IME_MODE_HANJACONVERT     type USHORT value('0004'xu);
 dcl IME_MODE_DBCSCHAR         type USHORT value('0010'xu);
 dcl IME_MODE_ROMAN            type USHORT value('0020'xu);
 dcl IME_MODE_NOROMAN          type USHORT value('0040'xu);
 dcl IME_MODE_CODEINPUT        type USHORT value('0080'xu);
 dcl IME_MODE_NOCODEINPUT      type USHORT value('0100'xu);

 /*              */
 /*     IME APIs */
 /*              */
 dcl IME_GETIMECAPS            type BYTE value('03'xu);
 dcl IME_SETOPEN               type BYTE value('04'xu);
 dcl IME_GETOPEN               type BYTE value('05'xu);
 dcl IME_GETVERSION            type BYTE value('07'xu);
 dcl IME_SETCONVERSIONWINDOW   type BYTE value('08'xu);
 dcl IME_MOVEIMEWINDOW         type BYTE value(IME_SETCONVERSIONWINDOW);
 /* KOREA only */
 dcl IME_SETCONVERSIONMODE     type BYTE value('10'xu);

 dcl IME_GETCONVERSIONMODE     type BYTE value('11'xu);
 dcl IME_SET_MODE              type BYTE value('12'xu); /* KOREA only */
 dcl IME_SENDVKEY              type BYTE value('13'xu);
 dcl IME_ENTERWORDREGISTERMODE type BYTE value('18'xu);
 dcl IME_SETCONVERSIONFONTEX   type BYTE value('19'xu);

 /*                              */
 /* IME_CODECONVERT subfunctions */
 /*                              */
 dcl IME_BANJAtoJUNJA          type BYTE value('13'xu); /* KOREA only */
 dcl IME_JUNJAtoBANJA          type BYTE value('14'xu); /* KOREA only */
 dcl IME_JOHABtoKS             type BYTE value('15'xu); /* KOREA only */
 dcl IME_KStoJOHAB             type BYTE value('16'xu); /* KOREA only */

 /*                           */
 /* IME_AUTOMATA subfunctions */
 /*                           */
 dcl IMEA_INIT                 type BYTE value('01'xu); /* KOREA only */
 dcl IMEA_NEXT                 type BYTE value('02'xu); /* KOREA only */
 dcl IMEA_PREV                 type BYTE value('03'xu); /* KOREA only */

 /*                            */
 /* IME_HANJAMODE subfunctions */
 /*                            */
 dcl IME_REQUEST_CONVERT       type BYTE value('01'xu); /* KOREA only */
 dcl IME_ENABLE_CONVERT        type BYTE value('02'xu); /* KOREA only */

 /*                                */
 /* IME_MOVEIMEWINDOW subfunctions */
 /*                                */
 dcl INTERIM_WINDOW            type BYTE value('00'xu); /* KOREA only */
 dcl MODE_WINDOW               type BYTE value('01'xu); /* KOREA only */
 dcl HANJA_WINDOW              type BYTE value('02'xu); /* KOREA only */

 /* */
 /*    error code */
 /* */
 dcl IME_RS_ERROR              type BYTE value('01'xu);
                               /* general error */
 dcl IME_RS_NOIME              type BYTE value('02'xu);
                               /* IME is not installed */
 dcl IME_RS_TOOLONG            type BYTE value('05'xu);
                               /* given string is too long */
 dcl IME_RS_ILLEGAL            type BYTE value('06'xu);
                               /* illegal charactor(s) is string */
 dcl IME_RS_NOTFOUND           type BYTE value('07'xu);
                               /* no (more) candidate */
 dcl IME_RS_NOROOM             type BYTE value('0a'xu);
                               /* no disk/memory space */
 dcl IME_RS_DISKERROR          type BYTE value('0e'xu);
                               /* disk I/O error */
 dcl IME_RS_INVALID            type BYTE value('11'xu);
                               /* Win3.1/NT */
 dcl IME_RS_NEST               type BYTE value('12'xu);
                               /* called nested */
 dcl IME_RS_SYSTEMMODAL        type BYTE value('13'xu);
                               /* called when system mode */

 /*                                      */
 /*   report message from IME to WinApps */
 /*                                      */
 dcl WM_IME_REPORT             type USHORT value('0280'xu);

 /*                                              */
 /*   report message parameter for WM_IME_REPORT */
 /*                                              */
 dcl IR_STRINGSTART            type USHORT value('100'xu);
 dcl IR_STRINGEND              type USHORT value('101'xu);
 dcl IR_OPENCONVERT            type USHORT value('120'xu);
 dcl IR_CHANGECONVERT          type USHORT value('121'xu);
 dcl IR_CLOSECONVERT           type USHORT value('122'xu);
 dcl IR_FULLCONVERT            type USHORT value('123'xu);
 dcl IR_IMESELECT              type USHORT value('130'xu);
 dcl IR_STRING                 type USHORT value('140'xu);
 dcl IR_DBCSCHAR               type USHORT value('160'xu);
 dcl IR_UNDETERMINE            type USHORT value('170'xu);
 dcl IR_STRINGEX               type USHORT value('180'xu);
                               /* New for 3.1 */
 dcl IR_MODEINFO               type USHORT value('190'xu);

 /* dcl WM_CONVERTREQUESTEX    type USHORT value('0109'xu) */
 dcl WM_WNT_CONVERTREQUESTEX   type USHORT value('0109'xu);
  /* WM_CONVERTREQUESTEX: 109 for NT, 108 for OT */
 dcl WM_CONVERTREQUEST         type USHORT value('010A'xu);
 dcl WM_CONVERTRESULT          type USHORT value('010B'xu);
 dcl WM_INTERIM                type USHORT value('010C'xu);

 dcl WM_IMEKEYDOWN             type USHORT value('290'xu);
 dcl WM_IMEKEYUP               type USHORT value('291'xu);


 /*                                                */
 /* UNDETERMINESTRING structure for IR_UNDETERMINE */
 /*                                                */
 define structure
   1 UNDETERMINESTRUCT,
     2 dwSize             type DWORD,
     2 uDefIMESize        type UINT,
     2 uDefIMEPos         type UINT,
     2 uUndetTextLen      type UINT,
     2 uUndetTextPos      type UINT,
     2 uUndetAttrPos      type UINT,
     2 uCursorPos         type UINT,
     2 uDeltaStart        type UINT,
     2 uDetermineTextLen  type UINT,
     2 uDetermineTextPos  type UINT,
     2 uDetermineDelimPos type UINT,
     2 uYomiTextLen       type UINT,
     2 uYomiTextPos       type UINT,
     2 uYomiDelimPos      type UINT;

 define alias  PUNDETERMINESTRUCT handle UNDETERMINESTRUCT;
 define alias NPUNDETERMINESTRUCT handle UNDETERMINESTRUCT;
 define alias LPUNDETERMINESTRUCT handle UNDETERMINESTRUCT;


 define structure
   1 STRINGEXSTRUCT,
     2 dwSize             type DWORD,
     2 uDeterminePos      type UINT,
     2 uDetermineDelimPos type UINT,
     2 uYomiPos           type UINT,
     2 uYomiDelimPos      type UINT;

 define alias NPSTRINGEXSTRUCT handle STRINGEXSTRUCT;
 define alias LPSTRINGEXSTRUCT handle STRINGEXSTRUCT;

 %end; /* _IME_ */

