 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1998-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   netsetup.cpy (???)                                              */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   Definitions and prototypes for the Net setup apis,              */
 /*   for joining/unjoining domains and promoting/demoting servers    */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*   Portable to any flat, 32-bit environment. (Uses Win32 typedefs.)*/
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /* --                                                                */

 %dcl #_LMJOIN_H__ char ext;
 %if #_LMJOIN_H__ = '' %then %do;
 %#_LMJOIN_H__ = 'Y';

 %dcl #WIN32_WINNT fixed ext;


 /* Types of name that can be validated */

 define ordinal NETSETUP_NAME_TYPE
   ( NetSetupUnknown value(0),
     NetSetupMachine,
     NetSetupWorkgroup,
     NetSetupDomain,
     NetSetupNonExistentDomain
 %if #WIN32_WINNT >= 1280 %then %do;
   , NetSetupDnsMachine
 %end;
   ) prec (31);
 dcl PNETSETUP_NAME_TYPE pointer;


 /* Status of a workstation */

 define ordinal NETSETUP_JOIN_STATUS
   ( NetSetupUnknownStatus value(0),
     NetSetupUnjoined,
     NetSetupWorkgroupName,
     NetSetupDomainName
   ) prec(31);
 dcl PNETSETUP_JOIN_STATUS pointer;


 /* Flags to determine the behavior of the join/unjoin APIs */

 dcl NETSETUP_JOIN_DOMAIN           type DWORD value('00000001'xu);
     /* If not present, workgroup is joined */
 dcl NETSETUP_ACCT_CREATE           type DWORD value('00000002'xu);
     /* Do the server side account creation/rename */
 dcl NETSETUP_ACCT_DELETE           type DWORD value('00000004'xu);
     /* Delete the account when a domain is left */
 dcl NETSETUP_WIN9X_UPGRADE         type DWORD value('00000010'xu);
     /* Invoked during upgrade of Windows 9x to Windows NT */
 dcl NETSETUP_DOMAIN_JOIN_IF_JOINED type DWORD value('00000020'xu) ;
     /* Allow the client to join a new domain */
     /* even if it is already joined to a domain */
 dcl NETSETUP_JOIN_UNSECURE         type DWORD value('00000040'xu);
     /* Performs an unsecure join */

 dcl NETSETUP_INSTALL_INVOCATION    type DWORD value('00040000'xu);
     /* The APIs were invoked during install */

 /* '80000000'XU is reserved for internal use only */


 /* Joins a machine to the domain. */

 dcl NetJoinDomain
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetJoinDomain');

 dcl NetUnjoinDomain
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetUnjoinDomain');

 dcl NetRenameMachineInDomain
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetRenameMachineInDomain');


 /* Determine the validity of a name */

 dcl NetValidateName
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type NETSETUP_NAME_TYPE)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetValidateName');


 /* Determines whether a workstation is joined to a domain or not */

 dcl NetGetJoinInformation
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type LPWSTR byaddr,
            type NETSETUP_JOIN_STATUS byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGetJoinInformation');


 /* Determines the list of OUs that the client can create a machine */
 /* account in                                                      */

 dcl NetGetJoinableOUs
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            pointer byaddr) /* to (*) type LPWSTR */
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetGetJoinableOUs');

 %end; /* __LMJOIN_H__ */
