 /* ++                                                                */
 /*                                                                   */
 /* Copyright 1995 - 1998 Microsoft Corporation                       */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     loadperf.cpy                                                  */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Header file for the Performance Monitor counter string        */
 /*     installation and removal functions.                           */
 /*                                                                   */
 /* Revision History                                                  */
 /*                                                                   */
 /*     16-Nov-95   Created (a-robw)                                  */
 /*                                                                   */
 /* --                                                                */

 %dcl #LOADPERF_H_ char ext;
 %if #LOADPERF_H_ = '' %then %do;
 %#LOADPERF_H_ = 'Y';

 %dcl UNICODE char ext;

 /* function prototypes for perf counter name string load & unload */
 /* functions provided in LOADPERF.DLL */

 %dcl LOADPERF_FUNCTION char ext;
 %LOADPERF_FUNCTION='returns (type LONG byvalue optional) '
                 || 'options (byvalue linkage(stdcall) nodescriptor)';

 dcl LoadPerfCounterTextStringsA
     entry (char(*) varz byaddr,
            type BOOL)
     LOADPERF_FUNCTION external('LoadPerfCounterTextStringsA');

 dcl LoadPerfCounterTextStringsW
     entry (WCHAR(*) varz byaddr,
            type BOOL)
     LOADPERF_FUNCTION external('LoadPerfCounterTextStringsW');

 dcl UnloadPerfCounterTextStringsW
     entry (WCHAR(*) varz byaddr,
            type BOOL)
     LOADPERF_FUNCTION external('UnloadPerfCounterTextStringsW');

 dcl UnloadPerfCounterTextStringsA
     entry (char(*) varz byaddr,
            type BOOL)
     LOADPERF_FUNCTION external('UnloadPerfCounterTextStringsA');

 %dcl LoadPerfCounterTextStrings   char ext;
 %dcl UnloadPerfCounterTextStrings char ext;
 %if UNICODE ^= '' %then  %do;
   %LoadPerfCounterTextStrings  ='LoadPerfCounterTextStringsW';
   %UnloadPerfCounterTextStrings='UnloadPerfCounterTextStringsW';
 %end; %else %do;
   %LoadPerfCounterTextStrings  ='LoadPerfCounterTextStringsA';
   %UnloadPerfCounterTextStrings='UnloadPerfCounterTextStringsA';
 %end;

 %end; /* _LOADPERF_H_ */
