 /* lzexpand.h - Public interface to LZ32.DLL */

 %dcl #LZEXPAND_ char ext;
 %if #LZEXPAND_ = '' %then %do;
 %#LZEXPAND_ = 'Y';

 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
 %include winbase;
 %end;

 %dcl UNICODE char ext;

 /* Error Return Codes */

 dcl LZERROR_BADINHANDLE  fixed bin(31) value(-1 );
     /* invalid input handle */
 dcl LZERROR_BADOUTHANDLE fixed bin(31) value(-2 );
     /* invalid output handle */
 dcl LZERROR_READ         fixed bin(31) value(-3 );
     /* corrupt compressed file format */
 dcl LZERROR_WRITE        fixed bin(31) value(-4 );
     /* out of space for output file */
 dcl LZERROR_GLOBALLOC    fixed bin(31) value(-5 );
     /* insufficient memory for LZFile struct */
 dcl LZERROR_GLOBLOCK     fixed bin(31) value(-6 );
     /* bad global handle */
 dcl LZERROR_BADVALUE     fixed bin(31) value(-7 );
     /* input parameter out of acceptable range*/
 dcl LZERROR_UNKNOWNALG   fixed bin(31) value(-8 );
     /* compression algorithm not recognized */


 /* Prototypes */

 dcl LZStart     /* obsolete */
     entry ()
     returns (type INT byvalue optional)
     APIENTRY external('LZStart');

 dcl LZDone      /* obsolete */
     entry ()
     APIENTRY external('LZDone');

 dcl CopyLZFile  /* obsolete - use LZCopy */
     entry (type INT,
            type INT)
     returns (type LONG byvalue optional)
     APIENTRY external('CopyLZFile');

 dcl LZCopy
     entry (type INT,
            type INT)
     returns (type LONG byvalue optional)
     APIENTRY external('LZCopy');

 dcl LZInit
     entry (type INT)
     returns (type INT byvalue optional)
     APIENTRY external('LZInit');

 dcl GetExpandedNameA
     entry (char (*) varz byaddr,
            char (*) varz byaddr)
     returns (type INT byvalue optional)
     APIENTRY external('GetExpandedNameA');
 dcl GetExpandedNameW
     entry (WCHAR (*) varz byaddr,
            WCHAR (*) varz byaddr)
     returns (type INT byvalue optional)
     APIENTRY external('GetExpandedNameW');

 %dcl GetExpandedName char ext;
 %if UNICODE ^= '' %then %do;
   %GetExpandedName='GetExpandedNameW';
 %end; %else %do;
   %GetExpandedName='GetExpandedNameA';
 %end; /* !UNICODE */

 dcl LZOpenFileA
     entry (char (*) varz byaddr,
            type OFSTRUCT byaddr,
            type WORD)
     returns (type INT byvalue optional)
     APIENTRY external('LZOpenFileA');
 dcl LZOpenFileW
     entry (WCHAR (*) varz byaddr,
            type OFSTRUCT byaddr,
            type WORD)
     returns (type INT byvalue optional)
     APIENTRY external('LZOpenFileW');

 %dcl LZOpenFile char ext;
 %if UNICODE ^= '' %then %do;
   %LZOpenFile='LZOpenFileW';
 %end; %else %do;
   %LZOpenFile='LZOpenFileA';
 %end; /* !UNICODE */

 dcl LZSeek
     entry (type INT,
            type LONG,
            type INT)
     returns (type LONG byvalue optional)
     APIENTRY external('LZSeek');

 dcl LZRead
     entry (type INT,
            type LPSTR, /* to buffer for bytes from file */
            type INT)
     returns (type INT byvalue optional)
     APIENTRY external('LZRead');

 dcl LZClose
     entry (type INT)
     APIENTRY external('LZClose');

 %end; /* _LZEXPAND_ */
