 /* ++ BUILD Version: 0000                                            */
 /* -- Increment this if a change has global effects                  */
 /*                                                                   */
 /* The Telephony API is jointly copyrighted by Intel and Microsoft.  */
 /* You are granted a royalty free worldwide, unlimited license to    */
 /* make copies, and use the API/SPI for making applications/drivers  */
 /* that interface with the specification provided that this          */
 /* paragraph and the Intel/Microsoft copyright statement is          */
 /* maintained as is in the text and source code files.               */
 /*                                                                   */
 /* Copyright 1995 - 1999 Microsoft, all rights reserved.             */
 /* Portions copyright 1992, 1993 Intel/Microsoft,                    */
 /*          all rights reserved.                                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*   tapi.cpy                                                        */
 /*                                                                   */
 /* Notes:                                                            */
 /*   Additions to the Telephony Application Programming Interface    */
 /*   (TAPI) since version 2.0 are %if protected.                     */
 /* --                                                                */

 %dcl TAPI_H char ext;
 %if TAPI_H = '' %then %do;
 %TAPI_H = 'Y';


 /* -- TAPI VERSION INFO -- TAPI VERSION INFO -- TAPI VERSION INFO -- */
 /*                                                                   */
 /* To build  a TAPI 2.0 application put a define as below in your    */
 /* source file before you include TAPI.CPY:                          */
 /*                                                                   */
 /* %dcl TAPI_CURRENT_VERSION char ext                                */
 /* %TAPI_CURRENT_VERSION = '00020000'                                */
 /*                                                                   */
 /* PL/I Note: Only TAPI 2.0 and above are supported.                 */

 %dcl TAPI_CURRENT_VERSION char ext;
 %if TAPI_CURRENT_VERSION = 0 %then %do;
  %TAPI_CURRENT_VERSION  = '00030000';
 %end;

 %dcl UNICODE char ext;

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
 %include winuser;
 %end;


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 /* %include oaidl */
 %dcl #_wtypes_h__ char ext;
 %if #_wtypes_h__ = '' %then %do;
 %include wtypes;
 %end;
 define alias CURRENCY type CY;
 %end;


 /* Type definitions of the data types used in tapi */


 /* TAPI type definitions */

 %DECLARE_OPAQUE32: proc (name) returns (char);
   dcl name char;
   return ('define alias ' || name || ' type DWORD');
 %end DECLARE_OPAQUE32;
 %dcl DECLARE_OPAQUE32 entry;

 DECLARE_OPAQUE32 (HCALL);
 define alias LPHCALL pointer;

 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 DECLARE_OPAQUE32 (HCALLHUB);
 define alias LPHCALLHUB pointer;
 %end;

 DECLARE_OPAQUE32 (HLINE);
 define alias LPHLINE pointer;

 DECLARE_OPAQUE32 (HPHONE);
 define alias LPHPHONE pointer;

 DECLARE_OPAQUE32 (HLINEAPP);
 define alias LPHLINEAPP pointer;

 DECLARE_OPAQUE32 (HPHONEAPP);
 define alias LPHPHONEAPP pointer;

 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 DECLARE_OPAQUE32 (HAGENTSESSION);
 define alias LPHAGENTSESSION pointer;

 DECLARE_OPAQUE32 (HAGENT);
 define alias LPHAGENT pointer;
 %end;


 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 DECLARE_OPAQUE32 (HPRIVATECHANNEL);
 define alias LPHPRIVATECHANNEL pointer;
 %end;

 define alias LPHICON pointer;

 define alias LINECALLBACK
        entry (type DWORD,
               type DWORD,
               type DWORD_PTR,
               type DWORD_PTR,
               type DWORD_PTR,
               type DWORD_PTR)
        limited CALLBACK;

 define alias PHONECALLBACK
        entry (type DWORD,
               type DWORD,
               type DWORD_PTR,
               type DWORD_PTR,
               type DWORD_PTR,
               type DWORD_PTR)
        limited CALLBACK;


 /* Messages for Phones and Lines */

 dcl LINE_ADDRESSSTATE       fixed bin(31) value( 0);
 dcl LINE_CALLINFO           fixed bin(31) value( 1);
 dcl LINE_CALLSTATE          fixed bin(31) value( 2);
 dcl LINE_CLOSE              fixed bin(31) value( 3);
 dcl LINE_DEVSPECIFIC        fixed bin(31) value( 4);
 dcl LINE_DEVSPECIFICFEATURE fixed bin(31) value( 5);
 dcl LINE_GATHERDIGITS       fixed bin(31) value( 6);
 dcl LINE_GENERATE           fixed bin(31) value( 7);
 dcl LINE_LINEDEVSTATE       fixed bin(31) value( 8);
 dcl LINE_MONITORDIGITS      fixed bin(31) value( 9);
 dcl LINE_MONITORMEDIA       fixed bin(31) value(10);
 dcl LINE_MONITORTONE        fixed bin(31) value(11);
 dcl LINE_REPLY              fixed bin(31) value(12);
 dcl LINE_REQUEST            fixed bin(31) value(13);
 dcl PHONE_BUTTON            fixed bin(31) value(14);
 dcl PHONE_CLOSE             fixed bin(31) value(15);
 dcl PHONE_DEVSPECIFIC       fixed bin(31) value(16);
 dcl PHONE_REPLY             fixed bin(31) value(17);
 dcl PHONE_STATE             fixed bin(31) value(18);
 dcl LINE_CREATE             fixed bin(31) value(19);
 dcl PHONE_CREATE            fixed bin(31) value(20);

 dcl LINE_AGENTSPECIFIC      fixed bin(31) value(21);
 dcl LINE_AGENTSTATUS        fixed bin(31) value(22);
 dcl LINE_APPNEWCALL         fixed bin(31) value(23);
 dcl LINE_PROXYREQUEST       fixed bin(31) value(24);
 dcl LINE_REMOVE             fixed bin(31) value(25);
 dcl PHONE_REMOVE            fixed bin(31) value(26);

 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl LINE_AGENTSESSIONSTATUS fixed bin(31) value(27);
 dcl LINE_QUEUESTATUS        fixed bin(31) value(28);
 dcl LINE_AGENTSTATUSEX      fixed bin(31) value(29);
 dcl LINE_GROUPSTATUS        fixed bin(31) value(30);
 dcl LINE_PROXYSTATUS        fixed bin(31) value(31);
 %end;

 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINE_APPNEWCALLHUB      fixed bin(31) value(32);
 dcl LINE_CALLHUBCLOSE       fixed bin(31) value(33);
 dcl LINE_DEVSPECIFICEX      fixed bin(31) value(34);
 %end;

 dcl INITIALIZE_NEGOTIATION type DWORD value('FFFFFFFF'xu);

 dcl LINEADDRCAPFLAGS_FWDNUMRINGS        type DWORD value('00000001'xu);
 dcl LINEADDRCAPFLAGS_PICKUPGROUPID      type DWORD value('00000002'xu);
 dcl LINEADDRCAPFLAGS_SECURE             type DWORD value('00000004'xu);
 dcl LINEADDRCAPFLAGS_BLOCKIDDEFAULT     type DWORD value('00000008'xu);
 dcl LINEADDRCAPFLAGS_BLOCKIDOVERRIDE    type DWORD value('00000010'xu);
 dcl LINEADDRCAPFLAGS_DIALED             type DWORD value('00000020'xu);
 dcl LINEADDRCAPFLAGS_ORIGOFFHOOK        type DWORD value('00000040'xu);
 dcl LINEADDRCAPFLAGS_DESTOFFHOOK        type DWORD value('00000080'xu);
 dcl LINEADDRCAPFLAGS_FWDCONSULT         type DWORD value('00000100'xu);
 dcl LINEADDRCAPFLAGS_SETUPCONFNULL      type DWORD value('00000200'xu);
 dcl LINEADDRCAPFLAGS_AUTORECONNECT      type DWORD value('00000400'xu);
 dcl LINEADDRCAPFLAGS_COMPLETIONID       type DWORD value('00000800'xu);
 dcl LINEADDRCAPFLAGS_TRANSFERHELD       type DWORD value('00001000'xu);
 dcl LINEADDRCAPFLAGS_TRANSFERMAKE       type DWORD value('00002000'xu);
 dcl LINEADDRCAPFLAGS_CONFERENCEHELD     type DWORD value('00004000'xu);
 dcl LINEADDRCAPFLAGS_CONFERENCEMAKE     type DWORD value('00008000'xu);
 dcl LINEADDRCAPFLAGS_PARTIALDIAL        type DWORD value('00010000'xu);
 dcl LINEADDRCAPFLAGS_FWDSTATUSVALID     type DWORD value('00020000'xu);
 dcl LINEADDRCAPFLAGS_FWDINTEXTADDR      type DWORD value('00040000'xu);
 dcl LINEADDRCAPFLAGS_FWDBUSYNAADDR      type DWORD value('00080000'xu);
 dcl LINEADDRCAPFLAGS_ACCEPTTOALERT      type DWORD value('00100000'xu);
 dcl LINEADDRCAPFLAGS_CONFDROP           type DWORD value('00200000'xu);
 dcl LINEADDRCAPFLAGS_PICKUPCALLWAIT     type DWORD value('00400000'xu);
 dcl LINEADDRCAPFLAGS_PREDICTIVEDIALER   type DWORD value('00800000'xu)
 ;
 dcl LINEADDRCAPFLAGS_QUEUE              type DWORD value('01000000'xu);
 dcl LINEADDRCAPFLAGS_ROUTEPOINT         type DWORD value('02000000'xu);
 dcl LINEADDRCAPFLAGS_HOLDMAKESNEW       type DWORD value('04000000'xu);
 dcl LINEADDRCAPFLAGS_NOINTERNALCALLS    type DWORD value('08000000'xu);
 dcl LINEADDRCAPFLAGS_NOEXTERNALCALLS    type DWORD value('10000000'xu);
 dcl LINEADDRCAPFLAGS_SETCALLINGID       type DWORD value('20000000'xu);

 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl LINEADDRCAPFLAGS_ACDGROUP           type DWORD value('40000000'xu);
 %end;
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINEADDRCAPFLAGS_NOPSTNADDRESSTRANSLATION
                                         type DWORD value('80000000'xu);
 %end;

 dcl LINEADDRESSMODE_ADDRESSID           type DWORD value('00000001'xu);
 dcl LINEADDRESSMODE_DIALABLEADDR        type DWORD value('00000002'xu);

 dcl LINEADDRESSSHARING_PRIVATE          type DWORD value('00000001'xu);
 dcl LINEADDRESSSHARING_BRIDGEDEXCL      type DWORD value('00000002'xu);
 dcl LINEADDRESSSHARING_BRIDGEDNEW       type DWORD value('00000004'xu);
 dcl LINEADDRESSSHARING_BRIDGEDSHARED    type DWORD value('00000008'xu);
 dcl LINEADDRESSSHARING_MONITORED        type DWORD value('00000010'xu);

 dcl LINEADDRESSSTATE_OTHER              type DWORD value('00000001'xu);
 dcl LINEADDRESSSTATE_DEVSPECIFIC        type DWORD value('00000002'xu);
 dcl LINEADDRESSSTATE_INUSEZERO          type DWORD value('00000004'xu);
 dcl LINEADDRESSSTATE_INUSEONE           type DWORD value('00000008'xu);
 dcl LINEADDRESSSTATE_INUSEMANY          type DWORD value('00000010'xu);
 dcl LINEADDRESSSTATE_NUMCALLS           type DWORD value('00000020'xu);
 dcl LINEADDRESSSTATE_FORWARD            type DWORD value('00000040'xu);
 dcl LINEADDRESSSTATE_TERMINALS          type DWORD value('00000080'xu);
 dcl LINEADDRESSSTATE_CAPSCHANGE         type DWORD value('00000100'xu);


 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINEADDRESSTYPE_PHONENUMBER         type DWORD value('00000001'xu);
 dcl LINEADDRESSTYPE_SDP                 type DWORD value('00000002'xu);
 dcl LINEADDRESSTYPE_EMAILNAME           type DWORD value('00000004'xu);
 dcl LINEADDRESSTYPE_DOMAINNAME          type DWORD value('00000008'xu);
 dcl LINEADDRESSTYPE_IPADDRESS           type DWORD value('00000010'xu);
 %end;

 dcl LINEADDRFEATURE_FORWARD             type DWORD value('00000001'xu);
 dcl LINEADDRFEATURE_MAKECALL            type DWORD value('00000002'xu);
 dcl LINEADDRFEATURE_PICKUP              type DWORD value('00000004'xu);
 dcl LINEADDRFEATURE_SETMEDIACONTROL     type DWORD value('00000008'xu);
 dcl LINEADDRFEATURE_SETTERMINAL         type DWORD value('00000010'xu);
 dcl LINEADDRFEATURE_SETUPCONF           type DWORD value('00000020'xu);
 dcl LINEADDRFEATURE_UNCOMPLETECALL      type DWORD value('00000040'xu);
 dcl LINEADDRFEATURE_UNPARK              type DWORD value('00000080'xu);
 dcl LINEADDRFEATURE_PICKUPHELD          type DWORD value('00000100'xu);
 dcl LINEADDRFEATURE_PICKUPGROUP         type DWORD value('00000200'xu);
 dcl LINEADDRFEATURE_PICKUPDIRECT        type DWORD value('00000400'xu);
 dcl LINEADDRFEATURE_PICKUPWAITING       type DWORD value('00000800'xu);
 dcl LINEADDRFEATURE_FORWARDFWD          type DWORD value('00001000'xu);
 dcl LINEADDRFEATURE_FORWARDDND          type DWORD value('00002000'xu);

 dcl LINEAGENTFEATURE_SETAGENTGROUP      type DWORD value('00000001'xu);
 dcl LINEAGENTFEATURE_SETAGENTSTATE      type DWORD value('00000002'xu);
 dcl LINEAGENTFEATURE_SETAGENTACTIVITY   type DWORD value('00000004'xu);
 dcl LINEAGENTFEATURE_AGENTSPECIFIC      type DWORD value('00000008'xu);
 dcl LINEAGENTFEATURE_GETAGENTACTIVITYLIST
                                         type DWORD value('00000010'xu);
 dcl LINEAGENTFEATURE_GETAGENTGROUP      type DWORD value('00000020'xu);

 dcl LINEAGENTSTATE_LOGGEDOFF            type DWORD value('00000001'xu);
 dcl LINEAGENTSTATE_NOTREADY             type DWORD value('00000002'xu);
 dcl LINEAGENTSTATE_READY                type DWORD value('00000004'xu);
 dcl LINEAGENTSTATE_BUSYACD              type DWORD value('00000008'xu);
 dcl LINEAGENTSTATE_BUSYINCOMING         type DWORD value('00000010'xu);
 dcl LINEAGENTSTATE_BUSYOUTBOUND         type DWORD value('00000020'xu);
 dcl LINEAGENTSTATE_BUSYOTHER            type DWORD value('00000040'xu);
 dcl LINEAGENTSTATE_WORKINGAFTERCALL     type DWORD value('00000080'xu);
 dcl LINEAGENTSTATE_UNKNOWN              type DWORD value('00000100'xu);
 dcl LINEAGENTSTATE_UNAVAIL              type DWORD value('00000200'xu);

 dcl LINEAGENTSTATUS_GROUP               type DWORD value('00000001'xu);
 dcl LINEAGENTSTATUS_STATE               type DWORD value('00000002'xu);
 dcl LINEAGENTSTATUS_NEXTSTATE           type DWORD value('00000004'xu);
 dcl LINEAGENTSTATUS_ACTIVITY            type DWORD value('00000008'xu);
 dcl LINEAGENTSTATUS_ACTIVITYLIST        type DWORD value('00000010'xu);
 dcl LINEAGENTSTATUS_GROUPLIST           type DWORD value('00000020'xu);
 dcl LINEAGENTSTATUS_CAPSCHANGE          type DWORD value('00000040'xu);
 dcl LINEAGENTSTATUS_VALIDSTATES         type DWORD value('00000080'xu);
 dcl LINEAGENTSTATUS_VALIDNEXTSTATES     type DWORD value('00000100'xu);


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl LINEAGENTSTATEEX_NOTREADY           type DWORD value('00000001'xu);
 dcl LINEAGENTSTATEEX_READY              type DWORD value('00000002'xu);
 dcl LINEAGENTSTATEEX_BUSYACD            type DWORD value('00000004'xu);
 dcl LINEAGENTSTATEEX_BUSYINCOMING       type DWORD value('00000008'xu);
 dcl LINEAGENTSTATEEX_BUSYOUTGOING       type DWORD value('00000010'xu);
 dcl LINEAGENTSTATEEX_UNKNOWN            type DWORD value('00000020'xu);
 dcl LINEAGENTSTATEEX_RELEASED           type DWORD value('00000040'xu);

 dcl LINEAGENTSTATUSEX_NEWAGENT          type DWORD value('00000001'xu);
 dcl LINEAGENTSTATUSEX_STATE             type DWORD value('00000002'xu);
 dcl LINEAGENTSTATUSEX_UPDATEINFO        type DWORD value('00000003'xu);
 /*dcl LINEAGENTSTATUSEX_DESTROYED     type DWORD value('00000004'xu) */

 dcl LINEAGENTSESSIONSTATE_NOTREADY      type DWORD value('00000001'xu);
 dcl LINEAGENTSESSIONSTATE_READY         type DWORD value('00000002'xu);
 dcl LINEAGENTSESSIONSTATE_BUSYONCALL    type DWORD value('00000004'xu);
 dcl LINEAGENTSESSIONSTATE_BUSYWRAPUP    type DWORD value('00000008'xu);
 dcl LINEAGENTSESSIONSTATE_ENDED         type DWORD value('00000010'xu);
 dcl LINEAGENTSESSIONSTATE_RELEASED      type DWORD value('00000020'xu);

 dcl LINEAGENTSESSIONSTATUS_NEWSESSION   type DWORD value('00000001'xu);
 dcl LINEAGENTSESSIONSTATUS_STATE        type DWORD value('00000002'xu);
 dcl LINEAGENTSESSIONSTATUS_UPDATEINFO   type DWORD value('00000004'xu);
 /*dcl LINEAGENTSESSIONSTATUS_DESTROYED type DWORD value('00000008'xu)*/

 dcl LINEQUEUESTATUS_UPDATEINFO          type DWORD value('00000001'xu);
 dcl LINEQUEUESTATUS_NEWQUEUE            type DWORD value('00000002'xu);
 dcl LINEQUEUESTATUS_QUEUEREMOVED        type DWORD value('00000004'xu);

 dcl LINEGROUPSTATUS_NEWGROUP            type DWORD value('00000001'xu);
 dcl LINEGROUPSTATUS_GROUPREMOVED        type DWORD value('00000002'xu);

 dcl LINEPROXYSTATUS_OPEN                type DWORD value('00000001'xu);
 dcl LINEPROXYSTATUS_CLOSE               type DWORD value('00000002'xu);
 dcl LINEPROXYSTATUS_ALLOPENFORACD       type DWORD value('00000004'xu);
 %end;

 dcl LINEANSWERMODE_NONE                 type DWORD value('00000001'xu);
 dcl LINEANSWERMODE_DROP                 type DWORD value('00000002'xu);
 dcl LINEANSWERMODE_HOLD                 type DWORD value('00000004'xu);

 dcl LINEBEARERMODE_VOICE                type DWORD value('00000001'xu);
 dcl LINEBEARERMODE_SPEECH               type DWORD value('00000002'xu);
 dcl LINEBEARERMODE_MULTIUSE             type DWORD value('00000004'xu);
 dcl LINEBEARERMODE_DATA                 type DWORD value('00000008'xu);
 dcl LINEBEARERMODE_ALTSPEECHDATA        type DWORD value('00000010'xu);
 dcl LINEBEARERMODE_NONCALLSIGNALING     type DWORD value('00000020'xu);
 dcl LINEBEARERMODE_PASSTHROUGH          type DWORD value('00000040'xu);
 dcl LINEBEARERMODE_RESTRICTEDDATA       type DWORD value('00000080'xu);

 dcl LINEBUSYMODE_STATION                type DWORD value('00000001'xu);
 dcl LINEBUSYMODE_TRUNK                  type DWORD value('00000002'xu);
 dcl LINEBUSYMODE_UNKNOWN                type DWORD value('00000004'xu);
 dcl LINEBUSYMODE_UNAVAIL                type DWORD value('00000008'xu);

 dcl LINECALLCOMPLCOND_BUSY              type DWORD value('00000001'xu);
 dcl LINECALLCOMPLCOND_NOANSWER          type DWORD value('00000002'xu);

 dcl LINECALLCOMPLMODE_CAMPON            type DWORD value('00000001'xu);
 dcl LINECALLCOMPLMODE_CALLBACK          type DWORD value('00000002'xu);
 dcl LINECALLCOMPLMODE_INTRUDE           type DWORD value('00000004'xu);
 dcl LINECALLCOMPLMODE_MESSAGE           type DWORD value('00000008'xu);

 dcl LINECALLFEATURE_ACCEPT              type DWORD value('00000001'xu);
 dcl LINECALLFEATURE_ADDTOCONF           type DWORD value('00000002'xu);
 dcl LINECALLFEATURE_ANSWER              type DWORD value('00000004'xu);
 dcl LINECALLFEATURE_BLINDTRANSFER       type DWORD value('00000008'xu);
 dcl LINECALLFEATURE_COMPLETECALL        type DWORD value('00000010'xu);
 dcl LINECALLFEATURE_COMPLETETRANSF      type DWORD value('00000020'xu);
 dcl LINECALLFEATURE_DIAL                type DWORD value('00000040'xu);
 dcl LINECALLFEATURE_DROP                type DWORD value('00000080'xu);
 dcl LINECALLFEATURE_GATHERDIGITS        type DWORD value('00000100'xu);
 dcl LINECALLFEATURE_GENERATEDIGITS      type DWORD value('00000200'xu);
 dcl LINECALLFEATURE_GENERATETONE        type DWORD value('00000400'xu);
 dcl LINECALLFEATURE_HOLD                type DWORD value('00000800'xu);
 dcl LINECALLFEATURE_MONITORDIGITS       type DWORD value('00001000'xu);
 dcl LINECALLFEATURE_MONITORMEDIA        type DWORD value('00002000'xu);
 dcl LINECALLFEATURE_MONITORTONES        type DWORD value('00004000'xu);
 dcl LINECALLFEATURE_PARK                type DWORD value('00008000'xu);
 dcl LINECALLFEATURE_PREPAREADDCONF      type DWORD value('00010000'xu);
 dcl LINECALLFEATURE_REDIRECT            type DWORD value('00020000'xu);
 dcl LINECALLFEATURE_REMOVEFROMCONF      type DWORD value('00040000'xu);
 dcl LINECALLFEATURE_SECURECALL          type DWORD value('00080000'xu);
 dcl LINECALLFEATURE_SENDUSERUSER        type DWORD value('00100000'xu);
 dcl LINECALLFEATURE_SETCALLPARAMS       type DWORD value('00200000'xu);
 dcl LINECALLFEATURE_SETMEDIACONTROL     type DWORD value('00400000'xu);
 dcl LINECALLFEATURE_SETTERMINAL         type DWORD value('00800000'xu);
 dcl LINECALLFEATURE_SETUPCONF           type DWORD value('01000000'xu);
 dcl LINECALLFEATURE_SETUPTRANSFER       type DWORD value('02000000'xu);
 dcl LINECALLFEATURE_SWAPHOLD            type DWORD value('04000000'xu);
 dcl LINECALLFEATURE_UNHOLD              type DWORD value('08000000'xu);
 dcl LINECALLFEATURE_RELEASEUSERUSERINFO type DWORD value('10000000'xu);
 dcl LINECALLFEATURE_SETTREATMENT        type DWORD value('20000000'xu);
 dcl LINECALLFEATURE_SETQOS              type DWORD value('40000000'xu);
 dcl LINECALLFEATURE_SETCALLDATA         type DWORD value('80000000'xu);

 dcl LINECALLFEATURE2_NOHOLDCONFERENCE   type DWORD value('00000001'xu);
 dcl LINECALLFEATURE2_ONESTEPTRANSFER    type DWORD value('00000002'xu);
 dcl LINECALLFEATURE2_COMPLCAMPON        type DWORD value('00000004'xu);
 dcl LINECALLFEATURE2_COMPLCALLBACK      type DWORD value('00000008'xu);
 dcl LINECALLFEATURE2_COMPLINTRUDE       type DWORD value('00000010'xu);
 dcl LINECALLFEATURE2_COMPLMESSAGE       type DWORD value('00000020'xu);
 dcl LINECALLFEATURE2_TRANSFERNORM       type DWORD value('00000040'xu);
 dcl LINECALLFEATURE2_TRANSFERCONF       type DWORD value('00000080'xu);
 dcl LINECALLFEATURE2_PARKDIRECT         type DWORD value('00000100'xu);
 dcl LINECALLFEATURE2_PARKNONDIRECT      type DWORD value('00000200'xu);


 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINECALLHUBTRACKING_NONE            type DWORD value('00000000'xu);
 dcl LINECALLHUBTRACKING_PROVIDERLEVEL   type DWORD value('00000001'xu);
 dcl LINECALLHUBTRACKING_ALLCALLS        type DWORD value('00000002'xu);
 %end;

 dcl LINECALLINFOSTATE_OTHER             type DWORD value('00000001'xu);
 dcl LINECALLINFOSTATE_DEVSPECIFIC       type DWORD value('00000002'xu);
 dcl LINECALLINFOSTATE_BEARERMODE        type DWORD value('00000004'xu);
 dcl LINECALLINFOSTATE_RATE              type DWORD value('00000008'xu);
 dcl LINECALLINFOSTATE_MEDIAMODE         type DWORD value('00000010'xu);
 dcl LINECALLINFOSTATE_APPSPECIFIC       type DWORD value('00000020'xu);
 dcl LINECALLINFOSTATE_CALLID            type DWORD value('00000040'xu);
 dcl LINECALLINFOSTATE_RELATEDCALLID     type DWORD value('00000080'xu);
 dcl LINECALLINFOSTATE_ORIGIN            type DWORD value('00000100'xu);
 dcl LINECALLINFOSTATE_REASON            type DWORD value('00000200'xu);
 dcl LINECALLINFOSTATE_COMPLETIONID      type DWORD value('00000400'xu);
 dcl LINECALLINFOSTATE_NUMOWNERINCR      type DWORD value('00000800'xu);
 dcl LINECALLINFOSTATE_NUMOWNERDECR      type DWORD value('00001000'xu);
 dcl LINECALLINFOSTATE_NUMMONITORS       type DWORD value('00002000'xu);
 dcl LINECALLINFOSTATE_TRUNK             type DWORD value('00004000'xu);
 dcl LINECALLINFOSTATE_CALLERID          type DWORD value('00008000'xu);
 dcl LINECALLINFOSTATE_CALLEDID          type DWORD value('00010000'xu);
 dcl LINECALLINFOSTATE_CONNECTEDID       type DWORD value('00020000'xu);
 dcl LINECALLINFOSTATE_REDIRECTIONID     type DWORD value('00040000'xu);
 dcl LINECALLINFOSTATE_REDIRECTINGID     type DWORD value('00080000'xu);
 dcl LINECALLINFOSTATE_DISPLAY           type DWORD value('00100000'xu);
 dcl LINECALLINFOSTATE_USERUSERINFO      type DWORD value('00200000'xu);
 dcl LINECALLINFOSTATE_HIGHLEVELCOMP     type DWORD value('00400000'xu);
 dcl LINECALLINFOSTATE_LOWLEVELCOMP      type DWORD value('00800000'xu);
 dcl LINECALLINFOSTATE_CHARGINGINFO      type DWORD value('01000000'xu);
 dcl LINECALLINFOSTATE_TERMINAL          type DWORD value('02000000'xu);
 dcl LINECALLINFOSTATE_DIALPARAMS        type DWORD value('04000000'xu);
 dcl LINECALLINFOSTATE_MONITORMODES      type DWORD value('08000000'xu);
 dcl LINECALLINFOSTATE_TREATMENT         type DWORD value('10000000'xu);
 dcl LINECALLINFOSTATE_QOS               type DWORD value('20000000'xu);
 dcl LINECALLINFOSTATE_CALLDATA          type DWORD value('40000000'xu);

 dcl LINECALLORIGIN_OUTBOUND             type DWORD value('00000001'xu);
 dcl LINECALLORIGIN_INTERNAL             type DWORD value('00000002'xu);
 dcl LINECALLORIGIN_EXTERNAL             type DWORD value('00000004'xu);
 dcl LINECALLORIGIN_UNKNOWN              type DWORD value('00000010'xu);
 dcl LINECALLORIGIN_UNAVAIL              type DWORD value('00000020'xu);
 dcl LINECALLORIGIN_CONFERENCE           type DWORD value('00000040'xu);
 dcl LINECALLORIGIN_INBOUND              type DWORD value('00000080'xu);

 dcl LINECALLPARAMFLAGS_SECURE           type DWORD value('00000001'xu);
 dcl LINECALLPARAMFLAGS_IDLE             type DWORD value('00000002'xu);
 dcl LINECALLPARAMFLAGS_BLOCKID          type DWORD value('00000004'xu);
 dcl LINECALLPARAMFLAGS_ORIGOFFHOOK      type DWORD value('00000008'xu);
 dcl LINECALLPARAMFLAGS_DESTOFFHOOK      type DWORD value('00000010'xu);
 dcl LINECALLPARAMFLAGS_NOHOLDCONFERENCE type DWORD value('00000020'xu);
 dcl LINECALLPARAMFLAGS_PREDICTIVEDIAL   type DWORD value('00000040'xu);
 dcl LINECALLPARAMFLAGS_ONESTEPTRANSFER  type DWORD value('00000080'xu);

 dcl LINECALLPARTYID_BLOCKED             type DWORD value('00000001'xu);
 dcl LINECALLPARTYID_OUTOFAREA           type DWORD value('00000002'xu);
 dcl LINECALLPARTYID_NAME                type DWORD value('00000004'xu);
 dcl LINECALLPARTYID_ADDRESS             type DWORD value('00000008'xu);
 dcl LINECALLPARTYID_PARTIAL             type DWORD value('00000010'xu);
 dcl LINECALLPARTYID_UNKNOWN             type DWORD value('00000020'xu);
 dcl LINECALLPARTYID_UNAVAIL             type DWORD value('00000040'xu);

 dcl LINECALLPRIVILEGE_NONE              type DWORD value('00000001'xu);
 dcl LINECALLPRIVILEGE_MONITOR           type DWORD value('00000002'xu);
 dcl LINECALLPRIVILEGE_OWNER             type DWORD value('00000004'xu);

 dcl LINECALLREASON_DIRECT               type DWORD value('00000001'xu);
 dcl LINECALLREASON_FWDBUSY              type DWORD value('00000002'xu);
 dcl LINECALLREASON_FWDNOANSWER          type DWORD value('00000004'xu);
 dcl LINECALLREASON_FWDUNCOND            type DWORD value('00000008'xu);
 dcl LINECALLREASON_PICKUP               type DWORD value('00000010'xu);
 dcl LINECALLREASON_UNPARK               type DWORD value('00000020'xu);
 dcl LINECALLREASON_REDIRECT             type DWORD value('00000040'xu);
 dcl LINECALLREASON_CALLCOMPLETION       type DWORD value('00000080'xu);
 dcl LINECALLREASON_TRANSFER             type DWORD value('00000100'xu);
 dcl LINECALLREASON_REMINDER             type DWORD value('00000200'xu);
 dcl LINECALLREASON_UNKNOWN              type DWORD value('00000400'xu);
 dcl LINECALLREASON_UNAVAIL              type DWORD value('00000800'xu);
 dcl LINECALLREASON_INTRUDE              type DWORD value('00001000'xu);
 dcl LINECALLREASON_PARKED               type DWORD value('00002000'xu);
 dcl LINECALLREASON_CAMPEDON             type DWORD value('00004000'xu);
 dcl LINECALLREASON_ROUTEREQUEST         type DWORD value('00008000'xu);

 dcl LINECALLSELECT_LINE                 type DWORD value('00000001'xu);
 dcl LINECALLSELECT_ADDRESS              type DWORD value('00000002'xu);
 dcl LINECALLSELECT_CALL                 type DWORD value('00000004'xu);

 %if TAPI_CURRENT_VERSION >= '00020001' %then %do;
 dcl LINECALLSELECT_DEVICEID             type DWORD value('00000008'xu);
 %end;

 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINECALLSELECT_CALLID               type DWORD value('00000010'xu);
 %end;

 dcl LINECALLSTATE_IDLE                  type DWORD value('00000001'xu);
 dcl LINECALLSTATE_OFFERING              type DWORD value('00000002'xu);
 dcl LINECALLSTATE_ACCEPTED              type DWORD value('00000004'xu);
 dcl LINECALLSTATE_DIALTONE              type DWORD value('00000008'xu);
 dcl LINECALLSTATE_DIALING               type DWORD value('00000010'xu);
 dcl LINECALLSTATE_RINGBACK              type DWORD value('00000020'xu);
 dcl LINECALLSTATE_BUSY                  type DWORD value('00000040'xu);
 dcl LINECALLSTATE_SPECIALINFO           type DWORD value('00000080'xu);
 dcl LINECALLSTATE_CONNECTED             type DWORD value('00000100'xu);
 dcl LINECALLSTATE_PROCEEDING            type DWORD value('00000200'xu);
 dcl LINECALLSTATE_ONHOLD                type DWORD value('00000400'xu);
 dcl LINECALLSTATE_CONFERENCED           type DWORD value('00000800'xu);
 dcl LINECALLSTATE_ONHOLDPENDCONF        type DWORD value('00001000'xu);
 dcl LINECALLSTATE_ONHOLDPENDTRANSFER    type DWORD value('00002000'xu);
 dcl LINECALLSTATE_DISCONNECTED          type DWORD value('00004000'xu);
 dcl LINECALLSTATE_UNKNOWN               type DWORD value('00008000'xu);

 dcl LINECALLTREATMENT_SILENCE           type DWORD value('00000001'xu);
 dcl LINECALLTREATMENT_RINGBACK          type DWORD value('00000002'xu);
 dcl LINECALLTREATMENT_BUSY              type DWORD value('00000003'xu);
 dcl LINECALLTREATMENT_MUSIC             type DWORD value('00000004'xu);

 dcl LINECARDOPTION_PREDEFINED           type DWORD value('00000001'xu);
 dcl LINECARDOPTION_HIDDEN               type DWORD value('00000002'xu);

 dcl LINECONNECTEDMODE_ACTIVE            type DWORD value('00000001'xu);
 dcl LINECONNECTEDMODE_INACTIVE          type DWORD value('00000002'xu);
 dcl LINECONNECTEDMODE_ACTIVEHELD        type DWORD value('00000004'xu);
 dcl LINECONNECTEDMODE_INACTIVEHELD      type DWORD value('00000008'xu);
 dcl LINECONNECTEDMODE_CONFIRMED         type DWORD value('00000010'xu);

 dcl LINEDEVCAPFLAGS_CROSSADDRCONF       type DWORD value('00000001'xu);
 dcl LINEDEVCAPFLAGS_HIGHLEVCOMP         type DWORD value('00000002'xu);
 dcl LINEDEVCAPFLAGS_LOWLEVCOMP          type DWORD value('00000004'xu);
 dcl LINEDEVCAPFLAGS_MEDIACONTROL        type DWORD value('00000008'xu);
 dcl LINEDEVCAPFLAGS_MULTIPLEADDR        type DWORD value('00000010'xu);
 dcl LINEDEVCAPFLAGS_CLOSEDROP           type DWORD value('00000020'xu);
 dcl LINEDEVCAPFLAGS_DIALBILLING         type DWORD value('00000040'xu);
 dcl LINEDEVCAPFLAGS_DIALQUIET           type DWORD value('00000080'xu);
 dcl LINEDEVCAPFLAGS_DIALDIALTONE        type DWORD value('00000100'xu);

 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINEDEVCAPFLAGS_MSP                 type DWORD value('00000200'xu);
 dcl LINEDEVCAPFLAGS_CALLHUB             type DWORD value('00000400'xu);
 dcl LINEDEVCAPFLAGS_CALLHUBTRACKING     type DWORD value('00000800'xu);
 dcl LINEDEVCAPFLAGS_PRIVATEOBJECTS      type DWORD value('00001000'xu);
 %end;

 dcl LINEDEVSTATE_OTHER                  type DWORD value('00000001'xu);
 dcl LINEDEVSTATE_RINGING                type DWORD value('00000002'xu);
 dcl LINEDEVSTATE_CONNECTED              type DWORD value('00000004'xu);
 dcl LINEDEVSTATE_DISCONNECTED           type DWORD value('00000008'xu);
 dcl LINEDEVSTATE_MSGWAITON              type DWORD value('00000010'xu);
 dcl LINEDEVSTATE_MSGWAITOFF             type DWORD value('00000020'xu);
 dcl LINEDEVSTATE_INSERVICE              type DWORD value('00000040'xu);
 dcl LINEDEVSTATE_OUTOFSERVICE           type DWORD value('00000080'xu);
 dcl LINEDEVSTATE_MAINTENANCE            type DWORD value('00000100'xu);
 dcl LINEDEVSTATE_OPEN                   type DWORD value('00000200'xu);
 dcl LINEDEVSTATE_CLOSE                  type DWORD value('00000400'xu);
 dcl LINEDEVSTATE_NUMCALLS               type DWORD value('00000800'xu);
 dcl LINEDEVSTATE_NUMCOMPLETIONS         type DWORD value('00001000'xu);
 dcl LINEDEVSTATE_TERMINALS              type DWORD value('00002000'xu);
 dcl LINEDEVSTATE_ROAMMODE               type DWORD value('00004000'xu);
 dcl LINEDEVSTATE_BATTERY                type DWORD value('00008000'xu);
 dcl LINEDEVSTATE_SIGNAL                 type DWORD value('00010000'xu);
 dcl LINEDEVSTATE_DEVSPECIFIC            type DWORD value('00020000'xu);
 dcl LINEDEVSTATE_REINIT                 type DWORD value('00040000'xu);
 dcl LINEDEVSTATE_LOCK                   type DWORD value('00080000'xu);
 dcl LINEDEVSTATE_CAPSCHANGE             type DWORD value('00100000'xu);
 dcl LINEDEVSTATE_CONFIGCHANGE           type DWORD value('00200000'xu);
 dcl LINEDEVSTATE_TRANSLATECHANGE        type DWORD value('00400000'xu);
 dcl LINEDEVSTATE_COMPLCANCEL            type DWORD value('00800000'xu);
 dcl LINEDEVSTATE_REMOVED                type DWORD value('01000000'xu);

 dcl LINEDEVSTATUSFLAGS_CONNECTED        type DWORD value('00000001'xu);
 dcl LINEDEVSTATUSFLAGS_MSGWAIT          type DWORD value('00000002'xu);
 dcl LINEDEVSTATUSFLAGS_INSERVICE        type DWORD value('00000004'xu);
 dcl LINEDEVSTATUSFLAGS_LOCKED           type DWORD value('00000008'xu);

 dcl LINEDIALTONEMODE_NORMAL             type DWORD value('00000001'xu);
 dcl LINEDIALTONEMODE_SPECIAL            type DWORD value('00000002'xu);
 dcl LINEDIALTONEMODE_INTERNAL           type DWORD value('00000004'xu);
 dcl LINEDIALTONEMODE_EXTERNAL           type DWORD value('00000008'xu);
 dcl LINEDIALTONEMODE_UNKNOWN            type DWORD value('00000010'xu);
 dcl LINEDIALTONEMODE_UNAVAIL            type DWORD value('00000020'xu);

 dcl LINEDIGITMODE_PULSE                 type DWORD value('00000001'xu);
 dcl LINEDIGITMODE_DTMF                  type DWORD value('00000002'xu);
 dcl LINEDIGITMODE_DTMFEND               type DWORD value('00000004'xu);

 dcl LINEDISCONNECTMODE_NORMAL           type DWORD value('00000001'xu);
 dcl LINEDISCONNECTMODE_UNKNOWN          type DWORD value('00000002'xu);
 dcl LINEDISCONNECTMODE_REJECT           type DWORD value('00000004'xu);
 dcl LINEDISCONNECTMODE_PICKUP           type DWORD value('00000008'xu);
 dcl LINEDISCONNECTMODE_FORWARDED        type DWORD value('00000010'xu);
 dcl LINEDISCONNECTMODE_BUSY             type DWORD value('00000020'xu);
 dcl LINEDISCONNECTMODE_NOANSWER         type DWORD value('00000040'xu);
 dcl LINEDISCONNECTMODE_BADADDRESS       type DWORD value('00000080'xu);
 dcl LINEDISCONNECTMODE_UNREACHABLE      type DWORD value('00000100'xu);
 dcl LINEDISCONNECTMODE_CONGESTION       type DWORD value('00000200'xu);
 dcl LINEDISCONNECTMODE_INCOMPATIBLE     type DWORD value('00000400'xu);
 dcl LINEDISCONNECTMODE_UNAVAIL          type DWORD value('00000800'xu);
 dcl LINEDISCONNECTMODE_NODIALTONE       type DWORD value('00001000'xu);
 dcl LINEDISCONNECTMODE_NUMBERCHANGED    type DWORD value('00002000'xu);
 dcl LINEDISCONNECTMODE_OUTOFORDER       type DWORD value('00004000'xu);
 dcl LINEDISCONNECTMODE_TEMPFAILURE      type DWORD value('00008000'xu);
 dcl LINEDISCONNECTMODE_QOSUNAVAIL       type DWORD value('00010000'xu);
 dcl LINEDISCONNECTMODE_BLOCKED          type DWORD value('00020000'xu);
 dcl LINEDISCONNECTMODE_DONOTDISTURB     type DWORD value('00040000'xu);
 dcl LINEDISCONNECTMODE_CANCELLED        type DWORD value('00080000'xu);

 dcl LINEERR_ALLOCATED                fixed bin(31) value('80000001'xn);
 dcl LINEERR_BADDEVICEID              fixed bin(31) value('80000002'xn);
 dcl LINEERR_BEARERMODEUNAVAIL        fixed bin(31) value('80000003'xn);
 dcl LINEERR_CALLUNAVAIL              fixed bin(31) value('80000005'xn);
 dcl LINEERR_COMPLETIONOVERRUN        fixed bin(31) value('80000006'xn);
 dcl LINEERR_CONFERENCEFULL           fixed bin(31) value('80000007'xn);
 dcl LINEERR_DIALBILLING              fixed bin(31) value('80000008'xn);
 dcl LINEERR_DIALDIALTONE             fixed bin(31) value('80000009'xn);
 dcl LINEERR_DIALPROMPT               fixed bin(31) value('8000000A'xn);
 dcl LINEERR_DIALQUIET                fixed bin(31) value('8000000B'xn);
 dcl LINEERR_INCOMPATIBLEAPIVERSION   fixed bin(31) value('8000000C'xn);
 dcl LINEERR_INCOMPATIBLEEXTVERSION   fixed bin(31) value('8000000D'xn);
 dcl LINEERR_INIFILECORRUPT           fixed bin(31) value('8000000E'xn);
 dcl LINEERR_INUSE                    fixed bin(31) value('8000000F'xn);
 dcl LINEERR_INVALADDRESS             fixed bin(31) value('80000010'xn);
 dcl LINEERR_INVALADDRESSID           fixed bin(31) value('80000011'xn);
 dcl LINEERR_INVALADDRESSMODE         fixed bin(31) value('80000012'xn);
 dcl LINEERR_INVALADDRESSSTATE        fixed bin(31) value('80000013'xn);
 dcl LINEERR_INVALAPPHANDLE           fixed bin(31) value('80000014'xn);
 dcl LINEERR_INVALAPPNAME             fixed bin(31) value('80000015'xn);
 dcl LINEERR_INVALBEARERMODE          fixed bin(31) value('80000016'xn);
 dcl LINEERR_INVALCALLCOMPLMODE       fixed bin(31) value('80000017'xn);
 dcl LINEERR_INVALCALLHANDLE          fixed bin(31) value('80000018'xn);
 dcl LINEERR_INVALCALLPARAMS          fixed bin(31) value('80000019'xn);
 dcl LINEERR_INVALCALLPRIVILEGE       fixed bin(31) value('8000001A'xn);
 dcl LINEERR_INVALCALLSELECT          fixed bin(31) value('8000001B'xn);
 dcl LINEERR_INVALCALLSTATE           fixed bin(31) value('8000001C'xn);
 dcl LINEERR_INVALCALLSTATELIST       fixed bin(31) value('8000001D'xn);
 dcl LINEERR_INVALCARD                fixed bin(31) value('8000001E'xn);
 dcl LINEERR_INVALCOMPLETIONID        fixed bin(31) value('8000001F'xn);
 dcl LINEERR_INVALCONFCALLHANDLE      fixed bin(31) value('80000020'xn);
 dcl LINEERR_INVALCONSULTCALLHANDLE   fixed bin(31) value('80000021'xn);
 dcl LINEERR_INVALCOUNTRYCODE         fixed bin(31) value('80000022'xn);
 dcl LINEERR_INVALDEVICECLASS         fixed bin(31) value('80000023'xn);
 dcl LINEERR_INVALDEVICEHANDLE        fixed bin(31) value('80000024'xn);
 dcl LINEERR_INVALDIALPARAMS          fixed bin(31) value('80000025'xn);
 dcl LINEERR_INVALDIGITLIST           fixed bin(31) value('80000026'xn);
 dcl LINEERR_INVALDIGITMODE           fixed bin(31) value('80000027'xn);
 dcl LINEERR_INVALDIGITS              fixed bin(31) value('80000028'xn);
 dcl LINEERR_INVALEXTVERSION          fixed bin(31) value('80000029'xn);
 dcl LINEERR_INVALGROUPID             fixed bin(31) value('8000002A'xn);
 dcl LINEERR_INVALLINEHANDLE          fixed bin(31) value('8000002B'xn);
 dcl LINEERR_INVALLINESTATE           fixed bin(31) value('8000002C'xn);
 dcl LINEERR_INVALLOCATION            fixed bin(31) value('8000002D'xn);
 dcl LINEERR_INVALMEDIALIST           fixed bin(31) value('8000002E'xn);
 dcl LINEERR_INVALMEDIAMODE           fixed bin(31) value('8000002F'xn);
 dcl LINEERR_INVALMESSAGEID           fixed bin(31) value('80000030'xn);
 dcl LINEERR_INVALPARAM               fixed bin(31) value('80000032'xn);
 dcl LINEERR_INVALPARKID              fixed bin(31) value('80000033'xn);
 dcl LINEERR_INVALPARKMODE            fixed bin(31) value('80000034'xn);
 dcl LINEERR_INVALPOINTER             fixed bin(31) value('80000035'xn);
 dcl LINEERR_INVALPRIVSELECT          fixed bin(31) value('80000036'xn);
 dcl LINEERR_INVALRATE                fixed bin(31) value('80000037'xn);
 dcl LINEERR_INVALREQUESTMODE         fixed bin(31) value('80000038'xn);
 dcl LINEERR_INVALTERMINALID          fixed bin(31) value('80000039'xn);
 dcl LINEERR_INVALTERMINALMODE        fixed bin(31) value('8000003A'xn);
 dcl LINEERR_INVALTIMEOUT             fixed bin(31) value('8000003B'xn);
 dcl LINEERR_INVALTONE                fixed bin(31) value('8000003C'xn);
 dcl LINEERR_INVALTONELIST            fixed bin(31) value('8000003D'xn);
 dcl LINEERR_INVALTONEMODE            fixed bin(31) value('8000003E'xn);
 dcl LINEERR_INVALTRANSFERMODE        fixed bin(31) value('8000003F'xn);
 dcl LINEERR_LINEMAPPERFAILED         fixed bin(31) value('80000040'xn);
 dcl LINEERR_NOCONFERENCE             fixed bin(31) value('80000041'xn);
 dcl LINEERR_NODEVICE                 fixed bin(31) value('80000042'xn);
 dcl LINEERR_NODRIVER                 fixed bin(31) value('80000043'xn);
 dcl LINEERR_NOMEM                    fixed bin(31) value('80000044'xn);
 dcl LINEERR_NOREQUEST                fixed bin(31) value('80000045'xn);
 dcl LINEERR_NOTOWNER                 fixed bin(31) value('80000046'xn);
 dcl LINEERR_NOTREGISTERED            fixed bin(31) value('80000047'xn);
 dcl LINEERR_OPERATIONFAILED          fixed bin(31) value('80000048'xn);
 dcl LINEERR_OPERATIONUNAVAIL         fixed bin(31) value('80000049'xn);
 dcl LINEERR_RATEUNAVAIL              fixed bin(31) value('8000004A'xn);
 dcl LINEERR_RESOURCEUNAVAIL          fixed bin(31) value('8000004B'xn);
 dcl LINEERR_REQUESTOVERRUN           fixed bin(31) value('8000004C'xn);
 dcl LINEERR_STRUCTURETOOSMALL        fixed bin(31) value('8000004D'xn);
 dcl LINEERR_TARGETNOTFOUND           fixed bin(31) value('8000004E'xn);
 dcl LINEERR_TARGETSELF               fixed bin(31) value('8000004F'xn);
 dcl LINEERR_UNINITIALIZED            fixed bin(31) value('80000050'xn);
 dcl LINEERR_USERUSERINFOTOOBIG       fixed bin(31) value('80000051'xn);
 dcl LINEERR_REINIT                   fixed bin(31) value('80000052'xn);
 dcl LINEERR_ADDRESSBLOCKED           fixed bin(31) value('80000053'xn);
 dcl LINEERR_BILLINGREJECTED          fixed bin(31) value('80000054'xn);
 dcl LINEERR_INVALFEATURE             fixed bin(31) value('80000055'xn);
 dcl LINEERR_NOMULTIPLEINSTANCE       fixed bin(31) value('80000056'xn);
 dcl LINEERR_INVALAGENTID             fixed bin(31) value('80000057'xn);
 dcl LINEERR_INVALAGENTGROUP          fixed bin(31) value('80000058'xn);
 dcl LINEERR_INVALPASSWORD            fixed bin(31) value('80000059'xn);
 dcl LINEERR_INVALAGENTSTATE          fixed bin(31) value('8000005A'xn);
 dcl LINEERR_INVALAGENTACTIVITY       fixed bin(31) value('8000005B'xn);
 dcl LINEERR_DIALVOICEDETECT          fixed bin(31) value('8000005C'xn);

 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl LINEERR_USERCANCELLED            fixed bin(31) value('8000005D'xn);
 %end;
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINEERR_INVALADDRESSTYPE         fixed bin(31) value('8000005E'xn);
 %end;

 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl LINEERR_INVALAGENTSESSIONSTATE   fixed bin(31) value('8000005F'xn);
 dcl LINEERR_DISCONNECTED             fixed bin(31) value('80000060'xn);
 %end;

 dcl LINEFEATURE_DEVSPECIFIC             type DWORD value('00000001'xu);
 dcl LINEFEATURE_DEVSPECIFICFEAT         type DWORD value('00000002'xu);
 dcl LINEFEATURE_FORWARD                 type DWORD value('00000004'xu);
 dcl LINEFEATURE_MAKECALL                type DWORD value('00000008'xu);
 dcl LINEFEATURE_SETMEDIACONTROL         type DWORD value('00000010'xu);
 dcl LINEFEATURE_SETTERMINAL             type DWORD value('00000020'xu);
 dcl LINEFEATURE_SETDEVSTATUS            type DWORD value('00000040'xu);
 dcl LINEFEATURE_FORWARDFWD              type DWORD value('00000080'xu);
 dcl LINEFEATURE_FORWARDDND              type DWORD value('00000100'xu);

 dcl LINEFORWARDMODE_UNCOND              type DWORD value('00000001'xu);
 dcl LINEFORWARDMODE_UNCONDINTERNAL      type DWORD value('00000002'xu);
 dcl LINEFORWARDMODE_UNCONDEXTERNAL      type DWORD value('00000004'xu);
 dcl LINEFORWARDMODE_UNCONDSPECIFIC      type DWORD value('00000008'xu);
 dcl LINEFORWARDMODE_BUSY                type DWORD value('00000010'xu);
 dcl LINEFORWARDMODE_BUSYINTERNAL        type DWORD value('00000020'xu);
 dcl LINEFORWARDMODE_BUSYEXTERNAL        type DWORD value('00000040'xu);
 dcl LINEFORWARDMODE_BUSYSPECIFIC        type DWORD value('00000080'xu);
 dcl LINEFORWARDMODE_NOANSW              type DWORD value('00000100'xu);
 dcl LINEFORWARDMODE_NOANSWINTERNAL      type DWORD value('00000200'xu);
 dcl LINEFORWARDMODE_NOANSWEXTERNAL      type DWORD value('00000400'xu);
 dcl LINEFORWARDMODE_NOANSWSPECIFIC      type DWORD value('00000800'xu);
 dcl LINEFORWARDMODE_BUSYNA              type DWORD value('00001000'xu);
 dcl LINEFORWARDMODE_BUSYNAINTERNAL      type DWORD value('00002000'xu);
 dcl LINEFORWARDMODE_BUSYNAEXTERNAL      type DWORD value('00004000'xu);
 dcl LINEFORWARDMODE_BUSYNASPECIFIC      type DWORD value('00008000'xu);
 dcl LINEFORWARDMODE_UNKNOWN             type DWORD value('00010000'xu);
 dcl LINEFORWARDMODE_UNAVAIL             type DWORD value('00020000'xu);

 dcl LINEGATHERTERM_BUFFERFULL           type DWORD value('00000001'xu);
 dcl LINEGATHERTERM_TERMDIGIT            type DWORD value('00000002'xu);
 dcl LINEGATHERTERM_FIRSTTIMEOUT         type DWORD value('00000004'xu);
 dcl LINEGATHERTERM_INTERTIMEOUT         type DWORD value('00000008'xu);
 dcl LINEGATHERTERM_CANCEL               type DWORD value('00000010'xu);

 dcl LINEGENERATETERM_DONE               type DWORD value('00000001'xu);
 dcl LINEGENERATETERM_CANCEL             type DWORD value('00000002'xu);

 /* These constants are mutually exclusive                            */
 /* - there's no way to specify more than one at a time (and it       */
 /* doesn't make sense, either) so they're ordinal rather than bits.  */
 dcl ( LINEINITIALIZEEXOPTION_USEHIDDENWINDOW       value('00000001'xu)
     , LINEINITIALIZEEXOPTION_USEEVENT              value('00000002'xu)
     , LINEINITIALIZEEXOPTION_USECOMPLETIONPORT     value('00000003'xu)
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
     , LINEINITIALIZEEXOPTION_CALLHUBTRACKING       value('80000000'xu)
 %end;
     ) type DWORD;

 dcl LINELOCATIONOPTION_PULSEDIAL        type DWORD value('00000001'xu);

 dcl LINEMAPPER                          type DWORD value('FFFFFFFF'xu);

 dcl LINEMEDIACONTROL_NONE               type DWORD value('00000001'xu);
 dcl LINEMEDIACONTROL_START              type DWORD value('00000002'xu);
 dcl LINEMEDIACONTROL_RESET              type DWORD value('00000004'xu);
 dcl LINEMEDIACONTROL_PAUSE              type DWORD value('00000008'xu);
 dcl LINEMEDIACONTROL_RESUME             type DWORD value('00000010'xu);
 dcl LINEMEDIACONTROL_RATEUP             type DWORD value('00000020'xu);
 dcl LINEMEDIACONTROL_RATEDOWN           type DWORD value('00000040'xu);
 dcl LINEMEDIACONTROL_RATENORMAL         type DWORD value('00000080'xu);
 dcl LINEMEDIACONTROL_VOLUMEUP           type DWORD value('00000100'xu);
 dcl LINEMEDIACONTROL_VOLUMEDOWN         type DWORD value('00000200'xu);
 dcl LINEMEDIACONTROL_VOLUMENORMAL       type DWORD value('00000400'xu);

 dcl LINEMEDIAMODE_UNKNOWN               type DWORD value('00000002'xu);
 dcl LINEMEDIAMODE_INTERACTIVEVOICE      type DWORD value('00000004'xu);
 dcl LINEMEDIAMODE_AUTOMATEDVOICE        type DWORD value('00000008'xu);
 dcl LINEMEDIAMODE_DATAMODEM             type DWORD value('00000010'xu);
 dcl LINEMEDIAMODE_G3FAX                 type DWORD value('00000020'xu);
 dcl LINEMEDIAMODE_TDD                   type DWORD value('00000040'xu);
 dcl LINEMEDIAMODE_G4FAX                 type DWORD value('00000080'xu);
 dcl LINEMEDIAMODE_DIGITALDATA           type DWORD value('00000100'xu);
 dcl LINEMEDIAMODE_TELETEX               type DWORD value('00000200'xu);
 dcl LINEMEDIAMODE_VIDEOTEX              type DWORD value('00000400'xu);
 dcl LINEMEDIAMODE_TELEX                 type DWORD value('00000800'xu);
 dcl LINEMEDIAMODE_MIXED                 type DWORD value('00001000'xu);
 dcl LINEMEDIAMODE_ADSI                  type DWORD value('00002000'xu);
 dcl LINEMEDIAMODE_VOICEVIEW             type DWORD value('00004000'xu);

 %if TAPI_CURRENT_VERSION >= '00020001' %then %do;
 dcl LINEMEDIAMODE_VIDEO                 type DWORD value('00008000'xu);
 %end;
 dcl LAST_LINEMEDIAMODE                  type DWORD value('00008000'xu);

 dcl LINEOFFERINGMODE_ACTIVE             type DWORD value('00000001'xu);
 dcl LINEOFFERINGMODE_INACTIVE           type DWORD value('00000002'xu);

 dcl LINEOPENOPTION_SINGLEADDRESS        type DWORD value('80000000'xu);
 dcl LINEOPENOPTION_PROXY                type DWORD value('40000000'xu);

 dcl LINEPARKMODE_DIRECTED               type DWORD value('00000001'xu);
 dcl LINEPARKMODE_NONDIRECTED            type DWORD value('00000002'xu);

 dcl LINEPROXYREQUEST_SETAGENTGROUP      type DWORD value('00000001'xu);
 dcl LINEPROXYREQUEST_SETAGENTSTATE      type DWORD value('00000002'xu);
 dcl LINEPROXYREQUEST_SETAGENTACTIVITY   type DWORD value('00000003'xu);
 dcl LINEPROXYREQUEST_GETAGENTCAPS       type DWORD value('00000004'xu);
 dcl LINEPROXYREQUEST_GETAGENTSTATUS     type DWORD value('00000005'xu);
 dcl LINEPROXYREQUEST_AGENTSPECIFIC      type DWORD value('00000006'xu);
 dcl LINEPROXYREQUEST_GETAGENTACTIVITYLIST
                                         type DWORD value('00000007'xu);
 dcl LINEPROXYREQUEST_GETAGENTGROUPLIST  type DWORD value('00000008'xu);


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl LINEPROXYREQUEST_CREATEAGENT        type DWORD value('00000009'xu);
 dcl LINEPROXYREQUEST_SETAGENTMEASUREMENTPERIOD
                                         type DWORD value('0000000A'xu);
 dcl LINEPROXYREQUEST_GETAGENTINFO       type DWORD value('0000000B'xu);
 dcl LINEPROXYREQUEST_CREATEAGENTSESSION type DWORD value('0000000C'xu);
 dcl LINEPROXYREQUEST_GETAGENTSESSIONLIST
                                         type DWORD value('0000000D'xu);
 dcl LINEPROXYREQUEST_SETAGENTSESSIONSTATE
                                         type DWORD value('0000000E'xu);
 dcl LINEPROXYREQUEST_GETAGENTSESSIONINFO
                                         type DWORD value('0000000F'xu);
 dcl LINEPROXYREQUEST_GETQUEUELIST       type DWORD value('00000010'xu);
 dcl LINEPROXYREQUEST_SETQUEUEMEASUREMENTPERIOD
                                         type DWORD value('00000011'xu);
 dcl LINEPROXYREQUEST_GETQUEUEINFO       type DWORD value('00000012'xu);
 dcl LINEPROXYREQUEST_GETGROUPLIST       type DWORD value('00000013'xu);
 dcl LINEPROXYREQUEST_SETAGENTSTATEEX    type DWORD value('00000014'xu);
 %end;

 dcl LINEREMOVEFROMCONF_NONE             type DWORD value('00000001'xu);
 dcl LINEREMOVEFROMCONF_LAST             type DWORD value('00000002'xu);
 dcl LINEREMOVEFROMCONF_ANY              type DWORD value('00000003'xu);

 dcl LINEREQUESTMODE_MAKECALL            type DWORD value('00000001'xu);
 dcl LINEREQUESTMODE_MEDIACALL           type DWORD value('00000002'xu);
 dcl LINEREQUESTMODE_DROP                type DWORD value('00000004'xu);
 dcl LAST_LINEREQUESTMODE   type DWORD value(LINEREQUESTMODE_MEDIACALL);
 dcl LINEROAMMODE_UNKNOWN                type DWORD value('00000001'xu);
 dcl LINEROAMMODE_UNAVAIL                type DWORD value('00000002'xu);
 dcl LINEROAMMODE_HOME                   type DWORD value('00000004'xu);
 dcl LINEROAMMODE_ROAMA                  type DWORD value('00000008'xu);
 dcl LINEROAMMODE_ROAMB                  type DWORD value('00000010'xu);

 dcl LINESPECIALINFO_NOCIRCUIT           type DWORD value('00000001'xu);
 dcl LINESPECIALINFO_CUSTIRREG           type DWORD value('00000002'xu);
 dcl LINESPECIALINFO_REORDER             type DWORD value('00000004'xu);
 dcl LINESPECIALINFO_UNKNOWN             type DWORD value('00000008'xu);
 dcl LINESPECIALINFO_UNAVAIL             type DWORD value('00000010'xu);

 dcl LINETERMDEV_PHONE                   type DWORD value('00000001'xu);
 dcl LINETERMDEV_HEADSET                 type DWORD value('00000002'xu);
 dcl LINETERMDEV_SPEAKER                 type DWORD value('00000004'xu);

 dcl LINETERMMODE_BUTTONS                type DWORD value('00000001'xu);
 dcl LINETERMMODE_LAMPS                  type DWORD value('00000002'xu);
 dcl LINETERMMODE_DISPLAY                type DWORD value('00000004'xu);
 dcl LINETERMMODE_RINGER                 type DWORD value('00000008'xu);
 dcl LINETERMMODE_HOOKSWITCH             type DWORD value('00000010'xu);
 dcl LINETERMMODE_MEDIATOLINE            type DWORD value('00000020'xu);
 dcl LINETERMMODE_MEDIAFROMLINE          type DWORD value('00000040'xu);
 dcl LINETERMMODE_MEDIABIDIRECT          type DWORD value('00000080'xu);

 dcl LINETERMSHARING_PRIVATE             type DWORD value('00000001'xu);
 dcl LINETERMSHARING_SHAREDEXCL          type DWORD value('00000002'xu);
 dcl LINETERMSHARING_SHAREDCONF          type DWORD value('00000004'xu);

 dcl LINETOLLLISTOPTION_ADD              type DWORD value('00000001'xu);
 dcl LINETOLLLISTOPTION_REMOVE           type DWORD value('00000002'xu);

 dcl LINETONEMODE_CUSTOM                 type DWORD value('00000001'xu);
 dcl LINETONEMODE_RINGBACK               type DWORD value('00000002'xu);
 dcl LINETONEMODE_BUSY                   type DWORD value('00000004'xu);
 dcl LINETONEMODE_BEEP                   type DWORD value('00000008'xu);
 dcl LINETONEMODE_BILLING                type DWORD value('00000010'xu);

 dcl LINETRANSFERMODE_TRANSFER           type DWORD value('00000001'xu);
 dcl LINETRANSFERMODE_CONFERENCE         type DWORD value('00000002'xu);

 dcl LINETRANSLATEOPTION_CARDOVERRIDE    type DWORD value('00000001'xu);
 dcl LINETRANSLATEOPTION_CANCELCALLWAITING
                                         type DWORD value('00000002'xu);
 dcl LINETRANSLATEOPTION_FORCELOCAL      type DWORD value('00000004'xu);
 dcl LINETRANSLATEOPTION_FORCELD         type DWORD value('00000008'xu);

 dcl LINETRANSLATERESULT_CANONICAL       type DWORD value('00000001'xu);
 dcl LINETRANSLATERESULT_INTERNATIONAL   type DWORD value('00000002'xu);
 dcl LINETRANSLATERESULT_LONGDISTANCE    type DWORD value('00000004'xu);
 dcl LINETRANSLATERESULT_LOCAL           type DWORD value('00000008'xu);
 dcl LINETRANSLATERESULT_INTOLLLIST      type DWORD value('00000010'xu);
 dcl LINETRANSLATERESULT_NOTINTOLLLIST   type DWORD value('00000020'xu);
 dcl LINETRANSLATERESULT_DIALBILLING     type DWORD value('00000040'xu);
 dcl LINETRANSLATERESULT_DIALQUIET       type DWORD value('00000080'xu);
 dcl LINETRANSLATERESULT_DIALDIALTONE    type DWORD value('00000100'xu);
 dcl LINETRANSLATERESULT_DIALPROMPT      type DWORD value('00000200'xu);
 dcl LINETRANSLATERESULT_VOICEDETECT     type DWORD value('00000400'xu);
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 dcl LINETRANSLATERESULT_NOTRANSLATION   type DWORD value('00000800'xu);
 %end;

 dcl PHONEBUTTONFUNCTION_UNKNOWN         type DWORD value('00000000'xu);
 dcl PHONEBUTTONFUNCTION_CONFERENCE      type DWORD value('00000001'xu);
 dcl PHONEBUTTONFUNCTION_TRANSFER        type DWORD value('00000002'xu);
 dcl PHONEBUTTONFUNCTION_DROP            type DWORD value('00000003'xu);
 dcl PHONEBUTTONFUNCTION_HOLD            type DWORD value('00000004'xu);
 dcl PHONEBUTTONFUNCTION_RECALL          type DWORD value('00000005'xu);
 dcl PHONEBUTTONFUNCTION_DISCONNECT      type DWORD value('00000006'xu);
 dcl PHONEBUTTONFUNCTION_CONNECT         type DWORD value('00000007'xu);
 dcl PHONEBUTTONFUNCTION_MSGWAITON       type DWORD value('00000008'xu);
 dcl PHONEBUTTONFUNCTION_MSGWAITOFF      type DWORD value('00000009'xu);
 dcl PHONEBUTTONFUNCTION_SELECTRING      type DWORD value('0000000A'xu);
 dcl PHONEBUTTONFUNCTION_ABBREVDIAL      type DWORD value('0000000B'xu);
 dcl PHONEBUTTONFUNCTION_FORWARD         type DWORD value('0000000C'xu);
 dcl PHONEBUTTONFUNCTION_PICKUP          type DWORD value('0000000D'xu);
 dcl PHONEBUTTONFUNCTION_RINGAGAIN       type DWORD value('0000000E'xu);
 dcl PHONEBUTTONFUNCTION_PARK            type DWORD value('0000000F'xu);
 dcl PHONEBUTTONFUNCTION_REJECT          type DWORD value('00000010'xu);
 dcl PHONEBUTTONFUNCTION_REDIRECT        type DWORD value('00000011'xu);
 dcl PHONEBUTTONFUNCTION_MUTE            type DWORD value('00000012'xu);
 dcl PHONEBUTTONFUNCTION_VOLUMEUP        type DWORD value('00000013'xu);
 dcl PHONEBUTTONFUNCTION_VOLUMEDOWN      type DWORD value('00000014'xu);
 dcl PHONEBUTTONFUNCTION_SPEAKERON       type DWORD value('00000015'xu);
 dcl PHONEBUTTONFUNCTION_SPEAKEROFF      type DWORD value('00000016'xu);
 dcl PHONEBUTTONFUNCTION_FLASH           type DWORD value('00000017'xu);
 dcl PHONEBUTTONFUNCTION_DATAON          type DWORD value('00000018'xu);
 dcl PHONEBUTTONFUNCTION_DATAOFF         type DWORD value('00000019'xu);
 dcl PHONEBUTTONFUNCTION_DONOTDISTURB    type DWORD value('0000001A'xu);
 dcl PHONEBUTTONFUNCTION_INTERCOM        type DWORD value('0000001B'xu);
 dcl PHONEBUTTONFUNCTION_BRIDGEDAPP      type DWORD value('0000001C'xu);
 dcl PHONEBUTTONFUNCTION_BUSY            type DWORD value('0000001D'xu);
 dcl PHONEBUTTONFUNCTION_CALLAPP         type DWORD value('0000001E'xu);
 dcl PHONEBUTTONFUNCTION_DATETIME        type DWORD value('0000001F'xu);
 dcl PHONEBUTTONFUNCTION_DIRECTORY       type DWORD value('00000020'xu);
 dcl PHONEBUTTONFUNCTION_COVER           type DWORD value('00000021'xu);
 dcl PHONEBUTTONFUNCTION_CALLID          type DWORD value('00000022'xu);
 dcl PHONEBUTTONFUNCTION_LASTNUM         type DWORD value('00000023'xu);
 dcl PHONEBUTTONFUNCTION_NIGHTSRV        type DWORD value('00000024'xu);
 dcl PHONEBUTTONFUNCTION_SENDCALLS       type DWORD value('00000025'xu);
 dcl PHONEBUTTONFUNCTION_MSGINDICATOR    type DWORD value('00000026'xu);
 dcl PHONEBUTTONFUNCTION_REPDIAL         type DWORD value('00000027'xu);
 dcl PHONEBUTTONFUNCTION_SETREPDIAL      type DWORD value('00000028'xu);
 dcl PHONEBUTTONFUNCTION_SYSTEMSPEED     type DWORD value('00000029'xu);
 dcl PHONEBUTTONFUNCTION_STATIONSPEED    type DWORD value('0000002A'xu);
 dcl PHONEBUTTONFUNCTION_CAMPON          type DWORD value('0000002B'xu);
 dcl PHONEBUTTONFUNCTION_SAVEREPEAT      type DWORD value('0000002C'xu);
 dcl PHONEBUTTONFUNCTION_QUEUECALL       type DWORD value('0000002D'xu);
 dcl PHONEBUTTONFUNCTION_NONE            type DWORD value('0000002E'xu);

 dcl PHONEBUTTONMODE_DUMMY               type DWORD value('00000001'xu);
 dcl PHONEBUTTONMODE_CALL                type DWORD value('00000002'xu);
 dcl PHONEBUTTONMODE_FEATURE             type DWORD value('00000004'xu);
 dcl PHONEBUTTONMODE_KEYPAD              type DWORD value('00000008'xu);
 dcl PHONEBUTTONMODE_LOCAL               type DWORD value('00000010'xu);
 dcl PHONEBUTTONMODE_DISPLAY             type DWORD value('00000020'xu);

 dcl PHONEBUTTONSTATE_UP                 type DWORD value('00000001'xu);
 dcl PHONEBUTTONSTATE_DOWN               type DWORD value('00000002'xu);
 dcl PHONEBUTTONSTATE_UNKNOWN            type DWORD value('00000004'xu);
 dcl PHONEBUTTONSTATE_UNAVAIL            type DWORD value('00000008'xu);

 dcl PHONEERR_ALLOCATED               fixed bin(31) value('90000001'xn);
 dcl PHONEERR_BADDEVICEID             fixed bin(31) value('90000002'xn);
 dcl PHONEERR_INCOMPATIBLEAPIVERSION  fixed bin(31) value('90000003'xn);
 dcl PHONEERR_INCOMPATIBLEEXTVERSION  fixed bin(31) value('90000004'xn);
 dcl PHONEERR_INIFILECORRUPT          fixed bin(31) value('90000005'xn);
 dcl PHONEERR_INUSE                   fixed bin(31) value('90000006'xn);
 dcl PHONEERR_INVALAPPHANDLE          fixed bin(31) value('90000007'xn);
 dcl PHONEERR_INVALAPPNAME            fixed bin(31) value('90000008'xn);
 dcl PHONEERR_INVALBUTTONLAMPID       fixed bin(31) value('90000009'xn);
 dcl PHONEERR_INVALBUTTONMODE         fixed bin(31) value('9000000A'xn);
 dcl PHONEERR_INVALBUTTONSTATE        fixed bin(31) value('9000000B'xn);
 dcl PHONEERR_INVALDATAID             fixed bin(31) value('9000000C'xn);
 dcl PHONEERR_INVALDEVICECLASS        fixed bin(31) value('9000000D'xn);
 dcl PHONEERR_INVALEXTVERSION         fixed bin(31) value('9000000E'xn);
 dcl PHONEERR_INVALHOOKSWITCHDEV      fixed bin(31) value('9000000F'xn);
 dcl PHONEERR_INVALHOOKSWITCHMODE     fixed bin(31) value('90000010'xn);
 dcl PHONEERR_INVALLAMPMODE           fixed bin(31) value('90000011'xn);
 dcl PHONEERR_INVALPARAM              fixed bin(31) value('90000012'xn);
 dcl PHONEERR_INVALPHONEHANDLE        fixed bin(31) value('90000013'xn);
 dcl PHONEERR_INVALPHONESTATE         fixed bin(31) value('90000014'xn);
 dcl PHONEERR_INVALPOINTER            fixed bin(31) value('90000015'xn);
 dcl PHONEERR_INVALPRIVILEGE          fixed bin(31) value('90000016'xn);
 dcl PHONEERR_INVALRINGMODE           fixed bin(31) value('90000017'xn);
 dcl PHONEERR_NODEVICE                fixed bin(31) value('90000018'xn);
 dcl PHONEERR_NODRIVER                fixed bin(31) value('90000019'xn);
 dcl PHONEERR_NOMEM                   fixed bin(31) value('9000001A'xn);
 dcl PHONEERR_NOTOWNER                fixed bin(31) value('9000001B'xn);
 dcl PHONEERR_OPERATIONFAILED         fixed bin(31) value('9000001C'xn);
 dcl PHONEERR_OPERATIONUNAVAIL        fixed bin(31) value('9000001D'xn);
 dcl PHONEERR_RESOURCEUNAVAIL         fixed bin(31) value('9000001F'xn);
 dcl PHONEERR_REQUESTOVERRUN          fixed bin(31) value('90000020'xn);
 dcl PHONEERR_STRUCTURETOOSMALL       fixed bin(31) value('90000021'xn);
 dcl PHONEERR_UNINITIALIZED           fixed bin(31) value('90000022'xn);
 dcl PHONEERR_REINIT                  fixed bin(31) value('90000023'xn);

 dcl PHONEFEATURE_GETBUTTONINFO          type DWORD value('00000001'xu);
 dcl PHONEFEATURE_GETDATA                type DWORD value('00000002'xu);
 dcl PHONEFEATURE_GETDISPLAY             type DWORD value('00000004'xu);
 dcl PHONEFEATURE_GETGAINHANDSET         type DWORD value('00000008'xu);
 dcl PHONEFEATURE_GETGAINSPEAKER         type DWORD value('00000010'xu);
 dcl PHONEFEATURE_GETGAINHEADSET         type DWORD value('00000020'xu);
 dcl PHONEFEATURE_GETHOOKSWITCHHANDSET   type DWORD value('00000040'xu);
 dcl PHONEFEATURE_GETHOOKSWITCHSPEAKER   type DWORD value('00000080'xu);
 dcl PHONEFEATURE_GETHOOKSWITCHHEADSET   type DWORD value('00000100'xu);
 dcl PHONEFEATURE_GETLAMP                type DWORD value('00000200'xu);
 dcl PHONEFEATURE_GETRING                type DWORD value('00000400'xu);
 dcl PHONEFEATURE_GETVOLUMEHANDSET       type DWORD value('00000800'xu);
 dcl PHONEFEATURE_GETVOLUMESPEAKER       type DWORD value('00001000'xu);
 dcl PHONEFEATURE_GETVOLUMEHEADSET       type DWORD value('00002000'xu);
 dcl PHONEFEATURE_SETBUTTONINFO          type DWORD value('00004000'xu);
 dcl PHONEFEATURE_SETDATA                type DWORD value('00008000'xu);
 dcl PHONEFEATURE_SETDISPLAY             type DWORD value('00010000'xu);
 dcl PHONEFEATURE_SETGAINHANDSET         type DWORD value('00020000'xu);
 dcl PHONEFEATURE_SETGAINSPEAKER         type DWORD value('00040000'xu);
 dcl PHONEFEATURE_SETGAINHEADSET         type DWORD value('00080000'xu);
 dcl PHONEFEATURE_SETHOOKSWITCHHANDSET   type DWORD value('00100000'xu);
 dcl PHONEFEATURE_SETHOOKSWITCHSPEAKER   type DWORD value('00200000'xu);
 dcl PHONEFEATURE_SETHOOKSWITCHHEADSET   type DWORD value('00400000'xu);
 dcl PHONEFEATURE_SETLAMP                type DWORD value('00800000'xu);
 dcl PHONEFEATURE_SETRING                type DWORD value('01000000'xu);
 dcl PHONEFEATURE_SETVOLUMEHANDSET       type DWORD value('02000000'xu);
 dcl PHONEFEATURE_SETVOLUMESPEAKER       type DWORD value('04000000'xu);
 dcl PHONEFEATURE_SETVOLUMEHEADSET       type DWORD value('08000000'xu);

 dcl PHONEHOOKSWITCHDEV_HANDSET          type DWORD value('00000001'xu);
 dcl PHONEHOOKSWITCHDEV_SPEAKER          type DWORD value('00000002'xu);
 dcl PHONEHOOKSWITCHDEV_HEADSET          type DWORD value('00000004'xu);

 dcl PHONEHOOKSWITCHMODE_ONHOOK          type DWORD value('00000001'xu);
 dcl PHONEHOOKSWITCHMODE_MIC             type DWORD value('00000002'xu);
 dcl PHONEHOOKSWITCHMODE_SPEAKER         type DWORD value('00000004'xu);
 dcl PHONEHOOKSWITCHMODE_MICSPEAKER      type DWORD value('00000008'xu);
 dcl PHONEHOOKSWITCHMODE_UNKNOWN         type DWORD value('00000010'xu);

 dcl PHONEINITIALIZEEXOPTION_USEHIDDENWINDOW
                                         type DWORD value('00000001'xu);
 dcl PHONEINITIALIZEEXOPTION_USEEVENT    type DWORD value('00000002'xu);
 dcl PHONEINITIALIZEEXOPTION_USECOMPLETIONPORT
                                         type DWORD value('00000003'xu);

 dcl PHONELAMPMODE_DUMMY                 type DWORD value('00000001'xu);
 dcl PHONELAMPMODE_OFF                   type DWORD value('00000002'xu);
 dcl PHONELAMPMODE_STEADY                type DWORD value('00000004'xu);
 dcl PHONELAMPMODE_WINK                  type DWORD value('00000008'xu);
 dcl PHONELAMPMODE_FLASH                 type DWORD value('00000010'xu);
 dcl PHONELAMPMODE_FLUTTER               type DWORD value('00000020'xu);
 dcl PHONELAMPMODE_BROKENFLUTTER         type DWORD value('00000040'xu);
 dcl PHONELAMPMODE_UNKNOWN               type DWORD value('00000080'xu);

 dcl PHONEPRIVILEGE_MONITOR              type DWORD value('00000001'xu);
 dcl PHONEPRIVILEGE_OWNER                type DWORD value('00000002'xu);

 dcl PHONESTATE_OTHER                    type DWORD value('00000001'xu);
 dcl PHONESTATE_CONNECTED                type DWORD value('00000002'xu);
 dcl PHONESTATE_DISCONNECTED             type DWORD value('00000004'xu);
 dcl PHONESTATE_OWNER                    type DWORD value('00000008'xu);
 dcl PHONESTATE_MONITORS                 type DWORD value('00000010'xu);
 dcl PHONESTATE_DISPLAY                  type DWORD value('00000020'xu);
 dcl PHONESTATE_LAMP                     type DWORD value('00000040'xu);
 dcl PHONESTATE_RINGMODE                 type DWORD value('00000080'xu);
 dcl PHONESTATE_RINGVOLUME               type DWORD value('00000100'xu);
 dcl PHONESTATE_HANDSETHOOKSWITCH        type DWORD value('00000200'xu);
 dcl PHONESTATE_HANDSETVOLUME            type DWORD value('00000400'xu);
 dcl PHONESTATE_HANDSETGAIN              type DWORD value('00000800'xu);
 dcl PHONESTATE_SPEAKERHOOKSWITCH        type DWORD value('00001000'xu);
 dcl PHONESTATE_SPEAKERVOLUME            type DWORD value('00002000'xu);
 dcl PHONESTATE_SPEAKERGAIN              type DWORD value('00004000'xu);
 dcl PHONESTATE_HEADSETHOOKSWITCH        type DWORD value('00008000'xu);
 dcl PHONESTATE_HEADSETVOLUME            type DWORD value('00010000'xu);
 dcl PHONESTATE_HEADSETGAIN              type DWORD value('00020000'xu);
 dcl PHONESTATE_SUSPEND                  type DWORD value('00040000'xu);
 dcl PHONESTATE_RESUME                   type DWORD value('00080000'xu);
 dcl PHONESTATE_DEVSPECIFIC              type DWORD value('00100000'xu);
 dcl PHONESTATE_REINIT                   type DWORD value('00200000'xu);
 dcl PHONESTATE_CAPSCHANGE               type DWORD value('00400000'xu);
 dcl PHONESTATE_REMOVED                  type DWORD value('00800000'xu);

 dcl PHONESTATUSFLAGS_CONNECTED          type DWORD value('00000001'xu);
 dcl PHONESTATUSFLAGS_SUSPENDED          type DWORD value('00000002'xu);

 dcl STRINGFORMAT_ASCII                  type DWORD value('00000001'xu);
 dcl STRINGFORMAT_DBCS                   type DWORD value('00000002'xu);
 dcl STRINGFORMAT_UNICODE                type DWORD value('00000003'xu);
 dcl STRINGFORMAT_BINARY                 type DWORD value('00000004'xu);

 dcl TAPI_REPLY                      fixed bin(31) value (WM_USER + 99);

 dcl TAPIERR_CONNECTED                fixed bin(31) value(0);
 dcl TAPIERR_DROPPED                  fixed bin(31) value(-1);
 dcl TAPIERR_NOREQUESTRECIPIENT       fixed bin(31) value(-2);
 dcl TAPIERR_REQUESTQUEUEFULL         fixed bin(31) value(-3);
 dcl TAPIERR_INVALDESTADDRESS         fixed bin(31) value(-4);
 dcl TAPIERR_INVALWINDOWHANDLE        fixed bin(31) value(-5);
 dcl TAPIERR_INVALDEVICECLASS         fixed bin(31) value(-6);
 dcl TAPIERR_INVALDEVICEID            fixed bin(31) value(-7);
 dcl TAPIERR_DEVICECLASSUNAVAIL       fixed bin(31) value(-8);
 dcl TAPIERR_DEVICEIDUNAVAIL          fixed bin(31) value(-9);
 dcl TAPIERR_DEVICEINUSE              fixed bin(31) value(-10);
 dcl TAPIERR_DESTBUSY                 fixed bin(31) value(-11);
 dcl TAPIERR_DESTNOANSWER             fixed bin(31) value(-12);
 dcl TAPIERR_DESTUNAVAIL              fixed bin(31) value(-13);
 dcl TAPIERR_UNKNOWNWINHANDLE         fixed bin(31) value(-14);
 dcl TAPIERR_UNKNOWNREQUESTID         fixed bin(31) value(-15);
 dcl TAPIERR_REQUESTFAILED            fixed bin(31) value(-16);
 dcl TAPIERR_REQUESTCANCELLED         fixed bin(31) value(-17);
 dcl TAPIERR_INVALPOINTER             fixed bin(31) value(-18);


 dcl TAPIMAXDESTADDRESSSIZE           fixed bin(31) value(80);
 dcl TAPIMAXAPPNAMESIZE               fixed bin(31) value(40);
 dcl TAPIMAXCALLEDPARTYSIZE           fixed bin(31) value(40);
 dcl TAPIMAXCOMMENTSIZE               fixed bin(31) value(80);
 dcl TAPIMAXDEVICECLASSSIZE           fixed bin(31) value(40);
 dcl TAPIMAXDEVICEIDSIZE              fixed bin(31) value(40);


 %dcl GUID_DEFINED char ext;
 %if GUID_DEFINED = '' %then %do;
 %GUID_DEFINED = 'Y';
 define structure
   1 GUID,
     2 Data1 type DWORD,
     2 Data2 type WORD,
     2 Data3 type WORD,
     2 Data4 (8) char;
 %end;

 %dcl #_LPGUID_DEFINED__ char ext;
 %if #_LPGUID_DEFINED__ = '' %then %do;
 %#_LPGUID_DEFINED__ = 'Y';
 define alias LPGUID handle GUID;
 %end;

 define structure
   1 LINEADDRESSCAPS,
     2 dwTotalSize                    type DWORD,
     2 dwNeededSize                   type DWORD,
     2 dwUsedSize                     type DWORD,
     2 dwLineDeviceID                 type DWORD,
     2 dwAddressSize                  type DWORD,
     2 dwAddressOffset                type DWORD,
     2 dwDevSpecificSize              type DWORD,
     2 dwDevSpecificOffset            type DWORD,
     2 dwAddressSharing               type DWORD,
     2 dwAddressStates                type DWORD,
     2 dwCallInfoStates               type DWORD,
     2 dwCallerIDFlags                type DWORD,
     2 dwCalledIDFlags                type DWORD,
     2 dwConnectedIDFlags             type DWORD,
     2 dwRedirectionIDFlags           type DWORD,
     2 dwRedirectingIDFlags           type DWORD,
     2 dwCallStates                   type DWORD,
     2 dwDialToneModes                type DWORD,
     2 dwBusyModes                    type DWORD,
     2 dwSpecialInfo                  type DWORD,
     2 dwDisconnectModes              type DWORD,
     2 dwMaxNumActiveCalls            type DWORD,
     2 dwMaxNumOnHoldCalls            type DWORD,
     2 dwMaxNumOnHoldPendingCalls     type DWORD,
     2 dwMaxNumConference             type DWORD,
     2 dwMaxNumTransConf              type DWORD,
     2 dwAddrCapFlags                 type DWORD,
     2 dwCallFeatures                 type DWORD,
     2 dwRemoveFromConfCaps           type DWORD,
     2 dwRemoveFromConfState          type DWORD,
     2 dwTransferModes                type DWORD,
     2 dwParkModes                    type DWORD,
     2 dwForwardModes                 type DWORD,
     2 dwMaxForwardEntries            type DWORD,
     2 dwMaxSpecificEntries           type DWORD,
     2 dwMinFwdNumRings               type DWORD,
     2 dwMaxFwdNumRings               type DWORD,
     2 dwMaxCallCompletions           type DWORD,
     2 dwCallCompletionConds          type DWORD,
     2 dwCallCompletionModes          type DWORD,
     2 dwNumCompletionMessages        type DWORD,
     2 dwCompletionMsgTextEntrySize   type DWORD,
     2 dwCompletionMsgTextSize        type DWORD,
     2 dwCompletionMsgTextOffset      type DWORD,
     2 dwAddressFeatures              type DWORD,
     2 dwPredictiveAutoTransferStates type DWORD,
     2 dwNumCallTreatments            type DWORD,
     2 dwCallTreatmentListSize        type DWORD,
     2 dwCallTreatmentListOffset      type DWORD,
     2 dwDeviceClassesSize            type DWORD,
     2 dwDeviceClassesOffset          type DWORD,
     2 dwMaxCallDataSize              type DWORD,
     2 dwCallFeatures2                type DWORD,
     2 dwMaxNoAnswerTimeout           type DWORD,
     2 dwConnectedModes               type DWORD,
     2 dwOfferingModes                type DWORD,
     2 dwAvailableMediaModes          type DWORD;
 define alias LPLINEADDRESSCAPS handle LINEADDRESSCAPS;

 define structure
   1 LINEADDRESSSTATUS,
     2 dwTotalSize           type DWORD,
     2 dwNeededSize          type DWORD,
     2 dwUsedSize            type DWORD,
     2 dwNumInUse            type DWORD,
     2 dwNumActiveCalls      type DWORD,
     2 dwNumOnHoldCalls      type DWORD,
     2 dwNumOnHoldPendCalls  type DWORD,
     2 dwAddressFeatures     type DWORD,
     2 dwNumRingsNoAnswer    type DWORD,
     2 dwForwardNumEntries   type DWORD,
     2 dwForwardSize         type DWORD,
     2 dwForwardOffset       type DWORD,
     2 dwTerminalModesSize   type DWORD,
     2 dwTerminalModesOffset type DWORD,
     2 dwDevSpecificSize     type DWORD,
     2 dwDevSpecificOffset   type DWORD;
 define alias LPLINEADDRESSSTATUS handle LINEADDRESSSTATUS;

 define structure
   1 LINEAGENTACTIVITYENTRY,
     2 dwID         type DWORD,
     2 dwNameSize   type DWORD,
     2 dwNameOffset type DWORD;
 define alias LPLINEAGENTACTIVITYENTRY handle LINEAGENTACTIVITYENTRY;

 define structure
   1 LINEAGENTACTIVITYLIST,
     2 dwTotalSize  type DWORD,
     2 dwNeededSize type DWORD,
     2 dwUsedSize   type DWORD,
     2 dwNumEntries type DWORD,
     2 dwListSize   type DWORD,
     2 dwListOffset type DWORD;
 define alias LPLINEAGENTACTIVITYLIST handle LINEAGENTACTIVITYLIST;

 define structure
   1 LINEAGENTCAPS,
     2 dwTotalSize                  type DWORD,
     2 dwNeededSize                 type DWORD,
     2 dwUsedSize                   type DWORD,
     2 dwAgentHandlerInfoSize       type DWORD,
     2 dwAgentHandlerInfoOffset     type DWORD,
     2 dwCapsVersion                type DWORD,
     2 dwFeatures                   type DWORD,
     2 dwStates                     type DWORD,
     2 dwNextStates                 type DWORD,
     2 dwMaxNumGroupEntries         type DWORD,
     2 dwAgentStatusMessages        type DWORD,
     2 dwNumAgentExtensionIDs       type DWORD,
     2 dwAgentExtensionIDListSize   type DWORD,
     2 dwAgentExtensionIDListOffset type DWORD
 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
   , 2 ProxyGUID                    type GUID
 %end;
   ;
 define alias LPLINEAGENTCAPS handle LINEAGENTCAPS;


 define structure
   1 LINEAGENTGROUPENTRY,
     2 GroupID,
       3 dwGroupID1 type DWORD,
       3 dwGroupID2 type DWORD,
       3 dwGroupID3 type DWORD,
       3 dwGroupID4 type DWORD,
     2 dwNameSize   type DWORD,
     2 dwNameOffset type DWORD;
 define alias LPLINEAGENTGROUPENTRY handle LINEAGENTGROUPENTRY;

 define structure
   1 LINEAGENTGROUPLIST,
     2 dwTotalSize  type DWORD,
     2 dwNeededSize type DWORD,
     2 dwUsedSize   type DWORD,
     2 dwNumEntries type DWORD,
     2 dwListSize   type DWORD,
     2 dwListOffset type DWORD;
 define alias LPLINEAGENTGROUPLIST handle LINEAGENTGROUPLIST;

 define structure
   1 LINEAGENTSTATUS,
     2 dwTotalSize       type DWORD,
     2 dwNeededSize      type DWORD,
     2 dwUsedSize        type DWORD,
     2 dwNumEntries      type DWORD,
     2 dwGroupListSize   type DWORD,
     2 dwGroupListOffset type DWORD,
     2 dwState           type DWORD,
     2 dwNextState       type DWORD,
     2 dwActivityID      type DWORD,
     2 dwActivitySize    type DWORD,
     2 dwActivityOffset  type DWORD,
     2 dwAgentFeatures   type DWORD,
     2 dwValidStates     type DWORD,
     2 dwValidNextStates type DWORD;
 define alias LPLINEAGENTSTATUS handle LINEAGENTSTATUS;

 define structure
   1 LINEAPPINFO,
     2 dwMachineNameSize      type DWORD,
     2 dwMachineNameOffset    type DWORD,
     2 dwUserNameSize         type DWORD,
     2 dwUserNameOffset       type DWORD,
     2 dwModuleFilenameSize   type DWORD,
     2 dwModuleFilenameOffset type DWORD,
     2 dwFriendlyNameSize     type DWORD,
     2 dwFriendlyNameOffset   type DWORD,
     2 dwMediaModes           type DWORD,
     2 dwAddressID            type DWORD;
 define alias LPLINEAPPINFO handle LINEAPPINFO;


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 define structure
   1 LINEAGENTENTRY,
     2 hAgent       type HAGENT,
     2 dwNameSize   type DWORD,
     2 dwNameOffset type DWORD,
     2 dwIDSize     type DWORD,
     2 dwIDOffset   type DWORD,
     2 dwPINSize    type DWORD,
     2 dwPINOffset  type DWORD;
 define alias LPLINEAGENTENTRY handle LINEAGENTENTRY;

 define structure
   1 LINEAGENTLIST,
     2 dwTotalSize  type DWORD,
     2 dwNeededSize type DWORD,
     2 dwUsedSize   type DWORD,
     2 dwNumEntries type DWORD,
     2 dwListSize   type DWORD,
     2 dwListOffset type DWORD;
 define alias LPLINEAGENTLIST handle LINEAGENTLIST;

 define structure
   1 LINEAGENTINFO,
     2 dwTotalSize             type DWORD,
     2 dwNeededSize            type DWORD,
     2 dwUsedSize              type DWORD,
     2 dwAgentState            type DWORD,
     2 dwNextAgentState        type DWORD,
     2 dwMeasurementPeriod     type DWORD,
     2 cyOverallCallRate       type CURRENCY,
     2 dwNumberOfACDCalls      type DWORD,
     2 dwNumberOfIncomingCalls type DWORD,
     2 dwNumberOfOutgoingCalls type DWORD,
     2 dwTotalACDTalkTime      type DWORD,
     2 dwTotalACDCallTime      type DWORD,
     2 dwTotalACDWrapUpTime    type DWORD;
 define alias LPLINEAGENTINFO handle LINEAGENTINFO;

 define structure
   1 LINEAGENTSESSIONENTRY,
     2 hAgentSession      type HAGENTSESSION,
     2 hAgent             type HAGENT,
     2 GroupID            type GUID,
     2 dwWorkingAddressID type DWORD;
 define alias LPLINEAGENTSESSIONENTRY handle LINEAGENTSESSIONENTRY;

 define structure
   1 LINEAGENTSESSIONLIST,
     2 dwTotalSize  type DWORD,
     2 dwNeededSize type DWORD,
     2 dwUsedSize   type DWORD,
     2 dwNumEntries type DWORD,
     2 dwListSize   type DWORD,
     2 dwListOffset type DWORD;
 define alias LPLINEAGENTSESSIONLIST handle LINEAGENTSESSIONLIST;

 define structure
   1 LINEAGENTSESSIONINFO unaligned,
     2 dwTotalSize             type DWORD,
     2 dwNeededSize            type DWORD,
     2 dwUsedSize              type DWORD,
     2 dwAgentSessionState     type DWORD,
     2 dwNextAgentSessionState type DWORD,
     2 dateSessionStartTime    type DATE,
     2 dwSessionDuration       type DWORD,
     2 dwNumberOfCalls         type DWORD,
     2 dwTotalTalkTime         type DWORD,
     2 dwAverageTalkTime       type DWORD,
     2 dwTotalCallTime         type DWORD,
     2 dwAverageCallTime       type DWORD,
     2 dwTotalWrapUpTime       type DWORD,
     2 dwAverageWrapUpTime     type DWORD,
     2 cyACDCallRate           type CURRENCY,
     2 dwLongestTimeToAnswer   type DWORD,
     2 dwAverageTimeToAnswer   type DWORD;
 define alias LPLINEAGENTSESSIONINFO handle LINEAGENTSESSIONINFO;

 define structure
   1 LINEQUEUEENTRY,
     2 dwQueueID    type DWORD,
     2 dwNameSize   type DWORD,
     2 dwNameOffset type DWORD;
 define alias LPLINEQUEUEENTRY handle LINEQUEUEENTRY;

 define structure
   1 LINEQUEUELIST,
     2 dwTotalSize  type DWORD,
     2 dwNeededSize type DWORD,
     2 dwUsedSize   type DWORD,
     2 dwNumEntries type DWORD,
     2 dwListSize   type DWORD,
     2 dwListOffset type DWORD;
 define alias LPLINEQUEUELIST handle LINEQUEUELIST;

 define structure
   1 LINEQUEUEINFO,
     2 dwTotalSize              type DWORD,
     2 dwNeededSize             type DWORD,
     2 dwUsedSize               type DWORD,
     2 dwMeasurementPeriod      type DWORD,
     2 dwTotalCallsQueued       type DWORD,
     2 dwCurrentCallsQueued     type DWORD,
     2 dwTotalCallsAbandoned    type DWORD,
     2 dwTotalCallsFlowedIn     type DWORD,
     2 dwTotalCallsFlowedOut    type DWORD,
     2 dwLongestEverWaitTime    type DWORD,
     2 dwCurrentLongestWaitTime type DWORD,
     2 dwAverageWaitTime        type DWORD,
     2 dwFinalDisposition       type DWORD;
 define alias LPLINEQUEUEINFO handle LINEQUEUEINFO;

 define structure
   1 LINEPROXYREQUESTLIST,
     2 dwTotalSize  type DWORD,
     2 dwNeededSize type DWORD,
     2 dwUsedSize   type DWORD,
     2 dwNumEntries type DWORD,
     2 dwListSize   type DWORD,
     2 dwListOffset type DWORD;
 define alias LPLINEPROXYREQUESTLIST handle LINEPROXYREQUESTLIST;
 %end;


 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
 define structure
   1 LINECALLHUBTRACKINGINFO,
     2 dwTotalSize         type DWORD,
     2 dwNeededSize        type DWORD,
     2 dwUsedSize          type DWORD,
     2 dwAvailableTracking type DWORD,
     2 dwCurrentTracking   type DWORD;
 define alias LPLINECALLHUBTRACKINGINFO handle LINECALLHUBTRACKINGINFO;
 %end;

 define structure
   1 LINEDIALPARAMS,
     2 dwDialPause       type DWORD,
     2 dwDialSpeed       type DWORD,
     2 dwDigitDuration   type DWORD,
     2 dwWaitForDialtone type DWORD;
 define alias LPLINEDIALPARAMS handle LINEDIALPARAMS;

 define structure
   1 LINECALLINFO,
     2 dwTotalSize                type DWORD,
     2 dwNeededSize               type DWORD,
     2 dwUsedSize                 type DWORD,
     2 hLine                      type HLINE,
     2 dwLineDeviceID             type DWORD,
     2 dwAddressID                type DWORD,
     2 dwBearerMode               type DWORD,
     2 dwRate                     type DWORD,
     2 dwMediaMode                type DWORD,
     2 dwAppSpecific              type DWORD,
     2 dwCallID                   type DWORD,
     2 dwRelatedCallID            type DWORD,
     2 dwCallParamFlags           type DWORD,
     2 dwCallStates               type DWORD,
     2 dwMonitorDigitModes        type DWORD,
     2 dwMonitorMediaModes        type DWORD,
     2 DialParams                 type LINEDIALPARAMS,
     2 dwOrigin                   type DWORD,
     2 dwReason                   type DWORD,
     2 dwCompletionID             type DWORD,
     2 dwNumOwners                type DWORD,
     2 dwNumMonitors              type DWORD,
     2 dwCountryCode              type DWORD,
     2 dwTrunk                    type DWORD,
     2 dwCallerIDFlags            type DWORD,
     2 dwCallerIDSize             type DWORD,
     2 dwCallerIDOffset           type DWORD,
     2 dwCallerIDNameSize         type DWORD,
     2 dwCallerIDNameOffset       type DWORD,
     2 dwCalledIDFlags            type DWORD,
     2 dwCalledIDSize             type DWORD,
     2 dwCalledIDOffset           type DWORD,
     2 dwCalledIDNameSize         type DWORD,
     2 dwCalledIDNameOffset       type DWORD,
     2 dwConnectedIDFlags         type DWORD,
     2 dwConnectedIDSize          type DWORD,
     2 dwConnectedIDOffset        type DWORD,
     2 dwConnectedIDNameSize      type DWORD,
     2 dwConnectedIDNameOffset    type DWORD,
     2 dwRedirectionIDFlags       type DWORD,
     2 dwRedirectionIDSize        type DWORD,
     2 dwRedirectionIDOffset      type DWORD,
     2 dwRedirectionIDNameSize    type DWORD,
     2 dwRedirectionIDNameOffset  type DWORD,
     2 dwRedirectingIDFlags       type DWORD,
     2 dwRedirectingIDSize        type DWORD,
     2 dwRedirectingIDOffset      type DWORD,
     2 dwRedirectingIDNameSize    type DWORD,
     2 dwRedirectingIDNameOffset  type DWORD,
     2 dwAppNameSize              type DWORD,
     2 dwAppNameOffset            type DWORD,
     2 dwDisplayableAddressSize   type DWORD,
     2 dwDisplayableAddressOffset type DWORD,
     2 dwCalledPartySize          type DWORD,
     2 dwCalledPartyOffset        type DWORD,
     2 dwCommentSize              type DWORD,
     2 dwCommentOffset            type DWORD,
     2 dwDisplaySize              type DWORD,
     2 dwDisplayOffset            type DWORD,
     2 dwUserUserInfoSize         type DWORD,
     2 dwUserUserInfoOffset       type DWORD,
     2 dwHighLevelCompSize        type DWORD,
     2 dwHighLevelCompOffset      type DWORD,
     2 dwLowLevelCompSize         type DWORD,
     2 dwLowLevelCompOffset       type DWORD,
     2 dwChargingInfoSize         type DWORD,
     2 dwChargingInfoOffset       type DWORD,
     2 dwTerminalModesSize        type DWORD,
     2 dwTerminalModesOffset      type DWORD,
     2 dwDevSpecificSize          type DWORD,
     2 dwDevSpecificOffset        type DWORD,
     2 dwCallTreatment            type DWORD,
     2 dwCallDataSize             type DWORD,
     2 dwCallDataOffset           type DWORD,
     2 dwSendingFlowspecSize      type DWORD,
     2 dwSendingFlowspecOffset    type DWORD,
     2 dwReceivingFlowspecSize    type DWORD,
     2 dwReceivingFlowspecOffset  type DWORD
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
   , 2 dwCallerIDAddressType      type DWORD
   , 2 dwCalledIDAddressType      type DWORD
   , 2 dwConnectedIDAddressType   type DWORD
   , 2 dwRedirectionIDAddressType type DWORD
   , 2 dwRedirectingIDAddressType type DWORD
 %end;
   ;
 define alias LPLINECALLINFO handle LINECALLINFO;

 define structure
   1 LINECALLLIST,
     2 dwTotalSize       type DWORD,
     2 dwNeededSize      type DWORD,
     2 dwUsedSize        type DWORD,
     2 dwCallsNumEntries type DWORD,
     2 dwCallsSize       type DWORD,
     2 dwCallsOffset     type DWORD;
 define alias LPLINECALLLIST handle LINECALLLIST;

 define structure
   1 LINECALLPARAMS,                             /* Defaults: */
     2 dwTotalSize                    type DWORD,/* --------- */
     2 dwBearerMode                   type DWORD,/* voice */
     2 dwMinRate                      type DWORD,/* (3.1kHz) */
     2 dwMaxRate                      type DWORD,/* (3.1kHz) */
     2 dwMediaMode                    type DWORD,/* interactiveVoice */
     2 dwCallParamFlags               type DWORD,/* 0 */
     2 dwAddressMode                  type DWORD,/* addressID */
     2 dwAddressID                    type DWORD,/* (any available) */
     2 DialParams            type LINEDIALPARAMS,/* (0, 0, 0, 0) */
     2 dwOrigAddressSize              type DWORD,/* 0 */
     2 dwOrigAddressOffset            type DWORD,
     2 dwDisplayableAddressSize       type DWORD,
     2 dwDisplayableAddressOffset     type DWORD,
     2 dwCalledPartySize              type DWORD,/* 0 */
     2 dwCalledPartyOffset            type DWORD,
     2 dwCommentSize                  type DWORD,/* 0 */
     2 dwCommentOffset                type DWORD,
     2 dwUserUserInfoSize             type DWORD,/* 0 */
     2 dwUserUserInfoOffset           type DWORD,
     2 dwHighLevelCompSize            type DWORD,/* 0 */
     2 dwHighLevelCompOffset          type DWORD,
     2 dwLowLevelCompSize             type DWORD,/* 0 */
     2 dwLowLevelCompOffset           type DWORD,
     2 dwDevSpecificSize              type DWORD,/* 0 */
     2 dwDevSpecificOffset            type DWORD,
     2 dwPredictiveAutoTransferStates type DWORD,
     2 dwTargetAddressSize            type DWORD,
     2 dwTargetAddressOffset          type DWORD,
     2 dwSendingFlowspecSize          type DWORD,
     2 dwSendingFlowspecOffset        type DWORD,
     2 dwReceivingFlowspecSize        type DWORD,
     2 dwReceivingFlowspecOffset      type DWORD,
     2 dwDeviceClassSize              type DWORD,
     2 dwDeviceClassOffset            type DWORD,
     2 dwDeviceConfigSize             type DWORD,
     2 dwDeviceConfigOffset           type DWORD,
     2 dwCallDataSize                 type DWORD,
     2 dwCallDataOffset               type DWORD,
     2 dwNoAnswerTimeout              type DWORD,
     2 dwCallingPartyIDSize           type DWORD,
     2 dwCallingPartyIDOffset         type DWORD
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
   , 2 dwAddressType                  type DWORD
 %end;
   ;
 define alias LPLINECALLPARAMS handle LINECALLPARAMS;

 define structure
   1 LINECALLSTATUS,
     2 dwTotalSize         type DWORD,
     2 dwNeededSize        type DWORD,
     2 dwUsedSize          type DWORD,
     2 dwCallState         type DWORD,
     2 dwCallStateMode     type DWORD,
     2 dwCallPrivilege     type DWORD,
     2 dwCallFeatures      type DWORD,
     2 dwDevSpecificSize   type DWORD,
     2 dwDevSpecificOffset type DWORD,
     2 dwCallFeatures2     type DWORD,
     2 tStateEntryTime     type SYSTEMTIME;
 define alias LPLINECALLSTATUS handle LINECALLSTATUS;

 define structure
   1 LINECALLTREATMENTENTRY,
     2 dwCallTreatmentID         type DWORD,
     2 dwCallTreatmentNameSize   type DWORD,
     2 dwCallTreatmentNameOffset type DWORD;
 define alias LPLINECALLTREATMENTENTRY handle LINECALLTREATMENTENTRY;

 define structure
   1 LINECARDENTRY,
     2 dwPermanentCardID         type DWORD,
     2 dwCardNameSize            type DWORD,
     2 dwCardNameOffset          type DWORD,
     2 dwCardNumberDigits        type DWORD,
     2 dwSameAreaRuleSize        type DWORD,
     2 dwSameAreaRuleOffset      type DWORD,
     2 dwLongDistanceRuleSize    type DWORD,
     2 dwLongDistanceRuleOffset  type DWORD,
     2 dwInternationalRuleSize   type DWORD,
     2 dwInternationalRuleOffset type DWORD,
     2 dwOptions                 type DWORD;
 define alias LPLINECARDENTRY handle LINECARDENTRY;

 define structure
   1 LINECOUNTRYENTRY,
     2 dwCountryID               type DWORD,
     2 dwCountryCode             type DWORD,
     2 dwNextCountryID           type DWORD,
     2 dwCountryNameSize         type DWORD,
     2 dwCountryNameOffset       type DWORD,
     2 dwSameAreaRuleSize        type DWORD,
     2 dwSameAreaRuleOffset      type DWORD,
     2 dwLongDistanceRuleSize    type DWORD,
     2 dwLongDistanceRuleOffset  type DWORD,
     2 dwInternationalRuleSize   type DWORD,
     2 dwInternationalRuleOffset type DWORD;
 define alias LPLINECOUNTRYENTRY handle LINECOUNTRYENTRY;

 define structure
   1 LINECOUNTRYLIST,
     2 dwTotalSize        type DWORD,
     2 dwNeededSize        type DWORD,
     2 dwUsedSize          type DWORD,
     2 dwNumCountries      type DWORD,
     2 dwCountryListSize   type DWORD,
     2 dwCountryListOffset type DWORD;
 define alias LPLINECOUNTRYLIST handle LINECOUNTRYLIST;

 define structure
   1 LINEDEVCAPS,
     2 dwTotalSize                  type DWORD,
     2 dwNeededSize                 type DWORD,
     2 dwUsedSize                   type DWORD,
     2 dwProviderInfoSize           type DWORD,
     2 dwProviderInfoOffset         type DWORD,
     2 dwSwitchInfoSize             type DWORD,
     2 dwSwitchInfoOffset           type DWORD,
     2 dwPermanentLineID            type DWORD,
     2 dwLineNameSize               type DWORD,
     2 dwLineNameOffset             type DWORD,
     2 dwStringFormat               type DWORD,
     2 dwAddressModes               type DWORD,
     2 dwNumAddresses               type DWORD,
     2 dwBearerModes                type DWORD,
     2 dwMaxRate                    type DWORD,
     2 dwMediaModes                 type DWORD,
     2 dwGenerateToneModes          type DWORD,
     2 dwGenerateToneMaxNumFreq     type DWORD,
     2 dwGenerateDigitModes         type DWORD,
     2 dwMonitorToneMaxNumFreq      type DWORD,
     2 dwMonitorToneMaxNumEntries   type DWORD,
     2 dwMonitorDigitModes          type DWORD,
     2 dwGatherDigitsMinTimeout     type DWORD,
     2 dwGatherDigitsMaxTimeout     type DWORD,
     2 dwMedCtlDigitMaxListSize     type DWORD,
     2 dwMedCtlMediaMaxListSize     type DWORD,
     2 dwMedCtlToneMaxListSize      type DWORD,
     2 dwMedCtlCallStateMaxListSize type DWORD,
     2 dwDevCapFlags                type DWORD,
     2 dwMaxNumActiveCalls          type DWORD,
     2 dwAnswerMode                 type DWORD,
     2 dwRingModes                  type DWORD,
     2 dwLineStates                 type DWORD,
     2 dwUUIAcceptSize              type DWORD,
     2 dwUUIAnswerSize              type DWORD,
     2 dwUUIMakeCallSize            type DWORD,
     2 dwUUIDropSize                type DWORD,
     2 dwUUISendUserUserInfoSize    type DWORD,
     2 dwUUICallInfoSize            type DWORD,
     2 MinDialParams                type LINEDIALPARAMS,
     2 MaxDialParams                type LINEDIALPARAMS,
     2 DefaultDialParams            type LINEDIALPARAMS,
     2 dwNumTerminals               type DWORD,
     2 dwTerminalCapsSize           type DWORD,
     2 dwTerminalCapsOffset         type DWORD,
     2 dwTerminalTextEntrySize      type DWORD,
     2 dwTerminalTextSize           type DWORD,
     2 dwTerminalTextOffset         type DWORD,
     2 dwDevSpecificSize            type DWORD,
     2 dwDevSpecificOffset          type DWORD,
     2 dwLineFeatures               type DWORD,
     2 dwSettableDevStatus          type DWORD,
     2 dwDeviceClassesSize          type DWORD,
     2 dwDeviceClassesOffset        type DWORD
 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
   , 2 PermanentLineGuid            type GUID
 %end;
 %if TAPI_CURRENT_VERSION >= '00030000' %then %do;
   , 2 dwAddressTypes               type DWORD
   , 2 ProtocolGuid                 type GUID
   , 2 dwAvailableTracking          type DWORD
 %end;
   ;
 define alias LPLINEDEVCAPS handle LINEDEVCAPS;

 define structure
   1 LINEDEVSTATUS,
     2 dwTotalSize           type DWORD,
     2 dwNeededSize          type DWORD,
     2 dwUsedSize            type DWORD,
     2 dwNumOpens            type DWORD,
     2 dwOpenMediaModes      type DWORD,
     2 dwNumActiveCalls      type DWORD,
     2 dwNumOnHoldCalls      type DWORD,
     2 dwNumOnHoldPendCalls  type DWORD,
     2 dwLineFeatures        type DWORD,
     2 dwNumCallCompletions  type DWORD,
     2 dwRingMode            type DWORD,
     2 dwSignalLevel         type DWORD,
     2 dwBatteryLevel        type DWORD,
     2 dwRoamMode            type DWORD,
     2 dwDevStatusFlags      type DWORD,
     2 dwTerminalModesSize   type DWORD,
     2 dwTerminalModesOffset type DWORD,
     2 dwDevSpecificSize     type DWORD,
     2 dwDevSpecificOffset   type DWORD,
     2 dwAvailableMediaModes type DWORD,
     2 dwAppInfoSize         type DWORD,
     2 dwAppInfoOffset       type DWORD;
 define alias LPLINEDEVSTATUS handle LINEDEVSTATUS;

 define structure
   1 LINEEXTENSIONID,
     2 dwExtensionID0 type DWORD,
     2 dwExtensionID1 type DWORD,
     2 dwExtensionID2 type DWORD,
     2 dwExtensionID3 type DWORD;
 define alias LPLINEEXTENSIONID handle LINEEXTENSIONID;

 define structure
   1 LINEFORWARD,
     2 dwForwardMode         type DWORD,
     2 dwCallerAddressSize   type DWORD,
     2 dwCallerAddressOffset type DWORD,
     2 dwDestCountryCode     type DWORD,
     2 dwDestAddressSize     type DWORD,
     2 dwDestAddressOffset   type DWORD;
 define alias LPLINEFORWARD handle LINEFORWARD;

 define structure
   1 LINEFORWARDLIST,
     2 dwTotalSize     type DWORD,
     2 dwNumEntries    type DWORD,
     2 ForwardList (1) type LINEFORWARD; /* refer */
 define alias LPLINEFORWARDLIST handle LINEFORWARDLIST;

 define structure
   1 LINEGENERATETONE,
     2 dwFrequency  type DWORD,
     2 dwCadenceOn  type DWORD,
     2 dwCadenceOff type DWORD,
     2 dwVolume     type DWORD;
 define alias LPLINEGENERATETONE handle LINEGENERATETONE;

 define structure
   1 LINEINITIALIZEEXPARAMS,
     2 dwTotalSize       type DWORD,
     2 dwNeededSize      type DWORD,
     2 dwUsedSize        type DWORD,
     2 dwOptions         type DWORD,
     2 Handles           union,
       3 hEvent          type HANDLE,
       3 hCompletionPort type HANDLE,
     2 dwCompletionKey   type DWORD;
 define alias LPLINEINITIALIZEEXPARAMS handle LINEINITIALIZEEXPARAMS;

 define structure
   1 LINELOCATIONENTRY,
     2 dwPermanentLocationID          type DWORD,
     2 dwLocationNameSize             type DWORD,
     2 dwLocationNameOffset           type DWORD,
     2 dwCountryCode                  type DWORD,
     2 dwCityCodeSize                 type DWORD,
     2 dwCityCodeOffset               type DWORD,
     2 dwPreferredCardID              type DWORD,
     2 dwLocalAccessCodeSize          type DWORD,
     2 dwLocalAccessCodeOffset        type DWORD,
     2 dwLongDistanceAccessCodeSize   type DWORD,
     2 dwLongDistanceAccessCodeOffset type DWORD,
     2 dwTollPrefixListSize           type DWORD,
     2 dwTollPrefixListOffset         type DWORD,
     2 dwCountryID                    type DWORD,
     2 dwOptions                      type DWORD,
     2 dwCancelCallWaitingSize        type DWORD,
     2 dwCancelCallWaitingOffset      type DWORD;
 define alias LPLINELOCATIONENTRY handle LINELOCATIONENTRY;

 define structure
   1 LINEMEDIACONTROLCALLSTATE,
     2 dwCallStates   type DWORD,
     2 dwMediaControl type DWORD;
 define alias LPLINEMEDIACONTROLCALLSTATE
                                  handle LINEMEDIACONTROLCALLSTATE;

 define structure
   1 LINEMEDIACONTROLDIGIT,
     2 dwDigit        type DWORD,
     2 dwDigitModes   type DWORD,
     2 dwMediaControl type DWORD;
 define alias LPLINEMEDIACONTROLDIGIT handle LINEMEDIACONTROLDIGIT;

 define structure
   1 LINEMEDIACONTROLMEDIA,
     2 dwMediaModes   type DWORD,
     2 dwDuration     type DWORD,
     2 dwMediaControl type DWORD;
 define alias LPLINEMEDIACONTROLMEDIA handle LINEMEDIACONTROLMEDIA;

 define structure
   1 LINEMEDIACONTROLTONE,
     2 dwAppSpecific  type DWORD,
     2 dwDuration     type DWORD,
     2 dwFrequency1   type DWORD,
     2 dwFrequency2   type DWORD,
     2 dwFrequency3   type DWORD,
     2 dwMediaControl type DWORD;
 define alias LPLINEMEDIACONTROLTONE handle LINEMEDIACONTROLTONE;

 define structure
   1 LINEMESSAGE,
     2 hDevice            type DWORD,
     2 dwMessageID        type DWORD,
     2 dwCallbackInstance type DWORD_PTR,
     2 dwParam1           type DWORD_PTR,
     2 dwParam2           type DWORD_PTR,
     2 dwParam3           type DWORD_PTR;
 define alias LPLINEMESSAGE handle LINEMESSAGE;

 define structure
   1 LINEMONITORTONE,
     2 dwAppSpecific type DWORD,
     2 dwDuration    type DWORD,
     2 dwFrequency1  type DWORD,
     2 dwFrequency2  type DWORD,
     2 dwFrequency3  type DWORD;
 define alias LPLINEMONITORTONE handle LINEMONITORTONE;

 define structure
   1 LINEPROVIDERENTRY,
     2 dwPermanentProviderID    type DWORD,
     2 dwProviderFilenameSize   type DWORD,
     2 dwProviderFilenameOffset type DWORD;
 define alias LPLINEPROVIDERENTRY handle LINEPROVIDERENTRY;

 define structure
   1 LINEPROVIDERLIST,
     2 dwTotalSize          type DWORD,
     2 dwNeededSize         type DWORD,
     2 dwUsedSize           type DWORD,
     2 dwNumProviders       type DWORD,
     2 dwProviderListSize   type DWORD,
     2 dwProviderListOffset type DWORD;
 define alias LPLINEPROVIDERLIST handle LINEPROVIDERLIST;

  define structure
   1 LINEPROXYREQUEST,
     2 dwSize                      type DWORD,
     2 dwClientMachineNameSize     type DWORD,
     2 dwClientMachineNameOffset   type DWORD,
     2 dwClientUserNameSize        type DWORD,
     2 dwClientUserNameOffset      type DWORD,
     2 dwClientAppAPIVersion       type DWORD,
     2 dwRequestType               type DWORD,
     2 * union,                    /* ProxyRequestType */
       3 SetAgentGroup,
         4 dwAddressID             type DWORD,
         4 GroupList               type LINEAGENTGROUPLIST,
       3 SetAgentState,
         4 dwAddressID             type DWORD,
         4 dwAgentState            type DWORD,
         4 dwNextAgentState        type DWORD,
       3 SetAgentActivity,
         4 dwAddressID             type DWORD,
         4 dwActivityID            type DWORD,
       3 GetAgentCaps,
         4 dwAddressID             type DWORD,
         4 AgentCaps               type LINEAGENTCAPS,
       3 GetAgentStatus,
         4 dwAddressID             type DWORD,
         4 AgentStatus             type LINEAGENTSTATUS,
       3 AgentSpecific,
         4 dwAddressID             type DWORD,
         4 dwAgentExtensionIDIndex type DWORD,
         4 dwSize                  type DWORD,
         4 Params (1)              type BYTE,
       3 GetAgentActivityList,
         4 dwAddressID             type DWORD,
         4 ActivityList            type LINEAGENTACTIVITYLIST,
       3 GetAgentGroupList,
         4 dwAddressID             type DWORD,
         4 GroupList               type LINEAGENTGROUPLIST
 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
     , 3 CreateAgent,
         4 hAgent                  type HAGENT,
         4 dwAgentIDSize           type DWORD,
         4 dwAgentIDOffset         type DWORD,
         4 dwAgentPINSize          type DWORD,
         4 dwAgentPINOffset        type DWORD,
       3 SetAgentStateEx,
         4 hAgent                  type HAGENT,
         4 dwAgentState            type DWORD,
         4 dwNextAgentState        type DWORD,
       3 SetAgentMeasurementPeriod,
         4 hAgent                  type HAGENT,
         4 dwMeasurementPeriod     type DWORD,
       3 GetAgentInfo,
         4 hAgent                  type HAGENT,
         4 AgentInfo               type LINEAGENTINFO,
       3 CreateAgentSession,
         4 hAgentSession           type HAGENTSESSION,
         4 dwAgentPINSize          type DWORD,
         4 dwAgentPINOffset        type DWORD,
         4 hAgent                  type HAGENT,
         4 GroupID                 type GUID,
         4 dwWorkingAddressID      type DWORD,
       3 GetAgentSessionList,
         4 hAgent                  type HAGENT,
         4 SessionList             type LINEAGENTSESSIONLIST,
       3 GetAgentSessionInfo,
         4 hAgentSession           type HAGENTSESSION,
         4 SessionInfo             type LINEAGENTSESSIONINFO,
       3 SetAgentSessionState,
         4 hAgentSession           type HAGENTSESSION,
         4 dwAgentSessionState     type DWORD,
         4 dwNextAgentSessionState type DWORD,
       3 GetQueueList,
         4 GroupID                 type GUID,
         4 QueueList               type LINEQUEUELIST,
       3 SetQueueMeasurementPeriod,
         4 dwQueueID               type DWORD,
         4 dwMeasurementPeriod     type DWORD,
       3 GetQueueInfo,
         4 dwQueueID               type DWORD,
         4 QueueInfo               type LINEQUEUEINFO,
       3 GetGroupList,
         4 GroupList               type LINEAGENTGROUPLIST
 %end;
   ;
 define alias LPLINEPROXYREQUEST handle LINEPROXYREQUEST;

 define structure
   1 LINEREQMAKECALLA,
     2 szDestAddress char (TAPIMAXDESTADDRESSSIZE-1) varz,
     2 szAppName     char (TAPIMAXAPPNAMESIZE-1) varz,
     2 szCalledParty char (TAPIMAXCALLEDPARTYSIZE-1) varz,
     2 szComment     char (TAPIMAXCOMMENTSIZE-1) varz;
 define alias LPLINEREQMAKECALLA handle LINEREQMAKECALLA;

 define structure
   1 LINEREQMAKECALLW,
     2 szDestAddress WCHAR (TAPIMAXDESTADDRESSSIZE-1) varz,
     2 szAppName     WCHAR (TAPIMAXAPPNAMESIZE-1) varz,
     2 szCalledParty WCHAR (TAPIMAXCALLEDPARTYSIZE-1) varz,
     2 szComment     WCHAR (TAPIMAXCOMMENTSIZE-1) varz;
 define alias LPLINEREQMAKECALLW handle LINEREQMAKECALLW;


 %if UNICODE ^= '' %then %do;
 define alias   LINEREQMAKECALL type   LINEREQMAKECALLW;
 define alias LPLINEREQMAKECALL type LPLINEREQMAKECALLW;
 %end; %else %do;
 define alias   LINEREQMAKECALL type   LINEREQMAKECALLA;
 define alias LPLINEREQMAKECALL type LPLINEREQMAKECALLA;
 %end;

 define structure
   1 LINEREQMEDIACALLA,
     2 hWnd          type HWND,
     2 wRequestID    type WPARAM,
     2 szDeviceClass char (TAPIMAXDEVICECLASSSIZE-1) varz,
     2 ucDeviceID    (TAPIMAXDEVICEIDSIZE) fixed bin (8) unsigned,
     2 dwSize        type DWORD,
     2 dwSecure      type DWORD,
     2 szDestAddress char (TAPIMAXDESTADDRESSSIZE-1) varz,
     2 szAppName     char (TAPIMAXAPPNAMESIZE-1) varz,
     2 szCalledParty char (TAPIMAXCALLEDPARTYSIZE-1) varz,
     2 szComment     char (TAPIMAXCOMMENTSIZE-1) varz;
 define alias LPLINEREQMEDIACALLA handle LINEREQMEDIACALLW;

 define structure
   1 LINEREQMEDIACALLW,
     2 hWnd          type HWND,
     2 wRequestID    type WPARAM,
     2 szDeviceClass WCHAR (TAPIMAXDEVICECLASSSIZE-1) varz,
     2 ucDeviceID    (TAPIMAXDEVICEIDSIZE) fixed bin (8) unsigned,
     2 dwSize        type DWORD,
     2 dwSecure      type DWORD,
     2 szDestAddress WCHAR (TAPIMAXDESTADDRESSSIZE-1) varz,
     2 szAppName     WCHAR (TAPIMAXAPPNAMESIZE-1) varz,
     2 szCalledParty WCHAR (TAPIMAXCALLEDPARTYSIZE-1) varz,
     2 szComment     WCHAR (TAPIMAXCOMMENTSIZE-1) varz;
 define alias LPLINEREQMEDIACALLW handle LINEREQMEDIACALLW;


 %if UNICODE ^= '' %then %do;
 define alias   LINEREQMEDIACALL type   LINEREQMEDIACALLW;
 define alias LPLINEREQMEDIACALL type LPLINEREQMEDIACALLW;
 %end; %else %do;
 define alias   LINEREQMEDIACALL type   LINEREQMEDIACALLA;
 define alias LPLINEREQMEDIACALL type LPLINEREQMEDIACALLA;
 %end;

 define structure
   1 LINETERMCAPS,
     2 dwTermDev     type DWORD,
     2 dwTermModes   type DWORD,
     2 dwTermSharing type DWORD;
 define alias LPLINETERMCAPS handle LINETERMCAPS;

 define structure
   1 LINETRANSLATECAPS,
     2 dwTotalSize              type DWORD,
     2 dwNeededSize             type DWORD,
     2 dwUsedSize               type DWORD,
     2 dwNumLocations           type DWORD,
     2 dwLocationListSize       type DWORD,
     2 dwLocationListOffset     type DWORD,
     2 dwCurrentLocationID      type DWORD,
     2 dwNumCards               type DWORD,
     2 dwCardListSize           type DWORD,
     2 dwCardListOffset         type DWORD,
     2 dwCurrentPreferredCardID type DWORD;
 define alias LPLINETRANSLATECAPS handle LINETRANSLATECAPS;

 define structure
   1 LINETRANSLATEOUTPUT,
     2 dwTotalSize               type DWORD,
     2 dwNeededSize              type DWORD,
     2 dwUsedSize                type DWORD,
     2 dwDialableStringSize      type DWORD,
     2 dwDialableStringOffset    type DWORD,
     2 dwDisplayableStringSize   type DWORD,
     2 dwDisplayableStringOffset type DWORD,
     2 dwCurrentCountry          type DWORD,
     2 dwDestCountry             type DWORD,
     2 dwTranslateResults        type DWORD;
 define alias LPLINETRANSLATEOUTPUT handle LINETRANSLATEOUTPUT;

 define structure
   1 PHONEBUTTONINFO,
     2 dwTotalSize         type DWORD,
     2 dwNeededSize        type DWORD,
     2 dwUsedSize          type DWORD,
     2 dwButtonMode        type DWORD,
     2 dwButtonFunction    type DWORD,
     2 dwButtonTextSize    type DWORD,
     2 dwButtonTextOffset  type DWORD,
     2 dwDevSpecificSize   type DWORD,
     2 dwDevSpecificOffset type DWORD,
     2 dwButtonState       type DWORD;
 define alias LPPHONEBUTTONINFO handle PHONEBUTTONINFO;

 define structure
   1 PHONECAPS,
     2 dwTotalSize                       type DWORD,
     2 dwNeededSize                      type DWORD,
     2 dwUsedSize                        type DWORD,
     2 dwProviderInfoSize                type DWORD,
     2 dwProviderInfoOffset              type DWORD,
     2 dwPhoneInfoSize                   type DWORD,
     2 dwPhoneInfoOffset                 type DWORD,
     2 dwPermanentPhoneID                type DWORD,
     2 dwPhoneNameSize                   type DWORD,
     2 dwPhoneNameOffset                 type DWORD,
     2 dwStringFormat                    type DWORD,
     2 dwPhoneStates                     type DWORD,
     2 dwHookSwitchDevs                  type DWORD,
     2 dwHandsetHookSwitchModes          type DWORD,
     2 dwSpeakerHookSwitchModes          type DWORD,
     2 dwHeadsetHookSwitchModes          type DWORD,
     2 dwVolumeFlags                     type DWORD,
     2 dwGainFlags                       type DWORD,
     2 dwDisplayNumRows                  type DWORD,
     2 dwDisplayNumColumns               type DWORD,
     2 dwNumRingModes                    type DWORD,
     2 dwNumButtonLamps                  type DWORD,
     2 dwButtonModesSize                 type DWORD,
     2 dwButtonModesOffset               type DWORD,
     2 dwButtonFunctionsSize             type DWORD,
     2 dwButtonFunctionsOffset           type DWORD,
     2 dwLampModesSize                   type DWORD,
     2 dwLampModesOffset                 type DWORD,
     2 dwNumSetData                      type DWORD,
     2 dwSetDataSize                     type DWORD,
     2 dwSetDataOffset                   type DWORD,
     2 dwNumGetData                      type DWORD,
     2 dwGetDataSize                     type DWORD,
     2 dwGetDataOffset                   type DWORD,
     2 dwDevSpecificSize                 type DWORD,
     2 dwDevSpecificOffset               type DWORD,
     2 dwDeviceClassesSize               type DWORD,
     2 dwDeviceClassesOffset             type DWORD,
     2 dwPhoneFeatures                   type DWORD,
     2 dwSettableHandsetHookSwitchModes  type DWORD,
     2 dwSettableSpeakerHookSwitchModes  type DWORD,
     2 dwSettableHeadsetHookSwitchModes  type DWORD,
     2 dwMonitoredHandsetHookSwitchModes type DWORD,
     2 dwMonitoredSpeakerHookSwitchModes type DWORD,
     2 dwMonitoredHeadsetHookSwitchModes type DWORD
 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
   , 2 PermanentPhoneGuid                type GUID
 %end;
   ;
 define alias LPPHONECAPS handle PHONECAPS;

 define structure
   1 PHONEEXTENSIONID,
     2 dwExtensionID0 type DWORD,
     2 dwExtensionID1 type DWORD,
     2 dwExtensionID2 type DWORD,
     2 dwExtensionID3 type DWORD;
 define alias LPPHONEEXTENSIONID handle PHONEEXTENSIONID;

 define structure
   1 PHONEINITIALIZEEXPARAMS,
     2 dwTotalSize       type DWORD,
     2 dwNeededSize      type DWORD,
     2 dwUsedSize        type DWORD,
     2 dwOptions         type DWORD,
     2 Handles           union,
       3 hEvent          type HANDLE,
       3 hCompletionPort type HANDLE,
     2 dwCompletionKey   type DWORD;
 define alias LPPHONEINITIALIZEEXPARAMS handle PHONEINITIALIZEEXPARAMS;

 define structure
   1 PHONEMESSAGE,
     2 hDevice            type DWORD,
     2 dwMessageID        type DWORD,
     2 dwCallbackInstance type DWORD_PTR,
     2 dwParam1           type DWORD_PTR,
     2 dwParam2           type DWORD_PTR,
     2 dwParam3           type DWORD_PTR;
 define alias LPPHONEMESSAGE handle PHONEMESSAGE;

 define structure
   1 PHONESTATUS,
     2 dwTotalSize             type DWORD,
     2 dwNeededSize            type DWORD,
     2 dwUsedSize              type DWORD,
     2 dwStatusFlags           type DWORD,
     2 dwNumOwners             type DWORD,
     2 dwNumMonitors           type DWORD,
     2 dwRingMode              type DWORD,
     2 dwRingVolume            type DWORD,
     2 dwHandsetHookSwitchMode type DWORD,
     2 dwHandsetVolume         type DWORD,
     2 dwHandsetGain           type DWORD,
     2 dwSpeakerHookSwitchMode type DWORD,
     2 dwSpeakerVolume         type DWORD,
     2 dwSpeakerGain           type DWORD,
     2 dwHeadsetHookSwitchMode type DWORD,
     2 dwHeadsetVolume         type DWORD,
     2 dwHeadsetGain           type DWORD,
     2 dwDisplaySize           type DWORD,
     2 dwDisplayOffset         type DWORD,
     2 dwLampModesSize         type DWORD,
     2 dwLampModesOffset       type DWORD,
     2 dwOwnerNameSize         type DWORD,
     2 dwOwnerNameOffset       type DWORD,
     2 dwDevSpecificSize       type DWORD,
     2 dwDevSpecificOffset     type DWORD,
     2 dwPhoneFeatures         type DWORD;
 define alias LPPHONESTATUS handle PHONESTATUS;

 define structure
   1 VARSTRING,
     2 dwTotalSize    type DWORD,
     2 dwNeededSize   type DWORD,
     2 dwUsedSize     type DWORD,
     2 dwStringFormat type DWORD,
     2 dwStringSize   type DWORD,
     2 dwStringOffset type DWORD;
 define alias LPVARSTRING handle VARSTRING;



 dcl lineAccept
     entry (type HCALL,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineAccept');

 dcl lineAddProviderA
     entry (char(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineAddProviderA');

 dcl lineAddProviderW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type HWND,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineAddProviderW');

 %dcl lineAddProvider char ext;
 %if UNICODE ^= '' %then %do;
   %lineAddProvider='lineAddProviderW';
 %end; %else %do;
   %lineAddProvider='lineAddProviderA';
 %end;


 dcl lineAddToConference
     entry (type HCALL,
            type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineAddToConference');

 dcl lineAgentSpecific
     entry (type HLINE,
            type DWORD,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineAgentSpecific');

 dcl lineAnswer
     entry (type HCALL,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineAnswer');


 dcl lineBlindTransferA
     entry (type HCALL,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineBlindTransferA');

 dcl lineBlindTransferW
     entry (type HCALL,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineBlindTransferW');

 %dcl lineBlindTransfer char ext;
 %if UNICODE ^= '' %then %do;
   %lineBlindTransfer='lineBlindTransferW';
 %end; %else %do;
   %lineBlindTransfer='lineBlindTransferA';
 %end;

 dcl lineClose
     entry (type HLINE)
     returns (type LONG byvalue optional)
     WINAPI external('lineClose');

 dcl lineCompleteCall
     entry (type HCALL,
            type DWORD byaddr,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineCompleteCall');

 dcl lineCompleteTransfer
     entry (type HCALL,
            type HCALL,
            type HCALL byaddr,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineCompleteTransfer');

 dcl lineConfigDialogA
     entry (type DWORD,
            type HWND,
            char(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineConfigDialogA');

 dcl lineConfigDialogW
     entry (type DWORD,
            type HWND,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineConfigDialogW');

 %dcl lineConfigDialog char ext;
 %if UNICODE ^= '' %then %do;
   %lineConfigDialog='lineConfigDialogW';
 %end; %else %do;
   %lineConfigDialog='lineConfigDialogA';
 %end;

 dcl lineConfigDialogEditA
     entry (type DWORD,
            type HWND,
            char(*) varz byaddr nonasgn optional,
            type LPVOID,
            type DWORD,
            type VARSTRING byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineConfigDialogEditA');

 dcl lineConfigDialogEditW
     entry (type DWORD,
            type HWND,
            WCHAR(*) varz byaddr nonasgn optional,
            type LPVOID,
            type DWORD,
            type VARSTRING byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineConfigDialogEditW');

 %dcl lineConfigDialogEdit char ext;
 %if UNICODE ^= '' %then %do;
   %lineConfigDialogEdit='lineConfigDialogEditW';
 %end; %else %do;
   %lineConfigDialogEdit='lineConfigDialogEditA';
 %end;

 dcl lineConfigProvider
     entry (type HWND,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineConfigProvider');


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl lineCreateAgentW
     entry (type HLINE,
            WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            type HAGENT byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineCreateAgentW');

 dcl lineCreateAgentA
     entry (type HLINE,
            char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            type HAGENT byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineCreateAgentA');

 %dcl lineCreateAgent char ext;
 %if UNICODE ^= '' %then %do;
   %lineCreateAgent='lineCreateAgentW';
 %end; %else %do;
   %lineCreateAgent='lineCreateAgentA';
 %end;

 dcl lineCreateAgentSessionW
     entry (type HLINE,
            type HAGENT,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            type GUID byaddr,
            type HAGENTSESSION byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineCreateAgentSessionW');

 dcl lineCreateAgentSessionA
     entry (type HLINE,
            type HAGENT,
            char(*) varz byaddr optional,
            type DWORD,
            type GUID byaddr,
            type HAGENTSESSION byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineCreateAgentSessionA');

 %dcl lineCreateAgent char ext;
 %if UNICODE ^= '' %then %do;
   %lineCreateAgent='lineCreateAgentW';
 %end; %else %do;
   %lineCreateAgent='lineCreateAgentA';
 %end;
 %end;

 dcl lineDeallocateCall
     entry (type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineDeallocateCall');

 dcl lineDevSpecific
     entry (type HLINE,
            type DWORD,
            type HCALL,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineDevSpecific');

 dcl lineDevSpecificFeature
     entry (type HLINE,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineDevSpecificFeature');

 dcl lineDialA
     entry (type HCALL,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineDialA');

 dcl lineDialW
     entry (type HCALL,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineDialW');

 %dcl lineDial char ext;
 %if UNICODE ^= '' %then %do;
   %lineDial='lineDialW';
 %end; %else %do;
   %lineDial='lineDialA';
 %end;

 dcl lineDrop
     entry (type HCALL,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineDrop');

 dcl lineForwardA
     entry (type HLINE,
            type DWORD,
            type DWORD,
            type LINEFORWARDLIST byaddr nonasgn,
            type DWORD,
            type HCALL byaddr,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineForwardA');

 dcl lineForwardW
     entry (type HLINE,
            type DWORD,
            type DWORD,
            type LINEFORWARDLIST byaddr nonasgn,
            type DWORD,
            type HCALL byaddr,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineForwardW');

 %dcl lineForward char ext;
 %if UNICODE ^= '' %then %do;
   %lineForward='lineForwardW';
 %end; %else %do;
   %lineForward='lineForwardA';
 %end;

 dcl lineGatherDigitsA
     entry (type HCALL,
            type DWORD,
            char(*) varz byaddr optional,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGatherDigitsA');

 dcl lineGatherDigitsW
     entry (type HCALL,
            type DWORD,
            WCHAR(*) varz byaddr optional,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGatherDigitsW');

 %dcl lineGatherDigits char ext;
 %if UNICODE ^= '' %then %do;
   %lineGatherDigits='lineGatherDigitsW';
 %end; %else %do;
   %lineGatherDigits='lineGatherDigitsA';
 %end;

 dcl lineGenerateDigitsA
     entry (type HCALL,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGenerateDigitsA');

 dcl lineGenerateDigitsW
     entry (type HCALL,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGenerateDigitsW');

 %dcl lineGenerateDigits char ext;
 %if UNICODE ^= '' %then %do;
   %lineGenerateDigits='lineGenerateDigitsW';
 %end; %else %do;
   %lineGenerateDigits='lineGenerateDigitsA';
 %end;

 dcl lineGenerateTone
     entry (type HCALL,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEGENERATETONE byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineGenerateTone');

 dcl lineGetAddressCapsA
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEADDRESSCAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAddressCapsA');

 dcl lineGetAddressCapsW
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEADDRESSCAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAddressCapsW');

 %dcl lineGetAddressCaps char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAddressCaps='lineGetAddressCapsW';
 %end; %else %do;
   %lineGetAddressCaps='lineGetAddressCapsA';
 %end;

 dcl lineGetAddressIDA
     entry (type HLINE,
            type DWORD byaddr,
            type DWORD,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAddressIDA');

 dcl lineGetAddressIDW
     entry (type HLINE,
            type DWORD byaddr,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAddressIDW');

 %dcl lineGetAddressID char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAddressID='lineGetAddressIDW';
 %end; %else %do;
   %lineGetAddressID='lineGetAddressIDA';
 %end;

 dcl lineGetAddressStatusA
     entry (type HLINE,
            type DWORD,
            type LINEADDRESSSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAddressStatusA');

 dcl lineGetAddressStatusW
     entry (type HLINE,
            type DWORD,
            type LINEADDRESSSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAddressStatusW');

 %dcl lineGetAddressStatus char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAddressStatus='lineGetAddressStatusW';
 %end; %else %do;
   %lineGetAddressStatus='lineGetAddressStatusA';
 %end;

 dcl lineGetAgentActivityListA
     entry (type HLINE,
            type DWORD,
            type LINEAGENTACTIVITYLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentActivityListA');

 dcl lineGetAgentActivityListW
     entry (type HLINE,
            type DWORD,
            type LINEAGENTACTIVITYLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentActivityListW');

 %dcl lineGetAgentActivityList char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAgentActivityList='lineGetAgentActivityListW';
 %end; %else %do;
   %lineGetAgentActivityList='lineGetAgentActivityListA';
 %end;


 dcl lineGetAgentCapsA
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEAGENTCAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentCapsA');

 dcl lineGetAgentCapsW
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEAGENTCAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentCapsW');

 %dcl lineGetAgentCaps char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAgentCaps='lineGetAgentCapsW';
 %end; %else %do;
   %lineGetAgentCaps='lineGetAgentCapsA';
 %end;


 dcl lineGetAgentGroupListA
     entry (type HLINE,
            type DWORD,
            type LINEAGENTGROUPLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentGroupListA');

 dcl lineGetAgentGroupListW
     entry (type HLINE,
            type DWORD,
            type LINEAGENTGROUPLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentGroupListW');

 %dcl lineGetAgentGroupList char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAgentGroupList='lineGetAgentGroupListW';
 %end; %else %do;
   %lineGetAgentGroupList='lineGetAgentGroupListA';
 %end;


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl lineGetAgentInfo
     entry (type HLINE,
            type HAGENT,
            type LINEAGENTINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentInfo');

 dcl lineGetAgentSessionInfo
     entry (type HLINE,
            type HAGENTSESSION,
            type LINEAGENTSESSIONINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentSessionInfo');

 dcl lineGetAgentSessionList
     entry (type HLINE,
            type HAGENT,
            type LINEAGENTSESSIONLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentSessionList');
 %end;

 dcl lineGetAgentStatusA
     entry (type HLINE,
            type DWORD,
            type LINEAGENTSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentStatusA');

 dcl lineGetAgentStatusW
     entry (type HLINE,
            type DWORD,
            type LINEAGENTSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAgentStatusW');

 %dcl lineGetAgentStatus char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAgentStatus='lineGetAgentStatusW';
 %end; %else %do;
   %lineGetAgentStatus='lineGetAgentStatusA';
 %end;

 dcl lineGetAppPriorityA
     entry (char(*) varz byaddr nonasgn,
            type DWORD,
            type LPLINEEXTENSIONID byaddr optional,
            type DWORD,
            type VARSTRING byaddr optional,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAppPriorityA');

 dcl lineGetAppPriorityW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LPLINEEXTENSIONID byaddr optional,
            type DWORD,
            type LPVARSTRING byaddr optional,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetAppPriorityW');

 %dcl lineGetAppPriority char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetAppPriority='lineGetAppPriorityW';
 %end; %else %do;
   %lineGetAppPriority='lineGetAppPriorityA';
 %end;

 dcl lineGetCallInfoA
     entry (type HCALL,
            type LINECALLINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetCallInfoA');

 dcl lineGetCallInfoW
     entry (type HCALL,
            type LINECALLINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetCallInfoW');

 %dcl lineGetCallInfo char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetCallInfo='lineGetCallInfoW';
 %end; %else %do;
   %lineGetCallInfo='lineGetCallInfoA';
 %end;

 dcl lineGetCallStatus
     entry (type HCALL,
            type LINECALLSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetCallStatus');

 dcl lineGetConfRelatedCalls
     entry (type HCALL,
            type LINECALLLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetConfRelatedCalls');

 dcl lineGetCountryA
     entry (type DWORD,
            type DWORD,
            type LINECOUNTRYLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetCountryA');

 dcl lineGetCountryW
     entry (type DWORD,
            type DWORD,
            type LINECOUNTRYLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetCountryW');

 %dcl lineGetCountry char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetCountry='lineGetCountryW';
 %end; %else %do;
   %lineGetCountry='lineGetCountryA';
 %end;

 dcl lineGetDevCapsA
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEDEVCAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetDevCapsA');

 dcl lineGetDevCapsW
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEDEVCAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetDevCapsW');

 %dcl lineGetDevCaps char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetDevCaps='lineGetDevCapsW';
 %end; %else %do;
   %lineGetDevCaps='lineGetDevCapsA';
 %end;

 dcl lineGetDevConfigA
     entry (type DWORD,
            type VARSTRING byaddr,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetDevConfigA');

 dcl lineGetDevConfigW
     entry (type DWORD,
            type VARSTRING byaddr,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetDevConfigW');

 %dcl lineGetDevConfig char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetDevConfig='lineGetDevConfigW';
 %end; %else %do;
   %lineGetDevConfig='lineGetDevConfigA';
 %end;


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl lineGetGroupListA
     entry (type HLINE,
            type LINEAGENTGROUPLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetGroupListA');

 dcl lineGetGroupListW
     entry (type HLINE,
            type LPLINEAGENTGROUPLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetGroupListW');

 %dcl lineGetGroupList char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetGroupList='lineGetGroupListW';
 %end; %else %do;
   %lineGetGroupList='lineGetGroupListA';
 %end;
 %end;

 dcl lineGetIconA
     entry (type DWORD,
            char(*) varz byaddr nonasgn optional,
            type HICON byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetIconA');

 dcl lineGetIconW
     entry (type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type HICON byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetIconW');

 %dcl lineGetIcon char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetIcon='lineGetIconW';
 %end; %else %do;
   %lineGetIcon='lineGetIconA';
 %end;

 dcl lineGetIDA
     entry (type HLINE,
            type DWORD,
            type HCALL,
            type DWORD,
            type VARSTRING byaddr,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetIDA');

 dcl lineGetIDW
     entry (type HLINE,
            type DWORD,
            type HCALL,
            type DWORD,
            type VARSTRING byaddr,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetIDW');

 %dcl lineGetID char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetID='lineGetIDW';
 %end; %else %do;
   %lineGetID='lineGetIDA';
 %end;

 dcl lineGetLineDevStatusA
     entry (type HLINE,
            type LINEDEVSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetLineDevStatusA');

 dcl lineGetLineDevStatusW
     entry (type HLINE,
            type LINEDEVSTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetLineDevStatusW');

 %dcl lineGetDevStatus char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetDevStatus='lineGetDevStatusW';
 %end; %else %do;
   %lineGetDevStatus='lineGetDevStatusA';
 %end;

 dcl lineGetMessage
     entry (type HLINEAPP,
            type LINEMESSAGE byaddr,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetMessage');

 dcl lineGetNewCalls
     entry (type HLINE,
            type DWORD,
            type DWORD,
            type LINECALLLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetNewCalls');

 dcl lineGetNumRings
     entry (type HLINE,
            type DWORD,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetNumRings');

 dcl lineGetProviderListA
     entry (type DWORD,
            type LINEPROVIDERLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetProviderListA');

 dcl lineGetProviderListW
     entry (type DWORD,
            type LINEPROVIDERLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetProviderListW');

 %dcl lineGetProviderList char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetProviderList='lineGetProviderListW';
 %end; %else %do;
   %lineGetProviderList='lineGetProviderListA';
 %end;


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl lineGetProxyStatus
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type LINEPROXYREQUESTLIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetProxyStatus');

 dcl lineGetQueueInfo
     entry (type HLINE,
            type DWORD,
            type LINEQUEUEINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetQueueInfo');

 dcl lineGetQueueListA
     entry (type HLINE,
            type GUID byaddr,
            type LINEQUEUELIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetQueueListA');

 dcl lineGetQueueListW
     entry (type HLINE,
            type GUID byaddr,
            type LINEQUEUELIST byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetQueueListW');

 %dcl lineGetQueueList char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetQueueList='lineGetQueueListW';
 %end; %else %do;
   %lineGetQueueList='lineGetQueueListA';
 %end;
 %end;

 dcl lineGetRequestA
     entry (type HLINEAPP,
            type DWORD,
            type LPVOID)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetRequestA');

 dcl lineGetRequestW
     entry (type HLINEAPP,
            type DWORD,
            type LPVOID)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetRequestW');

 %dcl lineGetRequest char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetRequest='lineGetRequestW';
 %end; %else %do;
   %lineGetRequest='lineGetRequestA';
 %end;

 dcl lineGetStatusMessages
     entry (type HLINE,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetStatusMessages');

 dcl lineGetTranslateCapsA
     entry (type HLINEAPP,
            type DWORD,
            type LINETRANSLATECAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetTranslateCapsA');

 dcl lineGetTranslateCapsW
     entry (type HLINEAPP,
            type DWORD,
            type LINETRANSLATECAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineGetTranslateCapsW');

 %dcl lineGetTranslateCaps char ext;
 %if UNICODE ^= '' %then %do;
   %lineGetTranslateCaps='lineGetTranslateCapsW';
 %end; %else %do;
   %lineGetTranslateCaps='lineGetTranslateCapsA';
 %end;

 dcl lineHandoffA
     entry (type HCALL,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineHandoffA');

 dcl lineHandoffW
     entry (type HCALL,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineHandoffW');

 %dcl lineHandoff char ext;
 %if UNICODE ^= '' %then %do;
   %lineHandoff='lineHandoffW';
 %end; %else %do;
   %lineHandoff='lineHandoffA';
 %end;

 dcl lineHold
     entry (type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineHold');

 dcl lineInitializeExA
     entry (type HLINEAPP byaddr,
            type HINSTANCE,
            type LINECALLBACK,
            char(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type DWORD byaddr,
            type LINEINITIALIZEEXPARAMS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineInitializeExA');

 dcl lineInitializeExW
     entry (type HLINEAPP byaddr,
            type HINSTANCE,
            type LINECALLBACK,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type DWORD byaddr,
            type LINEINITIALIZEEXPARAMS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineInitializeExW');

 %dcl lineInitializeEx char ext;
 %if UNICODE ^= '' %then %do;
   %lineInitializeEx='lineInitializeExW';
 %end; %else %do;
   %lineInitializeEx='lineInitializeExA';
 %end;

 dcl lineMakeCallA
     entry (type HLINE,
            type LPHCALL,
            char(*) varz byaddr nonasgn optional,
            type DWORD,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineMakeCallA');

 dcl lineMakeCallW
     entry (type HLINE,
            type LPHCALL,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineMakeCallW');

 %dcl lineMakeCall char ext;
 %if UNICODE ^= '' %then %do;
   %lineMakeCall='lineMakeCallW';
 %end; %else %do;
   %lineMakeCall='lineMakeCallA';
 %end;

 dcl lineMonitorDigits
     entry (type HCALL,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineMonitorDigits');

 dcl lineMonitorMedia
     entry (type HCALL,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineMonitorMedia');

 dcl lineMonitorTones
     entry (type HCALL,
            type LINEMONITORTONE byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineMonitorTones');

 dcl lineNegotiateAPIVersion
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD byaddr,
            type LINEEXTENSIONID byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineNegotiateAPIVersion');

 dcl lineNegotiateExtVersion
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineNegotiateExtVersion');

 dcl lineOpenA
     entry (type HLINEAPP,
            type DWORD,
            type HLINE byaddr,
            type DWORD,
            type DWORD,
            type DWORD_PTR,
            type DWORD,
            type DWORD,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineOpenA');

 dcl lineOpenW
     entry (type HLINEAPP,
            type DWORD,
            type HLINE byaddr,
            type DWORD,
            type DWORD,
            type DWORD_PTR,
            type DWORD,
            type DWORD,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineOpenW');

 %dcl lineOpen char ext;
 %if UNICODE ^= '' %then %do;
   %lineOpen='lineOpenW';
 %end; %else %do;
   %lineOpen='lineOpenA';
 %end;

 dcl lineParkA
     entry (type HCALL,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type VARSTRING byaddr optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineParkA');

 dcl lineParkW
     entry (type HCALL,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type VARSTRING byaddr optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineParkW');

 %dcl linePark char ext;
 %if UNICODE ^= '' %then %do;
   %linePark='lineParkW';
 %end; %else %do;
   %linePark='lineParkA';
 %end;

 dcl linePickupA
     entry (type HLINE,
            type DWORD,
            type HCALL byaddr,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('linePickupA');

 dcl linePickupW
     entry (type HLINE,
            type DWORD,
            type HCALL byaddr,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('linePickupW');

 %dcl linePickup char ext;
 %if UNICODE ^= '' %then %do;
    %linePickup='linePickupW';
 %end; %else %do;
   %linePickup='linePickupA';
 %end;

 dcl linePrepareAddToConferenceA
     entry (type HCALL,
            type HCALL byaddr,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('linePrepareAddToConferenceA');

 dcl linePrepareAddToConferenceW
     entry (type HCALL,
            type HCALL byaddr,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('linePrepareAddToConferenceW');

 %dcl linePrepareAddToConference char ext;
 %if UNICODE ^= '' %then %do;
   %linePrepareAddToConference='linePrepareAddToConferenceW';
 %end; %else %do;
   %linePrepareAddToConference='linePrepareAddToConferenceA';
 %end;

 dcl lineProxyMessage
     entry (type HLINE,
            type HCALL,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineProxyMessage');

 dcl lineProxyResponse
     entry (type HLINE,
            type LINEPROXYREQUEST byaddr,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineProxyResponse');

 dcl lineRedirectA
     entry (type HCALL,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineRedirectA');

 dcl lineRedirectW
     entry (type HCALL,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineRedirectW');

 %dcl lineRedirect char ext;
 %if UNICODE ^= '' %then %do;
   %lineRedirect='lineRedirectW';
 %end; %else %do;
   %lineRedirect='lineRedirectA';
 %end;

 dcl lineRegisterRequestRecipient
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineRegisterRequestRecipient');

 dcl lineReleaseUserUserInfo
     entry (type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineReleaseUserUserInfo');

 dcl lineRemoveFromConference
     entry (type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineRemoveFromConference');

 dcl lineRemoveProvider
     entry (type DWORD,
            type HWND)
     returns (type LONG byvalue optional)
     WINAPI external('lineRemoveProvider');

 dcl lineSecureCall
     entry (type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineSecureCall');

 dcl lineSendUserUserInfo
     entry (type HCALL,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSendUserUserInfo');

 dcl lineSetAgentActivity
     entry (type HLINE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAgentActivity');

 dcl lineSetAgentGroup
     entry (type HLINE,
            type DWORD,
            type LINEAGENTGROUPLIST byaddr optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAgentGroup');


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl lineSetAgentMeasurementPeriod
     entry (type HLINE,
            type HAGENT,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAgentMeasurementPeriod');

 dcl lineSetAgentSessionState
     entry (type HLINE,
            type HAGENTSESSION,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAgentSessionState');

 dcl lineSetAgentStateEx
     entry (type HLINE,
            type HAGENT,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAgentStateEx');
 %end;

 dcl lineSetAgentState
     entry (type HLINE,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAgentState');

 dcl lineSetAppPriorityA
     entry (char(*) varz byaddr nonasgn,
            type DWORD,
            type LINEEXTENSIONID byaddr optional,
            type DWORD,
            char(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAppPriorityA');

 dcl lineSetAppPriorityW
     entry (WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type LINEEXTENSIONID byaddr optional,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAppPriorityW');

 %dcl lineSetAppPriority char ext;
 %if UNICODE ^= '' %then %do;
   %lineSetAppPriority='lineSetAppPriorityW';
 %end; %else %do;
   %lineSetAppPriority='lineSetAppPriorityA';
 %end;

 dcl lineSetAppSpecific
     entry (type HCALL,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetAppSpecific');

 dcl lineSetCallData
     entry (type HCALL,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetCallData');

 dcl lineSetCallParams
     entry (type HCALL,
            type DWORD,
            type DWORD,
            type DWORD,
            type LINEDIALPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetCallParams');

 dcl lineSetCallPrivilege
     entry (type HCALL,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetCallPrivilege');

 dcl lineSetCallQualityOfService
     entry (type HCALL,
            type LPVOID,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetCallQualityOfService');

 dcl lineSetCallTreatment
     entry (type HCALL,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetCallTreatment');

 dcl lineSetCurrentLocation
     entry (type HLINEAPP,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetCurrentLocation');

 dcl lineSetDevConfigA
     entry (type DWORD,
            type LPVOID,
            type DWORD,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetDevConfigA');

 dcl lineSetDevConfigW
     entry (type DWORD,
            type LPVOID,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetDevConfigW');

 %dcl lineSetDevConfig char ext;
 %if UNICODE ^= '' %then %do;
   %lineSetDevConfig='lineSetDevConfigW';
 %end; %else %do;
   %lineSetDevConfig='lineSetDevConfigA';
 %end;

 dcl lineSetLineDevStatus
     entry (type HLINE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetLineDevStatus');

 dcl lineSetMediaControl
     entry (type HLINE,
            type DWORD,
            type HCALL,
            type DWORD,
            (*) type LINEMEDIACONTROLDIGIT byaddr nonasgn optional,
            type DWORD,
            (*) type LINEMEDIACONTROLMEDIA byaddr nonasgn optional,
            type DWORD,
            (*) type LINEMEDIACONTROLTONE byaddr nonasgn optional,
            type DWORD,
            (*) type LINEMEDIACONTROLCALLSTATE byaddr nonasgn optional,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetMediaControl');

 dcl lineSetMediaMode
     entry (type HCALL,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetMediaMode');


 %if TAPI_CURRENT_VERSION >= '00020002' %then %do;
 dcl lineSetQueueMeasurementPeriod
     entry (type HLINE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetQueueMeasurementPeriod');
 %end;

 dcl lineSetNumRings
     entry (type HLINE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetNumRings');

 dcl lineSetStatusMessages
     entry (type HLINE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetStatusMessages');

 dcl lineSetTerminal
     entry (type HLINE,
            type DWORD,
            type HCALL,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetTerminal');

 dcl lineSetTollListA
     entry (type HLINEAPP,
            type DWORD,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetTollListA');

 dcl lineSetTollListW
     entry (type HLINEAPP,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetTollListW');

 %dcl lineSetTollList char ext;
 %if UNICODE ^= '' %then %do;
   %lineSetTollList='lineSetTollListW';
 %end; %else %do;
   %lineSetTollList='lineSetTollListA';
 %end;

 dcl lineSetupConferenceA
     entry (type HCALL,
            type HLINE,
            type HCALL byaddr,
            type HCALL byaddr,
            type DWORD,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetupConferenceA');

 dcl lineSetupConferenceW  entry (
            type HCALL,
            type HLINE,
            type HCALL byaddr,
            type HCALL byaddr,
            type DWORD,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetupConferenceW');

 %dcl lineSetupConference char ext;
 %if UNICODE ^= '' %then %do;
   %lineSetupConference='lineSetupConferenceW';
 %end; %else %do;
   %lineSetupConference='lineSetupConferenceA';
 %end;

 dcl lineSetupTransferA
     entry (type HCALL,
            type HCALL byaddr,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetupTransferA');

 dcl lineSetupTransferW
     entry (type HCALL,
            type HCALL byaddr,
            type LINECALLPARAMS byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineSetupTransferW');

 %dcl lineSetupTransfer char ext;
 %if UNICODE ^= '' %then %do;
   %lineSetupTransfer='lineSetupTransferW';
 %end; %else %do;
   %lineSetupTransfer='lineSetupTransferA';
 %end;

 dcl lineShutdown
     entry (type HLINEAPP)
     returns (type LONG byvalue optional)
     WINAPI external('lineShutdown');

 dcl lineSwapHold
     entry (type HCALL,
            type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineSwapHold');

 dcl lineTranslateAddressA
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type LINETRANSLATEOUTPUT byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineTranslateAddressA');

 dcl lineTranslateAddressW
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            type LINETRANSLATEOUTPUT byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('lineTranslateAddressW');

 %dcl lineTranslateAddress char ext;
 %if UNICODE ^= '' %then %do;
   %lineTranslateAddress='lineTranslateAddressW';
 %end; %else %do;
   %lineTranslateAddress='lineTranslateAddressA';
 %end;

 dcl lineTranslateDialogA
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type HWND,
            char(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineTranslateDialogA');

 dcl lineTranslateDialogW
     entry (type HLINEAPP,
            type DWORD,
            type DWORD,
            type HWND,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('lineTranslateDialogW');

 %dcl lineTranslateDialog char ext;
 %if UNICODE ^= '' %then %do;
   %lineTranslateDialog='lineTranslateDialogW';
 %end; %else %do;
   %lineTranslateDialog='lineTranslateDialogA';
 %end;

 dcl lineUncompleteCall
     entry (type HLINE,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('lineUncompleteCall');

 dcl lineUnhold
     entry (type HCALL)
     returns (type LONG byvalue optional)
     WINAPI external('lineUnhold');

 dcl lineUnparkA
     entry (type HLINE,
            type DWORD,
            type HCALL byaddr,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineUnparkA');

 dcl lineUnparkW
     entry (type HLINE,
            type DWORD,
            type HCALL byaddr,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('lineUnparkW');

 %dcl lineUnpark char ext;
 %if UNICODE ^= '' %then %do;
   %lineUnpark='lineUnparkW';
 %end; %else %do;
   %lineUnpark='lineUnparkA';
 %end;


 dcl phoneClose
     entry (type HPHONE)
     returns (type LONG byvalue optional)
     WINAPI external('phoneClose');

 dcl phoneConfigDialogA
     entry (type DWORD,
            type HWND,
            char(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('phoneConfigDialogA');

 dcl phoneConfigDialogW
     entry (type DWORD,
            type HWND,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('phoneConfigDialogW');

 %dcl phoneConfigDialog char ext;
 %if UNICODE ^= '' %then %do;
   %phoneConfigDialog='phoneConfigDialogW';
 %end; %else %do;
   %phoneConfigDialog='phoneConfigDialogA';
 %end;

 dcl phoneDevSpecific
     entry (type HPHONE,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneDevSpecific');

 dcl phoneGetButtonInfoA
     entry (type HPHONE,
            type DWORD,
            type PHONEBUTTONINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetButtonInfoA');

 dcl phoneGetButtonInfoW
     entry (type HPHONE,
            type DWORD,
            type PHONEBUTTONINFO byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetButtonInfoW');

 %dcl phoneGetButtonInfo char ext;
 %if UNICODE ^= '' %then %do;
   %phoneGetButtonInfo='phoneGetButtonInfoW';
 %end; %else %do;
   %phoneGetButtonInfo='phoneGetButtonInfoA';
 %end;

 dcl phoneGetData
     entry (type HPHONE,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetData');

 dcl phoneGetDevCapsA
     entry (type HPHONEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type PHONECAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetDevCapsA');

 dcl phoneGetDevCapsW
     entry (type HPHONEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type PHONECAPS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetDevCapsW');

 %dcl phoneGetDevCaps char ext;
 %if UNICODE ^= '' %then %do;
   %phoneGetDevCaps='phoneGetDevCapsW';
 %end; %else %do;
   %phoneGetDevCaps='phoneGetDevCapsA';
 %end;

 dcl phoneGetDisplay
     entry (type HPHONE,
            type VARSTRING byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetDisplay');

 dcl phoneGetGain
     entry (type HPHONE,
            type DWORD,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetGain');

 dcl phoneGetHookSwitch
     entry (type HPHONE,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetHookSwitch');

 dcl phoneGetIconA
     entry (type DWORD,
            char(*) varz byaddr nonasgn,
            type HICON byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetIconA');

 dcl phoneGetIconW
     entry (type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            type HICON byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetIconW');

 %dcl phoneGetIcon char ext;
 %if UNICODE ^= '' %then %do;
   %phoneGetIcon='phoneGetIconW';
 %end; %else %do;
   %phoneGetIcon='phoneGetIconA';
 %end;

 dcl phoneGetIDA
     entry (type HPHONE,
            type VARSTRING byaddr,
            char(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetIDA');

 dcl phoneGetIDW
     entry (type HPHONE,
            type VARSTRING byaddr,
            WCHAR(*) varz byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetIDW');

 %dcl phoneGetID char ext;
 %if UNICODE ^= '' %then %do;
   %phoneGetID='phoneGetIDW';
 %end; %else %do;
   %phoneGetID='phoneGetIDA';
 %end;

 dcl phoneGetLamp
     entry (type HPHONE,
            type DWORD,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetLamp');

 dcl phoneGetMessage
     entry (type HPHONEAPP,
            type PHONEMESSAGE byaddr,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetMessage');

 dcl phoneGetRing
     entry (type HPHONE,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetRing');

 dcl phoneGetStatusA
     entry (type HPHONE,
            type PHONESTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetStatusA');

 dcl phoneGetStatusW
     entry (type HPHONE,
            type PHONESTATUS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetStatusW');

 %dcl phoneGetStatus char ext;
 %if UNICODE ^= '' %then %do;
   %phoneGetStatus='phoneGetStatusW';
 %end; %else %do;
   %phoneGetStatus='phoneGetStatusA';
 %end;

 dcl phoneGetStatusMessages
     entry (type HPHONE,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetStatusMessages');

 dcl phoneGetVolume
     entry (type HPHONE,
            type DWORD,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneGetVolume');

 dcl phoneInitializeExA
     entry (type HPHONEAPP byaddr,
            type HINSTANCE,
            type PHONECALLBACK,
            char(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type DWORD byaddr,
            type PHONEINITIALIZEEXPARAMS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneInitializeExA');

 dcl phoneInitializeExW
     entry (type HPHONEAPP byaddr,
            type HINSTANCE,
            type PHONECALLBACK,
            WCHAR(*) varz byaddr nonasgn optional,
            type DWORD byaddr,
            type DWORD byaddr,
            type PHONEINITIALIZEEXPARAMS byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneInitializeExW');

 %dcl phoneInitializeEx char ext;
 %if UNICODE ^= '' %then %do;
   %phoneInitializeEx='phoneInitializeExW';
 %end; %else %do;
   %phoneInitializeEx='phoneInitializeExA';
 %end;

 dcl phoneNegotiateAPIVersion
     entry (type HPHONEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD byaddr,
            type PHONEEXTENSIONID byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneNegotiateAPIVersion');

 dcl phoneNegotiateExtVersion
     entry (type HPHONEAPP,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD,
            type DWORD byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('phoneNegotiateExtVersion');

 dcl phoneOpen
     entry (type HPHONEAPP,
            type DWORD,
            type HPHONE byaddr,
            type DWORD,
            type DWORD,
            type DWORD_PTR,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneOpen');

 dcl phoneSetButtonInfoA
     entry (type HPHONE,
            type DWORD,
            type PHONEBUTTONINFO byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetButtonInfoA');

 dcl phoneSetButtonInfoW
     entry (type HPHONE,
            type DWORD,
            type PHONEBUTTONINFO byaddr nonasgn)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetButtonInfoW');

 %dcl phoneSetButtonInfo char ext;
 %if UNICODE ^= '' %then %do;
   %phoneSetButtonInfo='phoneSetButtonInfoW';
 %end; %else %do;
   %phoneSetButtonInfo='phoneSetButtonInfoA';
 %end;

 dcl phoneSetData
     entry (type HPHONE,
            type DWORD,
            type LPVOID,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetData');

 dcl phoneSetDisplay
     entry (type HPHONE,
            type DWORD,
            type DWORD,
            char(*) varz byaddr nonasgn,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetDisplay');

 dcl phoneSetGain
     entry (type HPHONE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetGain');

 dcl phoneSetHookSwitch
     entry (type HPHONE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetHookSwitch');

 dcl phoneSetLamp
     entry (type HPHONE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetLamp');

 dcl phoneSetRing
     entry (type HPHONE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetRing');

 dcl phoneSetStatusMessages
     entry (type HPHONE,
            type DWORD,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetStatusMessages');

 dcl phoneSetVolume
     entry (type HPHONE,
            type DWORD,
            type DWORD)
     returns (type LONG byvalue optional)
     WINAPI external('phoneSetVolume');

 dcl phoneShutdown
     entry (type HPHONEAPP)
     returns (type LONG byvalue optional)
     WINAPI external('phoneShutdown');


 dcl tapiGetLocationInfoA
     entry (char(*) varz byaddr,
            char(*) varz byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('tapiGetLocationInfoA');

 dcl tapiGetLocationInfoW
     entry (WCHAR(*) varz byaddr,
            WCHAR(*) varz byaddr)
     returns (type LONG byvalue optional)
     WINAPI external('tapiGetLocationInfoW');

 %dcl tapiGetLocationInfo char ext;
 %if UNICODE ^= '' %then %do;
   %tapiGetLocationInfo='tapiGetLocationInfoW';
 %end; %else %do;
   %tapiGetLocationInfo='tapiGetLocationInfoA';
 %end;

 dcl tapiRequestDrop
     entry (type HWND,
            type WPARAM)
     returns (type LONG byvalue optional)
     WINAPI external('tapiRequestDrop');

 dcl tapiRequestMakeCallA
     entry (char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('tapiRequestMakeCallA');

 dcl tapiRequestMakeCallW
     entry (WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('tapiRequestMakeCallW');

 %dcl tapiRequestMakeCall char ext;
 %if UNICODE ^= '' %then %do;
   %tapiRequestMakeCall='tapiRequestMakeCallW';
 %end; %else %do;
   %tapiRequestMakeCall='tapiRequestMakeCallA';
 %end;

 dcl tapiRequestMediaCallA
     entry (type HWND,
            type WPARAM,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            char(*) varz byaddr nonasgn,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('tapiRequestMediaCallA');

 dcl tapiRequestMediaCallW
     entry (type HWND,
            type WPARAM,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn,
            type DWORD,
            type DWORD,
            WCHAR(*) varz byaddr nonasgn,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional)
     returns (type LONG byvalue optional)
     WINAPI external('tapiRequestMediaCallW');

 %dcl tapiRequestMediaCall char ext;
 %if UNICODE ^= '' %then %do;
   %tapiRequestMediaCall='tapiRequestMediaCallW';
 %end; %else %do;
   %tapiRequestMediaCall='tapiRequestMediaCallA';
 %end;


 /* TAPIERROR_FORMATMESSAGE - macro to convert a TAPI error constant  */
 /*   into a constant that FormatMessage will accept                  */
 /*                                                                   */
 /*       TAPIERR : Negative numbers and 0                            */
 /*           Map to : strip off high WORD                            */
 /*           Example: 0xFFFFFFFF (-1) becomes 0x0000FFFF             */
 /*       LINEERR : Start at 0x80000000                               */
 /*           Map to : strip off 0x80000000 and add 0xE000            */
 /*           Example: 0x80000004 becomes 0x0000E004                  */
 /*       PHONEERR: Start at 0x90000000                               */
 /*           Map to : strip off 0x90000000 and add 0xF000            */
 /*           Example: 0x9000000A becomes 0x0000F00A                  */
 /*                                                                   */
 /*       pseudocode:                                                 */
 /*                                                                   */
 /*       if (__ErrCode__ is a TAPIERR)                               */
 /*           strip off high word                                     */
 /*                                                                   */
 /*           else if (__ErrCode__ is a PHONEERR)                     */
 /*               strip off 0x90000000                                */
 /*               add 0xE000                                          */
 /*                                                                   */
 /*               else                                                */
 /*                   strip off 0x80000000                            */
 /*                   add 0xF000                                      */

 TAPIERROR_FORMATMESSAGE: proc (__ErrCode__)
                          returns (fixed bin(31) byvalue)
                          options (inline reorder) internal;
   dcl __ErrCode__ type LONG byvalue;
   dcl (iand, isigned, iunsigned) builtin;
   dcl ulErrCode type ULONG;

   ulErrCode = iunsigned (__ErrCode__);
   if ulErrCode > 'ffff0000'xu then
     ulErrCode = iand (ulErrCode, '0000ffff'xu);
   else if iand (ulErrCode, '10000000'xu) ^= 0 then
     ulErrCode = ulErrCode - '90000000'xu + 'F000'xu;
   else
     ulErrCode = ulErrCode - '80000000'xu + 'E000'xu;
   /* PL/I Note: error codes in FormatMessage are signed in PL/I,     */
   /* because that is what getLastError returns (see FormatMessage).  */
   /* Whereas C silently converts, PL/I raises SIZE. Convert here.    */
   return (isigned (ulErrCode));
 end TAPIERROR_FORMATMESSAGE;

 %end; /* TAPI_H */

