 /*********************************************************************/
 /* windef.cpy -- Basic Windows Type Definitions                      */
 /* Copyright (c) 1985-1997, Microsoft Corp. All rights reserved.     */
 /*********************************************************************/

 /* PL/I-specific support macros can be found at the end of this file */
 /* PL/I-specific fromalien callback linkage macros follow the        */
 /* core linkage macros                                               */

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %#WINDEF_ = 'Y';
 %dcl WINVER fixed ext;
 %if WINVER = 0 %then %do;
   %WINVER = 1281; /* Windows XP */
 %end;


 /* BASETYPES is defined in ntdef.h if these types are already defined*/

 %dcl BASETYPES char ext;
 %if BASETYPES = '' %then %do;
 %BASETYPES = 'Y';
 define alias ULONG   unsigned fixed bin(32);
 define alias PULONG  pointer;
 define alias USHORT  unsigned fixed bin(16);
 define alias PUSHORT pointer;
 define alias UCHAR   unsigned fixed bin (8);
 define alias PUCHAR  pointer;
 define alias PSZ     pointer;
 %end; /* !BASETYPES */

 dcl MAX_PATH fixed bin(31) value(260);


 %dcl #FALSE char ext;
 %if #FALSE = '' %then %do;
 %#FALSE = '0';
 dcl FALSE fixed bin (31) value (0);
 %end;

 %dcl #TRUE char ext;
 %if #TRUE = '' %then %do;
 %#TRUE = '1';
 dcl TRUE fixed bin (31) value (1);
 %end;

 %dcl CALLBACK char ext;
 %CALLBACK   = 'options (byvalue linkage(stdcall) nodescriptor)';
 %dcl WINAPI char ext;
 %WINAPI     = 'options (byvalue linkage(stdcall) nodescriptor)';
 %dcl WINAPIV char ext;
 %WINAPIV    = 'options (byvalue linkage(cdecl) nodescriptor)';
 %dcl APIENTRY char ext;
 %APIENTRY   = WINAPI;
 %dcl APIPRIVATE char ext;
 %APIPRIVATE = 'options (byvalue linkage(stdcall) nodescriptor)';
 %dcl PASCAL char ext;
 %PASCAL     = 'options (byvalue linkage(stdcall) nodescriptor)';

 /* PL/I note: sometimes "callback" routines are called from          */
 /* a non-PL/I environment, and need to be declared with fromalien    */
 /* Rather than using CALLBACK, WINAPI, etc. in these cases,          */
 /* use the following *_FROMALIEN versions thereof.                   */

 %dcl CALLBACK_FROMALIEN char ext;
 %CALLBACK_FROMALIEN   = 'options (byvalue linkage(stdcall) ' ||
                                  'fromalien nodescriptor)';
 %dcl WINAPI_FROMALIEN char ext;
 %WINAPI_FROMALIEN     = 'options (byvalue linkage(stdcall) ' ||
                                  'fromalien nodescriptor)';
 %dcl WINAPIV_FROMALIEN char ext;
 %WINAPIV_FROMALIEN    = 'options (byvalue linkage(cdecl) '   ||
                                  'fromalien nodescriptor)';
 %dcl APIENTRY_FROMALIEN char ext;
 %APIENTRY_FROMALIEN   = WINAPI_FROMALIEN;
 %dcl APIPRIVATE_FROMALIEN char ext;
 %APIPRIVATE_FROMALIEN = 'options (byvalue linkage(stdcall) ' ||
                                  'fromalien nodescriptor)';
 %dcl PASCAL_FROMALIEN char ext;
 %PASCAL_FROMALIEN     = 'options (byvalue linkage(stdcall) ' ||
                                  'fromalien nodescriptor)';

 %dcl #DWORD_DEFINED char ext;
 %#DWORD_DEFINED = 'Y';
 define alias DWORD   unsigned fixed bin(32);
 define alias BOOL    fixed bin(31);
 define alias BYTE    unsigned fixed bin (8);
 define alias WORD    unsigned fixed bin(16);
 define alias FLOAT   float bin(21);
 define alias DOUBLE  float bin(53);

 define alias PFLOAT  pointer;
 define alias PBOOL   pointer;
 define alias LPBOOL  pointer;
 define alias PBYTE   pointer;
 define alias LPBYTE  pointer;
 define alias PINT    pointer;
 define alias LPINT   pointer;
 define alias PWORD   pointer;
 define alias LPWORD  pointer;
 define alias LPLONG  pointer;
 define alias PDWORD  pointer;
 define alias LPDWORD pointer;
 define alias LPVOID  pointer;
 define alias LPCVOID pointer;

 define alias INT     fixed bin(31);
 define alias UINT    unsigned fixed bin(32);
 define alias PUINT   pointer;

 %dcl NT_INCLUDED char ext;
 %if NT_INCLUDED = '' %then %do;
   %include winnt;
 %end; /* NT_INCLUDED */

 /* Types use for passing & returning polymorphic values */
 define alias WPARAM  type UINT_PTR;
 define alias LPARAM  type LONG_PTR;
 define alias LRESULT type LONG_PTR;

 %dcl MAKEWORD entry;
 %MAKEWORD : procedure (a, b) returns (char);
   dcl (a, b) char;
   return ('ior (cast (: WORD, cast (: BYTE, iand (cast (: DWORD_PTR, '
        ||                            a || ' :), ''ff''xu) :) :), '
        || 'isll(cast (: WORD, cast (: BYTE, iand (cast (: DWORD_PTR, '
        ||                            b || ' :), ''ff''xu) :) :), 8))');
 %end MAKEWORD;

 %dcl MAKELONG entry;
 %MAKELONG : procedure (a, b) returns (char);
   dcl (a, b) char;
   /* Original C macro casts the first parameter to ior to a LONG */
   /* Since this could lead to SIZE in PL/I, I have used DWORD    */
   return ('ior (cast (: DWORD, cast (: WORD, iand (cast (: DWORD_PTR, '
        ||                         a || ' :), ''ffff''xu) :) :), '
        || 'isll(cast (: DWORD, cast (: WORD, iand (cast (: DWORD_PTR, '
        ||                         b || ' :), ''ffff''xu) :) :), 16))');
 %end MAKELONG;

 %dcl LOWORD entry;
 %LOWORD : procedure (l) returns (char);
   dcl l char;
   return ('cast (: WORD, iand (cast (: DWORD_PTR, ' ||
                                      l || ' :), ''ffff''xu) :) ');
 %end LOWORD;

 %dcl HIWORD entry;
 %HIWORD : procedure (l) returns (char);
   dcl l char;
   return ('cast (: WORD, isrl (cast (: DWORD_PTR, ' ||
                                      l || ' :), 16) :) ');
 %end HIWORD;

 %dcl LOBYTE entry;
 %LOBYTE : procedure (w) returns (char);
   dcl w char;
   return ('cast (: BYTE, iand (cast (: DWORD_PTR, ' ||
                                      w || ' :), ''ff''xu) :) ');
 %end LOBYTE;

 %dcl HIBYTE entry;
 %HIBYTE : procedure (w) returns (char);
   dcl w char;
   return ('cast (: BYTE, isrl (cast (: DWORD_PTR, ' ||
                                      w || ' :), 8) :) ');
 %end HIBYTE;

 %dcl WIN_INTERNAL char ext;
 %if WIN_INTERNAL = '' %then %do;
 DECLARE_HANDLE (HWND);
 DECLARE_HANDLE (HHOOK);
 %end;
 %dcl WINABLE char ext;
 %if WINABLE ^= '' %then %do;
 DECLARE_HANDLE (HEVENT);
 %end;


 define alias ATOM         type WORD;

 define alias SPHANDLE     pointer;
 define alias LPHANDLE     pointer;
 define alias HGLOBAL      type HANDLE;
 define alias HLOCAL       type HANDLE;
 define alias GLOBALHANDLE type HANDLE;
 define alias LOCALHANDLE  type HANDLE;

 define alias FARPROC  entry limited
              returns (fixed bin(31) optional) WINAPI;
 define alias NEARPROC entry limited
              returns (fixed bin(31) optional) WINAPI;
 define alias PROC     entry limited
              returns (fixed bin(31) optional) WINAPI;

 define alias HGDIOBJ pointer;

 DECLARE_HANDLE(HACCEL);
 DECLARE_HANDLE(HBITMAP);
 DECLARE_HANDLE(HBRUSH);
 %if (WINVER >= 1024) %then %do;
 DECLARE_HANDLE(HCOLORSPACE);
 %end; /* WINVER >= 0x0400 */
 DECLARE_HANDLE(HDC);
 DECLARE_HANDLE(HGLRC); /* OpenGL */
 DECLARE_HANDLE(HDESK);
 DECLARE_HANDLE(HENHMETAFILE);
 DECLARE_HANDLE(HFONT);
 DECLARE_HANDLE(HICON);
 DECLARE_HANDLE(HMENU);
 DECLARE_HANDLE(HMETAFILE);
 DECLARE_HANDLE(HINSTANCE);

 define alias HMODULE type HINSTANCE;
              /* HMODULEs can be used in place of HINSTANCEs */

 DECLARE_HANDLE(HPALETTE);
 DECLARE_HANDLE(HPEN);
 DECLARE_HANDLE(HRGN);
 DECLARE_HANDLE(HRSRC);
 DECLARE_HANDLE(HSTR);
 DECLARE_HANDLE(HTASK);
 DECLARE_HANDLE(HWINSTA);
 DECLARE_HANDLE(HKL);
 %if (WINVER >= 1280) %then %do;
 DECLARE_HANDLE(HMONITOR);
 DECLARE_HANDLE(HTERMINAL);
 DECLARE_HANDLE(HWINEVENTHOOK);
 %end;

 DECLARE_HANDLE(HKEY);
 DECLARE_HANDLE(HMF);
 DECLARE_HANDLE(HEMF);

 define alias HFILE fixed bin(31);
 define alias HCURSOR type HICON; /* HICONs & HCURSORs are polymorphic*/

 define alias   COLORREF type DWORD;
 define alias LPCOLORREF pointer;

 dcl HFILE_ERROR type HFILE value (-1);

 define structure
   1 RECT,
    2 left   type LONG,
    2 top    type LONG,
    2 right  type LONG,
    2 bottom type LONG;

 define alias  PRECT handle RECT;
 define alias NPRECT handle RECT;
 define alias LPRECT handle RECT;

 define structure
   1 RECTL,   /* rcl */
    2 left   type LONG,
    2 top    type LONG,
    2 right  type LONG,
    2 bottom type LONG;

 define alias   PRECTL handle RECTL;
 define alias  LPRECTL handle RECTL;
 define alias LPCRECTL handle RECTL;


 define structure
   1 POINT,
    2 x type LONG,
    2 y type LONG;

 define alias  PPOINT handle POINT;
 define alias LPPOINT handle POINT;
 define alias NPPOINT handle POINT;

 define structure
   1 POINTL,   /* ptl  */
    2 x type LONG,
    2 y type LONG;

 define alias PPOINTL handle POINTL;

 define structure
   1 SIZE,
    2 cx type LONG,
    2 cy type LONG;

 define alias  PSIZE  handle SIZE;
 define alias LPSIZE  handle SIZE;

 define alias   SIZEL type   SIZE;
 define alias  PSIZEL handle SIZEL;
 define alias LPSIZEL handle SIZEL;

 define structure
   1 POINTS,
    2 x type SHORT,
    2 y type SHORT;

 define alias  PPOINTS handle POINTS;
 define alias LPPOINTS handle POINTS;

 /* mode selections for the device mode function */
 dcl DM_UPDATE           fixed bin(31) value(1);
 dcl DM_COPY             fixed bin(31) value(2);
 dcl DM_PROMPT           fixed bin(31) value(4);
 dcl DM_MODIFY           fixed bin(31) value(8);

 dcl DM_IN_BUFFER        fixed bin(31) value(DM_MODIFY);
 dcl DM_IN_PROMPT        fixed bin(31) value(DM_PROMPT);
 dcl DM_OUT_BUFFER       fixed bin(31) value(DM_COPY);
 dcl DM_OUT_DEFAULT      fixed bin(31) value(DM_UPDATE);

 /* device capabilities indices */
 dcl DC_FIELDS           type WORD value(1);
 dcl DC_PAPERS           type WORD value(2);
 dcl DC_PAPERSIZE        type WORD value(3);
 dcl DC_MINEXTENT        type WORD value(4);
 dcl DC_MAXEXTENT        type WORD value(5);
 dcl DC_BINS             type WORD value(6);
 dcl DC_DUPLEX           type WORD value(7);
 dcl DC_SIZE             type WORD value(8);
 dcl DC_EXTRA            type WORD value(9);
 dcl DC_VERSION          type WORD value(10);
 dcl DC_DRIVER           type WORD value(11);
 dcl DC_BINNAMES         type WORD value(12);
 dcl DC_ENUMRESOLUTIONS  type WORD value(13);
 dcl DC_FILEDEPENDENCIES type WORD value(14);
 dcl DC_TRUETYPE         type WORD value(15);
 dcl DC_PAPERNAMES       type WORD value(16);
 dcl DC_ORIENTATION      type WORD value(17);
 dcl DC_COPIES           type WORD value(18);


 /*********************************************************************/
 /* PL/I-specific support macros - data declarations                  */
 /*********************************************************************/

 %dcl TCHARVAL char;        /* (w)charval - char/unicode hiding macro */
 %dcl THIGH    char;        /* (w)high    - char/unicode hiding macro */
 %dcl TLOW     char;        /* (w)low     - char/unicode hiding macro */
 %if UNICODE ^= '' %then %do;
   %TCHARVAL = 'wcharval';
   %THIGH    = 'whigh';
   %TLOW     = 'wlow';
 %end; %else %do;
   %TCHARVAL = 'charval';
   %THIGH    = 'high';
   %TLOW     = 'low';
 %end;


 dcl PLI_STRINGA  char(32767) varz based,
     PLI_STRINGW WCHAR(16383) varz based;
 %dcl UNICODE char;
 %dcl PLI_STRING char ext;
 %if UNICODE ^= '' %then %do;
   %PLI_STRING = 'PLI_STRINGW';
 %end; %else %do;
   %PLI_STRING = 'PLI_STRINGA';
 %end;
 dcl PLI_DWORD   type DWORD based;
 dcl PLI_POINTER pointer based;


 /*********************************************************************/
 /* Macros to permit conversion of pointer to nul-terminated string   */
 /* to that nul-terminated string (Unicode-capable)                   */
 /* or to convert a pointer to an array of pointers to nul-terminated */
 /* strings to a subscripted nul-terminated string (Unicode-capable). */
 /* Can also be used to pass a byvalue pointer as a byaddr string.    */
 /*********************************************************************/

 %dcl pli_p2za entry; /* ptr -> [(*) ptr -> ] ASCII string byaddr*/
 %pli_p2za: proc (p, i) returns (char);
   dcl p char;    /* pointer to char(*) varz or (*) ptr thereof */
   dcl i char;    /* array subscript, counting from 1, if (*) ptr */
   if parmset(i) then
     return ('ptradd (' || p || ' -> PLI_POINTER , '
                        || '(i - 1) * stg (PLI_POINTER))' ||
             ' -> PLI_STRINGA ');
   else
     return (p || ' -> PLI_STRINGA ');
 %end pli_p2za;

 %dcl pli_p2zw entry; /* ptr -> [(*) ptr -> ] Unicode string byaddr*/
 %pli_p2zw: proc (p, i) returns (char);
   dcl p char;    /* pointer to WCHAR(*) varz or (*) ptr thereof */
   dcl i char;    /* array subscript, counting from 1, if (*) ptr */
   if parmset(i) then
     return ('ptradd (' || p || ' -> PLI_POINTER , '
                        || '(i - 1) * stg (PLI_POINTER))' ||
             ' -> PLI_STRINGW ');
   else
     return (p || ' -> PLI_STRINGW ');
 %end pli_p2zw;

 %dcl pli_p2z entry;  /* ptr -> [(*) ptr -> ] Generic string byaddr*/
 %pli_p2z: proc (p, i) returns (char);
   dcl p char;    /* pointer to TCHAR(*) varz or (*) ptr thereof */
   dcl i char;    /* array subscript, counting from 1, if (*) ptr */
   if parmset(i) then
     return ('ptradd (' || p || ' -> PLI_POINTER , '
                        || '(i - 1) * stg (PLI_POINTER))' ||
             ' -> PLI_STRING ');
   else
     return (p || ' -> PLI_STRING ');
 %end pli_p2z;


 /*********************************************************************/
 /* Macro to permit conversion of pointer to DWORD to that DWORD      */
 /* or pointer to DWORD array to appropriate DWORD element (1..)      */
 /*********************************************************************/

 %dcl pli_p2d entry; /* dereference pointer to DWORD to that DWORD */
 %pli_p2d: proc (p, i) returns (char);
   dcl (p, i) char;
   if parmset(i) then
     return ('ptradd (' || p || ', (i - 1) * size (: DWORD :))' ||
             ' -> PLI_DWORD ');
   else
     return (p || ' -> PLI_DWORD ');
 %end pli_p2d;


 /*********************************************************************/
 /* Macros to permit passing a byvalue integer as a byaddr string     */
 /*********************************************************************/

 %dcl pli_b2za entry; /* int ==> string byaddr, ASCII version */
 %pli_b2za: proc (b) returns (char);
   dcl b char;    /* integer value */
   return ('ptrvalue (' || b || ') -> PLI_STRINGA ');
 %end pli_b2za;

 %dcl pli_b2zw entry; /* int ==> string byaddr, Unicode version */
 %pli_b2zw: proc (b) returns (char);
   dcl b char;    /* integer value */
   return ('ptrvalue (' || b || ') -> PLI_STRINGW ');
 %end pli_b2zw;

 %dcl pli_b2z entry;  /* int ==> string byaddr, Generic version */
 %pli_b2z: proc (b) returns (char);
   dcl b char;    /* integer value */
   return ('ptrvalue (' || b || ') -> PLI_STRING ');
 %end pli_b2z;


 /*********************************************************************/
 /* Macros to convert between Message Parms (int) and                 */
 /* handles / structures                                              */
 /*********************************************************************/

 %dcl pli_b2h entry; /* int ==> handle */
 %pli_b2h: proc (struc, b) returns (char);
   dcl (struc, b) char;
   return ('BIND (: ' || struc || ', ptrvalue (' || b || ') :)');
 %end pli_b2h;

 %dcl pli_h2b entry; /* handle ==> int */
 %pli_h2b: proc (h) returns (char);
   dcl (h) char;
   return ('binvalue (ptrvalue (' || h || '))');
 %end pli_h2b;

 %dcl pli_b2v entry; /* int ==> structure */
 %pli_b2v: proc (struc, b) returns (char);
   dcl (struc, b) char;
   return ('type (BIND (: ' || struc || ', ptrvalue (' || b || ') :))');
 %end pli_b2v;

 %dcl pli_v2b entry; /* var ==> int */
 %pli_v2b: proc (v) returns (char);
   dcl v char; /* structure, etc */
   return ('binvalue (addr (' || v || '))');
 %end pli_v2b;


 /*********************************************************************/
 /* Macros to convert between differing handles / structures          */
 /*********************************************************************/

 %dcl pli_h2h entry; /* handle ==> other handle, cf RESPEC */
 %pli_h2h: proc (struc, h) returns (char);
   dcl (struc, h) char;
   return ('BIND (: ' || struc || ', ptrvalue (' || h || ') :)');
 %end pli_h2h;

 %dcl pli_v2h entry; /* structure ==> other handle */
 %pli_v2h: proc (struc, v) returns (char);
   dcl (struc, v) char;
   return ('BIND (: ' || struc || ', addr (' || v || ') :)');
 %end pli_v2h;

 %dcl pli_h2v entry; /* handle ==> other structure */
 %pli_h2v: proc (struc, h) returns (char);
   dcl (struc, h) char;
   return ('type (BIND (: ' || struc || ', ptrvalue (' || h || ') :))');
 %end pli_h2v;

 %dcl pli_v2v entry; /* structure ==> other structure, cf: REDEFINE */
 %pli_v2v: proc (struc, v) returns (char);
   dcl (struc, v) char;
   return ('type (BIND (: ' || struc || ', addr (' || v || ') :))');
 %end pli_v2v;


 /*********************************************************************/
 /* Macros to convert between pointers and handles / structures       */
 /* Only pli_p2v is of any real benefit,                              */
 /* the other 3 routines are merely present for symmetry              */
 /*********************************************************************/

 %dcl pli_p2h entry; /* ptr ==> handle, aka BIND */
 %pli_p2h: proc (struc, p) returns (char);
   dcl (struc, p) char;
   return ('BIND (: ' || struc || ', ' || p || ' :)');
 %end pli_p2h;

 %dcl pli_h2p entry; /* handle ==> ptr, aka PTRVALUE */
 %pli_h2p: proc (h) returns (char);
   dcl (h) char;
   return ('ptrvalue (' || h || ')');
 %end pli_h2p;

 %dcl pli_p2v entry; /* ptr ==> structure */
 %pli_p2v: proc (struc, p) returns (char);
   dcl (struc, p) char;
   return ('type (BIND (: ' || struc || ', ' || p || ' :))');
 %end pli_p2v;

 %dcl pli_v2p entry; /* var ==> ptr, aka ADDR */
 %pli_v2p: proc (v) returns (char);
   dcl v char; /* structure, etc */
   return ('addr (' || v || ')');
 %end pli_v2p;


 /*********************************************************************/
 /* Macros to convert between PL/I bit (1) and Windows BOOL (C int)   */
 /*********************************************************************/

 %dcl pli_bit2bool entry; /* bit(1) ==> BOOL */
 %pli_bit2bool: proc (b) returns (char);
   dcl b char; /* bit(1) value */
   return ('fixed (' || b || ', 31)');
 %end pli_bit2bool;

 %dcl pli_bool2bit entry; /* BOOL ==> bit(1) */
 %pli_bool2bit: proc (b) returns (char);
   dcl b char; /* BOOL value */
   return ('((' || b || ') ^= 0)');
 %end pli_bool2bit;


 /*********************************************************************/
 /* Macro to zero out a variable                                      */
 /* Use as subroutine "call pli_zerovar (var)"                        */
 /*********************************************************************/

 %dcl pli_zerovar entry;
 %pli_zerovar: proc (v) returns (char);
   dcl v char;
   return ('plifill (addr (' || v || '), low (1), stg (' || v || '))');
 %end pli_zerovar;

 %end; /* windef */
