 /* ++                                                                */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     winnetwk.cpy                                                  */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Standard WINNET Header File for WIN32                         */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*     User Mode -Win32                                              */
 /*                                                                   */
 /* --                                                                */

 %dcl #WINNETWK_ char ext;
 %if #WINNETWK_ = '' %then %do;
 %#WINNETWK_ = 'Y';


 %dcl #WINBASE_ char ext;
 %if #WINBASE_ = '' %then %do;
 %include winbase;
 %end;

 %dcl WINVER  fixed ext; /*  1024 for NT4, 1280 for NT5 */

 %dcl UNICODE char ext;

 /* Network types */

 dcl WNNC_NET_MSNET                   type DWORD value('00010000'xu);
 dcl WNNC_NET_LANMAN                  type DWORD value('00020000'xu);
 dcl WNNC_NET_NETWARE                 type DWORD value('00030000'xu);
 dcl WNNC_NET_VINES                   type DWORD value('00040000'xu);
 dcl WNNC_NET_10NET                   type DWORD value('00050000'xu);
 dcl WNNC_NET_LOCUS                   type DWORD value('00060000'xu);
 dcl WNNC_NET_SUN_PC_NFS              type DWORD value('00070000'xu);
 dcl WNNC_NET_LANSTEP                 type DWORD value('00080000'xu);
 dcl WNNC_NET_9TILES                  type DWORD value('00090000'xu);
 dcl WNNC_NET_LANTASTIC               type DWORD value('000A0000'xu);
 dcl WNNC_NET_AS400                   type DWORD value('000B0000'xu);
 dcl WNNC_NET_FTP_NFS                 type DWORD value('000C0000'xu);
 dcl WNNC_NET_PATHWORKS               type DWORD value('000D0000'xu);
 dcl WNNC_NET_LIFENET                 type DWORD value('000E0000'xu);
 dcl WNNC_NET_POWERLAN                type DWORD value('000F0000'xu);
 dcl WNNC_NET_BWNFS                   type DWORD value('00100000'xu);
 dcl WNNC_NET_COGENT                  type DWORD value('00110000'xu);
 dcl WNNC_NET_FARALLON                type DWORD value('00120000'xu);
 dcl WNNC_NET_APPLETALK               type DWORD value('00130000'xu);
 dcl WNNC_NET_INTERGRAPH              type DWORD value('00140000'xu);
 dcl WNNC_NET_SYMFONET                type DWORD value('00150000'xu);
 dcl WNNC_NET_CLEARCASE               type DWORD value('00160000'xu);
 dcl WNNC_NET_FRONTIER                type DWORD value('00170000'xu);
 dcl WNNC_NET_BMC                     type DWORD value('00180000'xu);
 dcl WNNC_NET_DCE                     type DWORD value('00190000'xu);
 dcl WNNC_NET_DECORB                  type DWORD value('00200000'xu);
 dcl WNNC_NET_PROTSTOR                type DWORD value('00210000'xu);
 dcl WNNC_NET_FJ_REDIR                type DWORD value('00220000'xu);
 dcl WNNC_NET_DISTINCT                type DWORD value('00230000'xu);
 dcl WNNC_NET_TWINS                   type DWORD value('00240000'xu);
 dcl WNNC_NET_RDR2SAMPLE              type DWORD value('00250000'xu);
 dcl WNNC_NET_CSC                     type DWORD value('00260000'xu);
 dcl WNNC_NET_3IN1                    type DWORD value('00270000'xu);
 dcl WNNC_NET_EXTENDNET               type DWORD value('00290000'xu);
 dcl WNNC_NET_OBJECT_DIRE             type DWORD value('00300000'xu);
 dcl WNNC_NET_MASFAX                  type DWORD value('00310000'xu);
 dcl WNNC_NET_HOB_NFS                 type DWORD value('00320000'xu);
 dcl WNNC_NET_SHIVA                   type DWORD value('00330000'xu);
 dcl WNNC_NET_IBMAL                   type DWORD value('00340000'xu);

 dcl WNNC_CRED_MANAGER                type DWORD value('FFFF0000'xu);


 /*  Network Resources. */

 dcl RESOURCE_CONNECTED               type DWORD value('00000001'xu);
 dcl RESOURCE_GLOBALNET               type DWORD value('00000002'xu);
 dcl RESOURCE_REMEMBERED              type DWORD value('00000003'xu);

 %if WINVER >= 1024 %then %do;
 dcl RESOURCE_RECENT                  type DWORD value('00000004'xu);
 dcl RESOURCE_CONTEXT                 type DWORD value('00000005'xu);
 %end; /* WINVER >= 0x0400 */

 dcl RESOURCETYPE_ANY                 type DWORD value('00000000'xu);
 dcl RESOURCETYPE_DISK                type DWORD value('00000001'xu);
 dcl RESOURCETYPE_PRINT               type DWORD value('00000002'xu);

 %if WINVER >= 1024 %then %do;
 dcl RESOURCETYPE_RESERVED            type DWORD value('00000008'xu);
 %end; /* WINVER >= 0x0400 */
 dcl RESOURCETYPE_UNKNOWN             type DWORD value('FFFFFFFF'xu);

 dcl RESOURCEUSAGE_CONNECTABLE        type DWORD value('00000001'xu);
 dcl RESOURCEUSAGE_CONTAINER          type DWORD value('00000002'xu);

 %if WINVER >= 1024 %then %do;
 dcl RESOURCEUSAGE_NOLOCALDEVICE      type DWORD value('00000004'xu);
 dcl RESOURCEUSAGE_SIBLING            type DWORD value('00000008'xu);
 dcl RESOURCEUSAGE_ATTACHED           type DWORD value('00000010'xu);
 dcl RESOURCEUSAGE_ALL                type DWORD
                                 value( ior (RESOURCEUSAGE_CONNECTABLE,
                                             RESOURCEUSAGE_CONTAINER,
                                             RESOURCEUSAGE_ATTACHED));
 %end; /* WINVER >= 0x0400 */
 dcl RESOURCEUSAGE_RESERVED           type DWORD value('80000000'xu);

 dcl RESOURCEDISPLAYTYPE_GENERIC      type DWORD value('00000000'xu);
 dcl RESOURCEDISPLAYTYPE_DOMAIN       type DWORD value('00000001'xu);
 dcl RESOURCEDISPLAYTYPE_SERVER       type DWORD value('00000002'xu);
 dcl RESOURCEDISPLAYTYPE_SHARE        type DWORD value('00000003'xu);
 dcl RESOURCEDISPLAYTYPE_FILE         type DWORD value('00000004'xu);
 dcl RESOURCEDISPLAYTYPE_GROUP        type DWORD value('00000005'xu);

 %if WINVER >= 1024 %then %do;
 dcl RESOURCEDISPLAYTYPE_NETWORK      type DWORD value('00000006'xu);
 dcl RESOURCEDISPLAYTYPE_ROOT         type DWORD value('00000007'xu);
 dcl RESOURCEDISPLAYTYPE_SHAREADMIN   type DWORD value('00000008'xu);
 dcl RESOURCEDISPLAYTYPE_DIRECTORY    type DWORD value('00000009'xu);
 %end; /* WINVER >= 0x0400 */
 dcl RESOURCEDISPLAYTYPE_TREE         type DWORD value('0000000A'xu);

 %if WINVER >= 1024 %then %do;
 dcl RESOURCEDISPLAYTYPE_NDSCONTAINER type DWORD value('0000000B'xu);
 %end; /* WINVER >= 0x0400 */

 define structure
   1 NETRESOURCEA,
     2 dwScope       type DWORD,
     2 dwType        type DWORD,
     2 dwDisplayType type DWORD,
     2 dwUsage       type DWORD,
     2 lpLocalName   type LPSTR,
     2 lpRemoteName  type LPSTR,
     2 lpComment     type LPSTR,
     2 lpProvider    type LPSTR;
 define alias LPNETRESOURCEA handle NETRESOURCEA;

 define structure
   1 NETRESOURCEW,
     2 dwScope       type DWORD,
     2 dwType        type DWORD,
     2 dwDisplayType type DWORD,
     2 dwUsage       type DWORD,
     2 lpLocalName   type LPWSTR,
     2 lpRemoteName  type LPWSTR,
     2 lpComment     type LPWSTR,
     2 lpProvider    type LPWSTR;
 define alias LPNETRESOURCEW handle NETRESOURCEW;
 %if UNICODE ^= '' %then %do;
 define alias   NETRESOURCE type   NETRESOURCEW;
 define alias LPNETRESOURCE type LPNETRESOURCEW;
 %end; %else %do;
 define alias   NETRESOURCE type   NETRESOURCEA;
 define alias LPNETRESOURCE type LPNETRESOURCEA;
 %end; /* UNICODE */


 /*  Network Connections. */

 dcl NETPROPERTY_PERSISTENT type DWORD value(1);

 dcl CONNECT_UPDATE_PROFILE type DWORD value('00000001'xu);
 dcl CONNECT_UPDATE_RECENT  type DWORD value('00000002'xu);
 dcl CONNECT_TEMPORARY      type DWORD value('00000004'xu);
 dcl CONNECT_INTERACTIVE    type DWORD value('00000008'xu);
 dcl CONNECT_PROMPT         type DWORD value('00000010'xu);
 dcl CONNECT_NEED_DRIVE     type DWORD value('00000020'xu);

 %if WINVER >= 1024 %then %do;
 dcl CONNECT_REFCOUNT       type DWORD value('00000040'xu);
 dcl CONNECT_REDIRECT       type DWORD value('00000080'xu);
 dcl CONNECT_LOCALDRIVE     type DWORD value('00000100'xu);
 dcl CONNECT_CURRENT_MEDIA  type DWORD value('00000200'xu);
 dcl CONNECT_DEFERRED       type DWORD value('00000400'xu);
 dcl CONNECT_RESERVED       type DWORD value('FF000000'xu);
 %end; /* WINVER >= 0x0400 */

 dcl WNetAddConnectionA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetAddConnectionA');
 dcl WNetAddConnectionW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetAddConnectionW');
 %dcl WNetAddConnection char ext;
 %if UNICODE ^= '' %then %do;
   %WNetAddConnection='WNetAddConnectionW';
 %end; %else %do;
 %dcl WNetAddConnection char ext;
   %WNetAddConnection='WNetAddConnectionA';
 %end; /* !UNICODE */

 dcl WNetAddConnection2A
     entry (type NETRESOURCEA byaddr,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetAddConnection2A');
 dcl WNetAddConnection2W
     entry (type NETRESOURCEW byaddr,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetAddConnection2W');
 %dcl WNetAddConnection2 char ext;
 %if UNICODE ^= '' %then %do;
   %WNetAddConnection2='WNetAddConnection2W';
 %end; %else %do;
   %WNetAddConnection2='WNetAddConnection2A';
 %end; /* !UNICODE */

 dcl WNetAddConnection3A
     entry (type HWND,
            type NETRESOURCEA byaddr,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetAddConnection3A');
 dcl WNetAddConnection3W
     entry (type HWND,
            type NETRESOURCEW byaddr,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetAddConnection3W');
 %dcl WNetAddConnection3 char ext;
 %if UNICODE ^= '' %then %do;
   %WNetAddConnection3='WNetAddConnection3W';
 %end; %else %do;
   %WNetAddConnection3='WNetAddConnection3A';
 %end; /* !UNICODE */

 dcl WNetCancelConnectionA
     entry (char (*) varz byaddr nonasgn,
            type BOOL)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetCancelConnectionA');
 dcl WNetCancelConnectionW
     entry (WCHAR (*) varz byaddr nonasgn,
            type BOOL)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetCancelConnectionW');
 %dcl WNetCancelConnection char ext;
 %if UNICODE ^= '' %then %do;
   %WNetCancelConnection='WNetCancelConnectionW';
 %end; %else %do;
   %WNetCancelConnection='WNetCancelConnectionA';
 %end; /* !UNICODE */

 dcl WNetCancelConnection2A
     entry (char (*) varz byaddr nonasgn,
            type DWORD,
            type BOOL)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetCancelConnection2A');
 dcl WNetCancelConnection2W
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type BOOL)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetCancelConnection2W');
 %dcl WNetCancelConnection2 char ext;
 %if UNICODE ^= '' %then %do;
   %WNetCancelConnection2='WNetCancelConnection2W';
 %end; %else %do;
   %WNetCancelConnection2='WNetCancelConnection2A';
 %end; /* !UNICODE */

 dcl WNetGetConnectionA
     entry (char (*) varz byaddr nonasgn,
            char (*) varz byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetConnectionA');
 dcl WNetGetConnectionW
     entry (WCHAR (*) varz byaddr nonasgn,
            WCHAR (*) varz byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetConnectionW');
 %dcl WNetGetConnection char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetConnection='WNetGetConnectionW';
 %end; %else %do;
   %WNetGetConnection='WNetGetConnectionA';
 %end; /* !UNICODE */


 %if WINVER >= 1024 %then %do;
 dcl WNetUseConnectionA
     entry (type HWND,
            type NETRESOURCEA byaddr,
            char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr nonasgn optional,
            type DWORD,
            char (*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetUseConnectionA');
 dcl WNetUseConnectionW
     entry (type HWND,
            type NETRESOURCEW byaddr,
            WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr nonasgn optional,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetUseConnectionW');
 %dcl WNetUseConnection char ext;
 %if UNICODE ^= '' %then %do;
   %WNetUseConnection='WNetUseConnectionW';
 %end; %else %do;
   %WNetUseConnection='WNetUseConnectionA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */


 /*  Network Connection Dialogs. */

 dcl WNetConnectionDialog
     entry (type HWND,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetConnectionDialog');

 dcl WNetDisconnectDialog
     entry (type HWND,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetDisconnectDialog');


 %if WINVER >= 1024 %then %do;
 define structure
   1 CONNECTDLGSTRUCTA,
     2 cbStructure type DWORD,/* size of this structure in bytes */
     2 hwndOwner   type HWND, /* owner window for the dialog */
     2 lpConnRes   type LPNETRESOURCEA,/* Requested Resource info */
     2 dwFlags     type DWORD,/* flags (see below) */
     2 dwDevNum    type DWORD;/* number of devices connected to */
 define alias LPCONNECTDLGSTRUCTA handle CONNECTDLGSTRUCTA;

 define structure
   1 CONNECTDLGSTRUCTW,
     2 cbStructure type DWORD,/* size of this structure in bytes */
     2 hwndOwner   type HWND, /* owner window for the dialog */
     2 lpConnRes   type LPNETRESOURCEW,/* Requested Resource info */
     2 dwFlags     type DWORD,/* flags (see below) */
     2 dwDevNum    type DWORD;/* number of devices connected to */
 define alias LPCONNECTDLGSTRUCTW handle CONNECTDLGSTRUCTW;
 %if UNICODE ^= '' %then %do;
 define alias   CONNECTDLGSTRUCT type   CONNECTDLGSTRUCTW;
 define alias LPCONNECTDLGSTRUCT type LPCONNECTDLGSTRUCTW;
 %end; %else %do;
 define alias   CONNECTDLGSTRUCT type   CONNECTDLGSTRUCTA;
 define alias LPCONNECTDLGSTRUCT type LPCONNECTDLGSTRUCTA;
 %end; /* UNICODE */

 dcl CONNDLG_RO_PATH     type DWORD value('00000001'xu);
     /* Resource path should be read-only    */
 dcl CONNDLG_CONN_POINT  type DWORD value('00000002'xu);
     /* Netware -style movable connection point enabled */
 dcl CONNDLG_USE_MRU     type DWORD value('00000004'xu);
     /* Use MRU combobox  */
 dcl CONNDLG_HIDE_BOX    type DWORD value('00000008'xu);
     /* Hide persistent connect checkbox  */

 /* NOTE: Set at most ONE of the below flags.                    */
 /*       If neither flag is set, then the persistence is set to */
 /*       whatever the user chose during a previous connection   */
 dcl CONNDLG_PERSIST     type DWORD value('00000010'xu);
     /* Force persistent connection */
 dcl CONNDLG_NOT_PERSIST type DWORD value('00000020'xu);
     /* Force connection NOT persistent */

 dcl WNetConnectionDialog1A
     entry (type CONNECTDLGSTRUCTA byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetConnectionDialog1A');
 dcl WNetConnectionDialog1W
     entry (type CONNECTDLGSTRUCTW byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetConnectionDialog1W');
 %dcl WNetConnectionDialog1 char ext;
 %if UNICODE ^= '' %then %do;
   %WNetConnectionDialog1='WNetConnectionDialog1W';
 %end; %else %do;
   %WNetConnectionDialog1='WNetConnectionDialog1A';
 %end; /* !UNICODE */

 define structure
   1 DISCDLGSTRUCTA,
     2 cbStructure  type DWORD, /* size of this structure in bytes */
     2 hwndOwner    type HWND,  /* owner window for the dialog */
     2 lpLocalName  type LPSTR, /* local device name */
     2 lpRemoteName type LPSTR, /* network resource name */
     2 dwFlags      type DWORD; /* flags */
 define alias LPDISCDLGSTRUCTA handle DISCDLGSTRUCTA;

 define structure
   1 DISCDLGSTRUCTW,
     2 cbStructure  type DWORD, /* size of this structure in bytes */
     2 hwndOwner    type HWND,  /* owner window for the dialog */
     2 lpLocalName  type LPWSTR,/* local device name */
     2 lpRemoteName type LPWSTR,/* network resource name */
     2 dwFlags      type DWORD; /* flags */
 define alias LPDISCDLGSTRUCTW handle DISCDLGSTRUCTW;
 %if UNICODE ^= '' %then %do;
 define alias   DISCDLGSTRUCT type   DISCDLGSTRUCTW;
 define alias LPDISCDLGSTRUCT type LPDISCDLGSTRUCTW;
 %end; %else %do;
 define alias   DISCDLGSTRUCT type   DISCDLGSTRUCTA;
 define alias LPDISCDLGSTRUCT type LPDISCDLGSTRUCTA;
 %end; /* UNICODE */

 dcl DISC_UPDATE_PROFILE type DWORD value('00000001'xu);
 dcl DISC_NO_FORCE       type DWORD value('00000040'xu);

 dcl WNetDisconnectDialog1A
     entry (type LPDISCDLGSTRUCTA)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetDisconnectDialog1A');
 dcl WNetDisconnectDialog1W
     entry (type LPDISCDLGSTRUCTW)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetDisconnectDialog1W');
 %dcl WNetDisconnectDialog1 char ext;
 %if UNICODE ^= '' %then %do;
   %WNetDisconnectDialog1='WNetDisconnectDialog1W';
 %end; %else %do;
   %WNetDisconnectDialog1='WNetDisconnectDialog1A';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */


 /*  Network Browsing. */

 dcl WNetOpenEnumA
     entry (type DWORD,
            type DWORD,
            type DWORD,
            type NETRESOURCEA byaddr,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetOpenEnumA');
 dcl WNetOpenEnumW
     entry (type DWORD,
            type DWORD,
            type DWORD,
            type NETRESOURCEW byaddr,
            type HANDLE byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetOpenEnumW');
 %dcl WNetOpenEnum char ext;
 %if UNICODE ^= '' %then %do;
   %WNetOpenEnum='WNetOpenEnumW';
 %end; %else %do;
   %WNetOpenEnum='WNetOpenEnumA';
 %end; /* !UNICODE */

 dcl WNetEnumResourceA
     entry (type HANDLE,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetEnumResourceA');
 dcl WNetEnumResourceW
     entry (type HANDLE,
            type DWORD byaddr,
            type LPVOID,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetEnumResourceW');
 %dcl WNetEnumResource char ext;
 %if UNICODE ^= '' %then %do;
   %WNetEnumResource='WNetEnumResourceW';
 %end; %else %do;
   %WNetEnumResource='WNetEnumResourceA';
 %end; /* !UNICODE */

 dcl WNetCloseEnum
     entry (type HANDLE)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetCloseEnum');

 %if (WINVER >= 1024) %then %do;

 dcl WNetGetResourceParentA
     entry (type NETRESOURCEA byaddr,
            type LPVOID,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetResourceParentA');
 dcl WNetGetResourceParentW
     entry (type NETRESOURCEW byaddr,
            type LPVOID,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetResourceParentW');
 %dcl WNetGetResourceParent char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetResourceParent='WNetGetResourceParentW';
 %end; %else %do;
   %WNetGetResourceParent='WNetGetResourceParentA';
 %end; /* !UNICODE */

 dcl WNetGetResourceInformationA
     entry (type NETRESOURCEA byaddr,
            type LPVOID,
            type DWORD byaddr,
            type LPSTR byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetResourceInformationA');
 dcl WNetGetResourceInformationW
     entry (type NETRESOURCEW byaddr,
            type LPVOID,
            type DWORD byaddr,
            type LPWSTR byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetResourceInformationW');
 %dcl WNetGetResourceInformation char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetResourceInformation='WNetGetResourceInformationW';
 %end; %else %do;
   %WNetGetResourceInformation='WNetGetResourceInformationA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */

 /*  Universal Naming. */

 dcl UNIVERSAL_NAME_INFO_LEVEL type DWORD value('00000001'xu);
 dcl REMOTE_NAME_INFO_LEVEL    type DWORD value('00000002'xu);

 define structure
   1 UNIVERSAL_NAME_INFOA,
     2 lpUniversalName type LPSTR;
 define alias LPUNIVERSAL_NAME_INFOA handle UNIVERSAL_NAME_INFOA;

 define structure
   1 UNIVERSAL_NAME_INFOW,
     2 lpUniversalName type LPWSTR;
 define alias LPUNIVERSAL_NAME_INFOW handle UNIVERSAL_NAME_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias   UNIVERSAL_NAME_INFO type   UNIVERSAL_NAME_INFOW;
 define alias LPUNIVERSAL_NAME_INFO type LPUNIVERSAL_NAME_INFOW;
 %end; %else %do;
 define alias   UNIVERSAL_NAME_INFO type   UNIVERSAL_NAME_INFOA;
 define alias LPUNIVERSAL_NAME_INFO type LPUNIVERSAL_NAME_INFOA;
 %end; /* UNICODE */

 define structure
   1 REMOTE_NAME_INFOA,
     2 lpUniversalName  type LPSTR,
     2 lpConnectionName type LPSTR,
     2 lpRemainingPath  type LPSTR;
 define alias LPREMOTE_NAME_INFOA handle REMOTE_NAME_INFOA;

 define structure
   1 REMOTE_NAME_INFOW,
     2 lpUniversalName  type LPWSTR,
     2 lpConnectionName type LPWSTR,
     2 lpRemainingPath  type LPWSTR;
 define alias LPREMOTE_NAME_INFOW handle REMOTE_NAME_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias   REMOTE_NAME_INFO type   REMOTE_NAME_INFOW;
 define alias LPREMOTE_NAME_INFO type LPREMOTE_NAME_INFOW;
 %end; %else %do;
 define alias   REMOTE_NAME_INFO type   REMOTE_NAME_INFOA;
 define alias LPREMOTE_NAME_INFO type LPREMOTE_NAME_INFOA;
 %end; /* UNICODE */

 dcl WNetGetUniversalNameA
     entry (char (*) varz byaddr nonasgn,
            type DWORD,
            type LPVOID,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetUniversalNameA');
 dcl WNetGetUniversalNameW
     entry (WCHAR (*) varz byaddr nonasgn,
            type DWORD,
            type LPVOID,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetUniversalNameW');
 %dcl WNetGetUniversalName char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetUniversalName='WNetGetUniversalNameW';
 %end; %else %do;
   %WNetGetUniversalName='WNetGetUniversalNameA';
 %end; /* !UNICODE */


 /*  Authentication and Logon/Logoff. */

 dcl WNetGetUserA
     entry (char (*) varz byaddr nonasgn optional,
            char (*) varz byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetUserA');
 dcl WNetGetUserW
     entry (WCHAR (*) varz byaddr nonasgn optional,
            WCHAR (*) varz byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetUserW');
 %dcl WNetGetUser char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetUser='WNetGetUserW';
 %end; %else %do;
   %WNetGetUser='WNetGetUserA';
 %end; /* !UNICODE */


 /* Other. */

 %if WINVER >= 1024 %then %do;
 dcl WNFMT_MULTILINE   type DWORD value('01'xu);
 dcl WNFMT_ABBREVIATED type DWORD value('02'xu);
 dcl WNFMT_INENUM      type DWORD value('10'xu);
 dcl WNFMT_CONNECTION  type DWORD value('20'xu);
 %end; /* WINVER >= 0x0400 */


 %if WINVER >= 1024 %then %do;
 dcl WNetGetProviderNameA
     entry (type DWORD,
            char (*) varz byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetProviderNameA');
 dcl WNetGetProviderNameW
     entry (type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetProviderNameW');
 %dcl WNetGetProviderName char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetProviderName='WNetGetProviderNameW';
 %end; %else %do;
   %WNetGetProviderName='WNetGetProviderNameA';
 %end; /* !UNICODE */

 define structure
   1 NETINFOSTRUCT,
     2 cbStructure       type DWORD,
     2 dwProviderVersion type DWORD,
     2 dwStatus          type DWORD,
     2 dwCharacteristics type DWORD,
     2 dwHandle          type DWORD,
     2 wNetType          type WORD,
     2 dwPrinters        type DWORD,
     2 dwDrives          type DWORD;
 define alias LPNETINFOSTRUCT handle NETINFOSTRUCT;

 dcl NETINFO_DLL16      type DWORD value('00000001'xu);
     /* Provider running as 16 bit Winnet Driver */
 dcl NETINFO_DISKRED    type DWORD value('00000004'xu);
     /* Provider requires disk redirections to connect */
 dcl NETINFO_PRINTERRED type DWORD value('00000008'xu);
     /* Provider requires printer redirections to connect */

 dcl WNetGetNetworkInformationA
     entry (char (*) varz byaddr nonasgn,
            type NETINFOSTRUCT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetNetworkInformationA');
 dcl WNetGetNetworkInformationW
     entry (WCHAR (*) varz byaddr nonasgn,
            type NETINFOSTRUCT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetNetworkInformationW');
 %dcl WNetGetNetworkInformation char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetNetworkInformation='WNetGetNetworkInformationW';
 %end; %else %do;
   %WNetGetNetworkInformation='WNetGetNetworkInformationA';
 %end; /* !UNICODE */


 /*  User Profiles. */
 define alias PFNGETPROFILEPATHA
        entry (type LPCSTR,   /* pszUsername */
               type LPSTR,    /* pszBuffer   */
               type UINT)     /* cbBuffer    */
        returns (type UINT byvalue optional)
        PASCAL limited;
 define alias PFNGETPROFILEPATHW
        entry (type LPCWSTR,  /* pszUsername */
               type LPWSTR,   /* pszBuffer   */
               type UINT)     /* cbBuffer    */
        returns (type UINT byvalue optional)
        PASCAL limited;
 %if UNICODE ^= '' %then %do;
 define alias PFNGETPROFILEPATH type PFNGETPROFILEPATHW;
 %end; %else %do;
 define alias PFNGETPROFILEPATH type PFNGETPROFILEPATHA;
 %end; /* !UNICODE */

 define alias PFNRECONCILEPROFILEA
        entry (type LPCSTR,   /* pszCentralFile */
               type LPCSTR,   /* pszLocalFile   */
               type DWORD)    /* dwFlags        */
        returns (type UINT byvalue optional)
        PASCAL limited;
 define alias PFNRECONCILEPROFILEW
        entry (type LPCWSTR,  /* pszCentralFile */
               type LPCWSTR,  /* pszLocalFile   */
               type DWORD)    /* dwFlags        */
        returns (type UINT byvalue optional)
        PASCAL limited;
 %if UNICODE ^= '' %then %do;
 define alias PFNRECONCILEPROFILE type PFNRECONCILEPROFILEW;
 %end; %else %do;
 define alias PFNRECONCILEPROFILE type PFNRECONCILEPROFILEA;
 %end; /* !UNICODE */

 dcl RP_LOGON   fixed bin(15) value('01'xn);
     /* if set, do for logon, else for logoff */
 dcl RP_INIFILE fixed bin(15) value('02'xn);
     /* if set, reconcile .INI file, else reg. hive */


 /*  Policies. */

 define alias PFNPROCESSPOLICIESA
        entry (type HWND,     /* hwnd            */
               type LPCSTR,   /* pszPath         */
               type LPCSTR,   /* pszUsername     */
               type LPCSTR,   /* pszComputerName */
               type DWORD)    /* dwFlags         */
        returns (type BOOL byvalue optional)
        PASCAL limited;
 define alias PFNPROCESSPOLICIESW
        entry (type HWND,     /* hwnd            */
               type LPCWSTR,  /* pszPath         */
               type LPCWSTR,  /* pszUsername     */
               type LPCWSTR,  /* pszComputerName */
               type DWORD)    /* dwFlags         */
        returns (type BOOL byvalue optional)
        PASCAL limited;
 %if UNICODE ^= '' %then %do;
 define alias PFNPROCESSPOLICIES type PFNPROCESSPOLICIESW;
 %end; %else %do;
 define alias PFNPROCESSPOLICIES type PFNPROCESSPOLICIESA;
 %end; /* !UNICODE */

 dcl PP_DISPLAYERRORS fixed bin(15) value('01'xn);
     /* if set, display error messages, else fail silently if error */
 %end; /* WINVER >= 0x0400 */


 /*  Error handling. */

 dcl WNetGetLastErrorA
     entry (type DWORD byaddr,
            char (*) varz byaddr,
            type DWORD,
            char (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetLastErrorA');
 dcl WNetGetLastErrorW
     entry (type DWORD byaddr,
            WCHAR (*) varz byaddr,
            type DWORD,
            WCHAR (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     APIENTRY external('WNetGetLastErrorW');
 %dcl WNetGetLastError char ext;
 %if UNICODE ^= '' %then %do;
   %WNetGetLastError='WNetGetLastErrorW';
 %end; %else %do;
   %WNetGetLastError='WNetGetLastErrorA';
 %end; /* !UNICODE */


 /*  STATUS CODES */

 /* General */

 dcl WN_SUCCESS          fixed bin (31) value (NO_ERROR);
 dcl WN_NO_ERROR         fixed bin (31) value (NO_ERROR);
 dcl WN_NOT_SUPPORTED    fixed bin (31) value (ERROR_NOT_SUPPORTED);
 dcl WN_CANCEL           fixed bin (31) value (ERROR_CANCELLED);
 dcl WN_RETRY            fixed bin (31) value (ERROR_RETRY);
 dcl WN_NET_ERROR        fixed bin (31) value (ERROR_UNEXP_NET_ERR);
 dcl WN_MORE_DATA        fixed bin (31) value (ERROR_MORE_DATA);
 dcl WN_BAD_POINTER      fixed bin (31) value (ERROR_INVALID_ADDRESS);
 dcl WN_BAD_VALUE        fixed bin (31) value (ERROR_INVALID_PARAMETER);
 dcl WN_BAD_USER         fixed bin (31) value (ERROR_BAD_USERNAME);
 dcl WN_BAD_PASSWORD     fixed bin (31) value (ERROR_INVALID_PASSWORD);
 dcl WN_ACCESS_DENIED    fixed bin (31) value (ERROR_ACCESS_DENIED);
 dcl WN_FUNCTION_BUSY    fixed bin (31) value (ERROR_BUSY);
 dcl WN_WINDOWS_ERROR    fixed bin (31) value (ERROR_UNEXP_NET_ERR);
 dcl WN_OUT_OF_MEMORY    fixed bin (31) value (ERROR_NOT_ENOUGH_MEMORY);
 dcl WN_NO_NETWORK       fixed bin (31) value (ERROR_NO_NETWORK);
 dcl WN_EXTENDED_ERROR   fixed bin (31) value (ERROR_EXTENDED_ERROR);
 dcl WN_BAD_LEVEL        fixed bin (31) value (ERROR_INVALID_LEVEL);
 dcl WN_BAD_HANDLE       fixed bin (31) value (ERROR_INVALID_HANDLE);

 %if WINVER >= 1024 %then %do;
 dcl WN_NOT_INITIALIZING fixed bin (31)
                         value (ERROR_ALREADY_INITIALIZED);
 dcl WN_NO_MORE_DEVICES  fixed bin (31) value (ERROR_NO_MORE_DEVICES);
 %end; /* WINVER >= 0x0400 */

 /* Connection */

 dcl WN_NOT_CONNECTED     fixed bin (31) value (ERROR_NOT_CONNECTED);
 dcl WN_OPEN_FILES        fixed bin (31) value (ERROR_OPEN_FILES);
 dcl WN_DEVICE_IN_USE     fixed bin (31) value (ERROR_DEVICE_IN_USE);
 dcl WN_BAD_NETNAME       fixed bin (31) value (ERROR_BAD_NET_NAME);
 dcl WN_BAD_LOCALNAME     fixed bin (31) value (ERROR_BAD_DEVICE);
 dcl WN_ALREADY_CONNECTED fixed bin (31) value (ERROR_ALREADY_ASSIGNED);
 dcl WN_DEVICE_ERROR      fixed bin (31) value (ERROR_GEN_FAILURE);
 dcl WN_CONNECTION_CLOSED fixed bin (31)
                          value (ERROR_CONNECTION_UNAVAIL);
 dcl WN_NO_NET_OR_BAD_PATH fixed bin (31)
                          value (ERROR_NO_NET_OR_BAD_PATH);
 dcl WN_BAD_PROVIDER      fixed bin (31) value (ERROR_BAD_PROVIDER);
 dcl WN_CANNOT_OPEN_PROFILE fixed bin (31)
                          value (ERROR_CANNOT_OPEN_PROFILE);
 dcl WN_BAD_PROFILE       fixed bin (31) value (ERROR_BAD_PROFILE);
 dcl WN_BAD_DEV_TYPE      fixed bin (31) value (ERROR_BAD_DEV_TYPE);
 dcl WN_DEVICE_ALREADY_REMEMBERED fixed bin (31)
                          value (ERROR_DEVICE_ALREADY_REMEMBERED);
 dcl WN_CONNECTED_OTHER_PASSWORD fixed bin (31)
                          value (ERROR_CONNECTED_OTHER_PASSWORD);

 /* Enumeration */

 dcl WN_NO_MORE_ENTRIES   fixed bin (31) value (ERROR_NO_MORE_ITEMS);
 dcl WN_NOT_CONTAINER     fixed bin (31) value (ERROR_NOT_CONTAINER);


 %if WINVER >= 1024 %then %do;
 /* Authentication */

 dcl WN_NOT_AUTHENTICATED fixed bin (31) value(ERROR_NOT_AUTHENTICATED);
 dcl WN_NOT_LOGGED_ON     fixed bin (31) value (ERROR_NOT_LOGGED_ON);
 dcl WN_NOT_VALIDATED     fixed bin (31) value (ERROR_NO_LOGON_SERVERS);
 %end; /* WINVER >= 0x0400 */


 /*  For Shell */

 %if WINVER >= 1024 %then %do;
 define structure
   1 NETCONNECTINFOSTRUCT,
     2 cbStructure   type DWORD,
     2 dwFlags       type DWORD,
     2 dwSpeed       type DWORD,
     2 dwDelay       type DWORD,
     2 dwOptDataSize type DWORD;
 define alias LPNETCONNECTINFOSTRUCT handle NETCONNECTINFOSTRUCT;

 dcl WNCON_FORNETCARD type DWORD value('00000001'xu);
 dcl WNCON_NOTROUTED  type DWORD value('00000002'xu);
 dcl WNCON_SLOWLINK   type DWORD value('00000004'xu);
 dcl WNCON_DYNAMIC    type DWORD value('00000008'xu);

 dcl MultinetGetConnectionPerformanceA
     entry (type NETRESOURCEA byaddr,
            type NETCONNECTINFOSTRUCT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('MultinetGetConnectionPerformanceA');
 dcl MultinetGetConnectionPerformanceW
     entry (type NETRESOURCEW byaddr,
            type NETCONNECTINFOSTRUCT byaddr)
     returns (type DWORD byvalue optional)
     APIENTRY external('MultinetGetConnectionPerformanceW');
 %dcl MultinetGetConnectionPerformance char ext;
 %if UNICODE ^= '' %then %do;
 %MultinetGetConnectionPerformance='MultinetGetConnectionPerformanceW';
 %end; %else %do;
 %MultinetGetConnectionPerformance='MultinetGetConnectionPerformanceA';
 %end; /* !UNICODE */
 %end; /* WINVER >= 0x0400 */

 %end; /* _WINNETWK_ */

