 /*********************************************************************/
 /*                                                                   */
 /* commctrl.cpy - - Interface for the Windows Common Controls        */
 /*                                                                   */
 /* Version 1.2                                                       */
 /*                                                                   */
 /* Copyright 1991-1999, Microsoft Corp.      All rights reserved.    */
 /*                                                                   */
 /*********************************************************************/


 %dcl #INC_COMMCTRL char ext;
 %if #INC_COMMCTRL = '' %then %do;
 %#INC_COMMCTRL = 'Y';

 %dcl #WIN32_IE    fixed ext;
 %dcl #WIN32_WINNT fixed ext;
 %dcl WINVER       fixed ext;
 %dcl #WIN32       char ext;
 %if #WIN32 = '' %then %#WIN32 = 'Y'; /* always */
 %dcl #WIN64       char ext;
 %dcl UNICODE      char ext;

 %if #WIN32_IE = 0 %then %do;
  %#WIN32_IE = 1281;
 %end; %else %do;
  %if #WIN32_IE < 1024 & #WIN32_WINNT >= 1280 %then %do;
   %note ('Error: #WIN32_IE conflicts with #WIN32_WINNT setting', 8);
  %end;
 %end;

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
   %include winuser;
 %end;


 %dcl #HRESULT_DEFINED char ext;
 %if #HRESULT_DEFINED = '' %then %do;
 %#HRESULT_DEFINED = 'Y';
 define alias HRESULT type LONG;
 %end; /* _HRESULT_DEFINED */

 %dcl NOUSER char ext;
 %if NOUSER = '' %then %do;

 /* Define API decoration for direct importing of DLL references. */
 %dcl WINCOMMCTRLAPI char ext;
 %WINCOMMCTRLAPI = '';

 /*===================================================================*/
 /* Users of this header may define any number of these constants to  */
 /* avoid the definitions of each functional group.                   */
 /*                                                                   */
 /*    NOTOOLBAR    Customizable bitmap-button toolbar control.       */
 /*    NOUPDOWN     Up and Down arrow increment/decrement control.    */
 /*    NOSTATUSBAR  Status bar control.                               */
 /*    NOMENUHELP   APIs to help manage menus, especially with a      */
 /*                 status bar.                                       */
 /*    NOTRACKBAR   Customizable column-width tracking control.       */
 /*    NODRAGLIST   APIs to make a listbox source and sink drag&drop  */
 /*                 actions.                                          */
 /*    NOPROGRESS   Progress gas gauge.                               */
 /*    NOHOTKEY     HotKey control                                    */
 /*    NOHEADER     Header bar control.                               */
 /*    NOIMAGEAPIS  ImageList apis.                                   */
 /*    NOLISTVIEW   ListView control.                                 */
 /*    NOTREEVIEW   TreeView control.                                 */
 /*    NOTABCONTROL Tab control.                                      */
 /*    NOANIMATE    Animate control.                                  */
 /*    NOBUTTON     Button control.                                   */
 /*    NOSTATIC     Static control.                                   */
 /*    NOEDIT       Edit control.                                     */
 /*    NOLISTBOX    Listbox control.                                  */
 /*    NOCOMBOBOX   Combobox control.                                 */
 /*    NOSCROLLBAR  Scrollbar control.                                */
 /*                                                                   */
 /*===================================================================*/

 %dcl #PRSHT_H_ char ext;
 %if #PRSHT_H_ = '' %then %do;
 %include prsht;
 %end;

 %dcl SNDMSG char ext;
 %if SNDMSG = '' %then %do;
 %SNDMSG='SendMessage';
 %end; /* ifndef SNDMSG */

 dcl InitCommonControls
     entry ()
     WINCOMMCTRLAPI WINAPI external('InitCommonControls');


 %if #WIN32_IE >= 768 %then %do;
 define structure
   1 INITCOMMONCONTROLSEX,
     2 dwSize type DWORD,/* size of this structure */
     2 dwICC  type DWORD;
       /* flags indicating which classes to be initialized */
 define alias LPINITCOMMONCONTROLSEX handle INITCOMMONCONTROLSEX;

 dcl ICC_LISTVIEW_CLASSES   type DWORD value('00000001'xu);
     /* listview, header */
 dcl ICC_TREEVIEW_CLASSES   type DWORD value('00000002'xu);
     /* treeview, tooltips */
 dcl ICC_BAR_CLASSES        type DWORD value('00000004'xu);
     /* toolbar, statusbar, trackbar, tooltips */
 dcl ICC_TAB_CLASSES        type DWORD value('00000008'xu);
     /* tab, tooltips */
 dcl ICC_UPDOWN_CLASS       type DWORD value('00000010'xu);
     /* updown */
 dcl ICC_PROGRESS_CLASS     type DWORD value('00000020'xu);
     /* progress */
 dcl ICC_HOTKEY_CLASS       type DWORD value('00000040'xu);
     /* hotkey */
 dcl ICC_ANIMATE_CLASS      type DWORD value('00000080'xu);
     /* animate */
 dcl ICC_WIN95_CLASSES      type DWORD value('000000FF'xu);
 dcl ICC_DATE_CLASSES       type DWORD value('00000100'xu);
     /* month picker, date picker, time picker, updown */
 dcl ICC_USEREX_CLASSES     type DWORD value('00000200'xu);
     /* comboex */
 dcl ICC_COOL_CLASSES       type DWORD value('00000400'xu);
     /* rebar (coolbar) control */

 %if #WIN32_IE >= 1024 %then %do;
 dcl ICC_INTERNET_CLASSES   type DWORD value('00000800'xu);
 dcl ICC_PAGESCROLLER_CLASS type DWORD value('00001000'xu);
     /* page scroller */
 dcl ICC_NATIVEFNTCTL_CLASS type DWORD value('00002000'xu);
     /* native font control */
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl ICC_STANDARD_CLASSES   type DWORD value('00004000'xu);
 dcl ICC_LINK_CLASS         type DWORD value('00008000'xu);
 %end;

 dcl InitCommonControlsEx
     entry (type INITCOMMONCONTROLSEX byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('InitCommonControlsEx');
 %end; /* _WIN32_IE >= 0x0300 */

 dcl ODT_HEADER   fixed bin(31) value(100);
 dcl ODT_TAB      fixed bin(31) value(101);
 dcl ODT_LISTVIEW fixed bin(31) value(102);


 /* ====== Ranges for control message IDs =========================== */

 dcl LVM_FIRST  fixed bin(31) value('1000'xn);
     /* ListView messages */
 dcl TV_FIRST   fixed bin(31) value('1100'xn);
     /* TreeView messages */
 dcl HDM_FIRST  fixed bin(31) value('1200'xn);
     /* Header messages */
 dcl TCM_FIRST  fixed bin(31) value('1300'xn);
     /* Tab control messages */


 %if #WIN32_IE >= 1024 %then %do;
 dcl PGM_FIRST fixed bin(31) value('1400'xn);
     /* Pager control messages */
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl ECM_FIRST fixed bin(31) value('1500'xn);
     /* Edit control messages  */
 dcl BCM_FIRST fixed bin(31) value('1600'xn);
     /* Button control messages */
 dcl CBM_FIRST fixed bin(31) value('1700'xn);
     /* Combobox control messages */
 %end;
 dcl CCM_FIRST fixed bin(31) value('2000'xn);
     /* Common control shared messages */
 dcl CCM_LAST  fixed bin(31) value(CCM_FIRST + '200'xn);

 dcl CCM_SETBKCOLOR fixed bin(31) value(CCM_FIRST + 1);
     /* lParam is bkColor */

 define structure
   1 COLORSCHEME,
     2 dwSize          type DWORD,
     2 clrBtnHighlight type COLORREF,/* highlight color */
     2 clrBtnShadow    type COLORREF;/* shadow color */
 define alias LPCOLORSCHEME handle COLORSCHEME;

 dcl CCM_SETCOLORSCHEME   fixed bin(31) value(CCM_FIRST + 2);
     /* lParam is color scheme */
 dcl CCM_GETCOLORSCHEME   fixed bin(31) value(CCM_FIRST + 3);
     /* fills in COLORSCHEME pointed to by lParam */
 dcl CCM_GETDROPTARGET    fixed bin(31) value(CCM_FIRST + 4);
 dcl CCM_SETUNICODEFORMAT fixed bin(31) value(CCM_FIRST + 5);
 dcl CCM_GETUNICODEFORMAT fixed bin(31) value(CCM_FIRST + 6);

 %if #WIN32_IE >= 1280 %then %do;
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl COMCTL32_VERSION     fixed bin (31) value(6);
 %end; %else %do;
 dcl COMCTL32_VERSION     fixed bin (31) value(5);
 %end;
 dcl CCM_SETVERSION       fixed bin (31) value(CCM_FIRST + 7);
 dcl CCM_GETVERSION       fixed bin (31) value(CCM_FIRST + 8);
 dcl CCM_SETNOTIFYWINDOW  fixed bin (31) value(CCM_FIRST + 9);
     /* wParam == hwndParent. */
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl CCM_SETWINDOWTHEME   fixed bin (31) value(CCM_FIRST + '0b'xn);
 dcl CCM_DPISCALE         fixed bin (31) value(CCM_FIRST + '0c'xn);
     /* wParam == Awareness */
 %end;
 %end; /* (_WIN32_IE >= 0x0500) */

 %end; /* (_WIN32_IE >= 0x0400) */


 %if #WIN32_IE >= 1024 %then %do;
 /* for tooltips */
 dcl INFOTIPSIZE          fixed bin(31) value(1024);
 %end;

 /* ====== WM_NOTIFY Macros ========================================= */

 /* dcl Cls_OnNotify entry (type HWND, fixed bin (31),       */
 /*                         type NMHDR byaddr)               */
 /*                  returns (type LRESULT optional byvalue) */

 HANDLE_WM_NOTIFY: proc (hwnd, wParam, lParam, fn)
                   returns (type LRESULT optional byvalue)
                   options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       wParam type WPARAM byvalue,
       lParam type LPARAM byvalue,
       fn     entry (type HWND byvalue, fixed bin (31) byvalue,
                     type NMHDR byaddr)
              returns (type LRESULT optional byvalue);
   dcl (isigned, ptrvalue, type) builtin;
   return (fn (hwnd, isigned (wParam),
               type (bind (: NMHDR, ptrvalue (lParam) :) )));
 end HANDLE_WM_NOTIFY;

 FORWARD_WM_NOTIFY: proc (hwnd, idFrom, pnmhdr, fn)
                    returns (type LRESULT optional byvalue)
                    options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       idFrom fixed bin(31) byvalue,
       pnmhdr type NMHDR byaddr, /* (may be derived message)   */
       fn     type WNDPROC;      /* SendMessage or PostMessage */
   dcl (addr, binvalue, iunsigned) builtin;
   return (fn (hwnd, WM_NOTIFY, iunsigned (idFrom),
                                binvalue (addr (pnmhdr))));
 end FORWARD_WM_NOTIFY;

 /* ====== Generic WM_NOTIFY notification codes ===================== */

 dcl NM_FIRST   fixed bin(31) value(0-  0); /* generic to all */
 dcl NM_LAST    fixed bin(31) value(0- 99); /* controls */

 dcl NM_OUTOFMEMORY     fixed bin(31) value(NM_FIRST-1);
 dcl NM_CLICK           fixed bin(31) value(NM_FIRST-2);
     /* uses NMCLICK struct */
 dcl NM_DBLCLK          fixed bin(31) value(NM_FIRST-3);
 dcl NM_RETURN          fixed bin(31) value(NM_FIRST-4);
 dcl NM_RCLICK          fixed bin(31) value(NM_FIRST-5);
     /* uses NMCLICK struct */
 dcl NM_RDBLCLK         fixed bin(31) value(NM_FIRST-6);
 dcl NM_SETFOCUS        fixed bin(31) value(NM_FIRST-7);
 dcl NM_KILLFOCUS       fixed bin(31) value(NM_FIRST-8);

 %if #WIN32_IE >= 768 %then %do;
 dcl NM_CUSTOMDRAW      fixed bin(31) value(NM_FIRST-12);
 dcl NM_HOVER           fixed bin(31) value(NM_FIRST-13);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl NM_NCHITTEST       fixed bin(31) value(NM_FIRST-14);
     /* uses NMMOUSE struct */
 dcl NM_KEYDOWN         fixed bin(31) value(NM_FIRST-15);
     /* uses NMKEY struct */
 dcl NM_RELEASEDCAPTURE fixed bin(31) value(NM_FIRST-16);
 dcl NM_SETCURSOR       fixed bin(31) value(NM_FIRST-17);
     /* uses NMMOUSE struct */
 dcl NM_CHAR            fixed bin(31) value(NM_FIRST-18);
     /* uses NMCHAR struct */
 %end;
 %if #WIN32_IE >= 1025 %then %do;
 dcl NM_TOOLTIPSCREATED fixed bin(31) value(NM_FIRST-19);
     /* notify of when the tooltips window is createD */
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl NM_LDOWN           fixed bin(31) value(NM_FIRST-20);
 dcl NM_RDOWN           fixed bin(31) value(NM_FIRST-21);
 dcl NM_THEMECHANGED    fixed bin(31) value(NM_FIRST-22);
 %end;

 /* CCSIZEOF_STRUCT is declared in prsht.cpy, which we included */

 %if #WIN32_IE >= 1025 %then %do;
 define structure
   1 NMTOOLTIPSCREATED unaligned,
     2 hdr          type NMHDR,
     2 hwndToolTips type HWND;
 define alias LPNMTOOLTIPSCREATED handle NMTOOLTIPSCREATED;
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 /* ====== Generic WM_NOTIFY notification structures ================ */

 define structure
   1 NMMOUSE unaligned,
     2 hdr        type NMHDR,
     2 dwItemSpec type DWORD_PTR,
     2 dwItemData type DWORD_PTR,
     2 pt         type POINT,
     2 dwHitInfo  type DWORD;
     /* any specifics about where on the item or control the mouse is */
 define alias LPNMMOUSE handle NMMOUSE;
 define alias   NMCLICK type   NMMOUSE;
 define alias LPNMCLICK type LPNMMOUSE;

 /* Generic structure to request an object of a specific type. */

 define structure
   1 NMOBJECTNOTIFY unaligned,
     2 hdr   type NMHDR,
     2 iItem fixed bin(31),
 %dcl #_IID_DEFINED__ char ext;
 %if #_IID_DEFINED__ ^= '' %then %do;
     2 piid handle IID,
 %end; %else %do;
     2 piid pointer,
 %end;
     2 pObject pointer,
     2 hResult type HRESULT,
     2 dwFlags type DWORD;
       /* control specific flags (hints as to where in iItem it hit) */
 define alias LPNMOBJECTNOTIFY handle NMOBJECTNOTIFY;

 /* Generic structure for a key */

 define structure
   1 NMKEY unaligned,
     2 hdr    type NMHDR,
     2 nVKey  type UINT,
     2 uFlags type UINT;
 define alias LPNMKEY handle NMKEY;

 /* Generic structure for a character */

 define structure
   1 NMCHAR unaligned,
     2 hdr        type NMHDR,
     2 ch         type UINT,
     2 dwItemPrev type DWORD,/* Item previously selected */
     2 dwItemNext type DWORD;/* Item to be selected */
 define alias LPNMCHAR handle NMCHAR;

 %end; /* _WIN32_IE >= 0x0400 */

 /* ====== WM_NOTIFY codes (NMHDR.code values) ====================== */

 /* for NM_FIRST and NM_LAST see above */   /* generic to all controls*/

 dcl LVN_FIRST  fixed bin(31) value(0-100); /* listview */
 dcl LVN_LAST   fixed bin(31) value(0-199);

 dcl HDN_FIRST  fixed bin(31) value(0-300); /* header */
 dcl HDN_LAST   fixed bin(31) value(0-399);

 dcl TVN_FIRST  fixed bin(31) value(0-400); /* treeview */
 dcl TVN_LAST   fixed bin(31) value(0-499);

 dcl TTN_FIRST  fixed bin(31) value(0-520); /* tooltips */
 dcl TTN_LAST   fixed bin(31) value(0-549);

 dcl TCN_FIRST  fixed bin(31) value(0-550); /* tab control */
 dcl TCN_LAST   fixed bin(31) value(0-580);

 /* Shell reserved               (0-580) -  (0-589) */

 /* CDN_FIRST anfd CDN_LAST declared in CommDlg.cpy */
 /* dcl CDN_FIRST  fixed bin(31) value(0-601) -- common dialog (new) */
 /* dcl CDN_LAST   fixed bin(31) value(0-699)                        */

 dcl TBN_FIRST  fixed bin(31) value(0-700); /* toolbar */
 dcl TBN_LAST   fixed bin(31) value(0-720);

 dcl UDN_FIRST  fixed bin(31) value(0-721); /* updown */
 dcl UDN_LAST   fixed bin(31) value(0-740);

 %if #WIN32_IE >= 768 %then %do;
 dcl MCN_FIRST  fixed bin(31) value(0-750); /* monthcal */
 dcl MCN_LAST   fixed bin(31) value(0-759);

 dcl DTN_FIRST  fixed bin(31) value(0-760); /* datetimepick */
 dcl DTN_LAST   fixed bin(31) value(0-799);

 dcl CBEN_FIRST fixed bin(31) value(0-800); /* combo box ex */
 dcl CBEN_LAST  fixed bin(31) value(0-830);

 dcl RBN_FIRST  fixed bin(31) value(0-831); /* rebar */
 dcl RBN_LAST   fixed bin(31) value(0-859);
 %end;


 %if #WIN32_IE >= 1024 %then %do;
 dcl IPN_FIRST  fixed bin(31) value(0-860); /* internet address */
 dcl IPN_LAST   fixed bin(31) value(0-879);

 dcl SBN_FIRST  fixed bin(31) value(0-880); /* status bar */
 dcl SBN_LAST   fixed bin(31) value(0-899);

 dcl PGN_FIRST  fixed bin(31) value(0-900); /* Pager Control */
 dcl PGN_LAST   fixed bin(31) value(0-950);

 %end;

 %if #WIN32_IE >= 1280 %then %do;
 %dcl #WMN_FIRST char ext;
 %if #WMN_FIRST = '' %then %do;
 %#WMN_FIRST = 'Y';
 dcl WMN_FIRST  fixed bin(31) value(0-1000);
 dcl WMN_LAST   fixed bin(31) value(0-1200);
 %end;
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl BCN_FIRST  fixed bin(31) value(0-1250);
 dcl BCN_LAST   fixed bin(31) value(0-1350);
 %end;


 dcl MSGF_COMMCTRL_BEGINDRAG   fixed bin(31) value('4200'xn);
 dcl MSGF_COMMCTRL_SIZEHEADER  fixed bin(31) value('4201'xn);
 dcl MSGF_COMMCTRL_DRAGSELECT  fixed bin(31) value('4202'xn);
 dcl MSGF_COMMCTRL_TOOLBARCUST fixed bin(31) value('4203'xn);


 %if #WIN32_IE >= 768 %then %do;
 /* ==================== CUSTOM DRAW ================================ */


 /* custom draw return flags */
 /* values under 0x00010000 are reserved for global custom draw  */
 /* values above that are for specific controls */
 dcl CDRF_DODEFAULT          type DWORD value('00000000'xu);
 dcl CDRF_NEWFONT            type DWORD value('00000002'xu);
 dcl CDRF_SKIPDEFAULT        type DWORD value('00000004'xu);


 dcl CDRF_NOTIFYPOSTPAINT    type DWORD value('00000010'xu);
 dcl CDRF_NOTIFYITEMDRAW     type DWORD value('00000020'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl CDRF_NOTIFYSUBITEMDRAW  type DWORD value('00000020'xu);
    /* flags are the same, we can distinguish by context */
 %end;
 dcl CDRF_NOTIFYPOSTERASE    type DWORD value('00000040'xu);

 /* drawstage flags */
 /* values under 0x00010000 are reserved for global custom draw */
 /* values above that are for specific controls */
 dcl CDDS_PREPAINT           type DWORD value('00000001'xu);
 dcl CDDS_POSTPAINT          type DWORD value('00000002'xu);
 dcl CDDS_PREERASE           type DWORD value('00000003'xu);
 dcl CDDS_POSTERASE          type DWORD value('00000004'xu);
     /* the 0x000010000 bit means it's individual item specific */
 dcl CDDS_ITEM               type DWORD value('00010000'xu);
 dcl CDDS_ITEMPREPAINT       type DWORD
     value(ior (CDDS_ITEM, CDDS_PREPAINT));
 dcl CDDS_ITEMPOSTPAINT      type DWORD
     value(ior (CDDS_ITEM, CDDS_POSTPAINT));
 dcl CDDS_ITEMPREERASE       type DWORD
     value(ior (CDDS_ITEM, CDDS_PREERASE));
 dcl CDDS_ITEMPOSTERASE      type DWORD
     value(ior (CDDS_ITEM, CDDS_POSTERASE));
 %if #WIN32_IE >= 1024 %then %do;
 dcl CDDS_SUBITEM            type DWORD value('00020000'xu);
 %end;


 /* itemState flags */
 dcl CDIS_SELECTED           type UINT value('0001'xu);
 dcl CDIS_GRAYED             type UINT value('0002'xu);
 dcl CDIS_DISABLED           type UINT value('0004'xu);
 dcl CDIS_CHECKED            type UINT value('0008'xu);
 dcl CDIS_FOCUS              type UINT value('0010'xu);
 dcl CDIS_DEFAULT            type UINT value('0020'xu);
 dcl CDIS_HOT                type UINT value('0040'xu);
 dcl CDIS_MARKED             type UINT value('0080'xu);
 dcl CDIS_INDETERMINATE      type UINT value('0100'xu);
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl CDIS_SHOWKEYBOARDCUES   type UINT value('0200'xu);
 %end;

 define structure
   1 NMCUSTOMDRAWINFO unaligned,
     2 hdr         type NMHDR,
     2 dwDrawStage type DWORD,
     2 hdc         type HDC,
     2 rc          type RECT,
     2 dwItemSpec  type DWORD_PTR,/* this is control specific, but it */
       /* is how to specify an item. valid only with CDDS_ITEM bit set*/
     2 uItemState  type UINT,
     2 lItemlParam type LPARAM;
 define alias   NMCUSTOMDRAW type   NMCUSTOMDRAWINFO;
 define alias LPNMCUSTOMDRAW handle NMCUSTOMDRAWINFO;


 define structure
   1 NMTTCUSTOMDRAW,
     2 nmcd       type NMCUSTOMDRAW,
     2 uDrawFlags type UINT;
 define alias LPNMTTCUSTOMDRAW handle NMTTCUSTOMDRAW;

 %end; /* _WIN32_IE >= 0x0300 */


 /* ====== IMAGE APIS =============================================== */

 %dcl NOIMAGEAPIS char ext;
 %if NOIMAGEAPIS = '' %then %do;

 dcl CLR_NONE    type COLORREF value('FFFFFFFF'xu);
 dcl CLR_DEFAULT type COLORREF value('FF000000'xu);

 define alias HIMAGELIST pointer;


 %if #WIN32_IE >= 768 %then %do;
 define structure
   1 IMAGELISTDRAWPARAMS,
     2 cbSize  type DWORD,
     2 himl    type HIMAGELIST,
     2 i       fixed bin(31),
     2 hdcDst  type HDC,
     2 x       fixed bin(31),
     2 y       fixed bin(31),
     2 cx      fixed bin(31),
     2 cy      fixed bin(31),
     2 xBitmap fixed bin(31),/* x offest from the upperleft of bitmap */
     2 yBitmap fixed bin(31),/* y offset from the upperleft of bitmap */
     2 rgbBk   type COLORREF,
     2 rgbFg   type COLORREF,
     2 fStyle  type UINT,
     2 dwRop   type DWORD
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 fState  type DWORD,
     2 Frame   type DWORD,
     2 crEffect type COLORREF
 %end;
     ;
 define alias LPIMAGELISTDRAWPARAMS handle IMAGELISTDRAWPARAMS;
 %end; /* _WIN32_IE >= 0x0300 */

 dcl ILC_MASK     type UINT value('00000001'xu);
 dcl ILC_COLOR    type UINT value('00000000'xu);
 dcl ILC_COLORDDB type UINT value('000000FE'xu);
 dcl ILC_COLOR4   type UINT value('00000004'xu);
 dcl ILC_COLOR8   type UINT value('00000008'xu);
 dcl ILC_COLOR16  type UINT value('00000010'xu);
 dcl ILC_COLOR24  type UINT value('00000018'xu);
 dcl ILC_COLOR32  type UINT value('00000020'xu);
 dcl ILC_PALETTE  type UINT value('00000800'xu); /* (not implemented) */
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl ILC_MIRROR        type UINT value('00002000'xu);
     /* Mirror the icons contained, if the process is mirrored */
 dcl ILC_PERITEMMIRROR type UINT value('00008000'xu);
     /* Causes the mirroring code to mirror each item when */
     /* inserting a set of images, verses the whole strip  */
 %end;	

 dcl ImageList_Create
     entry (fixed bin(31),
            fixed bin(31),
            type UINT,
            fixed bin(31),
            fixed bin(31))
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Create');

 dcl ImageList_Destroy
     entry (type HIMAGELIST )
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Destroy');

 dcl ImageList_GetImageCount
     entry (type HIMAGELIST )
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_GetImageCount');

 %if #WIN32_IE >= 768 %then %do;
 dcl ImageList_SetImageCount
     entry (type HIMAGELIST,
            type UINT)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_SetImageCount');
 %end;

 dcl ImageList_Add
     entry (type HIMAGELIST,
            type HBITMAP,
            type HBITMAP)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Add');

 dcl ImageList_ReplaceIcon
     entry (type HIMAGELIST,
            fixed bin(31),
            type HICON)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_ReplaceIcon');

 dcl ImageList_SetBkColor
     entry (type HIMAGELIST,
            type COLORREF)
     returns (type COLORREF byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_SetBkColor');

 dcl ImageList_GetBkColor
     entry (type HIMAGELIST )
     returns (type COLORREF byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_GetBkColor');

 dcl ImageList_SetOverlayImage
     entry (type HIMAGELIST,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_SetOverlayImage');

 ImageList_AddIcon: proc (himl, hicon)
                    returns (fixed bin(31) byvalue optional)
                    options (inline reorder) internal;
   dcl himl  type HIMAGELIST byvalue,
       hicon type HICON byvalue;
  return (ImageList_ReplaceIcon (himl, -1, hicon));
 end ImageList_AddIcon;


 dcl ILD_NORMAL      type UINT value('0000'xu);
 dcl ILD_TRANSPARENT type UINT value('0001'xu);
 dcl ILD_MASK        type UINT value('0010'xu);
 dcl ILD_IMAGE       type UINT value('0020'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl ILD_ROP         type UINT value('0040'xu);
 %end;
 dcl ILD_BLEND25     type UINT value('0002'xu);
 dcl ILD_BLEND50     type UINT value('0004'xu);
 dcl ILD_OVERLAYMASK type UINT value('0F00'xu);

 INDEXTOOVERLAYMASK: proc (i) returns (type UINT byvalue)
                     options (inline reorder) internal;
   dcl i type UINT byvalue;
   dcl raise2 builtin;
   return (raise2 (i, 8));
 end INDEXTOOVERLAYMASK;


 dcl ILD_SELECTED    type UINT value(ILD_BLEND50);
 dcl ILD_FOCUS       type UINT value(ILD_BLEND25);
 dcl ILD_BLEND       type UINT value(ILD_BLEND50);
 dcl CLR_HILIGHT     type UINT value(CLR_DEFAULT);

 dcl ImageList_Draw
     entry (type HIMAGELIST,
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Draw');

 %if #WIN32 ^= '' %then %do;

 dcl ImageList_Replace
     entry (type HIMAGELIST,
            fixed bin(31),
            type HBITMAP,
            type HBITMAP)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Replace');

 dcl ImageList_AddMasked
     entry (type HIMAGELIST,
            type HBITMAP,
            type COLORREF)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_AddMasked');

 dcl ImageList_DrawEx
     entry (type HIMAGELIST,
            fixed bin(31),
            type HDC,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type COLORREF,
            type COLORREF,
            type UINT)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_DrawEx');

 %if #WIN32_IE >= 768 %then %do;
 dcl ImageList_DrawIndirect
     entry (type IMAGELISTDRAWPARAMS byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_DrawIndirect');
 %end;

 dcl ImageList_Remove
     entry (type HIMAGELIST,
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Remove');

 dcl ImageList_GetIcon
     entry (type HIMAGELIST,
            fixed bin(31),
            type UINT)
     returns (type HICON byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_GetIcon');

 dcl ImageList_LoadImageA
     entry (type HINSTANCE,
            char (*) varz byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            type COLORREF,
            type UINT,
            type UINT)
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_LoadImageA');

 dcl ImageList_LoadImageW
     entry (type HINSTANCE,
            WCHAR (*) varz byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            type COLORREF,
            type UINT,
            type UINT)
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_LoadImageW');

 %dcl ImageList_LoadImage char ext;
 %if UNICODE ^= '' %then %do;
   %ImageList_LoadImage='ImageList_LoadImageW';
 %end; %else %do;
   %ImageList_LoadImage='ImageList_LoadImageA';
 %end;


 %if #WIN32_IE >= 768 %then %do;
 dcl ILCF_MOVE type UINT value('00000000'xu);
 dcl ILCF_SWAP type UINT value('00000001'xu);

 dcl ImageList_Copy
     entry (type HIMAGELIST,
            fixed bin(31),
            type HIMAGELIST,
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Copy');
 %end;

 dcl ImageList_BeginDrag
     entry (type HIMAGELIST,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_BeginDrag');

 dcl ImageList_EndDrag
     entry ( )
     WINCOMMCTRLAPI WINAPI external('ImageList_EndDrag');

 dcl ImageList_DragEnter
     entry (type HWND,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_DragEnter');

 dcl ImageList_DragLeave
     entry (type HWND )
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_DragLeave');

 dcl ImageList_DragMove
     entry (fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_DragMove');

 dcl ImageList_SetDragCursorImage
     entry (type HIMAGELIST,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_SetDragCursorImage');

 dcl ImageList_DragShowNolock
     entry (type BOOL )
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_DragShowNolock');

 dcl ImageList_GetDragImage
     entry (type POINT byaddr optional,
            type POINT byaddr optional)
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_GetDragImage');

 ImageList_RemoveAll: proc (himl)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl himl type HIMAGELIST byvalue;
   return (ImageList_Remove (himl, -1));
 end ImageList_RemoveAll;

 ImageList_ExtractIcon: proc (hi, himl, i)
                        returns (type HICON byvalue optional)
                        options (inline reorder) internal;
   dcl hi   type HINSTANCE byvalue,
       himl type HIMAGELIST byvalue,
       i    fixed bin (31) byvalue;
   return (ImageList_GetIcon (himl, i, 0));
 end ImageList_ExtractIcon;

 ImageList_LoadBitmap: proc (hi, lpbmp, cx, cGrow, crMask)
                       returns (type HIMAGELIST byvalue optional)
                       options (inline reorder) internal;
   dcl hi     type HINSTANCE byvalue,
       lpbmp  char (*) varz byaddr nonasgn,
       cx     fixed bin(31) byvalue,
       cGrow  fixed bin(31) byvalue,
       crMask type COLORREF;
   return (ImageList_LoadImage (hi, lpbmp, cx, cGrow, crMask,
                                IMAGE_BITMAP, 0));
 end ImageList_LoadBitmap;

 %dcl #_IStream_INTERFACE_DEFINED__ char ext;
 %if #_IStream_INTERFACE_DEFINED__ ^= '' %then %do;

 dcl ImageList_Read
     entry (type LPSTREAM)
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Read');

 dcl ImageList_Write
     entry (type HIMAGELIST,
            type LPSTREAM)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Write');
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl ILP_NORMAL       type DWORD value(0);
     /* Writes or reads the stream using new semantics */
     /*  for this version of comctl32                  */
 dcl ILP_DOWNLEVEL    type DWORD value(1);
     /* Write or reads the stream using downlevel semantics. */

 dcl ImageList_ReadEx
     entry (type DWORD,
            type LPSTREAM,
            type REFIID,
            type PVOID byaddr)
     returns (type HRESULT byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_ReadEx');

 dcl ImageList_WriteEx
     entry (type HIMAGELIST,
            type DWORD,
            type LPSTREAM)
     returns (type HRESULT byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_WriteEx');
 %end;
 %end;

 define structure
   1 IMAGEINFO,
     2 hbmImage type HBITMAP,
     2 hbmMask  type HBITMAP,
     2 Unused1  fixed bin(31),
     2 Unused2  fixed bin(31),
     2 rcImage  type RECT;
 define alias LPIMAGEINFO handle IMAGEINFO;

 dcl ImageList_GetIconSize
     entry (type HIMAGELIST,
            fixed bin(31) byaddr,
            fixed bin(31) byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_GetIconSize');

 dcl ImageList_SetIconSize
     entry (type HIMAGELIST,
            fixed bin(31),
            fixed bin(31))
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_SetIconSize');

 dcl ImageList_GetImageInfo
     entry (type HIMAGELIST,
            fixed bin(31),
            type IMAGEINFO byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_GetImageInfo');

 dcl ImageList_Merge
     entry (type HIMAGELIST,
            fixed bin(31),
            type HIMAGELIST,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Merge');

 %if #WIN32_IE >= 1024 %then %do;
 dcl ImageList_Duplicate
     entry (type HIMAGELIST)
     returns (type HIMAGELIST byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_Duplicate');
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 dcl ImageList_SetFlags
     entry (type HIMAGELIST,
            type UINT)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ImageList_SetFlags');
 %end;

 %end;

 %end;


 /* ====== HEADER CONTROL =========================================== */

 %dcl NOHEADER char ext;
 %if NOHEADER = '' %then %do;

 %if #WIN32 ^= '' %then %do;
 dcl WC_HEADERA char  value('SysHeader32');
 dcl WC_HEADERW WCHAR value('SysHeader32');

 %dcl WC_HEADER char ext;
 %if UNICODE ^= '' %then %do;
 %WC_HEADER='WC_HEADERW';
 %end; %else %do;
 %WC_HEADER='WC_HEADERA';
 %end;

 %end; %else %do;
 dcl WC_HEADER char value('SysHeader');
 %end;

 /* begin_r_commctrl */

 dcl HDS_HORZ      fixed bin(31) value('0000'xn);
 dcl HDS_BUTTONS   fixed bin(31) value('0002'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl HDS_HOTTRACK  fixed bin(31) value('0004'xn);
 %end;
 dcl HDS_HIDDEN    fixed bin(31) value('0008'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl HDS_DRAGDROP  fixed bin(31) value('0040'xn);
 dcl HDS_FULLDRAG  fixed bin(31) value('0080'xn);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl HDS_FILTERBAR fixed bin(31) value('0100'xn);
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl HDS_FLAT      fixed bin(31) value('0200'xn);
 %end;
 /* end_r_commctrl */

 %if #WIN32_IE >= 1280 %then %do;

 dcl HDFT_ISSTRING    type UINT value('0000'xu);
     /* HD_ITEM.pvFilter points to a HD_TEXTFILTER */
 dcl HDFT_ISNUMBER    type UINT value('0001'xu);
     /* HD_ITEM.pvFilter points to a INT */

 dcl HDFT_HASNOVALUE  type UINT value('8000'xu);
     /* clear the filter, by setting this bit */


 define structure
   1 HD_TEXTFILTERA,
     2 pszText    type LPSTR,
       /* [in] pointer to the buffer containing the filter (ANSI) */
     2 cchTextMax type INT;
       /* [in] max size of buffer/edit control buffer */
 define alias LPHD_TEXTFILTERA type HD_TEXTFILTERA;


 define structure
   1 HD_TEXTFILTERW,
     2 pszText    type LPWSTR,
       /* [in] pointer to the buffer containing the filter (UNICODE) */
     2 cchTextMax type INT;
       /* [in] max size of buffer/edit control buffer */
 define alias LPHD_TEXTFILTERW type HD_TEXTFILTERW;

 %if UNICODE ^= '' %then %do;
 define alias   HD_TEXTFILTER type   HD_TEXTFILTERW;
 define alias   HDTEXTFILTER  type   HD_TEXTFILTERW;
 define alias LPHD_TEXTFILTER type LPHD_TEXTFILTERW;
 define alias LPHDTEXTFILTER  type LPHD_TEXTFILTERW;
 %end; %else %do;
 define alias   HD_TEXTFILTER type   HD_TEXTFILTERA;
 define alias   HDTEXTFILTER  type   HD_TEXTFILTERA;
 define alias LPHD_TEXTFILTER type LPHD_TEXTFILTERA;
 define alias LPHDTEXTFILTER  type LPHD_TEXTFILTERA;
 %end;

 %end; /* _WIN32_IE >= 0x0500 */

 define structure
   1 HD_ITEMA,
     2 mask       type UINT,
     2 cxy        fixed bin(31),
     2 pszText    type LPSTR,
     2 hbm        type HBITMAP,
     2 cchTextMax fixed bin(31),
     2 fmt        fixed bin(31),
     2 lParam     type LPARAM
 %if #WIN32_IE >= 768 %then %do;
   , 2 iImage     fixed bin(31) /* index of bitmap in ImageList */
   , 2 iOrder     fixed bin(31) /* where to draw this item */
 %end;
 %if #WIN32_IE >= 1280 %then %do;
   , 2 type       type UINT
       /*"[in] filter type (defined what pvFilter is a pointer to) */
   , 2 pvFilter   type LPVOID   /* [in] filter data see above */
 %end;
   ;
 define alias   HDITEMA type   HD_ITEMA;
 define alias LPHDITEMA handle HD_ITEMA;
 dcl HDITEMA_V1_SIZE fixed bin (31)
     value (CCSIZEOF_STRUCT (HDITEMA, lParam));

 define structure
   1 HD_ITEMW,
     2 mask       type UINT,
     2 cxy        fixed bin(31),
     2 pszText    type LPWSTR,
     2 hbm        type HBITMAP,
     2 cchTextMax fixed bin(31),
     2 fmt        fixed bin(31),
     2 lParam     type LPARAM
 %if #WIN32_IE >= 768 %then %do;
   , 2 iImage     fixed bin(31) /* index of bitmap in ImageList */
   , 2 iOrder     fixed bin(31)
 %end;
 %if #WIN32_IE >= 1280 %then %do;
   , 2 type       type UINT
       /*[in] filter type (defined what pvFilter is a pointer to) */
   , 2 pvFilter   type LPVOID   /* [in] filter data see above */
 %end;
   ;
 define alias   HDITEMW type   HD_ITEMW;
 define alias LPHDITEMW handle HD_ITEMW;
 dcl HDITEMW_V1_SIZE fixed bin (31)
     value (CCSIZEOF_STRUCT (HDITEMW, lParam));

 %if UNICODE ^= '' %then %do;
 define alias   HDITEM type   HDITEMW;
 define alias LPHDITEM type LPHDITEMW;
 dcl HDITEM_V1_SIZE fixed bin (31) value (HDITEMW_V1_SIZE);
 %end; %else %do;
 define alias   HDITEM type   HDITEMA;
 define alias LPHDITEM type LPHDITEMA;
 dcl HDITEM_V1_SIZE fixed bin (31) value (HDITEMA_V1_SIZE);
 %end;

 define alias HD_ITEM  type HDITEM;

 dcl HDI_WIDTH           fixed bin(31) value('0001'xn);
 dcl HDI_HEIGHT          fixed bin(31) value(HDI_WIDTH);
 dcl HDI_TEXT            fixed bin(31) value('0002'xn);
 dcl HDI_FORMAT          fixed bin(31) value('0004'xn);
 dcl HDI_LPARAM          fixed bin(31) value('0008'xn);
 dcl HDI_BITMAP          fixed bin(31) value('0010'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl HDI_IMAGE           fixed bin(31) value('0020'xn);
 dcl HDI_DI_SETITEM      fixed bin(31) value('0040'xn);
 dcl HDI_ORDER           fixed bin(31) value('0080'xn);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl HDI_FILTER          fixed bin(31) value('0100'xn);
 %end;

 dcl HDF_LEFT            fixed bin(31) value(0);
 dcl HDF_RIGHT           fixed bin(31) value(1);
 dcl HDF_CENTER          fixed bin(31) value(2);
 dcl HDF_JUSTIFYMASK     fixed bin(31) value('0003'xn);
 dcl HDF_RTLREADING      fixed bin(31) value(4);

 dcl HDF_OWNERDRAW       fixed bin(31) value('8000'xn);
 dcl HDF_STRING          fixed bin(31) value('4000'xn);
 dcl HDF_BITMAP          fixed bin(31) value('2000'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl HDF_BITMAP_ON_RIGHT fixed bin(31) value('1000'xn);
 dcl HDF_IMAGE           fixed bin(31) value('0800'xn);
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl HDF_SORTUP          fixed bin(31) value('0400'xn);
 dcl HDF_SORTDOWN        fixed bin(31) value('0200'xn);
 %end;

 dcl HDM_GETITEMCOUNT    fixed bin(31) value(HDM_FIRST + 0);
 Header_GetItemCount: proc (hwndHD)
                      returns (fixed bin(31) byvalue)
                      options (inline reorder) internal;
   dcl hwndHD type HWND byvalue;
   return (SNDMSG (hwndHD, HDM_GETITEMCOUNT, 0, 0));
 end Header_GetItemCount;

 dcl HDM_INSERTITEMA fixed bin(31) value(HDM_FIRST + 1);
 dcl HDM_INSERTITEMW fixed bin(31) value(HDM_FIRST + 10);

 %if UNICODE ^= '' %then %do;
 dcl HDM_INSERTITEM  fixed bin(31) value(HDM_INSERTITEMW);
 %end; %else %do;
 dcl HDM_INSERTITEM  fixed bin(31) value(HDM_INSERTITEMA);
 %end;

 Header_InsertItem: proc (hwndHD, i, phdi)
                    returns (fixed bin (31) byvalue optional)
                    options (inline reorder) internal;
   dcl hwndHD type HWND byvalue,
       i      fixed bin(31) byvalue,
       phdi   type HD_ITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndHD, HDM_INSERTITEM, i, binvalue (addr (phdi))));
 end Header_InsertItem;

 dcl HDM_DELETEITEM fixed bin(31) value(HDM_FIRST + 2);

 Header_DeleteItem: proc (hwndHD, i)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hwndHD type HWND byvalue,
       i      fixed bin(31) byvalue;
   return (SNDMSG (hwndHD, HDM_DELETEITEM,i, 0));
 end Header_DeleteItem;

 dcl HDM_GETITEMA fixed bin(31) value(HDM_FIRST + 3);
 dcl HDM_GETITEMW fixed bin(31) value(HDM_FIRST + 11);

 %if UNICODE ^= '' %then %do;
 dcl HDM_GETITEM  fixed bin(31) value(HDM_GETITEMW);
 %end; %else %do;
 dcl HDM_GETITEM  fixed bin(31) value(HDM_GETITEMA);
 %end;

 Header_GetItem: proc (hwndHD, i, phdi)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwndHD type HWND byvalue,
       i      fixed bin(31) byvalue,
       phdi   type HD_ITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndHD, HDM_GETITEM, i, binvalue (addr (phdi))));
 end Header_GetItem;

 dcl HDM_SETITEMA  fixed bin(31) value(HDM_FIRST + 4);
 dcl HDM_SETITEMW  fixed bin(31) value(HDM_FIRST + 12);

 %if UNICODE ^= '' %then %do;
 dcl HDM_SETITEM  fixed bin(31) value(HDM_SETITEMW);
 %end; %else %do;
 dcl HDM_SETITEM  fixed bin(31) value(HDM_SETITEMA);
 %end;

 Header_SetItem: proc (hwndHD, i, phdi)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwndHD type HWND byvalue,
       i      fixed bin(31) byvalue,
       phdi   type HD_ITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndHD, HDM_SETITEM, i, binvalue (addr (phdi))));
 end Header_SetItem;


 define structure
   1 HD_LAYOUT,
     2 prc   handle RECT,
     2 pwpos handle WINDOWPOS;

 define alias   HDLAYOUT type   HD_LAYOUT;
 define alias LPHDLAYOUT handle HD_LAYOUT;


 dcl HDM_LAYOUT fixed bin(31) value(HDM_FIRST + 5);

 Header_Layout: proc (hwndHD, playout)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwndHD  type HWND byvalue,
       playout type HDLAYOUT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndHD, HDM_LAYOUT, 0, binvalue (addr (playout))));
 end Header_Layout;

 dcl HHT_NOWHERE        type UINT value('0001'xu);
 dcl HHT_ONHEADER       type UINT value('0002'xu);
 dcl HHT_ONDIVIDER      type UINT value('0004'xu);
 dcl HHT_ONDIVOPEN      type UINT value('0008'xu);
 %if #WIN32_IE >= 1280 %then %do;
 dcl HHT_ONFILTER       type UINT value('0010'xu);
 dcl HHT_ONFILTERBUTTON type UINT value('0020'xu);
 %end;
 dcl HHT_ABOVE          type UINT value('0100'xu);
 dcl HHT_BELOW          type UINT value('0200'xu);
 dcl HHT_TORIGHT        type UINT value('0400'xu);
 dcl HHT_TOLEFT         type UINT value('0800'xu);


 define structure
   1 HD_HITTESTINFO,
     2 pt    type POINT,
     2 flags type UINT,
     2 iItem fixed bin(31);
 define alias   HDHITTESTINFO type   HD_HITTESTINFO;
 define alias LPHDHITTESTINFO handle HD_HITTESTINFO;


 dcl HDM_HITTEST   fixed bin(31) value(HDM_FIRST + 6);


 %if #WIN32_IE >= 768 %then %do;

 dcl HDM_GETITEMRECT fixed bin(31) value(HDM_FIRST + 7);

 Header_GetItemRect: proc (hwnd, iItem, lprc)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iItem fixed bin(31) byvalue,
       lprc  type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, HDM_GETITEMRECT, iItem,
                   binvalue (addr (lprc))));
 end Header_GetItemRect;


 dcl HDM_SETIMAGELIST fixed bin(31) value(HDM_FIRST + 8);

 Header_SetImageList: proc (hwnd, himl)
                      returns (type HIMAGELIST byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       himl  type HIMAGELIST byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, HDM_SETIMAGELIST, 0,
                             binvalue (himl))));
 end Header_SetImageList;


 dcl HDM_GETIMAGELIST fixed bin(31) value(HDM_FIRST + 9);

 Header_GetImageList: proc (hwnd)
                      returns (type HIMAGELIST byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, HDM_GETIMAGELIST, 0, 0)));
 end Header_GetImageList;


 dcl HDM_ORDERTOINDEX fixed bin(31) value(HDM_FIRST + 15);

 Header_OrderToIndex: proc (hwnd, i)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       i     fixed bin(31) byvalue;
   return (SNDMSG (hwnd, HDM_ORDERTOINDEX, i, 0));
 end Header_OrderToIndex;


 dcl HDM_CREATEDRAGIMAGE fixed bin(31) value(HDM_FIRST + 16);
     /* wparam = which item (by index) */

 Header_CreateDragImage: proc (hwnd, i)
                         returns (type HIMAGELIST byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       i     fixed bin(31) byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, HDM_CREATEDRAGIMAGE, i, 0)));
 end Header_CreateDragImage;


 dcl HDM_GETORDERARRAY fixed bin(31) value(HDM_FIRST + 17);

 Header_GetOrderArray: proc (hwnd, iCount, lpi)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iCount fixed bin(31) byvalue,
       lpi    (*) fixed bin(31) byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, HDM_GETORDERARRAY, iCount,
                   binvalue (addr (lpi))));
 end Header_GetOrderArray;


 dcl HDM_SETORDERARRAY fixed bin(31) value(HDM_FIRST + 18);

 Header_SetOrderArray: proc (hwnd, iCount, lpi)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iCount fixed bin(31) byvalue,
       lpi    (*) fixed bin(31) byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, HDM_SETORDERARRAY, iCount,
                   binvalue (addr (lpi))));
 end Header_SetOrderArray;

 /* lparam = int array of size HDM_GETITEMCOUNT                       */
 /* the array specifies the order that all items should be displayed. */
 /* e.g.  { 2, 0, 1}                                                  */
 /* says the index 2 item should be shown in the 0ths position        */
 /*      index 0 should be shown in the 1st position                  */
 /*      index 1 should be shown in the 2nd position                  */


 dcl HDM_SETHOTDIVIDER fixed bin(31) value(HDM_FIRST + 19);

 Header_SetHotDivider: proc (hwnd, fPos, dw)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       fPos type BOOL byvalue,
       dw   type DWORD byvalue;
   return (SNDMSG (hwnd, HDM_SETHOTDIVIDER, fPos, dw));
 end Header_SetHotDivider;

 /* convenience message for external dragdrop                         */
 /* wParam = BOOL  specifying whether the lParam is a dwPos of the    */
 /*                cursor position or the index of which divider to   */
 /*                hotlight                                           */
 /* lParam = depends on wParam  (-1 and wParm = FALSE turns off       */
 /*                              hotlight)                            */
 %end; /* _WIN32_IE >= 0x0300 */

 %if #WIN32_IE >= 1280 %then %do;

 dcl HDM_SETBITMAPMARGIN  fixed bin(31) value(HDM_FIRST + 20);

 Header_SetBitmapMargin: proc (hwnd, iWidth)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iWidth fixed bin(31) byvalue;
   return (SNDMSG (hwnd, HDM_SETBITMAPMARGIN, iWidth, 0));
 end Header_SetBitmapMargin;


 dcl HDM_GETBITMAPMARGIN  fixed bin(31) value(HDM_FIRST + 21);

 Header_GetBitmapMargin: proc (hwnd)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd   type HWND byvalue;
   return (SNDMSG (hwnd, HDM_GETBITMAPMARGIN, 0, 0));
 end Header_GetBitmapMargin;
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl HDM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);

 Header_SetUnicodeFormat: proc (hwnd, fUnicode)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       fUnicode type BOOL byvalue;
   return (SNDMSG (hwnd, HDM_SETUNICODEFORMAT, (fUnicode), 0));
 end Header_SetUnicodeFormat;


 dcl HDM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);

 Header_GetUnicodeFormat: proc (hwnd)
                          returns (type BOOL byvalue)
                          options (inline reorder) internal;
   dcl hwnd     type HWND byvalue;
   return (SNDMSG (hwnd, HDM_GETUNICODEFORMAT, 0, 0));
 end Header_GetUnicodeFormat;
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 dcl HDM_SETFILTERCHANGETIMEOUT fixed bin(31) value(HDM_FIRST+22);

 Header_SetFilterChangeTimeout: proc (hwnd, i)
                                returns (fixed bin(31) byvalue optional)
                                options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, HDM_SETFILTERCHANGETIMEOUT, 0, i));
 end Header_SetFilterChangeTimeout;

 dcl HDM_EDITFILTER             fixed bin(31) value(HDM_FIRST+23);

 Header_EditFilter: proc (hwnd, i, fDiscardChanges)
                    returns (fixed bin(31) byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd            type HWND byvalue,
       i               fixed bin(31) byvalue,
       fDiscardChanges type BOOL byvalue;
   return (SNDMSG (hwnd, HDM_EDITFILTER,
                         i, MAKELPARAM (fDiscardChanges, 0)));
 end Header_EditFilter;

 /* Clear filter takes -1 as a column value to indicate that all */
 /* the filter should be cleared.  When this happens you will    */
 /* only receive a single filter changed notification.           */

 dcl HDM_CLEARFILTER            fixed bin(31) value(HDM_FIRST+24);
 Header_ClearFilter: proc (hwnd, i)
                     returns (fixed bin(31) byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, HDM_CLEARFILTER, i, 0));
 end Header_ClearFilter;

 Header_ClearAllFilters: proc (hwnd)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, HDM_CLEARFILTER, -1, 0));
 end Header_ClearAllFilters;
 %end;

 dcl HDN_ITEMCHANGINGA    fixed bin(31) value(HDN_FIRST-0);
 dcl HDN_ITEMCHANGINGW    fixed bin(31) value(HDN_FIRST-20);
 dcl HDN_ITEMCHANGEDA     fixed bin(31) value(HDN_FIRST-1);
 dcl HDN_ITEMCHANGEDW     fixed bin(31) value(HDN_FIRST-21);
 dcl HDN_ITEMCLICKA       fixed bin(31) value(HDN_FIRST-2);
 dcl HDN_ITEMCLICKW       fixed bin(31) value(HDN_FIRST-22);
 dcl HDN_ITEMDBLCLICKA    fixed bin(31) value(HDN_FIRST-3);
 dcl HDN_ITEMDBLCLICKW    fixed bin(31) value(HDN_FIRST-23);
 dcl HDN_DIVIDERDBLCLICKA fixed bin(31) value(HDN_FIRST-5);
 dcl HDN_DIVIDERDBLCLICKW fixed bin(31) value(HDN_FIRST-25);
 dcl HDN_BEGINTRACKA      fixed bin(31) value(HDN_FIRST-6);
 dcl HDN_BEGINTRACKW      fixed bin(31) value(HDN_FIRST-26);
 dcl HDN_ENDTRACKA        fixed bin(31) value(HDN_FIRST-7);
 dcl HDN_ENDTRACKW        fixed bin(31) value(HDN_FIRST-27);
 dcl HDN_TRACKA           fixed bin(31) value(HDN_FIRST-8);
 dcl HDN_TRACKW           fixed bin(31) value(HDN_FIRST-28);

 %if #WIN32_IE >= 768 %then %do;
 dcl HDN_GETDISPINFOA     fixed bin(31) value(HDN_FIRST-9);
 dcl HDN_GETDISPINFOW     fixed bin(31) value(HDN_FIRST-29);
 dcl HDN_BEGINDRAG        fixed bin(31) value(HDN_FIRST-10);
 dcl HDN_ENDDRAG          fixed bin(31) value(HDN_FIRST-11);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl HDN_FILTERCHANGE     fixed bin(31) value(HDN_FIRST-12);
 dcl HDN_FILTERBTNCLICK   fixed bin(31) value(HDN_FIRST-13);
 %end;

 %if UNICODE ^= '' %then %do;
 dcl HDN_ITEMCHANGING    fixed bin(31) value(HDN_ITEMCHANGINGW);
 dcl HDN_ITEMCHANGED     fixed bin(31) value(HDN_ITEMCHANGEDW);
 dcl HDN_ITEMCLICK       fixed bin(31) value(HDN_ITEMCLICKW);
 dcl HDN_ITEMDBLCLICK    fixed bin(31) value(HDN_ITEMDBLCLICKW);
 dcl HDN_DIVIDERDBLCLICK fixed bin(31) value(HDN_DIVIDERDBLCLICKW);
 dcl HDN_BEGINTRACK      fixed bin(31) value(HDN_BEGINTRACKW);
 dcl HDN_ENDTRACK        fixed bin(31) value(HDN_ENDTRACKW);
 dcl HDN_TRACK           fixed bin(31) value(HDN_TRACKW);
 %if #WIN32_IE >= 768 %then %do;
 dcl HDN_GETDISPINFO     fixed bin(31) value(HDN_GETDISPINFOW);
 %end;
 %end; %else %do;
 dcl HDN_ITEMCHANGING    fixed bin(31) value(HDN_ITEMCHANGINGA);
 dcl HDN_ITEMCHANGED     fixed bin(31) value(HDN_ITEMCHANGEDA);
 dcl HDN_ITEMCLICK       fixed bin(31) value(HDN_ITEMCLICKA);
 dcl HDN_ITEMDBLCLICK    fixed bin(31) value(HDN_ITEMDBLCLICKA);
 dcl HDN_DIVIDERDBLCLICK fixed bin(31) value(HDN_DIVIDERDBLCLICKA);
 dcl HDN_BEGINTRACK      fixed bin(31) value(HDN_BEGINTRACKA);
 dcl HDN_ENDTRACK        fixed bin(31) value(HDN_ENDTRACKA);
 dcl HDN_TRACK           fixed bin(31) value(HDN_TRACKA);
 %if #WIN32_IE >= 768 %then %do;
 dcl HDN_GETDISPINFO     fixed bin(31) value(HDN_GETDISPINFOA);
 %end;
 %end;


 define structure
   1 NMHEADERA unaligned,
     2 hdr     type NMHDR,
     2 iItem   fixed bin(31),
     2 iButton fixed bin(31),
     2 pitem   handle HDITEMA;
 define alias LPNMHEADERA handle NMHEADERA;
 define alias HD_NOTIFYA  type   NMHEADERA;

 define structure
   1 NMHEADERW unaligned,
     2 hdr     type NMHDR,
     2 iItem   fixed bin(31),
     2 iButton fixed bin(31),
     2 pitem   handle HDITEMW;
 define alias LPNMHEADERW handle NMHEADERW;
 define alias HD_NOTIFYW  type   NMHEADERW;

 %if UNICODE ^= '' %then %do;
 define alias   NMHEADER type   NMHEADERW;
 define alias LPNMHEADER type LPNMHEADERW;
 %end; %else %do;
 define alias   NMHEADER type   NMHEADERA;
 define alias LPNMHEADER type LPNMHEADERA;
 %end;
 define alias HD_NOTIFY  type NMHEADER;

 define structure
   1 NMHDDISPINFOW unaligned,
     2 hdr        type NMHDR,
     2 iItem      fixed bin(31),
     2 mask       type UINT,
     2 pszText    type LPWSTR,
     2 cchTextMax fixed bin(31),
     2 iImage     fixed bin(31),
     2 lParam     type LPARAM;
 define alias LPNMHDDISPINFOW handle NMHDDISPINFOW;

 define structure
   1 NMHDDISPINFOA unaligned,
     2 hdr        type NMHDR,
     2 iItem      fixed bin(31),
     2 mask       type UINT,
     2 pszText    type LPSTR,
     2 cchTextMax fixed bin(31),
     2 iImage     fixed bin(31),
     2 lParam     type LPARAM;
 define alias LPNMHDDISPINFOA handle NMHDDISPINFOA;

 %if UNICODE ^= '' %then %do;
 define alias   NMHDDISPINFO type   NMHDDISPINFOW;
 define alias LPNMHDDISPINFO type LPNMHDDISPINFOW;
 %end; %else %do;
 define alias   NMHDDISPINFO type   NMHDDISPINFOA;
 define alias LPNMHDDISPINFO type LPNMHDDISPINFOA;
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 define structure
   1 NMHDFILTERBTNCLICK unaligned,
     2 hdr   type NMHDR,
     2 iItem type INT,
     2 rc    type RECT;
 define alias LPNMHDFILTERBTNCLICK handle NMHDFILTERBTNCLICK;
 %end;

 %end; /* NOHEADER */


 /* ====== TOOLBAR CONTROL ========================================== */

 %dcl NOTOOLBAR char ext;
 %if NOTOOLBAR = '' %then %do;

 %if #WIN32 ^= '' %then %do;
 dcl TOOLBARCLASSNAMEW WCHAR value('ToolbarWindow32');
 dcl TOOLBARCLASSNAMEA char  value('ToolbarWindow32');

 %dcl TOOLBARCLASSNAME char ext;
 %if UNICODE ^= '' %then %do;
 %TOOLBARCLASSNAME='TOOLBARCLASSNAMEW';
 %end; %else %do;
 %TOOLBARCLASSNAME='TOOLBARCLASSNAMEA';
 %end;
 %end; %else %do;
 dcl TOOLBARCLASSNAME char value('ToolbarWindow');
 %end;

 define structure
   1 TBBUTTON,
     2 iBitmap   fixed bin(31),
     2 idCommand fixed bin(31),
     2 fsState   type BYTE,
     2 fsStyle   type BYTE,
 %if #WIN64 ^= '' %then %do;
     2 bReserved (6) type BYTE, /* padding for alignment */
 %end; %else %if #WIN32 ^= '' %then %do;
     2 bReserved (2) type BYTE, /* padding for alignment */
 %end;
     2 dwData    type DWORD_PTR,
     2 iString   fixed bin(31);
 define alias   PTBBUTTON handle TBBUTTON;
 define alias  LPTBBUTTON handle TBBUTTON;
 define alias LPCTBBUTTON handle TBBUTTON;


 define structure
   1 COLORMAP,
     2 from type COLORREF,
     2 to   type COLORREF;
 define alias LPCOLORMAP handle COLORMAP;

 dcl CreateToolbarEx
     entry (type HWND,
            type DWORD,
            type UINT,
            fixed bin(31),
            type HINSTANCE,
            type UINT,
            (*) type TBBUTTON byaddr nonasgn,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type UINT)
     returns (type HWND byvalue optional)
     WINCOMMCTRLAPI WINAPI external('CreateToolbarEx');

 dcl CreateMappedBitmap
     entry (type HINSTANCE,
            fixed bin(31),
            type UINT,
            type COLORMAP byaddr optional,
            fixed bin(31))
     returns (type HBITMAP byvalue optional)
     WINCOMMCTRLAPI WINAPI external('CreateMappedBitmap');

 dcl CMB_MASKED              fixed bin(31) value('02'xn);

 dcl TBSTATE_CHECKED         fixed bin(31) value('01'xn);
 dcl TBSTATE_PRESSED         fixed bin(31) value('02'xn);
 dcl TBSTATE_ENABLED         fixed bin(31) value('04'xn);
 dcl TBSTATE_HIDDEN          fixed bin(31) value('08'xn);
 dcl TBSTATE_INDETERMINATE   fixed bin(31) value('10'xn);
 dcl TBSTATE_WRAP            fixed bin(31) value('20'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl TBSTATE_ELLIPSES        fixed bin(31) value('40'xn);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TBSTATE_MARKED          fixed bin(31) value('80'xn);
 %end;

 dcl TBSTYLE_BUTTON          type DWORD value('0000'xu);
 dcl TBSTYLE_SEP             type DWORD value('0001'xu);
 dcl TBSTYLE_CHECK           type DWORD value('0002'xu);
 dcl TBSTYLE_GROUP           type DWORD value('0004'xu);
 dcl TBSTYLE_CHECKGROUP      type DWORD
     value(ior(TBSTYLE_GROUP,  TBSTYLE_CHECK));
 %if #WIN32_IE >= 768 %then %do;
 dcl TBSTYLE_DROPDOWN        type DWORD value('0008'xu);
 %end;
 %if #WIN32_IE >= 1024 %then %do;
 dcl TBSTYLE_AUTOSIZE        type DWORD value('0010'xu);
     /* automatically calculate the cx of the button */
 dcl TBSTYLE_NOPREFIX        type DWORD value('0020'xu);
     /* if this button should not have accel prefix */
 %end;

 dcl TBSTYLE_TOOLTIPS        type DWORD value('0100'xu);
 dcl TBSTYLE_WRAPABLE        type DWORD value('0200'xu);
 dcl TBSTYLE_ALTDRAG         type DWORD value('0400'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl TBSTYLE_FLAT            type DWORD value('0800'xu);
 dcl TBSTYLE_LIST            type DWORD value('1000'xu);
 dcl TBSTYLE_CUSTOMERASE     type DWORD value('2000'xu);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TBSTYLE_REGISTERDROP    type DWORD value('4000'xu);
 dcl TBSTYLE_TRANSPARENT     type DWORD value('8000'xu);
 dcl TBSTYLE_EX_DRAWDDARROWS type DWORD value('00000001'xu);
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 dcl BTNS_BUTTON      type DWORD value(TBSTYLE_BUTTON);  /* 0x0000 */
 dcl BTNS_SEP         type DWORD value(TBSTYLE_SEP);     /* 0x0001 */
 dcl BTNS_CHECK       type DWORD value(TBSTYLE_CHECK);   /* 0x0002 */
 dcl BTNS_GROUP       type DWORD value(TBSTYLE_GROUP);   /* 0x0004 */
 dcl BTNS_CHECKGROUP  type DWORD value(TBSTYLE_CHECKGROUP);
                      /* ior (TBSTYLE_GROUP, TBSTYLE_CHECK) */
 dcl BTNS_DROPDOWN    type DWORD value(TBSTYLE_DROPDOWN); /* 0x0008 */
 dcl BTNS_AUTOSIZE    type DWORD value(TBSTYLE_AUTOSIZE); /* 0x0010 */
                      /* automatically calculate the cx of the button */
 dcl BTNS_NOPREFIX    type DWORD value(TBSTYLE_NOPREFIX); /* 0x0020 */
                      /* this button should not have accel prefix     */
 %if #WIN32_IE >= 1281 %then %do;
 dcl BTNS_SHOWTEXT    type DWORD value('0040'xu);
                      /* ignored unless TBSTYLE_EX_MIXEDBUTTONS is set*/
 %end;
 dcl BTNS_WHOLEDROPDOWN type DWORD value('0080'xu);
             /* draw drop-down arrow, but without split arrow section */
 %end;

 %if #WIN32_IE >= 1281 %then %do;
 dcl TBSTYLE_EX_MIXEDBUTTONS       type DWORD value('00000008'xu);
 dcl TBSTYLE_EX_HIDECLIPPEDBUTTONS type DWORD value('00000010'xu);
           /* don't show partially obscured buttons */
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl TBSTYLE_EX_DOUBLEBUFFER       type DWORD value('00000080'xu);
     /* Double Buffer the toolbar */
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 /* Custom Draw Structure */
 define structure
   1 NMTBCUSTOMDRAW,
     2 nmcd             type NMCUSTOMDRAW,
     2 hbrMonoDither    type HBRUSH,
     2 hbrLines         type HBRUSH,/* For drawing lines on buttons */
     2 hpenLines        type HPEN,/* For drawing lines on buttons */
     2 clrText          type COLORREF,/* Color of text */
     2 clrMark          type COLORREF,/* Color of text bk when marked.*/
                                      /* (only if TBSTATE_MARKED) */
     2 clrTextHighlight type COLORREF,/* Color of text when */
                                      /* highlighted */
     2 clrBtnFace       type COLORREF,/* Background of the button */
     2 clrBtnHighlight  type COLORREF,/* 3D highlight */
     2 clrHighlightHotTrack type COLORREF,
       /* In conjunction with fHighlightHotTrack */
       /* will cause button to highlight like a menu */
     2 rcText           type RECT,/* Rect for text */
     2 nStringBkMode    fixed bin(31),
     2 nHLStringBkMode  fixed bin(31)
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 iListGap         fixed bin(31)
 %end;
   ;
 define alias LPNMTBCUSTOMDRAW handle NMTBCUSTOMDRAW;

 /* Toolbar custom draw return flags */
 dcl TBCDRF_NOEDGES        type DWORD value('00010000'xu);
     /* Don't draw button edges */
 dcl TBCDRF_HILITEHOTTRACK type DWORD value('00020000'xu);
     /* Use color of the button bk when hottracked */
 dcl TBCDRF_NOOFFSET       type DWORD value('00040000'xu);
     /* Don't offset button if pressed */
 dcl TBCDRF_NOMARK         type DWORD value('00080000'xu);
     /* Don't draw default highlight of image/text for TBSTATE_MARKED */
 dcl TBCDRF_NOETCHEDEFFECT type DWORD value('00100000'xu);
     /* Don't draw etched effect for disabled items */
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 dcl TBCDRF_BLENDICON      type DWORD value('00200000'xu);
     /* Use ILD_BLEND50 on the icon image */
 dcl TBCDRF_NOBACKGROUND   type DWORD value('00400000'xu);
     /* Use ILD_BLEND50 on the icon image */
 %end;


 dcl TB_ENABLEBUTTON          fixed bin(31) value(WM_USER + 1);
 dcl TB_CHECKBUTTON           fixed bin(31) value(WM_USER + 2);
 dcl TB_PRESSBUTTON           fixed bin(31) value(WM_USER + 3);
 dcl TB_HIDEBUTTON            fixed bin(31) value(WM_USER + 4);
 dcl TB_INDETERMINATE         fixed bin(31) value(WM_USER + 5);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TB_MARKBUTTON            fixed bin(31) value(WM_USER + 6);
 %end;
 dcl TB_ISBUTTONENABLED       fixed bin(31) value(WM_USER + 9);
 dcl TB_ISBUTTONCHECKED       fixed bin(31) value(WM_USER + 10);
 dcl TB_ISBUTTONPRESSED       fixed bin(31) value(WM_USER + 11);
 dcl TB_ISBUTTONHIDDEN        fixed bin(31) value(WM_USER + 12);
 dcl TB_ISBUTTONINDETERMINATE fixed bin(31) value(WM_USER + 13);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TB_ISBUTTONHIGHLIGHTED   fixed bin(31) value(WM_USER + 14);
 %end;
 dcl TB_SETSTATE              fixed bin(31) value(WM_USER + 17);
 dcl TB_GETSTATE              fixed bin(31) value(WM_USER + 18);
 dcl TB_ADDBITMAP             fixed bin(31) value(WM_USER + 19);

 %if #WIN32 ^= '' %then %do;
 define structure
   1 TBADDBITMAP,
     2 hInst type HINSTANCE,
     2 nID   type UINT;
 define alias LPTBADDBITMAP handle TBADDBITMAP;

 dcl HINST_COMMCTRL       fixed bin(31) value(-1 );
 dcl IDB_STD_SMALL_COLOR  fixed bin(31) value(0);
 dcl IDB_STD_LARGE_COLOR  fixed bin(31) value(1);
 dcl IDB_VIEW_SMALL_COLOR fixed bin(31) value(4);
 dcl IDB_VIEW_LARGE_COLOR fixed bin(31) value(5);

 %if #WIN32_IE >= 768 %then %do;
 dcl IDB_HIST_SMALL_COLOR fixed bin(31) value(8);
 dcl IDB_HIST_LARGE_COLOR fixed bin(31) value(9);
 %end;

 /* icon indexes for standard bitmap */

 dcl STD_CUT             fixed bin(31) value(0);
 dcl STD_COPY            fixed bin(31) value(1);
 dcl STD_PASTE           fixed bin(31) value(2);
 dcl STD_UNDO            fixed bin(31) value(3);
 dcl STD_REDOW           fixed bin(31) value(4);
 dcl STD_DELETE          fixed bin(31) value(5);
 dcl STD_FILENEW         fixed bin(31) value(6);
 dcl STD_FILEOPEN        fixed bin(31) value(7);
 dcl STD_FILESAVE        fixed bin(31) value(8);
 dcl STD_PRINTPRE        fixed bin(31) value(9);
 dcl STD_PROPERTIES      fixed bin(31) value(10);
 dcl STD_HELP            fixed bin(31) value(11);
 dcl STD_FIND            fixed bin(31) value(12);
 dcl STD_REPLACE         fixed bin(31) value(13);
 dcl STD_PRINT           fixed bin(31) value(14);

 /* icon indexes for standard view bitmap */

 dcl VIEW_LARGEICONS     fixed bin(31) value(0);
 dcl VIEW_SMALLICONS     fixed bin(31) value(1);
 dcl VIEW_LIST           fixed bin(31) value(2);
 dcl VIEW_DETAILS        fixed bin(31) value(3);
 dcl VIEW_SORTNAME       fixed bin(31) value(4);
 dcl VIEW_SORTSIZE       fixed bin(31) value(5);
 dcl VIEW_SORTDATE       fixed bin(31) value(6);
 dcl VIEW_SORTTYPE       fixed bin(31) value(7);
 dcl VIEW_PARENTFOLDER   fixed bin(31) value(8);
 dcl VIEW_NETCONNECT     fixed bin(31) value(9);
 dcl VIEW_NETDISCONNECT  fixed bin(31) value(10);
 dcl VIEW_NEWFOLDER      fixed bin(31) value(11);

 %if #WIN32_IE >= 1024 %then %do;
 dcl VIEW_VIEWMENU       fixed bin(31) value(12);
 %end;


 %if #WIN32_IE >= 768 %then %do;
 dcl HIST_BACK           fixed bin(31) value(0);
 dcl HIST_FORWARD        fixed bin(31) value(1);
 dcl HIST_FAVORITES      fixed bin(31) value(2);
 dcl HIST_ADDTOFAVORITES fixed bin(31) value(3);
 dcl HIST_VIEWTREE       fixed bin(31) value(4);
 %end;

 %end;


 %if #WIN32_IE >= 1024 %then %do;
 dcl TB_ADDBUTTONSA      fixed bin(31) value(WM_USER + 20);
 dcl TB_INSERTBUTTONA    fixed bin(31) value(WM_USER + 21);
 %end; %else %do;
 dcl TB_ADDBUTTONS       fixed bin(31) value(WM_USER + 20);
 dcl TB_INSERTBUTTON     fixed bin(31) value(WM_USER + 21);
 %end;

 dcl TB_DELETEBUTTON     fixed bin(31) value(WM_USER + 22);
 dcl TB_GETBUTTON        fixed bin(31) value(WM_USER + 23);
 dcl TB_BUTTONCOUNT      fixed bin(31) value(WM_USER + 24);
 dcl TB_COMMANDTOINDEX   fixed bin(31) value(WM_USER + 25);

 %if #WIN32 ^= '' %then %do;

 define structure
   1 TBSAVEPARAMSA,
     2 hkr          type HKEY,
     2 pszSubKey    type LPCSTR,
     2 pszValueName type LPCSTR;
 define alias LPTBSAVEPARAMSA handle TBSAVEPARAMSA;

 define structure
   1 TBSAVEPARAMSW,
     2 hkr          type HKEY,
     2 pszSubKey    type LPCWSTR,
     2 pszValueName type LPCWSTR;
 define alias LPTBSAVEPARAMW handle TBSAVEPARAMSW;

 %if UNICODE ^= '' %then %do;
 define alias   TBSAVEPARAMS type   TBSAVEPARAMSW;
 define alias LPTBSAVEPARAMS type LPTBSAVEPARAMSW;
 %end; %else %do;
 define alias   TBSAVEPARAMS type   TBSAVEPARAMSA;
 define alias LPTBSAVEPARAMS type LPTBSAVEPARAMSA;
 %end;

 %end; /* _WIN32 */

 dcl TB_SAVERESTOREA         fixed bin(31) value(WM_USER + 26);
 dcl TB_SAVERESTOREW         fixed bin(31) value(WM_USER + 76);
 dcl TB_CUSTOMIZE            fixed bin(31) value(WM_USER + 27);
 dcl TB_ADDSTRINGA           fixed bin(31) value(WM_USER + 28);
 dcl TB_ADDSTRINGW           fixed bin(31) value(WM_USER + 77);
 dcl TB_GETITEMRECT          fixed bin(31) value(WM_USER + 29);
 dcl TB_BUTTONSTRUCTSIZE     fixed bin(31) value(WM_USER + 30);
 dcl TB_SETBUTTONSIZE        fixed bin(31) value(WM_USER + 31);
 dcl TB_SETBITMAPSIZE        fixed bin(31) value(WM_USER + 32);
 dcl TB_AUTOSIZE             fixed bin(31) value(WM_USER + 33);
 dcl TB_GETTOOLTIPS          fixed bin(31) value(WM_USER + 35);
 dcl TB_SETTOOLTIPS          fixed bin(31) value(WM_USER + 36);
 dcl TB_SETPARENT            fixed bin(31) value(WM_USER + 37);
 dcl TB_SETROWS              fixed bin(31) value(WM_USER + 39);
 dcl TB_GETROWS              fixed bin(31) value(WM_USER + 40);
 dcl TB_SETCMDID             fixed bin(31) value(WM_USER + 42);
 dcl TB_CHANGEBITMAP         fixed bin(31) value(WM_USER + 43);
 dcl TB_GETBITMAP            fixed bin(31) value(WM_USER + 44);
 dcl TB_GETBUTTONTEXTA       fixed bin(31) value(WM_USER + 45);
 dcl TB_GETBUTTONTEXTW       fixed bin(31) value(WM_USER + 75);
 dcl TB_REPLACEBITMAP        fixed bin(31) value(WM_USER + 46);

 %if #WIN32_IE >= 768 %then %do;
 dcl TB_SETINDENT            fixed bin(31) value(WM_USER + 47);
 dcl TB_SETIMAGELIST         fixed bin(31) value(WM_USER + 48);
 dcl TB_GETIMAGELIST         fixed bin(31) value(WM_USER + 49);
 dcl TB_LOADIMAGES           fixed bin(31) value(WM_USER + 50);
 dcl TB_GETRECT              fixed bin(31) value(WM_USER + 51);
     /* wParam is the Cmd instead of index */
 dcl TB_SETHOTIMAGELIST      fixed bin(31) value(WM_USER + 52);
 dcl TB_GETHOTIMAGELIST      fixed bin(31) value(WM_USER + 53);
 dcl TB_SETDISABLEDIMAGELIST fixed bin(31) value(WM_USER + 54);
 dcl TB_GETDISABLEDIMAGELIST fixed bin(31) value(WM_USER + 55);
 dcl TB_SETSTYLE             fixed bin(31) value(WM_USER + 56);
 dcl TB_GETSTYLE             fixed bin(31) value(WM_USER + 57);
 dcl TB_GETBUTTONSIZE        fixed bin(31) value(WM_USER + 58);
 dcl TB_SETBUTTONWIDTH       fixed bin(31) value(WM_USER + 59);
 dcl TB_SETMAXTEXTROWS       fixed bin(31) value(WM_USER + 60);
 dcl TB_GETTEXTROWS          fixed bin(31) value(WM_USER + 61);
 %end; /* _WIN32_IE >= 0x0300 */


 %if UNICODE ^= '' %then %do;
 dcl TB_GETBUTTONTEXT        fixed bin(31) value(TB_GETBUTTONTEXTW);
 dcl TB_SAVERESTORE          fixed bin(31) value(TB_SAVERESTOREW);
 dcl TB_ADDSTRING            fixed bin(31) value(TB_ADDSTRINGW);
 %end; %else %do;
 dcl TB_GETBUTTONTEXT        fixed bin(31) value(TB_GETBUTTONTEXTA);
 dcl TB_SAVERESTORE          fixed bin(31) value(TB_SAVERESTOREA);
 dcl TB_ADDSTRING            fixed bin(31) value(TB_ADDSTRINGA);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TB_GETOBJECT            fixed bin(31) value(WM_USER + 62);
     /* wParam == IID, lParam void **ppv */
 dcl TB_GETHOTITEM           fixed bin(31) value(WM_USER + 71);
 dcl TB_SETHOTITEM           fixed bin(31) value(WM_USER + 72);
     /* wParam == iHotItem */
 dcl TB_SETANCHORHIGHLIGHT   fixed bin(31) value(WM_USER + 73);
     /* wParam == TRUE/FALSE */
 dcl TB_GETANCHORHIGHLIGHT   fixed bin(31) value(WM_USER + 74);
 dcl TB_MAPACCELERATORA      fixed bin(31) value(WM_USER + 78);
     /* wParam == ch, lParam int * pidBtn */

 define structure
   1 TBINSERTMARK,
     2 iButton fixed bin(31),
     2 dwFlags type DWORD;
 define alias LPTBINSERTMARK handle TBINSERTMARK;

 dcl TBIMHT_AFTER            type DWORD value('00000001'xu);
     /* TRUE = insert After iButton, otherwise before */
 dcl TBIMHT_BACKGROUND       type DWORD value('00000002'xu);
     /* TRUE iff missed buttons completely */

 dcl TB_GETINSERTMARK        fixed bin(31) value(WM_USER + 79);
     /* lParam == LPTBINSERTMARK */
 dcl TB_SETINSERTMARK        fixed bin(31) value(WM_USER + 80);
     /* lParam == LPTBINSERTMARK */
 dcl TB_INSERTMARKHITTEST    fixed bin(31) value(WM_USER + 81);
     /* wParam == LPPOINT lParam == LPTBINSERTMARK */
 dcl TB_MOVEBUTTON           fixed bin(31) value(WM_USER + 82);
 dcl TB_GETMAXSIZE           fixed bin(31) value(WM_USER + 83);
     /* lParam == LPSIZE */
 dcl TB_SETEXTENDEDSTYLE     fixed bin(31) value(WM_USER + 84);
     /* For TBSTYLE_EX_* */
 dcl TB_GETEXTENDEDSTYLE     fixed bin(31) value(WM_USER + 85);
     /* For TBSTYLE_EX_* */
 dcl TB_GETPADDING           fixed bin(31) value(WM_USER + 86);
 dcl TB_SETPADDING           fixed bin(31) value(WM_USER + 87);
 dcl TB_SETINSERTMARKCOLOR   fixed bin(31) value(WM_USER + 88);
 dcl TB_GETINSERTMARKCOLOR   fixed bin(31) value(WM_USER + 89);

 dcl TB_SETCOLORSCHEME       fixed bin(31) value(CCM_SETCOLORSCHEME);
     /* lParam is color scheme */
 dcl TB_GETCOLORSCHEME       fixed bin(31) value(CCM_GETCOLORSCHEME);
     /* fills in COLORSCHEME pointed to by lParam */

 dcl TB_SETUNICODEFORMAT     fixed bin(31) value(CCM_SETUNICODEFORMAT);
 dcl TB_GETUNICODEFORMAT     fixed bin(31) value(CCM_GETUNICODEFORMAT);

 dcl TB_MAPACCELERATORW      fixed bin(31) value(WM_USER + 90);
     /* wParam == ch, lParam int * pidBtn */

 %if UNICODE ^= '' %then %do;
 dcl TB_MAPACCELERATOR       fixed bin(31) value(TB_MAPACCELERATORW);
 %end; %else %do;
 dcl TB_MAPACCELERATOR       fixed bin(31) value(TB_MAPACCELERATORA);
 %end;
 %end; /* _WIN32_IE >= 0x0400 */

 define structure
   1 TBREPLACEBITMAP,
     2 hInstOld type HINSTANCE,
     2 nIDOld   type UINT,
     2 hInstNew type HINSTANCE,
     2 nIDNew   type UINT,
     2 nButtons fixed bin(31);
 define alias LPTBREPLACEBITMAP handle TBREPLACEBITMAP;

 %if #WIN32 ^= '' %then %do;

 dcl TBBF_LARGE        fixed bin(31) value('0001'xn);

 dcl TB_GETBITMAPFLAGS fixed bin(31) value(WM_USER + 41);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TBIF_IMAGE        type DWORD value('00000001'xu);
 dcl TBIF_TEXT         type DWORD value('00000002'xu);
 dcl TBIF_STATE        type DWORD value('00000004'xu);
 dcl TBIF_STYLE        type DWORD value('00000008'xu);
 dcl TBIF_LPARAM       type DWORD value('00000010'xu);
 dcl TBIF_COMMAND      type DWORD value('00000020'xu);
 dcl TBIF_SIZE         type DWORD value('00000040'xu);

 %if #WIN32_IE >= 1280 %then %do;
 dcl TBIF_BYINDEX      type DWORD value('80000000'xu);
     /* this specifies that the wparam in Get/SetButtonInfo  */
     /* is an index, not id                                  */
 %end;

 define structure
   1 TBBUTTONINFOA,
     2 cbSize    type UINT,
     2 dwMask    type DWORD,
     2 idCommand fixed bin(31),
     2 iImage    fixed bin(31),
     2 fsState   type BYTE,
     2 fsStyle   type BYTE,
     2 cx        type WORD,
     2 lParam    type DWORD_PTR,
     2 pszText   type LPSTR,
     2 cchText   fixed bin(31);
 define alias LPTBBUTTONINFOA handle TBBUTTONINFOA;

 define structure
   1 TBBUTTONINFOW,
     2 cbSize    type UINT,
     2 dwMask    type DWORD,
     2 idCommand fixed bin(31),
     2 iImage    fixed bin(31),
     2 fsState   type BYTE,
     2 fsStyle   type BYTE,
     2 cx        type WORD,
     2 lParam    type DWORD_PTR,
     2 pszText   type LPWSTR,
     2 cchText   fixed bin(31);
 define alias LPTBBUTTONINFOW handle TBBUTTONINFOW;

 %if UNICODE ^= '' %then %do;
 define alias   TBBUTTONINFO type   TBBUTTONINFOW;
 define alias LPTBBUTTONINFO type LPTBBUTTONINFOW;
 %end; %else %do;
 define alias   TBBUTTONINFO type   TBBUTTONINFOA;
 define alias LPTBBUTTONINFO type LPTBBUTTONINFOA;
 %end;

 /* BUTTONINFO APIs do NOT support the string pool. */
 dcl TB_GETBUTTONINFOW fixed bin(31) value(WM_USER + 63);
 dcl TB_SETBUTTONINFOW fixed bin(31) value(WM_USER + 64);
 dcl TB_GETBUTTONINFOA fixed bin(31) value(WM_USER + 65);
 dcl TB_SETBUTTONINFOA fixed bin(31) value(WM_USER + 66);

 %if UNICODE ^= '' %then %do;
 dcl TB_GETBUTTONINFO  fixed bin(31) value(TB_GETBUTTONINFOW);
 dcl TB_SETBUTTONINFO  fixed bin(31) value(TB_SETBUTTONINFOW);
 %end; %else %do;
 dcl TB_GETBUTTONINFO  fixed bin(31) value(TB_GETBUTTONINFOA);
 dcl TB_SETBUTTONINFO  fixed bin(31) value(TB_SETBUTTONINFOA);
 %end;


 dcl TB_INSERTBUTTONW  fixed bin(31) value(WM_USER + 67);
 dcl TB_ADDBUTTONSW    fixed bin(31) value(WM_USER + 68);

 dcl TB_HITTEST        fixed bin(31) value(WM_USER + 69);

 /* New post Win95/NT4 for InsertButton and AddButton.             */
 /* If iString member is a pointer to a string, it will be handled */
 /* as a string like listview (although LPSTR_TEXTCALLBACK is not  */
 /* supported).                                                    */

 %if UNICODE ^= '' %then %do;
 dcl TB_INSERTBUTTON   fixed bin(31) value(TB_INSERTBUTTONW);
 dcl TB_ADDBUTTONS     fixed bin(31) value(TB_ADDBUTTONSW);
 %end; %else %do;
 dcl TB_INSERTBUTTON   fixed bin(31) value(TB_INSERTBUTTONA);
 dcl TB_ADDBUTTONS     fixed bin(31) value(TB_ADDBUTTONSA);
 %end;

 dcl TB_SETDRAWTEXTFLAGS fixed bin(31) value(WM_USER + 70);
 /* wParam == mask lParam == bit values */

 %end; /* _WIN32_IE >= 0x0400 */

 %if #WIN32_IE >= 1280 %then %do;

 dcl TB_GETSTRINGW     fixed bin(31) value(WM_USER + 91);
 dcl TB_GETSTRINGA     fixed bin(31) value(WM_USER + 92);
 %if UNICODE ^= '' %then %do;
 dcl TB_GETSTRING      fixed bin(31) value(TB_GETSTRINGW);
 %end; %else %do;
 dcl TB_GETSTRING      fixed bin(31) value(TB_GETSTRINGA);
 %end;

 %end; /* _WIN32_IE >= 0x0500 */

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl TBMF_PAD            type DWORD value('00000001'xu);
 dcl TBMF_BARPAD         type DWORD value('00000002'xu);
 dcl TBMF_BUTTONSPACING  type DWORD value('00000004'xu);

 define structure
   1 TBMETRICS,
     2 cbSize          type UINT,
     2 dwMask          type DWORD,
     2 cxPad           fixed bin (31), /* PAD */
     2 cyPad           fixed bin (31),
     2 cxBarPad        fixed bin (31), /* BARPAD */
     2 cyBarPad        fixed bin (31),
     2 cxButtonSpacing fixed bin (31), /* BUTTONSPACING */
     2 cyButtonSpacing fixed bin (31);
 define alias LPTBMETRICS handle TBMETRICS;

 dcl TB_GETMETRICS      fixed bin (31) value(WM_USER + 101);
 dcl TB_SETMETRICS      fixed bin (31) value(WM_USER + 102);
 %end;


 %if #WIN32_WINNT >= 1281 %then %do;
 dcl TB_SETWINDOWTHEME  fixed bin (31) value(CCM_SETWINDOWTHEME);
 %end;

 dcl TBN_GETBUTTONINFOA fixed bin(31) value(TBN_FIRST-0);
 dcl TBN_BEGINDRAG      fixed bin(31) value(TBN_FIRST-1);
 dcl TBN_ENDDRAG        fixed bin(31) value(TBN_FIRST-2);
 dcl TBN_BEGINADJUST    fixed bin(31) value(TBN_FIRST-3);
 dcl TBN_ENDADJUST      fixed bin(31) value(TBN_FIRST-4);
 dcl TBN_RESET          fixed bin(31) value(TBN_FIRST-5);
 dcl TBN_QUERYINSERT    fixed bin(31) value(TBN_FIRST-6);
 dcl TBN_QUERYDELETE    fixed bin(31) value(TBN_FIRST-7);
 dcl TBN_TOOLBARCHANGE  fixed bin(31) value(TBN_FIRST-8);
 dcl TBN_CUSTHELP       fixed bin(31) value(TBN_FIRST-9);

 %if #WIN32_IE >= 768 %then %do;
 dcl TBN_DROPDOWN       fixed bin(31) value(TBN_FIRST - 10);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TBN_GETOBJECT      fixed bin(31) value(TBN_FIRST - 12);

 /* Structure for TBN_HOTITEMCHANGE notification */

 define structure
   1 NMTBHOTITEM unaligned,
     2 hdr     type NMHDR,
     2 idOld   fixed bin(31),
     2 idNew   fixed bin(31),
     2 dwFlags type DWORD;/* HICF_* */
 define alias LPNMTBHOTITEM handle NMTBHOTITEM;

 /* Hot item change flags */
 dcl HICF_OTHER        type DWORD value('00000000'xu);
 dcl HICF_MOUSE        type DWORD value('00000001'xu);
     /* Triggered by mouse */
 dcl HICF_ARROWKEYS    type DWORD value('00000002'xu);
     /* Triggered by arrow keys */
 dcl HICF_ACCELERATOR  type DWORD value('00000004'xu);
     /* Triggered by accelerator */
 dcl HICF_DUPACCEL     type DWORD value('00000008'xu);
     /* This accelerator is not unique */
 dcl HICF_ENTERING     type DWORD value('00000010'xu);
     /* idOld is invalid */
 dcl HICF_LEAVING      type DWORD value('00000020'xu);
     /* idNew is invalid */
 dcl HICF_RESELECT     type DWORD value('00000040'xu);
     /* hot item reselected */


 dcl TBN_HOTITEMCHANGE  fixed bin(31) value(TBN_FIRST - 13);
 dcl TBN_DRAGOUT        fixed bin(31) value(TBN_FIRST - 14);
     /* this is sent when the user clicks down on a button then drags */
     /* off the button                                                */
 dcl TBN_DELETINGBUTTON fixed bin(31) value(TBN_FIRST - 15);
     /* uses TBNOTIFY */
 dcl TBN_GETDISPINFOA   fixed bin(31) value(TBN_FIRST - 16);
     /* This is sent when the  toolbar needs  some display information*/
 dcl TBN_GETDISPINFOW   fixed bin(31) value(TBN_FIRST - 17);
     /* This is sent when the  toolbar needs  some display information*/
 dcl TBN_GETINFOTIPA    fixed bin(31) value(TBN_FIRST - 18);
 dcl TBN_GETINFOTIPW    fixed bin(31) value(TBN_FIRST - 19);
 dcl TBN_GETBUTTONINFOW fixed bin(31) value(TBN_FIRST - 20);
 %if #WIN32_IE >= 1280 %then %do;
 dcl TBN_RESTORE        fixed bin(31) value(TBN_FIRST - 21);
 dcl TBN_SAVE           fixed bin(31) value(TBN_FIRST - 22);
 dcl TBN_INITCUSTOMIZE  fixed bin(31) value(TBN_FIRST - 23);
 dcl TBNRF_HIDEHELP     type DWORD value('00000001'xu);
 dcl TBNRF_ENDCUSTOMIZE type DWORD value('00000002'xu);
 %end; /* (_WIN32_IE >= 0x0500) */


 %if #WIN32_IE >= 1280 %then %do;

 define structure
   1 NMTBSAVE unaligned,
     2 hdr              type NMHDR,
     2 pData            pointer,
     2 pCurrent         pointer,
     2 cbData           type UINT,
     2 iItem            fixed bin (31),
     2 cButtons         fixed bin (31),
     2 tbButton         type TBBUTTON;
 define alias LPNMTBSAVE handle NMTBSAVE;

 define structure
   1 NMTBRESTORE unaligned,
     2 hdr              type NMHDR,
     2 pData            pointer,
     2 pCurrent         pointer,
     2 cbData           type UINT,
     2 iItem            fixed bin (31),
     2 cButtons         fixed bin (31),
     2 cbBytesPerRecord fixed bin (31),
     2 tbButton         type TBBUTTON;
 define alias LPNMTBRESTORE handle NMTBRESTORE;
 %end; /* (_WIN32_IE >= 0x0500) */

 define structure
   1 NMTBGETINFOTIPA unaligned,
     2 hdr        type NMHDR,
     2 pszText    type LPSTR,
     2 cchTextMax fixed bin(31),
     2 iItem      fixed bin(31),
     2 lParam     type LPARAM;
 define alias LPNMTBGETINFOTIPA handle NMTBGETINFOTIPA;

 define structure
   1 NMTBGETINFOTIPW unaligned,
     2 hdr        type NMHDR,
     2 pszText    type LPWSTR,
     2 cchTextMax fixed bin(31),
     2 iItem      fixed bin(31),
     2 lParam     type LPARAM;
 define alias LPNMTBGETINFOTIPW handle NMTBGETINFOTIPW;

 %if UNICODE ^= '' %then %do;
 dcl TBN_GETINFOTIP fixed bin(31) value(TBN_GETINFOTIPW);
 define alias   NMTBGETINFOTIP type NMTBGETINFOTIPW;
 define alias LPNMTBGETINFOTIP type LPNMTBGETINFOTIPW;
 %end; %else %do;
 dcl TBN_GETINFOTIP fixed bin(31) value(TBN_GETINFOTIPA);
 define alias   NMTBGETINFOTIP type NMTBGETINFOTIPA;
 define alias LPNMTBGETINFOTIP type LPNMTBGETINFOTIPA;
 %end;

 dcl TBNF_IMAGE      type DWORD value('00000001'xu);
 dcl TBNF_TEXT       type DWORD value('00000002'xu);
 dcl TBNF_DI_SETITEM type DWORD value('10000000'xu);

 define structure
   1 NMTBDISPINFOA unaligned,
     2 hdr       type NMHDR,
     2 dwMask    type DWORD,/* [in] Specifies the values requested. */
       /* [out] Client ask the data to be set for future use */
     2 idCommand fixed bin(31),
       /* [in] id of button we're requesting info for */
     2 lParam    type DWORD_PTR,/* [in] lParam of button */
     2 iImage    fixed bin(31), /* [out] image index */
     2 pszText   type LPSTR,    /* [out] new text for item */
     2 cchText   fixed bin(31);
       /* [in] size of buffer pointed to by pszText */
 define alias LPNMTBDISPINFOA handle NMTBDISPINFOA;

 define structure
   1 NMTBDISPINFOW unaligned,
     2 hdr       type NMHDR,
     2 dwMask    type DWORD,/* [in] Specifies the values requested. */
       /* [out] Client ask the data to be set for future use */
     2 idCommand fixed bin(31),
       /* [in] id of button we're requesting info for */
     2 lParam    type DWORD_PTR,/* [in] lParam of button */
     2 iImage    fixed bin(31), /* [out] image index */
     2 pszText   type LPWSTR,   /* [out] new text for item */
     2 cchText   fixed bin(31);
       /* [in] size of buffer pointed to by pszText */
 define alias LPNMTBDISPINFOW handle NMTBDISPINFOW;

 %if UNICODE ^= '' %then %do;
 dcl TBN_GETDISPINFO fixed bin(31) value(TBN_GETDISPINFOW);
 define alias   NMTBDISPINFO type   NMTBDISPINFOW;
 define alias LPNMTBDISPINFO type LPNMTBDISPINFOW;
 %end; %else %do;
 dcl TBN_GETDISPINFO fixed bin(31) value(TBN_GETDISPINFOA);
 define alias   NMTBDISPINFO type   NMTBDISPINFOA;
 define alias LPNMTBDISPINFO type LPNMTBDISPINFOA;
 %end;

 /* Return codes for TBN_DROPDOWN */
 dcl TBDDRET_DEFAULT      fixed bin(31) value(0);
 dcl TBDDRET_NODEFAULT    fixed bin(31) value(1);
 dcl TBDDRET_TREATPRESSED fixed bin(31) value(2);
     /* Treat as a standard press button */

 %end;

 %if UNICODE ^= '' %then %do;
 dcl TBN_GETBUTTONINFO fixed bin(31) value(TBN_GETBUTTONINFOW);
 %end; %else %do;
 dcl TBN_GETBUTTONINFO fixed bin(31) value(TBN_GETBUTTONINFOA);
 %end;


 %if #WIN32_IE >= 768 %then %do;
 define structure
   1 NMTOOLBARA unaligned,
     2 hdr      type NMHDR,
     2 iItem    fixed bin(31),
     2 tbButton type TBBUTTON,
     2 cchText  fixed bin(31),
     2 pszText  type LPSTR;
 define alias LPNMTOOLBARA handle NMTOOLBARA;
 define alias   TBNOTIFYA  type   NMTOOLBARA;
 define alias LPTBNOTIFYA  type LPNMTOOLBARA;
 %end;


 %if #WIN32_IE >= 768 %then %do;
 define structure
   1 NMTOOLBARW unaligned,
     2 hdr      type NMHDR,
     2 iItem    fixed bin(31),
     2 tbButton type TBBUTTON,
     2 cchText  fixed bin(31),
     2 pszText  type LPWSTR;
 define alias LPNMTOOLBARW handle NMTOOLBARW;
 define alias   TBNOTIFYW  type   NMTOOLBARW;
 define alias LPTBNOTIFYW  type LPNMTOOLBARW;
 %end;

 %if UNICODE ^= '' %then %do;
 define alias   NMTOOLBAR type   NMTOOLBARW;
 define alias LPNMTOOLBAR type LPNMTOOLBARW;
 %end; %else %do;
 define alias   NMTOOLBAR type   NMTOOLBARA;
 define alias LPNMTOOLBAR type LPNMTOOLBARA;
 %end;

 define alias   TBNOTIFY type   NMTOOLBAR;
 define alias LPTBNOTIFY type LPNMTOOLBAR;

 %end;

 %end; /* NOTOOLBAR */



 %if #WIN32_IE >= 768 %then %do;
 /* ====== REBAR CONTROL ============================================ */

 %dcl NOREBAR char ext;
 %if NOREBAR = '' %then %do;


 %if #WIN32 ^= '' %then %do;
 dcl REBARCLASSNAMEW WCHAR value('ReBarWindow32');
 dcl REBARCLASSNAMEA char  value('ReBarWindow32');

 %dcl REBARCLASSNAME char ext;
 %if UNICODE ^= '' %then %do;
 %REBARCLASSNAME='REBARCLASSNAMEW';
 %end; %else %do;
 %REBARCLASSNAME='REBARCLASSNAMEA';
 %end;

 %end; %else %do;
 dcl REBARCLASSNAME char value('ReBarWindow');
 %end;

 dcl RBIM_IMAGELIST fixed bin(31) value('00000001'xn);


 %if #WIN32_IE >= 1024 %then %do;
 dcl RBS_TOOLTIPS        type DWORD value('0100'xu);
 dcl RBS_VARHEIGHT       type DWORD value('0200'xu);
 dcl RBS_BANDBORDERS     type DWORD value('0400'xu);
 dcl RBS_FIXEDORDER      type DWORD value('0800'xu);
 dcl RBS_REGISTERDROP    type DWORD value('1000'xu);
 dcl RBS_AUTOSIZE        type DWORD value('2000'xu);
 dcl RBS_VERTICALGRIPPER type DWORD value('4000'xu);
 /* this always has the vertical gripper (default for horizontal mode)*/
 dcl RBS_DBLCLKTOGGLE    type DWORD value('8000'xu);
 %end; %else %do;
 dcl RBS_TOOLTIPS        type DWORD value('00000100'xu);
 dcl RBS_VARHEIGHT       type DWORD value('00000200'xu);
 dcl RBS_BANDBORDERS     type DWORD value('00000400'xu);
 dcl RBS_FIXEDORDER      type DWORD value('00000800'xu);
 %end; /* _WIN32_IE >= 0x0400 */

 %if #WIN32_IE >= 1280 %then %do;
 dcl RBS_EX_OFFICE9      type DWORD value('00000001'xu);
     /* new gripper, chevron, focus handling */
 %end;

 define structure
   1 REBARINFO,
     2 cbSize type UINT,
     2 fMask  type UINT,
 %dcl NOIMAGEAPIS char ext;
 %if NOIMAGEAPIS = '' %then %do;
     2 himl   type HIMAGELIST;
 %end; %else %do;
     2 himl   type HANDLE;
 %end;
 define alias LPREBARINFO handle REBARINFO;

 dcl RBBS_BREAK          type UINT value('00000001'xu);
     /* break to new line */
 dcl RBBS_FIXEDSIZE      type UINT value('00000002'xu);
     /* band can't be sized */
 dcl RBBS_CHILDEDGE      type UINT value('00000004'xu);
     /* edge around top & bottom of child window */
 dcl RBBS_HIDDEN         type UINT value('00000008'xu);
     /* don't show */
 dcl RBBS_NOVERT         type UINT value('00000010'xu);
     /* don't show when vertical */
 dcl RBBS_FIXEDBMP       type UINT value('00000020'xu);
     /* bitmap doesn't move during band resize */

 %if #WIN32_IE >= 1024 %then %do;
 dcl RBBS_VARIABLEHEIGHT type UINT value('00000040'xu);
     /* allow autosizing of this child vertically */
 dcl RBBS_GRIPPERALWAYS  type UINT value('00000080'xu);
     /* always show the gripper */
 dcl RBBS_NOGRIPPER      type UINT value('00000100'xu);
     /* never show the gripper */
 %if #WIN32_IE >= 1280 %then %do;
 dcl RBBS_USECHEVRON     type UINT value('00000200'xu);
 %if #WIN32_IE >= 1281 %then %do;
 dcl RBBS_HIDETITLE      type UINT value('00000400'xu);
     /* keep band title hidden */
 dcl RBBS_TOPALIGN       type UINT value('00000800'xu);
 %end; /* 0x0501 */
 %end; /* 0x0500 */
 %end; /* 0x0400 */


 dcl RBBIM_STYLE         type UINT value('00000001'xu);
 dcl RBBIM_COLORS        type UINT value('00000002'xu);
 dcl RBBIM_TEXT          type UINT value('00000004'xu);
 dcl RBBIM_IMAGE         type UINT value('00000008'xu);
 dcl RBBIM_CHILD         type UINT value('00000010'xu);
 dcl RBBIM_CHILDSIZE     type UINT value('00000020'xu);
 dcl RBBIM_SIZE          type UINT value('00000040'xu);
 dcl RBBIM_BACKGROUND    type UINT value('00000080'xu);
 dcl RBBIM_ID            type UINT value('00000100'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl RBBIM_IDEALSIZE     type UINT value('00000200'xu);
 dcl RBBIM_LPARAM        type UINT value('00000400'xu);
 dcl RBBIM_HEADERSIZE    type UINT value('00000800'xu);
     /* control the size of the header */
 %end;

 define structure
   1 REBARBANDINFOA,
     2 cbSize     type UINT,
     2 fMask      type UINT,
     2 fStyle     type UINT,
     2 clrFore    type COLORREF,
     2 clrBack    type COLORREF,
     2 lpText     type LPSTR,
     2 cch        type UINT,
     2 iImage     fixed bin(31),
     2 hwndChild  type HWND,
     2 cxMinChild type UINT,
     2 cyMinChild type UINT,
     2 cx         type UINT,
     2 hbmBack    type HBITMAP,
     2 wID        type UINT
 %if #WIN32_IE >= 1024 %then %do;
   , 2 cyChild    type UINT,
     2 cyMaxChild type UINT,
     2 cyIntegral type UINT,
     2 cxIdeal    type UINT,
     2 lParam     type LPARAM,
     2 cxHeader   type UINT
 %end;
   ;
 define alias  LPREBARBANDINFOA handle REBARBANDINFOA;
 define alias LPCREBARBANDINFOA handle REBARBANDINFOA;
 dcl REBARBANDINFOA_V3_SIZE fixed bin(31)
     value(CCSIZEOF_STRUCT (REBARBANDINFOA, wID));


 define structure
   1 REBARBANDINFOW,
     2 cbSize     type UINT,
     2 fMask      type UINT,
     2 fStyle     type UINT,
     2 clrFore    type COLORREF,
     2 clrBack    type COLORREF,
     2 lpText     type LPWSTR,
     2 cch        type UINT,
     2 iImage     fixed bin(31),
     2 hwndChild  type HWND,
     2 cxMinChild type UINT,
     2 cyMinChild type UINT,
     2 cx         type UINT,
     2 hbmBack    type HBITMAP,
     2 wID        type UINT
 %if #WIN32_IE >= 1024 %then %do;
   , 2 cyChild    type UINT,
     2 cyMaxChild type UINT,
     2 cyIntegral type UINT,
     2 cxIdeal    type UINT,
     2 lParam     type LPARAM,
     2 cxHeader   type UINT
 %end;
   ;
 define alias  LPREBARBANDINFOW handle REBARBANDINFOW;
 define alias LPCREBARBANDINFOW handle REBARBANDINFOW;
 dcl REBARBANDINFOW_V3_SIZE fixed bin(31)
     value(CCSIZEOF_STRUCT (REBARBANDINFOW, wID));

 %if UNICODE ^= '' %then %do;
 define alias    REBARBANDINFO type    REBARBANDINFOW;
 define alias  LPREBARBANDINFO type  LPREBARBANDINFOW;
 define alias LPCREBARBANDINFO type LPCREBARBANDINFOW;
 dcl REBARBANDINFO_V3_SIZE fixed bin(31) value(REBARBANDINFOW_V3_SIZE);
 %end; %else %do;
 define alias    REBARBANDINFO type   REBARBANDINFOA;
 define alias  LPREBARBANDINFO type  LPREBARBANDINFOA;
 define alias LPCREBARBANDINFO type LPCREBARBANDINFOA;
 dcl REBARBANDINFO_V3_SIZE fixed bin(31) value(REBARBANDINFOA_V3_SIZE);
 %end;

 dcl RB_INSERTBANDA  fixed bin(31) value(WM_USER +  1);
 dcl RB_DELETEBAND   fixed bin(31) value(WM_USER +  2);
 dcl RB_GETBARINFO   fixed bin(31) value(WM_USER +  3);
 dcl RB_SETBARINFO   fixed bin(31) value(WM_USER +  4);

 %if #WIN32_IE < 1024 %then %do;
 dcl RB_GETBANDINFO  fixed bin(31) value(WM_USER +  5);
 %end;
 dcl RB_SETBANDINFOA fixed bin(31) value(WM_USER +  6);
 dcl RB_SETPARENT    fixed bin(31) value(WM_USER +  7);

 %if #WIN32_IE >= 1024 %then %do;
 dcl RB_HITTEST      fixed bin(31) value(WM_USER +  8);
 dcl RB_GETRECT      fixed bin(31) value(WM_USER +  9);
 %end;
 dcl RB_INSERTBANDW  fixed bin(31) value(WM_USER +  10);
 dcl RB_SETBANDINFOW fixed bin(31) value(WM_USER +  11);
 dcl RB_GETBANDCOUNT fixed bin(31) value(WM_USER +  12);
 dcl RB_GETROWCOUNT  fixed bin(31) value(WM_USER +  13);
 dcl RB_GETROWHEIGHT fixed bin(31) value(WM_USER +  14);

 %if #WIN32_IE >= 1024 %then %do;
 dcl RB_IDTOINDEX    fixed bin(31) value(WM_USER +  16);
     /* wParam == id */
 dcl RB_GETTOOLTIPS  fixed bin(31) value(WM_USER +  17);
 dcl RB_SETTOOLTIPS  fixed bin(31) value(WM_USER +  18);
 dcl RB_SETBKCOLOR   fixed bin(31) value(WM_USER +  19);
     /* sets the default BK color */
 dcl RB_GETBKCOLOR   fixed bin(31) value(WM_USER +  20);
     /* defaults to CLR_NONE */
 dcl RB_SETTEXTCOLOR fixed bin(31) value(WM_USER +  21);
 dcl RB_GETTEXTCOLOR fixed bin(31) value(WM_USER +  22);
     /* defaults to 0x00000000 */
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl RBSTR_CHANGERECT fixed bin(31) value('0001'xn);
     /* flags for RB_SIZETORECT */
 %end;
 dcl RB_SIZETORECT   fixed bin(31) value(WM_USER +  23);
     /* resize the rebar/break bands and such to this rect (lparam) */
 %end; /* _WIN32_IE >= 0x0400 */

 dcl RB_SETCOLORSCHEME   fixed bin(31) value(CCM_SETCOLORSCHEME);
     /* lParam is color scheme */
 dcl RB_GETCOLORSCHEME   fixed bin(31) value(CCM_GETCOLORSCHEME);
     /* fills in COLORSCHEME pointed to by lParam */

 %if UNICODE ^= '' %then %do;
 dcl RB_INSERTBAND       fixed bin(31) value(RB_INSERTBANDW);
 dcl RB_SETBANDINFO      fixed bin(31) value(RB_SETBANDINFOW);
 %end; %else %do;
 dcl RB_INSERTBAND       fixed bin(31) value(RB_INSERTBANDA);
 dcl RB_SETBANDINFO      fixed bin(31) value(RB_SETBANDINFOA);
 %end;


 %if #WIN32_IE >= 1024 %then %do;
 /* for manual drag control */
 /* lparam == cursor pos */
 /* -1 means do it yourself. */
 /* -2 means use what you had saved before */
 dcl RB_BEGINDRAG        fixed bin(31) value(WM_USER + 24);
 dcl RB_ENDDRAG          fixed bin(31) value(WM_USER + 25);
 dcl RB_DRAGMOVE         fixed bin(31) value(WM_USER + 26);
 dcl RB_GETBARHEIGHT     fixed bin(31) value(WM_USER + 27);
 dcl RB_GETBANDINFOW     fixed bin(31) value(WM_USER + 28);
 dcl RB_GETBANDINFOA     fixed bin(31) value(WM_USER + 29);

 %if UNICODE ^= '' %then %do;
 dcl RB_GETBANDINFO      fixed bin(31) value(RB_GETBANDINFOW);
 %end; %else %do;
 dcl RB_GETBANDINFO      fixed bin(31) value(RB_GETBANDINFOA);
 %end;

 dcl RB_MINIMIZEBAND     fixed bin(31) value(WM_USER + 30);
 dcl RB_MAXIMIZEBAND     fixed bin(31) value(WM_USER + 31);

 dcl RB_GETDROPTARGET    fixed bin(31) value(CCM_GETDROPTARGET);

 dcl RB_GETBANDBORDERS   fixed bin(31) value(WM_USER + 34);
 /* returns in lparam = lprc the amount of edges added to band wparam */

 dcl RB_SHOWBAND         fixed bin(31) value(WM_USER + 35);
     /* show/hide band */
 dcl RB_SETPALETTE       fixed bin(31) value(WM_USER + 37);
 dcl RB_GETPALETTE       fixed bin(31) value(WM_USER + 38);
 dcl RB_MOVEBAND         fixed bin(31) value(WM_USER + 39);

 dcl RB_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 dcl RB_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);

 %end; /* _WIN32_IE >= 0x0400 */

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl RB_GETBANDMARGINS   fixed bin(31) value(WM_USER + 40);
 dcl RB_SETWINDOWTHEME   fixed bin(31) value(CCM_SETWINDOWTHEME);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl RB_PUSHCHEVRON      fixed bin(31) value(WM_USER + 43);
 %end; /* _WIN32_IE >= 0x0500 */

 dcl RBN_HEIGHTCHANGE    fixed bin(31) value(RBN_FIRST - 0);

 %if #WIN32_IE >= 1024 %then %do;
 dcl RBN_GETOBJECT       fixed bin(31) value(RBN_FIRST - 1);
 dcl RBN_LAYOUTCHANGED   fixed bin(31) value(RBN_FIRST - 2);
 dcl RBN_AUTOSIZE        fixed bin(31) value(RBN_FIRST - 3);
 dcl RBN_BEGINDRAG       fixed bin(31) value(RBN_FIRST - 4);
 dcl RBN_ENDDRAG         fixed bin(31) value(RBN_FIRST - 5);
 dcl RBN_DELETINGBAND    fixed bin(31) value(RBN_FIRST - 6);
     /* Uses NMREBAR */
 dcl RBN_DELETEDBAND     fixed bin(31) value(RBN_FIRST - 7);
     /* Uses NMREBAR */
 dcl RBN_CHILDSIZE       fixed bin(31) value(RBN_FIRST - 8);

 %if #WIN32_IE >= 1280 %then %do;
 dcl RBN_CHEVRONPUSHED   fixed bin(31) value(RBN_FIRST - 10);
 %end; /* _WIN32_IE >= 0x0500 */

 %if #WIN32_IE >= 1280 %then %do;
 dcl RBN_MINMAX          fixed bin(31) value(RBN_FIRST - 21);
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl RBN_AUTOBREAK       fixed bin(31) value(RBN_FIRST - 22);
 %end;

 define structure
   1 NMREBARCHILDSIZE unaligned,
     2 hdr     type NMHDR,
     2 uBand   type UINT,
     2 wID     type UINT,
     2 rcChild type RECT,
     2 rcBand  type RECT;
 define alias LPNMREBARCHILDSIZE handle NMREBARCHILDSIZE;

 define structure
   1 NMREBAR unaligned,
     2 hdr    type NMHDR,
     2 dwMask type DWORD,/* RBNM_* */
     2 uBand  type UINT,
     2 fStyle type UINT,
     2 wID    type UINT,
     2 lParam type LPARAM;
 define alias LPNMREBAR handle NMREBAR;

 /* Mask flags for NMREBAR */
 dcl RBNM_ID     type DWORD value('00000001'xu);
 dcl RBNM_STYLE  type DWORD value('00000002'xu);
 dcl RBNM_LPARAM type DWORD value('00000004'xu);


 define structure
   1 NMRBAUTOSIZE unaligned,
     2 hdr      type NMHDR,
     2 fChanged type BOOL,
     2 rcTarget type RECT,
     2 rcActual type RECT;
 define alias LPNMRBAUTOSIZE handle NMRBAUTOSIZE;

 %if #WIN32_IE >= 1280 %then %do;
 define structure
   1 NMREBARCHEVRON unaligned,
     2 hdr    type NMHDR,
     2 uBand  type UINT,
     2 wID    type UINT,
     2 lParam type LPARAM,
     2 rc     type RECT;
 define alias LPNMREBARCHEVRON handle NMREBARCHEVRON;
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl RBAB_AUTOSIZE   type UINT value('0001'xu);
     /* These are not flags and are all mutually exclusive */
 dcl RBAB_ADDBAND    type UINT value('0002'xu);

 define structure
   1 NMREBARAUTOBREAK unaligned,
     2 hdr           type NMHDR,
     2 uBand         type UINT,
     2 wID           type UINT,
     2 lParam        type LPARAM,
     2 uMsg          type UINT,
     2 fStyleCurrent type UINT,
     2 fAutoBreak    type BOOL;
 define alias LPNMREBARAUTOBREAK handle NMREBARAUTOBREAK;
 %end;

 dcl RBHT_NOWHERE type UINT value('0001'xu);
 dcl RBHT_CAPTION type UINT value('0002'xu);
 dcl RBHT_CLIENT  type UINT value('0003'xu);
 dcl RBHT_GRABBER type UINT value('0004'xu);
 %if #WIN32_IE >= 1280 %then %do;
 dcl RBHT_CHEVRON type UINT value('0008'xu);
 %end;

 define structure
   1 RB_HITTESTINFO,
     2 pt    type POINT,
     2 flags type UINT,
     2 iBand fixed bin(31);
 define alias LPRBHITTESTINFO handle RB_HITTESTINFO;

 %end; /* _WIN32_IE >= 0x0400 */

 %end; /* NOREBAR */

 %end; /* _WIN32_IE >= 0x0300 */

 /* ====== TOOLTIPS CONTROL ========================================= */

 %dcl NOTOOLTIPS char ext;
 %if NOTOOLTIPS = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl TOOLTIPS_CLASSW WCHAR value('tooltips_class32');
 dcl TOOLTIPS_CLASSA char  value('tooltips_class32');

 %dcl TOOLTIPS_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %TOOLTIPS_CLASS='TOOLTIPS_CLASSW';
 %end; %else %do;
 %TOOLTIPS_CLASS='TOOLTIPS_CLASSA';
 %end;

 %end; %else %do;
 dcl TOOLTIPS_CLASS char value('tooltips_class');
 %end;


 define structure
   1 TOOLINFOA,
     2 cbSize   type UINT,
     2 uFlags   type UINT,
     2 hwnd     type HWND,
     2 uId      type UINT,
     2 rect     type RECT,
     2 hinst    type HINSTANCE,
     2 lpszText type LPSTR
 %if #WIN32_IE >= 768 %then %do;
   , 2 lParam   type LPARAM
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 lpReserved pointer
 %end;
   ;
 define alias    PTOOLINFOA handle TOOLINFOA;
 define alias   LPTOOLINFOA handle TOOLINFOA;
 define alias   TTTOOLINFOA type   TOOLINFOA;
 define alias  PTTTOOLINFOA handle TOOLINFOA;
 define alias LPTTTOOLINFOA handle TOOLINFOA;
 dcl TTTOOLINFOA_V1_SIZE fixed bin (31)
     value(CCSIZEOF_STRUCT (TTTOOLINFOA, lpszText));

 define structure
   1 TOOLINFOW,
     2 cbSize   type UINT,
     2 uFlags   type UINT,
     2 hwnd     type HWND,
     2 uId      type UINT,
     2 rect     type RECT,
     2 hinst    type HINSTANCE,
     2 lpszText type LPWSTR
 %if #WIN32_IE >= 768 %then %do;
   , 2 lParam   type LPARAM
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 lpReserved pointer
 %end;
   ;
 define alias    PTOOLINFOW handle TOOLINFOW;
 define alias   LPTOOLINFOW handle TOOLINFOW;
 define alias   TTTOOLINFOW type   TOOLINFOW;
 define alias  PTTTOOLINFOW handle TOOLINFOW;
 define alias LPTTTOOLINFOW handle TOOLINFOW;
 dcl TTTOOLINFOW_V1_SIZE fixed bin (31)
     value(CCSIZEOF_STRUCT (TTTOOLINFOW, lpszText));

 %if UNICODE ^= '' %then %do;
 define alias     TOOLINFO type     TOOLINFOW;
 define alias    PTOOLINFO type    PTOOLINFOW;
 define alias   LPTOOLINFO type   LPTOOLINFOW;
 define alias   TTTOOLINFO type   TTTOOLINFOW;
 define alias  PTTTOOLINFO type  PTTTOOLINFOW;
 define alias LPTTTOOLINFO type LPTTTOOLINFOW;
 dcl TTTOOLINFO_V1_SIZE fixed bin (31) value(TTTOOLINFOW_V1_SIZE);
 %end; %else %do;
 define alias     TOOLINFO type     TOOLINFOA;
 define alias    PTOOLINFO type    PTOOLINFOA;
 define alias   LPTOOLINFO type   LPTOOLINFOA;
 define alias   TTTOOLINFO type   TTTOOLINFOA;
 define alias  PTTTOOLINFO type  PTTTOOLINFOA;
 define alias LPTTTOOLINFO type LPTTTOOLINFOA;
 dcl TTTOOLINFO_V1_SIZE fixed bin (31) value(TTTOOLINFOA_V1_SIZE);
 %end;

 /* begin_r_commctrl */

 dcl TTS_ALWAYSTIP       type DWORD value('01'xu);
 dcl TTS_NOPREFIX        type DWORD value('02'xu);

 %if #WIN32_IE >= 1280 %then %do;
 dcl TTS_NOANIMATE       type DWORD value('10'xu);
 dcl TTS_NOFADE          type DWORD value('20'xu);
 dcl TTS_BALLOON         type DWORD value('40'xu);
 dcl TTS_CLOSE           type DWORD value('80'xu);
 %end;
 /* end_r_commctrl */

 dcl TTF_IDISHWND        type DWORD value('0001'xu);

 /* Use this to center around trackpoint in trackmode */
 /* -OR- to center around tool in normal mode.        */
 /* Use TTF_ABSOLUTE to place the tip exactly at the track coords */
 /* when in tracking mode.                                        */
 /* TTF_ABSOLUTE can be used in conjunction with TTF_CENTERTIP */
 /* to center the tip absolutely about the track point.        */

 dcl TTF_CENTERTIP       type UINT value('0002'xu);
 dcl TTF_RTLREADING      type UINT value('0004'xu);
 dcl TTF_SUBCLASS        type UINT value('0010'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl TTF_TRACK           type UINT value('0020'xu);
 dcl TTF_ABSOLUTE        type UINT value('0080'xu);
 dcl TTF_TRANSPARENT     type UINT value('0100'xu);
 %if #WIN32_IE >= 1281 %then %do;
 dcl TTF_PARSELINKS      type UINT value('1000'xu);
 %end; /* _WIN32_IE >= 0x0501 */
 dcl TTF_DI_SETITEM      type UINT value('8000'xu);
     /* valid only on the TTN_NEEDTEXT callback */
 %end; /* _WIN32_IE >= 0x0300 */

 dcl TTDT_AUTOMATIC      fixed bin(31) value(0);
 dcl TTDT_RESHOW         fixed bin(31) value(1);
 dcl TTDT_AUTOPOP        fixed bin(31) value(2);
 dcl TTDT_INITIAL        fixed bin(31) value(3);

 dcl TTM_ACTIVATE        fixed bin(31) value(WM_USER + 1);
 dcl TTM_SETDELAYTIME    fixed bin(31) value(WM_USER + 3);
 dcl TTM_ADDTOOLA        fixed bin(31) value(WM_USER + 4);
 dcl TTM_ADDTOOLW        fixed bin(31) value(WM_USER + 50);
 dcl TTM_DELTOOLA        fixed bin(31) value(WM_USER + 5);
 dcl TTM_DELTOOLW        fixed bin(31) value(WM_USER + 51);
 dcl TTM_NEWTOOLRECTA    fixed bin(31) value(WM_USER + 6);
 dcl TTM_NEWTOOLRECTW    fixed bin(31) value(WM_USER + 52);
 dcl TTM_RELAYEVENT      fixed bin(31) value(WM_USER + 7);

 dcl TTM_GETTOOLINFOA    fixed bin(31) value(WM_USER + 8);
 dcl TTM_GETTOOLINFOW    fixed bin(31) value(WM_USER + 53);

 dcl TTM_SETTOOLINFOA    fixed bin(31) value(WM_USER + 9);
 dcl TTM_SETTOOLINFOW    fixed bin(31) value(WM_USER + 54);

 dcl TTM_HITTESTA        fixed bin(31) value(WM_USER +10);
 dcl TTM_HITTESTW        fixed bin(31) value(WM_USER +55);
 dcl TTM_GETTEXTA        fixed bin(31) value(WM_USER +11);
 dcl TTM_GETTEXTW        fixed bin(31) value(WM_USER +56);
 dcl TTM_UPDATETIPTEXTA  fixed bin(31) value(WM_USER +12);
 dcl TTM_UPDATETIPTEXTW  fixed bin(31) value(WM_USER +57);
 dcl TTM_GETTOOLCOUNT    fixed bin(31) value(WM_USER +13);
 dcl TTM_ENUMTOOLSA      fixed bin(31) value(WM_USER +14);
 dcl TTM_ENUMTOOLSW      fixed bin(31) value(WM_USER +58);
 dcl TTM_GETCURRENTTOOLA fixed bin(31) value(WM_USER + 15);
 dcl TTM_GETCURRENTTOOLW fixed bin(31) value(WM_USER + 59);
 dcl TTM_WINDOWFROMPOINT fixed bin(31) value(WM_USER + 16);

 %if #WIN32_IE >= 768 %then %do;
 dcl TTM_TRACKACTIVATE   fixed bin(31) value(WM_USER + 17);
     /* wParam = TRUE/FALSE start end  lparam = LPTOOLINFO */
 dcl TTM_TRACKPOSITION   fixed bin(31) value(WM_USER + 18);
     /* lParam = dwPos */
 dcl TTM_SETTIPBKCOLOR   fixed bin(31) value(WM_USER + 19);
 dcl TTM_SETTIPTEXTCOLOR fixed bin(31) value(WM_USER + 20);
 dcl TTM_GETDELAYTIME    fixed bin(31) value(WM_USER + 21);
 dcl TTM_GETTIPBKCOLOR   fixed bin(31) value(WM_USER + 22);
 dcl TTM_GETTIPTEXTCOLOR fixed bin(31) value(WM_USER + 23);
 dcl TTM_SETMAXTIPWIDTH  fixed bin(31) value(WM_USER + 24);
 dcl TTM_GETMAXTIPWIDTH  fixed bin(31) value(WM_USER + 25);
 dcl TTM_SETMARGIN       fixed bin(31) value(WM_USER + 26);
     /* lParam = lprc */
 dcl TTM_GETMARGIN       fixed bin(31) value(WM_USER + 27);
     /* lParam = lprc */
 dcl TTM_POP             fixed bin(31) value(WM_USER + 28);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TTM_UPDATE          fixed bin(31) value(WM_USER + 29);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl TTM_GETBUBBLESIZE   fixed bin(31) value(WM_USER + 30);
 dcl TTM_ADJUSTRECT      fixed bin(31) value(WM_USER + 31);
 dcl TTM_SETTITLEA       fixed bin(31) value(WM_USER + 32);
     /* wParam = TTI_*, lParam = char* szTitle */
 dcl TTM_SETTITLEW       fixed bin(31) value(WM_USER + 33);
     /* wParam = TTI_*, lParam = wchar* szTitle */
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl TTM_POPUP           fixed bin(31) value(WM_USER + 34);
 dcl TTM_GETTITLE        fixed bin(31) value(WM_USER + 35);
     /* wParam = 0, lParam = TTGETTITLE* */

 define structure
   1 TTGETTITLE,
     2 dwSize       type DWORD,
     2 uTitleBitmap type UINT,
     2 cch          type UINT,
     2 pszTitle     pointer; /* to WCHAR(*) varz */
 define alias PTTGETTITLE handle TTGETTITLE;
 %end;

 %if UNICODE ^= '' %then %do;
 dcl TTM_ADDTOOL        fixed bin(31) value(TTM_ADDTOOLW);
 dcl TTM_DELTOOL        fixed bin(31) value(TTM_DELTOOLW);
 dcl TTM_NEWTOOLRECT    fixed bin(31) value(TTM_NEWTOOLRECTW);
 dcl TTM_GETTOOLINFO    fixed bin(31) value(TTM_GETTOOLINFOW);
 dcl TTM_SETTOOLINFO    fixed bin(31) value(TTM_SETTOOLINFOW);
 dcl TTM_HITTEST        fixed bin(31) value(TTM_HITTESTW);
 dcl TTM_GETTEXT        fixed bin(31) value(TTM_GETTEXTW);
 dcl TTM_UPDATETIPTEXT  fixed bin(31) value(TTM_UPDATETIPTEXTW);
 dcl TTM_ENUMTOOLS      fixed bin(31) value(TTM_ENUMTOOLSW);
 dcl TTM_GETCURRENTTOOL fixed bin(31) value(TTM_GETCURRENTTOOLW);
 %if #WIN32_IE >= 1280 %then %do;
 dcl TTM_SETTITLE       fixed bin(31) value(TTM_SETTITLEW);
 %end;
 %end; %else %do;
 dcl TTM_ADDTOOL        fixed bin(31) value(TTM_ADDTOOLA);
 dcl TTM_DELTOOL        fixed bin(31) value(TTM_DELTOOLA);
 dcl TTM_NEWTOOLRECT    fixed bin(31) value(TTM_NEWTOOLRECTA);
 dcl TTM_GETTOOLINFO    fixed bin(31) value(TTM_GETTOOLINFOA);
 dcl TTM_SETTOOLINFO    fixed bin(31) value(TTM_SETTOOLINFOA);
 dcl TTM_HITTEST        fixed bin(31) value(TTM_HITTESTA);
 dcl TTM_GETTEXT        fixed bin(31) value(TTM_GETTEXTA);
 dcl TTM_UPDATETIPTEXT  fixed bin(31) value(TTM_UPDATETIPTEXTA);
 dcl TTM_ENUMTOOLS      fixed bin(31) value(TTM_ENUMTOOLSA);
 dcl TTM_GETCURRENTTOOL fixed bin(31) value(TTM_GETCURRENTTOOLA);
 %if #WIN32_IE >= 1280 %then %do;
 dcl TTM_SETTITLE       fixed bin(31) value(TTM_SETTITLEA);
 %end;
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl TTM_SETWINDOWTHEME fixed bin(31) value(CCM_SETWINDOWTHEME);
 %end;

 define structure
   1 TTHITTESTINFOA,
     2 hwnd type HWND,
     2 pt   type POINT,
     2 ti   type TTTOOLINFOA;
 define alias LPTTHITTESTINFOA handle TTHITTESTINFOA;
 define alias   HITTESTINFOA   type TTHITTESTINFOA;
 define alias LPHITTESTINFOA handle HITTESTINFOA;

 define structure
   1 TTHITTESTINFOW,
     2 hwnd type HWND,
     2 pt   type POINT,
     2 ti   type TTTOOLINFOW;
 define alias LPTTHITTESTINFOW handle TTHITTESTINFOW;
 define alias   HITTESTINFOW   type TTHITTESTINFOW;
 define alias LPHITTESTINFOW handle HITTESTINFOW;


 %if UNICODE ^= '' %then %do;
 define alias   TTHITTESTINFO type   TTHITTESTINFOW;
 define alias LPTTHITTESTINFO type LPTTHITTESTINFOW;
 define alias   HITTESTINFO type   HITTESTINFOW;
 define alias LPHITTESTINFO type LPHITTESTINFOW;
 %end; %else %do;
 define alias   TTHITTESTINFO type   TTHITTESTINFOA;
 define alias LPTTHITTESTINFO type LPTTHITTESTINFOA;
 define alias   HITTESTINFO type   HITTESTINFOA;
 define alias LPHITTESTINFO type LPHITTESTINFOA;
 %end;

 dcl TTN_GETDISPINFOA fixed bin(31) value(TTN_FIRST - 0);
 dcl TTN_GETDISPINFOW fixed bin(31) value(TTN_FIRST - 10);
 dcl TTN_SHOW         fixed bin(31) value(TTN_FIRST - 1);
 dcl TTN_POP          fixed bin(31) value(TTN_FIRST - 2);


 %if UNICODE ^= '' %then %do;
 dcl TTN_GETDISPINFO fixed bin(31) value(TTN_GETDISPINFOW);
 %end; %else %do;
 dcl TTN_GETDISPINFO fixed bin(31) value(TTN_GETDISPINFOA);
 %end;

 dcl TTN_NEEDTEXT    fixed bin(31) value(TTN_GETDISPINFO);
 dcl TTN_NEEDTEXTA   fixed bin(31) value(TTN_GETDISPINFOA);
 dcl TTN_NEEDTEXTW   fixed bin(31) value(TTN_GETDISPINFOW);

 define structure
   1 NMTTDISPINFOA unaligned,
     2 hdr      type NMHDR,
     2 lpszText type LPSTR,
     2 szText   char(80-1) varz,
     2 hinst    type HINSTANCE,
     2 uFlags   type UINT
 %if #WIN32_IE >= 768 %then %do;
   , 2 lParam   type LPARAM
 %end;
   ;
 define alias LPNMTTDISPINFOA handle NMTTDISPINFOA;
 define alias   TOOLTIPTEXTA  type   NMTTDISPINFOA;
 define alias LPTOOLTIPTEXTA  type LPNMTTDISPINFOA;
 dcl NMTTDISPINFOA_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (NMTTDISPINFOA, uFlags));

 define structure
   1 NMTTDISPINFOW unaligned,
     2 hdr      type NMHDR,
     2 lpszText type LPWSTR,
     2 szText   WCHAR (80-1) varz,
     2 hinst    type HINSTANCE,
     2 uFlags   type UINT
 %if #WIN32_IE >= 768 %then %do;
   , 2 lParam   type LPARAM
 %end;
   ;
 define alias LPNMTTDISPINFOW handle NMTTDISPINFOW;
 define alias   TOOLTIPTEXTW  type   NMTTDISPINFOW;
 define alias LPTOOLTIPTEXTW  type LPNMTTDISPINFOW;
 dcl NMTTDISPINFOW_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (NMTTDISPINFOW, uFlags));


 %if UNICODE ^= '' %then %do;
 define alias   NMTTDISPINFO type   NMTTDISPINFOW;
 define alias LPNMTTDISPINFO type LPNMTTDISPINFOW;
 define alias   TOOLTIPTEXT  type   TOOLTIPTEXTW;
 define alias LPTOOLTIPTEXT  type LPTOOLTIPTEXTW;
 dcl NMTTDISPINFO_V1_SIZE fixed bin(31) value(NMTTDISPINFOW_V1_SIZE);
 %end; %else %do;
 define alias   NMTTDISPINFO type   NMTTDISPINFOA;
 define alias LPNMTTDISPINFO type LPNMTTDISPINFOA;
 define alias   TOOLTIPTEXT  type   TOOLTIPTEXTA;
 define alias LPTOOLTIPTEXT  type LPTOOLTIPTEXTA;
 dcl NMTTDISPINFO_V1_SIZE fixed bin(31) value(NMTTDISPINFOA_V1_SIZE);
 %end;

 %end; /* NOTOOLTIPS */


 /* ====== STATUS BAR CONTROL ======================================= */

 %dcl NOSTATUSBAR char ext;
 %if NOSTATUSBAR = '' %then %do;

 /* begin_r_commctrl */

 dcl SBARS_SIZEGRIP type UINT value('0100'xu);
 %if #WIN32_IE >= 1280 %then %do;
 dcl SBARS_TOOLTIPS type UINT value('0800'xu);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 /* this is a status bar flag, preference to SBARS_TOOLTIPS */
 dcl SBT_TOOLTIPS   type UINT value('0800'xu);
 %end;

 /* end_r_commctrl */

 dcl DrawStatusTextA
     entry (type HDC,
            type RECT byaddr,
            char(*) varz byaddr nonasgn,
            type UINT)
     WINCOMMCTRLAPI WINAPI external('DrawStatusTextA');

 dcl DrawStatusTextW
     entry (type HDC,
            type RECT byaddr,
            WCHAR(*) varz byaddr nonasgn,
            type UINT)
     WINCOMMCTRLAPI WINAPI external('DrawStatusTextW');

 dcl CreateStatusWindowA
     entry (type LONG,
            char(*) varz byaddr nonasgn,
            type HWND,
            type UINT)
     returns (type HWND byvalue optional)
     WINCOMMCTRLAPI WINAPI external('CreateStatusWindowA');

 dcl CreateStatusWindowW
     entry (type LONG,
            WCHAR(*) varz byaddr nonasgn,
            type HWND,
            type UINT)
     returns (type HWND byvalue optional)
     WINCOMMCTRLAPI WINAPI external('CreateStatusWindowW');

 %dcl CreateStatusWindow char ext;
 %dcl DrawStatusText char ext;
 %if UNICODE ^= '' %then %do;
   %CreateStatusWindow='CreateStatusWindowW';
   %DrawStatusText='DrawStatusTextW';
 %end; %else %do;
   %CreateStatusWindow='CreateStatusWindowA';
   %DrawStatusText='DrawStatusTextA';
 %end;


 %if #WIN32 ^= '' %then %do;
 dcl STATUSCLASSNAMEW WCHAR value('msctls_statusbar32');
 dcl STATUSCLASSNAMEA char  value('msctls_statusbar32');

 %dcl STATUSCLASSNAME char ext;
 %if UNICODE ^= '' %then %do;
 %STATUSCLASSNAME='STATUSCLASSNAMEW';
 %end; %else %do;
 %STATUSCLASSNAME='STATUSCLASSNAMEA';
 %end;

 %end; %else %do;
 dcl STATUSCLASSNAME char value('msctls_statusbar');
 %end;

 dcl SB_SETTEXTA          fixed bin(31) value(WM_USER+1);
 dcl SB_SETTEXTW          fixed bin(31) value(WM_USER+11);
 dcl SB_GETTEXTA          fixed bin(31) value(WM_USER+2);
 dcl SB_GETTEXTW          fixed bin(31) value(WM_USER+13);
 dcl SB_GETTEXTLENGTHA    fixed bin(31) value(WM_USER+3);
 dcl SB_GETTEXTLENGTHW    fixed bin(31) value(WM_USER+12);

 %if UNICODE ^= '' %then %do;
 dcl SB_GETTEXT           fixed bin(31) value(SB_GETTEXTW);
 dcl SB_SETTEXT           fixed bin(31) value(SB_SETTEXTW);
 dcl SB_GETTEXTLENGTH     fixed bin(31) value(SB_GETTEXTLENGTHW);
 %end; %else %do;
 dcl SB_GETTEXT           fixed bin(31) value(SB_GETTEXTA);
 dcl SB_SETTEXT           fixed bin(31) value(SB_SETTEXTA);
 dcl SB_GETTEXTLENGTH     fixed bin(31) value(SB_GETTEXTLENGTHA);
 %end;


 dcl SB_SETPARTS          fixed bin(31) value(WM_USER+4);
 dcl SB_GETPARTS          fixed bin(31) value(WM_USER+6);
 dcl SB_GETBORDERS        fixed bin(31) value(WM_USER+7);
 dcl SB_SETMINHEIGHT      fixed bin(31) value(WM_USER+8);
 dcl SB_SIMPLE            fixed bin(31) value(WM_USER+9);
 dcl SB_GETRECT           fixed bin(31) value(WM_USER+10);

 %if #WIN32_IE >= 768 %then %do;
 dcl SB_ISSIMPLE          fixed bin(31) value(WM_USER+14);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl SB_SETICON           fixed bin(31) value(WM_USER+15);
 dcl SB_SETTIPTEXTA       fixed bin(31) value(WM_USER+16);
 dcl SB_SETTIPTEXTW       fixed bin(31) value(WM_USER+17);
 dcl SB_GETTIPTEXTA       fixed bin(31) value(WM_USER+18);
 dcl SB_GETTIPTEXTW       fixed bin(31) value(WM_USER+19);
 %if UNICODE ^= '' %then %do;
 dcl SB_SETTIPTEXT        fixed bin(31) value(SB_SETTIPTEXTW);
 dcl SB_GETTIPTEXT        fixed bin(31) value(SB_GETTIPTEXTW);
 %end; %else %do;
 dcl SB_SETTIPTEXT        fixed bin(31) value(SB_SETTIPTEXTA);
 dcl SB_GETTIPTEXT        fixed bin(31) value(SB_GETTIPTEXTA);
 %end;
 dcl SB_GETICON           fixed bin(31) value(WM_USER+20);
 dcl SB_SETUNICODEFORMAT  fixed bin(31) value(CCM_SETUNICODEFORMAT);
 dcl SB_GETUNICODEFORMAT  fixed bin(31) value(CCM_GETUNICODEFORMAT);
 %end;

 dcl SBT_OWNERDRAW        fixed bin(31) value('1000'xn);
 dcl SBT_NOBORDERS        fixed bin(31) value('0100'xn);
 dcl SBT_POPOUT           fixed bin(31) value('0200'xn);
 dcl SBT_RTLREADING       fixed bin(31) value('0400'xn);

 %if #WIN32_IE >= 1280 %then %do;
 dcl SBT_NOTABPARSING     fixed bin(31) value('0800'xn);
 %end;

 dcl SB_SETBKCOLOR        fixed bin(31) value(CCM_SETBKCOLOR);
     /* lParam = bkColor */

 /* status bar notifications */

 %if #WIN32_IE >= 1024 %then %do;
 dcl SBN_SIMPLEMODECHANGE fixed bin(31) value(SBN_FIRST - 0);
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 /* refers to the data saved for simple mode */
 dcl SB_SIMPLEID          fixed bin(31) value('00ff'xn);
 %end;

 %end; /* NOSTATUSBAR */

 /* ====== MENU HELP ================================================ */

 %dcl NOMENUHELP char ext;
 %if NOMENUHELP = '' %then %do;

 dcl MenuHelp
     entry (type UINT,
            type WPARAM,
            type LPARAM,
            type HMENU,
            type HINSTANCE,
            type HWND,
            (*, 2) type INT byaddr)
     WINCOMMCTRLAPI WINAPI external('MenuHelp');

 dcl ShowHideMenuCtl
     entry (type HWND,
            type UINT,
            (*, 2) type INT byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('ShowHideMenuCtl');

 dcl GetEffectiveClientRect
     entry (type HWND,
            type RECT byaddr,
            (*, 2) type INT byaddr)
     WINCOMMCTRLAPI WINAPI external('GetEffectiveClientRect');

 dcl MINSYSCOMMAND fixed bin(31) value(SC_SIZE);

 %end;


 /* ====== TRACKBAR CONTROL ========================================= */

 %dcl NOTRACKBAR char ext;
 %if NOTRACKBAR = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl TRACKBAR_CLASSA char  value('msctls_trackbar32');
 dcl TRACKBAR_CLASSW WCHAR value('msctls_trackbar32');

 %dcl TRACKBAR_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %TRACKBAR_CLASS='TRACKBAR_CLASSW';
 %end; %else %do;
 %TRACKBAR_CLASS='TRACKBAR_CLASSA';
 %end;

 %end; %else %do;
 dcl TRACKBAR_CLASS char value('msctls_trackbar');
 %end;


 /* begin_r_commctrl */

 dcl TBS_AUTOTICKS      type DWORD value('0001'xu);
 dcl TBS_VERT           type DWORD value('0002'xu);
 dcl TBS_HORZ           type DWORD value('0000'xu);
 dcl TBS_TOP            type DWORD value('0004'xu);
 dcl TBS_BOTTOM         type DWORD value('0000'xu);
 dcl TBS_LEFT           type DWORD value('0004'xu);
 dcl TBS_RIGHT          type DWORD value('0000'xu);
 dcl TBS_BOTH           type DWORD value('0008'xu);
 dcl TBS_NOTICKS        type DWORD value('0010'xu);
 dcl TBS_ENABLESELRANGE type DWORD value('0020'xu);
 dcl TBS_FIXEDLENGTH    type DWORD value('0040'xu);
 dcl TBS_NOTHUMB        type DWORD value('0080'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl TBS_TOOLTIPS       type DWORD value('0100'xu);
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 dcl TBS_REVERSED       type DWORD value('0200'xu);
     /* Accessibility hint: the smaller number (usually the min      */
     /* value means "high" and the larger number (usually the max    */
     /* value) means "low"                                           */
 %end;

 %if #WIN32_IE >= 1281 %then %do;
 dcl TBS_DOWNISLEFT     type DWORD value('0400'xu);
     /* Down=Left and Up=Right (default is Down=Right and Up=Left) */
 %end;

 /* end_r_commctrl */

 dcl TBM_GETPOS         fixed bin(31) value(WM_USER);
 dcl TBM_GETRANGEMIN    fixed bin(31) value(WM_USER+1);
 dcl TBM_GETRANGEMAX    fixed bin(31) value(WM_USER+2);
 dcl TBM_GETTIC         fixed bin(31) value(WM_USER+3);
 dcl TBM_SETTIC         fixed bin(31) value(WM_USER+4);
 dcl TBM_SETPOS         fixed bin(31) value(WM_USER+5);
 dcl TBM_SETRANGE       fixed bin(31) value(WM_USER+6);
 dcl TBM_SETRANGEMIN    fixed bin(31) value(WM_USER+7);
 dcl TBM_SETRANGEMAX    fixed bin(31) value(WM_USER+8);
 dcl TBM_CLEARTICS      fixed bin(31) value(WM_USER+9);
 dcl TBM_SETSEL         fixed bin(31) value(WM_USER+10);
 dcl TBM_SETSELSTART    fixed bin(31) value(WM_USER+11);
 dcl TBM_SETSELEND      fixed bin(31) value(WM_USER+12);
 dcl TBM_GETPTICS       fixed bin(31) value(WM_USER+14);
 dcl TBM_GETTICPOS      fixed bin(31) value(WM_USER+15);
 dcl TBM_GETNUMTICS     fixed bin(31) value(WM_USER+16);
 dcl TBM_GETSELSTART    fixed bin(31) value(WM_USER+17);
 dcl TBM_GETSELEND      fixed bin(31) value(WM_USER+18);
 dcl TBM_CLEARSEL       fixed bin(31) value(WM_USER+19);
 dcl TBM_SETTICFREQ     fixed bin(31) value(WM_USER+20);
 dcl TBM_SETPAGESIZE    fixed bin(31) value(WM_USER+21);
 dcl TBM_GETPAGESIZE    fixed bin(31) value(WM_USER+22);
 dcl TBM_SETLINESIZE    fixed bin(31) value(WM_USER+23);
 dcl TBM_GETLINESIZE    fixed bin(31) value(WM_USER+24);
 dcl TBM_GETTHUMBRECT   fixed bin(31) value(WM_USER+25);
 dcl TBM_GETCHANNELRECT fixed bin(31) value(WM_USER+26);
 dcl TBM_SETTHUMBLENGTH fixed bin(31) value(WM_USER+27);
 dcl TBM_GETTHUMBLENGTH fixed bin(31) value(WM_USER+28);

 %if #WIN32_IE >= 768 %then %do;
 dcl TBM_SETTOOLTIPS    fixed bin(31) value(WM_USER+29);
 dcl TBM_GETTOOLTIPS    fixed bin(31) value(WM_USER+30);
 dcl TBM_SETTIPSIDE     fixed bin(31) value(WM_USER+31);
 /* TrackBar Tip Side flags */
 dcl TBTS_TOP           fixed bin(31) value(0);
 dcl TBTS_LEFT          fixed bin(31) value(1);
 dcl TBTS_BOTTOM        fixed bin(31) value(2);
 dcl TBTS_RIGHT         fixed bin(31) value(3);

 dcl TBM_SETBUDDY       fixed bin(31) value(WM_USER+32);
     /* wparam = BOOL fLeft; (or right) */
 dcl TBM_GETBUDDY       fixed bin(31) value(WM_USER+33);
     /* wparam = BOOL fLeft; (or right) */
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TBM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 dcl TBM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 %end;


 dcl TB_LINEUP        fixed bin(31) value(0);
 dcl TB_LINEDOWN      fixed bin(31) value(1);
 dcl TB_PAGEUP        fixed bin(31) value(2);
 dcl TB_PAGEDOWN      fixed bin(31) value(3);
 dcl TB_THUMBPOSITION fixed bin(31) value(4);
 dcl TB_THUMBTRACK    fixed bin(31) value(5);
 dcl TB_TOP           fixed bin(31) value(6);
 dcl TB_BOTTOM        fixed bin(31) value(7);
 dcl TB_ENDTRACK      fixed bin(31) value(8);



 %if #WIN32_IE >= 768 %then %do;
 /* custom draw item specs */
 dcl TBCD_TICS    fixed bin(31) value('0001'xn);
 dcl TBCD_THUMB   fixed bin(31) value('0002'xn);
 dcl TBCD_CHANNEL fixed bin(31) value('0003'xn);
 %end;

 %end;
 /* trackbar */

 /* ====== DRAG LIST CONTROL ======================================== */

 %dcl NODRAGLIST char ext;
 %if NODRAGLIST = '' %then %do;

 define structure
   1 DRAGLISTINFO,
     2 uNotification type UINT,
     2 hWnd          type HWND,
     2 ptCursor      type POINT;
 define alias LPDRAGLISTINFO handle DRAGLISTINFO;

 dcl DL_BEGINDRAG  fixed bin(31) value(WM_USER+133);
 dcl DL_DRAGGING   fixed bin(31) value(WM_USER+134);
 dcl DL_DROPPED    fixed bin(31) value(WM_USER+135);
 dcl DL_CANCELDRAG fixed bin(31) value(WM_USER+136);

 dcl DL_CURSORSET  fixed bin(31) value(0);
 dcl DL_STOPCURSOR fixed bin(31) value(1);
 dcl DL_COPYCURSOR fixed bin(31) value(2);
 dcl DL_MOVECURSOR fixed bin(31) value(3);

 dcl DRAGLISTMSGSTRING char value('commctrl_DragListMsg');

 dcl MakeDragList
     entry (type HWND )
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('MakeDragList');

 dcl DrawInsert
     entry (type HWND,
            type HWND,
            fixed bin(31))
     WINCOMMCTRLAPI WINAPI external('DrawInsert');

 dcl LBItemFromPt
     entry (type HWND,
            type POINT,
            type BOOL)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('LBItemFromPt');

 %end;


 /* ====== UPDOWN CONTROL =========================================== */

 %dcl NOUPDOWN char ext;
 %if NOUPDOWN = '' %then %do;


 %if #WIN32 ^= '' %then %do;

 dcl UPDOWN_CLASSA char  value('msctls_updown32');
 dcl UPDOWN_CLASSW WCHAR value('msctls_updown32');

 %dcl UPDOWN_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %UPDOWN_CLASS='UPDOWN_CLASSW';
 %end; %else %do;
 %UPDOWN_CLASS='UPDOWN_CLASSA';
 %end;

 %end; %else %do;
 dcl UPDOWN_CLASS char value('msctls_updown');
 %end;


 define structure
   1 UDACCEL,
     2 nSec type UINT,
     2 nInc type UINT;
 define alias LPUDACCEL handle UDACCEL;

 dcl UD_MAXVAL            fixed bin(31) value('7fff'xn);
 dcl UD_MINVAL            fixed bin(31) value(-UD_MAXVAL );

 /* begin_r_commctrl */

 dcl UDS_WRAP             type DWORD value('0001'xu);
 dcl UDS_SETBUDDYINT      type DWORD value('0002'xu);
 dcl UDS_ALIGNRIGHT       type DWORD value('0004'xu);
 dcl UDS_ALIGNLEFT        type DWORD value('0008'xu);
 dcl UDS_AUTOBUDDY        type DWORD value('0010'xu);
 dcl UDS_ARROWKEYS        type DWORD value('0020'xu);
 dcl UDS_HORZ             type DWORD value('0040'xu);
 dcl UDS_NOTHOUSANDS      type DWORD value('0080'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl UDS_HOTTRACK         type DWORD value('0100'xu);
 %end;

 /* end_r_commctrl */

 dcl UDM_SETRANGE         fixed bin(31) value(WM_USER+101);
 dcl UDM_GETRANGE         fixed bin(31) value(WM_USER+102);
 dcl UDM_SETPOS           fixed bin(31) value(WM_USER+103);
 dcl UDM_GETPOS           fixed bin(31) value(WM_USER+104);
 dcl UDM_SETBUDDY         fixed bin(31) value(WM_USER+105);
 dcl UDM_GETBUDDY         fixed bin(31) value(WM_USER+106);
 dcl UDM_SETACCEL         fixed bin(31) value(WM_USER+107);
 dcl UDM_GETACCEL         fixed bin(31) value(WM_USER+108);
 dcl UDM_SETBASE          fixed bin(31) value(WM_USER+109);
 dcl UDM_GETBASE          fixed bin(31) value(WM_USER+110);

 %if #WIN32_IE >= 1024 %then %do;
 dcl UDM_SETRANGE32       fixed bin(31) value(WM_USER+111);
 dcl UDM_GETRANGE32       fixed bin(31) value(WM_USER+112);
     /* wParam & lParam are LPINT */

 dcl UDM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 dcl UDM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl UDM_SETPOS32         fixed bin(31) value(WM_USER+113);
 dcl UDM_GETPOS32         fixed bin(31) value(WM_USER+114);
 %end;

 dcl CreateUpDownControl
     entry (type DWORD,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type HWND,
            fixed bin(31),
            type HINSTANCE,
            type HWND,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31))
     returns (type HWND byvalue optional)
     WINCOMMCTRLAPI WINAPI external('CreateUpDownControl');


 define structure
   1 NM_UPDOWN unaligned,
     2 hdr    type NMHDR,
     2 iPos   fixed bin(31),
     2 iDelta fixed bin(31);
 define alias LPNM_UPDOWN handle NM_UPDOWN;
 define alias   NMUPDOWN type   NM_UPDOWN;
 define alias LPNMUPDOWN handle NM_UPDOWN;

 dcl UDN_DELTAPOS fixed bin(31) value(UDN_FIRST - 1);

 %end; /* NOUPDOWN */


 /* ====== PROGRESS CONTROL ========================================= */

 %dcl NOPROGRESS char ext;
 %if NOPROGRESS = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl PROGRESS_CLASSA char  value('msctls_progress32');
 dcl PROGRESS_CLASSW WCHAR value('msctls_progress32');

 %dcl PROGRESS_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %PROGRESS_CLASS='PROGRESS_CLASSW';
 %end; %else %do;
 %PROGRESS_CLASS='PROGRESS_CLASSA';
 %end;

 %end; %else %do;
 dcl PROGRESS_CLASS char value('msctls_progress');
 %end;


 %if #WIN32_IE >= 768 %then %do;
 dcl PBS_SMOOTH      type DWORD value('01'xu);
 dcl PBS_VERTICAL    type DWORD value('04'xu);
 %end;

 dcl PBM_SETRANGE    fixed bin(31) value(WM_USER+1);
 dcl PBM_SETPOS      fixed bin(31) value(WM_USER+2);
 dcl PBM_DELTAPOS    fixed bin(31) value(WM_USER+3);
 dcl PBM_SETSTEP     fixed bin(31) value(WM_USER+4);
 dcl PBM_STEPIT      fixed bin(31) value(WM_USER+5);

 %if #WIN32_IE >= 768 %then %do;
 dcl PBM_SETRANGE32  fixed bin(31) value(WM_USER+6);
     /* lParam = high, wParam = low */

 define structure
   1 PBRANGE,
     2 iLow  fixed bin(31),
     2 iHigh fixed bin(31);
 define alias PPBRANGE handle PBRANGE;

 dcl PBM_GETRANGE    fixed bin(31) value(WM_USER+7);
     /* wParam = return (TRUE ? low : high). lParam = PPBRANGE or NULL*/
 dcl PBM_GETPOS      fixed bin(31) value(WM_USER+8);

 %if #WIN32_IE >= 1024 %then %do;
 dcl PBM_SETBARCOLOR fixed bin(31) value(WM_USER+9);
     /* lParam = bar color */
 %end; /* _WIN32_IE >= 0x0400 */

 dcl PBM_SETBKCOLOR  fixed bin(31) value(CCM_SETBKCOLOR);
     /* lParam = bkColor */
 %end; /* _WIN32_IE >= 0x0300 */

 %end;  /* NOPROGRESS */


 /* ====== HOTKEY CONTROL =========================================== */

 %dcl NOHOTKEY char ext;
 %if NOHOTKEY = '' %then %do;

 dcl HOTKEYF_SHIFT   fixed bin(31) value('01'xn);
 dcl HOTKEYF_CONTROL fixed bin(31) value('02'xn);
 dcl HOTKEYF_ALT     fixed bin(31) value('04'xn);
 dcl HOTKEYF_EXT     fixed bin(31) value('08'xn);

 dcl HKCOMB_NONE     fixed bin(31) value('0001'xn);
 dcl HKCOMB_S        fixed bin(31) value('0002'xn);
 dcl HKCOMB_C        fixed bin(31) value('0004'xn);
 dcl HKCOMB_A        fixed bin(31) value('0008'xn);
 dcl HKCOMB_SC       fixed bin(31) value('0010'xn);
 dcl HKCOMB_SA       fixed bin(31) value('0020'xn);
 dcl HKCOMB_CA       fixed bin(31) value('0040'xn);
 dcl HKCOMB_SCA      fixed bin(31) value('0080'xn);


 dcl HKM_SETHOTKEY   fixed bin(31) value(WM_USER+1);
 dcl HKM_GETHOTKEY   fixed bin(31) value(WM_USER+2);
 dcl HKM_SETRULES    fixed bin(31) value(WM_USER+3);


 %if #WIN32 ^= '' %then %do;

 dcl HOTKEY_CLASSA char  value('msctls_hotkey32');
 dcl HOTKEY_CLASSW WCHAR value('msctls_hotkey32');

 %dcl HOTKEY_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %HOTKEY_CLASS='HOTKEY_CLASSW';
 %end; %else %do;
 %HOTKEY_CLASS='HOTKEY_CLASSA';
 %end;

 %end; %else %do;
 dcl HOTKEY_CLASS char value('msctls_hotkey');
 %end;

 %end; /* NOHOTKEY */

 /* begin_r_commctrl */

 /* ====== COMMON CONTROL STYLES ==================================== */

 dcl CCS_TOP           type DWORD value('00000001'xu);
 dcl CCS_NOMOVEY       type DWORD value('00000002'xu);
 dcl CCS_BOTTOM        type DWORD value('00000003'xu);
 dcl CCS_NORESIZE      type DWORD value('00000004'xu);
 dcl CCS_NOPARENTALIGN type DWORD value('00000008'xu);
 dcl CCS_ADJUSTABLE    type DWORD value('00000020'xu);
 dcl CCS_NODIVIDER     type DWORD value('00000040'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl CCS_VERT          type DWORD value('00000080'xu);
 dcl CCS_LEFT          type DWORD value( ior(CCS_VERT, CCS_TOP));
 dcl CCS_RIGHT         type DWORD value( ior(CCS_VERT, CCS_BOTTOM));
 dcl CCS_NOMOVEX       type DWORD value( ior(CCS_VERT, CCS_NOMOVEY));
 %end;

 /* end_r_commctrl */

 /* ====== LISTVIEW CONTROL ========================================= */

 %dcl NOLISTVIEW char ext;
 %if NOLISTVIEW = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl WC_LISTVIEWA char  value('SysListView32');
 dcl WC_LISTVIEWW WCHAR value('SysListView32');

 %dcl WC_LISTVIEW char ext;
 %if UNICODE ^= '' %then %do;
 %WC_LISTVIEW='WC_LISTVIEWW';
 %end; %else %do;
 %WC_LISTVIEW='WC_LISTVIEWA';
 %end;

 %end; %else %do;
 dcl WC_LISTVIEW char value('SysListView');
 %end;

 /* begin_r_commctrl */

 dcl LVS_ICON            type DWORD value('0000'xu);
 dcl LVS_REPORT          type DWORD value('0001'xu);
 dcl LVS_SMALLICON       type DWORD value('0002'xu);
 dcl LVS_LIST            type DWORD value('0003'xu);
 dcl LVS_TYPEMASK        type DWORD value('0003'xu);
 dcl LVS_SINGLESEL       type DWORD value('0004'xu);
 dcl LVS_SHOWSELALWAYS   type DWORD value('0008'xu);
 dcl LVS_SORTASCENDING   type DWORD value('0010'xu);
 dcl LVS_SORTDESCENDING  type DWORD value('0020'xu);
 dcl LVS_SHAREIMAGELISTS type DWORD value('0040'xu);
 dcl LVS_NOLABELWRAP     type DWORD value('0080'xu);
 dcl LVS_AUTOARRANGE     type DWORD value('0100'xu);
 dcl LVS_EDITLABELS      type DWORD value('0200'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl LVS_OWNERDATA       type DWORD value('1000'xu);
 %end;
 dcl LVS_NOSCROLL        type DWORD value('2000'xu);

 dcl LVS_TYPESTYLEMASK   type DWORD value('fc00'xu);

 dcl LVS_ALIGNTOP        type DWORD value('0000'xu);
 dcl LVS_ALIGNLEFT       type DWORD value('0800'xu);
 dcl LVS_ALIGNMASK       type DWORD value('0c00'xu);

 dcl LVS_OWNERDRAWFIXED  type DWORD value('0400'xu);
 dcl LVS_NOCOLUMNHEADER  type DWORD value('4000'xu);
 dcl LVS_NOSORTHEADER    type DWORD value('8000'xu);

 /* end_r_commctrl */


 %if #WIN32_IE >= 1024 %then %do;
 dcl LVM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 ListView_SetUnicodeFormat: proc (hwnd, fUnicode)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       fUnicode type BOOL byvalue;
   return (SNDMSG (hwnd, LVM_SETUNICODEFORMAT, (fUnicode), 0));
 end ListView_SetUnicodeFormat;

 dcl LVM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 ListView_GetUnicodeFormat: proc (hwnd)
                            returns (type BOOL byvalue)
                            options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETUNICODEFORMAT, 0, 0));
 end ListView_GetUnicodeFormat;
 %end;

 dcl LVM_GETBKCOLOR fixed bin(31) value(LVM_FIRST + 0);
 ListView_GetBkColor: proc (hwnd)
                      returns (type COLORREF byvalue)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETBKCOLOR, 0, 0));
 end ListView_GetBkColor;


 dcl LVM_SETBKCOLOR fixed bin(31) value(LVM_FIRST + 1);
 ListView_SetBkColor: proc (hwnd, clrBk)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       clrBk type COLORREF byvalue;
   return (SNDMSG (hwnd, LVM_GETBKCOLOR, clrBk, 0));
 end ListView_SetBkColor;


 dcl LVM_GETIMAGELIST fixed bin(31) value(LVM_FIRST + 2);
 ListView_GetImageList: proc (hwnd, iImageList)
                        returns (type HIMAGELIST byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       iImageList fixed bin(31) byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, LVM_GETIMAGELIST,
                             (iImageList), 0)));
 end ListView_GetImageList;

 dcl LVSIL_NORMAL fixed bin(31) value(0);
 dcl LVSIL_SMALL  fixed bin(31) value(1);
 dcl LVSIL_STATE  fixed bin(31) value(2);

 dcl LVM_SETIMAGELIST fixed bin(31) value(LVM_FIRST + 3);
 ListView_SetImageList: proc (hwnd, himl, iImageList)
                        returns (type HIMAGELIST byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       himl       type HIMAGELIST byvalue,
       iImageList fixed bin(31) byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, LVM_SETIMAGELIST,
                             (iImageList), binvalue(himl))));
 end ListView_SetImageList;

 dcl LVM_GETITEMCOUNT fixed bin(31) value(LVM_FIRST + 4);
 ListView_GetItemCount: proc (hwnd)
                        returns (fixed bin(31) byvalue)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETITEMCOUNT, 0, 0));
 end ListView_GetItemCount;


 dcl LVIF_TEXT           type UINT value('0001'xu);
 dcl LVIF_IMAGE          type UINT value('0002'xu);
 dcl LVIF_PARAM          type UINT value('0004'xu);
 dcl LVIF_STATE          type UINT value('0008'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl LVIF_INDENT         type UINT value('0010'xu);
 dcl LVIF_NORECOMPUTE    type UINT value('0800'xu);
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl LVIF_GROUPID        type UINT value('0100'xu);
 dcl LVIF_COLUMNS        type UINT value('0200'xu);
 %end;

 dcl LVIS_FOCUSED        type UINT value('0001'xu);
 dcl LVIS_SELECTED       type UINT value('0002'xu);
 dcl LVIS_CUT            type UINT value('0004'xu);
 dcl LVIS_DROPHILITED    type UINT value('0008'xu);
 dcl LVIS_ACTIVATING     type UINT value('0020'xu);

 dcl LVIS_OVERLAYMASK    type UINT value('0F00'xu);
 dcl LVIS_STATEIMAGEMASK type UINT value('F000'xu);

 INDEXTOSTATEIMAGEMASK: proc (i) returns (type UINT byvalue)
                        options (inline reorder) internal;
   dcl i type UINT byvalue;
   dcl raise2 builtin;
   return (raise2 (i, 12));
 end INDEXTOSTATEIMAGEMASK;


 %if #WIN32_IE >= 768 %then %do;
 dcl I_INDENTCALLBACK  fixed bin(31) value(-1);
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl I_GROUPIDCALLBACK fixed bin(31) value(-1);
 dcl I_GROUPIDNONE     fixed bin(31) value(-2);
 %end;

 define structure
   1 LVITEMA,
     2 mask       type UINT,
     2 iItem      fixed bin(31),
     2 iSubItem   fixed bin(31),
     2 state      type UINT,
     2 stateMask  type UINT,
     2 pszText    type LPSTR,
     2 cchTextMax fixed bin(31),
     2 iImage     fixed bin(31),
     2 lParam     type LPARAM
 %if #WIN32_IE >= 768 %then %do;
   , 2 iIndent    fixed bin(31)
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 iGroupId   fixed bin(31),
     2 cColumns   type UINT, /* tile view columns */
     2 puColumns  type PUINT
 %end;
 %end;
   ;
 define alias LPLVITEMA  handle LVITEMA;
 define alias   LV_ITEMA type   LVITEMA;
 define alias LPLV_ITEMA type LPLVITEMA;
 dcl LVITEMA_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (LVITEMA, lParam));

 define structure
   1 LVITEMW,
     2 mask       type UINT,
     2 iItem      fixed bin(31),
     2 iSubItem   fixed bin(31),
     2 state      type UINT,
     2 stateMask  type UINT,
     2 pszText    type LPWSTR,
     2 cchTextMax fixed bin(31),
     2 iImage     fixed bin(31),
     2 lParam     type LPARAM
 %if #WIN32_IE >= 768 %then %do;
   , 2 iIndent    fixed bin(31)
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 iGroupId   fixed bin(31),
     2 cColumns   type UINT, /* tile view columns */
     2 puColumns  type PUINT
 %end;
   ;
 define alias LPLVITEMW  handle LVITEMW;
 define alias   LV_ITEMW type   LVITEMW;
 define alias LPLV_ITEMW type LPLVITEMW;
 dcl LVITEMW_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (LVITEMW, lParam));


 %if UNICODE ^= '' %then %do;
 define alias   LVITEM type   LVITEMW;
 define alias LPLVITEM type LPLVITEMW;
 define alias   LV_ITEM type   LV_ITEMW;
 define alias LPLV_ITEM type LPLV_ITEMW;
 dcl LVITEM_V1_SIZE fixed bin(31) value (LVITEMW_V1_SIZE);
 %end; %else %do;
 define alias   LVITEM type   LVITEMA;
 define alias LPLVITEM type LPLVITEMA;
 define alias   LV_ITEM type   LV_ITEMA;
 define alias LPLV_ITEM type LPLV_ITEMA;
 dcl LVITEM_V1_SIZE fixed bin(31) value (LVITEMA_V1_SIZE);
 %end;


 dcl LPSTR_TEXTCALLBACKW type LPWSTR value(ptrvalue(-1));
 dcl LPSTR_TEXTCALLBACKA type LPSTR  value(ptrvalue(-1));

 %if UNICODE ^= '' %then %do;
   dcl LPSTR_TEXTCALLBACK type LPWSTR value(LPSTR_TEXTCALLBACKW);
 %end; %else %do;
   dcl LPSTR_TEXTCALLBACK type LPSTR  value(LPSTR_TEXTCALLBACKA);
 %end;

 dcl I_IMAGECALLBACK fixed bin(31) value(-1);
 %if #WIN32_IE >= 1281 %then %do;
 dcl I_IMAGENONE     fixed bin(31) value(-2);
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
 /* For tileview */
 dcl I_COLUMNSCALLBACK fixed bin(31) value(-1); /* UINT? */
 %end;

 dcl LVM_GETITEMA fixed bin(31) value(LVM_FIRST + 5);
 dcl LVM_GETITEMW fixed bin(31) value(LVM_FIRST + 75);

 %if UNICODE ^= '' %then %do;
 dcl LVM_GETITEM  fixed bin(31) value(LVM_GETITEMW);
 %end; %else %do;
 dcl LVM_GETITEM  fixed bin(31) value(LVM_GETITEMA);
 %end;

 ListView_GetItem: proc (hwnd, pitem)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       pitem type LVITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETITEM, 0, binvalue (addr (pitem))));
 end ListView_GetItem;


 dcl LVM_SETITEMA fixed bin(31) value(LVM_FIRST + 6);
 dcl LVM_SETITEMW fixed bin(31) value(LVM_FIRST + 76);

 %if UNICODE ^= '' %then %do;
 dcl LVM_SETITEM  fixed bin(31) value(LVM_SETITEMW);
 %end; %else %do;
 dcl LVM_SETITEM  fixed bin(31) value(LVM_SETITEMA);
 %end;

 ListView_SetItem: proc (hwnd, pitem)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       pitem type LVITEM byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETITEM, 0, binvalue (addr (pitem))));
 end ListView_SetItem;

 dcl LVM_INSERTITEMA fixed bin(31) value(LVM_FIRST + 7);
 dcl LVM_INSERTITEMW fixed bin(31) value(LVM_FIRST + 77);

 %if UNICODE ^= '' %then %do;
 dcl LVM_INSERTITEM  fixed bin(31) value(LVM_INSERTITEMW);
 %end; %else %do;
 dcl LVM_INSERTITEM  fixed bin(31) value(LVM_INSERTITEMA);
 %end;

 ListView_InsertItem: proc (hwnd, pitem)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       pitem type LVITEM byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_INSERTITEM, 0, binvalue (addr (pitem))));
 end ListView_InsertItem;


 dcl LVM_DELETEITEM fixed bin(31) value(LVM_FIRST + 8);
 ListView_DeleteItem: proc (hwnd, i)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       i     fixed bin(31) byvalue;
   return (SNDMSG (hwnd, LVM_DELETEITEM, (i), 0));
 end ListView_DeleteItem;

 dcl LVM_DELETEALLITEMS fixed bin(31) value(LVM_FIRST + 9);
 ListView_DeleteAllItems: proc (hwnd)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (SNDMSG (hwnd, LVM_DELETEALLITEMS, 0, 0));
 end ListView_DeleteAllItems;


 dcl LVM_GETCALLBACKMASK fixed bin(31) value(LVM_FIRST + 10);
 ListView_GetCallbackMask: proc (hwnd)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETCALLBACKMASK, 0, 0));
 end ListView_GetCallbackMask;

 dcl LVM_SETCALLBACKMASK fixed bin(31) value(LVM_FIRST + 11);
 ListView_SetCallbackMask: proc (hwnd, mask)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       mask  type UINT byvalue;
   return (SNDMSG (hwnd, LVM_SETCALLBACKMASK, (mask), 0));
 end ListView_SetCallbackMask;


 dcl LVNI_ALL         type WORD value('0000'xu);
 dcl LVNI_FOCUSED     type WORD value('0001'xu);
 dcl LVNI_SELECTED    type WORD value('0002'xu);
 dcl LVNI_CUT         type WORD value('0004'xu);
 dcl LVNI_DROPHILITED type WORD value('0008'xu);

 dcl LVNI_ABOVE       type WORD value('0100'xu);
 dcl LVNI_BELOW       type WORD value('0200'xu);
 dcl LVNI_TOLEFT      type WORD value('0400'xu);
 dcl LVNI_TORIGHT     type WORD value('0800'xu);


 dcl LVM_GETNEXTITEM fixed bin(31) value(LVM_FIRST + 12);
 ListView_GetNextItem: proc (hwnd, i, flags)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       i     fixed bin (31) byvalue,
       flags type UINT;
   return (SNDMSG (hwnd, LVM_GETNEXTITEM, (i), MAKELPARAM (flags, 0)));
 end ListView_GetNextItem;


 dcl LVFI_PARAM     type UINT value('0001'xu);
 dcl LVFI_STRING    type UINT value('0002'xu);
 dcl LVFI_PARTIAL   type UINT value('0008'xu);
 dcl LVFI_WRAP      type UINT value('0020'xu);
 dcl LVFI_NEARESTXY type UINT value('0040'xu);


 define structure
   1 LVFINDINFOA,
     2 flags       type UINT,
     2 psz         type LPCSTR,
     2 lParam      type LPARAM,
     2 pt          type POINT,
     2 vkDirection type UINT;
 define alias LV_FINDINFOA   type   LVFINDINFOA;
 define alias LPLVFINDINFOA  handle LVFINDINFOA;
 define alias LPLV_FINDINFOA handle LVFINDINFOA;
 define alias LPFINDINFOA    handle LVFINDINFOA;


 define structure
   1 LVFINDINFOW,
     2 flags       type UINT,
     2 psz         type LPCWSTR,
     2 lParam      type LPARAM,
     2 pt          type POINT,
     2 vkDirection type UINT;
 define alias LV_FINDINFOW   type   LVFINDINFOW;
 define alias LPLVFINDINFOW  handle LVFINDINFOW;
 define alias LPLV_FINDINFOW handle LVFINDINFOW;
 define alias LPFINDINFOW    handle LVFINDINFOW;

 %if UNICODE ^= '' %then %do;
 define alias   LVFINDINFO type   LVFINDINFOW;
 define alias LPLVFINDINFO type LPLVFINDINFOW;
 %end; %else %do;
 define alias   LVFINDINFO type   LVFINDINFOA;
 define alias LPLVFINDINFO type LPLVFINDINFOA;
 %end;
 define alias   LV_FINDINFO type   LVFINDINFO;
 define alias LPLV_FINDINFO type LPLVFINDINFO;

 dcl LVM_FINDITEMA fixed bin(31) value(LVM_FIRST + 13);
 dcl LVM_FINDITEMW fixed bin(31) value(LVM_FIRST + 83);

 %if UNICODE ^= '' %then %do;
 dcl LVM_FINDITEM  fixed bin(31) value(LVM_FINDITEMW);
 %end; %else %do;
 dcl LVM_FINDITEM  fixed bin(31) value(LVM_FINDITEMA);
 %end;

 ListView_FindItem: proc (hwnd, iStart, plvfi)
                     returns (fixed bin(31) byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iStart fixed bin (31) byvalue,
       plvfi  type LV_FINDINFO byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_FINDITEM, (iStart),
                   binvalue (addr (plvfi))));
 end ListView_FindItem;

 dcl LVIR_BOUNDS       fixed bin(31) value(0);
 dcl LVIR_ICON         fixed bin(31) value(1);
 dcl LVIR_LABEL        fixed bin(31) value(2);
 dcl LVIR_SELECTBOUNDS fixed bin(31) value(3);


 dcl LVM_GETITEMRECT fixed bin(31) value(LVM_FIRST + 14);
 ListView_GetItemRect: proc (hwnd, i, prc, code)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       i     fixed bin (31) byvalue,
       prc   type RECT byaddr optional,
       code  fixed bin (31) byvalue;
   dcl (addr, binvalue, present) builtin;
   if present (prc) then
   do;
     prc.left = code;
     return (SNDMSG (hwnd, LVM_GETITEMRECT, (i),
                     binvalue (addr (prc))));
   end;
   else
     return (SNDMSG (hwnd, LVM_GETITEMRECT, (i), 0));
 end ListView_GetItemRect;


 dcl LVM_SETITEMPOSITION fixed bin(31) value(LVM_FIRST + 15);
 ListView_SetItemPosition: proc (hwndLV, i, x, y)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin (31) byvalue,
       x      fixed bin (31) byvalue,
       y      fixed bin (31) byvalue;
   return (SNDMSG (hwndLV, LVM_SETITEMPOSITION, (i),
                   MAKELPARAM (x, y)));
 end ListView_SetItemPosition;


 dcl LVM_GETITEMPOSITION fixed bin(31) value(LVM_FIRST + 16);
 ListView_GetItemPosition: proc (hwndLV, i, ppt)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin (31) byvalue,
       ppt    type POINT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndLV, LVM_GETITEMPOSITION, (i),
                   binvalue (addr (ppt))));
 end ListView_GetItemPosition;


 dcl LVM_GETSTRINGWIDTHA fixed bin(31) value(LVM_FIRST + 17);
 dcl LVM_GETSTRINGWIDTHW fixed bin(31) value(LVM_FIRST + 87);

 %if UNICODE ^= '' %then %do;
 dcl LVM_GETSTRINGWIDTH  fixed bin(31) value(LVM_GETSTRINGWIDTHW);
 %end; %else %do;
 dcl LVM_GETSTRINGWIDTH  fixed bin(31) value(LVM_GETSTRINGWIDTHA);
 %end;

 ListView_GetStringWidth: proc (hwndLV, psz)
                          returns (fixed bin(31) byvalue optional)
                          options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       psz    TCHAR (*) varz byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndLV, LVM_GETSTRINGWIDTH, 0,
                   binvalue (addr (psz))));
 end ListView_GetStringWidth;


 dcl LVHT_NOWHERE         type UINT value('0001'xu);
 dcl LVHT_ONITEMICON      type UINT value('0002'xu);
 dcl LVHT_ONITEMLABEL     type UINT value('0004'xu);
 dcl LVHT_ONITEMSTATEICON type UINT value('0008'xu);
 dcl LVHT_ONITEM          type UINT
     value(ior (LVHT_ONITEMICON,
                LVHT_ONITEMLABEL,
                LVHT_ONITEMSTATEICON));
 dcl LVHT_ABOVE           type UINT value('0008'xu);
 dcl LVHT_BELOW           type UINT value('0010'xu);
 dcl LVHT_TORIGHT         type UINT value('0020'xu);
 dcl LVHT_TOLEFT          type UINT value('0040'xu);


 define structure
   1 LVHITTESTINFO,
     2 pt       type POINT,
     2 flags    type UINT,
     2 iItem    fixed bin(31)
 %if #WIN32_IE >= 768 %then %do;
   , 2 iSubItem fixed bin(31)
     /* this is/was NOT in win95. Valid only for LVM_SUBITEMHITTEST */
 %end;
   ;
 define alias LPLVHITTESTINFO  handle LVHITTESTINFO;
 define alias   LV_HITTESTINFO type   LVHITTESTINFO;
 define alias LPLV_HITTESTINFO handle LVHITTESTINFO;
 dcl LVHITTESTINFO_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (LVHITTESTINFO, iItem));

 dcl LVM_HITTEST fixed bin(31) value(LVM_FIRST + 18);
 ListView_HitTest: proc (hwndLV, pinfo)
                   returns (fixed bin(31) byvalue optional)
                   options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       pinfo  type LV_HITTESTINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndLV, LVM_HITTEST, 0, binvalue (addr (pinfo))));
 end ListView_HitTest;


 dcl LVM_ENSUREVISIBLE fixed bin(31) value(LVM_FIRST + 19);
 ListView_EnsureVisible: proc (hwndLV, i, fPartialOK)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwndLV     type HWND byvalue,
       i          fixed bin (31) byvalue,
       fPartialOK type BOOL byvalue;
   return (SNDMSG (hwndLV, LVM_ENSUREVISIBLE, (i),
                   MAKELPARAM (fPartialOK, 0)));
 end ListView_EnsureVisible;


 dcl LVM_SCROLL fixed bin(31) value(LVM_FIRST + 20);
 ListView_Scroll: proc (hwndLV, dx, dy)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       dx     fixed bin (31) byvalue,
       dy     fixed bin (31) byvalue;
   return (SNDMSG (hwndLV, LVM_SCROLL, (dx), (dy)));
 end ListView_Scroll;


 dcl LVM_REDRAWITEMS fixed bin(31) value(LVM_FIRST + 21);
 ListView_RedrawItems: proc (hwndLV, iFirst, iLast)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       iFirst fixed bin (31) byvalue,
       iLast  fixed bin (31) byvalue;
   return (SNDMSG (hwndLV, LVM_REDRAWITEMS, (iFirst), (iLast)));
 end ListView_RedrawItems;


 dcl LVA_DEFAULT    type UINT value('0000'xu);
 dcl LVA_ALIGNLEFT  type UINT value('0001'xu);
 dcl LVA_ALIGNTOP   type UINT value('0002'xu);
 dcl LVA_SNAPTOGRID type UINT value('0005'xu);

 dcl LVM_ARRANGE fixed bin(31) value(LVM_FIRST + 22);
 ListView_Arrange: proc (hwndLV, code)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       code   type UINT byvalue;
   return (SNDMSG (hwndLV, LVM_ARRANGE, (code), 0));
 end ListView_Arrange;


 dcl LVM_EDITLABELA fixed bin(31) value(LVM_FIRST + 23);
 dcl LVM_EDITLABELW fixed bin(31) value(LVM_FIRST + 118);

 %if UNICODE ^= '' %then %do;
 dcl LVM_EDITLABEL  fixed bin(31) value(LVM_EDITLABELW);
 %end; %else %do;
 dcl LVM_EDITLABEL  fixed bin(31) value(LVM_EDITLABELA);
 %end;

 ListView_EditLabel: proc (hwndLV, i)
                     returns (type HWND byvalue optional)
                     options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin(31) byvalue;
   dcl (ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwndLV, LVM_EDITLABEL, (i), 0)));
 end ListView_EditLabel;


 dcl LVM_GETEDITCONTROL fixed bin(31) value(LVM_FIRST + 24);
 ListView_GetEditControl: proc (hwndLV)
                          returns (type HWND byvalue optional)
                          options (inline reorder) internal;
   dcl hwndLV type HWND byvalue;
   dcl (ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwndLV, LVM_GETEDITCONTROL, 0, 0)));
 end ListView_GetEditControl;


 define structure
   1 LVCOLUMNA,
     2 mask       type UINT,
     2 fmt        fixed bin(31),
     2 cx         fixed bin(31),
     2 pszText    type LPSTR,
     2 cchTextMax fixed bin(31),
     2 iSubItem   fixed bin(31)
 %if #WIN32_IE >= 768 %then %do;
   , 2 iImage     fixed bin(31),
     2 iOrder     fixed bin(31)
 %end;
   ;
 define alias LPLVCOLUMNA  handle LVCOLUMNA;
 define alias   LV_COLUMNA type   LVCOLUMNA;
 define alias LPLV_COLUMNA handle LVCOLUMNA;
 dcl LVCOLUMNA_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (LVCOLUMNA, iSubItem));

 define structure
   1 LVCOLUMNW,
     2 mask       type UINT,
     2 fmt        fixed bin(31),
     2 cx         fixed bin(31),
     2 pszText    type LPWSTR,
     2 cchTextMax fixed bin(31),
     2 iSubItem   fixed bin(31)
 %if #WIN32_IE >= 768 %then %do;
   , 2 iImage     fixed bin(31),
     2 iOrder     fixed bin(31)
 %end;
   ;
 define alias LPLVCOLUMNW  handle LVCOLUMNW;
 define alias   LV_COLUMNW type   LVCOLUMNW;
 define alias LPLV_COLUMNW handle LVCOLUMNW;
 dcl LVCOLUMNW_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (LVCOLUMNW, iSubItem));

 %if UNICODE ^= '' %then %do;
 define alias   LVCOLUMN type   LVCOLUMNW;
 define alias LPLVCOLUMN type LPLVCOLUMNW;
 define alias   LV_COLUMN type   LV_COLUMNW;
 define alias LPLV_COLUMN type LPLV_COLUMNW;
 dcl LVCOLUMN_V1_SIZE fixed bin(31) value(LVCOLUMNW_V1_SIZE);
 %end; %else %do;
 define alias   LVCOLUMN type   LVCOLUMNA;
 define alias LPLVCOLUMN type LPLVCOLUMNA;
 define alias   LV_COLUMN type   LV_COLUMNA;
 define alias LPLV_COLUMN type LPLV_COLUMNA;
 dcl LVCOLUMN_V1_SIZE fixed bin(31) value(LVCOLUMNA_V1_SIZE);
 %end;

 dcl LVCF_FMT               fixed bin(31) value('0001'xn);
 dcl LVCF_WIDTH             fixed bin(31) value('0002'xn);
 dcl LVCF_TEXT              fixed bin(31) value('0004'xn);
 dcl LVCF_SUBITEM           fixed bin(31) value('0008'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl LVCF_IMAGE             fixed bin(31) value('0010'xn);
 dcl LVCF_ORDER             fixed bin(31) value('0020'xn);
 %end;

 dcl LVCFMT_LEFT            fixed bin(31) value('0000'xn);
 dcl LVCFMT_RIGHT           fixed bin(31) value('0001'xn);
 dcl LVCFMT_CENTER          fixed bin(31) value('0002'xn);
 dcl LVCFMT_JUSTIFYMASK     fixed bin(31) value('0003'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl LVCFMT_IMAGE           fixed bin(31) value('0800'xn);
 dcl LVCFMT_BITMAP_ON_RIGHT fixed bin(31) value('1000'xn);
 dcl LVCFMT_COL_HAS_IMAGES  fixed bin(31) value('8000'xn);
 %end;

 dcl LVM_GETCOLUMNA fixed bin(31) value(LVM_FIRST + 25);
 dcl LVM_GETCOLUMNW fixed bin(31) value(LVM_FIRST + 95);

 %if UNICODE ^= '' %then %do;
 dcl LVM_GETCOLUMN  fixed bin(31) value(LVM_GETCOLUMNW);
 %end; %else %do;
 dcl LVM_GETCOLUMN  fixed bin(31) value(LVM_GETCOLUMNA);
 %end;

 ListView_GetColumn: proc (hwnd, iCol, pcol)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol fixed bin (31) byvalue,
       pcol type LV_COLUMN byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETCOLUMN, (iCol),
           binvalue (addr (pcol))));
 end ListView_GetColumn;


 dcl LVM_SETCOLUMNA fixed bin(31) value(LVM_FIRST + 26);
 dcl LVM_SETCOLUMNW fixed bin(31) value(LVM_FIRST + 96);

 %if UNICODE ^= '' %then %do;
 dcl LVM_SETCOLUMN  fixed bin(31) value(LVM_SETCOLUMNW);
 %end; %else %do;
 dcl LVM_SETCOLUMN  fixed bin(31) value(LVM_SETCOLUMNA);
 %end;

 ListView_SetColumn: proc (hwnd, iCol, pcol)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol fixed bin (31) byvalue,
       pcol type LV_COLUMN byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETCOLUMN, (iCol),
                   binvalue (addr (pcol))));
 end ListView_SetColumn;


 dcl LVM_INSERTCOLUMNA fixed bin(31) value(LVM_FIRST + 27);
 dcl LVM_INSERTCOLUMNW fixed bin(31) value(LVM_FIRST + 97);

 %if UNICODE ^= '' %then %do;
 dcl LVM_INSERTCOLUMN  fixed bin(31) value(LVM_INSERTCOLUMNW);
 %end; %else %do;
 dcl LVM_INSERTCOLUMN  fixed bin(31) value(LVM_INSERTCOLUMNA);
 %end;

 ListView_InsertColumn: proc (hwnd, iCol, pcol)
                        returns (fixed bin(31) byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol fixed bin (31) byvalue,
       pcol type LV_COLUMN byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_INSERTCOLUMN, (iCol),
           binvalue (addr (pcol))));
 end ListView_InsertColumn;


 dcl LVM_DELETECOLUMN fixed bin(31) value(LVM_FIRST + 28);
 ListView_DeleteColumn: proc (hwnd, iCol)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_DELETECOLUMN, (iCol), 0));
 end ListView_DeleteColumn;


 dcl LVM_GETCOLUMNWIDTH fixed bin(31) value(LVM_FIRST + 29);
 ListView_GetColumnWidth: proc (hwnd, iCol)
                          returns (fixed bin(31) byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_GETCOLUMNWIDTH, (iCol), 0));
 end ListView_GetColumnWidth;


 dcl LVSCW_AUTOSIZE           fixed bin(31) value (-1);
 dcl LVSCW_AUTOSIZE_USEHEADER fixed bin(31) value (-2);

 dcl LVM_SETCOLUMNWIDTH fixed bin(31) value(LVM_FIRST + 30);
 ListView_SetColumnWidth: proc (hwnd, iCol, cx)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol fixed bin (31) byvalue,
       cx   fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_SETCOLUMNWIDTH, (iCol),
                   MAKELPARAM (cx, 0)));
 end ListView_SetColumnWidth;


 %if #WIN32_IE >= 768 %then %do;
 dcl LVM_GETHEADER fixed bin(31) value(LVM_FIRST + 31);
 ListView_GetHeader: proc (hwnd)
                     returns (type HWND byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, LVM_GETHEADER, 0, 0)));
 end ListView_GetHeader;
 %end;

 dcl LVM_CREATEDRAGIMAGE fixed bin(31) value(LVM_FIRST + 33);
 ListView_CreateDragImage: proc (hwnd, i, lpptUpLeft)
                           returns (type HIMAGELIST byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       i          fixed bin (31) byvalue,
       lpptUpLeft type POINT byaddr;
   dcl (addr, binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, LVM_CREATEDRAGIMAGE, (i),
                             binvalue (addr (lpptUpLeft)))));
 end ListView_CreateDragImage;


 dcl LVM_GETVIEWRECT fixed bin(31) value(LVM_FIRST + 34);
 ListView_GetViewRect: proc (hwnd, prc)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       prc  type RECT byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETVIEWRECT, 0,
                   binvalue (addr (prc))));
 end ListView_GetViewRect;


 dcl LVM_GETTEXTCOLOR fixed bin(31) value(LVM_FIRST + 35);
 ListView_GetTextColor: proc (hwnd)
                        returns (type COLORREF byvalue)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETTEXTCOLOR, 0, 0));
 end ListView_GetTextColor;


 dcl LVM_SETTEXTCOLOR fixed bin(31) value(LVM_FIRST + 36);
 ListView_SetTextColor: proc (hwnd, clrText)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       clrText type COLORREF byvalue;
   return (SNDMSG (hwnd, LVM_SETTEXTCOLOR, 0, (clrText)));
 end ListView_SetTextColor;


 dcl LVM_GETTEXTBKCOLOR fixed bin(31) value(LVM_FIRST + 37);
 ListView_GetTextBkColor: proc (hwnd)
                          returns (type COLORREF byvalue)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETTEXTBKCOLOR, 0, 0));
 end ListView_GetTextBkColor;


 dcl LVM_SETTEXTBKCOLOR fixed bin(31) value(LVM_FIRST + 38);
 ListView_SetTextBkColor: proc (hwnd, clrTextBk)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd      type HWND byvalue,
       clrTextBk type COLORREF byvalue;
   return (SNDMSG (hwnd, LVM_SETTEXTBKCOLOR, 0, (clrTextBk)));
 end ListView_SetTextBkColor;


 dcl LVM_GETTOPINDEX fixed bin(31) value(LVM_FIRST + 39);
 ListView_GetTopIndex: proc (hwndLV)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwndLV type HWND byvalue;
   return (SNDMSG (hwndLV, LVM_GETTOPINDEX, 0, 0));
 end ListView_GetTopIndex;


 dcl LVM_GETCOUNTPERPAGE fixed bin(31) value(LVM_FIRST + 40);
 ListView_GetCountPerPage: proc (hwndLV)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwndLV type HWND byvalue;
   return (SNDMSG (hwndLV, LVM_GETCOUNTPERPAGE, 0, 0));
 end ListView_GetCountPerPage;


 dcl LVM_GETORIGIN fixed bin(31) value(LVM_FIRST + 41);
 ListView_GetOrigin: proc (hwndLV, ppt)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       ppt    type POINT byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndLV, LVM_GETORIGIN, 0, binvalue (addr (ppt))));
 end ListView_GetOrigin;


 dcl LVM_UPDATE fixed bin(31) value(LVM_FIRST + 42);
 ListView_Update: proc (hwndLV, i)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin(31) byvalue;
   return (SNDMSG (hwndLV, LVM_UPDATE, (i), 0));
 end ListView_Update;


 dcl LVM_SETITEMSTATE fixed bin(31) value(LVM_FIRST + 43);
 ListView_SetItemState: proc (hwndLV, i, data, mask)
                        options (inline reorder) internal;
   dcl hwndLV  type HWND byvalue,
       i       fixed bin(31) byvalue,
       data    type UINT byvalue,
       mask    type UINT byvalue;
   dcl _ms_lvi type LV_ITEM;
   dcl (addr, binvalue) builtin;
   _ms_lvi.stateMask = mask;
   _ms_lvi.state = data;
   call SNDMSG (hwndLV, LVM_SETITEMSTATE, (i),
                binvalue (addr (_ms_lvi)));
 end ListView_SetItemState;


 dcl LVM_GETITEMSTATE fixed bin(31) value(LVM_FIRST + 44);
 ListView_GetItemState: proc (hwndLV, i, mask)
                        returns (type UINT byvalue optional)
                        options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin(31) byvalue,
       mask   type UINT byvalue;
   return (SNDMSG (hwndLV, LVM_GETITEMSTATE, (i), (mask)));
 end ListView_GetItemState;


 %if #WIN32_IE >= 768 %then %do;
 ListView_GetCheckState: proc (hwndLV, i)
                         returns (type UINT byvalue optional)
                         options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin(31) byvalue;
   dcl isrl builtin;
   return (isrl (SNDMSG (hwndLV, LVM_GETITEMSTATE, (i),
                         LVIS_STATEIMAGEMASK), 12) - 1);
 end ListView_GetCheckState;
 %end;

 dcl LVM_GETITEMTEXTA fixed bin(31) value(LVM_FIRST + 45);
 dcl LVM_GETITEMTEXTW fixed bin(31) value(LVM_FIRST + 115);

 %if UNICODE ^= '' %then %do;
 dcl LVM_GETITEMTEXT  fixed bin(31) value(LVM_GETITEMTEXTW);
 %end; %else %do;
 dcl LVM_GETITEMTEXT  fixed bin(31) value(LVM_GETITEMTEXTA);
 %end;

 ListView_GetItemText: proc (hwndLV, i, iSubItem_,
                             pszText_, cchTextMax_)
                       options (inline reorder) internal;
   dcl hwndLV      type HWND byvalue,
       i           fixed bin(31) byvalue,
       iSubItem_   fixed bin(31) byvalue,
       pszText_    TCHAR(*) varz byaddr,
       cchTextMax_ fixed bin(31) byvalue;
   dcl _ms_lvi     type LV_ITEM;
   dcl (addr, binvalue) builtin;
   _ms_lvi.iSubItem   = iSubItem_;
   _ms_lvi.cchTextMax = cchTextMax_;
   _ms_lvi.pszText    = addr (pszText_);
   call SNDMSG (hwndLV, LVM_GETITEMTEXT, (i),
                binvalue (addr (_ms_lvi)));
 end ListView_GetItemText;


 dcl LVM_SETITEMTEXTA fixed bin(31) value(LVM_FIRST + 46);
 dcl LVM_SETITEMTEXTW fixed bin(31) value(LVM_FIRST + 116);


 %if UNICODE ^= '' %then %do;
 dcl LVM_SETITEMTEXT  fixed bin(31) value(LVM_SETITEMTEXTW);
 %end; %else %do;
 dcl LVM_SETITEMTEXT  fixed bin(31) value(LVM_SETITEMTEXTA);
 %end;

 ListView_SetItemText: proc (hwndLV, i, iSubItem_, pszText_)
                       options (inline reorder) internal;
   dcl hwndLV      type HWND byvalue,
       i           fixed bin(31) byvalue,
       iSubItem_   fixed bin(31) byvalue,
       pszText_    TCHAR(*) varz byaddr;
   dcl _ms_lvi     type LV_ITEM;
   dcl (addr, binvalue) builtin;
   _ms_lvi.iSubItem = iSubItem_;
   _ms_lvi.pszText  = addr (pszText_);
   call SNDMSG (hwndLV, LVM_SETITEMTEXT, (i),
                binvalue (addr (_ms_lvi)));
 end ListView_SetItemText;


 %if #WIN32_IE >= 768 %then %do;
 /* these flags only apply to LVS_OWNERDATA listviews */
 /* in report or list mode                            */
 dcl LVSICF_NOINVALIDATEALL fixed bin(31) value('00000001'xn);
 dcl LVSICF_NOSCROLL        fixed bin(31) value('00000002'xn);
 %end;

 dcl LVM_SETITEMCOUNT fixed bin(31) value(LVM_FIRST + 47);
 ListView_SetItemCount: proc (hwndLV, cItems)
                        options (inline reorder) internal;
   dcl hwndLV  type HWND byvalue,
       cItems  fixed bin(31) byvalue;
   call SNDMSG (hwndLV, LVM_SETITEMCOUNT, (cItems), 0);
 end ListView_SetItemCount;


 %if #WIN32_IE >= 768 %then %do;
 ListView_SetItemCountEx: proc (hwndLV, cItems, dwFlags)
                        options (inline reorder) internal;
   dcl hwndLV  type HWND byvalue,
       cItems  fixed bin(31),
       dwFlags type DWORD byvalue;
    call SNDMSG (hwndLV, LVM_SETITEMCOUNT, (cItems), (dwFlags));
 end ListView_SetItemCountEx;
 %end;

 define alias PFNLVCOMPARE
              entry (type LPARAM,
                     type LPARAM,
                     type LPARAM)
              returns (fixed bin(31) byvalue optional)
              limited CALLBACK;


 dcl LVM_SORTITEMS fixed bin(31) value(LVM_FIRST + 48);
 ListView_SortItems: proc (hwndLV, _pfnCompare, _lPrm)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwndLV      type HWND byvalue,
       _pfnCompare type PFNLVCOMPARE,
       _lPrm       type LPARAM byvalue;
   dcl (binvalue, entryaddr) builtin;
   return (SNDMSG (hwndLV, LVM_SORTITEMS, (_lPrm),
                   binvalue (entryaddr (_pfnCompare))));
 end ListView_SortItems;


 dcl LVM_SETITEMPOSITION32 fixed bin(31) value(LVM_FIRST + 49);
 ListView_SetItemPosition32: proc (hwndLV, i, x, y)
                             options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       i      fixed bin (31) byvalue,
       x      fixed bin (31) byvalue,
       y      fixed bin (31) byvalue;
   dcl ptNewPos type POINT;
   dcl (addr, binvalue) builtin;
   ptNewPos.x = x;
   ptNewPos.y = y;
   call SNDMSG (hwndLV, LVM_SETITEMPOSITION32, (i),
                binvalue (addr (ptNewPos)));
 end ListView_SetItemPosition32;


 dcl LVM_GETSELECTEDCOUNT fixed bin(31) value(LVM_FIRST + 50);
 ListView_GetSelectedCount: proc (hwndLV)
                            returns (type UINT byvalue optional)
                            options (inline reorder) internal;
   dcl hwndLV type HWND byvalue;
   return (SNDMSG (hwndLV, LVM_GETSELECTEDCOUNT, 0, 0));
 end ListView_GetSelectedCount;


 dcl LVM_GETITEMSPACING fixed bin(31) value(LVM_FIRST + 51);
 ListView_GetItemSpacing: proc (hwndLV, fSmall)
                          returns (type DWORD byvalue optional)
                          options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       fSmall type BOOL byvalue;
   return (SNDMSG (hwndLV, LVM_GETITEMSPACING, (fSmall), 0));
 end ListView_GetItemSpacing;


 dcl LVM_GETISEARCHSTRINGA fixed bin(31) value(LVM_FIRST + 52);
 dcl LVM_GETISEARCHSTRINGW fixed bin(31) value(LVM_FIRST + 117);


 %if UNICODE ^= '' %then %do;
 dcl LVM_GETISEARCHSTRING fixed bin(31) value(LVM_GETISEARCHSTRINGW);
 %end; %else %do;
 dcl LVM_GETISEARCHSTRING fixed bin(31) value(LVM_GETISEARCHSTRINGA);
 %end;

 ListView_GetISearchString: proc (hwndLV, lpsz)
                            returns (fixed bin(31) byvalue optional)
                                     /* not BOOL */
                            options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       lpsz   TCHAR(*) varz byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndLV, LVM_GETISEARCHSTRING, 0,
                   binvalue (addr (lpsz))));
 end ListView_GetISearchString;


 %if #WIN32_IE >= 768 %then %do;
 dcl LVM_SETICONSPACING fixed bin(31) value(LVM_FIRST + 53);
 /* -1 for cx and cy means we'll use the default (system settings) */
 /*  0 for cx  or cy means use the current setting                 */
 /*    (allows you to change just one param)                       */
 ListView_SetIconSpacing: proc (hwndLV, cx, cy)
                          returns (type DWORD byvalue optional)
                          options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       cx     fixed bin(31) byvalue,
       cy     fixed bin(31) byvalue;
   return (SNDMSG (hwndLV, LVM_SETICONSPACING, 0, MAKELONG(cx,cy)));
 end ListView_SetIconSpacing;


 dcl LVM_SETEXTENDEDLISTVIEWSTYLE fixed bin(31) value(LVM_FIRST + 54);
     /* optional wParam == mask */
 ListView_SetExtendedListViewStyle: proc (hwndLV, dw)
                                   returns (type DWORD byvalue optional)
                                   options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       dw     type DWORD byvalue;
   return (SNDMSG (hwndLV, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (dw)));
 end ListView_SetExtendedListViewStyle;

 %if #WIN32_IE >= 1024 %then %do;
 ListView_SetExtendedListViewStyleEx: proc (hwndLV, dwMask, dw)
                                   returns (type DWORD byvalue optional)
                                   options (inline reorder) internal;
   dcl hwndLV type HWND byvalue,
       dwMask type DWORD byvalue,
       dw     type DWORD byvalue;
   return (SNDMSG (hwndLV, LVM_SETEXTENDEDLISTVIEWSTYLE,
                   (dwMask), (dw)));
 end ListView_SetExtendedListViewStyleEx;
 %end;

 dcl LVM_GETEXTENDEDLISTVIEWSTYLE fixed bin(31) value(LVM_FIRST + 55);
 ListView_GetExtendedListViewStyle: proc (hwndLV)
                                   returns (type DWORD byvalue optional)
                                   options (inline reorder) internal;
   dcl hwndLV type HWND byvalue;
   return (SNDMSG (hwndLV, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0));
 end ListView_GetExtendedListViewStyle;


 dcl LVS_EX_GRIDLINES        type DWORD value('00000001'xu);
 dcl LVS_EX_SUBITEMIMAGES    type DWORD value('00000002'xu);
 dcl LVS_EX_CHECKBOXES       type DWORD value('00000004'xu);
 dcl LVS_EX_TRACKSELECT      type DWORD value('00000008'xu);
 dcl LVS_EX_HEADERDRAGDROP   type DWORD value('00000010'xu);
 dcl LVS_EX_FULLROWSELECT    type DWORD value('00000020'xu);
     /* applies to report mode only */
 dcl LVS_EX_ONECLICKACTIVATE type DWORD value('00000040'xu);
 dcl LVS_EX_TWOCLICKACTIVATE type DWORD value('00000080'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl LVS_EX_FLATSB           type DWORD value('00000100'xu);
 dcl LVS_EX_REGIONAL         type DWORD value('00000200'xu);
 dcl LVS_EX_INFOTIP          type DWORD value('00000400'xu);
     /* listview does InfoTips for you */
 dcl LVS_EX_UNDERLINEHOT     type DWORD value('00000800'xu);
 dcl LVS_EX_UNDERLINECOLD    type DWORD value('00001000'xu);
 dcl LVS_EX_MULTIWORKAREAS   type DWORD value('00002000'xu);
 %end;

 %if #WIN32_IE >= 1280 %then %do;
 dcl LVS_EX_LABELTIP         type DWORD value('00004000'xu);
     /* listview unfolds partly hidden labels */
     /* if it does not have infotip text      */
 dcl LVS_EX_BORDERSELECT     type DWORD value('00008000'xu);
     /* border selection style instead of highlight */
 %end; /* End (_WIN32_IE >= 0x0500) */
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl LVS_EX_DOUBLEBUFFER     type DWORD value('00010000'xu);
 dcl LVS_EX_HIDELABELS       type DWORD value('00020000'xu);
 dcl LVS_EX_SINGLEROW        type DWORD value('00040000'xu);
 dcl LVS_EX_SNAPTOGRID       type DWORD value('00080000'xu);
     /* Icons automatically snap to grid. */
 dcl LVS_EX_SIMPLESELECT     type DWORD value('00100000'xu);
     /* Also changes overlay rendering to top right for icon mode. */
 %end;

 dcl LVM_GETSUBITEMRECT fixed bin(31) value(LVM_FIRST + 56);
 ListView_GetSubItemRect: proc (hwnd, iItem, iSubItem, code, prc)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       iItem    fixed bin(31) byvalue,
       iSubItem fixed bin(31) byvalue,
       code     fixed bin(31) byvalue,
       prc      type RECT byaddr optional;
   dcl (addr, binvalue, present) builtin;
   if present (prc) then
   do;
     prc.top  = iSubItem;
     prc.left = code;
     return (SNDMSG (hwnd, LVM_GETSUBITEMRECT, (iITem),
                     binvalue (addr (prc))));
   end;
   else
     return (SNDMSG (hwnd, LVM_GETSUBITEMRECT, (iItem), 0));
 end ListView_GetSubItemRect;


 dcl LVM_SUBITEMHITTEST fixed bin(31) value(LVM_FIRST + 57);
 ListView_SubItemHitTest: proc (hwnd, plvhti)
                          returns (fixed bin(31) byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       plvhti   type LVHITTESTINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SUBITEMHITTEST, 0,
                   binvalue (addr (plvhti))));
 end ListView_SubItemHitTest;


 dcl LVM_SETCOLUMNORDERARRAY fixed bin(31) value(LVM_FIRST + 58);
 ListView_SetColumnOrderArray: proc (hwnd, iCount, pi)
                               returns (type BOOL byvalue optional)
                               options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iCount fixed bin(31) byvalue,
       pi (*) fixed bin(31) byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETCOLUMNORDERARRAY, (iCount),
                   binvalue (addr (pi))));
 end ListView_SetColumnOrderArray;

 dcl LVM_GETCOLUMNORDERARRAY fixed bin(31) value(LVM_FIRST + 59);
 ListView_GetColumnOrderArray: proc (hwnd, iCount, pi)
                               returns (type BOOL byvalue optional)
                               options (inline reorder) internal;
   dcl hwnd   type HWND,
       iCount fixed bin(31),
       pi (*) fixed bin(31) byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETCOLUMNORDERARRAY, iCount,
                   binvalue (addr (pi))));
 end ListView_GetColumnOrderArray;

 dcl LVM_SETHOTITEM fixed bin(31) value(LVM_FIRST + 60);
 ListView_SetHotItem: proc (hwnd, i)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND,
       i    fixed bin(31);
   return (SNDMSG (hwnd, LVM_SETHOTITEM, (i), 0));
 end ListView_SetHotItem;

 dcl LVM_GETHOTITEM fixed bin(31) value(LVM_FIRST + 61);
 ListView_GetHotItem: proc (hwnd)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND;
   return (SNDMSG (hwnd, LVM_GETHOTITEM, 0, 0));
 end ListView_GetHotItem;

 dcl LVM_SETHOTCURSOR fixed bin(31) value(LVM_FIRST + 62);
 ListView_SetHotCursor: proc (hwnd, hcur)
                        returns (type HCURSOR byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND,
       hcur type HCURSOR;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, LVM_SETHOTCURSOR, 0,
                     binvalue (hcur))));
 end ListView_SetHotCursor;

 dcl LVM_GETHOTCURSOR fixed bin(31) value(LVM_FIRST + 63);
 ListView_GetHotCursor: proc (hwnd)
                        returns (type HCURSOR byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, LVM_GETHOTCURSOR, 0, 0)));
 end ListView_GetHotCursor;

 dcl LVM_APPROXIMATEVIEWRECT fixed bin(31) value(LVM_FIRST + 64);
 ListView_ApproximateViewRect: proc (hwnd, iWidth, iHeight, iCount)
                               returns (type DWORD byvalue optional)
                               options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       iWidth  fixed bin(31) byvalue,
       iHeight fixed bin(31) byvalue,
       iCount  fixed bin(31) byvalue;
   return (SNDMSG (hwnd, LVM_APPROXIMATEVIEWRECT, (iCount),
                   MAKELPARAM (iWidth, iHeight)));
 end ListView_ApproximateViewRect;
 %end; /* _WIN32_IE >= 0x0300 */


 %if #WIN32_IE >= 1024 %then %do;
 dcl LV_MAX_WORKAREAS fixed bin(31) value(16);
 dcl LVM_SETWORKAREAS fixed bin(31) value(LVM_FIRST + 65);
 ListView_SetWorkAreas: proc (hwnd, nWorkAreas, prc)
                        returns (type BOOL byvalue optional)
                                         /* not used */
                        options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       nWorkAreas fixed bin(31) byvalue,
       prc (*)    type RECT byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETWORKAREAS, (nWorkAreas),
                   binvalue (addr (prc))));
 end ListView_SetWorkAreas;

 dcl LVM_GETWORKAREAS fixed bin(31) value(LVM_FIRST + 70);
 ListView_GetWorkAreas: proc (hwnd, nWorkAreas, prc)
                        returns (type BOOL byvalue optional)
                                         /* not used */
                        options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       nWorkAreas fixed bin(31),
       prc (*)    type RECT byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETWORKAREAS, (nWorkAreas),
                   binvalue (addr (prc))));
 end ListView_GetWorkAreas;


 dcl LVM_GETNUMBEROFWORKAREAS fixed bin(31) value(LVM_FIRST + 73);
 ListView_GetNumberOfWorkAreas: proc (hwnd, pnWorkAreas)
                                returns (type BOOL byvalue optional)
                                         /* not used */
                                options (inline reorder) internal;
   dcl hwnd        type HWND byvalue,
       pnWorkAreas fixed bin(31) byaddr;
   return (SNDMSG (hwnd, LVM_GETNUMBEROFWORKAREAS, 0,
                   binvalue (addr (pnWorkAreas))));
 end ListView_GetNumberOfWorkAreas;


 dcl LVM_GETSELECTIONMARK fixed bin(31) value(LVM_FIRST + 66);
 ListView_GetSelectionMark: proc (hwnd)
                            returns (fixed bin(31) byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETSELECTIONMARK, 0, 0));
 end ListView_GetSelectionMark;

 dcl LVM_SETSELECTIONMARK fixed bin(31) value(LVM_FIRST + 67);
 ListView_SetSelectionMark: proc (hwnd, i)
                            returns (fixed bin(31) byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, LVM_SETSELECTIONMARK, 0, (i)));
 end ListView_SetSelectionMark;


 dcl LVM_SETHOVERTIME fixed bin(31) value(LVM_FIRST + 71);
 ListView_SetHoverTime: proc (hwndLV, dwHoverTimeMs)
                        returns (type DWORD byvalue optional)
                        options (inline reorder) internal;
   dcl hwndLV        type HWND byvalue,
       dwHoverTimeMs type DWORD byvalue;
   return (SendMessage (hwndLV, LVM_SETHOVERTIME, 0, (dwHoverTimeMs)));
 end ListView_SetHoverTime;

 dcl LVM_GETHOVERTIME fixed bin(31) value(LVM_FIRST + 72);
 ListView_GetHoverTime: proc (hwndLV)
                        returns (type DWORD byvalue optional)
                        options (inline reorder) internal;
   dcl hwndLV type HWND byvalue;
   return (SendMessage (hwndLV, LVM_GETHOVERTIME, 0, 0));
 end ListView_GetHoverTime;

 dcl LVM_SETTOOLTIPS fixed bin(31) value(LVM_FIRST + 74);
 ListView_SetToolTips: proc (hwndLV, hwndNewHwnd)
                       returns (type HWND byvalue optional)
                       options (inline reorder) internal;
   dcl hwndLV      type HWND byvalue,
       hwndNewHwnd type DWORD byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SendMessage (hwndLV, LVM_SETTOOLTIPS,
                                  binvalue (hwndNewHwnd), 0)));
 end ListView_SetToolTips;

 dcl LVM_GETTOOLTIPS fixed bin(31) value(LVM_FIRST + 78);
 ListView_GetToolTips: proc (hwndLV)
                       returns (type HWND byvalue optional)
                       options (inline reorder) internal;
   dcl hwndLV   type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SendMessage (hwndLV, LVM_GETTOOLTIPS, 0, 0)));
 end ListView_GetToolTips;


 define structure
   1 LVBKIMAGEA,
     2 ulFlags        type ULONG, /* LVBKIF_* */
     2 hbm            type HBITMAP,
     2 pszImage       type LPSTR,
     2 cchImageMax    type UINT,
     2 xOffsetPercent fixed bin(31),
     2 yOffsetPercent fixed bin(31);
 define alias LPLVBKIMAGEA handle LVBKIMAGEA;

 define structure
   1 LVBKIMAGEW,
     2 ulFlags        type ULONG, /* LVBKIF_* */
     2 hbm            type HBITMAP,
     2 pszImage       type LPWSTR,
     2 cchImageMax    type UINT,
     2 xOffsetPercent fixed bin(31),
     2 yOffsetPercent fixed bin(31);
 define alias LPLVBKIMAGEW handle LVBKIMAGEW;

 dcl LVBKIF_SOURCE_NONE     type ULONG value('00000000'xu);
 dcl LVBKIF_SOURCE_HBITMAP  type ULONG value('00000001'xu);
 dcl LVBKIF_SOURCE_URL      type ULONG value('00000002'xu);
 dcl LVBKIF_SOURCE_MASK     type ULONG value('00000003'xu);
 dcl LVBKIF_STYLE_NORMAL    type ULONG value('00000000'xu);
 dcl LVBKIF_STYLE_TILE      type ULONG value('00000010'xu);
 dcl LVBKIF_STYLE_MASK      type ULONG value('00000010'xu);
 %if #WIN32_WINNT >= 1281 %then %do;
 dcl LVBKIF_FLAG_TILEOFFSET type ULONG value('00000100'xu);
 dcl LVBKIF_TYPE_WATERMARK  type ULONG value('10000000'xu);
 %end;

 dcl LVM_SETBKIMAGEA fixed bin(31) value(LVM_FIRST + 68);
 dcl LVM_SETBKIMAGEW fixed bin(31) value(LVM_FIRST + 138);
 dcl LVM_GETBKIMAGEA fixed bin(31) value(LVM_FIRST + 69);
 dcl LVM_GETBKIMAGEW fixed bin(31) value(LVM_FIRST + 139);

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl LVM_SETSELECTEDCOLUMN fixed bin(31) value(LVM_FIRST + 140);
 ListView_SetSelectedColumn: proc (hwnd, iCol)
                             returns (fixed bin(31) byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iCol type WPARAM byvalue;
   return (SNDMSG (hwnd, LVM_SETSELECTEDCOLUMN, iCol, 0));
 end ListView_SetSelectedColumn;

 dcl LVM_SETTILEWIDTH      fixed bin(31) value(LVM_FIRST + 141);
 ListView_SetTileWidth: proc (hwnd, cpWidth)
                        returns (fixed bin(31) byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       cpWidth fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_SETTILEWIDTH, cast (: WPARAM, cpWidth :),
                                           0));
 end ListView_SetTileWidth;

 dcl LV_VIEW_ICON        type DWORD value ('0000'xu);
 dcl LV_VIEW_DETAILS     type DWORD value ('0001'xu);
 dcl LV_VIEW_SMALLICON   type DWORD value ('0002'xu);
 dcl LV_VIEW_LIST        type DWORD value ('0003'xu);
 dcl LV_VIEW_TILE        type DWORD value ('0004'xu);
 dcl LV_VIEW_MAX         type DWORD value ('0004'xu);

 dcl LVM_SETVIEW         fixed bin(31) value(LVM_FIRST + 142);
 ListView_SetView: proc (hwnd, iView)
                   returns (type DWORD byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iView type DWORD byvalue;
   return (SNDMSG (hwnd, LVM_SETVIEW, cast (: WPARAM, iView :), 0));
 end ListView_SetView;

 dcl LVM_GETVIEW         fixed bin(31) value(LVM_FIRST + 143);
 ListView_GetView: proc (hwnd)
                   returns (type DWORD byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (SNDMSG (hwnd, LVM_GETVIEW, 0, 0));
 end ListView_GetView;

 dcl LVGF_NONE           type UINT value ('00000000'xu);
 dcl LVGF_HEADER         type UINT value ('00000001'xu);
 dcl LVGF_FOOTER         type UINT value ('00000002'xu);
 dcl LVGF_STATE          type UINT value ('00000004'xu);
 dcl LVGF_ALIGN          type UINT value ('00000008'xu);
 dcl LVGF_GROUPID        type UINT value ('00000010'xu);

 dcl LVGS_NORMAL         type UINT value ('00000000'xu);
 dcl LVGS_COLLAPSED      type UINT value ('00000001'xu);
 dcl LVGS_HIDDEN         type UINT value ('00000002'xu);

 dcl LVGA_HEADER_LEFT    type UINT value ('00000001'xu);
 dcl LVGA_HEADER_CENTER  type UINT value ('00000002'xu);
 dcl LVGA_HEADER_RIGHT   type UINT value ('00000004'xu);
     /* Don't forget to validate exclusivity */
 dcl LVGA_FOOTER_LEFT    type UINT value ('00000008'xu);
 dcl LVGA_FOOTER_CENTER  type UINT value ('00000010'xu);
 dcl LVGA_FOOTER_RIGHT   type UINT value ('00000020'xu);
     /* Don't forget to validate exclusivity */

 define structure
   1 LVGROUP,
     2 cbSize    type UINT,
     2 mask      type UINT,
     2 pszHeader type LPWSTR,
     2 cchHeader fixed bin (31),
     2 pszFooter type LPWSTR,
     2 cchFooter fixed bin (31),
     2 iGroupId  fixed bin (31),
     2 stateMask type UINT,
     2 state     type UINT,
     2 uAlign    type UINT;
 define alias PLVGROUP handle LVGROUP;


 dcl LVM_INSERTGROUP         fixed bin(31) value(LVM_FIRST + 145);
 ListView_InsertGroup: proc (hwnd, index, pgrp)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       index fixed bin (31) byvalue,
       pgrp  type LVGROUP byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_INSERTGROUP, cast (: WPARAM, index :),
                                          binvalue (addr (pgrp))));
 end ListView_InsertGroup;


 dcl LVM_SETGROUPINFO        fixed bin(31) value(LVM_FIRST + 147);
 ListView_SetGroupInfo: proc (hwnd, iGroupId, pgrp)
                        returns (fixed bin(31) byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       iGroupId fixed bin (31) byvalue,
       pgrp     type LVGROUP byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETGROUPINFO, cast (: WPARAM, iGroupId :),
                                           binvalue (addr (pgrp))));
 end ListView_SetGroupInfo;

 dcl LVM_GETGROUPINFO        fixed bin(31) value(LVM_FIRST + 149);
 ListView_GetGroupInfo: proc (hwnd, iGroupId, pgrp)
                        returns (fixed bin(31) byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       iGroupId fixed bin (31) byvalue,
       pgrp     type LVGROUP byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETGROUPINFO, cast (: WPARAM, iGroupId :),
                                           binvalue (addr (pgrp))));
 end ListView_GetGroupInfo;

 dcl LVM_REMOVEGROUP         fixed bin(31) value(LVM_FIRST + 150);
 ListView_RemoveGroup: proc (hwnd, iGroupId)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       iGroupId fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_REMOVEGROUP, cast (: WPARAM, iGroupId :),
                                          0));
 end ListView_RemoveGroup;

 dcl LVM_MOVEGROUP           fixed bin(31) value(LVM_FIRST + 151);
 ListView_MoveGroup: proc (hwnd, iGroupId, toIndex)
                     returns (fixed bin(31) byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       iGroupId fixed bin (31) byvalue,
       toIndex  fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_MOVEGROUP, cast (: WPARAM, iGroupId :),
                                        cast (: LPARAM, toIndex :)));
 end ListView_MoveGroup;

 dcl LVM_MOVEITEMTOGROUP     fixed bin(31) value(LVM_FIRST + 154);
 ListView_MoveItemToGroup: proc (hwnd, idItemFrom, idGroupTo)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       idItemFrom fixed bin (31) byvalue,
       idGroupTo  fixed bin (31) byvalue;
   return (SNDMSG (hwnd, LVM_MOVEITEMTOGROUP,
                         cast (: WPARAM, idItemFrom :),
                         cast (: LPARAM, idGroupTo :)));
 end ListView_MoveItemToGroup;

 dcl LVGMF_NONE          type DWORD value ('00000000'xu);
 dcl LVGMF_BORDERSIZE    type DWORD value ('00000001'xu);
 dcl LVGMF_BORDERCOLOR   type DWORD value ('00000002'xu);
 dcl LVGMF_TEXTCOLOR     type DWORD value ('00000004'xu);

 define structure
   1 LVGROUPMETRICS,
     2 cbSize    type UINT,
     2 mask      type UINT,
     2 Left      type UINT,
     2 Top       type UINT,
     2 Right     type UINT,
     2 Bottom    type UINT,
     2 crLeft    type COLORREF,
     2 crTop     type COLORREF,
     2 crRight   type COLORREF,
     2 crBottom  type COLORREF,
     2 crHeader  type COLORREF,
     2 crFooter  type COLORREF;
 define alias PLVGROUPMETRICS handle LVGROUPMETRICS;

 dcl LVM_SETGROUPMETRICS     fixed bin(31) value(LVM_FIRST + 155);
 ListView_SetGroupMetrics: proc (hwnd, pGroupMetrics)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd          type HWND byvalue,
       pGroupMetrics type LVGROUPMETRICS byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETGROUPMETRICS,
                         0, binvalue (addr (pGroupMetrics))));
 end ListView_SetGroupMetrics;

 dcl LVM_GETGROUPMETRICS     fixed bin(31) value(LVM_FIRST + 156);
 ListView_GetGroupMetrics: proc (hwnd, pGroupMetrics)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd          type HWND byvalue,
       pGroupMetrics type LVGROUPMETRICS byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETGROUPMETRICS,
                         0, binvalue (addr (pGroupMetrics))));
 end ListView_GetGroupMetrics;

 dcl LVM_ENABLEGROUPVIEW     fixed bin(31) value(LVM_FIRST + 157);
 ListView_EnableGroupView: proc (hwnd, fEnable)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       fEnable type BOOL byvalue;
   return (SNDMSG (hwnd, LVM_ENABLEGROUPVIEW,
                         cast (: WPARAM, fEnable :), 0));
 end ListView_EnableGroupView;

 define alias PFNLVGROUPCOMPARE
        entry (fixed bin (31),
               fixed bin (31),
               pointer)
        returns (fixed bin (31) byvalue optional)
        limited CALLBACK;

 dcl LVM_SORTGROUPS         fixed bin(31) value(LVM_FIRST + 158);
 ListView_SortGroups: proc (hwnd, pfnGroupCompare, plv)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd            type HWND byvalue,
       pfnGroupCompare type PFNLVGROUPCOMPARE byvalue,
       plv             pointer byvalue;
   return (SNDMSG (hwnd, LVM_SORTGROUPS,
                   cast (: WPARAM, pfnGroupCompare :),
                   cast (: LPARAM, plv :)));
 end ListView_SortGroups;

 define structure
   1 LVINSERTGROUPSORTED,
     2 pfnGroupCompare type PFNLVGROUPCOMPARE,
     2 pvData          pointer,
     2 lvGroup         type LVGROUP;
 define alias PLVINSERTGROUPSORTED handle LVINSERTGROUPSORTED;

 dcl LVM_INSERTGROUPSORTED  fixed bin(31) value(LVM_FIRST + 159);
 ListView_InsertGroupSorted: proc (hwnd, structInsert)
                             returns (fixed bin(31) byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd         type HWND byvalue,
       structInsert type LVINSERTGROUPSORTED byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_INSERTGROUPSORTED,
                         binvalue (addr (structInsert)), 0));
 end ListView_InsertGroupSorted;

 dcl LVM_REMOVEALLGROUPS    fixed bin(31) value(LVM_FIRST + 160);
 ListView_RemoveAllGroups: proc (hwnd)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd         type HWND byvalue;
   return (SNDMSG (hwnd, LVM_REMOVEALLGROUPS, 0, 0));
 end ListView_RemoveAllGroups;

 dcl LVM_HASGROUP           fixed bin(31) value(LVM_FIRST + 161);
 ListView_HasGroup: proc (hwnd, dwGroupId)
                    returns (fixed bin(31) byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd      type HWND byvalue,
       dwGroupId type DWORD byvalue;
   return (SNDMSG (hwnd, LVM_HASGROUP, dwGroupId, 0));
 end ListView_HasGroup;

 dcl LVTVIF_AUTOSIZE        type DWORD value ('00000000'xu);
 dcl LVTVIF_FIXEDWIDTH      type DWORD value ('00000001'xu);
 dcl LVTVIF_FIXEDHEIGHT     type DWORD value ('00000002'xu);
 dcl LVTVIF_FIXEDSIZE       type DWORD value ('00000003'xu);

 dcl LVTVIM_TILESIZE        type DWORD value ('00000001'xu);
 dcl LVTVIM_COLUMNS         type DWORD value ('00000002'xu);
 dcl LVTVIM_LABELMARGIN     type DWORD value ('00000004'xu);

 define structure
   1 LVTILEVIEWINFO,
     2 cbSize        type UINT,
     2 dwMask        type DWORD, /* LVTVIM_* */
     2 dwFlags       type DWORD, /* LVTVIF_* */
     2 sizeTile      type SIZE,
     2 cLines        fixed bin (31),
     2 rcLabelMargin type RECT;
 define alias PLVTILEVIEWINFO handle LVTILEVIEWINFO;

 define structure
   1 LVTILEINFO,
     2 cbSize     type UINT,
     2 iItem      fixed bin (31),
     2 cColumns   type UINT,
     2 puColumns  type PUINT;
 define alias PLVTILEINFO handle LVTILEINFO;

 dcl LVM_SETTILEVIEWINFO    fixed bin(31) value(LVM_FIRST + 162);
 ListView_SetTileViewInfo: proc (hwnd, ptvi)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       ptvi type LVTILEVIEWINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETTILEVIEWINFO,
                         0, binvalue (addr (ptvi))));
 end ListView_SetTileViewInfo;

 dcl LVM_GETTILEVIEWINFO    fixed bin(31) value(LVM_FIRST + 163);
 ListView_GetTileViewInfo: proc (hwnd, ptvi)
                           returns (fixed bin(31) byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       ptvi type LVTILEVIEWINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETTILEVIEWINFO,
                         0, binvalue (addr (ptvi))));
 end ListView_GetTileViewInfo;

 dcl LVM_SETTILEINFO        fixed bin(31) value(LVM_FIRST + 164);
 ListView_SetTileInfo: proc (hwnd, pti)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       pti  type LVTILEINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETTILEINFO,
                         0, binvalue (addr (pti))));
 end ListView_SetTileInfo;

 dcl LVM_GETTILEINFO        fixed bin(31) value(LVM_FIRST + 165);
 ListView_GetTileInfo: proc (hwnd, pti)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       pti  type LVTILEINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETTILEINFO,
                         0, binvalue (addr (pti))));
 end ListView_GetTileInfo;

 define structure
   1 LVINSERTMARK,
     2 cbSize     type UINT,
     2 dwFlags    type DWORD,
     2 iItem      fixed bin (31),
     2 dwReserved type DWORD;
 define alias LPLVINSERTMARK handle LVINSERTMARK;

 dcl LVIM_AFTER   type DWORD value('00000001'xu);
     /* TRUE = insert After iItem, otherwise before */

 dcl LVM_SETINSERTMARK      fixed bin(31) value(LVM_FIRST + 166);
 ListView_SetInsertMark: proc (hwnd, lvim)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lvim type LVINSERTMARK byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETINSERTMARK,
                         0, binvalue (addr (lvim))));
 end ListView_SetInsertMark;

 dcl LVM_GETINSERTMARK      fixed bin(31) value(LVM_FIRST + 167);
 ListView_GetInsertMark: proc (hwnd, lvim)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lvim type LVINSERTMARK byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETINSERTMARK,
                         0, binvalue (addr (lvim))));
 end ListView_GetInsertMark;


 dcl LVM_INSERTMARKHITTEST  fixed bin(31) value(LVM_FIRST + 168);
 ListView_InsertMarkHitTest: proc (hwnd, point, lvim)
                             returns (fixed bin(31) byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       point type POINT byaddr,
       lvim  type LVINSERTMARK byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_INSERTMARKHITTEST,
                         binvalue (addr (point)),
                         binvalue (addr (lvim))));
 end ListView_InsertMarkHitTest;

 dcl LVM_GETINSERTMARKRECT  fixed bin(31) value(LVM_FIRST + 169);
 ListView_GetInsertMarkRect: proc (hwnd, rc)
                             returns (fixed bin(31) byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       rc    type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETINSERTMARKRECT,
                         0, binvalue (addr (rc))));
 end ListView_GetInsertMarkRect;

 dcl LVM_SETINSERTMARKCOLOR fixed bin(31) value(LVM_FIRST + 170);
 ListView_SetInsertMarkColor: proc (hwnd, color)
                              returns (type COLORREF byvalue optional)
                              options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       color type COLORREF byaddr;
   dcl (addr, binvalue) builtin;
   return (cast (: COLORREF, SNDMSG (hwnd, LVM_SETINSERTMARKCOLOR,
                                     0, binvalue (addr (color))) :));
 end ListView_SetInsertMarkColor;

 dcl LVM_GETINSERTMARKCOLOR fixed bin(31) value(LVM_FIRST + 171);
 ListView_GetInsertMarkColor: proc (hwnd)
                              returns (type COLORREF byvalue optional)
                              options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   dcl (addr, binvalue) builtin;
   return (cast (: COLORREF, SNDMSG (hwnd, LVM_GETINSERTMARKCOLOR,
                                           0, 0) :));
 end ListView_GetInsertMarkColor;

 define structure
   1 LVSETINFOTIP,
     2 cbSize    type UINT,
     2 dwFlags   type DWORD,
     2 pszText   type LPWSTR,
     2 iItem     fixed bin (31),
     2 iSubItem  fixed bin (31);
 define alias PLVSETINFOTIP handle LVSETINFOTIP;

 dcl  LVM_SETINFOTIP        fixed bin(31) value(LVM_FIRST + 173);

 ListView_SetInfoTip: proc (hwndLV, plvInfoTip)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwndLV     type HWND byvalue,
       plvInfoTip type LVSETINFOTIP byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndLV, LVM_SETINFOTIP,
                   0, binvalue (addr (plvInfoTip))));
 end ListView_SetInfoTip;

 dcl LVM_GETSELECTEDCOLUMN  fixed bin(31) value(LVM_FIRST + 174);
 ListView_GetSelectedColumn: proc (hwnd)
                             returns (type UINT byvalue optional)
                             options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (cast (: UINT, SNDMSG (hwnd, LVM_GETSELECTEDCOLUMN, 0, 0) :));
 end ListView_GetSelectedColumn;

 dcl LVM_ISGROUPVIEWENABLED fixed bin(31) value(LVM_FIRST + 175);
 ListView_IsGroupViewEnabled: proc (hwnd)
                              returns (type BOOL byvalue optional)
                              options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, LVM_ISGROUPVIEWENABLED, 0, 0));
 end ListView_IsGroupViewEnabled;

 dcl LVM_GETOUTLINECOLOR    fixed bin(31) value(LVM_FIRST + 176);
 ListView_GetOutlineColor: proc (hwnd)
                           returns (type COLORREF byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (cast (: COLORREF, SNDMSG (hwnd, LVM_GETOUTLINECOLOR,
                                           0, 0) :));
 end ListView_GetOutlineColor;

 dcl LVM_SETOUTLINECOLOR    fixed bin(31) value(LVM_FIRST + 177);
 ListView_SetOutlineColor: proc (hwnd, color)
                           returns (type COLORREF byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       color type COLORREF byaddr;
   dcl (addr, binvalue) builtin;
   return (cast (: COLORREF, SNDMSG (hwnd, LVM_SETOUTLINECOLOR,
                                     0, binvalue (addr (color))) :));
 end ListView_SetOutlineColor;

 dcl LVM_CANCELEDITLABEL    fixed bin(31) value(LVM_FIRST + 179);
 ListView_CancelEditLabel: proc (hwnd)
                           options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   call SNDMSG (hwnd, LVM_CANCELEDITLABEL, 0, 0);
 end ListView_CancelEditLabel;


 /* These next to methods make it easy to identify an item that can   */
 /* be repositioned within listview. For example: Many developers use */
 /* the lParam to store an identifier that is unique. Unfortunatly,   */
 /* in order to find this item, they have to iterate through all of   */
 /* the items in the listview. Listview will maintain a unique        */
 /* identifier.  The upper bound is the size of a DWORD.              */
 dcl LVM_MAPINDEXTOID       fixed bin(31) value(LVM_FIRST + 180);
 ListView_MapIndexToID: proc (hwnd, index)
                        returns (type UINT byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       index fixed bin (31) byvalue;
   return (cast (: UINT, SNDMSG (hwnd, LVM_MAPINDEXTOID,
                         cast (: WPARAM, index :), 0) :));
 end ListView_MapIndexToID;

 dcl LVM_MAPIDTOINDEX       fixed bin(31) value(LVM_FIRST + 181);
 ListView_MapIDToIndex: proc (hwnd, id)
                        returns (type UINT byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       id    fixed bin (31) byvalue;
   return (cast (: UINT, SNDMSG (hwnd, LVM_MAPIDTOINDEX,
                         cast (: WPARAM, id :), 0) :));
 end ListView_MapIDToIndex;

 %end;

 %if UNICODE ^= '' %then %do;
 define alias   LVBKIMAGE type   LVBKIMAGEW;
 define alias LPLVBKIMAGE type LPLVBKIMAGEW;
 dcl LVM_SETBKIMAGE fixed bin(31) value(LVM_SETBKIMAGEW);
 dcl LVM_GETBKIMAGE fixed bin(31) value(LVM_GETBKIMAGEW);
 %end; %else %do;
 define alias   LVBKIMAGE type   LVBKIMAGEA;
 define alias LPLVBKIMAGE type LPLVBKIMAGEA;
 dcl LVM_SETBKIMAGE fixed bin(31) value(LVM_SETBKIMAGEA);
 dcl LVM_GETBKIMAGE fixed bin(31) value(LVM_GETBKIMAGEA);
 %end;

 ListView_SetBkImage: proc (hwnd, plvbki)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       plvbki type LVBKIMAGE byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_SETBKIMAGE, 0, binvalue (addr (plvbki))));
 end ListView_SetBkImage;

 ListView_GetBkImage: proc (hwnd, plvbki)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       plvbki type LVBKIMAGE byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, LVM_GETBKIMAGE, 0, binvalue (addr (plvbki))));
 end ListView_GetBkImage;

 %end; /* _WIN32_IE >= 0x0400 */


 define structure
   1 NMLISTVIEW unaligned,
     2 hdr       type NMHDR,
     2 iItem     fixed bin(31),
     2 iSubItem  fixed bin(31),
     2 uNewState type UINT,
     2 uOldState type UINT,
     2 uChanged  type UINT,
     2 ptAction  type POINT,
     2 lParam    type LPARAM;
 define alias LPNMLISTVIEW  handle NMLISTVIEW;
 define alias   NM_LISTVIEW type   NMLISTVIEW;
 define alias LPNM_LISTVIEW handle NMLISTVIEW;


 %if #WIN32_IE >= 1024 %then %do;
 /* NMITEMACTIVATE is used instead of NMLISTVIEW in IE >= 0x400     */
 /* therefore all the fields are the same except for extra uKeyFlags */
 /* they are used to store key flags at the time of the single click */
 /* with delayed activation - because by the time the timer goes off */
 /* a user may not hold the keys (shift, ctrl) any more              */
 define structure
   1 NMITEMACTIVATE unaligned,
     2 hdr       type NMHDR,
     2 iItem     fixed bin(31),
     2 iSubItem  fixed bin(31),
     2 uNewState type UINT,
     2 uOldState type UINT,
     2 uChanged  type UINT,
     2 ptAction  type POINT,
     2 lParam    type LPARAM,
     2 uKeyFlags type UINT;
 define alias LPNMITEMACTIVATE handle NMITEMACTIVATE;

 /* key flags stored in uKeyFlags */
 dcl LVKF_ALT     type UINT value('0001'xu);
 dcl LVKF_CONTROL type UINT value('0002'xu);
 dcl LVKF_SHIFT   type UINT value('0004'xu);
 %end; /*(_WIN32_IE >= 0x0400) */


 define structure
   1 NMLVCUSTOMDRAW unaligned,
     2 nmcd        type NMCUSTOMDRAW,
     2 clrText     type COLORREF,
     2 clrTextBk   type COLORREF
 %if #WIN32_IE >= 1024 %then %do;
   , 2 iSubItem    fixed bin(31)
 %end;
 %if #WIN32_WINNT >= 1281 %then %do;
   , 2 dwItemType  type DWORD,

     /* Item custom draw */
     2 clrFace     type COLORREF,
     2 iIconEffect fixed bin (31),
     2 iIconPhase  fixed bin (31),
     2 iPartId     fixed bin (31),
     2 iStateId    fixed bin (31),

     /* Group Custom Draw */
     2 rcText      type RECT,
     2 uAlign      type UINT /* Alignment. Use LVGA_HEADER_CENTER, */
                             /* LVGA_HEADER_RIGHT, LVGA_HEADER_LEFT */
 %end;
   ;
 define alias LPNMLVCUSTOMDRAW handle NMLVCUSTOMDRAW;

 /* dwItemType */
 dcl LVCDI_ITEM      type DWORD value ('00000000'xu);
 dcl LVCDI_GROUP     type DWORD value ('00000001'xu);

 /* ListView custom draw return values */
 dcl LVCDRF_NOSELECT      type DWORD value ('00010000'xu);
 dcl LVCDRF_NOGROUPFRAME  type DWORD value ('00020000'xu);

 dcl NMLVCUSTOMDRAW_V3_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (NMLVCUSTOMDRAW, clrTextBk));

 define structure
   1 NMLVCACHEHINT unaligned,
     2 hdr   type NMHDR,
     2 iFrom fixed bin(31),
     2 iTo   fixed bin(31);
 define alias LPNMLVCACHEHINT handle NMLVCACHEHINT;

 define alias   NM_CACHEHINT type   NMLVCACHEHINT;
 define alias  PNM_CACHEHINT type LPNMLVCACHEHINT;
 define alias LPNM_CACHEHINT type LPNMLVCACHEHINT;


 define structure
   1 NMLVFINDITEM unaligned,
     2 hdr    type NMHDR,
     2 iStart fixed bin(31),
     2 lvfi   type LVFINDINFO;
 define alias LPNMLVFINDITEM handle NMLVFINDITEM;

 define alias   NM_FINDITEM type   NMLVFINDITEM;
 define alias  PN_VFINDITEM type LPNMLVFINDITEM;
 define alias LPN_VFINDITEM type LPNMLVFINDITEM;


 define structure
   1 NMLVODSTATECHANGE unaligned,
     2 hdr       type NMHDR,
     2 iFrom     fixed bin(31),
     2 iTo       fixed bin(31),
     2 uNewState type UINT,
     2 uOldState type UINT;
 define alias LPNMLVODSTATECHANGE handle NMLVODSTATECHANGE;

 define alias   NM_ODSTATECHANGE type   NMLVODSTATECHANGE;
 define alias  PNM_ODSTATECHANGE type LPNMLVODSTATECHANGE;
 define alias LPNM_ODSTATECHANGE type LPNMLVODSTATECHANGE;


 dcl LVN_ITEMCHANGING    fixed bin(31) value(LVN_FIRST-0);
 dcl LVN_ITEMCHANGED     fixed bin(31) value(LVN_FIRST-1);
 dcl LVN_INSERTITEM      fixed bin(31) value(LVN_FIRST-2);
 dcl LVN_DELETEITEM      fixed bin(31) value(LVN_FIRST-3);
 dcl LVN_DELETEALLITEMS  fixed bin(31) value(LVN_FIRST-4);
 dcl LVN_BEGINLABELEDITA fixed bin(31) value(LVN_FIRST-5);
 dcl LVN_BEGINLABELEDITW fixed bin(31) value(LVN_FIRST-75);
 dcl LVN_ENDLABELEDITA   fixed bin(31) value(LVN_FIRST-6);
 dcl LVN_ENDLABELEDITW   fixed bin(31) value(LVN_FIRST-76);
 dcl LVN_COLUMNCLICK     fixed bin(31) value(LVN_FIRST-8);
 dcl LVN_BEGINDRAG       fixed bin(31) value(LVN_FIRST-9);
 dcl LVN_BEGINRDRAG      fixed bin(31) value(LVN_FIRST-11);


 %if #WIN32_IE >= 768 %then %do;
 dcl LVN_ODCACHEHINT     fixed bin(31) value(LVN_FIRST-13);
 dcl LVN_ODFINDITEMA     fixed bin(31) value(LVN_FIRST-52);
 dcl LVN_ODFINDITEMW     fixed bin(31) value(LVN_FIRST-79);

 dcl LVN_ITEMACTIVATE    fixed bin(31) value(LVN_FIRST-14);
 dcl LVN_ODSTATECHANGED  fixed bin(31) value(LVN_FIRST-15);


 %if UNICODE ^= '' %then %do;
 dcl LVN_ODFINDITEM      fixed bin(31) value(LVN_ODFINDITEMW);
 %end; %else %do;
 dcl LVN_ODFINDITEM      fixed bin(31) value(LVN_ODFINDITEMA);
 %end;
 %end; /* _WIN32_IE >= 0x0300 */


 %if #WIN32_IE >= 1024 %then %do;
 dcl LVN_HOTTRACK        fixed bin(31) value(LVN_FIRST-21);
 %end;

 dcl LVN_GETDISPINFOA    fixed bin(31) value(LVN_FIRST-50);
 dcl LVN_GETDISPINFOW    fixed bin(31) value(LVN_FIRST-77);
 dcl LVN_SETDISPINFOA    fixed bin(31) value(LVN_FIRST-51);
 dcl LVN_SETDISPINFOW    fixed bin(31) value(LVN_FIRST-78);


 %if UNICODE ^= '' %then %do;
 dcl LVN_BEGINLABELEDIT  fixed bin(31) value(LVN_BEGINLABELEDITW);
 dcl LVN_ENDLABELEDIT    fixed bin(31) value(LVN_ENDLABELEDITW);
 dcl LVN_GETDISPINFO     fixed bin(31) value(LVN_GETDISPINFOW);
 dcl LVN_SETDISPINFO     fixed bin(31) value(LVN_SETDISPINFOW);
 %end; %else %do;
 dcl LVN_BEGINLABELEDIT  fixed bin(31) value(LVN_BEGINLABELEDITA);
 dcl LVN_ENDLABELEDIT    fixed bin(31) value(LVN_ENDLABELEDITA);
 dcl LVN_GETDISPINFO     fixed bin(31) value(LVN_GETDISPINFOA);
 dcl LVN_SETDISPINFO     fixed bin(31) value(LVN_SETDISPINFOA);
 %end;


 dcl LVIF_DI_SETITEM     fixed bin(31) value('1000'xn);


 define structure
   1 LVDISPINFO unaligned,
     2 hdr  type NMHDR,
     2 item type LVITEMA;
 define alias   NMLVDISPINFOA type   LVDISPINFO;
 define alias LPNMLVDISPINFOA handle LVDISPINFO;
 define alias   LV_DISPINFOA  type   NMLVDISPINFOA;
 define alias LPLV_DISPINFOA  type LPNMLVDISPINFOA;

 define structure
   1 LVDISPINFOW unaligned,
     2 hdr  type NMHDR,
     2 item type LVITEMW;
 define alias   NMLVDISPINFOW type   LVDISPINFOW;
 define alias LPNMLVDISPINFOW handle LVDISPINFOW;
 define alias   LV_DISPINFOW  type   NMLVDISPINFOW;
 define alias LPLV_DISPINFOW  type LPNMLVDISPINFOW;


 %if UNICODE ^= '' %then %do;
 define alias   NMLVDISPINFO type   NMLVDISPINFOW;
 define alias LPNMLVDISPINFO type LPNMLVDISPINFOW;
 %end; %else %do;
 define alias   NMLVDISPINFO type   NMLVDISPINFOA;
 define alias LPNMLVDISPINFO type LPNMLVDISPINFOA;
 %end;
 define alias   LV_DISPINFO type   NMLVDISPINFO;
 define alias LPLV_DISPINFO type LPNMLVDISPINFO;

 dcl LVN_KEYDOWN fixed bin(31) value(LVN_FIRST-55);


 define structure
   1 LVKEYDOWN unaligned,
     2 hdr   type NMHDR,
     2 wVKey type WORD,
     2 flags type UINT;
 define alias   NMLVKEYDOWN type   LVKEYDOWN;
 define alias LPNMLVKEYDOWN handle LVKEYDOWN;
 define alias   NM_KEYDOWN type   NMLVKEYDOWN;
 define alias LPNM_KEYDOWN type LPNMLVKEYDOWN;


 %if #WIN32_IE >= 768 %then %do;
 dcl LVN_MARQUEEBEGIN fixed bin(31) value(LVN_FIRST-56);
 %end;


 %if #WIN32_IE >= 1024 %then %do;
 define structure
   1 NMLVGETINFOTIPA unaligned,
     2 hdr        type NMHDR,
     2 dwFlags    type DWORD,
     2 pszText    type LPSTR,
     2 cchTextMax fixed bin(31),
     2 iItem      fixed bin(31),
     2 iSubItem   fixed bin(31),
     2 lParam     type LPARAM;
 define alias LPNMLVGETINFOTIPA handle NMLVGETINFOTIPA;

 define structure
   1 NMLVGETINFOTIPW unaligned,
     2 hdr        type NMHDR,
     2 dwFlags    type DWORD,
     2 pszText    type LPWSTR,
     2 cchTextMax fixed bin(31),
     2 iItem      fixed bin(31),
     2 iSubItem   fixed bin(31),
     2 lParam     type LPARAM;
 define alias LPNMLVGETINFOTIPW handle NMLVGETINFOTIPW;

 /* NMLVGETINFOTIPA.dwFlag values */

 dcl LVGIT_UNFOLDED  fixed bin(31) value('0001'xn);

 dcl LVN_GETINFOTIPA fixed bin(31) value(LVN_FIRST-57);
 dcl LVN_GETINFOTIPW fixed bin(31) value(LVN_FIRST-58);


 %if UNICODE ^= '' %then %do;
 dcl LVN_GETINFOTIP  fixed bin(31) value(LVN_GETINFOTIPW);
 define alias NMLVGETINFOTIP   type   NMLVGETINFOTIPW;
 define alias LPNMLVGETINFOTIP type LPNMLVGETINFOTIPW;
 %end; %else %do;
 dcl LVN_GETINFOTIP  fixed bin(31) value(LVN_GETINFOTIPA);
 define alias   NMLVGETINFOTIP type   NMLVGETINFOTIPA;
 define alias LPNMLVGETINFOTIP type LPNMLVGETINFOTIPA;
 %end;


 %end; /* _WIN32_IE >= 0x0400 */

 %if #WIN32_WINNT >= 1281 %then %do;
 define structure
   1 NMLVSCROLL unaligned,
     2 hdr  type NMHDR,
     2 dx   fixed bin (31),
     2 dy   fixed bin (31);
 define alias LPNMLVSCROLL handle NMLVSCROLL;

 dcl LVN_BEGINSCROLL  fixed bin(31) value(LVN_FIRST-80);
 dcl LVN_ENDSCROLL    fixed bin(31) value(LVN_FIRST-81);
 %end;

 %end; /* NOLISTVIEW */

 /* ====== TREEVIEW CONTROL ========================================= */

 %dcl NOTREEVIEW char ext;
 %if NOTREEVIEW = '' %then %do;

 %if #WIN32 ^= '' %then %do;
 dcl WC_TREEVIEWA char  value('SysTreeView32');
 dcl WC_TREEVIEWW WCHAR value('SysTreeView32');

 %dcl WC_TREEVIEW char ext;
 %if UNICODE ^= '' %then %do;
 %WC_TREEVIEW='WC_TREEVIEWW';
 %end; %else %do;
 %WC_TREEVIEW='WC_TREEVIEWA';
 %end;

 %end; %else %do;
 dcl WC_TREEVIEW char value('SysTreeView');
 %end;

 /* begin_r_commctrl */

 dcl TVS_HASBUTTONS      type DWORD value('0001'xu);
 dcl TVS_HASLINES        type DWORD value('0002'xu);
 dcl TVS_LINESATROOT     type DWORD value('0004'xu);
 dcl TVS_EDITLABELS      type DWORD value('0008'xu);
 dcl TVS_DISABLEDRAGDROP type DWORD value('0010'xu);
 dcl TVS_SHOWSELALWAYS   type DWORD value('0020'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl TVS_RTLREADING      type DWORD value('0040'xu);

 dcl TVS_NOTOOLTIPS      type DWORD value('0080'xu);
 dcl TVS_CHECKBOXES      type DWORD value('0100'xu);
 dcl TVS_TRACKSELECT     type DWORD value('0200'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TVS_SINGLEEXPAND    type DWORD value('0400'xu);
 dcl TVS_INFOTIP         type DWORD value('0800'xu);
 dcl TVS_FULLROWSELECT   type DWORD value('1000'xu);
 dcl TVS_NOSCROLL        type DWORD value('2000'xu);
 dcl TVS_NONEVENHEIGHT   type DWORD value('4000'xu);
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 dcl TVS_NOHSCROLL       type DWORD value('8000'xu);
     /* TVS_NOSCROLL overrides this */
 %end;

 %end;

 /* end_r_commctrl */

 define alias HTREEITEM pointer;

 dcl TVIF_TEXT           type UINT value('0001'xu);
 dcl TVIF_IMAGE          type UINT value('0002'xu);
 dcl TVIF_PARAM          type UINT value('0004'xu);
 dcl TVIF_STATE          type UINT value('0008'xu);
 dcl TVIF_HANDLE         type UINT value('0010'xu);
 dcl TVIF_SELECTEDIMAGE  type UINT value('0020'xu);
 dcl TVIF_CHILDREN       type UINT value('0040'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TVIF_INTEGRAL       type UINT value('0080'xu);
 %end;
 dcl TVIS_SELECTED       type DWORD value('0002'xu);
 dcl TVIS_CUT            type DWORD value('0004'xu);
 dcl TVIS_DROPHILITED    type DWORD value('0008'xu);
 dcl TVIS_BOLD           type DWORD value('0010'xu);
 dcl TVIS_EXPANDED       type DWORD value('0020'xu);
 dcl TVIS_EXPANDEDONCE   type DWORD value('0040'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl TVIS_EXPANDPARTIAL  type DWORD value('0080'xu);
 %end;

 dcl TVIS_OVERLAYMASK    type DWORD value('0F00'xu);
 dcl TVIS_STATEIMAGEMASK type DWORD value('F000'xu);
 dcl TVIS_USERMASK       type DWORD value('F000'xu);

 dcl I_CHILDRENCALLBACK  fixed bin(31) value(-1 );


 define structure
   1 TVITEMA,
     2 mask           type UINT,
     2 hItem          type HTREEITEM,
     2 state          type UINT,
     2 stateMask      type UINT,
     2 pszText        type LPSTR,
     2 cchTextMax     fixed bin(31),
     2 iImage         fixed bin(31),
     2 iSelectedImage fixed bin(31),
     2 cChildren      fixed bin(31),
     2 lParam         type LPARAM;
 define alias LPTVITEMA  handle TVITEMA;
 define alias   TV_ITEMA type   TVITEMA;
 define alias LPTV_ITEMA type LPTVITEMA;

 define structure
   1 TVITEMW,
     2 mask           type UINT,
     2 hItem          type HTREEITEM,
     2 state          type UINT,
     2 stateMask      type UINT,
     2 pszText        type LPWSTR,
     2 cchTextMax     fixed bin(31),
     2 iImage         fixed bin(31),
     2 iSelectedImage fixed bin(31),
     2 cChildren      fixed bin(31),
     2 lParam         type LPARAM;
 define alias LPTVITEMW  handle TVITEMW;
 define alias   TV_ITEMW type   TVITEMW;
 define alias LPTV_ITEMW type LPTVITEMW;


 %if #WIN32_IE >= 1024 %then %do;
 /* only used for Get and Set messages.  no notifies */
 define structure
   1 TVITEMEXA,
     2 mask           type UINT,
     2 hItem          type HTREEITEM,
     2 state          type UINT,
     2 stateMask      type UINT,
     2 pszText        type LPSTR,
     2 cchTextMax     fixed bin(31),
     2 iImage         fixed bin(31),
     2 iSelectedImage fixed bin(31),
     2 cChildren      fixed bin(31),
     2 lParam         type LPARAM,
     2 iIntegral      fixed bin(31);
 define alias LPTVITEMEXA handle TVITEMEXA;

 /* only used for Get and Set messages.  no notifies */
 define structure
   1 TVITEMEXW,
     2 mask           type UINT,
     2 hItem          type HTREEITEM,
     2 state          type UINT,
     2 stateMask      type UINT,
     2 pszText        type LPWSTR,
     2 cchTextMax     fixed bin(31),
     2 iImage         fixed bin(31),
     2 iSelectedImage fixed bin(31),
     2 cChildren      fixed bin(31),
     2 lParam         type LPARAM,
     2 iIntegral      fixed bin(31);
 define alias LPTVITEMEXW handle TVITEMEXW;

 %if UNICODE ^= '' %then %do;
 define alias   TVITEMEX type TVITEMEXW;
 define alias LPTVITEMEX type LPTVITEMEXW;
 %end; %else %do;
 define alias   TVITEMEX type TVITEMEXA;
 define alias LPTVITEMEX type LPTVITEMEXA;
 %end; /* UNICODE */

 %end;


 %if UNICODE ^= '' %then %do;
 define alias   TVITEM  type   TVITEMW;
 define alias LPTVITEM  type LPTVITEMW;
 define alias   TV_ITEM type   TV_ITEMW;
 define alias LPTV_ITEM type LPTV_ITEMW;
 %end; %else %do;
 define alias   TVITEM  type   TVITEMA;
 define alias LPTVITEM  type LPTVITEMA;
 define alias   TV_ITEM type   TV_ITEMA;
 define alias LPTV_ITEM type LPTV_ITEMA;
 %end;


 dcl TVI_ROOT  type HTREEITEM  value(ptrvalue ('FFFF0000'xn));
 dcl TVI_FIRST type HTREEITEM  value(ptrvalue ('FFFF0001'xn));
 dcl TVI_LAST  type HTREEITEM  value(ptrvalue ('FFFF0002'xn));
 dcl TVI_SORT  type HTREEITEM  value(ptrvalue ('FFFF0003'xn));


 define structure
   1 TVINSERTSTRUCTA unaligned,
     2 hParent      type HTREEITEM,
     2 hInsertAfter type HTREEITEM,
 %if #WIN32_IE >= 1024 %then %do;
     2 * union,
       3 itemex     type TVITEMEXA,
       3 item       type TV_ITEMA;
 %end; %else %do;
     2 item         type TV_ITEMA;
 %end;
 define alias LPTVINSERTSTRUCTA  handle TVINSERTSTRUCTA;
 define alias   TV_INSERTSTRUCTA type   TVINSERTSTRUCTA;
 define alias LPTV_INSERTSTRUCTA type LPTVINSERTSTRUCTA;
 dcl TVINSERTSTRUCTA_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (TVINSERTSTRUCTA, item));

 define structure
   1 TVINSERTSTRUCTW unaligned,
     2 hParent      type HTREEITEM,
     2 hInsertAfter type HTREEITEM,
 %if #WIN32_IE >= 1024 %then %do;
     2 * union,
       3 itemex     type TVITEMEXW,
       3 item       type TV_ITEMW;
 %end; %else %do;
     2 item         type TV_ITEMW;
 %end;
 define alias LPTVINSERTSTRUCTW  handle TVINSERTSTRUCTW;
 define alias   TV_INSERTSTRUCTW type   TVINSERTSTRUCTW;
 define alias LPTV_INSERTSTRUCTW type LPTVINSERTSTRUCTW;
 dcl TVINSERTSTRUCTW_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (TVINSERTSTRUCTW, item));

 %if UNICODE ^= '' %then %do;
 define alias   TVINSERTSTRUCT type   TVINSERTSTRUCTW;
 define alias LPTVINSERTSTRUCT type LPTVINSERTSTRUCTW;
 define alias   TV_INSERTSTRUCT type   TV_INSERTSTRUCTW;
 define alias LPTV_INSERTSTRUCT type LPTV_INSERTSTRUCTW;
 dcl TVINSERTSTRUCT_V1_SIZE fixed bin(31)
     value (TVINSERTSTRUCTW_V1_SIZE);
 %end; %else %do;
 define alias   TVINSERTSTRUCT type   TVINSERTSTRUCTA;
 define alias LPTVINSERTSTRUCT type LPTVINSERTSTRUCTA;
 define alias   TV_INSERTSTRUCT type   TV_INSERTSTRUCTA;
 define alias LPTV_INSERTSTRUCT type LPTV_INSERTSTRUCTA;
 dcl TVINSERTSTRUCT_V1_SIZE fixed bin(31)
     value (TVINSERTSTRUCTA_V1_SIZE);
 %end;

 dcl TVM_INSERTITEMA fixed bin(31) value(TV_FIRST + 0);
 dcl TVM_INSERTITEMW fixed bin(31) value(TV_FIRST + 50);

 %if UNICODE ^= '' %then %do;
 dcl TVM_INSERTITEM  fixed bin(31) value(TVM_INSERTITEMW);
 %end; %else %do;
 dcl TVM_INSERTITEM  fixed bin(31) value(TVM_INSERTITEMA);
 %end;

 TreeView_InsertItem: proc (hwnd, lpis)
                      returns (type HTREEITEM byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lpis type TV_INSERTSTRUCT byaddr;
   dcl (addr, binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_INSERTITEM, 0,
                             binvalue (addr (lpis)))));
 end TreeView_InsertItem;


 dcl TVM_DELETEITEM fixed bin(31) value(TV_FIRST + 1);
 TreeView_DeleteItem: proc (hwnd, hitem)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_DELETEITEM, 0, binvalue (hitem)));
 end TreeView_DeleteItem;

 TreeView_DeleteAllItems: proc (hwnd)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_DELETEITEM, 0, binvalue(TVI_ROOT)));
 end TreeView_DeleteAllItems;


 dcl TVM_EXPAND fixed bin(31) value(TV_FIRST + 2);
 TreeView_Expand: proc (hwnd, hitem, code)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue,
       code  type UINT byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_EXPAND, (code),  binvalue (hitem)));
 end TreeView_Expand;


 dcl TVE_COLLAPSE      fixed bin(31) value('0001'xn);
 dcl TVE_EXPAND        fixed bin(31) value('0002'xn);
 dcl TVE_TOGGLE        fixed bin(31) value('0003'xn);

 %if #WIN32_IE >= 768 %then %do;
 dcl TVE_EXPANDPARTIAL fixed bin(31) value('4000'xn);
 %end;
 dcl TVE_COLLAPSERESET fixed bin(31) value('8000'xn);


 dcl TVM_GETITEMRECT fixed bin(31) value(TV_FIRST + 4);
 TreeView_GetItemRect: proc (hwnd, hitem, prc, code)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue,
       prc   type RECT byaddr,
       code  type BOOL byvalue;
   dcl (addr, binvalue) builtin;
   prc.left = binvalue (hitem); /* *(HTREEITEM *)prc = (hitem) */
   return (SNDMSG (hwnd, TVM_GETITEMRECT, (code),
                   binvalue (addr (prc))));
 end TreeView_GetItemRect;


 dcl TVM_GETCOUNT fixed bin(31) value(TV_FIRST + 5);
 TreeView_GetCount: proc (hwnd)
                    returns (type UINT byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETCOUNT, 0, 0));
 end TreeView_GetCount;


 dcl TVM_GETINDENT fixed bin(31) value(TV_FIRST + 6);
 TreeView_GetIndent: proc (hwnd)
                     returns (type UINT byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETINDENT, 0, 0));
 end TreeView_GetIndent;


 dcl TVM_SETINDENT fixed bin(31) value(TV_FIRST + 7);
 TreeView_SetIndent: proc (hwnd, indent)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       indent fixed bin(31);
   return (SNDMSG (hwnd, TVM_SETINDENT, (indent), 0));
 end TreeView_SetIndent;


 dcl TVM_GETIMAGELIST fixed bin(31) value(TV_FIRST + 8);
 TreeView_GetImageList: proc (hwnd, iImage)
                        returns (type HIMAGELIST byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       iImage fixed bin(31) byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_GETIMAGELIST, (iImage), 0)));
 end TreeView_GetImageList;


 dcl TVSIL_NORMAL fixed bin(31) value(0);
 dcl TVSIL_STATE  fixed bin(31) value(2);


 dcl TVM_SETIMAGELIST fixed bin(31) value(TV_FIRST + 9);
 TreeView_SetImageList: proc (hwnd, himl, iImage)
                        returns (type HIMAGELIST byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       himl   type HIMAGELIST byvalue,
       iImage fixed bin(31) byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_SETIMAGELIST, iImage,
                             binvalue (himl))));
 end TreeView_SetImageList;


 dcl TVM_GETNEXTITEM fixed bin(31) value(TV_FIRST + 10);
 TreeView_GetNextItem: proc (hwnd, hitem, code)
                       returns (type HTREEITEM byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue,
       code  type UINT byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_GETNEXTITEM, (code),
                             binvalue (hitem))));
 end TreeView_GetNextItem;


 dcl TVGN_ROOT            type UINT value('0000'xu);
 dcl TVGN_NEXT            type UINT value('0001'xu);
 dcl TVGN_PREVIOUS        type UINT value('0002'xu);
 dcl TVGN_PARENT          type UINT value('0003'xu);
 dcl TVGN_CHILD           type UINT value('0004'xu);
 dcl TVGN_FIRSTVISIBLE    type UINT value('0005'xu);
 dcl TVGN_NEXTVISIBLE     type UINT value('0006'xu);
 dcl TVGN_PREVIOUSVISIBLE type UINT value('0007'xu);
 dcl TVGN_DROPHILITE      type UINT value('0008'xu);
 dcl TVGN_CARET           type UINT value('0009'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TVGN_LASTVISIBLE     type UINT value('000A'xu);
 %end; /* _WIN32_IE >= 0x0400 */

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl TVSI_NOSINGLEEXPAND  type UINT value('8000'xu);
     /* Should not conflict with TVGN flags. */
 %end;

 TreeView_GetChild: proc (hwnd, hitem)
                    returns (type HTREEITEM byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   return (TreeView_GetNextItem (hwnd, hitem, TVGN_CHILD));
 end TreeView_GetChild;

 TreeView_GetNextSibling: proc (hwnd, hitem)
                          returns (type HTREEITEM byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
    return (TreeView_GetNextItem (hwnd, hitem, TVGN_NEXT));
 end TreeView_GetNextSibling;

 TreeView_GetPrevSibling: proc (hwnd, hitem)
                          returns (type HTREEITEM byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
    return (TreeView_GetNextItem (hwnd, hitem, TVGN_PREVIOUS));
 end TreeView_GetPrevSibling;

 TreeView_GetParent: proc (hwnd, hitem)
                     returns (type HTREEITEM byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   return (TreeView_GetNextItem (hwnd, hitem, TVGN_PARENT));
 end TreeView_GetParent;

 TreeView_GetFirstVisible: proc (hwnd)
                           returns (type HTREEITEM byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl sysnull builtin;
   return (TreeView_GetNextItem (hwnd, sysnull(), TVGN_FIRSTVISIBLE));
 end TreeView_GetFirstVisible;

 TreeView_GetNextVisible: proc (hwnd, hitem)
                          returns (type HTREEITEM byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
    return (TreeView_GetNextItem (hwnd, hitem, TVGN_NEXTVISIBLE));
 end TreeView_GetNextVisible;

 TreeView_GetPrevVisible: proc (hwnd, hitem)
                          returns (type HTREEITEM byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
    return (TreeView_GetNextItem (hwnd, hitem, TVGN_PREVIOUSVISIBLE));
 end TreeView_GetPrevVisible;

 TreeView_GetSelection: proc (hwnd)
                        returns (type HTREEITEM byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl sysnull builtin;
   return (TreeView_GetNextItem (hwnd, sysnull(), TVGN_CARET));
 end TreeView_GetSelection;

 TreeView_GetDropHilight: proc (hwnd)
                          returns (type HTREEITEM byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl sysnull builtin;
   return (TreeView_GetNextItem (hwnd, sysnull(), TVGN_DROPHILITE));
 end TreeView_GetDropHilight;

 TreeView_GetRoot: proc (hwnd)
                   returns (type HTREEITEM byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl sysnull builtin;
   return (TreeView_GetNextItem (hwnd, sysnull(), TVGN_ROOT));
 end TreeView_GetRoot;

 %if #WIN32_IE >= 1024 %then %do;
 TreeView_GetLastVisible: proc (hwnd)
                          returns (type HTREEITEM byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl sysnull builtin;
   return (TreeView_GetNextItem (hwnd, sysnull(),  TVGN_LASTVISIBLE));
 end TreeView_GetLastVisible;
 %end; /* _WIN32_IE >= 0x0400 */


 dcl TVM_SELECTITEM fixed bin(31) value(TV_FIRST + 11);
 TreeView_Select: proc (hwnd, hitem, code)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue,
       code  type UINT byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_SELECTITEM, (code), binvalue (hitem)));
 end TreeView_Select;

 TreeView_SelectItem: proc (hwnd, hitem)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   return (TreeView_Select (hwnd, hitem, TVGN_CARET));
 end TreeView_SelectItem;

 TreeView_SelectDropTarget: proc (hwnd, hitem)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   return (TreeView_Select (hwnd, hitem, TVGN_DROPHILITE));
 end TreeView_SelectDropTarget;

 TreeView_SelectSetFirstVisible: proc (hwnd, hitem)
                                 returns (type BOOL byvalue optional)
                                 options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   return (TreeView_Select (hwnd, hitem, TVGN_FIRSTVISIBLE));
 end TreeView_SelectSetFirstVisible;

 dcl TVM_GETITEMA fixed bin(31) value(TV_FIRST + 12);
 dcl TVM_GETITEMW fixed bin(31) value(TV_FIRST + 62);

 %if UNICODE ^= '' %then %do;
 dcl TVM_GETITEM  fixed bin(31) value(TVM_GETITEMW);
 %end; %else %do;
 dcl TVM_GETITEM  fixed bin(31) value(TVM_GETITEMA);
 %end;

 TreeView_GetItem: proc (hwnd, pitem)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       pitem type TV_ITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TVM_GETITEM, 0, binvalue (addr (pitem))));
 end TreeView_GetItem;


 dcl TVM_SETITEMA fixed bin(31) value(TV_FIRST + 13);
 dcl TVM_SETITEMW fixed bin(31) value(TV_FIRST + 63);


 %if UNICODE ^= '' %then %do;
 dcl TVM_SETITEM  fixed bin(31) value(TVM_SETITEMW);
 %end; %else %do;
 dcl TVM_SETITEM  fixed bin(31) value(TVM_SETITEMA);
 %end;

 TreeView_SetItem: proc (hwnd, pitem)
                   returns (type BOOL byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       pitem type TV_ITEM byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TVM_SETITEM, 0, binvalue (addr (pitem))));
 end TreeView_SetItem;


 dcl TVM_EDITLABELA fixed bin(31) value(TV_FIRST + 14);
 dcl TVM_EDITLABELW fixed bin(31) value(TV_FIRST + 65);

 %if UNICODE ^= '' %then %do;
 dcl TVM_EDITLABEL  fixed bin(31) value(TVM_EDITLABELW);
 %end; %else %do;
 dcl TVM_EDITLABEL  fixed bin(31) value(TVM_EDITLABELA);
 %end;

 TreeView_EditLabel: proc (hwnd, hitem)
                     returns (type HWND byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_EDITLABEL, 0,
                             binvalue (hitem))));
 end TreeView_EditLabel;

 dcl TVM_GETEDITCONTROL fixed bin(31) value(TV_FIRST + 15);
 TreeView_GetEditControl: proc (hwnd)
                          returns (type HWND byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_GETEDITCONTROL, 0, 0)));
 end TreeView_GetEditControl;

 dcl TVM_GETVISIBLECOUNT fixed bin(31) value(TV_FIRST + 16);
 TreeView_GetVisibleCount: proc (hwnd)
                           returns (type UINT byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETVISIBLECOUNT, 0, 0));
 end TreeView_GetVisibleCount;

 /* TreeView_HitTest follows declaration of TV_HITTESTINFO */

 define structure
   1 TVHITTESTINFO,
     2 pt    type POINT,
     2 flags type UINT,
     2 hItem type HTREEITEM;
 define alias LPTVHITTESTINFO  handle TVHITTESTINFO;
 define alias   TV_HITTESTINFO type   TVHITTESTINFO;
 define alias LPTV_HITTESTINFO type LPTVHITTESTINFO;

 dcl TVHT_NOWHERE         type UINT value('0001'xu);
 dcl TVHT_ONITEMICON      type UINT value('0002'xu);
 dcl TVHT_ONITEMLABEL     type UINT value('0004'xu);
 dcl TVHT_ONITEMINDENT    type UINT value('0008'xu);
 dcl TVHT_ONITEMBUTTON    type UINT value('0010'xu);
 dcl TVHT_ONITEMRIGHT     type UINT value('0020'xu);
 dcl TVHT_ONITEMSTATEICON type UINT value('0040'xu);
 dcl TVHT_ONITEM          type UINT value(ior (TVHT_ONITEMICON,
                                               TVHT_ONITEMLABEL,
                                               TVHT_ONITEMSTATEICON));
 dcl TVHT_ABOVE           type UINT value('0100'xu);
 dcl TVHT_BELOW           type UINT value('0200'xu);
 dcl TVHT_TORIGHT         type UINT value('0400'xu);
 dcl TVHT_TOLEFT          type UINT value('0800'xu);


 dcl TVM_HITTEST fixed bin(31) value(TV_FIRST + 17);
 TreeView_HitTest: proc (hwnd, lpht)
                   returns (type HTREEITEM byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       lpht type TV_HITTESTINFO byaddr;
   dcl (addr, binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_HITTEST, 0,
                             binvalue (addr (lpht)))));
 end TreeView_HitTest;

 dcl TVM_CREATEDRAGIMAGE fixed bin(31) value(TV_FIRST + 18);
 TreeView_CreateDragImage: proc (hwnd, hitem)
                           returns (type HIMAGELIST byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       hitem type HTREEITEM byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_CREATEDRAGIMAGE, 0,
                             binvalue (hitem))));
 end TreeView_CreateDragImage;

 dcl TVM_SORTCHILDREN fixed bin(31) value(TV_FIRST + 19);
 TreeView_SortChildren: proc (hwnd, hitem, recurse)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       hitem   type HTREEITEM byvalue,
       recurse type BOOL byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_SORTCHILDREN, (recurse),
                   binvalue (hitem)));
 end TreeView_SortChildren;


 dcl TVM_ENSUREVISIBLE fixed bin(31) value(TV_FIRST + 20);
 TreeView_EnsureVisible: proc (hwnd, hitem)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       hitem   type HTREEITEM byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_ENSUREVISIBLE, 0, binvalue (hitem)));
 end TreeView_EnsureVisible;


 define alias PFNTVCOMPARE
              entry (type LPARAM,
                     type LPARAM,
                     type LPARAM)
              returns (fixed bin(31) byvalue optional)
              limited CALLBACK;

 define structure
   1 TVSORTCB,
     2 hParent     type HTREEITEM,
     2 lpfnCompare type PFNTVCOMPARE,
     2 lParam      type LPARAM;
 define alias LPTVSORTCB  handle TVSORTCB;
 define alias   TV_SORTCB type   TVSORTCB;
 define alias LPTV_SORTCB type LPTVSORTCB;

 dcl TVM_SORTCHILDRENCB fixed bin(31) value(TV_FIRST + 21);
 TreeView_SortChildrenCB: proc (hwnd, psort, recurse)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       psort   type TV_SORTCB byaddr,
       recurse type BOOL byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TVM_SORTCHILDRENCB, (recurse),
                   binvalue (addr (psort))));
 end TreeView_SortChildrenCB;


 dcl TVM_ENDEDITLABELNOW fixed bin(31) value(TV_FIRST + 22);
 TreeView_EndEditLabelNow: proc (hwnd, fCancel)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       fCancel type BOOL byvalue;
   return (SNDMSG (hwnd, TVM_ENDEDITLABELNOW, (fCancel), 0));
 end TreeView_EndEditLabelNow;


 dcl TVM_GETISEARCHSTRINGA fixed bin(31) value(TV_FIRST + 23);
 dcl TVM_GETISEARCHSTRINGW fixed bin(31) value(TV_FIRST + 64);

 %if UNICODE ^= '' %then %do;
 dcl TVM_GETISEARCHSTRING  fixed bin(31) value(TVM_GETISEARCHSTRINGW);
 %end; %else %do;
 dcl TVM_GETISEARCHSTRING  fixed bin(31) value(TVM_GETISEARCHSTRINGA);
 %end;


 %if #WIN32_IE >= 768 %then %do;
 dcl TVM_SETTOOLTIPS fixed bin(31) value(TV_FIRST + 24);
 TreeView_SetToolTips: proc (hwnd, hwndTT)
                       returns (type HWND byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       hwndTT type HWND byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_SETTOOLTIPS, binvalue(hwndTT),
                             0)));
 end TreeView_SetToolTips;

 dcl TVM_GETTOOLTIPS fixed bin(31) value(TV_FIRST + 25);
 TreeView_GetToolTips: proc (hwnd)
                       returns (type HWND byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, TVM_GETTOOLTIPS, 0, 0)));
 end TreeView_GetToolTips;
 %end;

 TreeView_GetISearchString: proc (hwndTV, lpsz)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwndTV type HWND byvalue,
       lpsz   TCHAR(*) varz byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndTV, TVM_GETISEARCHSTRING, 0,
                   binvalue (addr (lpsz))));
 end TreeView_GetISearchString;


 %if #WIN32_IE >= 1024 %then %do;
 dcl TVM_SETINSERTMARK fixed bin(31) value(TV_FIRST + 26);
 TreeView_SetInsertMark: proc (hwnd, hItem, fAfter)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       hItem  type HTREEITEM byvalue,
       fAfter type BOOL byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hwnd, TVM_SETINSERTMARK, (fAfter),
                   binvalue (hItem)));
 end TreeView_SetInsertMark;

 dcl TVM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 TreeView_SetUnicodeFormat: proc (hwnd, fUnicode)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       fUnicode type BOOL byvalue;
   return (SNDMSG (hwnd, TVM_SETUNICODEFORMAT, (fUnicode), 0));
 end TreeView_SetUnicodeFormat;

 dcl TVM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 TreeView_GetUnicodeFormat: proc (hwnd)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETUNICODEFORMAT, 0, 0));
 end TreeView_GetUnicodeFormat;
 %end;


 %if #WIN32_IE >= 1024 %then %do;
 dcl TVM_SETITEMHEIGHT fixed bin(31) value(TV_FIRST + 27);
 TreeView_SetItemHeight: proc (hwnd, iHeight)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       iHeight fixed bin(31) byvalue;
   return (SNDMSG (hwnd, TVM_SETITEMHEIGHT, (iHeight), 0));
 end TreeView_SetItemHeight;

 dcl TVM_GETITEMHEIGHT fixed bin(31) value(TV_FIRST + 28);
 TreeView_GetItemHeight: proc (hwnd)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETITEMHEIGHT, 0, 0));
 end TreeView_GetItemHeight;

 dcl TVM_SETBKCOLOR fixed bin(31) value(TV_FIRST + 29);
 TreeView_SetBkColor: proc (hwnd, clr)
                      returns (type COLORREF byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       clr  type COLORREF byvalue;
   return (SNDMSG (hwnd, TVM_SETBKCOLOR, 0, (clr)));
 end TreeView_SetBkColor;

 dcl TVM_SETTEXTCOLOR fixed bin(31) value(TV_FIRST + 30);
 TreeView_SetTextColor: proc (hwnd, clr)
                        returns (type COLORREF byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       clr  type COLORREF byvalue;
   return (SNDMSG (hwnd, TVM_SETTEXTCOLOR, 0, (clr)));
 end TreeView_SetTextColor;

 dcl TVM_GETBKCOLOR fixed bin(31) value(TV_FIRST + 31);
 TreeView_GetBkColor: proc (hwnd)
                      returns (type COLORREF byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETBKCOLOR, 0, 0));
 end TreeView_GetBkColor;

 dcl TVM_GETTEXTCOLOR fixed bin(31) value(TV_FIRST + 32);
 TreeView_GetTextColor: proc (hwnd)
                        returns (type COLORREF byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETTEXTCOLOR, 0, 0));
 end TreeView_GetTextColor;

 dcl TVM_SETSCROLLTIME fixed bin(31) value(TV_FIRST + 33);
 TreeView_SetScrollTime: proc (hwnd, uTime)
                         returns (type UINT byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       uTime type UINT byvalue;
   return (SNDMSG (hwnd, TVM_SETSCROLLTIME, (uTime), 0));
 end TreeView_SetScrollTime;

 dcl TVM_GETSCROLLTIME fixed bin(31) value(TV_FIRST + 34);
 TreeView_GetScrollTime: proc (hwnd)
                         returns (type UINT byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETSCROLLTIME, 0, 0));
 end TreeView_GetScrollTime;


 %if #WIN32_IE >= 1024 %then %do;
 dcl TVM_SETINSERTMARKCOLOR fixed bin(31) value(TV_FIRST + 37);
 TreeView_SetInsertMarkColor: proc (hwnd, clr)
                              returns (type COLORREF byvalue optional)
                              options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       clr  type COLORREF byvalue;
   return (SNDMSG (hwnd, TVM_SETINSERTMARKCOLOR, 0, (clr)));
 end TreeView_SetInsertMarkColor;

 dcl TVM_GETINSERTMARKCOLOR fixed bin(31) value(TV_FIRST + 38);
 TreeView_GetInsertMarkColor: proc (hwnd)
                              returns (type COLORREF byvalue optional)
                              options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TVM_GETINSERTMARKCOLOR, 0, 0));
 end TreeView_GetInsertMarkColor;
 %end; /* (_WIN32_IE >= 0x0400) */

 %if #WIN32_IE >= 1280 %then %do;
 /* tvm_?etitemstate only uses mask, state and stateMask. */
 /* so unicode or ansi is irrelevant.                     */
 TreeView_SetItemState: proc (hwndTV, hti, data, mask)
                        returns (type UINT byvalue optional)
                        options (inline reorder) internal;
   dcl hwndTV type HWND byvalue,
       hti    type HTREEITEM byvalue,
       data   type UINT byvalue,
       mask   type UINT byvalue;
   dcl (addr, binvalue) builtin;
   dcl _ms_TVi type TVITEM;
   _ms_TVi.mask = TVIF_STATE;
   _ms_TVi.hItem = hti;
   _ms_TVi.stateMask = mask;
   _ms_TVi.state = data;
   return (SNDMSG (hwndTV, TVM_SETITEM, 0, binvalue (addr (_ms_TVi))));
 end TreeView_SetItemState;

 TreeView_SetCheckState: proc (hwndTV, hti, fCheck)
                         returns (type UINT byvalue optional)
                         options (inline reorder) internal;
   dcl hwndTV type HWND byvalue,
       hti    type HTREEITEM byvalue,
       fCheck type BOOL byvalue;
   dcl ix     fixed bin (31);

   if INDEXTOSTATEIMAGEMASK (fCheck) = 0 then
     ix = 1;
   else
     ix = 2;
   return (TreeView_SetItemState (hwndTV, hti, ix,
                                          TVIS_STATEIMAGEMASK));

 end TreeView_SetCheckState;

 dcl TVM_GETITEMSTATE       fixed bin(31) value(TV_FIRST + 39);

 TreeView_GetItemState: proc (hwndTV, hti, mask)
                        returns (type UINT byvalue optional)
                        options (inline reorder) internal;
   dcl hwndTV type HWND byvalue,
       hti    type HTREEITEM byvalue,
       mask   type UINT byvalue;
   dcl binvalue builtin;

   return (SNDMSG (hwndTV, TVM_GETITEMSTATE, binvalue (hti), (mask)));
 end TreeView_GetItemState;

 TreeView_GetCheckState: proc (hwndTV, hti)
                         returns (type UINT byvalue optional)
                         options (inline reorder) internal;
   dcl hwndTV type HWND byvalue,
       hti    type HTREEITEM byvalue;
   dcl (binvalue, lower2) builtin;
   return (lower2 (SNDMSG (hwndTV, TVM_GETITEMSTATE, binvalue (hti),
                                   TVIS_STATEIMAGEMASK), 12) - 1);
 end TreeView_GetCheckState;

 dcl TVM_SETLINECOLOR     fixed bin(31) value(TV_FIRST + 40);
 TreeView_SetLineColor: proc (hwnd, clr)
                        returns (type COLORREF byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       clr  type COLORREF byvalue;
   return (cast (:COLORREF, SNDMSG (hwnd, TVM_SETLINECOLOR,
                                    0, cast (: LPARAM, clr :)) :));
 end TreeView_SetLineColor;

 dcl TVM_GETLINECOLOR     fixed bin(31) value(TV_FIRST + 41);
 TreeView_GetLineColor: proc (hwnd)
                        returns (type COLORREF byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (cast (:COLORREF, SNDMSG (hwnd, TVM_GETLINECOLOR, 0, 0) :));
 end TreeView_GetLineColor;

 %end;

 %if #WIN32_WINNT >= 1281 %then %do;

 dcl TVM_MAPACCIDTOHTREEITEM  fixed bin(31) value(TV_FIRST + 42);
 TreeView_MapAccIDToHTREEITEM: proc (hwnd, id)
                               returns (type HTREEITEM byvalue optional)
                               options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       id   type UINT byvalue;
   return (cast (: HTREEITEM, SNDMSG (hwnd, TVM_MAPACCIDTOHTREEITEM,
                                            id, 0) :) );
 end TreeView_MapAccIDToHTREEITEM;

 dcl TVM_MAPHTREEITEMTOACCID  fixed bin(31) value(TV_FIRST + 43);
 TreeView_MapHTREEITEMToAccID: proc (hwnd, htreeitem)
                               returns (type UINT byvalue optional)
                               options (inline reorder) internal;
   dcl hwnd      type HWND byvalue,
       htreeitem type HTREEITEM byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TVM_MAPHTREEITEMTOACCID,
                         cast (: WPARAM, htreeitem :), 0));
 end TreeView_MapHTREEITEMToAccID;

 %end;

 %end;

 define structure
   1 NMTREEVIEWA unaligned,
     2 hdr     type NMHDR,
     2 action  type UINT,
     2 itemOld type TVITEMA,
     2 itemNew type TVITEMA,
     2 ptDrag  type POINT;
 define alias LPNMTREEVIEWA  handle NMTREEVIEWA;
 define alias   NM_TREEVIEWA type   NMTREEVIEWA;
 define alias LPNM_TREEVIEWA type LPNMTREEVIEWA;

 define structure
   1 NMTREEVIEWW unaligned,
     2 hdr     type NMHDR,
     2 action  type UINT,
     2 itemOld type TVITEMW,
     2 itemNew type TVITEMW,
     2 ptDrag  type POINT;
 define alias LPNMTREEVIEWW  handle NMTREEVIEWW;
 define alias   NM_TREEVIEWW type   NMTREEVIEWW;
 define alias LPNM_TREEVIEWW type LPNMTREEVIEWW;

 %if UNICODE ^= '' %then %do;
 define alias   NMTREEVIEW  type   NMTREEVIEWW;
 define alias LPNMTREEVIEW  type LPNMTREEVIEWW;
 define alias   NM_TREEVIEW type   NM_TREEVIEWW;
 define alias LPNM_TREEVIEW type LPNM_TREEVIEWW;
 %end; %else %do;
 define alias   NMTREEVIEW  type   NMTREEVIEWA;
 define alias LPNMTREEVIEW  type LPNMTREEVIEWA;
 define alias   NM_TREEVIEW type   NM_TREEVIEWA;
 define alias LPNM_TREEVIEW type LPNM_TREEVIEWA;
 %end;


 dcl TVN_SELCHANGINGA fixed bin(31) value(TVN_FIRST-1);
 dcl TVN_SELCHANGINGW fixed bin(31) value(TVN_FIRST-50);
 dcl TVN_SELCHANGEDA  fixed bin(31) value(TVN_FIRST-2);
 dcl TVN_SELCHANGEDW  fixed bin(31) value(TVN_FIRST-51);

 dcl TVC_UNKNOWN      type UINT value('0000'xu);
 dcl TVC_BYMOUSE      type UINT value('0001'xu);
 dcl TVC_BYKEYBOARD   type UINT value('0002'xu);

 dcl TVN_GETDISPINFOA fixed bin(31) value(TVN_FIRST-3);
 dcl TVN_GETDISPINFOW fixed bin(31) value(TVN_FIRST-52);
 dcl TVN_SETDISPINFOA fixed bin(31) value(TVN_FIRST-4);
 dcl TVN_SETDISPINFOW fixed bin(31) value(TVN_FIRST-53);

 dcl TVIF_DI_SETITEM  fixed bin(31) value('1000'xn);


 define structure
   1 TVDISPINFOA unaligned,
     2 hdr  type NMHDR,
     2 item type TVITEMA;
 define alias   NMTVDISPINFOA type   TVDISPINFOA;
 define alias LPNMTVDISPINFOA handle TVDISPINFOA;
 define alias   TV_DISPINFOA type   NMTVDISPINFOA;
 define alias LPTV_DISPINFOA type LPNMTVDISPINFOA;

 define structure
   1 TVDISPINFOW unaligned,
     2 hdr  type NMHDR,
     2 item type TVITEMW;
 define alias   NMTVDISPINFOW type   TVDISPINFOW;
 define alias LPNMTVDISPINFOW handle TVDISPINFOW;
 define alias   TV_DISPINFOW type   NMTVDISPINFOW;
 define alias LPTV_DISPINFOW type LPNMTVDISPINFOW;

 %if UNICODE ^= '' %then %do;
 define alias   NMTVDISPINFO type   NMTVDISPINFOW;
 define alias LPNMTVDISPINFO type LPNMTVDISPINFOW;
 define alias   TV_DISPINFO  type   TV_DISPINFOW;
 define alias LPTV_DISPINFO  type LPTV_DISPINFOW;
 %end; %else %do;
 define alias   NMTVDISPINFO type   NMTVDISPINFOA;
 define alias LPNMTVDISPINFO type LPNMTVDISPINFOA;
 define alias   TV_DISPINFO  type   TV_DISPINFOA;
 define alias LPTV_DISPINFO  type LPTV_DISPINFOA;
 %end;

 dcl TVN_ITEMEXPANDINGA  fixed bin(31) value(TVN_FIRST-5);
 dcl TVN_ITEMEXPANDINGW  fixed bin(31) value(TVN_FIRST-54);
 dcl TVN_ITEMEXPANDEDA   fixed bin(31) value(TVN_FIRST-6);
 dcl TVN_ITEMEXPANDEDW   fixed bin(31) value(TVN_FIRST-55);
 dcl TVN_BEGINDRAGA      fixed bin(31) value(TVN_FIRST-7);
 dcl TVN_BEGINDRAGW      fixed bin(31) value(TVN_FIRST-56);
 dcl TVN_BEGINRDRAGA     fixed bin(31) value(TVN_FIRST-8);
 dcl TVN_BEGINRDRAGW     fixed bin(31) value(TVN_FIRST-57);
 dcl TVN_DELETEITEMA     fixed bin(31) value(TVN_FIRST-9);
 dcl TVN_DELETEITEMW     fixed bin(31) value(TVN_FIRST-58);
 dcl TVN_BEGINLABELEDITA fixed bin(31) value(TVN_FIRST-10);
 dcl TVN_BEGINLABELEDITW fixed bin(31) value(TVN_FIRST-59);
 dcl TVN_ENDLABELEDITA   fixed bin(31) value(TVN_FIRST-11);
 dcl TVN_ENDLABELEDITW   fixed bin(31) value(TVN_FIRST-60);
 dcl TVN_KEYDOWN         fixed bin(31) value(TVN_FIRST-12);


 %if #WIN32_IE >= 1024 %then %do;
 dcl TVN_GETINFOTIPA     fixed bin(31) value(TVN_FIRST-13);
 dcl TVN_GETINFOTIPW     fixed bin(31) value(TVN_FIRST-14);
 dcl TVN_SINGLEEXPAND    fixed bin(31) value(TVN_FIRST-15);
 %end; /* 0x400 */


 define structure
   1 TVKEYDOWN unaligned,
     2 hdr   type NMHDR,
     2 wVKey type WORD,
     2 flags type UINT;
 define alias   NMTVKEYDOWN type   TVKEYDOWN;
 define alias LPNMTVKEYDOWN handle TVKEYDOWN;
 define alias   TV_KEYDOWN  type   NMTVKEYDOWN;
 define alias LPTV_KEYDOWN  type LPNMTVKEYDOWN;

 %if UNICODE ^= '' %then %do;
 dcl TVN_SELCHANGING    fixed bin(31) value(TVN_SELCHANGINGW);
 dcl TVN_SELCHANGED     fixed bin(31) value(TVN_SELCHANGEDW);
 dcl TVN_GETDISPINFO    fixed bin(31) value(TVN_GETDISPINFOW);
 dcl TVN_SETDISPINFO    fixed bin(31) value(TVN_SETDISPINFOW);
 dcl TVN_ITEMEXPANDING  fixed bin(31) value(TVN_ITEMEXPANDINGW);
 dcl TVN_ITEMEXPANDED   fixed bin(31) value(TVN_ITEMEXPANDEDW);
 dcl TVN_BEGINDRAG      fixed bin(31) value(TVN_BEGINDRAGW);
 dcl TVN_BEGINRDRAG     fixed bin(31) value(TVN_BEGINRDRAGW);
 dcl TVN_DELETEITEM     fixed bin(31) value(TVN_DELETEITEMW);
 dcl TVN_BEGINLABELEDIT fixed bin(31) value(TVN_BEGINLABELEDITW);
 dcl TVN_ENDLABELEDIT   fixed bin(31) value(TVN_ENDLABELEDITW);
 %end; %else %do;
 dcl TVN_SELCHANGING    fixed bin(31) value(TVN_SELCHANGINGA);
 dcl TVN_SELCHANGED     fixed bin(31) value(TVN_SELCHANGEDA);
 dcl TVN_GETDISPINFO    fixed bin(31) value(TVN_GETDISPINFOA);
 dcl TVN_SETDISPINFO    fixed bin(31) value(TVN_SETDISPINFOA);
 dcl TVN_ITEMEXPANDING  fixed bin(31) value(TVN_ITEMEXPANDINGA);
 dcl TVN_ITEMEXPANDED   fixed bin(31) value(TVN_ITEMEXPANDEDA);
 dcl TVN_BEGINDRAG      fixed bin(31) value(TVN_BEGINDRAGA);
 dcl TVN_BEGINRDRAG     fixed bin(31) value(TVN_BEGINRDRAGA);
 dcl TVN_DELETEITEM     fixed bin(31) value(TVN_DELETEITEMA);
 dcl TVN_BEGINLABELEDIT fixed bin(31) value(TVN_BEGINLABELEDITA);
 dcl TVN_ENDLABELEDIT   fixed bin(31) value(TVN_ENDLABELEDITA);
 %end;


 %if #WIN32_IE >= 768 %then %do;

 define structure
   1 NMTVCUSTOMDRAW unaligned,
     2 nmcd      type NMCUSTOMDRAW,
     2 clrText   type COLORREF,
     2 clrTextBk type COLORREF
 %if #WIN32_IE >= 1024 %then %do;
   , 2 iLevel fixed bin(31)
 %end;
   ;
 define alias LPNMTVCUSTOMDRAW handle NMTVCUSTOMDRAW;
 dcl NMTVCUSTOMDRAW_V3_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT(NMTVCUSTOMDRAW, clrTextBk));
 %end;


 %if #WIN32_IE >= 1024 %then %do;

 /* for tooltips */

 define structure
   1 NMTVGETINFOTIPA unaligned,
     2 hdr        type NMHDR,
     2 pszText    type LPSTR,
     2 cchTextMax fixed bin(31),
     2 hItem      type HTREEITEM,
     2 lParam     type LPARAM;
 define alias LPNMTVGETINFOTIPA handle NMTVGETINFOTIPA;
 define alias   TVN_GETINFOTIPA type   NMTVGETINFOTIPA;

 define structure
   1 NMTVGETINFOTIPW unaligned,
     2 hdr        type NMHDR,
     2 pszText    type LPWSTR,
     2 cchTextMax fixed bin(31),
     2 hItem      type HTREEITEM,
     2 lParam     type LPARAM;
 define alias LPNMTVGETINFOTIPW handle NMTVGETINFOTIPW;
 define alias   TVN_GETINFOTIPW type   NMTVGETINFOTIPW;



 %if UNICODE ^= '' %then %do;
 define alias   TVN_GETINFOTIP type   TVN_GETINFOTIPW;
 define alias   NMTVGETINFOTIP type   NMTVGETINFOTIPW;
 define alias LPNMTVGETINFOTIP type LPNMTVGETINFOTIPW;
 %end; %else %do;
 define alias   TVN_GETINFOTIP type   TVN_GETINFOTIPA;
 define alias   NMTVGETINFOTIP type   NMTVGETINFOTIPA;
 define alias LPNMTVGETINFOTIP type LPNMTVGETINFOTIPA;
 %end;

 /* treeview's customdraw return meaning don't draw images. */
 /* valid on CDRF_NOTIFYITEMPREPAINT                        */
 dcl TVCDRF_NOIMAGES fixed bin(31) value('00010000'xn);


 %end; /* _WIN32_IE >= 0x0400 */

 %end; /* NOTREEVIEW */


 %if #WIN32_IE >= 768 %then %do;

 %dcl NOUSEREXCONTROLS char ext;
 %if NOUSEREXCONTROLS = '' %then %do;

 /* *****************  ComboBoxEx ********************** */


 dcl WC_COMBOBOXEXW WCHAR value('ComboBoxEx32');
 dcl WC_COMBOBOXEXA char  value('ComboBoxEx32');

 %dcl WC_COMBOBOXEX char ext;
 %if UNICODE ^= '' %then %do;
 %WC_COMBOBOXEX='WC_COMBOBOXEXW';
 %end; %else %do;
 %WC_COMBOBOXEX='WC_COMBOBOXEXA';
 %end;


 dcl CBEIF_TEXT          type UINT value('00000001'xu);
 dcl CBEIF_IMAGE         type UINT value('00000002'xu);
 dcl CBEIF_SELECTEDIMAGE type UINT value('00000004'xu);
 dcl CBEIF_OVERLAY       type UINT value('00000008'xu);
 dcl CBEIF_INDENT        type UINT value('00000010'xu);
 dcl CBEIF_LPARAM        type UINT value('00000020'xu);

 dcl CBEIF_DI_SETITEM    type UINT value('10000000'xu);

 define structure
   1 COMBOBOXEXITEMA,
     2 mask           type UINT,
     2 iItem          fixed bin(31),
     2 pszText        type LPSTR,
     2 cchTextMax     fixed bin(31),
     2 iImage         fixed bin(31),
     2 iSelectedImage fixed bin(31),
     2 iOverlay       fixed bin(31),
     2 iIndent        fixed bin(31),
     2 lParam         type LPARAM;
 define alias  PCOMBOBOXEXITEMA handle COMBOBOXEXITEMA;
 define alias PCCOMBOBOXEXITEMA handle COMBOBOXEXITEMA; /* fixed typo */


 define structure
   1 COMBOBOXEXITEMW,
     2 mask           type UINT,
     2 iItem          fixed bin(31),
     2 pszText        type LPWSTR,
     2 cchTextMax     fixed bin(31),
     2 iImage         fixed bin(31),
     2 iSelectedImage fixed bin(31),
     2 iOverlay       fixed bin(31),
     2 iIndent        fixed bin(31),
     2 lParam         type LPARAM;
 define alias  PCOMBOBOXEXITEMW handle COMBOBOXEXITEMW;
 define alias PCCOMBOBOXEXITEMW handle COMBOBOXEXITEMW; /* fixed typo */


 %if UNICODE ^= '' %then %do;
 define alias   COMBOBOXEXITEM type   COMBOBOXEXITEMW;
 define alias  PCOMBOBOXEXITEM type  PCOMBOBOXEXITEMW;
 define alias PCCOMBOBOXEXITEM type PCCOMBOBOXEXITEMW;
 %end; %else %do;
 define alias   COMBOBOXEXITEM type   COMBOBOXEXITEMA;
 define alias  PCOMBOBOXEXITEM type  PCOMBOBOXEXITEMA;
 define alias PCCOMBOBOXEXITEM type PCCOMBOBOXEXITEMA;
 %end;

 dcl CBEM_INSERTITEMA      fixed bin(31) value(WM_USER + 1);
 dcl CBEM_SETIMAGELIST     fixed bin(31) value(WM_USER + 2);
 dcl CBEM_GETIMAGELIST     fixed bin(31) value(WM_USER + 3);
 dcl CBEM_GETITEMA         fixed bin(31) value(WM_USER + 4);
 dcl CBEM_SETITEMA         fixed bin(31) value(WM_USER + 5);
 dcl CBEM_DELETEITEM       fixed bin(31) value(CB_DELETESTRING);
 dcl CBEM_GETCOMBOCONTROL  fixed bin(31) value(WM_USER + 6);
 dcl CBEM_GETEDITCONTROL   fixed bin(31) value(WM_USER + 7);

 %if #WIN32_IE >= 1024 %then %do;
 dcl CBEM_SETEXSTYLE       fixed bin(31) value(WM_USER + 8);
     /* use SETEXTENDEDSTYLE instead */
 dcl CBEM_SETEXTENDEDSTYLE fixed bin(31) value(WM_USER + 14);
     /* lparam == new style, wParam (optional) == mask */
 dcl CBEM_GETEXSTYLE       fixed bin(31) value(WM_USER + 9);
     /* use GETEXTENDEDSTYLE instead */
 dcl CBEM_GETEXTENDEDSTYLE fixed bin(31) value(WM_USER + 9);
 dcl CBEM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 dcl CBEM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 %end; %else %do;
 dcl CBEM_SETEXSTYLE       fixed bin(31) value(WM_USER + 8);
 dcl CBEM_GETEXSTYLE       fixed bin(31) value(WM_USER + 9);
 %end;
 dcl CBEM_HASEDITCHANGED   fixed bin(31) value(WM_USER + 10);
 dcl CBEM_INSERTITEMW      fixed bin(31) value(WM_USER + 11);
 dcl CBEM_SETITEMW         fixed bin(31) value(WM_USER + 12);
 dcl CBEM_GETITEMW         fixed bin(31) value(WM_USER + 13);


 %if UNICODE ^= '' %then %do;
 dcl CBEM_INSERTITEM       fixed bin(31) value(CBEM_INSERTITEMW);
 dcl CBEM_SETITEM          fixed bin(31) value(CBEM_SETITEMW);
 dcl CBEM_GETITEM          fixed bin(31) value(CBEM_GETITEMW);
 %end; %else %do;
 dcl CBEM_INSERTITEM       fixed bin(31) value(CBEM_INSERTITEMA);
 dcl CBEM_SETITEM          fixed bin(31) value(CBEM_SETITEMA);
 dcl CBEM_GETITEM          fixed bin(31) value(CBEM_GETITEMA);
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl CBEM_SETWINDOWTHEME   fixed bin(31) value(CCM_SETWINDOWTHEME);
 %end;

 dcl CBES_EX_NOEDITIMAGE       type DWORD value('00000001'xu);
 dcl CBES_EX_NOEDITIMAGEINDENT type DWORD value('00000002'xu);
 dcl CBES_EX_PATHWORDBREAKPROC type DWORD value('00000004'xu);

 %if #WIN32_IE >= 1024 %then %do;
 dcl CBES_EX_NOSIZELIMIT       type DWORD value('00000008'xu);
 dcl CBES_EX_CASESENSITIVE     type DWORD value('00000010'xu);

 define structure
   1 NMCOMBOBOXEXA unaligned,
     2 hdr    type NMHDR,
     2 ceItem type COMBOBOXEXITEMA;
 define alias PNMCOMBOBOXEXA handle NMCOMBOBOXEXA;

 define structure
   1 NMCOMBOBOXEXW unaligned,
     2 hdr    type NMHDR,
     2 ceItem type COMBOBOXEXITEMW;
 define alias PNMCOMBOBOXEXW handle NMCOMBOBOXEXW;

 dcl CBEN_GETDISPINFOA fixed bin(31) value(CBEN_FIRST - 0);
 dcl CBEN_GETDISPINFOW fixed bin(31) value(CBEN_FIRST - 7);

 %if UNICODE ^= '' %then %do;
 define alias  NMCOMBOBOXEX type  NMCOMBOBOXEXW;
 define alias PNMCOMBOBOXEX type PNMCOMBOBOXEXW;
 dcl CBEN_GETDISPINFO fixed bin(31) value(CBEN_GETDISPINFOW);
 %end; %else %do;
 define alias  NMCOMBOBOXEX type  NMCOMBOBOXEXA;
 define alias PNMCOMBOBOXEX type PNMCOMBOBOXEXA;
 dcl CBEN_GETDISPINFO fixed bin(31) value(CBEN_GETDISPINFOA);
 %end;

 %end; %else %do;
 define structure
   1 NMCOMBOBOXEX unaligned,
     2 hdr    type NMHDR,
     2 ceItem type COMBOBOXEXITEM;
 define alias PNMCOMBOBOXEX handle NMCOMBOBOXEX;
 dcl CBEN_GETDISPINFO fixed bin(31) value(CBEN_FIRST - 0);
 %end; /* _WIN32_IE >= 0x0400 */


 dcl CBEN_INSERTITEM fixed bin(31) value(CBEN_FIRST - 1);
 dcl CBEN_DELETEITEM fixed bin(31) value(CBEN_FIRST - 2);
 dcl CBEN_BEGINEDIT  fixed bin(31) value(CBEN_FIRST - 4);
 dcl CBEN_ENDEDITA   fixed bin(31) value(CBEN_FIRST - 5);
 dcl CBEN_ENDEDITW   fixed bin(31) value(CBEN_FIRST - 6);

 %if #WIN32_IE >= 1024 %then %do;
 dcl CBEN_DRAGBEGINA fixed bin(31) value(CBEN_FIRST - 8);
 dcl CBEN_DRAGBEGINW fixed bin(31) value(CBEN_FIRST - 9);

 %if UNICODE ^= '' %then %do;
 dcl CBEN_DRAGBEGIN  fixed bin(31) value(CBEN_DRAGBEGINW);
 %end; %else %do;
 dcl CBEN_DRAGBEGIN  fixed bin(31) value(CBEN_DRAGBEGINA);
 %end;

 %end; /*(_WIN32_IE >= 0x0400) */

 /* lParam specifies why the endedit is happening */

 %if UNICODE ^= '' %then %do;
 dcl CBEN_ENDEDIT    fixed bin(31) value(CBEN_ENDEDITW);
 %end; %else %do;
 dcl CBEN_ENDEDIT    fixed bin(31) value(CBEN_ENDEDITA);
 %end;

 dcl CBENF_KILLFOCUS fixed bin(31) value(1);
 dcl CBENF_RETURN    fixed bin(31) value(2);
 dcl CBENF_ESCAPE    fixed bin(31) value(3);
 dcl CBENF_DROPDOWN  fixed bin(31) value(4);

 dcl CBEMAXSTRLEN    fixed bin(31) value(260);

 %if #WIN32_IE >= 1024 %then %do;
 /* CBEN_DRAGBEGIN sends this information ... */

 define structure
   1 NMCBEDRAGBEGINW unaligned,
     2 hdr     type NMHDR,
     2 iItemid fixed bin(31),
     2 szText  WCHAR (CBEMAXSTRLEN-1) varz;
 define alias LPNMCBEDRAGBEGINW handle NMCBEDRAGBEGINW;
 define alias  PNMCBEDRAGBEGINW handle NMCBEDRAGBEGINW;


 define structure
   1 NMCBEDRAGBEGINA unaligned,
     2 hdr     type NMHDR,
     2 iItemid fixed bin(31),
     2 szText  char(CBEMAXSTRLEN-1) varz;
 define alias LPNMCBEDRAGBEGINA handle NMCBEDRAGBEGINA;
 define alias  PNMCBEDRAGBEGINA handle NMCBEDRAGBEGINA;

 %if UNICODE ^= '' %then %do;
 define alias   NMCBEDRAGBEGIN type   NMCBEDRAGBEGINW;
 define alias LPNMCBEDRAGBEGIN type LPNMCBEDRAGBEGINW;
 define alias  PNMCBEDRAGBEGIN type  PNMCBEDRAGBEGINW;
 %end; %else %do;
 define alias   NMCBEDRAGBEGIN type   NMCBEDRAGBEGINA;
 define alias LPNMCBEDRAGBEGIN type LPNMCBEDRAGBEGINA;
 define alias  PNMCBEDRAGBEGIN type  PNMCBEDRAGBEGINA;
 %end;
 %end; /* _WIN32_IE >= 0x0400 */

 /* CBEN_ENDEDIT sends this information...                         */
 /* fChanged if the user actually did anything                     */
 /* iNewSelection gives what would be the new selection unless the */
 /*   notify is failed. May be CB_ERR if there's no match          */

 define structure
   1 NMCBEENDEDITW unaligned,
     2 hdr           type NMHDR,
     2 fChanged      type BOOL,
     2 iNewSelection fixed bin(31),
     2 szText        WCHAR (CBEMAXSTRLEN-1) varz,
     2 iWhy          fixed bin(31);
 define alias LPNMCBEENDEDITW handle NMCBEENDEDITW;
 define alias  PNMCBEENDEDITW handle NMCBEENDEDITW;

 define structure
   1 NMCBEENDEDITA unaligned,
     2 hdr           type NMHDR,
     2 fChanged      type BOOL,
     2 iNewSelection fixed bin(31),
     2 szText        char(CBEMAXSTRLEN-1) varz,
     2 iWhy          fixed bin(31);
 define alias LPNMCBEENDEDITA handle NMCBEENDEDITA;
 define alias  PNMCBEENDEDITA handle NMCBEENDEDITA;

 %if UNICODE ^= '' %then %do;
 define alias   NMCBEENDEDIT type   NMCBEENDEDITW;
 define alias LPNMCBEENDEDIT type LPNMCBEENDEDITW;
 define alias  PNMCBEENDEDIT type  PNMCBEENDEDITW;
 %end; %else %do;
 define alias   NMCBEENDEDIT type   NMCBEENDEDITA;
 define alias LPNMCBEENDEDIT type LPNMCBEENDEDITA;
 define alias  PNMCBEENDEDIT type  PNMCBEENDEDITA;
 %end;

 %end;

 %end; /* _WIN32_IE >= 0x0300 */


 /* ====== TAB CONTROL ============================================== */

 %dcl NOTABCONTROL char ext;
 %if NOTABCONTROL = '' %then %do;


 %if #WIN32 ^= '' %then %do;

 dcl WC_TABCONTROLA char  value('SysTabControl32');
 dcl WC_TABCONTROLW WCHAR value('SysTabControl32');

 %dcl WC_TABCONTROL char ext;
 %if UNICODE ^= '' %then %do;
 %WC_TABCONTROL='WC_TABCONTROLW';
 %end; %else %do;
 %WC_TABCONTROL='WC_TABCONTROLA';
 %end;

 %end; %else %do;
 dcl WC_TABCONTROL char value('SysTabControl');
 %end;

 /* begin_r_commctrl */


 %if #WIN32_IE >= 768 %then %do;
 dcl TCS_SCROLLOPPOSITE    type DWORD value('0001'xu);
     /* assumes multiline tab */
 dcl TCS_BOTTOM            type DWORD value('0002'xu);
 dcl TCS_RIGHT             type DWORD value('0002'xu);
 dcl TCS_MULTISELECT       type DWORD value('0004'xu);
     /* allow multi-select in button mode */
 %end;
 %if #WIN32_IE >= 1024 %then %do;
 dcl TCS_FLATBUTTONS       type DWORD value('0008'xu);
 %end;
 dcl TCS_FORCEICONLEFT     type DWORD value('0010'xu);
 dcl TCS_FORCELABELLEFT    type DWORD value('0020'xu);
 %if #WIN32_IE >= 768 %then %do;
 dcl TCS_HOTTRACK          type DWORD value('0040'xu);
 dcl TCS_VERTICAL          type DWORD value('0080'xu);
 %end;
 dcl TCS_TABS              type DWORD value('0000'xu);
 dcl TCS_BUTTONS           type DWORD value('0100'xu);
 dcl TCS_SINGLELINE        type DWORD value('0000'xu);
 dcl TCS_MULTILINE         type DWORD value('0200'xu);
 dcl TCS_RIGHTJUSTIFY      type DWORD value('0000'xu);
 dcl TCS_FIXEDWIDTH        type DWORD value('0400'xu);
 dcl TCS_RAGGEDRIGHT       type DWORD value('0800'xu);
 dcl TCS_FOCUSONBUTTONDOWN type DWORD value('1000'xu);
 dcl TCS_OWNERDRAWFIXED    type DWORD value('2000'xu);
 dcl TCS_TOOLTIPS          type DWORD value('4000'xu);
 dcl TCS_FOCUSNEVER        type DWORD value('8000'xu);

 %if #WIN32_IE >= 1024 %then %do;
 /* EX styles for use with TCM_SETEXTENDEDSTYLE */
 dcl TCS_EX_FLATSEPARATORS type DWORD value('00000001'xu);
 dcl TCS_EX_REGISTERDROP   type DWORD value('00000002'xu);
 %end;

 /* end_r_commctrl */


 dcl TCM_GETIMAGELIST fixed bin(31) value(TCM_FIRST + 2);
 TabCtrl_GetImageList: proc (hwnd)
                       returns (type HIMAGELIST byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, TCM_GETIMAGELIST, 0, 0)));
 end TabCtrl_GetImageList;


 dcl TCM_SETIMAGELIST fixed bin(31) value(TCM_FIRST + 3);
 TabCtrl_SetImageList: proc (hwnd, himl)
                       returns (type HIMAGELIST byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       himl type HIMAGELIST byvalue;
   dcl (binvalue, ptrvalue) builtin;
   return (ptrvalue (SNDMSG (hwnd, TCM_SETIMAGELIST, 0,
                             binvalue(himl))));
 end TabCtrl_SetImageList;


 dcl TCM_GETITEMCOUNT fixed bin(31) value(TCM_FIRST + 4);
 TabCtrl_GetItemCount: proc (hwnd)
                       returns (fixed bin(31) byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_GETITEMCOUNT, 0, 0));
 end TabCtrl_GetItemCount;


 dcl TCIF_TEXT          type UINT value('0001'xu);
 dcl TCIF_IMAGE         type UINT value('0002'xu);
 dcl TCIF_RTLREADING    type UINT value('0004'xu);
 dcl TCIF_PARAM         type UINT value('0008'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl TCIF_STATE         type UINT value('0010'xu);

 dcl TCIS_BUTTONPRESSED type DWORD value('0001'xu);
 %end;

 %if #WIN32_IE >= 1024 %then %do;
 dcl TCIS_HIGHLIGHTED   type DWORD value('0002'xu);
 %end;


 define structure
   1 TCITEMHEADERA,
     2 mask        type UINT,
     2 lpReserved1 type UINT,
     2 lpReserved2 type UINT,
     2 pszText     type LPSTR,
     2 cchTextMax  fixed bin(31),
     2 iImage      fixed bin(31);
 define alias LPTCITEMHEADERA handle TCITEMHEADERA;
 define alias TC_ITEMHEADERA  type   TCITEMHEADERA;

 define structure
   1 TCITEMHEADERW,
     2 mask        type UINT,
     2 lpReserved1 type UINT,
     2 lpReserved2 type UINT,
     2 pszText     type LPWSTR,
     2 cchTextMax  fixed bin(31),
     2 iImage      fixed bin(31);
 define alias LPTCITEMHEADERW handle TCITEMHEADERW;
 define alias TC_ITEMHEADERW  type   TCITEMHEADERW;

 %if UNICODE ^= '' %then %do;
 define alias   TCITEMHEADER type   TCITEMHEADERW;
 define alias LPTCITEMHEADER type LPTCITEMHEADERW;
 %end; %else %do;
 define alias   TCITEMHEADER type   TCITEMHEADERA;
 define alias LPTCITEMHEADER type LPTCITEMHEADERA;
 %end;
 define alias TC_ITEMHEADER type TCITEMHEADER;

 define structure
   1 TCITEMA,
     2 mask        type UINT,
 %if #WIN32_IE >= 768 %then %do;
     2 dwState     type DWORD,
     2 dwStateMask type DWORD,
 %end; %else %do;
     2 lpReserved1 type UINT,
     2 lpReserved2 type UINT,
 %end;
     2 pszText     type LPSTR,
     2 cchTextMax  fixed bin(31),
     2 iImage      fixed bin(31),
     2 lParam      type LPARAM;
 define alias LPTCITEMA handle TCITEMA;
 define alias  TC_ITEMA type   TCITEMA;

 define structure
   1 TCITEMW,
     2 mask        type UINT,
 %if #WIN32_IE >= 768 %then %do;
     2 dwState     type DWORD,
     2 dwStateMask type DWORD,
 %end; %else %do;
     2 lpReserved1 type UINT,
     2 lpReserved2 type UINT,
 %end;
     2 pszText     type LPWSTR,
     2 cchTextMax  fixed bin(31),
     2 iImage      fixed bin(31),
     2 lParam      type LPARAM;
 define alias LPTCITEMW handle TCITEMW;
 define alias  TC_ITEMW type   TCITEMW;

 %if UNICODE ^= '' %then %do;
 define alias   TCITEM type   TCITEMW;
 define alias LPTCITEM type LPTCITEMW;
 %end; %else %do;
 define alias   TCITEM type   TCITEMA;
 define alias LPTCITEM type LPTCITEMA;
 %end;
 define alias TC_ITEM type TCITEM;


 dcl TCM_GETITEMA fixed bin(31) value(TCM_FIRST + 5);
 dcl TCM_GETITEMW fixed bin(31) value(TCM_FIRST + 60);

 %if UNICODE ^= '' %then %do;
 dcl TCM_GETITEM  fixed bin(31) value(TCM_GETITEMW);
 %end; %else %do;
 dcl TCM_GETITEM  fixed bin(31) value(TCM_GETITEMA);
 %end;

 TabCtrl_GetItem: proc (hwnd, iItem, pitem)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iItem fixed bin(31) byvalue,
       pitem type TC_ITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TCM_GETITEM, (iItem),
                   binvalue (addr (pitem))));
 end TabCtrl_GetItem;


 dcl TCM_SETITEMA fixed bin(31) value(TCM_FIRST + 6);
 dcl TCM_SETITEMW fixed bin(31) value(TCM_FIRST + 61);

 %if UNICODE ^= '' %then %do;
 dcl TCM_SETITEM  fixed bin(31) value(TCM_SETITEMW);
 %end; %else %do;
 dcl TCM_SETITEM  fixed bin(31) value(TCM_SETITEMA);
 %end;

 TabCtrl_SetItem: proc (hwnd, iItem, pitem)
                  returns (type BOOL byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iItem fixed bin(31) byvalue,
       pitem type TC_ITEM byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TCM_SETITEM, (iItem),
                   binvalue (addr (pitem))));
 end TabCtrl_SetItem;


 dcl TCM_INSERTITEMA fixed bin(31) value(TCM_FIRST + 7);
 dcl TCM_INSERTITEMW fixed bin(31) value(TCM_FIRST + 62);

 %if UNICODE ^= '' %then %do;
 dcl TCM_INSERTITEM  fixed bin(31) value(TCM_INSERTITEMW);
 %end; %else %do;
 dcl TCM_INSERTITEM  fixed bin(31) value(TCM_INSERTITEMA);
 %end;

 TabCtrl_InsertItem: proc (hwnd, iItem, pitem)
                     returns (fixed bin(31) byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iItem fixed bin(31) byvalue,
       pitem type TC_ITEM byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TCM_INSERTITEM, (iItem),
                   binvalue (addr (pitem))));
 end TabCtrl_InsertItem;


 dcl TCM_DELETEITEM fixed bin(31) value(TCM_FIRST + 8);
 TabCtrl_DeleteItem: proc (hwnd, i)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, TCM_DELETEITEM, (i), 0));
 end TabCtrl_DeleteItem;

 dcl TCM_DELETEALLITEMS fixed bin(31) value(TCM_FIRST + 9);
 TabCtrl_DeleteAllItems: proc (hwnd)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_DELETEALLITEMS, 0, 0));
 end TabCtrl_DeleteAllItems;


 dcl TCM_GETITEMRECT fixed bin(31) value(TCM_FIRST + 10);
 TabCtrl_GetItemRect: proc (hwnd, i, prc)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue,
       prc  type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TCM_GETITEMRECT, (i), binvalue (addr (prc))));
 end TabCtrl_GetItemRect;


 dcl TCM_GETCURSEL fixed bin(31) value(TCM_FIRST + 11);
 TabCtrl_GetCurSel: proc (hwnd)
                    returns (fixed bin(31) byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_GETCURSEL, 0, 0));
 end TabCtrl_GetCurSel;


 dcl TCM_SETCURSEL fixed bin(31) value(TCM_FIRST + 12);
 TabCtrl_SetCurSel: proc (hwnd, i)
                    returns (fixed bin(31) byvalue optional)
                    options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, TCM_SETCURSEL, (i), 0));
 end TabCtrl_SetCurSel;


 dcl TCHT_NOWHERE     fixed bin(31) value('0001'xn);
 dcl TCHT_ONITEMICON  fixed bin(31) value('0002'xn);
 dcl TCHT_ONITEMLABEL fixed bin(31) value('0004'xn);
 dcl TCHT_ONITEM      fixed bin(31)
     value (ior (TCHT_ONITEMICON, TCHT_ONITEMLABEL));


 define structure
   1 TCHITTESTINFO,
     2 pt    type POINT,
     2 flags type UINT;
 define alias LPTCHITTESTINFO  handle TCHITTESTINFO;
 define alias   TC_HITTESTINFO type   TCHITTESTINFO;
 define alias LPTC_HITTESTINFO type LPTCHITTESTINFO;

 dcl TCM_HITTEST fixed bin(31) value(TCM_FIRST + 13);
 TabCtrl_HitTest: proc (hwndTC, pinfo)
                  returns (fixed bin(31) byvalue optional)
                  options (inline reorder) internal;
   dcl hwndTC type HWND byvalue,
       pinfo  type TC_HITTESTINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwndTC, TCM_HITTEST, 0, binvalue (addr (pinfo))));
 end TabCtrl_HitTest;


 dcl TCM_SETITEMEXTRA fixed bin(31) value(TCM_FIRST + 14);
 TabCtrl_SetItemExtra: proc (hwndTC, cb)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwndTC type HWND byvalue,
       cb     fixed bin(31) byvalue;
   return (SNDMSG (hwndTC, TCM_SETITEMEXTRA, (cb), 0));
 end TabCtrl_SetItemExtra;


 dcl TCM_ADJUSTRECT fixed bin(31) value(TCM_FIRST + 40);
 TabCtrl_AdjustRect: proc (hwnd, bLarger, prc)
                     returns (fixed bin(31) byvalue optional)
                     options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       bLarger type BOOL byvalue,
       prc     type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, TCM_ADJUSTRECT, (bLarger),
                   binvalue (addr (prc))));
 end TabCtrl_AdjustRect;


 dcl TCM_SETITEMSIZE fixed bin(31) value(TCM_FIRST + 41);
 TabCtrl_SetItemSize: proc (hwnd, x, y)
                      returns (type DWORD byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       x    fixed bin(31) byvalue,
       y    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, TCM_SETITEMSIZE, 0, MAKELPARAM(x,y)));
 end TabCtrl_SetItemSize;


 dcl TCM_REMOVEIMAGE fixed bin(31) value(TCM_FIRST + 42);
 TabCtrl_RemoveImage: proc (hwnd, i)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   call SNDMSG (hwnd, TCM_REMOVEIMAGE, (i), 0);
 end TabCtrl_RemoveImage;


 dcl TCM_SETPADDING fixed bin(31) value(TCM_FIRST + 43);
 TabCtrl_SetPadding: proc (hwnd, cx, cy)
                     options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       cx   fixed bin(31) byvalue,
       cy   fixed bin(31) byvalue;
   call SNDMSG (hwnd, TCM_SETPADDING, 0, MAKELPARAM(cx, cy));
 end TabCtrl_SetPadding;


 dcl TCM_GETROWCOUNT fixed bin(31) value(TCM_FIRST + 44);
 TabCtrl_GetRowCount: proc (hwnd)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_GETROWCOUNT, 0, 0));
 end TabCtrl_GetRowCount;


 dcl TCM_GETTOOLTIPS fixed bin(31) value(TCM_FIRST + 45);
 TabCtrl_GetToolTips: proc (hwnd)
                      returns (type HWND byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hwnd, TCM_GETTOOLTIPS, 0, 0)));
 end TabCtrl_GetToolTips;

 dcl TCM_SETTOOLTIPS fixed bin(31) value(TCM_FIRST + 46);
 TabCtrl_SetToolTips: proc (hwnd, hwndTT)
                      options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       hwndTT type HWND byvalue;
   dcl binvalue builtin;
   call SNDMSG (hwnd, TCM_SETTOOLTIPS, binvalue (hwndTT), 0);
 end TabCtrl_SetToolTips;


 dcl TCM_GETCURFOCUS fixed bin(31) value(TCM_FIRST + 47);
 TabCtrl_GetCurFocus: proc (hwnd)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_GETCURFOCUS, 0, 0));
 end TabCtrl_GetCurFocus;

 dcl TCM_SETCURFOCUS fixed bin(31) value(TCM_FIRST + 48);
 TabCtrl_SetCurFocus: proc (hwnd, i)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       i    fixed bin(31) byvalue;
   call SNDMSG (hwnd,TCM_SETCURFOCUS, (i), 0);
 end TabCtrl_SetCurFocus;


 %if #WIN32_IE >= 768 %then %do;
 dcl TCM_SETMINTABWIDTH fixed bin(31) value(TCM_FIRST + 49);
 TabCtrl_SetMinTabWidth: proc (hwnd, x)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       x    fixed bin(31) byvalue;
   return (SNDMSG (hwnd, TCM_SETMINTABWIDTH, 0, (x)));
 end TabCtrl_SetMinTabWidth;


 dcl TCM_DESELECTALL fixed bin(31) value(TCM_FIRST + 50);
 TabCtrl_DeselectAll: proc (hwnd, fExcludeFocus)
                      options (inline reorder) internal;
   dcl hwnd          type HWND byvalue,
       fExcludeFocus type UINT byvalue;
   call SNDMSG (hwnd, TCM_DESELECTALL, (fExcludeFocus), 0);
 end TabCtrl_DeselectAll;
 %end;


 %if #WIN32_IE >= 1024 %then %do;

 dcl TCM_HIGHLIGHTITEM fixed bin(31) value(TCM_FIRST + 51);
 TabCtrl_HighlightItem: proc (hwnd, i, fHighlight)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd       type HWND byvalue,
       i          fixed bin(31) byvalue,
       fHighlight type WORD byvalue;
   return (SNDMSG (hwnd, TCM_HIGHLIGHTITEM, (i),
                   MAKELONG (fHighlight, 0)));
 end TabCtrl_HighlightItem;

 dcl TCM_SETEXTENDEDSTYLE fixed bin(31) value(TCM_FIRST + 52);
     /* optional wParam == mask */
 TabCtrl_SetExtendedStyle: proc (hwnd, dw)
                           returns (type DWORD byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       dw   type DWORD byvalue;
   return (SNDMSG (hwnd, TCM_SETEXTENDEDSTYLE, 0, dw));
 end TabCtrl_SetExtendedStyle;

 dcl TCM_GETEXTENDEDSTYLE fixed bin(31) value(TCM_FIRST + 53);
 TabCtrl_GetExtendedStyle: proc (hwnd)
                           returns (type DWORD byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_GETEXTENDEDSTYLE, 0, 0));
 end TabCtrl_GetExtendedStyle;

 dcl TCM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 TabCtrl_SetUnicodeFormat: proc (hwnd, fUnicode)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       fUnicode type BOOL byvalue;
   return (SNDMSG (hwnd, TCM_SETUNICODEFORMAT, (fUnicode), 0));
 end TabCtrl_SetUnicodeFormat;

 dcl TCM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 TabCtrl_GetUnicodeFormat: proc (hwnd)
                           returns (type BOOL byvalue optional)
                           options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, TCM_GETUNICODEFORMAT, 0, 0));
 end TabCtrl_GetUnicodeFormat;

 %end; /* _WIN32_IE >= 0x0400 */

 dcl TCN_KEYDOWN fixed bin(31) value(TCN_FIRST - 0);

 define structure
   1 TCKEYDOWN unaligned,
     2 hdr   type NMHDR,
     2 wVKey type WORD,
     2 flags type UINT;
 define alias NMTCKEYDOWN type TCKEYDOWN;
 define alias TC_KEYDOWN  type TCKEYDOWN;

 dcl TCN_SELCHANGE   fixed bin(31) value(TCN_FIRST - 1);
 dcl TCN_SELCHANGING fixed bin(31) value(TCN_FIRST - 2);

 %if #WIN32_IE >= 1024 %then %do;
 dcl TCN_GETOBJECT   fixed bin(31) value(TCN_FIRST - 3);
 %end; /* _WIN32_IE >= 0x0400 */
 %if #WIN32_IE >= 1280 %then %do;
 dcl TCN_FOCUSCHANGE fixed bin(31) value(TCN_FIRST - 4);
 %end; /* _WIN32_IE >= 0x0500 */

 %end; /* NOTABCONTROL */


 /* ====== ANIMATE CONTROL ========================================== */

 %dcl NOANIMATE char ext;
 %if NOANIMATE = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl ANIMATE_CLASSW WCHAR value('SysAnimate32');
 dcl ANIMATE_CLASSA char  value('SysAnimate32');

 %dcl ANIMATE_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %ANIMATE_CLASS='ANIMATE_CLASSW';
 %end; %else %do;
 %ANIMATE_CLASS='ANIMATE_CLASSA';
 %end;

 /* begin_r_commctrl */

 dcl ACS_CENTER      type DWORD value('0001'xu);
 dcl ACS_TRANSPARENT type DWORD value('0002'xu);
 dcl ACS_AUTOPLAY    type DWORD value('0004'xu);

 %if #WIN32_IE >= 768 %then %do;
 dcl ACS_TIMER       type DWORD value('0008'xu);
     /* don't use threads... use timers */
 %end;

 /* end_r_commctrl */

 dcl ACM_OPENA    fixed bin(31) value(WM_USER+100);
 dcl ACM_OPENW    fixed bin(31) value(WM_USER+103);


 %if UNICODE ^= '' %then %do;
 dcl ACM_OPEN     fixed bin(31) value(ACM_OPENW);
 %end; %else %do;
 dcl ACM_OPEN     fixed bin(31) value(ACM_OPENA);
 %end;

 dcl ACM_PLAY     fixed bin(31) value(WM_USER+101);
 dcl ACM_STOP     fixed bin(31) value(WM_USER+102);


 dcl ACN_START    fixed bin(31) value(1);
 dcl ACN_STOP     fixed bin(31) value(2);

 Animate_Create: proc (hwndP, id, dwStyle, hInstance)
                 returns (type HWND byvalue optional)
                 options (inline reorder) internal;
   dcl hwndP     type HWND byvalue,
       id        type UINT byvalue,
       dwStyle   type DWORD byvalue,
       hInstance type HINSTANCE byvalue;
   dcl (ptrvalue, sysnull) builtin;
   return (CreateWindow (ANIMATE_CLASS, *, dwStyle, 0, 0, 0, 0,
                         hwndP, ptrvalue(id), hInstance, sysnull()));
 end Animate_Create;

 Animate_Open: proc (hwnd, szName)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       szName TCHAR(*) varz byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, ACM_OPEN, 0, binvalue (addr (szName))));
 end Animate_Open;

 Animate_OpenEx: proc (hwnd, hInst, szName)
                 returns (type BOOL byvalue optional)
                 options (inline reorder) internal;
   dcl hwnd   type HWND byvalue,
       hInst  type HINSTANCE byvalue,
       szName TCHAR(*) varz byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, ACM_OPEN, binvalue (hInst),
                   binvalue (addr (szName))));
 end Animate_OpenEx;

 Animate_Play: proc (hwnd, from, to, rep)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       from type UINT byvalue,
       to   type UINT byvalue,
       rep  type UINT byvalue;
   return (SNDMSG (hwnd, ACM_PLAY, (rep), MAKELONG (from, to)));
 end Animate_Play;

 Animate_Stop: proc (hwnd)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, ACM_STOP, 0, 0));
 end Animate_Stop;

 Animate_Close: proc (hwnd)
                returns (type BOOL byvalue optional)
                options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (Animate_Open (hwnd, *));
 end Animate_Close;

 Animate_Seek: proc (hwnd, frame)
               returns (type BOOL byvalue optional)
               options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       frame type UINT byvalue;
   return (Animate_Play (hwnd, frame, frame, 1));
 end Animate_Seek;

 %end;

 %end; /* NOANIMATE */


 %if #WIN32_IE >= 768 %then %do;
 /* ====== MONTHCAL CONTROL ========================================= */

 %dcl NOMONTHCAL char ext;
 %if NOMONTHCAL = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl MONTHCAL_CLASSW char value('SysMonthCal32');
 dcl MONTHCAL_CLASSA char value('SysMonthCal32');

 %dcl MONTHCAL_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %MONTHCAL_CLASS='MONTHCAL_CLASSW';
 %end; %else %do;
 %MONTHCAL_CLASS='MONTHCAL_CLASSA';
 %end;

 /* bit-packed array of "bold" info for a month                       */
 /* if a bit is on, that day is drawn bold                            */
 /* PL/I note: to get a bold day bit mask, use: raise2(1, day-1)      */
 define alias MONTHDAYSTATE   type DWORD;
 define alias LPMONTHDAYSTATE pointer;


 dcl MCM_FIRST fixed bin(31) value('1000'xn);

 /* BOOL MonthCal_GetCurSel(HWND hmc, LPSYSTEMTIME pst)               */
 /*   returns FALSE if MCS_MULTISELECT                                */
 /*   returns TRUE and sets *pst to the currently selected date       */
 /*     otherwise                                                     */
 dcl MCM_GETCURSEL fixed bin(31) value(MCM_FIRST + 1);
 MonthCal_GetCurSel: proc (hmc, pst)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       pst type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_GETCURSEL, 0, binvalue (addr (pst))));
 end MonthCal_GetCurSel;

 /* BOOL MonthCal_SetCurSel(HWND hmc, LPSYSTEMTIME pst)               */
 /*   returns FALSE if MCS_MULTISELECT                                */
 /*   returns TURE and sets the currently selected date to *pst       */
 /*     otherwise                                                     */
 dcl MCM_SETCURSEL fixed bin(31) value(MCM_FIRST + 2);
 MonthCal_SetCurSel: proc (hmc, pst)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       pst type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_SETCURSEL, 0, binvalue (addr (pst))));
 end MonthCal_SetCurSel;

 /* DWORD MonthCal_GetMaxSelCount(HWND hmc)                           */
 /*   returns the maximum number of selectable days allowed           */
 dcl MCM_GETMAXSELCOUNT fixed bin(31) value(MCM_FIRST + 3);
 MonthCal_GetMaxSelCount: proc (hmc)
                          returns (type DWORD byvalue optional)
                          options (inline reorder) internal;
   dcl hmc type HWND byvalue;
   return (SNDMSG (hmc, MCM_GETMAXSELCOUNT, 0, 0));
 end MonthCal_GetMaxSelCount;

 /* BOOL MonthCal_SetMaxSelCount(HWND hmc, UINT n)                    */
 /*   sets the max number days that can be selected iff               */
 /*     MCS_MULTISELECT                                               */
 dcl MCM_SETMAXSELCOUNT fixed bin(31) value(MCM_FIRST + 4);
 MonthCal_SetMaxSelCount: proc (hmc, n)
                          returns (type BOOL byvalue optional)
                          options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       n   type UINT byvalue;
   return (SNDMSG (hmc, MCM_SETMAXSELCOUNT, (n), 0));
 end MonthCal_SetMaxSelCount;

 /* BOOL MonthCal_GetSelRange(HWND hmc, LPSYSTEMTIME rgst)            */
 /*   sets rgst[0] to the first day of the selection range            */
 /*   sets rgst[1] to the last day of the selection range             */
 /* PL/I note: uses rgst(1) and rgst(2)                               */
 dcl MCM_GETSELRANGE fixed bin(31) value(MCM_FIRST + 5);
 MonthCal_GetSelRange: proc (hmc, rgst)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hmc     type HWND byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_GETSELRANGE, 0, binvalue (addr (rgst))));
 end MonthCal_GetSelRange;

 /* BOOL MonthCal_SetSelRange(HWND hmc, LPSYSTEMTIME rgst)            */
 /*   selects the range of days from rgst[0] to rgst[1]               */
 /* PL/I note: uses rgst(1) and rgst(2)                               */
 dcl MCM_SETSELRANGE fixed bin(31) value(MCM_FIRST + 6);
 MonthCal_SetSelRange: proc (hmc, rgst)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hmc     type HWND byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_SETSELRANGE, 0, binvalue (addr (rgst))));
 end MonthCal_SetSelRange;

 /* DWORD MonthCal_GetMonthRange(HWND hmc, DWORD gmr,                 */
 /*                              LPSYSTEMTIME rgst)                   */
 /*   if rgst specified, sets rgst[0] to the starting date and        */
 /*      rgst[1] to the ending date of the the selectable             */
 /*      (non-grayed) days if GMR_VISIBLE or all the displayed        */
 /*      days (including grayed) if GMR_DAYSTATE.                     */
 /*   returns the number of months spanned by the above range.        */
 /* PL/I note: uses rgst(1) and rgst(2)                               */
 dcl MCM_GETMONTHRANGE fixed bin(31) value(MCM_FIRST + 7);
 MonthCal_GetMonthRange: proc (hmc, gmr, rgst)
                         returns (type DWORD byvalue optional)
                         options (inline reorder) internal;
   dcl hmc     type HWND byvalue,
       gmr     type DWORD byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_GETMONTHRANGE, (gmr),
                   binvalue (addr (rgst))));
 end MonthCal_GetMonthRange;

 /* BOOL MonthCal_SetDayState(HWND hmc, int cbds, DAYSTATE *rgds)     */
 /*   cbds is the count of DAYSTATE items in rgds and it must be      */
 /*      equal to the value returned from                             */
 /*      MonthCal_GetMonthRange(hmc, GMR_DAYSTATE, NULL)              */
 /*   This sets the DAYSTATE bits for each month (grayed and          */
 /*      non-grayed days) displayed in the calendar. The first        */
 /*      bit in a month's DAYSTATE corresponds to bolding day 1,      */
 /*      the second bit affects day 2, etc.                           */
 dcl MCM_SETDAYSTATE fixed bin(31) value(MCM_FIRST + 8);
 MonthCal_SetDayState: proc (hmc, cbds, rgds)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hmc  type HWND byvalue,
       cbds fixed bin(31) byvalue,
       rgds type MONTHDAYSTATE byaddr; /* no such thing as DAYSTATE */
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_SETDAYSTATE, (cbds),
                   binvalue (addr (rgds))));
 end MonthCal_SetDayState;

 /* BOOL MonthCal_GetMinReqRect(HWND hmc, LPRECT prc)                 */
 /*   sets *prc the minimal size needed to display one month          */
 /*   To display two months, undo the AdjustWindowRect calculation    */
 /*   already done to this rect, double the width, and redo the       */
 /*   AdjustWindowRect calculation -- the monthcal control will       */
 /*   display two calendars in this window (if you also double the    */
 /*   vertical size, you will get 4 calendars)                        */
 /*   NOTE: if you want to guarantee that the "Today" string is       */
 /*   not clipped, get the MCM_GETMAXTODAYWIDTH and use the max of    */
 /*   that width and this width                                       */
 dcl MCM_GETMINREQRECT fixed bin(31) value(MCM_FIRST + 9);
 MonthCal_GetMinReqRect: proc (hmc, prc)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       prc type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_GETMINREQRECT, 0, binvalue( addr (prc))));
 end MonthCal_GetMinReqRect;

 /* set colors to draw control with -- see MCSC_ bits below */
 dcl MCM_SETCOLOR fixed bin(31) value(MCM_FIRST + 10);
 MonthCal_SetColor: proc (hmc, iColor, clr)
                    returns (type COLORREF byvalue optional)
                    options (inline reorder) internal;
   dcl hmc    type HWND byvalue,
       iColor fixed bin(31) byvalue,
       clr    type COLORREF byvalue;
   return (SNDMSG (hmc, MCM_SETCOLOR, iColor, clr));
 end MonthCal_SetColor;

 dcl MCM_GETCOLOR fixed bin(31) value(MCM_FIRST + 11);
 MonthCal_GetColor: proc (hmc, iColor)
                    returns (type COLORREF byvalue optional)
                    options (inline reorder) internal;
   dcl hmc    type HWND byvalue,
       iColor fixed bin(31) byvalue;
   return (SNDMSG (hmc, MCM_SETCOLOR, iColor, 0));
 end MonthCal_GetColor;

 dcl MCSC_BACKGROUND   fixed bin(31) value(0);
     /* the background color (between months) */
 dcl MCSC_TEXT         fixed bin(31) value(1);
     /* the dates */
 dcl MCSC_TITLEBK      fixed bin(31) value(2);
     /* background of the title */
 dcl MCSC_TITLETEXT    fixed bin(31) value(3);
 dcl MCSC_MONTHBK      fixed bin(31) value(4);
     /* background within the month cal */
 dcl MCSC_TRAILINGTEXT fixed bin(31) value(5);
     /* the text color of header & trailing days */

 /* set what day is "today" send NULL to revert back to real date */
 dcl MCM_SETTODAY   fixed bin(31) value(MCM_FIRST + 12);
 MonthCal_SetToday: proc (hmc, pst)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       pst type SYSTEMTIME byaddr optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_SETTODAY, 0, binvalue (addr (pst))));
 end MonthCal_SetToday;

 /* get what day is "today" */
 /* returns BOOL for success/failure */
 dcl MCM_GETTODAY fixed bin(31) value(MCM_FIRST + 13);
 MonthCal_GetToday: proc (hmc, pst)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       pst type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_GETTODAY, 0, binvalue (addr (pst))));
 end MonthCal_GetToday;

 /* determine what pinfo->pt is over */
 dcl MCM_HITTEST fixed bin(31) value(MCM_FIRST + 14);

 define structure
   1 MCHITTESTINFO,
     2 cbSize type UINT,
     2 pt     type POINT,
     2 uHit   type UINT,/* out param */
     2 st     type SYSTEMTIME;
 define alias PMCHITTESTINFO handle MCHITTESTINFO;

 MonthCal_HitTest: proc (hmc, pinfo)
                   returns (type DWORD byvalue optional)
                   options (inline reorder) internal;
   dcl hmc   type HWND byvalue,
       pinfo type MCHITTESTINFO byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_HITTEST, 0, binvalue (addr (pinfo))));
 end MonthCal_HitTest;

 dcl MCHT_TITLE        type UINT value('00010000'xu);
 dcl MCHT_CALENDAR     type UINT value('00020000'xu);
 dcl MCHT_TODAYLINK    type UINT value('00030000'xu);

 dcl MCHT_NEXT         type UINT value('01000000'xu);
     /* these indicate that hitting */
 dcl MCHT_PREV         type UINT value('02000000'xu);
     /* here will go to the next/prev month */

 dcl MCHT_NOWHERE      type UINT value('00000000'xu);

 dcl MCHT_TITLEBK      type UINT value (MCHT_TITLE);
 dcl MCHT_TITLEMONTH   type UINT value (ior (MCHT_TITLE, '0001'xu));
 dcl MCHT_TITLEYEAR    type UINT value (ior (MCHT_TITLE, '0002'xu));
 dcl MCHT_TITLEBTNNEXT type UINT
                       value (ior (MCHT_TITLE, MCHT_NEXT, '0003'xu));
 dcl MCHT_TITLEBTNPREV type UINT
                       value (ior (MCHT_TITLE, MCHT_PREV, '0003'xu));


 dcl MCHT_CALENDARBK   type UINT value (MCHT_CALENDAR);
 dcl MCHT_CALENDARDATE type UINT
                       value (ior (MCHT_CALENDAR, '0001'xu));
 dcl MCHT_CALENDARDATENEXT type UINT
                       value (ior (MCHT_CALENDARDATE, MCHT_NEXT));
 dcl MCHT_CALENDARDATEPREV type UINT
                       value (ior (MCHT_CALENDARDATE, MCHT_PREV));
 dcl MCHT_CALENDARDAY      type UINT
                       value (ior (MCHT_CALENDAR, '0002'xu));
 dcl MCHT_CALENDARWEEKNUM  type UINT
                       value (ior (MCHT_CALENDAR, '0003'xu));


 /* set first day of week to iDay:                 */
 /* 0 for Monday, 1 for Tuesday, ..., 6 for Sunday */
 /* -1 for means use locale info                   */
 dcl MCM_SETFIRSTDAYOFWEEK fixed bin(31) value(MCM_FIRST + 15);
 MonthCal_SetFirstDayOfWeek: proc (hmc, iDay)
                             returns (type DWORD byvalue optional)
                             options (inline reorder) internal;
   dcl hmc  type HWND byvalue,
       iDay fixed bin(31) byvalue;
   return (SNDMSG (hmc, MCM_SETFIRSTDAYOFWEEK, 0, (iDay)));
 end MonthCal_SetFirstDayOfWeek;

 /* DWORD result...  low word has the day.  high word is bool if this */
 /* is app set or not (FALSE == using locale info)                    */
 dcl MCM_GETFIRSTDAYOFWEEK fixed bin(31) value(MCM_FIRST + 16);
 MonthCal_GetFirstDayOfWeek: proc (hmc)
                             returns (type DWORD byvalue optional)
                             options (inline reorder) internal;
   dcl hmc  type HWND byvalue;
   return (SNDMSG (hmc, MCM_GETFIRSTDAYOFWEEK, 0, 0));
 end MonthCal_GetFirstDayOfWeek;

 /* DWORD MonthCal_GetRange(HWND hmc, LPSYSTEMTIME rgst)              */
 /*   modifies rgst[0] to be the minimum ALLOWABLE systemtime         */
 /*      (or 0 if no minimum)                                         */
 /*   modifies rgst[1] to be the maximum ALLOWABLE systemtime         */
 /*      (or 0 if no maximum)                                         */
 /*   returns GDTR_MIN|GDTR_MAX if there is a minimum|maximum limit   */
 /* PL/I note: uses rgst(1) and rgst(2)                               */
 dcl MCM_GETRANGE fixed bin(31) value(MCM_FIRST + 17);
 MonthCal_GetRange: proc (hmc, rgst)
                    returns (type DWORD byvalue optional)
                    options (inline reorder) internal;
   dcl hmc     type HWND byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_GETRANGE, 0, binvalue (addr (rgst))));
 end MonthCal_GetRange;

 /* BOOL MonthCal_SetRange(HWND hmc, DWORD gdtr, LPSYSTEMTIME rgst)   */
 /*   if GDTR_MIN, sets the minimum ALLOWABLE systemtime to rgst[0],  */
 /*      otherwise removes minimum                                    */
 /*   if GDTR_MAX, sets the maximum ALLOWABLE systemtime to rgst[1],  */
 /*      otherwise removes maximum                                    */
 /*   returns TRUE on success, FALSE on error (such as invalid        */
 /*      parameters)                                                  */
 dcl MCM_SETRANGE fixed bin(31) value(MCM_FIRST + 18);
 MonthCal_SetRange: proc (hmc, gd, rgst)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hmc     type HWND byvalue,
       gd      type DWORD byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hmc, MCM_SETRANGE, (gd), binvalue (addr (rgst))));
 end MonthCal_SetRange;

 /* int MonthCal_GetMonthDelta(HWND hmc)                              */
 /*   returns the number of months one click on a next/prev button    */
 /*   moves by                                                        */
 dcl MCM_GETMONTHDELTA fixed bin(31) value(MCM_FIRST + 19);
 MonthCal_GetMonthDelta: proc (hmc)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hmc type HWND byvalue;
   return (SNDMSG (hmc, MCM_GETMONTHDELTA, 0, 0));
 end MonthCal_GetMonthDelta;

 /* int MonthCal_SetMonthDelta(HWND hmc, int n)                       */
 /*   sets the month delta to n. n==0 reverts to moving by a page of  */
 /*     months                                                        */
 /*   returns the previous value of n.                                */
 dcl MCM_SETMONTHDELTA fixed bin(31) value(MCM_FIRST + 20);
 MonthCal_SetMonthDelta: proc (hmc, n)
                         returns (fixed bin(31) byvalue optional)
                         options (inline reorder) internal;
   dcl hmc type HWND byvalue,
       n   fixed bin(31) byvalue;
   return (SNDMSG (hmc, MCM_SETMONTHDELTA, (n), 0));
 end MonthCal_SetMonthDelta;

 /* DWORD MonthCal_GetMaxTodayWidth(HWND hmc, LPSIZE psz)             */
 /*   sets *psz to the maximum width/height of the "Today" string     */
 /*   displayed at the bottom of the calendar (as long as MCS_NOTODAY */
 /*   is not specified)                                               */
 dcl MCM_GETMAXTODAYWIDTH fixed bin(31) value(MCM_FIRST + 21);
 MonthCal_GetMaxTodayWidth: proc (hmc)
                            returns (type DWORD byvalue optional)
                            options (inline reorder) internal;
   dcl hmc type HWND byvalue;
   return (SNDMSG (hmc, MCM_GETMAXTODAYWIDTH, 0, 0));
 end MonthCal_GetMaxTodayWidth;


 %if #WIN32_IE >= 1024 %then %do;
 dcl MCM_SETUNICODEFORMAT fixed bin(31) value(CCM_SETUNICODEFORMAT);
 MonthCal_SetUnicodeFormat: proc (hwnd, fUnicode)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       fUnicode type BOOL byvalue;
   return (SNDMSG (hwnd, MCM_SETUNICODEFORMAT, (fUnicode), 0));
 end MonthCal_SetUnicodeFormat;

 dcl MCM_GETUNICODEFORMAT fixed bin(31) value(CCM_GETUNICODEFORMAT);
 MonthCal_GetUnicodeFormat: proc (hwnd)
                            returns (type BOOL byvalue optional)
                            options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, MCM_GETUNICODEFORMAT, 0, 0));
 end MonthCal_GetUnicodeFormat;

 %end;

 /* MCN_SELCHANGE is sent whenever the currently displayed date    */
 /* changes via month change, year change, keyboard navigation,    */
 /* prev/next button                                               */

 define structure
   1 NMSELCHANGE unaligned,
     2 nmhdr      type NMHDR,
       /* this must be first, so we don't break WM_NOTIFY */
     2 stSelStart type SYSTEMTIME,
     2 stSelEnd   type SYSTEMTIME;
 define alias LPNMSELCHANGE handle NMSELCHANGE;

 dcl MCN_SELCHANGE fixed bin(31) value(MCN_FIRST + 1);

 /* MCN_GETDAYSTATE is sent for MCS_DAYSTATE controls whenever new    */
 /* daystate information is needed (month or year scroll) to draw     */
 /* bolding information. The app must fill in cDayState months worth  */
 /* of information starting from stStart date. The app may fill in    */
 /* the array at prgDayState or change prgDayState to point to a      */
 /* different array out of which the information will be copied.      */
 /* (similar to tooltips)                                             */

 define structure
   1 NMDAYSTATE unaligned,
     2 nmhdr       type NMHDR,
       /* this must be first, so we don't break WM_NOTIFY */
     2 stStart     type SYSTEMTIME,
     2 cDayState   fixed bin(31),
     2 prgDayState type LPMONTHDAYSTATE;
       /* points to cDayState MONTHDAYSTATEs */
 define alias LPNMDAYSTATE handle NMDAYSTATE;

 dcl MCN_GETDAYSTATE fixed bin(31) value(MCN_FIRST + 3);

 /* MCN_SELECT is sent whenever a selection has occurred */
 /* (via mouse or keyboard)                              */

 define alias LPNMSELECT handle NMSELCHANGE;

 dcl MCN_SELECT        fixed bin(31) value(MCN_FIRST + 4);

 dcl MCS_DAYSTATE      fixed bin(31) value('0001'xn);
 dcl MCS_MULTISELECT   fixed bin(31) value('0002'xn);
 dcl MCS_WEEKNUMBERS   fixed bin(31) value('0004'xn);

 %if #WIN32_IE >= 1024 %then %do;
 dcl MCS_NOTODAYCIRCLE fixed bin(31) value('0008'xn);
 dcl MCS_NOTODAY       fixed bin(31) value('0010'xn);
 %end; %else %do;
 dcl MCS_NOTODAY       fixed bin(31) value('0008'xn);
 %end;

 dcl GMR_VISIBLE       fixed bin(31) value(0);
    /* visible portion of display */
 dcl GMR_DAYSTATE      fixed bin(31) value(1);
     /* above plus the grayed out parts of partially displayed months */

 %end; /* _WIN32 */
 %end; /* NOMONTHCAL */


 /* ====== DATETIMEPICK CONTROL ===================================== */

 %dcl NODATETIMEPICK char ext;
 %if NODATETIMEPICK = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 dcl DATETIMEPICK_CLASSW WCHAR value('SysDateTimePick32');
 dcl DATETIMEPICK_CLASSA char  value('SysDateTimePick32');

 %dcl DATETIMEPICK_CLASS char ext;
 %if UNICODE ^= '' %then %do;
 %DATETIMEPICK_CLASS='DATETIMEPICK_CLASSW';
 %end; %else %do;
 %DATETIMEPICK_CLASS='DATETIMEPICK_CLASSA';
 %end;

 dcl DTM_FIRST fixed bin(31) value('1000'xn);

 /* DWORD DateTimePick_GetSystemtime(HWND hdp, LPSYSTEMTIME pst)      */
 /*   returns GDT_NONE if "none" is selected (DTS_SHOWNONE only)      */
 /*   returns GDT_VALID and modifies *pst to be the currently         */
 /*     selected value                                                */
 dcl DTM_GETSYSTEMTIME fixed bin(31) value(DTM_FIRST + 1);
 DateTime_GetSystemtime: proc (hdp, pst)
                         returns (type DWORD byvalue optional)
                         options (inline reorder) internal;
   dcl hdp     type HWND byvalue,
       pst     type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hdp, DTM_GETSYSTEMTIME, 0, binvalue (addr (pst))));
 end DateTime_GetSystemtime;

 /* BOOL DateTime_SetSystemtime(HWND hdp, DWORD gd, LPSYSTEMTIME pst) */
 /*   if gd==GDT_NONE, sets datetimepick to None (DTS_SHOWNONE only)  */
 /*   if gd==GDT_VALID, sets datetimepick to *pst                     */
 /*   returns TRUE on success, FALSE on error (such as bad params)    */
 dcl DTM_SETSYSTEMTIME fixed bin(31) value(DTM_FIRST + 2);
 DateTime_SetSystemtime: proc (hdp, gd, pst)
                         returns (type DWORD byvalue optional)
                         options (inline reorder) internal;
   dcl hdp     type HWND byvalue,
       gd      type DWORD byvalue,
       pst     type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hdp, DTM_SETSYSTEMTIME, (gd),
                   binvalue (addr (pst))));
 end DateTime_SetSystemtime;

 /* DWORD DateTime_GetRange(HWND hdp, LPSYSTEMTIME rgst)              */
 /*   modifies rgst[0] to be the minimum ALLOWABLE systemtime         */
 /*      (or 0 if no minimum)                                         */
 /*   modifies rgst[1] to be the maximum ALLOWABLE systemtime         */
 /*      (or 0 if no maximum)                                         */
 /*   returns GDTR_MIN|GDTR_MAX if there is a minimum|maximum limit   */
 /* PL/I note: uses rgst(1) and rgst(2)                               */
 dcl DTM_GETRANGE fixed bin(31) value(DTM_FIRST + 3);
 DateTime_GetRange: proc (hdp, rgst)
                    returns (type DWORD byvalue optional)
                    options (inline reorder) internal;
   dcl hdp     type HWND byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hdp, DTM_GETRANGE, 0, binvalue (addr (rgst))));
 end DateTime_GetRange;

 /* BOOL DateTime_SetRange(HWND hdp, DWORD gdtr, LPSYSTEMTIME rgst)   */
 /*   if GDTR_MIN, sets the minimum ALLOWABLE systemtime to rgst[0],  */
 /*      otherwise removes minimum                                    */
 /*   if GDTR_MAX, sets the maximum ALLOWABLE systemtime to rgst[1],  */
 /*      otherwise removes maximum                                    */
 /*   returns TRUE on success, FALSE on error (such as invalid        */
 /*      parameters)                                                  */
 /* PL/I note: uses rgst(1) and rgst(2)                               */
 dcl DTM_SETRANGE fixed bin(31) value(DTM_FIRST + 4);
 DateTime_SetRange: proc (hdp, gd, rgst)
                    returns (type BOOL byvalue optional)
                    options (inline reorder) internal;
   dcl hdp     type HWND byvalue,
       gd      type DWORD byvalue,
       rgst(2) type SYSTEMTIME byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hdp, DTM_SETRANGE, (gd), binvalue (addr (rgst))));
 end DateTime_SetRange;

 /* BOOL DateTime_SetFormat(HWND hdp, LPCTSTR sz)                     */
 /*   sets the display formatting string to sz (see GetDateFormat and */
 /*      GetTimeFormat for valid formatting chars)                    */
 /*   NOTE: 'X' is a valid formatting character which indicates that  */
 /*      the application will determine how to display information.   */
 /*      Such apps must support DTN_WMKEYDOWN, DTN_FORMAT,            */
 /*      and DTN_FORMATQUERY.                                         */
 dcl DTM_SETFORMATA fixed bin(31) value(DTM_FIRST + 5);
 dcl DTM_SETFORMATW fixed bin(31) value(DTM_FIRST + 50);

 %if UNICODE ^= '' %then %do;
 dcl DTM_SETFORMAT  fixed bin(31) value(DTM_SETFORMATW);
 %end; %else %do;
 dcl DTM_SETFORMAT  fixed bin(31) value(DTM_SETFORMATA);
 %end;

 DateTime_SetFormat: proc (hdp, sz)
                     returns (type BOOL byvalue optional)
                     options (inline reorder) internal;
   dcl hdp type HWND byvalue,
       sz  TCHAR(*) varz byaddr nonasgn optional;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hdp, DTM_SETFORMAT, 0, binvalue (addr (sz))));
 end DateTime_SetFormat;


 dcl DTM_SETMCCOLOR fixed bin(31) value(DTM_FIRST + 6);
 DateTime_SetMonthCalColor: proc (hdp, iColor, clr)
                            returns (type COLORREF byvalue optional)
                            options (inline reorder) internal;
   dcl hdp    type HWND byvalue,
       iColor fixed bin(31) byvalue,
       clr    type COLORREF byvalue;
   return (SNDMSG (hdp, DTM_SETMCCOLOR, (iColor), (clr)));
 end DateTime_SetMonthCalColor;

 dcl DTM_GETMCCOLOR fixed bin(31) value(DTM_FIRST + 7);
 DateTime_GetMonthCalColor: proc (hdp, iColor)
                            returns (type COLORREF byvalue optional)
                            options (inline reorder) internal;
   dcl hdp    type HWND byvalue,
       iColor fixed bin(31) byvalue;
   return (SNDMSG (hdp, DTM_GETMCCOLOR, (iColor), 0));
 end DateTime_GetMonthCalColor;

 /* HWND DateTime_GetMonthCal(HWND hdp)                         */
 /*   returns the HWND of the MonthCal popup window. Only valid */
 /* between DTN_DROPDOWN and DTN_CLOSEUP notifications.         */
 dcl DTM_GETMONTHCAL fixed bin(31) value(DTM_FIRST + 8);
 DateTime_GetMonthCal: proc (hdp)
                       returns (type HWND byvalue optional)
                       options (inline reorder) internal;
   dcl hdp    type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hdp, DTM_GETMONTHCAL, 0, 0)));
 end DateTime_GetMonthCal;


 %if #WIN32_IE >= 1024 %then %do;

 dcl DTM_SETMCFONT fixed bin(31) value(DTM_FIRST + 9);
 DateTime_SetMonthCalFont: proc (hdp, hfont, fRedraw)
                           options (inline reorder) internal;
   dcl hdp     type HWND byvalue,
       hfont   type HFONT byvalue,
       fRedraw type DWORD byvalue; /* MAKEWORD (fRedraw, 0) */
   dcl binvalue builtin;
   call SNDMSG (hdp, DTM_SETMCFONT, binvalue (hfont), (fRedraw));
 end DateTime_SetMonthCalFont;

 dcl DTM_GETMCFONT fixed bin(31) value(DTM_FIRST + 10);
 DateTime_GetMonthCalFont: proc (hdp)
                           returns (type HFONT byvalue optional)
                           options (inline reorder) internal;
   dcl hdp     type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hdp, DTM_GETMCFONT, 0, 0)));
 end DateTime_GetMonthCalFont;


 %end; /* _WIN32_IE >= 0x0400 */

 dcl DTS_UPDOWN          fixed bin(31) value('0001'xn);
     /* use UPDOWN instead of MONTHCAL */
 dcl DTS_SHOWNONE        fixed bin(31) value('0002'xn);
     /* allow a NONE selection */
 dcl DTS_SHORTDATEFORMAT fixed bin(31) value('0000'xn);
     /* use the short date format                   */
     /* (app must forward WM_WININICHANGE messages) */
 dcl DTS_LONGDATEFORMAT  fixed bin(31) value('0004'xn);
     /* use the long date format                    */
     /* (app must forward WM_WININICHANGE messages) */

 dcl DTS_TIMEFORMAT      fixed bin(31) value('0009'xn);
     /* use the time format                         */
     /* (app must forward WM_WININICHANGE messages) */
 dcl DTS_APPCANPARSE     fixed bin(31) value('0010'xn);
     /* allow user entered strings           */
     /* (app MUST respond to DTN_USERSTRING) */
 dcl DTS_RIGHTALIGN      fixed bin(31) value('0020'xn);
     /* right-align popup instead of left-align it */

 dcl DTN_DATETIMECHANGE  fixed bin(31) value(DTN_FIRST + 1);
     /* the systemtime has changed */
 define structure
   1 NMDATETIMECHANGE unaligned,
     2 nmhdr         type NMHDR,
     2 dwFlags       type DWORD,/* GDT_VALID or GDT_NONE */
     2 st            type SYSTEMTIME;/* valid iff dwFlags==GDT_VALID */
 define alias LPNMDATETIMECHANGE handle NMDATETIMECHANGE;

 dcl DTN_USERSTRINGA fixed bin(31) value(DTN_FIRST + 2);
     /* the user has entered a string */
 dcl DTN_USERSTRINGW fixed bin(31) value(DTN_FIRST + 15);

 define structure
   1 NMDATETIMESTRINGA unaligned,
     2 nmhdr         type NMHDR,
     2 pszUserString type LPCSTR,/* string user entered */
     2 st            type SYSTEMTIME,/* app fills this in */
     2 dwFlags       type DWORD;/* GDT_VALID or GDT_NONE */
 define alias LPNMDATETIMESTRINGA handle NMDATETIMESTRINGA;

 define structure
   1 NMDATETIMESTRINGW unaligned,
     2 nmhdr         type NMHDR,
     2 pszUserString type LPCWSTR,/* string user entered */
     2 st            type SYSTEMTIME,/* app fills this in */
     2 dwFlags       type DWORD;/* GDT_VALID or GDT_NONE */
 define alias LPNMDATETIMESTRINGW handle NMDATETIMESTRINGW;


 %if UNICODE ^= '' %then %do;
 dcl DTN_USERSTRING fixed bin (31) value(DTN_USERSTRINGW);
 define alias NMDATETIMESTRING   type   NMDATETIMESTRINGW;
 define alias LPNMDATETIMESTRING type LPNMDATETIMESTRINGW;
 %end; %else %do;
 dcl DTN_USERSTRING fixed bin (31) value(DTN_USERSTRINGA);
 define alias NMDATETIMESTRING   type   NMDATETIMESTRINGA;
 define alias LPNMDATETIMESTRING type LPNMDATETIMESTRINGA;
 %end;


 dcl DTN_WMKEYDOWNA fixed bin(31) value(DTN_FIRST + 3);
    /* modify keydown on app format field (X) */
 dcl DTN_WMKEYDOWNW fixed bin(31) value(DTN_FIRST + 16);

 define structure
   1 NMDATETIMEWMKEYDOWNA unaligned,
     2 nmhdr     type NMHDR,
     2 nVirtKey  fixed bin(31),
       /* virtual key code of WM_KEYDOWN which MODIFIES an X field */
     2 pszFormat type LPCSTR,     /* format substring */
     2 st        type SYSTEMTIME;
       /* current systemtime, app should modify based on key */
 define alias LPNMDATETIMEWMKEYDOWNA handle NMDATETIMEWMKEYDOWNA;

 define structure
   1 NMDATETIMEWMKEYDOWNW unaligned,
     2 nmhdr     type NMHDR,
     2 nVirtKey  fixed bin(31),
       /* virtual key code of WM_KEYDOWN which MODIFIES an X field */
     2 pszFormat type LPCWSTR,    /* format substring */
     2 st        type SYSTEMTIME;
       /* current systemtime, app should modify based on key */
 define alias LPNMDATETIMEWMKEYDOWNW handle NMDATETIMEWMKEYDOWNW;

 %if UNICODE ^= '' %then %do;
 dcl DTN_WMKEYDOWN  fixed bin(31) value(DTN_WMKEYDOWNW);
 define alias   NMDATETIMEWMKEYDOWN type   NMDATETIMEWMKEYDOWNW;
 define alias LPNMDATETIMEWMKEYDOWN type LPNMDATETIMEWMKEYDOWNW;
 %end; %else %do;
 dcl DTN_WMKEYDOWN  fixed bin(31) value(DTN_WMKEYDOWNA);
 define alias   NMDATETIMEWMKEYDOWN type   NMDATETIMEWMKEYDOWNA;
 define alias LPNMDATETIMEWMKEYDOWN type LPNMDATETIMEWMKEYDOWNA;
 %end;


 dcl DTN_FORMATA fixed bin(31) value(DTN_FIRST + 4);
 /* query display for app format field (X) */
 dcl DTN_FORMATW fixed bin(31) value(DTN_FIRST + 17);

 define structure
   1 NMDATETIMEFORMATA unaligned,
     2 nmhdr        type NMHDR,
     2 pszFormat    type LPCSTR,    /* format substring */
     2 st           type SYSTEMTIME,/* current systemtime */
     2 pszDisplay   type LPCSTR,    /* string to display */
     2 szDisplay    char (64-1) varz;
       /* buffer pszDisplay originally points at */
 define alias LPNMDATETIMEFORMATA handle NMDATETIMEFORMATA;

 define structure
   1 NMDATETIMEFORMATW unaligned,
     2 nmhdr        type NMHDR,
     2 pszFormat    type LPCWSTR,   /* format substring */
     2 st           type SYSTEMTIME,/* current systemtime */
     2 pszDisplay   type LPCWSTR,   /* string to display */
     2 szDisplay    WCHAR (64-1) varz;
       /* buffer pszDisplay originally points at */
 define alias LPNMDATETIMEFORMATW handle NMDATETIMEFORMATW;

 %if UNICODE ^= '' %then %do;
 dcl DTN_FORMAT  fixed bin(31) value(DTN_FORMATW);
 define alias   NMDATETIMEFORMAT type   NMDATETIMEFORMATW;
 define alias LPNMDATETIMEFORMAT type LPNMDATETIMEFORMATW;
 %end; %else %do;
 dcl DTN_FORMAT  fixed bin(31) value(DTN_FORMATA);
 define alias   NMDATETIMEFORMAT type   NMDATETIMEFORMATA;
 define alias LPNMDATETIMEFORMAT type LPNMDATETIMEFORMATA;
 %end;


 dcl DTN_FORMATQUERYA fixed bin(31) value(DTN_FIRST + 5);
 /* query formatting info for app format field (X) */
 dcl DTN_FORMATQUERYW fixed bin(31) value(DTN_FIRST + 18);

 define structure
   1 NMDATETIMEFORMATQUERYA unaligned,
     2 nmhdr     type NMHDR,
     2 pszFormat type LPCSTR,  /* format substring */
     2 szMax     type SIZE;
       /* max bounding rectangle app will use for this format string */
 define alias LPNMDATETIMEFORMATQUERYA handle NMDATETIMEFORMATQUERYA;


 define structure
   1 NMDATETIMEFORMATQUERYW unaligned,
     2 nmhdr     type NMHDR,
     2 pszFormat type LPCWSTR, /* format substring */
     2 szMax     type SIZE;
       /* max bounding rectangle app will use for this format string */
 define alias LPNMDATETIMEFORMATQUERYW handle NMDATETIMEFORMATQUERYW;

 %if UNICODE ^= '' %then %do;
 dcl DTN_FORMATQUERY  fixed bin(31) value(DTN_FORMATQUERYW);
 define alias   NMDATETIMEFORMATQUERY type   NMDATETIMEFORMATQUERYW;
 define alias LPNMDATETIMEFORMATQUERY type LPNMDATETIMEFORMATQUERYW;
 %end; %else %do;
 dcl DTN_FORMATQUERY  fixed bin(31) value(DTN_FORMATQUERYA);
 define alias   NMDATETIMEFORMATQUERY type   NMDATETIMEFORMATQUERYA;
 define alias LPNMDATETIMEFORMATQUERY type LPNMDATETIMEFORMATQUERYA;
 %end;


 dcl DTN_DROPDOWN fixed bin(31) value(DTN_FIRST + 6);
     /* MonthCal has dropped down */
 dcl DTN_CLOSEUP fixed bin(31) value(DTN_FIRST + 7);
     /* MonthCal is popping up */

 dcl GDTR_MIN  fixed bin(31) value('0001'xn);
 dcl GDTR_MAX  fixed bin(31) value('0002'xn);

 dcl GDT_ERROR fixed bin(31) value(-1);
 dcl GDT_VALID fixed bin(31) value(0);
 dcl GDT_NONE  fixed bin(31) value(1);


 %end; /* _WIN32 */
 %end; /* NODATETIMEPICK */


 %if #WIN32_IE >= 1024 %then %do;

 %dcl NOIPADDRESS char ext;
 %if NOIPADDRESS = '' %then %do;

 /**********************************************/
 /*    IP Address edit control                 */
 /**********************************************/

 /* Messages sent to IPAddress controls */

 dcl IPM_CLEARADDRESS fixed bin(31) value(WM_USER+100);
     /* no parameters */
 dcl IPM_SETADDRESS   fixed bin(31) value(WM_USER+101);
     /* lparam = TCP/IP address */
 dcl IPM_GETADDRESS   fixed bin(31) value(WM_USER+102);
     /* lresult = # of non black fields.    */
     /* lparam = LPDWORD for TCP/IP address */
 dcl IPM_SETRANGE     fixed bin(31) value(WM_USER+103);
     /* wparam = field, lparam = range */
 dcl IPM_SETFOCUS     fixed bin(31) value(WM_USER+104);
     /* wparam = field */
 dcl IPM_ISBLANK      fixed bin(31) value(WM_USER+105);
     /* no parameters */

 dcl WC_IPADDRESSW WCHAR value('SysIPAddress32');
 dcl WC_IPADDRESSA char  value('SysIPAddress32');

 %dcl WC_IPADDRESS char ext;
 %if UNICODE ^= '' %then %do;
 %WC_IPADDRESS='WC_IPADDRESSW';
 %end; %else %do;
 %WC_IPADDRESS='WC_IPADDRESSA';
 %end;

 dcl IPN_FIELDCHANGED fixed bin(31) value(IPN_FIRST - 0);

 define structure
   1 NMIPADDRESS unaligned,
     2 hdr    type NMHDR,
     2 iField fixed bin(31),
     2 iValue fixed bin(31);
 define alias LPNMIPADDRESS handle NMIPADDRESS;

 /* The following is a useful macro for passing the range values in */
 /* the IPM_SETRANGE message.                                       */

 MAKEIPRANGE: proc (low, high) returns (type LPARAM byvalue)
              options (inline reorder) internal;
   dcl low  type BYTE byvalue,
       high type BYTE byvalue;
   dcl raise2 builtin;
   return (raise2 (high, 8) + low);
 end MAKEIPRANGE;

 /* And this is a useful macro for making the IP Address to be passed */
 /* as a LPARAM. */

 MAKEIPADDRESS: proc (b1, b2, b3, b4) returns (type LPARAM byvalue)
                options (inline reorder) internal;
   dcl b1 type BYTE byvalue,
       b2 type BYTE byvalue,
       b3 type BYTE byvalue,
       b4 type BYTE byvalue;
   dcl raise2 builtin;
   return (raise2 (b1, 24) + raise2 (b2, 16) + raise2 (b3, 8) + b4);
 end MAKEIPADDRESS;

 /* Get individual number */

 FIRST_IPADDRESS: proc (x) returns (type BYTE byvalue)
                  options (inline reorder) internal;
   dcl x type LPARAM byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (x, 24), 'ff'xu));
 end FIRST_IPADDRESS;

 SECOND_IPADDRESS: proc (x) returns (type BYTE byvalue)
                   options (inline reorder) internal;
   dcl x type LPARAM byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (x, 16), 'ff'xu));
 end SECOND_IPADDRESS;

 THIRD_IPADDRESS: proc (x) returns (type BYTE byvalue)
                  options (inline reorder) internal;
   dcl x type LPARAM byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (x, 8), 'ff'xu));
 end THIRD_IPADDRESS;

 FOURTH_IPADDRESS: proc (x) returns (type BYTE byvalue)
                   options (inline reorder) internal;
   dcl x type LPARAM byvalue;
   dcl iand builtin;
   return (iand (x, 'ff'xu));
 end FOURTH_IPADDRESS;

 %end; /* NOIPADDRESS */


 /*----------------------------------------------------------------- */
 /*  ====================== Pager Control ========================== */
 /*----------------------------------------------------------------- */

 %dcl NOPAGESCROLLER char ext;
 %if NOPAGESCROLLER = '' %then %do;

 /* Pager Class Name */
 dcl WC_PAGESCROLLERW WCHAR value('SysPager');
 dcl WC_PAGESCROLLERA char  value('SysPager');

 %dcl WC_PAGESCROLLER char ext;
 %if UNICODE ^= '' %then %do;
 %WC_PAGESCROLLER='WC_PAGESCROLLERW';
 %end; %else %do;
 %WC_PAGESCROLLER='WC_PAGESCROLLERA';
 %end;


 /*------------------------------------------------------------------ */
 /* Pager Control Styles                                              */
 /*------------------------------------------------------------------ */
 dcl PGS_VERT       type DWORD value('00000000'xu);
 dcl PGS_HORZ       type DWORD value('00000001'xu);
 dcl PGS_AUTOSCROLL type DWORD value('00000002'xu);
 dcl PGS_DRAGNDROP  type DWORD value('00000004'xu);


 /*------------------------------------------------------------------ */
 /* Pager Button State                                                */
 /*------------------------------------------------------------------ */
 /* The scroll can be in one of the following control State */
 dcl PGF_INVISIBLE  fixed bin(31) value(0);
     /* Scroll button is not visible */
 dcl PGF_NORMAL     fixed bin(31) value(1);
     /* Scroll button is in normal state */
 dcl PGF_GRAYED     fixed bin(31) value(2);
     /* Scroll button is in grayed state */
 dcl PGF_DEPRESSED  fixed bin(31) value(4);
     /* Scroll button is in depressed state */
 dcl PGF_HOT        fixed bin(31) value(8);
     /* Scroll button is in hot state */

 /* The following identifiers specifies the button control */
 dcl PGB_TOPORLEFT     fixed bin(31) value(0);
 dcl PGB_BOTTOMORRIGHT fixed bin(31) value(1);

 /*-------------------------------------------------------------------*/
 /* Pager Control Messages                                            */
 /*-------------------------------------------------------------------*/

 dcl PGM_SETCHILD fixed bin(31) value(PGM_FIRST + 1);
     /* lParam == hwnd */
 Pager_SetChild: proc (hwnd, hwndChild)
                 options (inline reorder) internal;
   dcl hwnd      type HWND byvalue,
       hwndChild type HWND byvalue;
   dcl binvalue builtin;
   call SNDMSG (hwnd, PGM_SETCHILD, 0, binvalue (hwndChild));
 end Pager_SetChild;

 dcl PGM_RECALCSIZE fixed bin(31) value(PGM_FIRST + 2);
 Pager_RecalcSize: proc (hwnd)
                   options (inline reorder) internal;
   dcl hwnd      type HWND byvalue;
   call SNDMSG (hwnd, PGM_RECALCSIZE, 0, 0);
 end Pager_RecalcSize;

 dcl PGM_FORWARDMOUSE fixed bin(31) value(PGM_FIRST + 3);
 Pager_ForwardMouse: proc (hwnd, bForward)
                     options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       bForward type BOOL byvalue;
   call SNDMSG (hwnd, PGM_FORWARDMOUSE, (bForward), 0);
 end Pager_ForwardMouse;

 dcl PGM_SETBKCOLOR fixed bin(31) value(PGM_FIRST + 4);
 Pager_SetBkColor: proc (hwnd, clr)
                   returns (type COLORREF byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       clr  type COLORREF byvalue;
   return (SNDMSG (hwnd, PGM_SETBKCOLOR, 0, (clr)));
 end Pager_SetBkColor;

 dcl PGM_GETBKCOLOR fixed bin(31) value(PGM_FIRST + 5);
 Pager_GetBkColor: proc (hwnd)
                   returns (type COLORREF byvalue optional)
                   options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, PGM_GETBKCOLOR, 0, 0));
 end Pager_GetBkColor;

 dcl PGM_SETBORDER fixed bin(31) value(PGM_FIRST + 6);
 Pager_SetBorder: proc (hwnd, iBorder)
                  returns (fixed bin(31) byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       iBorder fixed bin(31) byvalue;
   return (SNDMSG (hwnd, PGM_SETBORDER, 0, (iBorder)));
 end Pager_SetBorder;

 dcl PGM_GETBORDER fixed bin(31) value(PGM_FIRST + 7);
 Pager_GetBorder: proc (hwnd)
                  returns (fixed bin(31) byvalue optional)
                  options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, PGM_GETBORDER, 0, 0));
 end Pager_GetBorder;

 dcl PGM_SETPOS fixed bin(31) value(PGM_FIRST + 8);
 Pager_SetPos: proc (hwnd, iPos)
               returns (fixed bin(31) byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       iPos fixed bin(31) byvalue;
   return (SNDMSG (hwnd, PGM_SETPOS, 0, (iPos)));
 end Pager_SetPos;

 dcl PGM_GETPOS fixed bin(31) value(PGM_FIRST + 9);
 Pager_GetPos: proc (hwnd)
               returns (fixed bin(31) byvalue optional)
               options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, PGM_GETPOS, 0, 0));
 end Pager_GetPos;

 dcl PGM_SETBUTTONSIZE fixed bin(31) value(PGM_FIRST + 10);
 Pager_SetButtonSize: proc (hwnd, iSize)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue,
       iSize fixed bin(31);
   return (SNDMSG (hwnd, PGM_SETBUTTONSIZE, 0, (iSize)));
 end Pager_SetButtonSize;

 dcl PGM_GETBUTTONSIZE fixed bin(31) value(PGM_FIRST + 11);
 Pager_GetButtonSize: proc (hwnd)
                      returns (fixed bin(31) byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd  type HWND byvalue;
   return (SNDMSG (hwnd, PGM_GETBUTTONSIZE, 0, 0));
 end Pager_GetButtonSize;

 dcl PGM_GETBUTTONSTATE fixed bin(31) value(PGM_FIRST + 12);
 Pager_GetButtonState: proc (hwnd, iButton)
                       returns (type DWORD byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       iButton fixed bin(31) byvalue;
   return (SNDMSG (hwnd, PGM_GETBUTTONSTATE, 0, (iButton)));
 end Pager_GetButtonState;

 dcl PGM_GETDROPTARGET fixed bin(31) value(CCM_GETDROPTARGET);
 Pager_GetDropTarget: proc (hwnd, ppdt)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue,
       ppdt pointer byaddr; /* IDropTarget ** */
   dcl binvalue builtin;
   call SNDMSG (hwnd, PGM_GETDROPTARGET, 0, binvalue (ppdt));
 end Pager_GetDropTarget;

 /*-------------------------------------------------------------------*/
 /* Pager Control Notification Messages                               */
 /*-------------------------------------------------------------------*/


 /* PGN_SCROLL Notification Message */

 dcl PGN_SCROLL      fixed bin(31) value(PGN_FIRST-1);

 dcl PGF_SCROLLUP    fixed bin(31) value(1);
 dcl PGF_SCROLLDOWN  fixed bin(31) value(2);
 dcl PGF_SCROLLLEFT  fixed bin(31) value(4);
 dcl PGF_SCROLLRIGHT fixed bin(31) value(8);


 /* Keys down */
 dcl PGK_SHIFT       fixed bin(31) value(1);
 dcl PGK_CONTROL     fixed bin(31) value(2);
 dcl PGK_MENU        fixed bin(31) value(4);


 /* This structure is sent along with PGN_SCROLL notifications */
 define structure
   1 NMPGSCROLL unaligned,
     2 hdr      type NMHDR,
     2 fwKeys   type WORD,
     /* Specifies which keys are down when this notification is send */
     2 rcParent type RECT,    /* Contains Parent Window Rect */
     2 iDir     fixed bin(31),/* Scrolling Direction */
     2 iXpos    fixed bin(31),/* Horizontal scroll position */
     2 iYpos    fixed bin(31),/* Vertical scroll position */
     2 iScroll  fixed bin(31);/* [in/out] Amount to scroll */
 define alias LPNMPGSCROLL handle NMPGSCROLL;


 /* PGN_CALCSIZE Notification Message */

 dcl PGN_CALCSIZE   fixed bin(31) value(PGN_FIRST-2);

 dcl PGF_CALCWIDTH  fixed bin(31) value(1);
 dcl PGF_CALCHEIGHT fixed bin(31) value(2);

 define structure
   1 NMPGCALCSIZE unaligned,
     2 hdr     type NMHDR,
     2 dwFlag  type DWORD,
     2 iWidth  fixed bin(31),
     2 iHeight fixed bin(31);
 define alias LPNMPGCALCSIZE handle NMPGCALCSIZE;

 %end; /* NOPAGESCROLLER */

 /* ======================  End Pager Control ======================= */


 /* === Native Font Control === */

 %dcl NONATIVEFONTCTL char ext;
 %if NONATIVEFONTCTL = '' %then %do;
 /* NativeFont Class Name */
 dcl WC_NATIVEFONTCTLW WCHAR value('NativeFontCtl');
 dcl WC_NATIVEFONTCTLA char  value('NativeFontCtl');

 %dcl WC_NATIVEFONTCTL char ext;
 %if UNICODE ^= '' %then %do;
 %WC_NATIVEFONTCTL='WC_NATIVEFONTCTLW';
 %end; %else %do;
 %WC_NATIVEFONTCTL='WC_NATIVEFONTCTLA';
 %end;

 /* style definition */
 dcl NFS_EDIT         type DWORD value('0001'xu);
 dcl NFS_STATIC       type DWORD value('0002'xu);
 dcl NFS_LISTCOMBO    type DWORD value('0004'xu);
 dcl NFS_BUTTON       type DWORD value('0008'xu);
 dcl NFS_ALL          type DWORD value('0010'xu);
 dcl NFS_USEFONTASSOC type DWORD value('0020'xu);

 %end; /* NONATIVEFONTCTL */
 /* === End Native Font Control === */

 /* ====================== Button Control =========================== */

 %dcl NOBUTTON char ext;
 %if NOBUTTON  = '' %then %do;

 %if #WIN32 ^= '' %then %do;
 /* Button Class Name */
 dcl WC_BUTTONA char  value ('Button');
 dcl WC_BUTTONW WCHAR value ('Button');

 %dcl WC_BUTTON char ext;
 %if UNICODE ^= '' %then %do;
   %WC_BUTTON = 'WC_BUTTONW';
 %end; %else %do;
   %WC_BUTTON = 'WC_BUTTONA';
 %end;

 %end; %else %do;
 dcl WC_BUTTON char value ('Button');
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl BUTTON_IMAGELIST_ALIGN_LEFT     type UINT value(0);
 dcl BUTTON_IMAGELIST_ALIGN_RIGHT    type UINT value(1);
 dcl BUTTON_IMAGELIST_ALIGN_TOP      type UINT value(2);
 dcl BUTTON_IMAGELIST_ALIGN_BOTTOM   type UINT value(3);
 dcl BUTTON_IMAGELIST_ALIGN_CENTER   type UINT value(4);
     /* Doesn't draw text */

 define structure
   1 BUTTON_IMAGELIST,
     2 himl   type HIMAGELIST,
              /* Index: Normal, hot pushed, disabled.    */
              /* If count is less than 4, we use index 1 */
     2 margin type RECT, /* Margin around icon. */
     2 uAlign type UINT;
 define alias PBUTTON_IMAGELIST handle BUTTON_IMAGELIST;

 dcl BCM_GETIDEALSIZE    fixed bin (31) value(BCM_FIRST + '0001'xn);
 Button_GetIdealSize: proc (hwnd, psize)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       psize   type SIZE byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, BCM_GETIDEALSIZE,
                         0, binvalue (addr (psize))));
 end Button_GetIdealSize;

 dcl BCM_SETIMAGELIST    fixed bin (31) value(BCM_FIRST + '0002'xn);
 Button_SetImageList: proc (hwnd, pbuttonImagelist)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd             type HWND byvalue,
       pbuttonImagelist type BUTTON_IMAGELIST byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, BCM_SETIMAGELIST,
                         0, binvalue (addr (pbuttonImagelist))));
 end Button_SetImageList;

 dcl BCM_GETIMAGELIST    fixed bin (31) value(BCM_FIRST + '0003'xn);
 Button_GetImageList: proc (hwnd, pbuttonImagelist)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd             type HWND byvalue,
       pbuttonImagelist type BUTTON_IMAGELIST byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, BCM_GETIMAGELIST,
                         0, binvalue (addr (pbuttonImagelist))));
 end Button_GetImageList;

 dcl BCM_SETTEXTMARGIN   fixed bin (31) value(BCM_FIRST + '0004'xn);
 Button_SetTextMargin: proc (hwnd, pmargin)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       pmargin type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, BCM_SETTEXTMARGIN,
                         0, binvalue (addr (pmargin))));
 end Button_SetTextMargin;

 dcl BCM_GETTEXTMARGIN   fixed bin (31) value(BCM_FIRST + '0005'xn);
 Button_GetTextMargin: proc (hwnd, pmargin)
                       returns (type BOOL byvalue optional)
                       options (inline reorder) internal;
   dcl hwnd    type HWND byvalue,
       pmargin type RECT byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, BCM_GETTEXTMARGIN,
                         0, binvalue (addr (pmargin))));
 end Button_GetTextMargin;

 define structure
   1 NMBCHOTITEM unaligned,
     2 hdr     type NMHDR,
     2 dwFlags type DWORD; /* HICF_* */
 define alias LPNMBCHOTITEM handle NMBCHOTITEM;

 dcl BCN_HOTITEMCHANGE   fixed bin (31) value(BCN_FIRST + '0001'xn);

 dcl BST_HOT             fixed bin (31) value('0200'xn);

 %end;

 %end; /* NOBUTTON */

 /* =====================  End Button Control ======================= */

 /* ====================== Static Control =========================== */

 %dcl NOSTATIC char ext;
 %if NOSTATIC = '' %then %do;

 %if #WIN32 ^= '' %then %do;
 /* Static Class Name */
 dcl WC_STATICA  char value('Static');
 dcl WC_STATICW WCHAR value('Static');

 %dcl WC_STATIC char ext;
 %if UNICODE ^= '' %then %do;
   %WC_STATIC = 'WC_STATICW';
 %end; %else %do;
   %WC_STATIC = 'WC_STATICA';
 %end;

 %end; %else %do;
 dcl WC_STATIC  char value('Static');
 %end;

 %end; /* NOSTATIC */

 /* =====================  End Static Control ======================= */

 /* ====================== Edit Control ============================= */

 %dcl NOEDIT char ext;
 %if NOEDIT = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 /* Edit Class Name */
 dcl WC_EDITA  char value('Edit');
 dcl WC_EDITW WCHAR value('Edit');

 %dcl WC_EDIT char ext;
 %if UNICODE ^= '' %then %do;
   %WC_EDIT = 'WC_EDITW';
 %end; %else %do;
   %WC_EDIT = 'WC_EDITA';
 %end;

 %end; %else %do;
 dcl WC_EDIT  char value('Edit');
 %end;

 %if #WIN32_WINNT >= 1281 %then %do;
 dcl EM_SETCUEBANNER	    fixed bin (31) value(ECM_FIRST + 1);
     /* Set the cue banner with the lParm = LPCWSTR */

 Edit_SetCueBannerText: proc (hwnd, lpcwText)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       lpcwText WCHAR(*) varz byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, EM_SETCUEBANNER,
                   0, binvalue (addr (lpcwText))));
 end Edit_SetCueBannerText;

 dcl EM_GETCUEBANNER	    fixed bin (31) value(ECM_FIRST + 2);
     /* Get the cue banner with the lParm = LPCWSTR [???] */
 Edit_GetCueBannerText: proc (hwnd, lpwText, cchText)
                        returns (type BOOL byvalue optional)
                        options (inline reorder) internal;
   dcl hwnd     type HWND byvalue,
       lpwText  WCHAR(*) varz byaddr,
       cchText  fixed bin (31) byvalue;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, EM_GETCUEBANNER,
                         binvalue (addr (lpwText)), cchText));
 end Edit_GetCueBannerText;

 define structure
   1 EDITBALLOONTIP,
     2 cbStruct type DWORD,
     2 pszTitle type LPCWSTR,
     2 pszText  type LPCWSTR,
     2 ttiIcon  type INT;     /* From TTI_* */
 define alias PEDITBALLOONTIP handle EDITBALLOONTIP;

 dcl EM_SHOWBALLOONTIP    fixed bin (31) value(ECM_FIRST + 3);
     /* Show a balloon tip associated to the edit control */
 Edit_ShowBalloonTip: proc (hwnd, peditballoontip)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd            type HWND byvalue,
       peditballoontip type EDITBALLOONTIP byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hwnd, EM_SHOWBALLOONTIP,
                         0, binvalue (addr (peditballoontip))));
 end Edit_ShowBalloonTip;

 dcl EM_HIDEBALLOONTIP    fixed bin (31) value(ECM_FIRST + 4);
     /* Hide any balloon tip associated with the edit control */
 Edit_HideBalloonTip: proc (hwnd)
                      returns (type BOOL byvalue optional)
                      options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, EM_HIDEBALLOONTIP, 0, 0));
 end Edit_HideBalloonTip;
 %end;

 %end; /* NOEDIT */

 /* =====================  End Edit Control ========================= */

 /* ====================== Listbox Control ========================== */

 %dcl NOLISTBOX char ext;
 %if NOLISTBOX = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 /* Listbox Class Name */
 dcl WC_LISTBOXA  char value('ListBox');
 dcl WC_LISTBOXW WCHAR value('ListBox');

 %dcl WC_LISTBOX char ext;
 %if UNICODE ^= '' %then %do;
   %WC_LISTBOX = 'WC_LISTBOXW';
 %end; %else %do;
   %WC_LISTBOX = 'WC_LISTBOXA';
 %end;

 %end; %else %do;
 dcl WC_LISTBOX  char value('ListBox');
 %end;

 %end; /* NOLISTBOX */


 /* =====================  End Listbox Control ====================== */

 /* ====================== Combobox Control ========================= */

 %dcl NOCOMBOBOX char ext;
 %if NOCOMBOBOX = '' %then %do;

 %if #WIN32 ^= '' %then %do;

 /* Combobox Class Name */
 dcl WC_COMBOBOXA  char value('ComboBox');
 dcl WC_COMBOBOXW WCHAR value('ComboBox');

 %dcl WC_COMBOBOX char ext;
 %if UNICODE ^= '' %then %do;
   %WC_COMBOBOX = 'WC_COMBOBOXW';
 %end; %else %do;
   %WC_COMBOBOX = 'WC_COMBOBOXA';
 %end;

 %end; %else %do;
 dcl WC_COMBOBOX char value('ComboBox');
 %end;

 %end; /* NOCOMBOBOX */


 %if #WIN32_WINNT >= 1281 %then %do;

 /* custom combobox control messages */
 dcl CB_SETMINVISIBLE  fixed bin (31) value(CBM_FIRST + 1);
 dcl CB_GETMINVISIBLE  fixed bin (31) value(CBM_FIRST + 2);

 ComboBox_SetMinVisible: proc (hwnd, iMinVisible)
                         returns (type BOOL byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd        type HWND byvalue,
       iMinVisible fixed bin (31);
   return (SNDMSG (hwnd, CB_SETMINVISIBLE,
                         cast (: WPARAM, iMinVisible :), 0));
 end ComboBox_SetMinVisible;

 ComboBox_GetMinVisible: proc (hwnd)
                         returns (fixed bin (31) byvalue optional)
                         options (inline reorder) internal;
   dcl hwnd type HWND byvalue;
   return (SNDMSG (hwnd, CB_GETMINVISIBLE, 0, 0));
 end ComboBox_GetMinVisible;

 %end;

 /* =====================  End Combobox Control ===================== */

 /* ====================== Scrollbar Control ======================== */

 %dcl NOSCROLLBAR char ext;
 %if NOSCROLLBAR = '' %then %do;

 %if #WIN32 ^= '' %then %do;
 /* Scrollbar Class Name */
 dcl WC_SCROLLBARA  char value('ScrollBar');
 dcl WC_SCROLLBARW WCHAR value('ScrollBar');

 %dcl WC_SCROLLBAR char ext;
 %if UNICODE ^= '' %then %do;
   %WC_SCROLLBAR = 'WC_SCROLLBARW';
 %end; %else %do;
   %WC_SCROLLBAR = 'WC_SCROLLBARA';
 %end;

 %end; %else %do;
 dcl WC_SCROLLBAR char value('ScrollBar');
 %end;

 %end; /* NOSCROLLBAR */


 /* ===================== End Scrollbar Control ===================== */


 /* ====== SysLink control ========================================== */

 %if #WIN32 ^= '' %then %do;
 %if #WIN32_WINNT >= 1281 %then %do;

 dcl INVALID_LINK_INDEX  fixed bin (31) value (-1);
 dcl MAX_LINKID_TEXT     fixed bin (31) value (48);
 dcl L_MAX_URL_LENGTH    fixed bin (31)
     value (2048 + 32 + length('://') + 1 /* nul */);

 dcl WC_LINK WCHAR value('SysLink');

 dcl LWS_TRANSPARENT    type UINT value('0001'xu);
 dcl LWS_IGNORERETURN   type UINT value('0002'xu);

 dcl LIF_ITEMINDEX      type UINT value('00000001'xu);
 dcl LIF_STATE          type UINT value('00000002'xu);
 dcl LIF_ITEMID         type UINT value('00000004'xu);
 dcl LIF_URL            type UINT value('00000008'xu);

 dcl LIS_FOCUSED        type UINT value('00000001'xu);
 dcl LIS_ENABLED        type UINT value('00000002'xu);
 dcl LIS_VISITED        type UINT value('00000004'xu);

 define structure
   1 LITEM,
     2 mask      type UINT,
     2 iLink     fixed bin (31),
     2 state     type UINT,
     2 stateMask type UINT,
     2 szID      WCHAR (MAX_LINKID_TEXT - 1) varz,
     2 szUrl     WCHAR (L_MAX_URL_LENGTH - 1) varz;
 define alias PLITEM handle LITEM;

 define structure
   1 LHITTESTINFO,
     2 pt   type POINT,
     2 item type LITEM;
 define alias PLHITTESTINFO handle LHITTESTINFO;

 define structure
   1 NMLINK unaligned,
     2 hdr  type NMHDR,
     2 item type LITEM;
 define alias PNMLINK handle NMLINK;

 /*  SysLink notifications                                            */
 /*  NM_CLICK   -- wParam: control ID, lParam: PNMLINK, ret: ignored. */

 /*  LinkWindow messages */
 dcl LM_HITTEST         fixed bin (31) value(WM_USER+'300'xn);
     /* wParam: n/a, lparam: PLHITTESTINFO, ret: BOOL */
 dcl LM_GETIDEALHEIGHT  fixed bin (31) value(WM_USER+'301'xn);
     /* wParam: n/a, lparam: n/a, ret: cy */
 dcl LM_SETITEM         fixed bin (31) value(WM_USER+'302'xn);
     /* wParam: n/a, lparam: LITEM*, ret: BOOL */
 dcl LM_GETITEM         fixed bin (31) value(WM_USER+'303'xn);
     /* wParam: n/a, lparam: LITEM*, ret: BOOL */

 %end;
 %end; /* _WIN32 */
 /* ====== End SysLink control ====================================== */

 /* === MUI APIs === */
 %dcl NOMUI char ext;
 %if NOMUI = '' %then %do;

 dcl InitMUILanguage
     entry (type LANGID)
     WINAPI external('InitMUILanguage');

 dcl GetMUILanguage
     entry ()
     returns (type LANGID byvalue)
     WINAPI external('GetMUILanguage');
 %end;  /* NOMUI */

 %end; /* _WIN32_IE >= 0x0400 */


 %if #WIN32 ^= '' %then %do;
 /* ====== TrackMouseEvent  ========================================= */

 %dcl NOTRACKMOUSEEVENT char ext;
 %if NOTRACKMOUSEEVENT = '' %then %do;

 /* If the messages for TrackMouseEvent have not been defined then */
 /* define them now.                                               */

 %dcl #WM_MOUSEHOVER char ext;
 %if #WM_MOUSEHOVER = '' %then %do;
 %#WM_MOUSEHOVER = 'Y';
 dcl WM_MOUSEHOVER fixed bin(31) value('02A1'xn);
 dcl WM_MOUSELEAVE fixed bin(31) value('02A3'xn);
 %end;

 /* If the TRACKMOUSEEVENT structure and associated flags havent been */
 /* declared then declare them now.                                   */
 %dcl #TME_HOVER char ext;
 %if #TME_HOVER = '' %then %do;
 %#TME_HOVER = 'Y';

 dcl TME_HOVER     type DWORD value('00000001'xu);
 dcl TME_LEAVE     type DWORD value('00000002'xu);
 %if WINVER >= 1280 %then %do;
 dcl TME_NONCLIENT type DWORD value('00000010'xu);
 %end; /* WINVER >= 0x0500 */
 dcl TME_QUERY     type DWORD value('40000000'xu);
 dcl TME_CANCEL    type DWORD value('80000000'xu);


 dcl HOVER_DEFAULT type DWORD value('FFFFFFFF'xu);

 define structure
   1 TRACKMOUSEEVENT,
     2 cbSize      type DWORD,
     2 dwFlags     type DWORD,
     2 hwndTrack   type HWND,
     2 dwHoverTime type DWORD;
 define alias LPTRACKMOUSEEVENT handle TRACKMOUSEEVENT;

 %end; /* !TME_HOVER */

 /* Declare _TrackMouseEvent. This API tries to use the window    */
 /* manager's implementation of TrackMouseEvent if it is present, */
 /* otherwise it emulates.                                        */

 dcl _TrackMouseEvent
     entry (type TRACKMOUSEEVENT byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('_TrackMouseEvent');

 %end; /* !NOTRACKMOUSEEVENT */


 %if #WIN32_IE >= 1024 %then %do;

 /* ====== Flat Scrollbar APIs===================================== */
 %dcl NOFLATSBAPIS char ext;
 %if NOFLATSBAPIS = '' %then %do;

 dcl WSB_PROP_CYVSCROLL type UINT value('00000001'xu);
 dcl WSB_PROP_CXHSCROLL type UINT value('00000002'xu);
 dcl WSB_PROP_CYHSCROLL type UINT value('00000004'xu);
 dcl WSB_PROP_CXVSCROLL type UINT value('00000008'xu);
 dcl WSB_PROP_CXHTHUMB  type UINT value('00000010'xu);
 dcl WSB_PROP_CYVTHUMB  type UINT value('00000020'xu);
 dcl WSB_PROP_VBKGCOLOR type UINT value('00000040'xu);
 dcl WSB_PROP_HBKGCOLOR type UINT value('00000080'xu);
 dcl WSB_PROP_VSTYLE    type UINT value('00000100'xu);
 dcl WSB_PROP_HSTYLE    type UINT value('00000200'xu);
 dcl WSB_PROP_WINSTYLE  type UINT value('00000400'xu);
 dcl WSB_PROP_PALETTE   type UINT value('00000800'xu);
 dcl WSB_PROP_MASK      type UINT value('00000FFF'xu);

 dcl FSB_FLAT_MODE      fixed bin(31) value(2);
 dcl FSB_ENCARTA_MODE   fixed bin(31) value(1);
 dcl FSB_REGULAR_MODE   fixed bin(31) value(0);

 dcl FlatSB_EnableScrollBar
     entry (type HWND,
            fixed bin(31),
            type UINT)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_EnableScrollBar');

 dcl FlatSB_ShowScrollBar
     entry (type HWND,
            fixed bin(31),
            type BOOL)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_ShowScrollBar');

 dcl FlatSB_GetScrollRange
     entry (type HWND,
            fixed bin(31),
            type INT byaddr,
            type INT byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_GetScrollRange');

 dcl FlatSB_GetScrollInfo
     entry (type HWND,
            fixed bin(31),
            type SCROLLINFO byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_GetScrollInfo');

 dcl FlatSB_GetScrollPos
     entry (type HWND,
            fixed bin(31))
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_GetScrollPos');

 dcl FlatSB_GetScrollProp
     entry (type HWND,
            fixed bin(31),
            type INT byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_GetScrollProp');

 %if #WIN64 ^= '' %then %do;
 dcl FlatSB_GetScrollPropPtr
     entry (type HWND,
            fixed bin(31),
            type INT_PTR byaddr)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_GetScrollPropPtr');
 %end; %else %do;
 %dcl FlatSB_GetScrollPropPtr char ext;
 %FlatSB_GetScrollPropPtr = 'FlatSB_GetScrollProp';
 %end;

 dcl FlatSB_SetScrollPos
     entry (type HWND,
            fixed bin(31),
            fixed bin(31),
            type BOOL)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_SetScrollPos');

 dcl FlatSB_SetScrollInfo
     entry (type HWND,
            fixed bin(31),
            type SCROLLINFO byaddr,
            type BOOL)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_SetScrollInfo');

 dcl FlatSB_SetScrollRange
     entry (type HWND,
            fixed bin(31),
            fixed bin(31),
            fixed bin(31),
            type BOOL)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_SetScrollRange');

 dcl FlatSB_SetScrollProp
     entry (type HWND,
            type UINT,
            fixed bin(31),
            type BOOL)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('FlatSB_SetScrollProp');
 %dcl FlatSB_SetScrollPropPtr char ext;
 %FlatSB_SetScrollPropPtr = 'FlatSB_SetScrollProp';

 dcl InitializeFlatSB
     entry (type HWND)
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI external('InitializeFlatSB');

 dcl UninitializeFlatSB
     entry (type HWND )
     returns (type HRESULT byvalue optional)
     WINCOMMCTRLAPI WINAPI external('UninitializeFlatSB');

 %end; /* NOFLATSBAPIS */

 %end; /* _WIN32_IE >= 0x0400 */

 %end; /* _WIN32 */

 %end; /* _WIN32_IE >= 0x0300 */

 %if #WIN32_WINNT >= 1281 %then %do;
 /* subclassing stuff */

 define alias SUBCLASSPROC
              entry (type HWND,
                     type UINT,
                     type WPARAM,
                     type LPARAM,
                     type UINT_PTR,
                     type DWORD_PTR)
              returns (type LRESULT byvalue optional)
              limited CALLBACK;


 dcl SetWindowSubclass
     entry (type HWND,
            type SUBCLASSPROC,
            type UINT_PTR,
            type DWORD_PTR)
     returns (type BOOL byvalue optional)
     WINAPI external('SetWindowSubclass');

 dcl GetWindowSubclass
     entry (type HWND,
            type SUBCLASSPROC,
            type UINT_PTR,
            type DWORD_PTR byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('GetWindowSubclass');

 dcl RemoveWindowSubclass
     entry (type HWND,
            type SUBCLASSPROC,
            type UINT_PTR)
     returns (type BOOL byvalue optional)
     WINAPI external('RemoveWindowSubclass');

 dcl DefSubclassProc
      entry (type HWND,
             type UINT,
             type WPARAM,
             type LPARAM)
      returns (type LRESULT byvalue optional)
     WINAPI external('DefSubclassProc');
 %end;


 %if #WIN32_WINNT >= 1281 %then %do;

 dcl DrawShadowText
     entry (type HDC,
            WCHAR(*) varz byaddr nonasgn,
            type UINT,
            type RECT byaddr nonasgn,
            type DWORD,
            type COLORREF,
            type COLORREF,
            fixed bin (31),
            fixed bin (31))
     returns (fixed bin (31) byvalue optional)
     WINAPI external('DrawShadowText');

 %end;

 %end;

 %end; /* _INC_COMMCTRL */
