 /*++ BUILD Version: 0094 Increment this if a change has global       */
 /*   effects                                                         */
 /*                                                                   */
 /* Copyright (c) 1990-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*    winnt.cpy                                                      */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /* This module defines the 32-Bit Windows types and constants that   */
 /* are defined by NT, but exposed through the Win32 API.             */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* PL/I note: There has been a certain amount of declaration         */
 /* reordering. This is because under PL/I a TYPE or a VALUE must be  */
 /* declared before it can be referenced                              */
 /*                                                                   */
 /*--                                                                 */

 %dcl #WINNT_ char ext;
 %if #WINNT_ = '' %then %do;
 %#WINNT_ = 'Y';

 %dcl #WIN64  char ext;
 %dcl UNICODE char ext;

 dcl ANYSIZE_ARRAY fixed bin(31) value(16383); /* got a better idea?  */
 %dcl RESTRICTED_POINTER char ext;
 %RESTRICTED_POINTER = '';

 %if #WIN64 ^= '' %then %do;
 dcl MAX_NATURAL_ALIGNMENT fixed bin (31) value (size(: ULONGLONG :));
 %end; %else %do;
 dcl MAX_NATURAL_ALIGNMENT fixed bin (31) value (size(: DWORD :));
 %end;

 %dcl #BASETSD_H_ char ext;
 %if #BASETSD_H_ = '' %then %do;
 %include basetsd; /* also defines pointer64 */
 %end;

 define alias POINTER_64     pointer64;
 define alias POINTER_64_INT fixed bin(63);

 define alias PVOID   pointer;
 define alias PVOID64 pointer64;

 %dcl NTAPI char ext;
 %NTAPI = 'options (byvalue nodescriptor linkage(stdcall))';

 %dcl NTSYSAPI char ext;
 %NTSYSAPI = '';
 %dcl NTSYSCALLAPI char ext;
 %NTSYSCALLAPI = '';

 /* Basics */

 %dcl #VOID_DEFINED char ext;
 %if #VOID_DEFINED = '' %then %do;
 %#VOID_DEFINED = 'Y';
   define alias VOID  pointer;
   define alias SHORT fixed bin(15);
   define alias LONG  fixed bin(31);
 %end;

 %dcl #WCHAR_DEFINED char ext;
 %#WCHAR_DEFINED = 'Y';
 /* UNICODE (Wide Character) types */

 /* %dcl WCHAR char;     */
 /* %WCHAR = 'WIDECHAR'; */

 define alias PWCHAR  pointer;
 define alias LPWCH   pointer;
 define alias PWCH    pointer;
 define alias LPCWCH  pointer;
 define alias PCWCH   pointer;
 define alias NWPSTR  pointer;
 define alias LPWSTR  pointer;
 define alias PWSTR   pointer;
 define alias LPCWSTR pointer;
 define alias PCWSTR  pointer;

 /* ANSI (Multi-byte Character) types */

 define alias PCHAR  pointer;
 define alias LPCH   pointer;
 define alias PCH    pointer;

 define alias LPCCH  pointer;
 define alias PCCH   pointer;
 define alias NPSTR  pointer;
 define alias LPSTR  pointer;
 define alias PSTR   pointer;
 define alias LPCSTR pointer;
 define alias PCSTR  pointer;

 /* Neutral ANSI/UNICODE types and macros */

 %if UNICODE ^= '' %then %do;

 %dcl #TCHAR_DEFINED char ext;
 %if #TCHAR_DEFINED = '' %then %do;
 %dcl TCHAR char ext; %TCHAR = 'WIDECHAR';
 %dcl TSTR  char ext; %TSTR  = 'WIDECHAR (*) varz';
 define alias PTCHAR pointer;
 define alias TBYTE  WCHAR;
 define alias PTBYTE pointer;
 %#TCHAR_DEFINED = 'Y';
 %end; /* ! #TCHAR_DEFINED */

 define alias LPTCH   type LPWSTR;
 define alias PTCH    type LPWSTR;
 define alias PTSTR   type LPWSTR;
 define alias LPTSTR  type LPWSTR;
 define alias LPCTSTR type LPCWSTR;
 /* define alias LP   type LPWSTR */

 %end; %else %do;

 %dcl #TCHAR_DEFINED char ext;
 %if #TCHAR_DEFINED = '' %then %do;
 %dcl TCHAR char ext; %TCHAR = 'char';
 %dcl TSTR  char ext; %TSTR  = 'char (*) varz';
 define alias PTCHAR pointer;
 define alias TBYTE  char;
 define alias PTBYTE pointer;

 %#TCHAR_DEFINED = 'Y';
 %end; /* !_TCHAR_DEFINED */

 define alias LPTCH   type LPSTR;
 define alias PTCH    type LPSTR;
 define alias PTSTR   type LPSTR;
 define alias LPTSTR  type LPSTR;
 define alias LPCTSTR type LPCSTR;
 %end; /* UNICODE */

 %#_TEXT:PROC (quot) returns (char);
   dcl quot char;
   if UNICODE ^= '' then
     return (quot); /* PL/I will convert */
   else
     return (quot);
 %end #_TEXT;
 %dcl #_TEXT entry; /* name clash with TEXT as variable!!! */


 define alias PSHORT pointer;
 define alias PLONG  pointer;

 define alias HANDLE pointer;

 %dcl DECLARE_HANDLE ENTRY;
 %DECLARE_HANDLE: proc (name) statement returns (char);
   dcl name char;
   return ('define alias '|| name ||' pointer;');
 %end DECLARE_HANDLE;

 define alias PHANDLE pointer;


 /* Flag (bit) fields */

 define alias FCHAR  type BYTE;
 define alias FSHORT type WORD;
 define alias FLONG  type DWORD;

 /* Component Object Model defines, and macros */
 %dcl #HRESULT_DEFINED char ext;
 %if #HRESULT_DEFINED = '' %then %do;
 %#HRESULT_DEFINED = 'Y';
 define alias HRESULT type LONG;
 %end; /* !_HRESULT_DEFINED */

 %dcl STDMETHODCALLTYPE char ext;
 %STDMETHODCALLTYPE = 'options (byvalue nodescriptor linkage(stdcall))';
 %dcl STDMETHODVCALLTYPE char ext;
 %STDMETHODVCALLTYPE = 'options (byvalue nodescriptor linkage(cdecl))';

 %dcl STDAPICALLTYPE char ext;
 %STDAPICALLTYPE  = 'options (byvalue nodescriptor linkage(stdcall))';
 %dcl STDAPIVCALLTYPE char ext;
 %STDAPIVCALLTYPE = 'options (byvalue nodescriptor linkage(cdecl))';

 %dcl STDAPI char ext;
 %STDAPI = 'returns (type HRESULT byvalue optional) ' ||
           STDAPICALLTYPE;
 %dcl STDAPI_ entry;
 %STDAPI_: proc (type) returns (char);
   dcl type char;
   if type = '' then
     return (STDAPICALLTYPE);
   else
     return ('returns (' || type || ' byvalue optional) ' ||
             STDAPICALLTYPE);
 %end STDAPI_;

 %dcl STDMETHODIMP char ext;
 %STDMETHODIMP = 'returns (type HRESULT byvalue optional) ' ||
                 STDMETHODCALLTYPE;
 %dcl STDMETHODIMP_ entry;
 %STDMETHODIMP_: proc (type) returns (char);
   dcl type char;
   if type = '' then
     return (STDMETHODCALLTYPE);
   else
     return ('returns (' || type || ' byvalue optional) ' ||
             STDMETHODCALLTYPE);
 %end STDMETHODIMP_;

 /* The 'V' versions allow Variable Argument lists. */

 %dcl STDAPIV char ext;
 %STDAPIV = 'returns (type HRESULT byvalue optional) ' ||
            STDAPIVCALLTYPE;
 %dcl STDAPIV_ entry;
 %STDAPIV_: proc (type) returns (char);
   dcl type char;
   if type = '' then
     return (STDAPIVCALLTYPE);
   else
     return ('returns (' || type || ' byvalue optional) ' ||
             STDAPIVCALLTYPE);
 %end STDAPIV_;

 %dcl STDMETHODIMPV char ext;
 %STDMETHODIMPV = 'returns (type HRESULT byvalue optional) ' ||
                  STDMETHODVCALLTYPE;
 %dcl STDMETHODIMPV_ entry;
 %STDMETHODIMPV_: proc (type) returns (char);
   dcl type char;
   if type = '' then
     return (STDMETHODVCALLTYPE);
   else
     return ('returns (' || type || ' byvalue optional) ' ||
             STDMETHODVCALLTYPE);
 %end STDMETHODIMPV_;


 define alias CCHAR  char;
 %dcl #LCID_DEFINED char ext;
 %if #LCID_DEFINED = '' %then %do;
 %#LCID_DEFINED = 'Y';
 define alias  LCID  type DWORD;
 %end; /* !_LCID_DEFINED */
 define alias PLCID  type PDWORD;
 %dcl #LANGID_DEFINED char ext;
 %if #LANGID_DEFINED = '' %then %do;
 %#LANGID_DEFINED = 'Y';
 define alias LANGID type WORD;
 %end; /* !_LANGID_DEFINED */

 dcl APPLICATION_ERROR_MASK       fixed bin(31) value('20000000'xn);
 dcl ERROR_SEVERITY_SUCCESS       fixed bin(31) value('00000000'xn);
 dcl ERROR_SEVERITY_INFORMATIONAL fixed bin(31) value('40000000'xn);
 dcl ERROR_SEVERITY_WARNING       fixed bin(31) value('80000000'xn);
 dcl ERROR_SEVERITY_ERROR         fixed bin(31) value('C0000000'xn);

 define structure
   1 FLOAT128,
     2 LowPart  fixed bin (63),
     2 HighPart fixed bin (63);

 define alias PFLOAT128 handle FLOAT128;


 %dcl #DWORDLONG_ char ext;
 %dcl #ULONGLONG_ char ext;
 %if #DWORDLONG_ = '' %then %do;
 %#DWORDLONG_ = 'Y';
 %#ULONGLONG_ = 'Y';

 define alias LONGLONG   fixed bin (63);
 define alias ULONGLONG  unsigned fixed bin (64);
 dcl MAXLONGLONG type LONGLONG value ('7fffffffffffffff'xn);
 define alias DWORDLONG  unsigned fixed bin (64);
 define alias PLONGLONG  pointer;
 define alias PULONGLONG pointer;
 define alias PDWORDLONG pointer;
 %end;

 /* Update Sequence Number */
 define alias USN type LONGLONG;

 define structure
   1 LARGE_INTEGER union,
     2 u,
       3 LowPart  type DWORD,
       3 HighPart type LONG,
     2 QuadPart   type LONGLONG;

 define alias PLARGE_INTEGER handle LARGE_INTEGER;

 define structure
   1 ULARGE_INTEGER union,
     2 u,
       3 LowPart  type DWORD,
       3 HighPart type DWORD,
     2 QuadPart   type DWORDLONG;

 define alias PULARGE_INTEGER handle ULARGE_INTEGER;


 /* Locally Unique Identifier */

 define structure
   1 LUID,
     2 LowPart  type DWORD,
     2 HighPart type DWORD;

 define alias PLUID handle LUID;

 /* The 64-bit multiply, divide and logical shift operations */
 /* are part of the native PL/I 64-bit integer support.      */

 dcl ANSI_NULL    char(1)  value('00'x);
 dcl UNICODE_NULL WCHAR(1) value('0000'WX);
 define alias  BOOLEAN type BYTE;
 define alias PBOOLEAN pointer;

 /* Doubly linked list structure.  Can be used as either a list head, */
 /* or as link words.                                                 */

 define structure
   1 LIST_ENTRY,
     2 Flink handle LIST_ENTRY,
     2 Blink handle LIST_ENTRY;

 define alias  PLIST_ENTRY handle LIST_ENTRY;
 define alias PRLIST_ENTRY handle LIST_ENTRY;

 /* Singly linked list structure. Can be used as either a list head */
 /* or as link words.                                               */

 define structure
   1 SINGLE_LIST_ENTRY,
     2 Next handle SINGLE_LIST_ENTRY;

 define alias PSINGLE_LIST_ENTRY handle SINGLE_LIST_ENTRY;

 /* Base data structures for OLE support */

 %dcl GUID_DEFINED char ext;
 %if GUID_DEFINED = '' %then %do;
 %GUID_DEFINED = 'Y';

 define structure
   1 GUID,   /* size is 16 */
     2 Data1 type DWORD,
     2 Data2 type WORD,
     2 Data3 type WORD,
     2 Data4 (8) char;

 %end; /* !GUID_DEFINED */

 %dcl #_OBJECTID_DEFINED char ext;
 %if #_OBJECTID_DEFINED = '' %then %do;
 %#_OBJECTID_DEFINED = 'Y';

 define structure
   1 OBJECTID,   /* size is 20 */
    2 Lineage    type GUID,
    2 Uniquifier type DWORD;

 %end; /* !_OBJECTID_DEFINED */

 dcl MINCHAR  fixed bin(7)  value(-128);     /* '80'xn */
 dcl MAXCHAR  fixed bin(7)  value('7f'xn);
 dcl MINSHORT fixed bin(15) value(-32768);   /* '8000'xn */
 dcl MAXSHORT fixed bin(15) value('7fff'xn);
 dcl MINLONG  fixed bin(31) value('80000000'xn);
 dcl MAXLONG  fixed bin(31) value('7fffffff'xn);
 dcl MAXBYTE  fixed bin(8)  unsigned value('ff'xu);
 dcl MAXWORD  fixed bin(16) unsigned value('ffff'xu);
 dcl MAXDWORD fixed bin(32) unsigned value('ffffffff'xu);


 /* Calculate the byte offset of a field in a structure */
 /* of type type.                                       */
 %FIELD_OFFSET: proc (type, field) returns (char);
   dcl (type, field) char;
   return ('location (bind (: ' || type || ', sysnull() :) => ' ||
                      field || ')');
 %end FIELD_OFFSET;
 %dcl FIELD_OFFSET entry;

 /* Calculate the address of the base of the structure given  */
 /* its type, and an address of a field within the structure. */

 %CONTAINING_RECORD: proc (address, type, field) returns (char);
   dcl (address, type, field) char;
   return ('bind (:' || type || ', (' || address || ') - ' ||
           'location (bind (: ' || type || ', sysnull() :) => ' ||
                      field || ') :)');
 %end CONTAINING_RECORD;
 %dcl CONTAINING_RECORD entry;


 dcl VER_SERVER_NT                      type DWORD value('80000000'xu);
 dcl VER_WORKSTATION_NT                 type DWORD value('40000000'xu);
 dcl VER_SUITE_SMALLBUSINESS            type DWORD value('00000001'xu);
 dcl VER_SUITE_ENTERPRISE               type DWORD value('00000002'xu);
 dcl VER_SUITE_BACKOFFICE               type DWORD value('00000004'xu);
 dcl VER_SUITE_COMMUNICATIONS           type DWORD value('00000008'xu);
 dcl VER_SUITE_TERMINAL                 type DWORD value('00000010'xu);
 dcl VER_SUITE_SMALLBUSINESS_RESTRICTED type DWORD value('00000020'xu);
 dcl VER_SUITE_EMBEDDEDNT               type DWORD value('00000040'xu);
 dcl VER_SUITE_DATACENTER               type DWORD value('00000080'xu);
 dcl VER_SUITE_SINGLEUSERTS             type DWORD value('00000100'xu);
 dcl VER_SUITE_PERSONAL                 type DWORD value('00000200'xu);
 dcl VER_SUITE_BLADE                    type DWORD value('00000400'xu);


 /*  Language IDs.                                                    */
 /*                                                                   */
 /*  The following two combinations of primary language ID and        */
 /*  sublanguage ID have special semantics:                           */
 /*                                                                   */
 /* Primary Language ID  Sublanguage ID      Result                   */
 /* -------------------  ---------------     ------------------------ */
 /* LANG_NEUTRAL         SUBLANG_NEUTRAL     Language neutral         */
 /* LANG_NEUTRAL         SUBLANG_DEFAULT     User default language    */
 /* LANG_NEUTRAL         SUBLANG_SYS_DEFAULT System default language  */


 /*  Primary language IDs.  */
 dcl LANG_NEUTRAL    fixed bin(16) unsigned value('00'xu);
 dcl LANG_INVARIANT  fixed bin(16) unsigned value('7f'xu);

 dcl LANG_AFRIKAANS  fixed bin(16) unsigned value('36'xu);
 dcl LANG_ALBANIAN   fixed bin(16) unsigned value('1c'xu);
 dcl LANG_ARABIC     fixed bin(16) unsigned value('01'xu);
 dcl LANG_ARMENIAN   fixed bin(16) unsigned value('2b'xu);
 dcl LANG_ASSAMESE   fixed bin(16) unsigned value('4d'xu);
 dcl LANG_AZERI      fixed bin(16) unsigned value('2c'xu);
 dcl LANG_BASQUE     fixed bin(16) unsigned value('2d'xu);
 dcl LANG_BELARUSIAN fixed bin(16) unsigned value('23'xu);
 dcl LANG_BENGALI    fixed bin(16) unsigned value('45'xu);
 dcl LANG_BULGARIAN  fixed bin(16) unsigned value('02'xu);
 dcl LANG_CATALAN    fixed bin(16) unsigned value('03'xu);
 dcl LANG_CHINESE    fixed bin(16) unsigned value('04'xu);
 dcl LANG_CROATIAN   fixed bin(16) unsigned value('1a'xu);
 dcl LANG_CZECH      fixed bin(16) unsigned value('05'xu);
 dcl LANG_DANISH     fixed bin(16) unsigned value('06'xu);
 dcl LANG_DUTCH      fixed bin(16) unsigned value('13'xu);
 dcl LANG_ENGLISH    fixed bin(16) unsigned value('09'xu);
 dcl LANG_ESTONIAN   fixed bin(16) unsigned value('25'xu);
 dcl LANG_FAEROESE   fixed bin(16) unsigned value('38'xu);
 dcl LANG_FARSI      fixed bin(16) unsigned value('29'xu);
 dcl LANG_FINNISH    fixed bin(16) unsigned value('0b'xu);
 dcl LANG_FRENCH     fixed bin(16) unsigned value('0c'xu);
 dcl LANG_GEORGIAN   fixed bin(16) unsigned value('37'xu);
 dcl LANG_GERMAN     fixed bin(16) unsigned value('07'xu);
 dcl LANG_GREEK      fixed bin(16) unsigned value('08'xu);
 dcl LANG_GUJARATI   fixed bin(16) unsigned value('47'xu);
 dcl LANG_HEBREW     fixed bin(16) unsigned value('0D'xu);
 dcl LANG_HINDI      fixed bin(16) unsigned value('39'xu);
 dcl LANG_HUNGARIAN  fixed bin(16) unsigned value('0e'xu);
 dcl LANG_ICELANDIC  fixed bin(16) unsigned value('0f'xu);
 dcl LANG_INDONESIAN fixed bin(16) unsigned value('21'xu);
 dcl LANG_ITALIAN    fixed bin(16) unsigned value('10'xu);
 dcl LANG_JAPANESE   fixed bin(16) unsigned value('11'xu);
 dcl LANG_KANNADA    fixed bin(16) unsigned value('4b'xu);
 dcl LANG_KASHMIRI   fixed bin(16) unsigned value('60'xu);
 dcl LANG_KAZAK      fixed bin(16) unsigned value('3f'xu);
 dcl LANG_KONKANI    fixed bin(16) unsigned value('57'xu);
 dcl LANG_KOREAN     fixed bin(16) unsigned value('12'xu);
 dcl LANG_LATVIAN    fixed bin(16) unsigned value('26'xu);
 dcl LANG_LITHUANIAN fixed bin(16) unsigned value('27'xu);
 dcl LANG_MACEDONIAN fixed bin(16) unsigned value('2f'xu);
 dcl LANG_MALAY      fixed bin(16) unsigned value('3e'xu);
 dcl LANG_MALAYALAM  fixed bin(16) unsigned value('4c'xu);
 dcl LANG_MANIPURI   fixed bin(16) unsigned value('58'xu);
 dcl LANG_MARATHI    fixed bin(16) unsigned value('4e'xu);
 dcl LANG_NEPALI     fixed bin(16) unsigned value('61'xu);
 dcl LANG_NORWEGIAN  fixed bin(16) unsigned value('14'xu);
 dcl LANG_ORIYA      fixed bin(16) unsigned value('48'xu);
 dcl LANG_POLISH     fixed bin(16) unsigned value('15'xu);
 dcl LANG_PORTUGUESE fixed bin(16) unsigned value('16'xu);
 dcl LANG_PUNJABI    fixed bin(16) unsigned value('46'xu);
 dcl LANG_ROMANIAN   fixed bin(16) unsigned value('18'xu);
 dcl LANG_RUSSIAN    fixed bin(16) unsigned value('19'xu);
 dcl LANG_SANSKRIT   fixed bin(16) unsigned value('4f'xu);
 dcl LANG_SERBIAN    fixed bin(16) unsigned value('1a'xu);
 dcl LANG_SINDHI     fixed bin(16) unsigned value('59'xu);
 dcl LANG_SLOVAK     fixed bin(16) unsigned value('1b'xu);
 dcl LANG_SLOVENIAN  fixed bin(16) unsigned value('24'xu);
 dcl LANG_SPANISH    fixed bin(16) unsigned value('0a'xu);
 dcl LANG_SWAHILI    fixed bin(16) unsigned value('41'xu);
 dcl LANG_SWEDISH    fixed bin(16) unsigned value('1d'xu);
 dcl LANG_TAMIL      fixed bin(16) unsigned value('49'xu);
 dcl LANG_TATAR      fixed bin(16) unsigned value('44'xu);
 dcl LANG_TELUGU     fixed bin(16) unsigned value('4a'xu);
 dcl LANG_THAI       fixed bin(16) unsigned value('1e'xu);
 dcl LANG_TURKISH    fixed bin(16) unsigned value('1f'xu);
 dcl LANG_UKRAINIAN  fixed bin(16) unsigned value('22'xu);
 dcl LANG_URDU       fixed bin(16) unsigned value('20'xu);
 dcl LANG_UZBEK      fixed bin(16) unsigned value('43'xu);
 dcl LANG_VIETNAMESE fixed bin(16) unsigned value('2a'xu);


 /*  Sublanguage IDs.                                                 */
 /*                                                                   */
 /*  The name immediately following SUBLANG_ dictates which primary   */
 /*  language ID that sublanguage ID can be combined with to form a   */
 /*  valid language ID.                                               */

 dcl ( SUBLANG_NEUTRAL        value('00'xu) /* language neutral       */
     , SUBLANG_DEFAULT        value('01'xu) /* user default           */
     , SUBLANG_SYS_DEFAULT    value('02'xu) /* system default         */

     , SUBLANG_ARABIC         value('01'xu) /* Arabic (Saudi Arabia)  */
     , SUBLANG_ARABIC_IRAQ    value('02'xu) /* Arabic (Iraq)          */
     , SUBLANG_ARABIC_EGYPT   value('03'xu) /* Arabic (Egypt)         */
     , SUBLANG_ARABIC_LIBYA   value('04'xu) /* Arabic (Libya)         */
     , SUBLANG_ARABIC_ALGERIA value('05'xu) /* Arabic (Algeria)       */
     , SUBLANG_ARABIC_MOROCCO value('06'xu) /* Arabic (Morocco)       */
     , SUBLANG_ARABIC_TUNISIA value('07'xu) /* Arabic (Tunisia)       */
     , SUBLANG_ARABIC_OMAN    value('08'xu) /* Arabic (Oman)          */
     , SUBLANG_ARABIC_YEMEN   value('09'xu) /* Arabic (Yemen)         */
     , SUBLANG_ARABIC_SYRIA   value('0a'xu) /* Arabic (Syria)         */
     , SUBLANG_ARABIC_JORDAN  value('0b'xu) /* Arabic (Jordan)        */
     , SUBLANG_ARABIC_LEBANON value('0c'xu) /* Arabic (Lebanon)       */
     , SUBLANG_ARABIC_KUWAIT  value('0d'xu) /* Arabic (Kuwait)        */
     , SUBLANG_ARABIC_UAE     value('0e'xu)
                                     /* Arabic (United Arab Emirates) */
     , SUBLANG_ARABIC_BAHRAIN value('0f'xu) /* Arabic (Bahrain)       */
     , SUBLANG_ARABIC_QATAR   value('10'xu) /* Arabic (Qatar)         */

     , SUBLANG_AZERI_LATIN    value('01'xu) /* Azeri (Latin)          */
     , SUBLANG_AZERI_CYRILLIC value('02'xu) /* Azeri (Cyrillic)       */
     , SUBLANG_CHINESE_TRADITIONAL value('01'xu) /* Chinese (Taiwan)  */
     , SUBLANG_CHINESE_SIMPLIFIED value('02'xu) /* Chinese (PR China) */
     , SUBLANG_CHINESE_HONGKONG  value('03'xu) /* Chinese (Hong Kong) */
     , SUBLANG_CHINESE_SINGAPORE value('04'xu) /* Chinese (Singapore) */
     , SUBLANG_CHINESE_MACAU     value('05'xu) /* Chinese (Macau)     */

     , SUBLANG_DUTCH           value('01'xu) /* Dutch */
     , SUBLANG_DUTCH_BELGIAN   value('02'xu) /* Dutch (Belgian)       */

     , SUBLANG_ENGLISH_US      value('01'xu) /* English (USA)         */
     , SUBLANG_ENGLISH_UK      value('02'xu) /* English (UK)          */
     , SUBLANG_ENGLISH_AUS     value('03'xu) /* English (Australian)  */
     , SUBLANG_ENGLISH_CAN     value('04'xu) /* English (Canadian)    */
     , SUBLANG_ENGLISH_NZ      value('05'xu) /* English (New Zealand) */
     , SUBLANG_ENGLISH_EIRE    value('06'xu) /* English (Irish)       */
     , SUBLANG_ENGLISH_SAFRICA value('07'xu) /* English (South Africa)*/
     , SUBLANG_ENGLISH_JAMAICA   value('08'xu) /* English (Jamaica)   */
     , SUBLANG_ENGLISH_CARRIBEAN value('09'xu) /* English (Carribean) */
     , SUBLANG_ENGLISH_BELIZE    value('0a'xu) /* English (Belize)    */
     , SUBLANG_ENGLISH_TRINIDAD  value('0b'xu) /* English (Trinidad)  */
     , SUBLANG_ENGLISH_ZIMBABWE  value('0c'xu) /* English (Zimbabwe)  */
     , SUBLANG_ENGLISH_PHILIPPINES value('0d'xu)
                                             /* English (Philippines) */

     , SUBLANG_FRENCH            value('01'xu) /* French              */
     , SUBLANG_FRENCH_BELGIAN    value('02'xu) /* French (Belgian)    */
     , SUBLANG_FRENCH_CANADIAN   value('03'xu) /* French (Canadian)   */
     , SUBLANG_FRENCH_SWISS      value('04'xu) /* French (Swiss)      */
     , SUBLANG_FRENCH_LUXEMBOURG value('05'xu) /* French (Luxembourg) */
     , SUBLANG_FRENCH_MONACO     value('06'xu) /* French (Monaco)     */

     , SUBLANG_GERMAN            value('01'xu) /* German              */
     , SUBLANG_GERMAN_SWISS      value('02'xu) /* German (Swiss)      */
     , SUBLANG_GERMAN_AUSTRIAN   value('03'xu) /* German (Austrian)   */
     , SUBLANG_GERMAN_LUXEMBOURG value('04'xu) /* German (Luxembourg) */
     , SUBLANG_GERMAN_LIECHTENSTEIN value('05'xu)
                                            /* German (Liechtenstein) */

     , SUBLANG_ITALIAN       value('01'xu)  /* Italian                */
     , SUBLANG_ITALIAN_SWISS value('02'xu)  /* Italian (Swiss)        */

     , SUBLANG_KASHMIRI_SASIA value('02'xu) /* Kashmiri (South Asia)  */
     , SUBLANG_KASHMIRI_INDIA value('02'xu) /* For compatibility only */

     , SUBLANG_KOREAN        value('01'xu) /*Korean (Extended Wansung)*/
     , SUBLANG_KOREAN_JOHAB  value('02'xu) /* Korean (Johab)          */

     , SUBLANG_LITHUANIAN         value('01'xu) /* Lithuanian         */
     , SUBLANG_LITHUANIAN_CLASSIC value('02'xu) /*Lithuanian (Classic)*/

     , SUBLANG_MALAY_MALAYSIA     value('01'xu) /* Malay (Malaysia)   */
     , SUBLANG_MALAY_BRUNEI_DARUSSALAM value('02'xu)
                                         /* Malay (Brunei Darussalam) */

     , SUBLANG_NEPALI_INDIA      value('02'xu) /* Nepali (India)      */

     , SUBLANG_NORWEGIAN_BOKMAL  value('01'xu) /* Norwegian (Bokmal)  */
     , SUBLANG_NORWEGIAN_NYNORSK value('02'xu) /* Norwegian (Nynorsk) */

     , SUBLANG_PORTUGUESE            value('02'xu) /* Portuguese      */
     , SUBLANG_PORTUGUESE_BRAZILIAN  value('01'xu)
                                     /* Portuguese (Brazilian) */

     , SUBLANG_SERBIAN_LATIN     value('02'xu) /* Serbian (Latin)     */
     , SUBLANG_SERBIAN_CYRILLIC  value('03'xu) /* Serbian (Cyrillic)  */

     , SUBLANG_SPANISH           value('01'xu) /* Spanish (Castilian) */
     , SUBLANG_SPANISH_MEXICAN   value('02'xu) /* Spanish (Mexican)   */
     , SUBLANG_SPANISH_MODERN    value('03'xu) /* Spanish (Modern)    */
     , SUBLANG_SPANISH_GUATEMALA value('04'xu) /* Spanish (Guatemala) */
     , SUBLANG_SPANISH_COSTARICA value('05'xu) /* Spanish (Costa Rica)*/
     , SUBLANG_SPANISH_PANAMA    value('06'xu) /* Spanish (Panama)    */
     , SUBLANG_SPANISH_DOMINICAN_REPUBLIC value('07'xu)
                                 /* Spanish (Dominican Republic) */
     , SUBLANG_SPANISH_VENEZUELA value('08'xu) /* Spanish (Venezuela) */
     , SUBLANG_SPANISH_COLOMBIA  value('09'xu) /* Spanish (Colombia)  */
     , SUBLANG_SPANISH_PERU      value('0a'xu) /* Spanish (Peru)      */
     , SUBLANG_SPANISH_ARGENTINA value('0b'xu) /* Spanish (Argentina) */
     , SUBLANG_SPANISH_ECUADOR   value('0c'xu) /* Spanish (Ecuador)   */
     , SUBLANG_SPANISH_CHILE     value('0d'xu) /* Spanish (Chile)     */
     , SUBLANG_SPANISH_URUGUAY   value('0e'xu) /* Spanish (Uruguay)   */
     , SUBLANG_SPANISH_PARAGUAY  value('0f'xu) /* Spanish (Paraguay)  */
     , SUBLANG_SPANISH_BOLIVIA   value('10'xu) /* Spanish (Bolivia)   */
     , SUBLANG_SPANISH_EL_SALVADOR value('11'xu)
                                 /* Spanish (El Salvador) */
     , SUBLANG_SPANISH_HONDURAS  value('12'xu) /* Spanish (Honduras)  */
     , SUBLANG_SPANISH_NICARAGUA value('13'xu) /* Spanish (Nicaragua) */
     , SUBLANG_SPANISH_PUERTO_RICO value('14'xu)
                                 /* Spanish (Puerto Rico) */

     , SUBLANG_SWEDISH             value('01'xu) /* Swedish           */
     , SUBLANG_SWEDISH_FINLAND     value('02'xu) /* Swedish (Finland) */

     , SUBLANG_URDU_PAKISTAN       value('01'xu) /* Urdu (Pakistan)   */
     , SUBLANG_URDU_INDIA          value('02'xu) /* Urdu (India)      */

     , SUBLANG_UZBEK_LATIN         value('01'xu) /* Uzbek (Latin)     */
     , SUBLANG_UZBEK_CYRILLIC      value('02'xu) /* Uzbek (Cyrillic)  */
     ) fixed bin (8) unsigned;


 /*  Sorting IDs. */

 dcl ( SORT_DEFAULT           value('0'xu) /* sorting default */

     , SORT_JAPANESE_XJIS     value('0'xu) /* Japanese XJIS order */
     , SORT_JAPANESE_UNICODE  value('1'xu) /* Japanese Unicode order */

     , SORT_CHINESE_BIG5      value('0'xu) /* Chinese BIG5 order */
     , SORT_CHINESE_PRCP      value('0'xu)
                              /* PRC Chinese Phonetic order */
     , SORT_CHINESE_UNICODE   value('1'xu) /* Chinese Unicode order */
     , SORT_CHINESE_PRC       value('2'xu)
                              /* PRC Chinese Stroke Count order*/
     , SORT_CHINESE_BOPOMOFO  value('3'xu)
                              /* Traditional Chinese Bopomofo order */

     , SORT_KOREAN_KSC        value('0'xu) /* Korean KSC order */
     , SORT_KOREAN_UNICODE    value('1'xu) /* Korean Unicode order */

     , SORT_GERMAN_PHONE_BOOK value('1'xu) /* German Phone Book order */

     , SORT_HUNGARIAN_DEFAULT    value('0'xu)
                                 /* Hungarian Default order */
     , SORT_HUNGARIAN_TECHNICAL  value('1'xu)
                                 /* Hungarian Technical order */

     , SORT_GEORGIAN_TRADITIONAL value('0'xu)
                                 /* Georgian Traditional order */
     , SORT_GEORGIAN_MODERN      value('1'xu)
                                 /* Georgian Modern order */
     ) fixed bin (8) unsigned;


 /*  A language ID is a 16 bit value which is the combination of a    */
 /*  primary language ID and a secondary language ID.  The bits are   */
 /*  allocated as follows:                                            */
 /*                                                                   */
 /*       +-----------------------+-------------------------+         */
 /*       |     Sublanguage ID    |   Primary Language ID   |         */
 /*       +-----------------------+-------------------------+         */
 /*        15                   10 9                       0   bit    */
 /*                                                                   */
 /*                                                                   */
 /*  Language ID creation/extraction macros:                          */
 /*                                                                   */
 /* MAKELANGID    - construct language id from a primary language id  */
 /*                 and a sublanguage id.                             */
 /* PRIMARYLANGID - extract primary language id from a language id.   */
 /* SUBLANGID     - extract sublanguage id from a language id.        */


 %MAKELANGID: proc (p, s) returns (char);
   dcl (p, s) char;
   return ('ior (isll (cast (: WORD, ' || s || ' :), 10), ' ||
           'cast (: WORD, ' || p || ' :))');
 %end MAKELANGID;
 %dcl MAKELANGID entry;  /* must be macro as needed in value */

 PRIMARYLANGID: proc (lgid) returns (fixed bin(16) unsigned)
                options (inline reorder) internal;
   dcl lgid type LANGID;
   return (iand (lgid, '3ff'xu));
 end PRIMARYLANGID;

 SUBLANGID: proc (lgid) returns (fixed bin (8) unsigned)
            options (inline reorder) internal;
   dcl lgid type LANGID;
   return (isrl (lgid, 10));
 end SUBLANGID;


 /*  A locale ID is a 32 bit value which is the combination of a      */
 /*  language ID, a sort ID, and a reserved area.  The bits are       */
 /*  allocated as follows:                                            */
 /*                                                                   */
 /*         +-------------+---------+-------------------------+       */
 /*         |   Reserved  | Sort ID |      Language ID        |       */
 /*         +-------------+---------+-------------------------+       */
 /*          31         20 19     16 15                      0   bit  */
 /*                                                                   */
 /*                                                                   */
 /*  Locale ID creation/extraction macros:                            */
 /*                                                                   */
 /*  MAKELCID            - construct locale id from a language id and */
 /*                        a sort id.                                 */
 /*  MAKESORTLCID        - construct locale id from a language id,    */
 /*                        sort id, and sort version.                 */
 /*  LANGIDFROMLCID      - extract language id from a locale id.      */
 /*  SORTIDFROMLCID      - extract sort id from a locale id.          */
 /*  SORTVERSIONFROMLCID - extract the sort version from a locale id. */

 dcl NLS_VALID_LOCALE_MASK type DWORD value('000fffff'xu);

 %MAKELCID: proc (lgid, srtid) returns (char);
   dcl (lgid, srtid) char;
   return ('cast (: DWORD, ' ||
                 'ior (isll (cast (: DWORD, cast (: WORD, ' || srtid ||
                                   ' :) :), 16), ' ||
                      'cast (: DWORD, cast (: WORD, ' || lgid ||
                              ':) :)) :)');
 %end MAKELCID;
 %dcl MAKELCID entry; /* must be macro as needed in value */

 %MAKESORTLCID: proc (lgid, srtid, ver) returns (char);
   dcl (lgid, srtid, ver) char;
   return ('cast (: DWORD, ior (' || MAKELCID (lgid, srtid) || ', ' ||
                                'isll (cast (: DWORD, cast (: WORD, ' ||
                                       ver || ' :) :), 20)) :)');
 %end MAKESORTLCID;
 %dcl MAKESORTLCID entry; /* must be macro as needed in value */

 LANGIDFROMLCID: proc (lcid)
                 returns (type LANGID byvalue)
                 options (inline reorder) internal;
   dcl lcid type LCID byvalue;
   dcl iand builtin;
   return (iand (lcid, 'ffff'xu));
 end LANGIDFROMLCID;

 SORTIDFROMLCID: proc (lcid)
                 returns (fixed bin (8) unsigned byvalue)
                 options (inline reorder) internal;
   dcl lcid type LCID byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (iand (lcid, NLS_VALID_LOCALE_MASK), 16),
                 '0f'xu));
 end SORTIDFROMLCID;

 SORTVERSIONFROMLCID: proc (lcid)
                      returns (fixed bin (8) unsigned byvalue)
                      options (inline reorder) internal;
   dcl lcid type LCID byvalue;
   dcl (iand, isrl) builtin;
   return (iand (isrl (iand (lcid, NLS_VALID_LOCALE_MASK), 20),
                 '0f'xu));
 end SORTVERSIONFROMLCID;


 dcl LANG_SYSTEM_DEFAULT    type LANGID
     value (MAKELANGID (LANG_NEUTRAL, SUBLANG_SYS_DEFAULT));
 dcl LANG_USER_DEFAULT      type LANGID
     value (MAKELANGID (LANG_NEUTRAL, SUBLANG_DEFAULT));

 dcl LOCALE_SYSTEM_DEFAULT  type LCID
     value (MAKELCID (LANG_SYSTEM_DEFAULT, SORT_DEFAULT));
 dcl LOCALE_USER_DEFAULT    type LCID
     value (MAKELCID (LANG_USER_DEFAULT,   SORT_DEFAULT));

 dcl LOCALE_NEUTRAL         type LCID
     value (MAKELCID (MAKELANGID (LANG_NEUTRAL, SUBLANG_NEUTRAL),
                      SORT_DEFAULT));


 /* The following are masks for the predefined standard access types */
 /* (moved from usual place to ensure declaration before use)        */

 dcl DELETE                     type DWORD value ('00010000'xu);
 dcl READ_CONTROL               type DWORD value ('00020000'xu);
 dcl WRITE_DAC                  type DWORD value ('00040000'xu);
 dcl WRITE_OWNER                type DWORD value ('00080000'xu);
 dcl SYNCHRONIZE                type DWORD value ('00100000'xu);
 dcl STANDARD_RIGHTS_REQUIRED   type DWORD value ('000F0000'xu);
 dcl STANDARD_RIGHTS_READ       type DWORD value (READ_CONTROL);
 dcl STANDARD_RIGHTS_WRITE      type DWORD value (READ_CONTROL);
 dcl STANDARD_RIGHTS_EXECUTE    type DWORD value (READ_CONTROL);
 dcl STANDARD_RIGHTS_ALL        type DWORD value ('001F0000'xu);
 dcl SPECIFIC_RIGHTS_ALL        type DWORD value ('0000FFFF'xu);


 %dcl WIN32_NO_STATUS char ext;
 %if WIN32_NO_STATUS = '' %then %do;

 dcl STATUS_WAIT_0                   type DWORD value('00000000'xu);
 dcl STATUS_ABANDONED_WAIT_0         type DWORD value('00000080'xu);
 dcl STATUS_USER_APC                 type DWORD value('000000C0'xu);
 dcl STATUS_TIMEOUT                  type DWORD value('00000102'xu);
 dcl STATUS_PENDING                  type DWORD value('00000103'xu);
 dcl STATUS_SEGMENT_NOTIFICATION     type DWORD value('40000005'xu);
 dcl STATUS_GUARD_PAGE_VIOLATION     type DWORD value('80000001'xu);
 dcl STATUS_DATATYPE_MISALIGNMENT    type DWORD value('80000002'xu);
 dcl STATUS_BREAKPOINT               type DWORD value('80000003'xu);
 dcl STATUS_SINGLE_STEP              type DWORD value('80000004'xu);
 dcl STATUS_ACCESS_VIOLATION         type DWORD value('C0000005'xu);
 dcl STATUS_IN_PAGE_ERROR            type DWORD value('C0000006'xu);
 dcl STATUS_INVALID_HANDLE           type DWORD value('C0000008'xu);
 dcl STATUS_NO_MEMORY                type DWORD value('C0000017'xu);
 dcl STATUS_ILLEGAL_INSTRUCTION      type DWORD value('C000001D'xu);
 dcl STATUS_NONCONTINUABLE_EXCEPTION type DWORD value('C0000025'xu);
 dcl STATUS_INVALID_DISPOSITION      type DWORD value('C0000026'xu);
 dcl STATUS_ARRAY_BOUNDS_EXCEEDED    type DWORD value('C000008C'xu);
 dcl STATUS_FLOAT_DENORMAL_OPERAND   type DWORD value('C000008D'xu);
 dcl STATUS_FLOAT_DIVIDE_BY_ZERO     type DWORD value('C000008E'xu);
 dcl STATUS_FLOAT_INEXACT_RESULT     type DWORD value('C000008F'xu);
 dcl STATUS_FLOAT_INVALID_OPERATION  type DWORD value('C0000090'xu);
 dcl STATUS_FLOAT_OVERFLOW           type DWORD value('C0000091'xu);
 dcl STATUS_FLOAT_STACK_CHECK        type DWORD value('C0000092'xu);
 dcl STATUS_FLOAT_UNDERFLOW          type DWORD value('C0000093'xu);
 dcl STATUS_INTEGER_DIVIDE_BY_ZERO   type DWORD value('C0000094'xu);
 dcl STATUS_INTEGER_OVERFLOW         type DWORD value('C0000095'xu);
 dcl STATUS_PRIVILEGED_INSTRUCTION   type DWORD value('C0000096'xu);
 dcl STATUS_STACK_OVERFLOW           type DWORD value('C00000FD'xu);
 dcl STATUS_CONTROL_C_EXIT           type DWORD value('C000013A'xu);
 dcl STATUS_FLOAT_MULTIPLE_FAULTS    type DWORD value('C00002B4'xu);
 dcl STATUS_FLOAT_MULTIPLE_TRAPS     type DWORD value('C00002B5'xu);
 dcl STATUS_ILLEGAL_VLM_REFERENCE    type DWORD value('C00002C0'xu);
 dcl STATUS_REG_NAT_CONSUMPTION      type DWORD value('C00002C9'xu);
 dcl STATUS_SXS_EARLY_DEACTIVATION   type DWORD value('C015000F'xu);
 dcl STATUS_SXS_INVALID_DEACTIVATION type DWORD value('C0150010'xu);
 %end;
 dcl MAXIMUM_WAIT_OBJECTS  fixed bin(31) value(64);
     /* Maximum number of wait objects */

 dcl MAXIMUM_SUSPEND_COUNT fixed bin (31) value(MAXCHAR);
     /* Maximum times thread can be suspended */
 define alias  KSPIN_LOCK  type ULONG_PTR;
 define alias PKSPIN_LOCK  pointer;


 dcl SIZE_OF_80387_REGISTERS fixed bin (31) value (80);
 dcl CONTEXT_i386 type DWORD value ('00010000'xn);
 dcl CONTEXT_i486 type DWORD value ('00010000'xn);
 /* this assumes that i386 and i486 have identical context records */

 dcl CONTEXT_CONTROL            type DWORD
   value (ior (CONTEXT_i386, '00000001'xn)); /*SS:SP, CS:IP, FLAGS, BP*/
 dcl CONTEXT_INTEGER            type DWORD
   value (ior (CONTEXT_i386, '00000002'xn)); /* AX, BX, CX, DX, SI, DI*/
 dcl CONTEXT_SEGMENTS           type DWORD
   value (ior (CONTEXT_i386, '00000004'xn)); /* DS, ES, FS, GS */
 dcl CONTEXT_FLOATING_POINT     type DWORD
   value (ior (CONTEXT_i386, '00000008'xn)); /* 387 state */
 dcl CONTEXT_DEBUG_REGISTERS    type DWORD
   value (ior (CONTEXT_i386, '00000010'xn)); /* DB 0-3,6,7 */
 dcl CONTEXT_EXTENDED_REGISTERS type DWORD
   value (ior (CONTEXT_i386, '00000020'xn)); /*cpu specific extensions*/

 dcl CONTEXT_FULL type DWORD
   value (ior(CONTEXT_CONTROL, CONTEXT_INTEGER, CONTEXT_SEGMENTS));

 define structure
   1 FLOATING_SAVE_AREA,
     2 ControlWord   type DWORD,
     2 StatusWord    type DWORD,
     2 TagWord       type DWORD,
     2 ErrorOffset   type DWORD,
     2 ErrorSelector type DWORD,
     2 DataOffset    type DWORD,
     2 DataSelector  type DWORD,
     2 RegisterArea  char (SIZE_OF_80387_REGISTERS),
     2 Cr0NpxState   type DWORD;

 define alias PFLOATING_SAVE_AREA handle FLOATING_SAVE_AREA;

 /* Laziness: only the Intel structures are defined here */

 /* Context Frame                                                     */
 /*                                                                   */
 /*  This frame has a several purposes:                               */
 /*   1) it is used as an argument to NtContinue,                     */
 /*   2) is is used to constuct a call frame for APC delivery, and    */
 /*   3) it is used in the user level thread creation routines.       */
 /*                                                                   */
 /*  The layout of the record conforms to a standard call frame.      */

 define structure
   1 CONTEXT,
   /*                                                                 */
   /* The flags values within this flag control the contents of       */
   /* a CONTEXT record.                                               */
   /*                                                                 */
   /* If the context record is used as an input parameter, then       */
   /* for each portion of the context record controlled by a flag     */
   /* whose value is set, it is assumed that that portion of the      */
   /* context record contains valid context. If the context record    */
   /* is being used to modify a threads context, then only that       */
   /* portion of the threads context will be modified.                */
   /*                                                                 */
   /* If the context record is used as an IN OUT parameter to capture */
   /* the context of a thread, then only those portions of the        */
   /* thread's context corresponding to set flags will be returned.   */
   /*                                                                 */
   /* The context record is never used as an OUT only parameter.      */
   /*                                                                 */
    2 ContextFlags type DWORD,
   /*                                                                 */
   /* This section is specified/returned if CONTEXT_DEBUG_REGISTERS is*/
   /* set in ContextFlags. Note that CONTEXT_DEBUG_REGISTERS is NOT   */
   /* included in CONTEXT_FULL. */
   /*                                                                 */
     2 Dr0 type DWORD,
     2 Dr1 type DWORD,
     2 Dr2 type DWORD,
     2 Dr3 type DWORD,
     2 Dr6 type DWORD,
     2 Dr7 type DWORD,
   /*                                                                 */
   /* This section is specified/returned if the                       */
   /* ContextFlags word contains the flag CONTEXT_FLOATING_POINT.     */
   /*                                                                 */
     2 FloatSave type FLOATING_SAVE_AREA,
   /*                                                                 */
   /* This section is specified/returned if the                       */
   /* ContextFlags word contains the flag CONTEXT_SEGMENTS.           */
   /*                                                                 */
     2 SegGs type DWORD,
     2 SegFs type DWORD,
     2 SegEs type DWORD,
     2 SegDs type DWORD,
   /*                                                                 */
   /* This section is specified/returned if the                       */
   /* ContextFlags word contains the flag CONTEXT_INTEGER.            */
   /*                                                                 */
     2 Edi type DWORD,
     2 Esi type DWORD,
     2 Ebx type DWORD,
     2 Edx type DWORD,
     2 Ecx type DWORD,
     2 Eax type DWORD,
   /*                                                                 */
   /* This section is specified/returned if the                       */
   /* ContextFlags word contains the flag CONTEXT_CONTROL.            */
   /*                                                                 */
     2 Ebp    type DWORD,
     2 Eip    type DWORD,
     2 SegCs  type DWORD,              /* MUST BE SANITIZED */
     2 EFlags type DWORD,              /* MUST BE SANITIZED */
     2 Esp    type DWORD,
     2 SegSs  type DWORD;

 define alias PCONTEXT handle CONTEXT;


 define structure
   1 LDT_ENTRY,
     2 LimitLow type WORD,
     2 BaseLow  type WORD,
     2 HighWord,
       3 Bytes,
         4 BaseMid type BYTE,
         4 Flags1  type BYTE, /* Declare as bytes to avoid alignment */
         4 Flags2  type BYTE, /* Problems. */
         4 BaseHi  type BYTE,
       3 Bits,         /* PL/I bit ordering for little endian system */
         4 BaseMid     bit( 8) unaligned,
         4 Pres        bit( 1) unaligned,
         4 Dpl         bit( 2) unaligned,
         4 Type        bit( 5) unaligned,
         4 Granularity bit( 1) unaligned,
         4 Default_Big bit( 1) unaligned,
         4 Reserved_0  bit( 1) unaligned,
         4 Sys         bit( 1) unaligned,
         4 LimitHi     bit( 4) unaligned,
         4 BaseHi      bit( 8) unaligned;

 define alias PLDT_ENTRY handle LDT_ENTRY;

 /* end of Intel-specific definitions */


 dcl EXCEPTION_NONCONTINUABLE     fixed bin(31) value('1'xn);
     /* Noncontinuable exception */
 dcl EXCEPTION_MAXIMUM_PARAMETERS fixed bin(31) value(15);
     /* maximum number of exception parameters */

 /* Exception record definition. */

 define structure
   1 EXCEPTION_RECORD,   /* maximum number of exception parameters */
     2 ExceptionCode    type DWORD,
     2 ExceptionFlags   type DWORD,
     2 ExceptionRecord  handle EXCEPTION_RECORD,
     2 ExceptionAddress type PVOID,
     2 NumberParameters type DWORD,
     2 ExceptionInformation (EXCEPTION_MAXIMUM_PARAMETERS) type DWORD;
 define alias PEXCEPTION_RECORD handle EXCEPTION_RECORD;

 /* Typedef for pointer returned by exception_info() */

 define structure
   1 EXCEPTION_POINTERS,
     2 ExceptionRecord type PEXCEPTION_RECORD,
     2 ContextRecord   type PCONTEXT;
 define alias PEXCEPTION_POINTERS handle EXCEPTION_POINTERS;

 define alias PACCESS_TOKEN        type PVOID;
 define alias PSECURITY_DESCRIPTOR type PVOID;
 define alias PSID                 type PVOID;

 /*********************************************************************/
 /*                                                                   */
 /*                             ACCESS MASK                           */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /*  Define the access mask as a longword sized structure divided up a*/
 /*  follows:                                                         */
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +---------------+---------------+-------------------------------+ */
 /* |G|G|G|G|Res'd|A| StandardRights|         SpecificRights        | */
 /* |R|W|E|A|     |S|               |                               | */
 /* +-+-------------+---------------+-------------------------------+ */
 /*                                                                   */
 /* typedef struct _ACCESS_MASK {                                     */
 /*     WORD   SpecificRights;                                        */
 /*     BYTE  StandardRights;                                         */
 /*     BYTE  AccessSystemAcl : 1;                                    */
 /*     BYTE  Reserved : 3;                                           */
 /*     BYTE  GenericAll : 1;                                         */
 /*     BYTE  GenericExecute : 1;                                     */
 /*     BYTE  GenericWrite : 1;                                       */
 /*     BYTE  GenericRead : 1;                                        */
 /* } ACCESS_MASK;                                                    */
 /* typedef ACCESS_MASK *PACCESS_MASK;                                */
 /*                                                                   */
 /*  but to make life simple for programmer's we'll allow them to spec*/
 /*  a desired access mask by simply OR'ing together multiple single  */
 /*  rights and treat an access mask as a DWORD.  For example         */
 /*                                                                   */
 /*      DesiredAccess = DELETE | READ_CONTROL                        */
 /*                                                                   */
 /*  So we'll declare ACCESS_MASK as DWORD                            */
 /*********************************************************************/


 define alias  ACCESS_MASK type DWORD;
 define alias PACCESS_MASK pointer;

 /*********************************************************************/
 /*                                                                   */
 /*                             ACCESS TYPES                          */
 /*                                                                   */
 /*********************************************************************/

 /* standard access types definitions moved higher in file */


 /* AccessSystemAcl access type */


 dcl ACCESS_SYSTEM_SECURITY     type DWORD value ('01000000'xu);

 /* MaximumAllowed access type */

 dcl MAXIMUM_ALLOWED            type DWORD value ('02000000'xu);


 /* These are the generic rights */

 dcl GENERIC_READ               type DWORD value ('80000000'xu);
 dcl GENERIC_WRITE              type DWORD value ('40000000'xu);
 dcl GENERIC_EXECUTE            type DWORD value ('20000000'xu);
 dcl GENERIC_ALL                type DWORD value ('10000000'xu);


 /*  Define the generic mapping array.  This is used to denote the   */
 /*  mapping of each generic access right to a specific access mask. */

 define structure
   1 GENERIC_MAPPING,
     2 GenericRead    type ACCESS_MASK,
     2 GenericWrite   type ACCESS_MASK,
     2 GenericExecute type ACCESS_MASK,
     2 GenericAll     type ACCESS_MASK;
 define alias PGENERIC_MAPPING handle GENERIC_MAPPING;


 /*********************************************************************/
 /*                                                                   */
 /*                        LUID_AND_ATTRIBUTES                        */
 /*                                                                   */
 /*********************************************************************/

 define structure
   1 LUID_AND_ATTRIBUTES,
     2 Luid       type LUID,
     2 Attributes type DWORD;

 define alias PLUID_AND_ATTRIBUTES handle LUID_AND_ATTRIBUTES;
 dcl LUID_AND_ATTRIBUTES_ARRAY (ANYSIZE_ARRAY)
              type LUID_AND_ATTRIBUTES based;
 define alias PLUID_AND_ATTRIBUTES_ARRAY  pointer;


 /*********************************************************************/
 /*                                                                   */
 /*            Security Id     (SID)                                  */
 /*                                                                   */
 /*********************************************************************/
 /*                                                                   */
 /*                                                                   */
 /* Pictorially the structure of an SID is as follows:                */
 /*                                                                   */
 /*    1   1   1   1   1   1                                          */
 /*    5   4   3   2   1   0   9   8   7   6   5   4   3   2   1   0  */
 /* +---------------------------------------------------------------+ */
 /* |      SubAuthorityCount        |Reserved1 (SBZ)|   Revision    | */
 /* +---------------------------------------------------------------+ */
 /* |                   IdentifierAuthority[0]                      | */
 /* +---------------------------------------------------------------+ */
 /* |                   IdentifierAuthority[1]                      | */
 /* +---------------------------------------------------------------+ */
 /* |                   IdentifierAuthority[2]                      | */
 /* +---------------------------------------------------------------+ */
 /* |                                                               | */
 /* +- -  -  -  -  -  -  -  SubAuthority[]  -  -  -  -  -  -  -  - -+ */
 /* |                                                               | */
 /* +---------------------------------------------------------------+ */
 /*                                                                   */
 /*********************************************************************/

 %dcl SID_IDENTIFIER_AUTHORITY_DEFINED char ext;
 %if SID_IDENTIFIER_AUTHORITY_DEFINED = '' %then %do;
 %SID_IDENTIFIER_AUTHORITY_DEFINED = 'Y';
 define structure
   1 SID_IDENTIFIER_AUTHORITY,
     2 Value (6) type BYTE;
 define alias PSID_IDENTIFIER_AUTHORITY handle SID_IDENTIFIER_AUTHORITY;
 %end;

 %dcl SID_DEFINED char ext;
 %if SID_DEFINED = '' %then %do;
 %SID_DEFINED = 'Y';
 define structure
   1 SID,
     2 Revision            type BYTE,
     2 SubAuthorityCount   type BYTE,
     2 IdentifierAuthority type SID_IDENTIFIER_AUTHORITY,
     2 SubAuthority (ANYSIZE_ARRAY) type DWORD;
 define alias PISID handle SID;
 %end;


 dcl SID_REVISION fixed bin(31) value(1); /* Current revision level */
 dcl SID_MAX_SUB_AUTHORITIES         fixed bin(31) value(15);
 dcl SID_RECOMMENDED_SUB_AUTHORITIES fixed bin(31) value(1);
     /* Will change to around 6 in a future release. */

 define ordinal SID_NAME_USE
   ( SidTypeUser value(1),
     SidTypeGroup,
     SidTypeDomain,
     SidTypeAlias,
     SidTypeWellKnownGroup,
     SidTypeDeletedAccount,
     SidTypeInvalid,
     SidTypeUnknown,
     SidTypeComputer) prec(31);
 define alias PSID_NAME_USE pointer;

 define structure
   1 SID_AND_ATTRIBUTES,
     2 Sid        type PSID,
     2 Attributes type DWORD;
 define alias PSID_AND_ATTRIBUTES handle SID_AND_ATTRIBUTES;


 dcl SID_AND_ATTRIBUTES_ARRAY (ANYSIZE_ARRAY)
              type SID_AND_ATTRIBUTES based;
 define alias PSID_AND_ATTRIBUTES_ARRAY pointer;


 /****************************************************************/
 /*                                                              */
 /* Universal well-known SIDs                                    */
 /*                                                              */
 /*     Null SID                 S-1-0-0                         */
 /*     World                    S-1-1-0                         */
 /*     Local                    S-1-2-0                         */
 /*     Creator Owner ID         S-1-3-0                         */
 /*     Creator Group ID         S-1-3-1                         */
 /*     Creator Owner Server ID  S-1-3-2                         */
 /*     Creator Group Server ID  S-1-3-3                         */
 /*                                                              */
 /*     (Non-unique IDs)         S-1-4                           */
 /*                                                              */
 /****************************************************************/

 dcl 1 SECURITY_NULL_SID_AUTHORITY static,
       2 Value (6) type BYTE init (0,0,0,0,0,0);
 dcl 1 SECURITY_WORLD_SID_AUTHORITY static,
       2 Value (6) type BYTE init (0,0,0,0,0,1);
 dcl 1 SECURITY_LOCAL_SID_AUTHORITY static,
       2 Value (6) type BYTE init (0,0,0,0,0,2);
 dcl 1 SECURITY_CREATOR_SID_AUTHORITY static,
       2 Value (6) type BYTE init (0,0,0,0,0,3);
 dcl 1 SECURITY_NON_UNIQUE_AUTHORITY static,
       2 Value (6) type BYTE init (0,0,0,0,0,4);

 dcl SECURITY_NULL_RID                   type DWORD value('00000000'xu);
 dcl SECURITY_WORLD_RID                  type DWORD value('00000000'xu);
 dcl SECURITY_LOCAL_RID                  type DWORD value('00000000'xu);

 dcl SECURITY_CREATOR_OWNER_RID          type DWORD value('00000000'xu);
 dcl SECURITY_CREATOR_GROUP_RID          type DWORD value('00000001'xu);

 dcl SECURITY_CREATOR_OWNER_SERVER_RID   type DWORD value('00000002'xu);
 dcl SECURITY_CREATOR_GROUP_SERVER_RID   type DWORD value('00000003'xu);


 /*********************************************************************/
 /*                                                                   */
 /* NT well-known SIDs                                                */
 /*                                                                   */
 /*    NT Authority          S-1-5                                    */
 /*    Dialup                S-1-5-1                                  */
 /*                                                                   */
 /*    Network               S-1-5-2                                  */
 /*    Batch                 S-1-5-3                                  */
 /*    Interactive           S-1-5-4                                  */
 /*    Service               S-1-5-6                                  */
 /*    AnonymousLogon        S-1-5-7  (aka null logon session)        */
 /*    Proxy                 S-1-5-8                                  */
 /*    ServerLogon           S-1-5-9  (aka domain controller account) */
 /*    Self                  S-1-5-10 (self RID)                      */
 /*    Authenticated User    S-1-5-11 (Authenticated user somewhere)  */
 /*    Restricted Code       S-1-5-12 (Running restricted code)       */
 /*    Terminal Server       S-1-5-13 (Running on Terminal Server)    */
 /*    Remote Logon          S-1-5-14 (Remote Interactive Logon)      */
 /*                                                                   */
 /*    (Logon IDs)           S-1-5-5-X-Y                              */
 /*                                                                   */
 /*    (NT non-unique IDs)   S-1-5-0x15-...                           */
 /*                                                                   */
 /*    (Built-in domain)     s-1-5-0x20                               */
 /*                                                                   */
 /*********************************************************************/


 dcl 1 SECURITY_NT_AUTHORITY static,
       2 Value (6) type BYTE init (0,0,0,0,0,5); /* ntifs */

 dcl SECURITY_DIALUP_RID                 type DWORD value('00000001'xu);
 dcl SECURITY_NETWORK_RID                type DWORD value('00000002'xu);
 dcl SECURITY_BATCH_RID                  type DWORD value('00000003'xu);
 dcl SECURITY_INTERACTIVE_RID            type DWORD value('00000004'xu);
 dcl SECURITY_SERVICE_RID                type DWORD value('00000006'xu);
 dcl SECURITY_ANONYMOUS_LOGON_RID        type DWORD value('00000007'xu);
 dcl SECURITY_PROXY_RID                  type DWORD value('00000008'xu);
 dcl SECURITY_ENTERPRISE_CONTROLLERS_RID
                                         type DWORD value('00000009'xu);
 dcl SECURITY_SERVER_LOGON_RID           type DWORD
     value(SECURITY_ENTERPRISE_CONTROLLERS_RID);
 dcl SECURITY_PRINCIPAL_SELF_RID         type DWORD value('0000000A'xu);
 dcl SECURITY_AUTHENTICATED_USER_RID     type DWORD value('0000000B'xu);
 dcl SECURITY_RESTRICTED_CODE_RID        type DWORD value('0000000C'xu);
 dcl SECURITY_TERMINAL_SERVER_RID        type DWORD value('0000000D'xu);
 dcl SECURITY_REMOTE_LOGON_RID           type DWORD value('0000000E'xu);

 dcl SECURITY_LOGON_IDS_RID              type DWORD value('00000005'xu);
 dcl SECURITY_LOGON_IDS_RID_COUNT        type DWORD value(3);

 dcl SECURITY_LOCAL_SYSTEM_RID           type DWORD value('00000012'xu);
 dcl SECURITY_LOCAL_SERVICE_RID          type DWORD value('00000013'xu);
 dcl SECURITY_NETWORK_SERVICE_RID        type DWORD value('00000014'xu);

 dcl SECURITY_NT_NON_UNIQUE              type DWORD value('00000015'xu);
 dcl SECURITY_NT_NON_UNIQUE_SUB_AUTH_COUNT type DWORD value(3);

 dcl SECURITY_BUILTIN_DOMAIN_RID         type DWORD value('00000020'xu);

 /*********************************************************************/
 /*                                                                   */
 /* well-known domain relative sub-authority values (RIDs)...         */
 /*                                                                   */
 /*********************************************************************/

 /* Well-known users ... */

 dcl DOMAIN_USER_RID_ADMIN               type DWORD value('000001F4'xu);
 dcl DOMAIN_USER_RID_GUEST               type DWORD value('000001F5'xu);
 dcl DOMAIN_USER_RID_KRBTGT              type DWORD value('000001F6'xu);

 /* well-known groups ... */

 dcl DOMAIN_GROUP_RID_ADMINS             type DWORD value('00000200'xu);
 dcl DOMAIN_GROUP_RID_USERS              type DWORD value('00000201'xu);
 dcl DOMAIN_GROUP_RID_GUESTS             type DWORD value('00000202'xu);
 dcl DOMAIN_GROUP_RID_COMPUTERS          type DWORD value('00000203'xu);
 dcl DOMAIN_GROUP_RID_CONTROLLERS        type DWORD value('00000204'xu);
 dcl DOMAIN_GROUP_RID_CERT_ADMINS        type DWORD value('00000205'xu);
 dcl DOMAIN_GROUP_RID_SCHEMA_ADMINS      type DWORD value('00000206'xu);
 dcl DOMAIN_GROUP_RID_ENTERPRISE_ADMINS  type DWORD value('00000207'xu);
 dcl DOMAIN_GROUP_RID_POLICY_ADMINS      type DWORD value('00000208'xu);

 /* well-known aliases ... */

 dcl DOMAIN_ALIAS_RID_ADMINS             type DWORD value('00000220'xu);
 dcl DOMAIN_ALIAS_RID_USERS              type DWORD value('00000221'xu);
 dcl DOMAIN_ALIAS_RID_GUESTS             type DWORD value('00000222'xu);
 dcl DOMAIN_ALIAS_RID_POWER_USERS        type DWORD value('00000223'xu);

 dcl DOMAIN_ALIAS_RID_ACCOUNT_OPS        type DWORD value('00000224'xu);
 dcl DOMAIN_ALIAS_RID_SYSTEM_OPS         type DWORD value('00000225'xu);
 dcl DOMAIN_ALIAS_RID_PRINT_OPS          type DWORD value('00000226'xu);
 dcl DOMAIN_ALIAS_RID_BACKUP_OPS         type DWORD value('00000227'xu);

 dcl DOMAIN_ALIAS_RID_REPLICATOR         type DWORD value('00000228'xu);
 dcl DOMAIN_ALIAS_RID_RAS_SERVERS        type DWORD value('00000229'xu);
 dcl DOMAIN_ALIAS_RID_PREW2KCOMPACCESS   type DWORD value('0000022A'xu);
 dcl DOMAIN_ALIAS_RID_REMOTE_DESKTOP_USERS
                                         type DWORD value('0000022B'xu);
 dcl DOMAIN_ALIAS_RID_NETWORK_CONFIGURATION_OPS
                                         type DWORD value('0000022C'xu);

 /* Allocate the System Luid.  The first 1000 LUIDs are reserved. */
 /* Use #999 here (0x3E7 = 999) */
 dcl 1 SYSTEM_LUID static,
       2 LowPart  type DWORD init ('03E7'xu),
       2 HighPart type DWORD init (0);
 dcl 1 ANONYMOUS_LOGON_LUID static,
       2 LowPart  type DWORD init ('03E6'xu),
       2 HighPart type DWORD init (0);
 dcl 1 LOCALSERVICE_LUID static,
       2 LowPart  type DWORD init ('03E5'xu),
       2 HighPart type DWORD init (0);
 dcl 1 NETWORKSERVICE_LUID static,
       2 LowPart  type DWORD init ('03E4'xu),
       2 HighPart type DWORD init (0);

 /*********************************************************************/
 /*                                                                   */
 /* User and Group related SID attributes                             */
 /*                                                                   */
 /*********************************************************************/

 /* Group attributes */

 dcl SE_GROUP_MANDATORY                 type DWORD value('00000001'xu);
 dcl SE_GROUP_ENABLED_BY_DEFAULT        type DWORD value('00000002'xu);
 dcl SE_GROUP_ENABLED                   type DWORD value('00000004'xu);
 dcl SE_GROUP_OWNER                     type DWORD value('00000008'xu);
 dcl SE_GROUP_USE_FOR_DENY_ONLY         type DWORD value('00000010'xu);
 dcl SE_GROUP_LOGON_ID                  type DWORD value('C0000000'xu);
 dcl SE_GROUP_RESOURCE                  type DWORD value('20000000'xu);


 /* User attributes */

 /* (None yet defined.) */



 dcl PROCESS_TERMINATE                  type DWORD value('0001'xu);
 dcl PROCESS_CREATE_THREAD              type DWORD value('0002'xu);
 dcl PROCESS_SET_SESSIONID              type DWORD value('0004'xu);
 dcl PROCESS_VM_OPERATION               type DWORD value('0008'xu);
 dcl PROCESS_VM_READ                    type DWORD value('0010'xu);
 dcl PROCESS_VM_WRITE                   type DWORD value('0020'xu);
 dcl PROCESS_DUP_HANDLE                 type DWORD value('0040'xu);
 dcl PROCESS_CREATE_PROCESS             type DWORD value('0080'xu);
 dcl PROCESS_SET_QUOTA                  type DWORD value('0100'xu);
 dcl PROCESS_SET_INFORMATION            type DWORD value('0200'xu);
 dcl PROCESS_QUERY_INFORMATION          type DWORD value('0400'xu);
 dcl PROCESS_ALL_ACCESS                 type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE, '0fff'xu));

 dcl MAXIMUM_PROCESSORS                 fixed bin(31) value(32);

 dcl THREAD_TERMINATE                   type DWORD value('0001'xu);
 dcl THREAD_SUSPEND_RESUME              type DWORD value('0002'xu);
 dcl THREAD_GET_CONTEXT                 type DWORD value('0008'xu);
 dcl THREAD_SET_CONTEXT                 type DWORD value('0010'xu);
 dcl THREAD_SET_INFORMATION             type DWORD value('0020'xu);
 dcl THREAD_QUERY_INFORMATION           type DWORD value('0040'xu);
 dcl THREAD_SET_THREAD_TOKEN            type DWORD value('0080'xu);
 dcl THREAD_IMPERSONATE                 type DWORD value('0100'xu);
 dcl THREAD_DIRECT_IMPERSONATION        type DWORD value('0200'xu);
 dcl THREAD_ALL_ACCESS                  type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE, '03ff'xu));

 dcl JOB_OBJECT_ASSIGN_PROCESS          type DWORD value('0001'xu);
 dcl JOB_OBJECT_SET_ATTRIBUTES          type DWORD value('0002'xu);
 dcl JOB_OBJECT_QUERY                   type DWORD value('0004'xu);
 dcl JOB_OBJECT_TERMINATE               type DWORD value('0008'xu);
 dcl JOB_OBJECT_SET_SECURITY_ATTRIBUTES type DWORD value('0010'xu);
 dcl JOB_OBJECT_ALL_ACCESS              type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE, '1F'xu));

 dcl TLS_MINIMUM_AVAILABLE              fixed bin(31) value(64);

 define structure
   1 NT_TIB,
     2 ExceptionList pointer, /* handle EXCEPTION_REGISTRATION_RECORD */
     2 StackBase     type PVOID,
     2 StackLimit    type PVOID,
     2 SubSystemTib  type PVOID,
     2 * union,
       3 FiberData   type PVOID,
       3 Version     type DWORD,
     2 ArbitraryUserPointer type PVOID,
     2 Self          handle NT_TIB;
 define alias PNT_TIB handle NT_TIB;

 dcl THREAD_BASE_PRIORITY_LOWRT fixed bin(31) value(15);
     /* value that gets a thread to LowRealtime-1 */
 dcl THREAD_BASE_PRIORITY_MAX   fixed bin(31) value(2);
     /* maximum thread base priority boost */
 dcl THREAD_BASE_PRIORITY_MIN   fixed bin(31) value(-2);
     /* minimum thread base priority boost */
 dcl THREAD_BASE_PRIORITY_IDLE  fixed bin(31) value(-15);
     /* value that gets a thread to idle */

 define structure
   1 QUOTA_LIMITS,   /* value that gets a thread to idle */
     2 PagedPoolLimit        type SIZE_T,
     2 NonPagedPoolLimit     type SIZE_T,
     2 MinimumWorkingSetSize type SIZE_T,
     2 MaximumWorkingSetSize type SIZE_T,
     2 PagefileLimit         type SIZE_T,
     2 TimeLimit             type LARGE_INTEGER;
 define alias PQUOTA_LIMITS handle QUOTA_LIMITS;

 define structure
   1 IO_COUNTERS,
     2 ReadOperationCount  type ULONGLONG,
     2 WriteOperationCount type ULONGLONG,
     2 OtherOperationCount type ULONGLONG,
     2 ReadTransferCount   type ULONGLONG,
     2 WriteTransferCount  type ULONGLONG,
     2 OtherTransferCount  type ULONGLONG;
 define alias PIO_COUNTERS handle IO_COUNTERS;


 /*********************************************************************/
 /*                                                                   */
 /*                         ACL  and  ACE                             */
 /* Define an ACL and the ACE format.  The structure of an ACL header */
 /* followed by one or more ACEs.  Pictorally the structure of an ACL */
 /* header is as follows:                                             */
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +-------------------------------+---------------+---------------+ */
 /* |            AclSize            |      Sbz1     |  AclRevision  | */
 /* +-------------------------------+---------------+---------------+ */
 /* |              Sbz2             |           AceCount            | */
 /* +-------------------------------+-------------------------------+ */
 /* The current AclRevision is defined to be ACL_REVISION.            */
 /* AclSize is the size, in bytes, allocated for the ACL.             */
 /* This includes the ACL header, ACES, and remaining free space      */
 /* in the buffer.                                                    */
 /* AceCount is the number of ACES in the ACL.                        */
 /*                                                                   */
 /*********************************************************************/
 dcl ACL_REVISION     fixed bin(31) value(2);
 dcl ACL_REVISION_DS  fixed bin(31) value(4);


 /* This is the history of ACL revisions.  Add a new one whenever */
 /* ACL_REVISION is updated */

 dcl ACL_REVISION1    fixed bin(31) value(1);
 dcl ACL_REVISION2    fixed bin(31) value(2);
 dcl ACL_REVISION3    fixed bin(31) value(3);
 dcl ACL_REVISION4    fixed bin(31) value(4);
 dcl MIN_ACL_REVISION fixed bin(31) value(ACL_REVISION2);
 dcl MAX_ACL_REVISION fixed bin(31) value(ACL_REVISION4);

 define structure
   1 ACL,
    2 AclRevision type BYTE,
    2 Sbz1        type BYTE,
    2 AclSize     type WORD,
    2 AceCount    type WORD,
    2 Sbz2        type WORD;
 define alias PACL handle ACL;


 /*********************************************************************/
 /* The structure of an ACE is a common ace header followed           */
 /* by ace type specific data.  Pictorally the structure of           */
 /* the common ace header is as follows:                              */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +---------------+-------+-------+---------------+--------------+  */
 /* |            AceSize            |    AceFlags   |     AceType  |  */
 /* +---------------+-------+-------+---------------+--------------+  */
 /* AceType denotes the type of the ace, there are some predefined    */
 /* ace types AceSize is the size, in bytes, of ace.                  */
 /*                                                                   */
 /*********************************************************************/

 define structure
   1 ACE_HEADER,
     2 AceType  type BYTE,
     2 AceFlags type BYTE,
     2 AceSize  type WORD;
 define alias PACE_HEADER handle ACE_HEADER;


 /* The following are the predefined ace types that go to the AceType */
 /* field of an Ace header.                                           */

 dcl ACCESS_MIN_MS_ACE_TYPE                  type BYTE value('0'xu);
 dcl ACCESS_ALLOWED_ACE_TYPE                 type BYTE value('0'xu);
 dcl ACCESS_DENIED_ACE_TYPE                  type BYTE value('1'xu);
 dcl SYSTEM_AUDIT_ACE_TYPE                   type BYTE value('2'xu);
 dcl SYSTEM_ALARM_ACE_TYPE                   type BYTE value('3'xu);
 dcl ACCESS_MAX_MS_V2_ACE_TYPE               type BYTE value('3'xu);

 dcl ACCESS_ALLOWED_COMPOUND_ACE_TYPE        type BYTE value('4'xu);
 dcl ACCESS_MAX_MS_V3_ACE_TYPE               type BYTE value('4'xu);

 dcl ACCESS_MIN_MS_OBJECT_ACE_TYPE           type BYTE value('5'xu);
 dcl ACCESS_ALLOWED_OBJECT_ACE_TYPE          type BYTE value('5'xu);
 dcl ACCESS_DENIED_OBJECT_ACE_TYPE           type BYTE value('6'xu);
 dcl SYSTEM_AUDIT_OBJECT_ACE_TYPE            type BYTE value('7'xu);
 dcl SYSTEM_ALARM_OBJECT_ACE_TYPE            type BYTE value('8'xu);
 dcl ACCESS_MAX_MS_OBJECT_ACE_TYPE           type BYTE value('8'xu);

 dcl ACCESS_MAX_MS_V4_ACE_TYPE               type BYTE value('8'xu);
 dcl ACCESS_MAX_MS_ACE_TYPE                  type BYTE value('8'xu);

 dcl ACCESS_ALLOWED_CALLBACK_ACE_TYPE        type BYTE value('9'xu);
 dcl ACCESS_DENIED_CALLBACK_ACE_TYPE         type BYTE value('A'xu);
 dcl ACCESS_ALLOWED_CALLBACK_OBJECT_ACE_TYPE type BYTE value('B'xu);
 dcl ACCESS_DENIED_CALLBACK_OBJECT_ACE_TYPE  type BYTE value('C'xu);
 dcl SYSTEM_AUDIT_CALLBACK_ACE_TYPE          type BYTE value('D'xu);
 dcl SYSTEM_ALARM_CALLBACK_ACE_TYPE          type BYTE value('E'xu);
 dcl SYSTEM_AUDIT_CALLBACK_OBJECT_ACE_TYPE   type BYTE value('F'xu);
 dcl SYSTEM_ALARM_CALLBACK_OBJECT_ACE_TYPE   type BYTE value('10'xu);

 dcl ACCESS_MAX_MS_V5_ACE_TYPE               type BYTE value('10'xu);


 /* The following are the inherit flags that go into the AceFlags     */
 /* field of an Ace header.                                           */

 dcl OBJECT_INHERIT_ACE               type BYTE value('1'xu);
 dcl CONTAINER_INHERIT_ACE            type BYTE value('2'xu);
 dcl NO_PROPAGATE_INHERIT_ACE         type BYTE value('4'xu);
 dcl INHERIT_ONLY_ACE                 type BYTE value('8'xu);
 dcl INHERITED_ACE                    type BYTE value('10'xu);
 dcl VALID_INHERIT_FLAGS              type BYTE value('1F'xu);


 /* The following are the currently defined ACE flagsthat go into     */
 /* the AceFlags field of an ACE header. Each ACE type has its own    */
 /* set of AceFlags.                                                  */
 /*                                                                   */
 /* SUCCESSFUL_ACCESS_ACE_FLAG - used only with system audit and      */
 /* alarm ACE types to indicate that a message is generated for       */
 /* successful accesses.                                              */
 /*                                                                   */
 /* FAILED_ACCESS_ACE_FLAG - used only with system audit and          */
 /* alarm ACE types to indicate that a message is generated for       */
 /* failed accesses.                                                  */

 /*  SYSTEM_AUDIT and SYSTEM_ALARM AceFlags                           */
 /*                                                                   */
 /* These control the signaling of audit and alarms for success or    */
 /* failure.                                                          */


 dcl SUCCESSFUL_ACCESS_ACE_FLAG       type BYTE value('40'xu);
 dcl FAILED_ACCESS_ACE_FLAG           type BYTE value('80'xu);

 /*********************************************************************/
 /* We'll define the structure of the predefined ACE types.           */
 /* Pictorally, the structure of the predefined ACE's is as follows:  */
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +---------------+-------+-------+---------------+---------------+ */
 /* |    AceFlags   | Resd  |Inherit|    AceSize    |     AceType   | */
 /* +---------------+-------+-------+---------------+---------------+ */
 /* |                              Mask                             | */
 /* +---------------------------------------------------------------+ */
 /* |                                                               | */
 /* +                                                               + */
 /* |                                                               | */
 /* +                              Sid                              + */
 /* |                                                               | */
 /* +                                                               + */
 /* |                                                               | */
 /* +---------------------------------------------------------------+ */
 /*                                                                   */
 /* Mask is the access mask associated with the ACE.  This is either  */
 /* the access allowed, access denied, audit, or alarm mask.          */
 /*                                                                   */
 /* Sid is the Sid associated with the ACE.                           */
 /*                                                                   */
 /*********************************************************************/

 /* The following are the four predefined ACE types.     */
 /* Examine the AceType field in the Header to determine */
 /* which structure is appropriate to use for casting.   */


 define structure
   1 ACCESS_ALLOWED_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
 define alias PACCESS_ALLOWED_ACE handle ACCESS_ALLOWED_ACE;

 define structure
   1 ACCESS_DENIED_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
 define alias PACCESS_DENIED_ACE handle ACCESS_DENIED_ACE;

 define structure
   1 SYSTEM_AUDIT_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
 define alias PSYSTEM_AUDIT_ACE handle SYSTEM_AUDIT_ACE;

 define structure
   1 SYSTEM_ALARM_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
 define alias PSYSTEM_ALARM_ACE handle SYSTEM_ALARM_ACE;


 define structure
   1 ACCESS_ALLOWED_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
 define alias PACCESS_ALLOWED_OBJECT_ACE
              handle ACCESS_ALLOWED_OBJECT_ACE;

 define structure
   1 ACCESS_DENIED_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
 define alias PACCESS_DENIED_OBJECT_ACE
              handle ACCESS_DENIED_OBJECT_ACE;

 define structure
   1 SYSTEM_AUDIT_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
 define alias PSYSTEM_AUDIT_OBJECT_ACE handle SYSTEM_AUDIT_OBJECT_ACE;

 define structure
   1 SYSTEM_ALARM_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
 define alias PSYSTEM_ALARM_OBJECT_ACE handle SYSTEM_ALARM_OBJECT_ACE;

 /* Callback ace support in post Win2000.          */
 /* Resource managers can put their own data after */
 /* Sidstart + Length of the sid                   */

 define structure
   1 ACCESS_ALLOWED_CALLBACK_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
     /* Opaque resouce manager specific data */
 define alias PACCESS_ALLOWED_CALLBACK_ACE
        handle ACCESS_ALLOWED_CALLBACK_ACE;

 define structure
   1 ACCESS_DENIED_CALLBACK_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
     /* Opaque resouce manager specific data */
 define alias PACCESS_DENIED_CALLBACK_ACE
        handle ACCESS_DENIED_CALLBACK_ACE;

 define structure
   1 SYSTEM_AUDIT_CALLBACK_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
     /* Opaque resouce manager specific data */
 define alias PSYSTEM_AUDIT_CALLBACK_ACE
        handle SYSTEM_AUDIT_CALLBACK_ACE;

 define structure
   1 SYSTEM_ALARM_CALLBACK_ACE,
     2 Header   type ACE_HEADER,
     2 Mask     type ACCESS_MASK,
     2 SidStart type DWORD;
     /* Opaque resouce manager specific data */
 define alias PSYSTEM_ALARM_CALLBACK_ACE
        handle SYSTEM_ALARM_CALLBACK_ACE;

 define structure
   1 ACCESS_ALLOWED_CALLBACK_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
     /* Opaque resouce manager specific data */
 define alias PACCESS_ALLOWED_CALLBACK_OBJECT_ACE
        handle ACCESS_ALLOWED_CALLBACK_OBJECT_ACE;

 define structure
   1 ACCESS_DENIED_CALLBACK_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
     /* Opaque resouce manager specific data */
 define alias PACCESS_DENIED_CALLBACK_OBJECT_ACE
        handle ACCESS_DENIED_CALLBACK_OBJECT_ACE;

 define structure
   1 SYSTEM_AUDIT_CALLBACK_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
     /* Opaque resouce manager specific data */
 define alias PSYSTEM_AUDIT_CALLBACK_OBJECT_ACE
        handle SYSTEM_AUDIT_CALLBACK_OBJECT_ACE;

 define structure
   1 SYSTEM_ALARM_CALLBACK_OBJECT_ACE,
     2 Header              type ACE_HEADER,
     2 Mask                type ACCESS_MASK,
     2 Flags               type DWORD,
     2 ObjectType          type GUID,
     2 InheritedObjectType type GUID,
     2 SidStart            type DWORD;
     /* Opaque resouce manager specific data */
 define alias PSYSTEM_ALARM_CALLBACK_OBJECT_ACE
        handle SYSTEM_ALARM_CALLBACK_OBJECT_ACE;


 /* Currently define Flags for "OBJECT" ACE types. */

 dcl ACE_OBJECT_TYPE_PRESENT           type BYTE value('1'xu);
 dcl ACE_INHERITED_OBJECT_TYPE_PRESENT type BYTE value('2'xu);

 /* The following declarations are used for setting and querying */
 /* information about an ACL. First are the various information  */
 /* classes available to the user.                               */

 define ordinal
   ACL_INFORMATION_CLASS
     ( AclRevisionInformation value(1),
       AclSizeInformation
     ) prec(31);

 /* This record is returned/sent if the user is requesting/setting */
 /* the AclRevisionInformation                                     */

 define structure
   1 ACL_REVISION_INFORMATION,
     2 AclRevision type DWORD;
 define alias PACL_REVISION_INFORMATION handle ACL_REVISION_INFORMATION;

 /*  This record is returned if the user is requesting */
 /*  AclSizeInformation                                */

 define structure
   1 ACL_SIZE_INFORMATION,
    2 AceCount      type DWORD,
    2 AclBytesInUse type DWORD,
    2 AclBytesFree  type DWORD;
 define alias PACL_SIZE_INFORMATION handle ACL_SIZE_INFORMATION;


 /****************************************************************/
 /*                                                              */
 /*           Security Quality Of Service                        */
 /*                                                              */
 /****************************************************************/

 /* Impersonation Level                                               */
 /*                                                                   */
 /* Impersonation level is represented by a pair of bits in Windows.  */
 /* If a new impersonation level is added or lowest value is changed  */
 /* from 0 to something else, fix the Windows CreateFile call.        */


 define ordinal
   SECURITY_IMPERSONATION_LEVEL
     ( SecurityAnonymous,
       SecurityIdentification,
       SecurityImpersonation,
       SecurityDelegation) prec(31);
 dcl PSECURITY_IMPERSONATION_LEVEL pointer;

 dcl SECURITY_MAX_IMPERSONATION_LEVEL type SECURITY_IMPERSONATION_LEVEL
     value(SecurityDelegation);

 dcl SECURITY_MIN_IMPERSONATION_LEVEL type SECURITY_IMPERSONATION_LEVEL
     value(SecurityAnonymous);

 dcl DEFAULT_IMPERSONATION_LEVEL      type SECURITY_IMPERSONATION_LEVEL
     value (SecurityImpersonation);

 VALID_IMPERSONATION_LEVEL: proc (L)
                            returns (bit(1) aligned byvalue)
                            options (inline reorder) internal;
   dcl L type SECURITY_IMPERSONATION_LEVEL;
   return (L >= SECURITY_MIN_IMPERSONATION_LEVEL &
           L <= SECURITY_MAX_IMPERSONATION_LEVEL);
 end VALID_IMPERSONATION_LEVEL;

 /******************************************************************/
 /*                                                                */
 /*           Token Object Definitions                             */
 /*                                                                */
 /******************************************************************/

 /* Token Specific Access Rights. */


 dcl TOKEN_ASSIGN_PRIMARY    type DWORD value('0001'xu);
 dcl TOKEN_DUPLICATE         type DWORD value('0002'xu);
 dcl TOKEN_IMPERSONATE       type DWORD value('0004'xu);
 dcl TOKEN_QUERY             type DWORD value('0008'xu);
 dcl TOKEN_QUERY_SOURCE      type DWORD value('0010'xu);
 dcl TOKEN_ADJUST_PRIVILEGES type DWORD value('0020'xu);
 dcl TOKEN_ADJUST_GROUPS     type DWORD value('0040'xu);
 dcl TOKEN_ADJUST_DEFAULT    type DWORD value('0080'xu);
 dcl TOKEN_ADJUST_SESSIONID  type DWORD value('0100'xu);

 dcl TOKEN_ALL_ACCESS        type DWORD
     value( ior (STANDARD_RIGHTS_REQUIRED,
                 TOKEN_ASSIGN_PRIMARY,
                 TOKEN_DUPLICATE,
                 TOKEN_IMPERSONATE,
                 TOKEN_QUERY,
                 TOKEN_QUERY_SOURCE,
                 TOKEN_ADJUST_PRIVILEGES,
                 TOKEN_ADJUST_GROUPS,
                 TOKEN_ADJUST_SESSIONID,
                 TOKEN_ADJUST_DEFAULT));

 dcl TOKEN_READ              type DWORD
     value( ior (STANDARD_RIGHTS_READ, TOKEN_QUERY));

 dcl TOKEN_WRITE             type DWORD
     value( ior (STANDARD_RIGHTS_WRITE, TOKEN_ADJUST_PRIVILEGES,
                 TOKEN_ADJUST_GROUPS, TOKEN_ADJUST_DEFAULT));

 dcl TOKEN_EXECUTE           type DWORD
     value (STANDARD_RIGHTS_EXECUTE);


 /* Token Types */

 define ordinal
   TOKEN_TYPE
     ( TokenPrimary value (1),
       TokenImpersonation
     ) prec(31);
 define alias PTOKEN_TYPE pointer;

 /* Token Information Classes. */

 define ordinal
   TOKEN_INFORMATION_CLASS
     ( TokenUser  value (1),
       TokenGroups,
       TokenPrivileges,
       TokenOwner,
       TokenPrimaryGroup,
       TokenDefaultDacl,
       TokenSource,
       TokenType,
       TokenImpersonationLevel,
       TokenStatistics,
       TokenRestrictedSids,
       TokenSessionId
     ) prec(31);
 define alias PTOKEN_INFORMATION_CLASS pointer;


 /* Token information class structures */

 define structure
   1 TOKEN_USER,
     2 User type SID_AND_ATTRIBUTES;
 define alias PTOKEN_USER handle TOKEN_USER;

 define structure
   1 TOKEN_GROUPS,
     2 GroupCount type DWORD,
     2 Groups (ANYSIZE_ARRAY) type SID_AND_ATTRIBUTES;
 define alias PTOKEN_GROUPS handle TOKEN_GROUPS;

 define structure
   1 TOKEN_PRIVILEGES,
     2 PrivilegeCount type DWORD,
    2  Privileges (ANYSIZE_ARRAY) type LUID_AND_ATTRIBUTES;
 define alias PTOKEN_PRIVILEGES handle TOKEN_PRIVILEGES;

 define structure
   1 TOKEN_OWNER,
     2 Owner type PSID;
 define alias PTOKEN_OWNER handle TOKEN_OWNER;


 define structure
   1 TOKEN_PRIMARY_GROUP,
     2 PrimaryGroup type PSID;
 define alias PTOKEN_PRIMARY_GROUP handle TOKEN_PRIMARY_GROUP;


 define structure
   1 TOKEN_DEFAULT_DACL,
     2 DefaultDacl type PACL;
 define alias PTOKEN_DEFAULT_DACL handle TOKEN_DEFAULT_DACL;


 dcl TOKEN_SOURCE_LENGTH fixed bin (31) value (8);

 define structure
   1 TOKEN_SOURCE,
     2 SourceName       char (TOKEN_SOURCE_LENGTH),
     2 SourceIdentifier type LUID;
 define alias PTOKEN_SOURCE handle TOKEN_SOURCE;


 define structure
   1 TOKEN_STATISTICS,
     2 TokenId            type LUID,
     2 AuthenticationId   type LUID,
     2 ExpirationTime     type LARGE_INTEGER,
     2 TokenType          type TOKEN_TYPE,
     2 ImpersonationLevel type SECURITY_IMPERSONATION_LEVEL,
     2 DynamicCharged     type DWORD,
     2 DynamicAvailable   type DWORD,
     2 GroupCount         type DWORD,
     2 PrivilegeCount     type DWORD,
     2 ModifiedId         type LUID;
 define alias PTOKEN_STATISTICS handle TOKEN_STATISTICS;

 define structure
  1 TOKEN_CONTROL,
     2 TokenId          type LUID,
     2 AuthenticationId type LUID,
     2 ModifiedId       type LUID,
     2 TokenSource      type TOKEN_SOURCE;
 define alias PTOKEN_CONTROL handle TOKEN_CONTROL;



 define structure
   1 JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
     2 TotalUserTime             type LARGE_INTEGER,
     2 TotalKernelTime           type LARGE_INTEGER,
     2 ThisPeriodTotalUserTime   type LARGE_INTEGER,
     2 ThisPeriodTotalKernelTime type LARGE_INTEGER,
     2 TotalPageFaultCount       type DWORD,
     2 TotalProcesses            type DWORD,
     2 ActiveProcesses           type DWORD;
 define alias PJOBOBJECT_BASIC_ACCOUNTING_INFORMATION
              handle JOBOBJECT_BASIC_ACCOUNTING_INFORMATION;

 define structure
   1 JOBOBJECT_BASIC_LIMIT_INFORMATION,
      2 PerProcessUserTimeLimit type LARGE_INTEGER,
      2 PerJobUserTimeLimit     type LARGE_INTEGER,
      2 LimitFlags              type DWORD,
      2 MinimumWorkingSetSize   type SIZE_T,
      2 MaximumWorkingSetSize   type SIZE_T,
      2 ActiveProcessLimit      type DWORD,
      2 Affinity                type ULONG_PTR,
      2 PriorityClass           type DWORD;
 define alias PJOBOBJECT_BASIC_LIMIT_INFORMATION
              handle JOBOBJECT_BASIC_LIMIT_INFORMATION;

 define structure
   1 JOBOBJECT_EXTENDED_LIMIT_INFORMATION,
     2 BasicLimitInformation type JOBOBJECT_BASIC_LIMIT_INFORMATION,
     2 IoInfo                type IO_COUNTERS,
     2 ProcessMemoryLimit    type SIZE_T,
     2 JobMemoryLimit        type SIZE_T,
     2 PeakProcessMemoryUsed type SIZE_T,
     2 PeakJobMemoryUsed     type SIZE_T;
 define alias PJOBOBJECT_EXTENDED_LIMIT_INFORMATION
        handle JOBOBJECT_EXTENDED_LIMIT_INFORMATION;

 define structure
   1 JOBOBJECT_BASIC_PROCESS_ID_LIST,
     2 NumberOfAssignedProcesses type DWORD,
     2 NumberOfProcessIdsInList  type DWORD,
     2 ProcessIdList         (1) type ULONG_PTR; /* actually refer */
 define alias PJOBOBJECT_BASIC_PROCESS_ID_LIST
        handle JOBOBJECT_BASIC_PROCESS_ID_LIST;

 define structure
   1 JOBOBJECT_BASIC_UI_RESTRICTIONS,
     2 UIRestrictionsClass type DWORD;
 define alias PJOBOBJECT_BASIC_UI_RESTRICTIONS
        handle JOBOBJECT_BASIC_UI_RESTRICTIONS;

 define structure
   1 JOBOBJECT_SECURITY_LIMIT_INFORMATION,
     2 SecurityLimitFlags type DWORD,
     2 JobToken           type HANDLE,
     2 SidsToDisable      type PTOKEN_GROUPS,
     2 PrivilegesToDelete type PTOKEN_PRIVILEGES,
     2 RestrictedSids     type PTOKEN_GROUPS;
 define alias PJOBOBJECT_SECURITY_LIMIT_INFORMATION
        handle JOBOBJECT_SECURITY_LIMIT_INFORMATION;

 define structure
   1 JOBOBJECT_END_OF_JOB_TIME_INFORMATION,
     2 EndOfJobTimeAction type DWORD;
 define alias PJOBOBJECT_END_OF_JOB_TIME_INFORMATION
        handle JOBOBJECT_END_OF_JOB_TIME_INFORMATION;

 define structure
   1 JOBOBJECT_ASSOCIATE_COMPLETION_PORT,
     2 CompletionKey  type PVOID,
     2 CompletionPort type HANDLE;
 define alias PJOBOBJECT_ASSOCIATE_COMPLETION_PORT
        handle JOBOBJECT_ASSOCIATE_COMPLETION_PORT;

 define structure
   1 JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION,
     2 BasicInfo type JOBOBJECT_BASIC_ACCOUNTING_INFORMATION,
     2 IoInfo    type IO_COUNTERS;
 define alias PJOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION
        handle JOBOBJECT_BASIC_AND_IO_ACCOUNTING_INFORMATION;

 dcl JOB_OBJECT_TERMINATE_AT_END_OF_JOB  fixed bin(31) value(0);
 dcl JOB_OBJECT_POST_AT_END_OF_JOB       fixed bin(31) value(1);

 /* Completion Port Messages for job objects                     */
 /*                                                              */
 /* These values are returned via the lpNumberOfBytesTransferred */
 /* parameter                                                    */

 dcl JOB_OBJECT_MSG_END_OF_JOB_TIME       fixed bin(31) value( 1);
 dcl JOB_OBJECT_MSG_END_OF_PROCESS_TIME   fixed bin(31) value( 2);
 dcl JOB_OBJECT_MSG_ACTIVE_PROCESS_LIMIT  fixed bin(31) value( 3);
 dcl JOB_OBJECT_MSG_ACTIVE_PROCESS_ZERO   fixed bin(31) value( 4);
 dcl JOB_OBJECT_MSG_NEW_PROCESS           fixed bin(31) value( 6);
 dcl JOB_OBJECT_MSG_EXIT_PROCESS          fixed bin(31) value( 7);
 dcl JOB_OBJECT_MSG_ABNORMAL_EXIT_PROCESS fixed bin(31) value( 8);
 dcl JOB_OBJECT_MSG_PROCESS_MEMORY_LIMIT  fixed bin(31) value( 9);
 dcl JOB_OBJECT_MSG_JOB_MEMORY_LIMIT      fixed bin(31) value(10);


 dcl JOB_OBJECT_LIMIT_WORKINGSET         type DWORD value('00000001'xu);
 dcl JOB_OBJECT_LIMIT_PROCESS_TIME       type DWORD value('00000002'xu);
 dcl JOB_OBJECT_LIMIT_JOB_TIME           type DWORD value('00000004'xu);
 dcl JOB_OBJECT_LIMIT_ACTIVE_PROCESS     type DWORD value('00000008'xu);
 dcl JOB_OBJECT_LIMIT_AFFINITY           type DWORD value('00000010'xu);
 dcl JOB_OBJECT_LIMIT_PRIORITY_CLASS     type DWORD value('00000020'xu);
 dcl JOB_OBJECT_LIMIT_PRESERVE_JOB_TIME  type DWORD value('00000040'xu);
 dcl JOB_OBJECT_LIMIT_SCHEDULING_CLASS   type DWORD value('00000080'xu);

 /* Extended Limits */
 dcl JOB_OBJECT_LIMIT_PROCESS_MEMORY     type DWORD value('00000100'xu);
 dcl JOB_OBJECT_LIMIT_JOB_MEMORY         type DWORD value('00000200'xu);
 dcl JOB_OBJECT_LIMIT_DIE_ON_UNHANDLED_EXCEPTION
                                         type DWORD value('00000400'xu);
 dcl JOB_OBJECT_LIMIT_BREAKAWAY_OK       type DWORD value('00000800'xu);
 dcl JOB_OBJECT_LIMIT_SILENT_BREAKAWAY_OK
                                         type DWORD value('00001000'xu);

 dcl JOB_OBJECT_LIMIT_RESERVED1          type DWORD value('00002000'xu);
 dcl JOB_OBJECT_LIMIT_RESERVED2          type DWORD value('00004000'xu);
 dcl JOB_OBJECT_LIMIT_RESERVED3          type DWORD value('00008000'xu);
 dcl JOB_OBJECT_LIMIT_RESERVED4          type DWORD value('00010000'xu);
 dcl JOB_OBJECT_LIMIT_RESERVED5          type DWORD value('00020000'xu);
 dcl JOB_OBJECT_LIMIT_RESERVED6          type DWORD value('00040000'xu);

 dcl JOB_OBJECT_LIMIT_VALID_FLAGS        type DWORD value('0007ffff'xu);

 dcl JOB_OBJECT_BASIC_LIMIT_VALID_FLAGS  type DWORD value('000000ff'xu);
 dcl JOB_OBJECT_EXTENDED_LIMIT_VALID_FLAGS
                                         type DWORD value('00001fff'xu);
 dcl JOB_OBJECT_RESERVED_LIMIT_VALID_FLAGS
                                         type DWORD value('0007ffff'xu);

 /* UI restrictions for jobs */

 dcl JOB_OBJECT_UILIMIT_NONE             type DWORD value('00000000'xu);

 dcl JOB_OBJECT_UILIMIT_HANDLES          type DWORD value('00000001'xu);
 dcl JOB_OBJECT_UILIMIT_READCLIPBOARD    type DWORD value('00000002'xu);
 dcl JOB_OBJECT_UILIMIT_WRITECLIPBOARD
                                         type DWORD value('00000004'xu);
 dcl JOB_OBJECT_UILIMIT_SYSTEMPARAMETERS type DWORD value('00000008'xu);
 dcl JOB_OBJECT_UILIMIT_DISPLAYSETTINGS  type DWORD value('00000010'xu);
 dcl JOB_OBJECT_UILIMIT_GLOBALATOMS      type DWORD value('00000020'xu);
 dcl JOB_OBJECT_UILIMIT_DESKTOP          type DWORD value('00000040'xu);
 dcl JOB_OBJECT_UILIMIT_EXITWINDOWS      type DWORD value('00000080'xu);

 dcl JOB_OBJECT_UILIMIT_ALL              type DWORD value('000000FF'xu);

 dcl JOB_OBJECT_UI_VALID_FLAGS           type DWORD value('000000FF'xu);

 dcl JOB_OBJECT_SECURITY_NO_ADMIN        type DWORD value('00000001'xu);
 dcl JOB_OBJECT_SECURITY_RESTRICTED_TOKEN
                                         type DWORD value('00000002'xu);
 dcl JOB_OBJECT_SECURITY_ONLY_TOKEN      type DWORD value('00000004'xu);
 dcl JOB_OBJECT_SECURITY_FILTER_TOKENS   type DWORD value('00000008'xu);

 dcl JOB_OBJECT_SECURITY_VALID_FLAGS     type DWORD value('0000000f'xu);


 define ordinal
   JOBOBJECTINFOCLASS
     ( JobObjectBasicAccountingInformation value(1),
       JobObjectBasicLimitInformation,
       JobObjectBasicProcessIdList,
       JobObjectBasicUIRestrictions,
       JobObjectSecurityLimitInformation,
       JobObjectEndOfJobTimeInformation,
       JobObjectAssociateCompletionPortInformation,
       MaxJobObjectInfoClass) prec(31);


 dcl EVENT_MODIFY_STATE      type DWORD value('0002'xu);
 dcl EVENT_ALL_ACCESS        type DWORD
     value (ior(STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE, '0003'xu));
 dcl MUTANT_QUERY_STATE      type DWORD value('0001'xu);
 dcl MUTANT_ALL_ACCESS       type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE,
                 MUTANT_QUERY_STATE));
 dcl SEMAPHORE_MODIFY_STATE  type DWORD value('0002'xu);
 dcl SEMAPHORE_ALL_ACCESS    type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE, '0003'xu));

 /* Timer Specific Access Rights. */


 dcl TIMER_QUERY_STATE       type DWORD value('0001'xn);
 dcl TIMER_MODIFY_STATE      type DWORD value('0002'xn);

 dcl TIMER_ALL_ACCESS        type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE,
                 TIMER_QUERY_STATE, TIMER_MODIFY_STATE));


 dcl TIME_ZONE_ID_UNKNOWN    fixed bin(31) value(0);
 dcl TIME_ZONE_ID_STANDARD   fixed bin(31) value(1);
 dcl TIME_ZONE_ID_DAYLIGHT   fixed bin(31) value(2);

 dcl MAXIMUM_NUMA_NODES      type DWORD value (16);

 define structure
   1 SYSTEM_NUMA_INFORMATION,
     2 HighestNodeNumber type DWORD,
     2 Reserved          type DWORD,
     2 * union,
       3 ActiveProcessorsAffinityMask (MAXIMUM_NUMA_NODES)
                         type ULONGLONG,
       3 AvailableMemory (MAXIMUM_NUMA_NODES) type ULONGLONG;
 define alias PSYSTEM_NUMA_INFORMATION handle SYSTEM_NUMA_INFORMATION;

 dcl PROCESSOR_INTEL_386     fixed bin(31) value(386);
 dcl PROCESSOR_INTEL_486     fixed bin(31) value(486);
 dcl PROCESSOR_INTEL_PENTIUM fixed bin(31) value(586);
 dcl PROCESSOR_INTEL_IA64    fixed bin(31) value(2200);
 dcl PROCESSOR_MIPS_R4000    fixed bin(31) value(4000);
     /* incl R4101 & R3910 for Windows CE */
 dcl PROCESSOR_ALPHA_21064   fixed bin(31) value(21064);
 dcl PROCESSOR_PPC_601       fixed bin(31) value(601);
 dcl PROCESSOR_PPC_603       fixed bin(31) value(603);
 dcl PROCESSOR_PPC_604       fixed bin(31) value(604);
 dcl PROCESSOR_PPC_620       fixed bin(31) value(620);
 /* Windows CE: */
 dcl PROCESSOR_HITACHI_SH3   fixed bin(31) value(10003);
 dcl PROCESSOR_HITACHI_SH3E  fixed bin(31) value(10004);
 dcl PROCESSOR_HITACHI_SH4   fixed bin(31) value(10005);
 dcl PROCESSOR_MOTOROLA_821  fixed bin(31) value(821);
 dcl PROCESSOR_SHx_SH3       fixed bin(31) value(103);
 dcl PROCESSOR_SHx_SH4       fixed bin(31) value(104);
 dcl PROCESSOR_STRONGARM     fixed bin(31) value(2577);  /* 0xA11 */
 dcl PROCESSOR_ARM720        fixed bin(31) value(1824);  /* 0x720 */
 dcl PROCESSOR_ARM820        fixed bin(31) value(2080);  /* 0x820 */
 dcl PROCESSOR_ARM920        fixed bin(31) value(2336);  /* 0x920 */
 dcl PROCESSOR_ARM_7TDMI     fixed bin(31) value(70001);
 dcl PROCESSOR_OPTIL         fixed bin(31) value('494f'xn); /* MSIL */


 dcl PROCESSOR_ARCHITECTURE_INTEL          fixed bin(31) value(0);
 dcl PROCESSOR_ARCHITECTURE_MIPS           fixed bin(31) value(1);
 dcl PROCESSOR_ARCHITECTURE_ALPHA          fixed bin(31) value(2);
 dcl PROCESSOR_ARCHITECTURE_PPC            fixed bin(31) value(3);
 dcl PROCESSOR_ARCHITECTURE_SH             fixed bin(31) value(4);
 dcl PROCESSOR_ARCHITECTURE_ARM            fixed bin(31) value(5);
 dcl PROCESSOR_ARCHITECTURE_IA64           fixed bin(31) value(6);
 dcl PROCESSOR_ARCHITECTURE_ALPHA64        fixed bin(31) value(7);
 dcl PROCESSOR_ARCHITECTURE_MSIL           fixed bin(31) value(8);
 dcl PROCESSOR_ARCHITECTURE_AMD64          fixed bin(31) value(9);
 dcl PROCESSOR_ARCHITECTURE_IA32_ON_WIN64  fixed bin(31) value(10);
 dcl PROCESSOR_ARCHITECTURE_UNKNOWN fixed bin(31) value(-1);/*'ffff'xn*/

 dcl PF_FLOATING_POINT_PRECISION_ERRATA fixed bin(15) value(0);
 dcl PF_FLOATING_POINT_EMULATED         fixed bin(15) value(1);
 dcl PF_COMPARE_EXCHANGE_DOUBLE         fixed bin(15) value(2);
 dcl PF_MMX_INSTRUCTIONS_AVAILABLE      fixed bin(15) value(3);
 dcl PF_PPC_MOVEMEM_64BIT_OK            fixed bin(15) value(4);
 dcl PF_ALPHA_BYTE_INSTRUCTIONS         fixed bin(15) value(5);
 dcl PF_XMMI_INSTRUCTIONS_AVAILABLE     fixed bin(15) value(6);
 dcl PF_AMD3D_INSTRUCTIONS_AVAILABLE    fixed bin(15) value(7);
 dcl PF_RDTSC_INSTRUCTION_AVAILABLE     fixed bin(15) value(8);
 dcl PF_PAE_ENABLED                     fixed bin(15) value(9);
 dcl PF_XMMI64_INSTRUCTIONS_AVAILABLE   fixed bin(15) value(10);

 dcl SYSTEM_FLAG_REMOTE_BOOT_CLIENT  fixed bin(31) value('00000001'xn);
 dcl SYSTEM_FLAG_DISKLESS_CLIENT     fixed bin(31) value('00000002'xn);

 define structure
   1 MEMORY_BASIC_INFORMATION,
     2 BaseAddress       type PVOID,
     2 AllocationBase    type PVOID,
     2 AllocationProtect type DWORD,
     2 RegionSize        type SIZE_T,
     2 State             type DWORD,
     2 Protect           type DWORD,
     2 Type              type DWORD;
 define alias PMEMORY_BASIC_INFORMATION handle MEMORY_BASIC_INFORMATION;

 define structure
   1 MEMORY_BASIC_INFORMATION_VLM,
     2 * union,
       3 BaseAddress               type PVOID64,
       3 BaseAddressAsUlongLong    type ULONGLONG,
     2 * union,
       3 AllocationBase            type PVOID64,
       3 AllocationBaseAsUlongLong type ULONGLONG,

     2 RegionSize                  type ULONGLONG,
     2 AllocationProtect           type DWORD,
     2 State                       type DWORD,
     2 Protect                     type DWORD,
     2 Type                        type DWORD;
 define alias PMEMORY_BASIC_INFORMATION_VLM
              handle MEMORY_BASIC_INFORMATION_VLM;

 dcl SECTION_QUERY       fixed bin(31) value('0001'xn);
 dcl SECTION_MAP_WRITE   fixed bin(31) value('0002'xn);
 dcl SECTION_MAP_READ    fixed bin(31) value('0004'xn);
 dcl SECTION_MAP_EXECUTE fixed bin(31) value('0008'xn);
 dcl SECTION_EXTEND_SIZE fixed bin(31) value('0010'xn);
 dcl SECTION_ALL_ACCESS  fixed bin(31)
     value (ior (STANDARD_RIGHTS_REQUIRED,
                 SECTION_QUERY,
                 SECTION_MAP_WRITE,
                 SECTION_MAP_READ,
                 SECTION_MAP_EXECUTE,
                 SECTION_EXTEND_SIZE));

 dcl PAGE_NOACCESS          type DWORD value (      '01'xu);
 dcl PAGE_READONLY          type DWORD value (      '02'xu);
 dcl PAGE_READWRITE         type DWORD value (      '04'xu);
 dcl PAGE_WRITECOPY         type DWORD value (      '08'xu);
 dcl PAGE_EXECUTE           type DWORD value (      '10'xu);
 dcl PAGE_EXECUTE_READ      type DWORD value (      '20'xu);
 dcl PAGE_EXECUTE_READWRITE type DWORD value (      '40'xu);
 dcl PAGE_EXECUTE_WRITECOPY type DWORD value (      '80'xu);
 dcl PAGE_GUARD             type DWORD value (     '100'xu);
 dcl PAGE_NOCACHE           type DWORD value (     '200'xu);
 dcl MEM_COMMIT             type DWORD value (    '1000'xu);
 dcl MEM_RESERVE            type DWORD value (    '2000'xu);
 dcl MEM_DECOMMIT           type DWORD value (    '4000'xu);
 dcl MEM_RELEASE            type DWORD value (    '8000'xu);
 dcl MEM_FREE               type DWORD value (   '10000'xu);
 dcl MEM_PRIVATE            type DWORD value (   '20000'xu);
 dcl MEM_MAPPED             type DWORD value (   '40000'xu);
 dcl MEM_TOP_DOWN           type DWORD value (  '100000'xu);
 dcl MEM_4MB_PAGES          type DWORD value ('80000000'xu);
 dcl SEC_FILE               type DWORD value (  '800000'xu);
 dcl SEC_IMAGE              type DWORD value ( '1000000'xu);
 dcl SEC_VLM                type DWORD value ( '2000000'xu);
 dcl SEC_RESERVE            type DWORD value ( '4000000'xu);
 dcl SEC_COMMIT             type DWORD value ( '8000000'xu);
 dcl SEC_NOCACHE            type DWORD value ('10000000'xu);
 dcl MEM_IMAGE              type DWORD value (SEC_IMAGE);


 /* Define access rights to files and directories */

 /* The FILE_READ_DATA and FILE_WRITE_DATA constants are also defined */
 /* in devioctl.h as FILE_READ_ACCESS and FILE_WRITE_ACCESS.          */
 /* The values for these constants *MUST* always be in sync.          */
 /* The values are redefined in devioctl.h because they must be       */
 /* available to both DOS and NT.                                     */


 dcl ( FILE_READ_DATA            value('0001'xu) /* file & pipe */
     , FILE_LIST_DIRECTORY       value('0001'xu) /* directory */

     , FILE_WRITE_DATA           value('0002'xu) /* file & pipe */
     , FILE_ADD_FILE             value('0002'xu) /* directory */

     , FILE_APPEND_DATA          value('0004'xu) /* file */
     , FILE_ADD_SUBDIRECTORY     value('0004'xu) /* directory */
     , FILE_CREATE_PIPE_INSTANCE value('0004'xu) /* named pipe */

     , FILE_READ_EA              value('0008'xu) /* file & directory */

     , FILE_WRITE_EA             value('0010'xu) /* file & directory */

     , FILE_EXECUTE              value('0020'xu) /* file */
     , FILE_TRAVERSE             value('0020'xu) /* directory */

     , FILE_DELETE_CHILD         value('0040'xu) /* directory */

     , FILE_READ_ATTRIBUTES      value('0080'xu) /* all */

     , FILE_WRITE_ATTRIBUTES     value('0100'xu) /* all */

     , FILE_ALL_ACCESS           value(ior (STANDARD_RIGHTS_REQUIRED,
                                            SYNCHRONIZE, '01ff'xn))

     , FILE_GENERIC_READ         value(ior (STANDARD_RIGHTS_READ,
                                            FILE_READ_DATA,
                                            FILE_READ_ATTRIBUTES,
                                            FILE_READ_EA,
                                            SYNCHRONIZE))

     , FILE_GENERIC_WRITE        value(ior (STANDARD_RIGHTS_WRITE,
                                            FILE_WRITE_DATA,
                                            FILE_WRITE_ATTRIBUTES,
                                            FILE_WRITE_EA,
                                            FILE_APPEND_DATA,
                                            SYNCHRONIZE))

     , FILE_GENERIC_EXECUTE      value(ior (STANDARD_RIGHTS_EXECUTE,
                                            FILE_READ_ATTRIBUTES,
                                            FILE_EXECUTE,
                                            SYNCHRONIZE))
     ) type DWORD;

 dcl ( FILE_SHARE_READ                    value('00000001'xu)
     , FILE_SHARE_WRITE                   value('00000002'xu)
     , FILE_SHARE_DELETE                  value('00000004'xu)
     , FILE_ATTRIBUTE_READONLY            value('00000001'xu)
     , FILE_ATTRIBUTE_HIDDEN              value('00000002'xu)
     , FILE_ATTRIBUTE_SYSTEM              value('00000004'xu)
     , FILE_ATTRIBUTE_DIRECTORY           value('00000010'xu)
     , FILE_ATTRIBUTE_ARCHIVE             value('00000020'xu)
     , FILE_ATTRIBUTE_DEVICE              value('00000040'xu)
     , FILE_ATTRIBUTE_NORMAL              value('00000080'xu)
     , FILE_ATTRIBUTE_TEMPORARY           value('00000100'xu)
     , FILE_ATTRIBUTE_SPARSE_FILE         value('00000200'xu)
     , FILE_ATTRIBUTE_REPARSE_POINT       value('00000400'xu)
     , FILE_ATTRIBUTE_COMPRESSED          value('00000800'xu)
     , FILE_ATTRIBUTE_OFFLINE             value('00001000'xu)
     , FILE_ATTRIBUTE_NOT_CONTENT_INDEXED value('00002000'xu)
     , FILE_ATTRIBUTE_ENCRYPTED           value('00004000'xu)
     , FILE_NOTIFY_CHANGE_FILE_NAME       value('00000001'xu)
     , FILE_NOTIFY_CHANGE_DIR_NAME        value('00000002'xu)
     , FILE_NOTIFY_CHANGE_ATTRIBUTES      value('00000004'xu)
     , FILE_NOTIFY_CHANGE_SIZE            value('00000008'xu)
     , FILE_NOTIFY_CHANGE_LAST_WRITE      value('00000010'xu)
     , FILE_NOTIFY_CHANGE_LAST_ACCESS     value('00000020'xu)
     , FILE_NOTIFY_CHANGE_CREATION        value('00000040'xu)
     , FILE_NOTIFY_CHANGE_SECURITY        value('00000100'xu)
     , FILE_ACTION_ADDED                  value('00000001'xu)
     , FILE_ACTION_REMOVED                value('00000002'xu)
     , FILE_ACTION_MODIFIED               value('00000003'xu)
     , FILE_ACTION_RENAMED_OLD_NAME       value('00000004'xu)
     , FILE_ACTION_RENAMED_NEW_NAME       value('00000005'xu)
     , MAILSLOT_NO_MESSAGE                value(iunsigned(bin(-1,31)))
     , MAILSLOT_WAIT_FOREVER              value(iunsigned(bin(-1,31)))
     , FILE_CASE_SENSITIVE_SEARCH         value('00000001'xu)
     , FILE_CASE_PRESERVED_NAMES          value('00000002'xu)
     , FILE_UNICODE_ON_DISK               value('00000004'xu)
     , FILE_PERSISTENT_ACLS               value('00000008'xu)
     , FILE_FILE_COMPRESSION              value('00000010'xu)
     , FILE_VOLUME_QUOTAS                 value('00000020'xu)
     , FILE_SUPPORTS_SPARSE_FILES         value('00000040'xu)
     , FILE_SUPPORTS_REPARSE_POINTS       value('00000080'xu)
     , FILE_SUPPORTS_REMOTE_STORAGE       value('00000100'xu)
     , FILE_VOLUME_IS_COMPRESSED          value('00008000'xu)
     , FILE_SUPPORTS_OBJECT_IDS           value('00010000'xu)
     , FILE_SUPPORTS_ENCRYPTION           value('00020000'xu)
     ) type DWORD;

 define structure
   1 FILE_NOTIFY_INFORMATION,
     2 NextEntryOffset type DWORD,
     2 Action          type DWORD,
     2 FileNameLength  type DWORD,    /* byte length of FileName */
     2 FileName        WCHAR (16383);
 define alias PFILE_NOTIFY_INFORMATION handle FILE_NOTIFY_INFORMATION;


 /* Define segement buffer structure for scatter/gather read/write. */

 define structure
   1 FILE_SEGMENT_ELEMENT union,
     2 Buffer    type PVOID64,
     2 Alignment type ULONGLONG;
 define alias PFILE_SEGMENT_ELEMENT handle FILE_SEGMENT_ELEMENT;

 /* Structures for FSCTL_SET_REPARSE_POINT, FSCTL_GET_REPARSE_POINT,  */
 /* and FSCTL_DELETE_REPARSE_POINT                                    */

 /* The reparse structure is used by layered drivers to store data in */
 /* a reparse point.                                                  */

 define structure
   1 REPARSE_DATA_BUFFER,
     2 ReparseTag         type DWORD,
     2 ReparseDataLength  type WORD,
     2 Reserved           type WORD,
     2 * union,
       3 SymbolicLinkReparseBuffer,
         4 SubstituteNameOffset  type WORD,
         4 SubstituteNameLength  type WORD,
         4 PrintNameOffset       type WORD,
         4 PrintNameLength       type WORD,
         4 PathBuffer            WCHAR(1),
       3 MountPointReparseBuffer,
         4 SubstituteNameOffset  type WORD,
         4 SubstituteNameLength  type WORD,
         4 PrintNameOffset       type WORD,
         4 PrintNameLength       type WORD,
         4 PathBuffer            WCHAR(1),
       3 GenericReparseBuffer,
         4  DataBuffer (1)       type BYTE;
 define alias PREPARSE_DATA_BUFFER handle REPARSE_DATA_BUFFER;

 dcl REPARSE_DATA_BUFFER_HEADER_SIZE fixed bin (31)
     value (FIELD_OFFSET (REPARSE_DATA_BUFFER, GenericReparseBuffer));


 /* The reparse GUID structure is used by all 3rd party layered       */
 /* drivers to store data in a reparse point. For non-Microsoft tags, */
 /* The GUID field cannot be GUID_NULL.                               */
 /* The constraints on reparse tags are defined below.                */
 /* Microsoft tags can also be uses with this format of the reparse   */
 /* point buffer.                                                     */


 define structure
   1 REPARSE_GUID_DATA_BUFFER,
     2 ReparseTag        type DWORD,
     2 ReparseDataLength type WORD,
     2 Reserved          type WORD,
     2 ReparseGuid       type GUID,
     2 GenericReparseBuffer,
       3 DataBuffer(1)   type BYTE;
 define alias PREPARSE_GUID_DATA_BUFFER handle REPARSE_GUID_DATA_BUFFER;

 dcl REPARSE_GUID_DATA_BUFFER_HEADER_SIZE fixed bin (31)
     value (FIELD_OFFSET (REPARSE_GUID_DATA_BUFFER,
                          GenericReparseBuffer));


 /* The reparse information structure is used to return information   */
 /* about a reparse point to the caller.                              */

 define structure
   1 REPARSE_POINT_INFORMATION,
     2 ReparseDataLength  type WORD,
     2 UnparsedNameLength type WORD;
 define alias PREPARSE_POINT_INFORMATION
              handle REPARSE_POINT_INFORMATION;

 /* Maximum allowed size of the reparse data.                         */

 dcl MAXIMUM_REPARSE_DATA_BUFFER_SIZE   fixed bin(31) value(16 * 1024);


 /* Predefined reparse tags.                                          */
 /* These tags need to avoid conflicting with IO_REMOUNT defined in   */
 /* ntos\inc\io.h                                                     */


 dcl IO_REPARSE_TAG_RESERVED_ZERO       type DWORD value(0);
 dcl IO_REPARSE_TAG_RESERVED_ONE        type DWORD value(1);

 /* The value of the following constant needs to satisfy the          */
 /* following conditions:                                             */
 /*  (1) Be at least as large as the largest of the reserved tags.    */
 /*  (2) Be strictly smaller than all the tags in use.                */


 dcl IO_REPARSE_TAG_RESERVED_RANGE      type DWORD
     value(IO_REPARSE_TAG_RESERVED_ONE);


 /* The reparse tags are a DWORD. The 32 bits are laid out as follows:*/
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +-+-+-+-------------------------+-------------------------------+ */
 /* |M|L|N|   Reserved bits         |       Reparse Tag Value       | */
 /* +-+-+-+-------------------------+-------------------------------+ */
 /*                                                                   */
 /* M is the Microsoft bit. When set to 1, it denotes a tag owned by  */
 /*   Microsoft. All ISVs must use a tag with a 0 in this position.   */
 /*   Note: If a Microsoft tag is used by non-Microsoft software, the */
 /*   behavior is not defined.                                        */
 /*                                                                   */
 /* L is the high-latency bit. When set to 1, a file with this tag is */
 /*   expected to have a long latency to retrieve the first byte of   */
 /*   data.                                                           */
 /*                                                                   */
 /* N is name surrogate. When set to 1, the file represents another   */
 /*   named entity in the system.                                     */
 /*                                                                   */
 /* The M, L, and N bits are OR-able.                                 */
 /* The following macros check for the M, L and N bit values:         */


 /* Macro to determine whether a reparse point tag corresponds to a   */
 /* tag owned by Microsoft.                                           */

 IsReparseTagMicrosoft: proc (_tag)
                        returns (bit (1) aligned byvalue)
                        options (inline reorder) internal;
   dcl _tag type DWORD byvalue;
   dcl ior builtin;
   return (ior (_tag, '80000000'xu) ^= 0);
 end IsReparseTagMicrosoft;


 /* Macro to determine whether a reparse point tag corresponds to a   */
 /* file that is to be displayed with the slow icon overlay.          */

 IsReparseTagHighLatency: proc (_tag)
                          returns (bit (1) aligned byvalue)
                          options (inline reorder) internal;
   dcl _tag type DWORD byvalue;
   dcl ior builtin;
   return (ior (_tag, '40000000'xu) ^= 0);
 end IsReparseTagHighLatency;


 /* Macro to determine whether a reparse point tag corresponds to a   */
 /* file that is to be displayed with the surrogate icon overlay.     */

 IsReparseTagNameSurrogate: proc (_tag)
                            returns (bit (1) aligned byvalue)
                            options (inline reorder) internal;
   dcl _tag type DWORD byvalue;
   dcl ior builtin;
   return (ior (_tag, '20000000'xu) ^= 0);
 end IsReparseTagNameSurrogate;


 /* The following constant represents the bits that are valid to use  */
 /* in reparse tags.                                                  */

 dcl IO_REPARSE_TAG_VALID_VALUES      type DWORD value('E000FFFF'xu);

 /* Macro to determine whether a reparse tag is a valid tag.          */

 IsReparseTagValid: proc (_tag)
                    returns (bit (1) aligned byvalue)
                    options (inline reorder) internal;
   dcl _tag type DWORD byvalue;
   dcl (iand, inot) builtin;
   return (iand (_tag, inot (IO_REPARSE_TAG_VALID_VALUES)) = 0
           & _tag > IO_REPARSE_TAG_RESERVED_RANGE);
 end IsReparseTagValid;


 /* Microsoft tags for reparse points. */

 dcl IO_REPARSE_TAG_SYMBOLIC_LINK       type DWORD
     value(IO_REPARSE_TAG_RESERVED_ZERO);
 dcl IO_REPARSE_TAG_MOUNT_POINT         type DWORD value('A0000003'xu);
 dcl IO_REPARSE_TAG_HSM                 type DWORD value('C0000004'xu);
 dcl IO_REPARSE_TAG_NSS                 type DWORD value('80000005'xu);
 dcl IO_REPARSE_TAG_NSSRECOVER          type DWORD value('80000006'xu);
 dcl IO_REPARSE_TAG_SIS                 type DWORD value('80000007'xu);
 dcl IO_REPARSE_TAG_DFS                 type DWORD value('80000008'xu);

 dcl IO_COMPLETION_MODIFY_STATE         type DWORD value('0002'xu);
 dcl IO_COMPLETION_ALL_ACCESS           type DWORD
     value (ior (STANDARD_RIGHTS_REQUIRED, SYNCHRONIZE, '0003'xu));

 dcl DUPLICATE_CLOSE_SOURCE             type DWORD value('00000001'xu);
 dcl DUPLICATE_SAME_ACCESS              type DWORD value('00000002'xu);


 define ordinal SYSTEM_POWER_STATE
   ( PowerSystemUnspecified value(0),
     PowerSystemWorking     value(1),
     PowerSystemSleeping1   value(2),
     PowerSystemSleeping2   value(3),
     PowerSystemSleeping3   value(4),
     PowerSystemHibernate   value(5),
     PowerSystemShutdown    value(6),
     PowerSystemMaximum     value(7)
   ) prec (31);
 dcl PSYSTEM_POWER_STATE pointer;

 dcl POWER_SYSTEM_MAXIMUM fixed bin(31) value(7);

 define ordinal POWER_ACTION
   ( PowerActionNone value(0),
     PowerActionReserved,
     PowerActionSleep,
     PowerActionHibernate,
     PowerActionShutdown,
     PowerActionShutdownReset,
     PowerActionShutdownOff,
     PowerActionWarmEject
   ) prec(31);
 dcl PPOWER_ACTION pointer;

 define ordinal DEVICE_POWER_STATE
   ( PowerDeviceUnspecified value(0),
     PowerDeviceD0,
     PowerDeviceD1,
     PowerDeviceD2,
     PowerDeviceD3,
     PowerDeviceMaximum
   ) prec(31);
 dcl PDEVICE_POWER_STATE pointer;


 dcl ES_SYSTEM_REQUIRED  type DWORD  value('00000001'xu);
 dcl ES_DISPLAY_REQUIRED type DWORD  value('00000002'xu);
 dcl ES_USER_PRESENT     type DWORD  value('00000004'xu);
 dcl ES_CONTINUOUS       type DWORD  value('80000000'xu);

 define alias EXECUTION_STATE type DWORD;

 define ordinal LATENCY_TIME
   ( LT_DONT_CARE,
     LT_LOWEST_LATENCY
   ) prec (31);


 /*-------------------------------------------------------------------*/
 /* Device Power Information                                          */
 /* Accessable via CM_Get_DevInst_Registry_Property_Ex                */
 /* (CM_DRP_DEVICE_POWER_DATA)                                        */
 /*-------------------------------------------------------------------*/

 dcl PDCAP_D0_SUPPORTED           type DWORD value('00000001'xu);
 dcl PDCAP_D1_SUPPORTED           type DWORD value('00000002'xu);
 dcl PDCAP_D2_SUPPORTED           type DWORD value('00000004'xu);
 dcl PDCAP_D3_SUPPORTED           type DWORD value('00000008'xu);
 dcl PDCAP_WAKE_FROM_D0_SUPPORTED type DWORD value('00000010'xu);
 dcl PDCAP_WAKE_FROM_D1_SUPPORTED type DWORD value('00000020'xu);
 dcl PDCAP_WAKE_FROM_D2_SUPPORTED type DWORD value('00000040'xu);
 dcl PDCAP_WAKE_FROM_D3_SUPPORTED type DWORD value('00000080'xu);
 dcl PDCAP_WARM_EJECT_SUPPORTED   type DWORD value('00000100'xu);

 define structure
   1 CM_POWER_DATA,
     2 PD_Size                 type DWORD,
     2 PD_MostRecentPowerState type DEVICE_POWER_STATE,
     2 PD_Capabilities         type DWORD,
     2 PD_D1Latency            type DWORD,
     2 PD_D2Latency            type DWORD,
     2 PD_D3Latency            type DWORD,
     2 PD_PowerStateMapping (POWER_SYSTEM_MAXIMUM)
                               type DEVICE_POWER_STATE,
     2 PD_DeepestSystemWake    type SYSTEM_POWER_STATE;
 define alias PCM_POWER_DATA handle CM_POWER_DATA;

 define ordinal POWER_INFORMATION_LEVEL
   ( SystemPowerPolicyAc,
     SystemPowerPolicyDc,
     VerifySystemPolicyAc,
     VerifySystemPolicyDc,
     SystemPowerCapabilities,
     SystemBatteryState,
     SystemPowerStateHandler,
     ProcessorStateHandler,
     SystemPowerPolicyCurrent,
     AdministratorPowerPolicy,
     SystemReserveHiberFile,
     ProcessorInformation,
     SystemPowerInformation,
     ProcessorStateHandler2,
     LastWakeTime,             /* Compare with KeQueryInterruptTime() */
     LastSleepTime,            /* Compare with KeQueryInterruptTime() */
     SystemExecutionState,
     SystemPowerStateNotifyHandler,
     ProcessorPowerPolicyAc,
     ProcessorPowerPolicyDc,
     VerifyProcessorPowerPolicyAc,
     VerifyProcessorPowerPolicyDc,
     ProcessorPowerPolicyCurrent
   ) prec(31);


 /* System power manager capabilities */


 define structure
   1 BATTERY_REPORTING_SCALE,
     2 Granularity type DWORD,
     2 Capacity    type DWORD;
 define alias PBATTERY_REPORTING_SCALE handle BATTERY_REPORTING_SCALE;

 /* Power Policy Management interfaces */

 define structure
   1 POWER_ACTION_POLICY,
     2 Action    type POWER_ACTION,
     2 Flags     type DWORD,
     2 EventCode type DWORD;
 define alias PPOWER_ACTION_POLICY handle POWER_ACTION_POLICY;

 /* POWER_ACTION_POLICY.Flags: */
 dcl POWER_ACTION_QUERY_ALLOWED    type DWORD value('00000001'xu);
 dcl POWER_ACTION_UI_ALLOWED       type DWORD value('00000002'xu);
 dcl POWER_ACTION_OVERRIDE_APPS    type DWORD value('00000004'xu);
 dcl POWER_ACTION_LIGHTEST_FIRST   type DWORD value('10000000'xu);
 dcl POWER_ACTION_LOCK_CONSOLE     type DWORD value('20000000'xu);
 dcl POWER_ACTION_DISABLE_WAKES    type DWORD value('40000000'xu);
 dcl POWER_ACTION_CRITICAL         type DWORD value('80000000'xu);

 /* POWER_ACTION_POLICY.EventCode flags */
 dcl POWER_LEVEL_USER_NOTIFY_TEXT  type DWORD value('00000001'xu);
 dcl POWER_LEVEL_USER_NOTIFY_SOUND type DWORD value('00000002'xu);
 dcl POWER_LEVEL_USER_NOTIFY_EXEC  type DWORD value('00000004'xu);
 dcl POWER_USER_NOTIFY_BUTTON      type DWORD value('00000008'xu);
 dcl POWER_USER_NOTIFY_SHUTDOWN    type DWORD value('00000010'xu);
 dcl POWER_FORCE_TRIGGER_RESET     type DWORD value('80000000'xu);

 /* system battery drain policies */
 define structure
   1 SYSTEM_POWER_LEVEL,
     2 Enable         type BOOLEAN,
     2 Spare (3)      type BYTE,
     2 BatteryLevel   type DWORD,
     2 PowerPolicy    type POWER_ACTION_POLICY,
     2 MinSystemState type SYSTEM_POWER_STATE;
 define alias PSYSTEM_POWER_LEVEL handle SYSTEM_POWER_LEVEL;

 /* Discharge policy constants */
 dcl NUM_DISCHARGE_POLICIES    fixed bin(31) value(4);
 dcl DISCHARGE_POLICY_CRITICAL fixed bin(31) value(0);
 dcl DISCHARGE_POLICY_LOW      fixed bin(31) value(1);

 /* Throttling policies */
 dcl PO_THROTTLE_NONE          fixed bin(31) value(0);
 dcl PO_THROTTLE_CONSTANT      fixed bin(31) value(1);
 dcl PO_THROTTLE_DEGRADE       fixed bin(31) value(2);
 dcl PO_THROTTLE_ADAPTIVE      fixed bin(31) value(3);
 dcl PO_THROTTLE_MAXIMUM       fixed bin(31) value(4);
     /* not a policy, just a limit */

 /* system power policies */
 define structure
   1 SYSTEM_POWER_POLICY,
     2 Revision             type DWORD, /* 1 */
     /* events */
     2 PowerButton          type POWER_ACTION_POLICY,
     2 SleepButton          type POWER_ACTION_POLICY,
     2 LidClose             type POWER_ACTION_POLICY,
     2 LidOpenWake          type SYSTEM_POWER_STATE,
     2 Reserved             type DWORD,
     /* "system idle" detection */
     2 Idle                 type POWER_ACTION_POLICY,
     2 IdleTimeout          type DWORD,
     2 IdleSensitivity      type BYTE,
     /* dynamic throttling policy */
     /* PO_THROTTLE_NONE, PO_THROTTLE_CONSTANT,     */
     /* PO_THROTTLE_DEGRADE or PO_THROTTLE_ADAPTIVE */
     2 DynamicThrottle      type BYTE,
     2 Spare2 (2)           type BYTE,
     /* meaning of power action "sleep" */
     2 MinSleep             type SYSTEM_POWER_STATE,
     2 MaxSleep             type SYSTEM_POWER_STATE,
     2 ReducedLatencySleep  type SYSTEM_POWER_STATE,
     2 WinLogonFlags        type DWORD,
     /* parameters for dozing */
     2 Spare3               type DWORD,
     2 DozeS4Timeout        type DWORD,
     /* battery policies */
     2 BroadcastCapacityResolution type DWORD,
     2 DischargePolicy (NUM_DISCHARGE_POLICIES) type SYSTEM_POWER_LEVEL,
     /* video policies */
     2 VideoTimeout         type DWORD,
     2 VideoDimDisplay      type BOOLEAN,
     2 VideoReserved (3)    type DWORD,
     /* hard disk policies */
     2 SpindownTimeout      type DWORD,
     /* processor policies */
     2 OptimizeForPower     type BOOLEAN,
     2 FanThrottleTolerance type BYTE,
     2 ForcedThrottle       type BYTE,
     2 MinThrottle          type BYTE,
     2 OverThrottled        type POWER_ACTION_POLICY;
 define alias PSYSTEM_POWER_POLICY handle SYSTEM_POWER_POLICY;

 /* processor power policy state */
 define structure
   1 PROCESSOR_POWER_POLICY_INFO,
     /* Time based information (will be converted to kernel units) */
     2 TimeCheck      type DWORD,/* in US */
     2 DemoteLimit    type DWORD,/* in US */
     2 PromoteLimit   type DWORD,/* in US */
     /* Percentage based information */
     2 DemotePercent  type BYTE,
     2 PromotePercent type BYTE,
     2 Spare (2)      type BYTE,
     /* Flags */
     2 Reserved       bit (30) unaligned,
     2 AllowPromotion bit (1) unaligned,
     2 AllowDemotion  bit (1) unaligned;
 define alias PPROCESSOR_POWER_POLICY_INFO
        handle PROCESSOR_POWER_POLICY_INFO;

 /* processor power policy */
 define structure
   1 PROCESSOR_POWER_POLICY,
     2 Revision           type DWORD,/* 1 */
     /* Dynamic Throttling Policy */
     2 DynamicThrottle    type BYTE,
     2 Spare (3)          type BYTE,
     /* Flags */
     2 Reserved           type DWORD,
     /* System policy information */
     /* The Array is last, in case it needs to be grown and */
     /* the structure revision incremented.                 */
     2 PolicyCount        type DWORD,
     2 Policy (3)         type PROCESSOR_POWER_POLICY_INFO;
 define alias PPROCESSOR_POWER_POLICY handle PROCESSOR_POWER_POLICY;

 /* administrator power policy overrides */
 define structure
   1 ADMINISTRATOR_POWER_POLICY,
     /* meaning of power action "sleep" */
     2 MinSleep           type SYSTEM_POWER_STATE,
     2 MaxSleep           type SYSTEM_POWER_STATE,
     /* video policies */
     2 MinVideoTimeout    type DWORD,
     2 MaxVideoTimeout    type DWORD,
     /* disk policies */
     2 MinSpindownTimeout type DWORD,
     2 MaxSpindownTimeout type DWORD;
 define alias PADMINISTRATOR_POWER_POLICY
        handle ADMINISTRATOR_POWER_POLICY;


 define structure
   1 SYSTEM_POWER_CAPABILITIES,
     /* Misc supported system features */
     2 PowerButtonPresent     type BOOLEAN,
     2 SleepButtonPresent     type BOOLEAN,
     2 LidPresent             type BOOLEAN,
     2 SystemS1               type BOOLEAN,
     2 SystemS2               type BOOLEAN,
     2 SystemS3               type BOOLEAN,
     2 SystemS4               type BOOLEAN, /* hibernate */
     2 SystemS5               type BOOLEAN, /* off */
     2 HiberFilePresent       type BOOLEAN,
     2 FullWake               type BOOLEAN,
     2 VideoDimPresent        type BOOLEAN,
     2 ApmPresent             type BOOLEAN,
     2 UpsPresent             type BOOLEAN,
     /* Processors */
     2 ThermalControl         type BOOLEAN,
     2 ProcessorThrottle      type BOOLEAN,
     2 ProcessorMinThrottle   type BYTE,
     2 ProcessorMaxThrottle   type BYTE,
     2 spare2 (4)             type BYTE,
     /* Disk */
     2 DiskSpinDown           type BOOLEAN,
     2 spare3 (8)             type BYTE,
     /* System Battery */
     2 SystemBatteriesPresent type BOOLEAN,
     2 BatteriesAreShortTerm  type BOOLEAN,
     2 BatteryScale (3)       type BATTERY_REPORTING_SCALE,
     /* Wake */
     2 AcOnLineWake           type SYSTEM_POWER_STATE,
     2 SoftLidWake            type SYSTEM_POWER_STATE,
     2 RtcWake                type SYSTEM_POWER_STATE,
     2 MinDeviceWakeState     type SYSTEM_POWER_STATE,
         /* note this may change on driver load */
     2 DefaultLowLatencyWake  type SYSTEM_POWER_STATE;
 define alias PSYSTEM_POWER_CAPABILITIES
        handle SYSTEM_POWER_CAPABILITIES;

 define structure
   1 SYSTEM_BATTERY_STATE,
     2 AcOnLine          type BOOLEAN,
     2 BatteryPresent    type BOOLEAN,
     2 Charging          type BOOLEAN,
     2 Discharging       type BOOLEAN,
     2 Spare1 (4)        type BOOLEAN,
     2 MaxCapacity       type DWORD,
     2 RemainingCapacity type DWORD,
     2 Rate              type DWORD,
     2 EstimatedTime     type DWORD,
     2 DefaultAlert1     type DWORD,
     2 DefaultAlert2     type DWORD;
 define alias PSYSTEM_BATTERY_STATE handle SYSTEM_BATTERY_STATE;


 /********************************************************************/
 /*                       SECURITY_DESCRIPTOR                        */
 /*                                                                  */
 /********************************************************************/

 /* Define the Security Descriptor and related data types.           */
 /* This is an opaque data structure.                                */

 /* Current security descriptor revision value                       */

 %dcl SECURITY_DESCRIPTOR_REVISION  fixed ext;
 %SECURITY_DESCRIPTOR_REVISION  = 1;

 %dcl SECURITY_DESCRIPTOR_REVISION1 fixed ext;
 %SECURITY_DESCRIPTOR_REVISION1 = 1;

 /* Minimum length, in bytes, needed to build a security descriptor */
 /* NOTE: This must manually be kept consistent with                */
 /*  size (: SECURITY_DESCRIPTOR :)                                 */
 dcl SECURITY_DESCRIPTOR_MIN_LENGTH fixed bin (31) value (20);

 define alias  SECURITY_DESCRIPTOR_CONTROL type WORD;
 define alias PSECURITY_DESCRIPTOR_CONTROL pointer;

 dcl SE_OWNER_DEFAULTED       type WORD value('0001'xn);
 dcl SE_GROUP_DEFAULTED       type WORD value('0002'xn);
 dcl SE_DACL_PRESENT          type WORD value('0004'xn);
 dcl SE_DACL_DEFAULTED        type WORD value('0008'xn);
 dcl SE_SACL_PRESENT          type WORD value('0010'xn);
 dcl SE_SACL_DEFAULTED        type WORD value('0020'xn);
 dcl SE_DACL_AUTO_INHERIT_REQ type WORD value('0100'xn);
 dcl SE_SACL_AUTO_INHERIT_REQ type WORD value('0200'xn);
 dcl SE_DACL_AUTO_INHERITED   type WORD value('0400'xn);
 dcl SE_SACL_AUTO_INHERITED   type WORD value('0800'xn);
 dcl SE_DACL_PROTECTED        type WORD value('1000'xn);
 dcl SE_SACL_PROTECTED        type WORD value('2000'xn);
 dcl SE_SELF_RELATIVE         type WORD value('8000'xn);


 /* Where:                                                            */
 /*                                                                   */
 /* SE_OWNER_DEFAULTED - This boolean flag, when set, indicates that  */
 /*     the SID pointed to by the Owner field was provided by a       */
 /*     defaulting mechanism rather than explicitly provided by the   */
 /*     original provider of the security descriptor. This may        */
 /*     affect the treatment of the SID with respect to inheritence   */
 /*     of an owner.                                                  */
 /*                                                                   */
 /* SE_GROUP_DEFAULTED - This boolean flag, when set, indicates that  */
 /*     the SID in the Group field was provided by a defaulting       */
 /*     mechanism rather than explicitly provided by the original     */
 /*     provider of the security descriptor. This may affect the      */
 /*     treatment of the SID with respect to inheritence of a primary */
 /*     group.                                                        */
 /*                                                                   */
 /* SE_DACL_PRESENT - This boolean flag, when set, indicates that the */
 /*     security descriptor contains a discretionary ACL. If this     */
 /*     flag is set and the Dacl field of the SECURITY_DESCRIPTOR is  */
 /*     null, then a null ACL is explicitly being specified.          */
 /*                                                                   */
 /* SE_DACL_DEFAULTED - This boolean flag, when set, indicates that   */
 /*     the ACL pointed to by the Dacl field was provided by a        */
 /*     defaulting mechanism rather than explicitly provided by the   */
 /*     original provider of the security descriptor. This may affect */
 /*     the treatment of the ACL with respect to inheritence of an    */
 /*     ACL. This flag is ignored if the DaclPresent flag is not set. */
 /*                                                                   */
 /* SE_SACL_PRESENT - This boolean flag, when set,  indicates that    */
 /*     the security descriptor contains a system ACL pointed to by   */
 /*     the Sacl field.  If this flag is set and the Sacl field of    */
 /*     the SECURITY_DESCRIPTOR is null, then an empty (but present)  */
 /*     ACL is being specified.                                       */
 /*                                                                   */
 /* SE_SACL_DEFAULTED - This boolean flag, when set, indicates that   */
 /*     the ACL pointed to by the Sacl field was provided by a        */
 /*     defaulting mechanism rather than explicitly provided by the   */
 /*     original provider of the security descriptor. This may affect */
 /*     the treatment of the ACL with respect to inheritence of an    */
 /*     ACL. This flag is ignored if the SaclPresent flag is not set. */
 /*                                                                   */
 /* SE_SELF_RELATIVE - This boolean flag, when set, indicates that    */
 /*     the security descriptor is in self-relative form. In this     */
 /*     form, all fields of the security descriptor are contiguous in */
 /*     memory and all pointer fields are expressed as offsets from   */
 /*     the beginning of the security descriptor. This form is useful */
 /*     for treating security descriptors as opaque data structures   */
 /*     for transmission in communication protocol or for storage on  */
 /*     secondary media.                                              */
 /*                                                                   */
 /*                                                                   */
 /* Pictorially the structure of a security descriptor is as follows: */
 /*                                                                   */
 /*  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1                      */
 /*  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0  */
 /* +---------------------------------------------------------------+ */
 /* |            Control            |Reserved1 (SBZ)|   Revision    | */
 /* +---------------------------------------------------------------+ */
 /* |                            Owner                              | */
 /* +---------------------------------------------------------------+ */
 /* |                            Group                              | */
 /* +---------------------------------------------------------------+ */
 /* |                            Sacl                               | */
 /* +---------------------------------------------------------------+ */
 /* |                            Dacl                               | */
 /* +---------------------------------------------------------------+ */
 /*                                                                   */
 /* In general, this data structure should be treated opaquely to     */
 /* ensure future compatibility.                                      */

 define structure
   1 SECURITY_DESCRIPTOR_RELATIVE,
     2 Revision type BYTE,
     2 Sbz1     type BYTE,
     2 Control  type SECURITY_DESCRIPTOR_CONTROL,
     2 Owner    type DWORD,
     2 Group    type DWORD,
     2 Sacl     type DWORD,
     2 Dacl     type DWORD;
 define alias PISECURITY_DESCRIPTOR_RELATIVE
        handle SECURITY_DESCRIPTOR_RELATIVE;

 define structure
   1 SECURITY_DESCRIPTOR,
     2 Revision type BYTE,
     2 Sbz1     type BYTE,
     2 Control  type SECURITY_DESCRIPTOR_CONTROL,
     2 Owner    type PSID,
     2 Group    type PSID,
     2 Sacl     type PACL,
     2 Dacl     type PACL;
 define alias PISECURITY_DESCRIPTOR handle SECURITY_DESCRIPTOR;

 /*********************************************************************/
 /* Where:                                                            */
 /* Revision - Contains the revision level of the security            */
 /*     descriptor.  This allows this structure to be passed between  */
 /*     systems or stored on disk even though it is expected to       */
 /*     change in the future.                                         */
 /*                                                                   */
 /* Control - A set of flags which qualify the meaning of the         */
 /*     security descriptor or individual fields of the security      */
 /*     descriptor.                                                   */
 /*                                                                   */
 /* Owner - is a pointer to an SID representing an object's owner.    */
 /*     If this field is null, then no owner SID is present in the    */
 /*     security descriptor.  If the security descriptor is in        */
 /*     self-relative form, then this field contains an offset to     */
 /*     the SID, rather than a pointer.                               */
 /*                                                                   */
 /* Group - is a pointer to an SID representing an object's primary   */
 /*     group.  If this field is null, then no primary group SID is   */
 /*     present in the security descriptor.  If the security descript */
 /*     is in self-relative form, then this field contains an offset  */
 /*     the SID, rather than a pointer.                               */
 /*                                                                   */
 /* Sacl - is a pointer to a system ACL.  This field value is only    */
 /*     valid if the DaclPresent control flag is set.  If the         */
 /*     SaclPresent flag is set and this field is null, then a null   */
 /*     ACL  is specified.  If the security descriptor is in          */
 /*     self-relative form, then this field contains an offset to     */
 /*     the ACL, rather than a pointer.                               */
 /*                                                                   */
 /* Dacl - is a pointer to a discretionary ACL.  This field value is  */
 /*     only valid if the DaclPresent control flag is set.  If the    */
 /*     DaclPresent flag is set and this field is null, then a null   */
 /*     ACL (unconditionally granting access) is specified.  If the   */
 /*     security descriptor is in self-relative form, then this field */
 /*     contains an offset to the ACL, rather than a pointer.         */
 /*********************************************************************/


 /*******************************************************************/
 /*                                                                 */
 /*           Object Type list for AccessCheckByType                */
 /*                                                                 */
 /*******************************************************************/

 define structure
   1 OBJECT_TYPE_LIST,
     2 Level      type WORD,
     2 Sbz        type WORD,
     2 ObjectType handle GUID;
 define alias POBJECT_TYPE_LIST handle OBJECT_TYPE_LIST;


 /* DS values for Level */

 dcl ACCESS_OBJECT_GUID       type WORD value(0);
 dcl ACCESS_PROPERTY_SET_GUID type WORD value(1);
 dcl ACCESS_PROPERTY_GUID     type WORD value(2);

 dcl ACCESS_MAX_LEVEL         type WORD value(4);

 /* Parameters to NtAccessCheckByTypeAndAditAlarm */

 define ordinal
   AUDIT_EVENT_TYPE
   ( AuditEventObjectAccess,
     AuditEventDirectoryServiceAccess) prec(31);
 define alias PAUDIT_EVENT_TYPE pointer;

 dcl AUDIT_ALLOW_NO_PRIVILEGE type WORD value ('1'xn);


 /* DS values for Source and ObjectTypeName */

 dcl ACCESS_DS_SOURCE_A char  value ('DS');
 dcl ACCESS_DS_SOURCE_W WCHAR value ('DS');
 dcl ACCESS_DS_OBJECT_TYPE_NAME_A char
     value ('Directory Service Object');
 dcl ACCESS_DS_OBJECT_TYPE_NAME_W WCHAR
     value ('Directory Service Object');

 /*******************************************************************/
 /*                                                                 */
 /*           Privilege Related Data Structures                     */
 /*                                                                 */
 /*******************************************************************/

 /* Privilege attributes */

 dcl SE_PRIVILEGE_ENABLED_BY_DEFAULT type DWORD value('00000001'xu);
 dcl SE_PRIVILEGE_ENABLED            type DWORD value('00000002'xu);
 dcl SE_PRIVILEGE_USED_FOR_ACCESS    type DWORD value('80000000'xu);

 /* Privilege Set Control flags */

 dcl PRIVILEGE_SET_ALL_NECESSARY     type DWORD value(1);


 /* Privilege Set - This is defined for a privilege set of one.      */
 /* If more than one privilege is needed, then this structure        */
 /* will need to be allocated with more space.                       */
 /*                                                                  */
 /* Note: don't change this structure without fixing the             */
 /* INITIAL_PRIVILEGE_SET structure (defined in se.h)                */

 define structure
   1 PRIVILEGE_SET,
     2 PrivilegeCount type DWORD,
     2 Control        type DWORD,
     2 Privilege (ANYSIZE_ARRAY) type LUID_AND_ATTRIBUTES;
 define alias PPRIVILEGE_SET handle PRIVILEGE_SET;



 /********************************************************************/
 /*                                                                  */
 /*               NT Defined Privileges                              */
 /*                                                                  */
 /********************************************************************/

 dcl SE_CREATE_TOKEN_NAME        TCHAR
     value ('SeCreateTokenPrivilege');
 dcl SE_ASSIGNPRIMARYTOKEN_NAME  TCHAR
     value ('SeAssignPrimaryTokenPrivilege');
 dcl SE_LOCK_MEMORY_NAME         TCHAR
     value ('SeLockMemoryPrivilege');
 dcl SE_INCREASE_QUOTA_NAME      TCHAR
     value ('SeIncreaseQuotaPrivilege');
 dcl SE_UNSOLICITED_INPUT_NAME   TCHAR
     value ('SeUnsolicitedInputPrivilege');
 dcl SE_MACHINE_ACCOUNT_NAME     TCHAR
     value ('SeMachineAccountPrivilege');
 dcl SE_TCB_NAME                 TCHAR
     value ('SeTcbPrivilege');
 dcl SE_SECURITY_NAME            TCHAR
     value ('SeSecurityPrivilege');
 dcl SE_TAKE_OWNERSHIP_NAME      TCHAR
     value ('SeTakeOwnershipPrivilege');
 dcl SE_LOAD_DRIVER_NAME         TCHAR
     value ('SeLoadDriverPrivilege');
 dcl SE_SYSTEM_PROFILE_NAME      TCHAR
     value ('SeSystemProfilePrivilege');
 dcl SE_SYSTEMTIME_NAME          TCHAR
     value ('SeSystemtimePrivilege');
 dcl SE_PROF_SINGLE_PROCESS_NAME TCHAR
     value ('SeProfileSingleProcessPrivilege');
 dcl SE_INC_BASE_PRIORITY_NAME   TCHAR
     value ('SeIncreaseBasePriorityPrivilege');
 dcl SE_CREATE_PAGEFILE_NAME     TCHAR
     value ('SeCreatePagefilePrivilege');
 dcl SE_CREATE_PERMANENT_NAME    TCHAR
     value ('SeCreatePermanentPrivilege');
 dcl SE_BACKUP_NAME              TCHAR
     value ('SeBackupPrivilege');
 dcl SE_RESTORE_NAME             TCHAR
     value ('SeRestorePrivilege');
 dcl SE_SHUTDOWN_NAME            TCHAR
     value ('SeShutdownPrivilege');
 dcl SE_DEBUG_NAME               TCHAR
     value ('SeDebugPrivilege');
 dcl SE_AUDIT_NAME               TCHAR
     value ('SeAuditPrivilege');
 dcl SE_SYSTEM_ENVIRONMENT_NAME  TCHAR
     value ('SeSystemEnvironmentPrivilege');
 dcl SE_CHANGE_NOTIFY_NAME       TCHAR
     value ('SeChangeNotifyPrivilege');
 dcl SE_REMOTE_SHUTDOWN_NAME     TCHAR
     value ('SeRemoteShutdownPrivilege');
 dcl SE_UNDOCK_NAME              TCHAR
     value('SeUndockPrivilege');
 dcl SE_SYNC_AGENT_NAME          TCHAR
     value('SeSyncAgentPrivilege');
 dcl SE_ENABLE_DELEGATION_NAME   TCHAR
     value('SeEnableDelegationPrivilege');
 dcl SE_MANAGE_VOLUME_NAME       TCHAR
     value('SeManageVolumePrivilege');

 /* Security Tracking Mode                              */

 dcl SECURITY_DYNAMIC_TRACKING type BOOLEAN value (TRUE);
 dcl SECURITY_STATIC_TRACKING  type BOOLEAN value (FALSE);

 define alias SECURITY_CONTEXT_TRACKING_MODE type BOOLEAN;
 dcl PSECURITY_CONTEXT_TRACKING_MODE pointer;


 /* Quality Of Service */

 define structure
   1 SECURITY_QUALITY_OF_SERVICE,
     2 Length              type DWORD,
     2 ImpersonationLevel  type SECURITY_IMPERSONATION_LEVEL,
     2 ContextTrackingMode type SECURITY_CONTEXT_TRACKING_MODE,
     2 EffectiveOnly       type BOOLEAN;
 define alias PSECURITY_QUALITY_OF_SERVICE
              handle SECURITY_QUALITY_OF_SERVICE;


 /* Used to represent information related to a thread impersonation */

 define structure
   1 SE_IMPERSONATION_STATE,
     2 Token         type PACCESS_TOKEN,
     2 CopyOnOpen    type BOOLEAN,
     2 EffectiveOnly type BOOLEAN,
     2 Level         type SECURITY_IMPERSONATION_LEVEL;

 define alias PSE_IMPERSONATION_STATE handle SE_IMPERSONATION_STATE;

 define alias  SECURITY_INFORMATION type DWORD;
 define alias PSECURITY_INFORMATION pointer;

 dcl OWNER_SECURITY_INFORMATION type DWORD value('00000001'xu);
 dcl GROUP_SECURITY_INFORMATION type DWORD value('00000002'xu);
 dcl DACL_SECURITY_INFORMATION  type DWORD value('00000004'xu);
 dcl SACL_SECURITY_INFORMATION  type DWORD value('00000008'xu);

 dcl PROTECTED_DACL_SECURITY_INFORMATION
                                type DWORD value('80000000'xu);
 dcl PROTECTED_SACL_SECURITY_INFORMATION
                                type DWORD value('40000000'xu);


 define structure
   1 POWER_DEVICE_TIMEOUTS,
     2 ConservationIdleTime type DWORD,
     2 PerformanceIdleTime  type DWORD;
 define alias PPOWER_DEVICE_TIMEOUTS handle POWER_DEVICE_TIMEOUTS;

 /* Image Format */

 dcl IMAGE_DOS_SIGNATURE    fixed bin(15) value('5A4D'xn); /* MZ */
 dcl IMAGE_OS2_SIGNATURE    fixed bin(15) value('454E'xn); /* NE */
 dcl IMAGE_OS2_SIGNATURE_LE fixed bin(15) value('454C'xn); /* LE */
 dcl IMAGE_VXD_SIGNATURE    fixed bin(15) value('454C'xn); /* LE */
 dcl IMAGE_NT_SIGNATURE     fixed bin(31) value('00004550'xn); /* PE00*/

 define structure
   1 IMAGE_DOS_HEADER,   /* DOS .EXE header */
     2 e_magic    type WORD,/* Magic number */
     2 e_cblp     type WORD,/* Bytes on last page of file */
     2 e_cp       type WORD,/* Pages in file */
     2 e_crlc     type WORD,/* Relocations */
     2 e_cparhdr  type WORD,/* Size of header in paragraphs */
     2 e_minalloc type WORD,/* Minimum extra paragraphs needed */
     2 e_maxalloc type WORD,/* Maximum extra paragraphs needed */
     2 e_ss       type WORD,/* Initial (relative) SS value */
     2 e_sp       type WORD,/* Initial SP value */
     2 e_csum     type WORD,/* Checksum */
     2 e_ip       type WORD,/* Initial IP value */
     2 e_cs       type WORD,/* Initial (relative) CS value */
     2 e_llc      type WORD,/* File address of relocation table */
     2 e_ovno     type WORD,/* Overlay number */
     2 e_res(4)   type WORD,/* Reserved words */
     2 e_oemid    type WORD,/* OEM identifier (for e_oeminfo) */
     2 e_oeminfo  type WORD,/* OEM information; e_oemid specific */
     2 e_res2(10) type WORD,/* Reserved words */
     2 e_lfanew   type LONG;/* File address of new exe header */

 define alias PIMAGE_DOS_HEADER handle IMAGE_DOS_HEADER;

 define structure
   1 IMAGE_OS2_HEADER,   /* OS/2 .EXE header */
    2 ne_magic        type WORD,/* Magic number */
    2 ne_ver          CHAR,     /* Version number */
    2 ne_rev          CHAR,     /* Revision number */
    2 ne_enttab       type WORD,/* Offset of Entry Table */
    2 ne_cbenttab     type WORD,/* Number of bytes in Entry Table */
    2 ne_crc          type LONG,/* Checksum of whole file */
    2 ne_flags        type WORD,/* Flag word */
    2 ne_autodata     type WORD,/* Automatic data segment number */
    2 ne_heap         type WORD,/* Initial heap allocation */
    2 ne_stack        type WORD,/* Initial stack allocation */
    2 ne_csip         type LONG,/* Initial CS:IP setting */
    2 ne_sssp         type LONG,/* Initial SS:SP setting */
    2 ne_cseg         type WORD,/* Count of file segments */
    2 ne_cmod         type WORD,/* Entries in Module Reference Table */
    2 ne_cbnrestab    type WORD,/* Size of non-resident name table */
    2 ne_segtab       type WORD,/* Offset of Segment Table */
    2 ne_rsrctab      type WORD,/* Offset of Resource Table */
    2 ne_restab       type WORD,/* Offset of resident name table */
    2 ne_modtab       type WORD,/* Offset of Module Reference Table */
    2 ne_imptab       type WORD,/* Offset of Imported Names Table */
    2 ne_nrestab      type LONG,/* Offset of Non-resident Names Table */
    2 ne_cmovent      type WORD,/* Count of movable entries */
    2 ne_align        type WORD,/* Segment alignment shift count */
    2 ne_cres         type WORD,/* Count of resource segments */
    2 ne_exetyp       type BYTE,/* Target Operating system */
    2 ne_flagsothers  type BYTE,/* Other .EXE flags */
    2 ne_pretthunks   type WORD,/* offset to return thunks */
    2 ne_psegrefbytes type WORD,/* offset to segment ref. bytes */
    2 ne_swaparea     type WORD,/* Minimum code swap area size */
    2 ne_expver       type WORD;/* Expected Windows version number */

 define alias PIMAGE_OS2_HEADER handle IMAGE_OS2_HEADER;

 define structure
   1 IMAGE_VXD_HEADER,   /* Windows VXD header */
    2 e32_magic      type WORD,/* Magic number */
    2 e32_border     type BYTE,/* The byte ordering for the VXD */
    2 e32_worder     type BYTE,/* The word ordering for the VXD */
    2 e32_level      type DWORD,/* The EXE format level for now = 0 */
    2 e32_cpu        type WORD,/* The CPU type */
    2 e32_os         type WORD,/* The OS type */
    2 e32_ver        type DWORD,/* Module version */
    2 e32_mflags     type DWORD,/* Module flags */
    2 e32_mpages     type DWORD,/* Module # pages */
    2 e32_startobj   type DWORD,/* Object # for instruction pointer */
    2 e32_eip        type DWORD,/* Extended instruction pointer */
    2 e32_stackobj   type DWORD,/* Object # for stack pointer */
    2 e32_esp        type DWORD,/* Extended stack pointer */
    2 e32_pagesize   type DWORD,/* VXD page size */
    2 e32_lastpagesize type DWORD,/* Last page size in VXD */
    2 e32_fixupsize  type DWORD,/* Fixup section size */
    2 e32_fixupsum   type DWORD,/* Fixup section checksum */
    2 e32_ldrsize    type DWORD,/* Loader section size */
    2 e32_ldrsum     type DWORD,/* Loader section checksum */
    2 e32_objtab     type DWORD,/* Object table offset */
    2 e32_objcnt     type DWORD,/* Number of objects in module */
    2 e32_objmap     type DWORD,/* Object page map offset */
    2 e32_itermap    type DWORD,/* Object iterated data map offset */
    2 e32_rsrctab    type DWORD,/* Offset of Resource Table */
    2 e32_rsrccnt    type DWORD,/* Number of resource entries */
    2 e32_restab     type DWORD,/* Offset of resident name table */
    2 e32_enttab     type DWORD,/* Offset of Entry Table */
    2 e32_dirtab     type DWORD,/* Offset of Module Directive Table */
    2 e32_dircnt     type DWORD,/* Number of module directives */
    2 e32_fpagetab   type DWORD,/* Offset of Fixup Page Table */
    2 e32_frectab    type DWORD,/* Offset of Fixup Record Table */
    2 e32_impmod     type DWORD,/* Offset of Import Module Name Table */
    2 e32_impmodcnt  type DWORD,
                     /* Number of entries in Import Module Name Table */
    2 e32_impproc    type DWORD,
                     /* Offset of Import Procedure Name Table */
    2 e32_pagesum    type DWORD,/* Offset of Per-Page Checksum Table */
    2 e32_datapage   type DWORD,/* Offset of Enumerated Data Pages */
    2 e32_preload    type DWORD,/* Number of preload pages */
    2 e32_nrestab    type DWORD,/* Offset of Non-resident Names Table */
    2 e32_cbnrestab  type DWORD,/* Size of Non-resident Name Table */
    2 e32_nressum    type DWORD,/* Non-resident Name Table Checksum */
    2 e32_autodata   type DWORD,/* Object # for automatic data object */
    2 e32_debuginfo  type DWORD,/* Offset of the debugging information*/
    2 e32_debuglen   type DWORD,
    /* The length of the debugging info. in bytes */
    2 e32_instpreload type DWORD,
    /* Number of instance pages in preload section of VXD file */
    2 e32_instdemand type DWORD,
    /* Number of instance pages in demand load section of VXD file */
    2 e32_heapsize   type DWORD,/* Size of heap - for 16-bit apps */
    2 e32_res3(12)   type BYTE,/* Reserved words */
    2 e32_winresoff  type DWORD,
    2 e32_winreslen  type DWORD,
    2 e32_devid      type WORD,/* Device ID for VxD */
    2 e32_ddkver     type WORD;/* DDK version for VxD */

 define alias PIMAGE_VXD_HEADER handle IMAGE_VXD_HEADER;


 /* File header format. */

 define structure
   1 IMAGE_FILE_HEADER,
    2 Machine              type WORD,
    2 NumberOfSections     type WORD,
    2 TimeDateStamp        type DWORD,
    2 PointerToSymbolTable type DWORD,
    2 NumberOfSymbols      type DWORD,
    2 SizeOfOptionalHeader type WORD,
    2 Characteristics      type WORD;

 define alias PIMAGE_FILE_HEADER handle IMAGE_FILE_HEADER;

 dcl IMAGE_SIZEOF_FILE_HEADER fixed bin(31) value(20);

 dcl IMAGE_FILE_RELOCS_STRIPPED         type WORD value('0001'xn);
     /* Relocation info stripped from file. */
 dcl IMAGE_FILE_EXECUTABLE_IMAGE        type WORD value('0002'xn);
     /* File is executable  (i.e. no unresolved externel references). */
 dcl IMAGE_FILE_LINE_NUMS_STRIPPED      type WORD value('0004'xn);
     /* Line nunbers stripped from file. */
 dcl IMAGE_FILE_LOCAL_SYMS_STRIPPED     type WORD value('0008'xn);
     /* Local symbols stripped from file. */
 dcl IMAGE_FILE_AGGRESIVE_WS_TRIM       type WORD value('0010'xn);
     /* Agressively trim working set */
 dcl IMAGE_FILE_LARGE_ADDRESS_AWARE     type WORD value('0020'xn);
     /* App can handle >2gb addresses */
 dcl IMAGE_FILE_BYTES_REVERSED_LO       type WORD value('0080'xn);
     /* Bytes of machine word are reversed. */
 dcl IMAGE_FILE_32BIT_MACHINE           type WORD value('0100'xn);
     /* 32 bit word machine. */
 dcl IMAGE_FILE_DEBUG_STRIPPED          type WORD value('0200'xn);
     /* Debugging info stripped from file in .DBG file */
 dcl IMAGE_FILE_REMOVABLE_RUN_FROM_SWAP type WORD value('0400'xn);
 /* If Image is on removable media, copy and run from the swap file. */
 dcl IMAGE_FILE_NET_RUN_FROM_SWAP       type WORD value('0800'xn);
     /* If Image is on Net, copy and run from the swap file. */
 dcl IMAGE_FILE_SYSTEM                  type WORD value('1000'xn);
     /* System File. */
 dcl IMAGE_FILE_DLL                     type WORD value('2000'xn);
     /* File is a DLL. */
 dcl IMAGE_FILE_UP_SYSTEM_ONLY          type WORD value('4000'xn);
     /* File should only be run on a UP machine */
 dcl IMAGE_FILE_BYTES_REVERSED_HI       type WORD value('8000'xn);
     /* Bytes of machine word are reversed. */

 dcl IMAGE_FILE_MACHINE_UNKNOWN   type WORD value(0);
 dcl IMAGE_FILE_MACHINE_I386      type WORD value('014c'xn);
                                  /* Intel 386. */
 dcl IMAGE_FILE_MACHINE_R3000     type WORD value('0162'xn);
                              /* MIPS little-endian, 0x160 big-endian */
 dcl IMAGE_FILE_MACHINE_R4000     type WORD value('0166'xn);
                                  /* MIPS little-endian */
 dcl IMAGE_FILE_MACHINE_R10000    type WORD value('0168'xn);
                                  /* MIPS little-endian */
 dcl IMAGE_FILE_MACHINE_WCEMIPSV2 type WORD value('0169'xn);
                                  /* MIPS little-endian WCE v2 */
 dcl IMAGE_FILE_MACHINE_ALPHA     type WORD value('0184'xn);
                                  /* Alpha_AXP */
 dcl IMAGE_FILE_MACHINE_POWERPC   type WORD value('01F0'xn);
                                  /* IBM PowerPC Little-Endian */
 dcl IMAGE_FILE_MACHINE_SH3       type WORD value('01a2'xn);
                                  /* SH3 little-endian */
 dcl IMAGE_FILE_MACHINE_SH3E      type WORD value('01a4'xn);
                                  /* SH3E little-endian */
 dcl IMAGE_FILE_MACHINE_SH4       type WORD value('01a6'xn);
                                  /* SH4 little-endian */
 dcl IMAGE_FILE_MACHINE_ARM       type WORD value('01c0'xn);
                                  /* ARM Little-Endian */

 dcl IMAGE_FILE_MACHINE_THUMB     type WORD value('01c2'xn);
 dcl IMAGE_FILE_MACHINE_IA64      type WORD value('0200'xn);
                                  /* Intel 64 */
 dcl IMAGE_FILE_MACHINE_MIPS16    type WORD value('0266'xn);
                                  /* MIPS */
 dcl IMAGE_FILE_MACHINE_MIPSFPU   type WORD value('0366'xn);
                                  /* MIPS */
 dcl IMAGE_FILE_MACHINE_MIPSFPU16 type WORD value('0466'xn);
                                  /* MIPS */
 dcl IMAGE_FILE_MACHINE_ALPHA64   type WORD value('0284'xn);
                                  /* ALPHA64 */
 dcl IMAGE_FILE_MACHINE_AXP64     type WORD
     value(IMAGE_FILE_MACHINE_ALPHA64);

 /* Directory format. */

 define structure
   1 IMAGE_DATA_DIRECTORY,
     2 VirtualAddress type DWORD,
     2 Size           type DWORD;
 define alias PIMAGE_DATA_DIRECTORY handle IMAGE_DATA_DIRECTORY;

 dcl IMAGE_NUMBEROF_DRECTORY_ENTRIES fixed bin(31) value(16);


 /* Optional header format. */

 define structure
   1 IMAGE_OPTIONAL_HEADER32,
     /* Standard fields. */
    2 Magic                       type WORD,
    2 MajorLinkerVersion          type BYTE,
    2 MinorLinkerVersion          type BYTE,
    2 SizeOfCode                  type DWORD,
    2 SizeOfInitializedData       type DWORD,
    2 SizeOfUninitializedData     type DWORD,
    2 AddressOfEntryPoint         type DWORD,
    2 BaseOfCode                  type DWORD,
    2 BaseOfData                  type DWORD,
    /* NT additional fields. */
    2 ImageBase                   type DWORD,
    2 SectionAlignment            type DWORD,
    2 FileAlignment               type DWORD,
    2 MajorOperatingSystemVersion type WORD,
    2 MinorOperatingSystemVersion type WORD,
    2 MajorImageVersion           type WORD,
    2 MinorImageVersion           type WORD,
    2 MajorSubsystemVersion       type WORD,
    2 MinorSubsystemVersion       type WORD,
    2 Reserved1                   type DWORD,
    2 SizeOfImage                 type DWORD,
    2 SizeOfHeaders               type DWORD,
    2 CheckSum                    type DWORD,
    2 Subsystem                   type WORD,
    2 DllCharacteristics          type WORD,
    2 SizeOfStackReserve          type DWORD,
    2 SizeOfStackCommit           type DWORD,
    2 SizeOfHeapReserve           type DWORD,
    2 SizeOfHeapCommit            type DWORD,
    2 LoaderFlags                 type DWORD,
    2 NumberOfRvaAndSizes         type DWORD,
    2 DataDirectory (IMAGE_NUMBEROF_DRECTORY_ENTRIES)
                                  type IMAGE_DATA_DIRECTORY;

 define alias PIMAGE_OPTIONAL_HEADER32 handle IMAGE_OPTIONAL_HEADER32;

 define structure
   1 IMAGE_ROM_OPTIONAL_HEADER,
    2 Magic                   type WORD,
    2 MajorLinkerVersion      type BYTE,
    2 MinorLinkerVersion      type BYTE,
    2 SizeOfCode              type DWORD,
    2 SizeOfInitializedData   type DWORD,
    2 SizeOfUninitializedData type DWORD,
    2 AddressOfEntryPoint     type DWORD,
    2 BaseOfCode              type DWORD,
    2 BaseOfData              type DWORD,
    2 BaseOfBss               type DWORD,
    2 GprMask                 type DWORD,
    2 CprMask (4)             type DWORD,
    2 GpValue                 type DWORD;

 define alias PIMAGE_ROM_OPTIONAL_HEADER
              handle IMAGE_ROM_OPTIONAL_HEADER;

 define structure
   1 IMAGE_OPTIONAL_HEADER64,
     /* Standard fields. */
    2 Magic                       type WORD,
    2 MajorLinkerVersion          type BYTE,
    2 MinorLinkerVersion          type BYTE,
    2 SizeOfCode                  type DWORD,
    2 SizeOfInitializedData       type DWORD,
    2 SizeOfUninitializedData     type DWORD,
    2 AddressOfEntryPoint         type DWORD,
    2 BaseOfCode                  type DWORD,
    2 ImageBase                   type ULONGLONG,
    2 SectionAlignment            type DWORD,
    2 FileAlignment               type DWORD,
    2 MajorOperatingSystemVersion type WORD,
    2 MinorOperatingSystemVersion type WORD,
    2 MajorImageVersion           type WORD,
    2 MinorImageVersion           type WORD,
    2 MajorSubsystemVersion       type WORD,
    2 MinorSubsystemVersion       type WORD,
    2 Win32VersionValue           type DWORD,
    2 SizeOfImage                 type DWORD,
    2 SizeOfHeaders               type DWORD,
    2 CheckSum                    type DWORD,
    2 Subsystem                   type WORD,
    2 DllCharacteristics          type WORD,
    2 SizeOfStackReserve          type ULONGLONG,
    2 SizeOfStackCommit           type ULONGLONG,
    2 SizeOfHeapReserve           type ULONGLONG,
    2 SizeOfHeapCommit            type ULONGLONG,
    2 LoaderFlags                 type DWORD,
    2 NumberOfRvaAndSizes         type DWORD,
    2 DataDirectory (IMAGE_NUMBEROF_DRECTORY_ENTRIES)
                                  type IMAGE_DATA_DIRECTORY;

 define alias PIMAGE_OPTIONAL_HEADER64 handle IMAGE_OPTIONAL_HEADER64;


 dcl IMAGE_SIZEOF_ROMOPTIONAL_HEADER   fixed bin(31) value(56);
 dcl IMAGE_SIZEOF_STDOPTIONAL_HEADER   fixed bin(31) value(28);
 dcl IMAGE_SIZEOF_NT_OPTIONAL32_HEADER fixed bin(31) value(224);
 dcl IMAGE_SIZEOF_NT_OPTIONAL64_HEADER fixed bin(31) value(240);

 dcl IMAGE_NT_OPTIONAL_HDR32_MAGIC  type WORD value('10b'xn);
 dcl IMAGE_NT_OPTIONAL_HDR64_MAGIC  type WORD value('20b'xn);
 dcl IMAGE_ROM_OPTIONAL_HDR_MAGIC   type WORD value('107'xn);

 %if #WIN64 ^= '' %then %do;
 define alias  IMAGE_OPTIONAL_HEADER type  IMAGE_OPTIONAL_HEADER64;
 define alias PIMAGE_OPTIONAL_HEADER type PIMAGE_OPTIONAL_HEADER64;
 dcl IMAGE_SIZEOF_NT_OPTIONAL_HEADER fixed bin(31)
     value(IMAGE_SIZEOF_NT_OPTIONAL64_HEADER);
 dcl IMAGE_NT_OPTIONAL_HDR_MAGIC     type WORD
     value(IMAGE_NT_OPTIONAL_HDR64_MAGIC);
 %end; %else %do;
 define alias  IMAGE_OPTIONAL_HEADER type  IMAGE_OPTIONAL_HEADER32;
 define alias PIMAGE_OPTIONAL_HEADER type PIMAGE_OPTIONAL_HEADER32;
 dcl IMAGE_SIZEOF_NT_OPTIONAL_HEADER fixed bin(31)
     value(IMAGE_SIZEOF_NT_OPTIONAL32_HEADER);
 dcl IMAGE_NT_OPTIONAL_HDR_MAGIC     type WORD
     value(IMAGE_NT_OPTIONAL_HDR32_MAGIC);
 %end;

 define structure
   1 IMAGE_NT_HEADERS64,
     2 Signature      type DWORD,
     2 FileHeader     type IMAGE_FILE_HEADER,
     2 OptionalHeader type IMAGE_OPTIONAL_HEADER64;
 define alias PIMAGE_NT_HEADERS64 handle IMAGE_NT_HEADERS64;

 define structure
   1 IMAGE_NT_HEADERS32,
     2 Signature      type DWORD,
     2 FileHeader     type IMAGE_FILE_HEADER,
     2 OptionalHeader type IMAGE_OPTIONAL_HEADER32;
 define alias PIMAGE_NT_HEADERS32 handle IMAGE_NT_HEADERS32;

 define structure
   1 IMAGE_ROM_HEADERS,
    2 FileHeader      type IMAGE_FILE_HEADER,
    2 OptionalHeader  type IMAGE_ROM_OPTIONAL_HEADER;

 define alias PIMAGE_ROM_HEADERS handle IMAGE_ROM_HEADERS;

 IMAGE_FIRST_SECTION64: proc (ntheader)
                        returns (type PIMAGE_SECTION_HEADER byvalue)
                        options (inline reorder) internal;
  dcl ntheader type PIMAGE_NT_HEADERS64 byvalue;
  dcl (location, ptradd, ptrvalue) builtin;

  return (bind (: IMAGE_SECTION_HEADER,
                  ptradd (ptrvalue (ntheader),
                          location (ntheader => OptionalHeader) +
                          ntheader => FileHeader.SizeOfOptionalHeader)
               :));
 end IMAGE_FIRST_SECTION64;

 IMAGE_FIRST_SECTION32: proc (ntheader)
                        returns (type PIMAGE_SECTION_HEADER byvalue)
                        options (inline reorder) internal;
  dcl ntheader type PIMAGE_NT_HEADERS64 byvalue;
  dcl (location, ptradd, ptrvalue) builtin;

  return (bind (: IMAGE_SECTION_HEADER,
                  ptradd (ptrvalue (ntheader),
                          location (ntheader => OptionalHeader) +
                          ntheader => FileHeader.SizeOfOptionalHeader)
               :));
 end IMAGE_FIRST_SECTION32;

 %dcl IMAGE_FIRST_SECTION char ext;
 %if #WIN64 ^= '' %then %do;
 define alias  IMAGE_NT_HEADERS type  IMAGE_NT_HEADERS64;
 define alias PIMAGE_NT_HEADERS type PIMAGE_NT_HEADERS64;
 %IMAGE_FIRST_SECTION = 'IMAGE_FIRST_SECTION64';
 %end; %else %do;
 define alias  IMAGE_NT_HEADERS type  IMAGE_NT_HEADERS32;
 define alias PIMAGE_NT_HEADERS type PIMAGE_NT_HEADERS32;
 %IMAGE_FIRST_SECTION = 'IMAGE_FIRST_SECTION32';
 %end;

 /* Subsystem Values */

 dcl IMAGE_SUBSYSTEM_UNKNOWN        fixed bin(31) value(0);
     /* Unknown subsystem. */
 dcl IMAGE_SUBSYSTEM_NATIVE         fixed bin(31) value(1);
     /* Image doesn't require a subsystem. */
 dcl IMAGE_SUBSYSTEM_WINDOWS_GUI    fixed bin(31) value(2);
     /* Image runs in the Windows GUI subsystem. */
 dcl IMAGE_SUBSYSTEM_WINDOWS_CUI    fixed bin(31) value(3);
     /* Image runs in the Windows character subsystem. */
 dcl IMAGE_SUBSYSTEM_WINDOWS_CE_GUI fixed bin(31) value(4);
     /* Image runs in the Windows CE subsystem. */
 dcl IMAGE_SUBSYSTEM_OS2_CUI        fixed bin(31) value(5);
     /* image runs in the OS/2 character subsystem. */
 dcl IMAGE_SUBSYSTEM_POSIX_CUI      fixed bin(31) value(7);
     /* image runs in the Posix character subsystem. */
 dcl IMAGE_SUBSYSTEM_RESERVED8      fixed bin(31) value(8);
     /* image runs in the 8 subsystem. */

 /* DllCharacteristics Entries */

 /* dcl IMAGE_LIBRARY_PROCESS_INIT       fixed bin(31) value('0001'xn)*/
 /* dcl IMAGE_LIBRARY_PROCESS_TERM       fixed bin(31) value('0002'xn)*/
 /* dcl IMAGE_LIBRARY_THREAD_INIT        fixed bin(31) value('0004'xn)*/
 /* dcl IMAGE_LIBRARY_THREAD_TERM        fixed bin(31) value('0008'xn)*/
 dcl IMAGE_DLLCHARACTERISTICS_NO_BIND    fixed bin(31) value('0800'xn);
     /* Do not bind this image. */
 dcl IMAGE_DLLCHARACTERISTICS_WDM_DRIVER fixed bin(31) value('2000'xn);
     /* Driver uses WDM model */
 dcl IMAGE_DLLCHARACTERISTICS_TERMINAL_SERVER_AWARE
                                         fixed bin(31) value('8000'xn);

 /* Directory Entries */

 dcl IMAGE_DIRECTORY_ENTRY_EXPORT         fixed bin(31) value( 0);
     /* Export Directory */
 dcl IMAGE_DIRECTORY_ENTRY_IMPORT         fixed bin(31) value( 1);
     /* Import Directory */
 dcl IMAGE_DIRECTORY_ENTRY_RESOURCE       fixed bin(31) value( 2);
     /* Resource Directory */
 dcl IMAGE_DIRECTORY_ENTRY_EXCEPTION      fixed bin(31) value( 3);
     /* Exception Directory */
 dcl IMAGE_DIRECTORY_ENTRY_SECURITY       fixed bin(31) value( 4);
     /* Security Directory */
 dcl IMAGE_DIRECTORY_ENTRY_BASERELOC      fixed bin(31) value( 5);
     /* Base Relocation Table */
 dcl IMAGE_DIRECTORY_ENTRY_DEBUG          fixed bin(31) value( 6);
     /* Debug Directory */
 dcl IMAGE_DIRECTORY_ENTRY_ARCHITECTURE   fixed bin(31) value( 7);
     /* Architecture Specific Data */
 dcl IMAGE_DIRECTORY_ENTRY_GLOBALPTR      fixed bin(31) value( 8);
     /* RVA of GP */
 dcl IMAGE_DIRECTORY_ENTRY_TLS            fixed bin(31) value( 9);
     /* TLS Directory */
 dcl IMAGE_DIRECTORY_TRY_LOAD_CONFIG      fixed bin(31) value(10);
     /* Load Configuration Directory */
 dcl IMAGE_DIRECTORY_RY_BOUND_IMPORT      fixed bin(31) value(11);
     /* Bound Import Directory in headers */
 dcl IMAGE_DIRECTORY_ENTRY_IAT            fixed bin(31) value(12);
     /* Import Address Table */
 dcl IMAGE_DIRECTORY_ENTRY_DELAY_IMPORT   fixed bin(31) value(13);
     /* Delay Load Import Descriptors */
 dcl IMAGE_DIRECTORY_ENTRY_COM_DESCRIPTOR fixed bin(31) value(14);
     /* COM Runtime descriptor */


 /* Section header format. */

 dcl IMAGE_SIZEOF_SHORT_NAME fixed bin(31) value(8);

 define structure
   1 IMAGE_SECTION_HEADER,   /* Import Address Table */
    2 Name (IMAGE_SIZEOF_SHORT_NAME) type BYTE,
    2 Misc union,
      3 PhysicalAddress    type DWORD,
      3 VirtualSize        type DWORD,
    2 VirtualAddress       type DWORD,
    2 SizeOfRawData        type DWORD,
    2 PointerToRawData     type DWORD,
    2 PointerToRelocations type DWORD,
    2 PointerToLinenumbers type DWORD,
    2 NumberOfRelocations  type WORD,
    2 NumberOfLinenumbers  type WORD,
    2 Characteristics      type DWORD;

 define alias PIMAGE_SECTION_HEADER handle IMAGE_SECTION_HEADER;

 dcl IMAGE_SIZEOF_SECTION_HEADER fixed bin(31) value(40);


 /* Section characteristics. */

 /*  IMAGE_SCN_TYPE_REG        type DWORD value('00000000'xu) Reserved*/
 /*  IMAGE_SCN_TYPE_DSECT      type DWORD value('00000001'xu) Reserved*/
 /*  IMAGE_SCN_TYPE_NOLOAD     type DWORD value('00000002'xu) Reserved*/
 /*  IMAGE_SCN_TYPE_GROUP      type DWORD value('00000004'xu) Reserved*/
 dcl IMAGE_SCN_TYPE_NO_PAD     type DWORD value('00000008'xu);
     /* Reserved. */
 /*  IMAGE_SCN_TYPE_COPY       type DWORD value('00000010'xu) Reserved*/

 dcl IMAGE_SCN_CNT_CODE        type DWORD value('00000020'xu);
     /* Section contains code. */
 dcl IMAGE_SCN_CNT_INITIALIZED_DATA  type DWORD value('00000040'xu);
     /* Section contains initialized data. */
 dcl IMAGE_SCN_CNT_UNNITIALIZED_DATA type DWORD value('00000080'xu);
     /* Section contains uninitialized data. */

 dcl IMAGE_SCN_LNK_OTHER       type DWORD value('00000100'xu);
     /* Reserved. */
 dcl IMAGE_SCN_LNK_INFO        type DWORD value('00000200'xu);
     /* Section contains comments or some other type of information. */
 /*  IMAGE_SCN_TYPE_OVER    type DWORD value('00000400')xn Reserved*/
 dcl IMAGE_SCN_LNK_REMOVE      type DWORD value('00000800'xu);
     /* Section contents will not become part of image. */
 dcl IMAGE_SCN_LNK_COMDAT      type DWORD value('00001000'xu);
     /* Section contents comdat. */
 /*                            type DWORD value('00002000'xu) Reserved*/

 /* IMAGE_SCN_MEM_PROTECTED    type DWORD value('00004000'xu) Obsolete*/
 dcl IMAGE_SCN_MEM_FARDATA     type DWORD value('00008000'xu);
 /*  IMAGE_SCN_MEM_SYSHEAP     type DWORD value('00010000'xu) Obsolete*/
 dcl IMAGE_SCN_MEM_PURGEABLE   type DWORD value('00020000'xu);
 dcl IMAGE_SCN_MEM_16BIT       type DWORD value('00020000'xu);
 dcl IMAGE_SCN_MEM_LOCKED      type DWORD value('00040000'xu);
 dcl IMAGE_SCN_MEM_PRELOAD     type DWORD value('00080000'xu);

 dcl IMAGE_SCN_ALIGN_1BYTES    type DWORD value('00100000'xu);
 dcl IMAGE_SCN_ALIGN_2BYTES    type DWORD value('00200000'xu);
 dcl IMAGE_SCN_ALIGN_4BYTES    type DWORD value('00300000'xu);
 dcl IMAGE_SCN_ALIGN_8BYTES    type DWORD value('00400000'xu);
 dcl IMAGE_SCN_ALIGN_16BYTES   type DWORD value('00500000'xu);
     /* Default alignment if no others are specified. */
 dcl IMAGE_SCN_ALIGN_32BYTES   type DWORD value('00600000'xu);
 dcl IMAGE_SCN_ALIGN_64BYTES   type DWORD value('00700000'xu);
 dcl IMAGE_SCN_ALIGN_128BYTES  type DWORD value('00800000'xu);
 dcl IMAGE_SCN_ALIGN_256BYTES  type DWORD value('00900000'xu);
 dcl IMAGE_SCN_ALIGN_512BYTES  type DWORD value('00A00000'xu);
 dcl IMAGE_SCN_ALIGN_1024BYTES type DWORD value('00B00000'xu);
 dcl IMAGE_SCN_ALIGN_2048BYTES type DWORD value('00C00000'xu);
 dcl IMAGE_SCN_ALIGN_4096BYTES type DWORD value('00D00000'xu);
 dcl IMAGE_SCN_ALIGN_8192BYTES type DWORD value('00E00000'xu);

 dcl IMAGE_SCN_LNK_NRELOC_OVFL type DWORD value('01000000'xu);
     /* Section contains extended relocations. */
 dcl IMAGE_SCN_MEM_DISCARDABLE type DWORD value('02000000'xu);
     /* Section can be discarded. */
 dcl IMAGE_SCN_MEM_NOT_CACHED  type DWORD value('04000000'xu);
     /* Section is not cachable. */
 dcl IMAGE_SCN_MEM_NOT_PAGED   type DWORD value('08000000'xu);
     /* Section is not pageable. */
 dcl IMAGE_SCN_MEM_SHARED      type DWORD value('10000000'xu);
     /* Section is shareable. */
 dcl IMAGE_SCN_MEM_EXECUTE     type DWORD value('20000000'xu);
     /* Section is executable. */
 dcl IMAGE_SCN_MEM_READ        type DWORD value('40000000'xu);
     /* Section is readable. */
 dcl IMAGE_SCN_MEM_WRITE       type DWORD value('80000000'xu);
     /* Section is writeable. */

 /* TLS Chaacteristic Flags */

 dcl IMAGE_SCN_SCALE_INDEX     type DWORD value('00000001'xu);
     /* Tls index is scaled */

 /* Symbol format. */


 define structure
   1 IMAGE_SYMBOL,   /* Section is writeable. */
     2 N union,
       3 ShortName   char(8),
       3 Name,
         4 Short     type DWORD,/* if 0, use LongName */
         4 Long      type DWORD,/* offset into string table */
       3 LongName(2) type PBYTE,
     2 Value         type DWORD,
     2 SectionNumber type SHORT,
     2 Type          type WORD,
     2 StorageClass  type BYTE,
     2 NumberOfAuxSymbols type BYTE;

 define alias PIMAGE_SYMBOL handle IMAGE_SYMBOL;

 dcl IMAGE_SIZEOF_SYMBOL fixed bin(31) value(18);


 /* Section values. */

 /* Symbols have a section number of the section in which they are   */
 /* defined. Otherwise, section numbers have the following meanings: */


 dcl IMAGE_SYM_UNDEFINED type SHORT value(0);
     /* Symbol is undefined or is common. */
 dcl IMAGE_SYM_ABSOLUTE  type SHORT value(-1);
     /* Symbol is an absolute value. */
 dcl IMAGE_SYM_DEBUG     type SHORT value(-2);
     /* Symbol is a special debug item. */


 /* Type (fundamental) values. */

 dcl IMAGE_SYM_TYPE_NULL   type WORD value('0000'xu); /* no type. */
 dcl IMAGE_SYM_TYPE_VOID   type WORD value('0001'xu);
 dcl IMAGE_SYM_TYPE_CHAR   type WORD value('0002'xu);
                           /* type character. */
 dcl IMAGE_SYM_TYPE_SHORT  type WORD value('0003'xu);
                           /* type short integer. */
 dcl IMAGE_SYM_TYPE_INT    type WORD value('0004'xu);
 dcl IMAGE_SYM_TYPE_LONG   type WORD value('0005'xu);
 dcl IMAGE_SYM_TYPE_FLOAT  type WORD value('0006'xu);
 dcl IMAGE_SYM_TYPE_DOUBLE type WORD value('0007'xu);
 dcl IMAGE_SYM_TYPE_STRUCT type WORD value('0008'xu);
 dcl IMAGE_SYM_TYPE_UNION  type WORD value('0009'xu);
 dcl IMAGE_SYM_TYPE_ENUM   type WORD value('000A'xu); /* enumeration. */
 dcl IMAGE_SYM_TYPE_MOE    type WORD value('000B'xu);
                           /* member of enumeration. */
 dcl IMAGE_SYM_TYPE_BYTE   type WORD value('000C'xu);
 dcl IMAGE_SYM_TYPE_WORD   type WORD value('000D'xu);
 dcl IMAGE_SYM_TYPE_UINT   type WORD value('000E'xu);
 dcl IMAGE_SYM_TYPE_DWORD  type WORD value('000F'xu);
 dcl IMAGE_SYM_TYPE_PCODE  type WORD value('8000'xu);


 /* Type (derived) values. */

 dcl IMAGE_SYM_DTYPE_NULL     fixed bin(15) value(0);
                              /* no derived type. */
 dcl IMAGE_SYM_DTYPE_POINTER  fixed bin(15) value(1);
                              /* pointer. */
 dcl IMAGE_SYM_DTYPE_FUNCTION fixed bin(15) value(2);
                              /* function. */
 dcl IMAGE_SYM_DTYPE_ARRAY    fixed bin(15) value(3);
                              /* array. */


 /* Storage classes. */

 dcl IMAGE_SYM_CLASS_END_OF_FUNCTION type BYTE value ('ff'xu);

 dcl IMAGE_SYM_CLASS_NULL            type BYTE value('00'xu);
 dcl IMAGE_SYM_CLASS_AUTOMATIC       type BYTE value('01'xu);
 dcl IMAGE_SYM_CLASS_EXTERNAL        type BYTE value('02'xu);
 dcl IMAGE_SYM_CLASS_STATIC          type BYTE value('03'xu);
 dcl IMAGE_SYM_CLASS_REGISTER        type BYTE value('04'xu);
 dcl IMAGE_SYM_CLASS_EXTERNAL_DEF    type BYTE value('05'xu);
 dcl IMAGE_SYM_CLASS_LABEL           type BYTE value('06'xu);
 dcl IMAGE_SYM_CLASS_UNDEFINED_LABEL type BYTE value('07'xu);
 dcl IMAGE_SYM_CLASS_EMBER_OF_STRUCT type BYTE value('08'xu);
 dcl IMAGE_SYM_CLASS_ARGUMENT        type BYTE value('09'xu);
 dcl IMAGE_SYM_CLASS_STRUCT_TAG      type BYTE value('0A'xu);
 dcl IMAGE_SYM_CLASS_MEMBER_OF_UNION type BYTE value('0B'xu);
 dcl IMAGE_SYM_CLASS_UNION_TAG       type BYTE value('0C'xu);
 dcl IMAGE_SYM_CLASS_TYPE_DEFINITION type BYTE value('0D'xu);
 dcl IMAGE_SYM_CLASS_NDEFINED_STATIC type BYTE value('0E'xu);
 dcl IMAGE_SYM_CLASS_ENUM_TAG        type BYTE value('0F'xu);
 dcl IMAGE_SYM_CLASS_MEMBER_OF_ENUM  type BYTE value('10'xu);
 dcl IMAGE_SYM_CLASS_REGISTER_PARAM  type BYTE value('11'xu);
 dcl IMAGE_SYM_CLASS_BIT_FIELD       type BYTE value('12'xu);

 dcl IMAGE_SYM_CLASS_FAR_EXTERNAL    type BYTE value('44'xu);

 dcl IMAGE_SYM_CLASS_BLOCK           type BYTE value('64'xu);
 dcl IMAGE_SYM_CLASS_FUNCTION        type BYTE value('65'xu);
 dcl IMAGE_SYM_CLASS_END_OF_STRUCT   type BYTE value('66'xu);
 dcl IMAGE_SYM_CLASS_FILE            type BYTE value('67'xu);
 /* new */
 dcl IMAGE_SYM_CLASS_SECTION         type BYTE value('68'xu);
 dcl IMAGE_SYM_CLASS_WEAK_EXTERNAL   type BYTE value('69'xu);

 /* type packing constants */

 dcl N_BTMASK type WORD value('000F'xu);
 dcl N_TMASK  type WORD value('0030'xu);
 dcl N_TMASK1 type WORD value('00C0'xu);
 dcl N_TMASK2 type WORD value('00F0'xu);
 dcl N_BTSHFT fixed bin(15) value(4);
 dcl N_TSHIFT fixed bin(15) value(2);

 /* MACROS           */

 /* Basic Type of  x */
 BTYPE: proc (x) returns (type WORD byvalue)
        options (inline reorder) internal;
   dcl x type WORD byvalue;
   dcl iand builtin;
   return (iand (x, N_BTMASK));
 end BTYPE;

 ISPTR: proc (x) returns (bit (1) aligned byvalue)
        options (inline reorder) internal;
   dcl x type WORD byvalue;
   dcl (iand, raise2) builtin;
   return (iand (x, N_TMASK) =
           raise2 (IMAGE_SYM_DTYPE_POINTER, N_BTSHFT));
 end ISPTR;

 ISFCN: proc (x) returns (bit (1) aligned byvalue)
        options (inline reorder) internal;
   dcl x type WORD byvalue;
   dcl (iand, raise2) builtin;
   return (iand (x, N_TMASK) =
           raise2 (IMAGE_SYM_DTYPE_FUNCTION, N_BTSHFT));
 end ISFCN;

 ISARY: proc (x) returns (bit (1) aligned byvalue)
        options (inline reorder) internal;
   dcl x type WORD byvalue;
   dcl (iand, raise2) builtin;
   return (iand (x, N_TMASK) =
           raise2 (IMAGE_SYM_DTYPE_ARRAY, N_BTSHFT));
 end ISARY;

 ISTAG: proc (x) returns (bit (1) aligned byvalue)
        options (inline reorder) internal;
   dcl x type WORD byvalue;
   return (x = IMAGE_SYM_CLASS_STRUCT_TAG |
           x = IMAGE_SYM_CLASS_UNION_TAG  |
           x = IMAGE_SYM_CLASS_ENUM_TAG);
 end ISTAG;


 INCREF: proc (x) returns (type DWORD byvalue)
         options (inline reorder) internal;
   dcl x type WORD byvalue;
   dcl (iand, inot, raise2) builtin;
   return (ior (raise2 (iand (x, inot (N_BTMASK)), N_TSHIFT),
                raise2 (IMAGE_SYM_DTYPE_POINTER, N_BTSHFT),
                iand (x, N_BTMASK)));
 end INCREF;

 DECREF: proc (x) returns (type DWORD byvalue)
         options (inline reorder) internal;
   dcl x type WORD byvalue;
   dcl (iand, inot, raise2) builtin;
   return (ior (iand (isrl(x, N_TSHIFT), inot (N_BTMASK)),
                iand (x, N_BTMASK)));
 end DECREF;


 /* Auxiliary entry format.  */

 define structure
   1 IMAGE_AUX_SYMBOL union,
     2 Sym,
       3 TagIndex type DWORD,/* struct, union, or enum tag index */
       3 Misc union,
         4 LnSz,
           5 Linenumber type WORD,/* declaration line number */
           5 Size       type WORD,/* size of struct, union, or enum */
         4 TotalSize type DWORD,
       3 FcnAry union,
         4 Function,
           5 PointerToLinenumber   type DWORD,
           5 PointerToNextFunction type DWORD,
         4 Array,
           5 Dimension (4) type WORD,
       3 TvIndex type WORD,/* tv index */
     2 File,
       3 Name char (IMAGE_SIZEOF_SYMBOL),
     2 Section,
       3 Length    type DWORD,/* section length */
       3 NumberOfRelocations type WORD,/* number of relocation entries*/
       3 NumberOfLinenumbers type WORD,/* number of line numbers */
       3 CheckSum  type DWORD,/* checksum for communal */
       3 Number    type SHORT,/* section number to associate with */
       3 Selection type BYTE;/* communal selection type */
 define alias PIMAGE_AUX_SYMBOL handle IMAGE_AUX_SYMBOL;

 dcl IMAGE_SIZEOF_AUX_SYMBOL fixed bin(31) value(18);


 /* Communal selection types. */

 dcl IMAGE_COMDAT_SELCT_NODUPLICATES type BYTE value(1);
 dcl IMAGE_COMDAT_SELECT_ANY         type BYTE value(2);
 dcl IMAGE_COMDAT_SELECT_SAME_SIZE   type BYTE value(3);
 dcl IMAGE_COMDAT_SELECT_EXACT_MATCH type BYTE value(4);
 dcl IMAGE_COMDAT_SELECT_ASSOCIATIVE type BYTE value(5);
 dcl IMAGE_COMDAT_SELECT_LARGEST     type BYTE value(6);
 dcl IMAGE_COMDAT_SELECT_NEWEST      type BYTE value(7);

 dcl IMAGE_WEAK_EXTEREARCH_NOLIBRARY type BYTE value(1);
 dcl IMAGE_WEAK_EXTER_SEARCH_LIBRARY type BYTE value(2);
 dcl IMAGE_WEAK_EXTERN_SEARCH_ALIAS  type BYTE value(3);


 /* Relocation format. */

 define structure
   1 IMAGE_RELOCATION,
     2 * union,
       3 VirtualAddress type DWORD,
       3 RelocCount     type DWORD,
         /*Set to the real count when IMAGE_SCN_LNK_NRELOC_OVFL is set*/
     2 SymbolTableIndex type DWORD,
     2 Type             type WORD;
 define alias PIMAGE_RELOCATION handle IMAGE_RELOCATION;

 dcl IMAGE_SIZEOF_RELOCATION fixed bin(31) value(10);


 /* I386 relocation types. */

 dcl IMAGE_REL_I386_ABSOLUTE type WORD value('0000'xn);
     /* Reference is absolute, no relocation is necessary */
 dcl IMAGE_REL_I386_DIR16    type WORD value('0001'xn);
     /* Direct 16-bit reference to the symbols virtual address */
 dcl IMAGE_REL_I386_REL16    type WORD value('0002'xn);
     /* PC-relative 16-bit reference to the symbols virtual address */
 dcl IMAGE_REL_I386_DIR32    type WORD value('0006'xn);
     /* Direct 32-bit reference to the symbols virtual address */
 dcl IMAGE_REL_I386_DIR32NB  type WORD value('0007'xn);
     /* Direct 32-bit reference to the symbols */
     /* virtual address, base not included */
 dcl IMAGE_REL_I386_SEG12    type WORD value('0009'xn);
     /* Direct 16-bit reference to the */
     /* segment-selector bits of a 32-bit virtual address */
 dcl IMAGE_REL_I386_SECTION  type WORD value('000A'xn);
 dcl IMAGE_REL_I386_SECREL   type WORD value('000B'xn);
 dcl IMAGE_REL_I386_REL32    type WORD value('0014'xn);
     /* PC-relative 32-bit reference to the symbols virtual address */


 /* MIPS relocation types. */

 dcl IMAGE_REL_MIPS_ABSOLUTE  type WORD value('0000'xn);
     /* Reference is absolute, no relocation is necessary */
 dcl IMAGE_REL_MIPS_REFHALF   type WORD value('0001'xn);
 dcl IMAGE_REL_MIPS_REFWORD   type WORD value('0002'xn);
 dcl IMAGE_REL_MIPS_JMPADDR   type WORD value('0003'xn);
 dcl IMAGE_REL_MIPS_REFHI     type WORD value('0004'xn);
 dcl IMAGE_REL_MIPS_REFLO     type WORD value('0005'xn);
 dcl IMAGE_REL_MIPS_GPREL     type WORD value('0006'xn);
 dcl IMAGE_REL_MIPS_LITERAL   type WORD value('0007'xn);
 dcl IMAGE_REL_MIPS_SECTION   type WORD value('000A'xn);
 dcl IMAGE_REL_MIPS_SECREL    type WORD value('000B'xn);
 dcl IMAGE_REL_MIPS_SECRELLO  type WORD value('000C'xn);
     /* Low 16-bit section relative referemce (used for >32k TLS) */
 dcl IMAGE_REL_MIPS_SECRELHI  type WORD value('000D'xn);
     /* High 16-bit section relative reference (used for >32k TLS) */
 dcl IMAGE_REL_MIPS_REFWORDNB type WORD value('0022'xn);
 dcl IMAGE_REL_MIPS_PAIR      type WORD value('0025'xn);


 /* Alpha Relocation types. */

 dcl IMAGE_REL_ALPHA_ABSOLUTE       type WORD value('0000'xn);
 dcl IMAGE_REL_ALPHA_REFLONG        type WORD value('0001'xn);
 dcl IMAGE_REL_ALPHA_REFQUAD        type WORD value('0002'xn);
 dcl IMAGE_REL_ALPHA_GPREL32        type WORD value('0003'xn);
 dcl IMAGE_REL_ALPHA_LITERAL        type WORD value('0004'xn);
 dcl IMAGE_REL_ALPHA_LITUSE         type WORD value('0005'xn);
 dcl IMAGE_REL_ALPHA_GPDISP         type WORD value('0006'xn);
 dcl IMAGE_REL_ALPHA_BRADDR         type WORD value('0007'xn);
 dcl IMAGE_REL_ALPHA_HINT           type WORD value('0008'xn);
 dcl IMAGE_REL_ALPHA_INLINE_REFLONG type WORD value('0009'xn);
 dcl IMAGE_REL_ALPHA_REFHI          type WORD value('000A'xn);
 dcl IMAGE_REL_ALPHA_REFLO          type WORD value('000B'xn);
 dcl IMAGE_REL_ALPHA_PAIR           type WORD value('000C'xn);
 dcl IMAGE_REL_ALPHA_MATCH          type WORD value('000D'xn);
 dcl IMAGE_REL_ALPHA_SECTION        type WORD value('000E'xn);
 dcl IMAGE_REL_ALPHA_SECREL         type WORD value('000F'xn);
 dcl IMAGE_REL_ALPHA_REFLONGNB      type WORD value('0010'xn);
 dcl IMAGE_REL_ALPHA_SECRELLO       type WORD value('0011'xn);
      /* Low 16-bit section relative reference */
 dcl IMAGE_REL_ALPHA_SECRELHI       type WORD value('0012'xn);
     /* High 16-bit section relative reference */
 dcl IMAGE_REL_ALPHA_REFQ3          type WORD value('0013'xn);
     /* High 16 bits of 48 bit reference */
 dcl IMAGE_REL_ALPHA_REFQ2          type WORD value('0014'xn);
     /* Middle 16 bits of 48 bit reference */
 dcl IMAGE_REL_ALPHA_REFQ1          type WORD value('0015'xn);
     /* Low 16 bits of 48 bit reference */
 dcl IMAGE_REL_ALPHA_GPRELLO        type WORD value('0016'xn);
     /* Low 16-bit GP relative reference */
 dcl IMAGE_REL_ALPHA_GPRELHI        type WORD value('0017'xn);
     /* High 16-bit GP relative reference */


 /* IBM PowerPC relocation types. */

 dcl IMAGE_REL_PPC_ABSOLUTE type WORD value('0000'xn); /* NOP */
 dcl IMAGE_REL_PPC_ADDR64   type WORD value('0001'xn);
     /* 64-bit address */
 dcl IMAGE_REL_PPC_ADDR32   type WORD value('0002'xn);
     /* 32-bit address */
 dcl IMAGE_REL_PPC_ADDR24   type WORD value('0003'xn);
     /* 26-bit address, shifted left 2 (branch absolute) */
 dcl IMAGE_REL_PPC_ADDR16   type WORD value('0004'xn);
     /* 16-bit address */
 dcl IMAGE_REL_PPC_ADDR14   type WORD value('0005'xn);
     /* 16-bit address, shifted left 2 (load doubleword) */
 dcl IMAGE_REL_PPC_REL24    type WORD value('0006'xn);
     /* 26-bit PC-relative offset, shifted left 2 (branch relative) */
 dcl IMAGE_REL_PPC_REL14    type WORD value('0007'xn);
     /* 16-bit PC-relative offset, shifted left 2 (br cond relative) */
 dcl IMAGE_REL_PPC_TOCREL16 type WORD value('0008'xn);
     /* 16-bit offset from TOC base */
 dcl IMAGE_REL_PPC_TOCREL14 type WORD value('0009'xn);
     /* 16-bit offset from TOC base, shifted left 2 (load doubleword) */

 dcl IMAGE_REL_PPC_ADDR32NB type WORD value('000A'xn);
     /* 32-bit addr w/o image base */
 dcl IMAGE_REL_PPC_SECREL   type WORD value('000B'xn);
     /* va of containing section (as in an image sectionhdr) */
 dcl IMAGE_REL_PPC_SECTION  type WORD value('000C'xn);
     /* sectionheader number */
 dcl IMAGE_REL_PPC_IFGLUE   type WORD value('000D'xn);
     /* substitute TOC restore instruction iff symbol is glue code */
 dcl IMAGE_REL_PPC_IMGLUE   type WORD value('000E'xn);
     /*symbol is glue code, virtual address is TOC restore instruction*/
 dcl IMAGE_REL_PPC_SECREL16 type WORD value('000F'xn);
     /* va of containing section (limited to 16 bits) */
 dcl IMAGE_REL_PPC_REFHI    type WORD value('0010'xn);

 dcl IMAGE_REL_PPC_REFLO    type WORD value('0011'xn);
 dcl IMAGE_REL_PPC_PAIR     type WORD value('0012'xn);
 dcl IMAGE_REL_PPC_SECRELLO type WORD value('0013'xn);
     /* Low 16-bit section relative reference (used for >32k TLS) */
 dcl IMAGE_REL_PPC_SECRELHI type WORD value('0014'xn);
     /* High 16-bit section relative reference (used for >32k TLS) */
 dcl IMAGE_REL_PPC_GPREL    type WORD value('0015'xn);

 dcl IMAGE_REL_PPC_TYPEMASK type WORD value('00FF'xn);
     /* mask to isolate above values in IMAGE_RELOCATION.Type */

 /* Flag bits in IMAGE_RELOCATION.TYPE */

 dcl IMAGE_REL_PPC_NEG      type WORD value('0100'xn);
     /* subtract reloc value rather than adding it */
 dcl IMAGE_REL_PPC_BRTAKEN  type WORD value('0200'xn);
     /* fix branch prediction bit to predict branch taken */
 dcl IMAGE_REL_PPC_BRNTAKEN type WORD value('0400'xn);
     /* fix branch prediction bit to predict branch not taken */
 dcl IMAGE_REL_PPC_TOCDEFN  type WORD value('0800'xn);
     /* toc slot defined in file (or, data in toc) */

 /* Hitachi SH3 relocation types. */

 dcl IMAGE_REL_SH3_ABSOLUTE        type WORD value('0000'xn);
     /* No relocation */
 dcl IMAGE_REL_SH3_DIRECT16        type WORD value('0001'xn);
     /* 16 bit direct */
 dcl IMAGE_REL_SH3_DIRECT32        type WORD value('0002'xn);
     /* 32 bit direct */
 dcl IMAGE_REL_SH3_DIRECT8         type WORD value('0003'xn);
     /* 8 bit direct, -128..255 */
 dcl IMAGE_REL_SH3_DIRECT8_WORD    type WORD value('0004'xn);
     /* 8 bit direct .W (0 ext.) */
 dcl IMAGE_REL_SH3_DIRECT8_LONG    type WORD value('0005'xn);
     /* 8 bit direct .L (0 ext.) */
 dcl IMAGE_REL_SH3_DIRECT4         type WORD value('0006'xn);
     /* 4 bit direct (0 ext.) */
 dcl IMAGE_REL_SH3_DIRECT4_WORD    type WORD value('0007'xn);
     /* 4 bit direct .W (0 ext.) */
 dcl IMAGE_REL_SH3_DIRECT4_LONG    type WORD value('0008'xn);
     /* 4 bit direct .L (0 ext.) */
 dcl IMAGE_REL_SH3_PCREL8_WORD     type WORD value('0009'xn);
     /* 8 bit PC relative .W */
 dcl IMAGE_REL_SH3_PCREL8_LONG     type WORD value('000A'xn);
     /* 8 bit PC relative .L */
 dcl IMAGE_REL_SH3_PCREL12_WORD    type WORD value('000B'xn);
     /* 12 LSB PC relative .W */
 dcl IMAGE_REL_SH3_STARTOF_SECTION type WORD value('000C'xn);
     /* Start of EXE section */
 dcl IMAGE_REL_SH3_SIZEOF_SECTION  type WORD value('000D'xn);
     /* Size of EXE section */
 dcl IMAGE_REL_SH3_SECTION         type WORD value('000E'xn);
     /* Section table index */
 dcl IMAGE_REL_SH3_SECREL          type WORD value('000F'xn);
     /* Offset within section */
 dcl IMAGE_REL_SH3_DIRECT32_NB     type WORD value('0010'xn);
     /* 32 bit direct not based */

 dcl IMAGE_REL_ARM_ABSOLUTE        type WORD value('0000'xn);
     /* No relocation required */
 dcl IMAGE_REL_ARM_ADDR32          type WORD value('0001'xn);
     /* 32 bit address */
 dcl IMAGE_REL_ARM_ADDR32NB        type WORD value('0002'xn);
     /* 32 bit address w/o image base */
 dcl IMAGE_REL_ARM_BRANCH24        type WORD value('0003'xn);
     /* 24 bit offset << 2 & sign ext. */
 dcl IMAGE_REL_ARM_BRANCH11        type WORD value('0004'xn);
     /* Thumb: 2 11 bit offsets */
 dcl IMAGE_REL_ARM_SECTION         type WORD value('000E'xn);
     /* Section table index */
 dcl IMAGE_REL_ARM_SECREL          type WORD value('000F'xn);
     /* Offset within section */

 /* IA64 relocation types. */

 dcl IMAGE_REL_IA64_ABSOLUTE       type WORD value('0000'xn);
 dcl IMAGE_REL_IA64_IMM14          type WORD value('0001'xn);
 dcl IMAGE_REL_IA64_IMM22          type WORD value('0002'xn);
 dcl IMAGE_REL_IA64_IMM64          type WORD value('0003'xn);
 dcl IMAGE_REL_IA64_DIR32          type WORD value('0004'xn);
 dcl IMAGE_REL_IA64_DIR64          type WORD value('0005'xn);
 dcl IMAGE_REL_IA64_PCREL21B       type WORD value('0006'xn);
 dcl IMAGE_REL_IA64_PCREL21M       type WORD value('0007'xn);
 dcl IMAGE_REL_IA64_PCREL21F       type WORD value('0008'xn);
 dcl IMAGE_REL_IA64_GPREL22        type WORD value('0009'xn);
 dcl IMAGE_REL_IA64_LTOFF22        type WORD value('000A'xn);
 dcl IMAGE_REL_IA64_SECTION        type WORD value('000B'xn);
 dcl IMAGE_REL_IA64_SECREL22       type WORD value('000C'xn);
 dcl IMAGE_REL_IA64_SECREL64I      type WORD value('000D'xn);
 dcl IMAGE_REL_IA64_SECREL32       type WORD value('000E'xn);
 dcl IMAGE_REL_IA64_LTOFF64        type WORD value('000F'xn);
 dcl IMAGE_REL_IA64_DIR32NB        type WORD value('0010'xn);
 dcl IMAGE_REL_IA64_RESERVED_11    type WORD value('0011'xn);
 dcl IMAGE_REL_IA64_RESERVED_12    type WORD value('0012'xn);
 dcl IMAGE_REL_IA64_RESERVED_13    type WORD value('0013'xn);
 dcl IMAGE_REL_IA64_RESERVED_14    type WORD value('0014'xn);
 dcl IMAGE_REL_IA64_RESERVED_15    type WORD value('0015'xn);
 dcl IMAGE_REL_IA64_RESERVED_16    type WORD value('0016'xn);
 dcl IMAGE_REL_IA64_ADDEND         type WORD value('001F'xn);



 /* Line number format. */

 define structure
   1 IMAGE_LINENUMBER,
     2 Type union,
       3 SymbolTableIndex type DWORD,
         /* Symbol table index of function nameif Linenumber is 0. */
       3 VirtualAddress type DWORD,/* Virtual address of line number. */
     2 Linenumber type WORD;/* Line number. */
 define alias PIMAGE_LINENUMBER handle IMAGE_LINENUMBER;

 dcl IMAGE_SIZEOF_LINENUMBER fixed bin(31) value(6);


 /* Based relocation format. */

 define structure
   1 IMAGE_BASE_RELOCATION,
     2 VirtualAddress type DWORD,
     2 SizeOfBlock    type DWORD;

 define alias PIMAGE_BASE_RELOCATION handle IMAGE_BASE_RELOCATION;

 dcl IMAGE_SIZEOF_BASE_RELOCATION fixed bin(31) value(8);


 /* Based relocation types. */

 dcl IMAGE_REL_BASED_ABSOLUTE       fixed bin(31) value(0);
 dcl IMAGE_REL_BASED_HIGH           fixed bin(31) value(1);
 dcl IMAGE_REL_BASED_LOW            fixed bin(31) value(2);
 dcl IMAGE_REL_BASED_HIGHLOW        fixed bin(31) value(3);
 dcl IMAGE_REL_BASED_HIGHADJ        fixed bin(31) value(4);
 dcl IMAGE_REL_BASED_MIPS_JMPADDR   fixed bin(31) value(5);
 dcl IMAGE_REL_BASED_SECTION        fixed bin(31) value(6);
 dcl IMAGE_REL_BASED_REL32          fixed bin(31) value(7);

 dcl IMAGE_REL_BASED_MIPS_JMPADDR16 fixed bin(31) value(9);
 dcl IMAGE_REL_BASED_IA64_IMM64     fixed bin(31) value(9);
 dcl IMAGE_REL_BASED_DIR64          fixed bin(31) value(10);
 dcl IMAGE_REL_BASED_HIGH3ADJ       fixed bin(31) value(11);

 /* Archive format. */

 dcl IMAGE_ARCHIVE_START_SIZE fixed bin(31) value(8);
 dcl IMAGE_ARCHIVE_START            char value('!<arch>' || '0a'x);
 dcl IMAGE_ARCHIVE_END              char value('`' || '0a'x);
 dcl IMAGE_ARCHIVE_PAD              char value('0a'x);
 dcl IMAGE_ARCHIVE_LINKER_MEMBER    char value('/               ');
 dcl IMAGE_ARCHIVE_LONGNAMES_MEMBER char value('//              ');


 define structure
   1 IMAGE_ARCHIVE_MEMBER_HEADER,
     2 Name      char(16), /* File member name -`/' terminated .*/
     2 Date      char(12), /* File member date - decimal.       */
     2 UserID    char( 6), /* File member user id - decimal.    */
     2 GroupID   char( 6), /* File member group id - decimal.   */
     2 Mode      char( 8), /* File member mode - octal.         */
     2 Size      char(10), /* File member size - decimal.       */
     2 EndHeader char( 2); /* String to end header.             */
 define alias PIMAGE_ARCHIVE_MEMBER_HEADER
              handle IMAGE_ARCHIVE_MEMBER_HEADER;

 dcl IMAGE_SIZEOF_ARCHIVE_MEMBER_HDR fixed bin(31) value(60);


 /* DLL support. */

 /* Export Format */

 define structure
   1 IMAGE_EXPORT_DIRECTORY,
     2 Characteristics       type DWORD,
     2 TimeDateStamp         type DWORD,
     2 MajorVersion          type WORD,
     2 MinorVersion          type WORD,
     2 Name                  type DWORD,
     2 Base                  type DWORD,
     2 NumberOfFunctions     type DWORD,
     2 NumberOfNames         type DWORD,
     2 AddressOfFunctions    type DWORD, /* RVA from base of image */
     2 AddressOfNames        type DWORD, /* RVA from base of image */
     2 AddressOfNameOrdinals type DWORD; /* RVA from base of image */
 define alias PIMAGE_EXPORT_DIRECTORY handle IMAGE_EXPORT_DIRECTORY;


 /* Import Format */

 define structure
   1 IMAGE_IMPORT_BY_NAME,
     2 Hint type WORD,
     2 Name char (1); /* or whatever size it is */
 define alias PIMAGE_IMPORT_BY_NAME handle IMAGE_IMPORT_BY_NAME;


 define structure
   1 IMAGE_THUNK_DATA64,
     2 u1 union,
       3 ForwarderString type PBYTE,
       3 Function        type PDWORD,
       3 Ordinal         type ULONGLONG,
       3 AddressOfData   type PIMAGE_IMPORT_BY_NAME;
 define alias PIMAGE_THUNK_DATA64 handle IMAGE_THUNK_DATA64;

 define structure
   1 IMAGE_THUNK_DATA32,
     2 u1 union,
       3 ForwarderString type PBYTE,
       3 Function        type PDWORD,
       3 Ordinal         type DWORD,
       3 AddressOfData   type PIMAGE_IMPORT_BY_NAME;
 define alias PIMAGE_THUNK_DATA32 handle IMAGE_THUNK_DATA32;

 dcl IMAGE_ORDINAL_FLAG64 type ULONGLONG value('8000000000000000'xu);
 dcl IMAGE_ORDINAL_FLAG32 type ULONG     value('80000000'xu);

 IMAGE_ORDINAL64: proc (Ordinal)
                  returns (type DWORD byvalue)
                  options(inline reorder) internal;
   dcl Ordinal type ULONGLONG byvalue;
   dcl iand builtin;
   return (iand (Ordinal, 'ffff'xu));
 end IMAGE_ORDINAL64;

 IMAGE_ORDINAL32: proc (Ordinal)
                  returns (type DWORD byvalue)
                  options(inline reorder) internal;
   dcl Ordinal type DWORD byvalue;
   dcl iand builtin;
   return (iand (Ordinal, 'ffff'xu));
 end IMAGE_ORDINAL32;

 IMAGE_SNAP_BY_ORDINAL64: proc (Ordinal)
                          returns (bit (1) aligned byvalue)
                          options(inline reorder) internal;
   dcl Ordinal type ULONGLONG byvalue;
   dcl iand builtin;
   return (iand (Ordinal, IMAGE_ORDINAL_FLAG64) ^= 0);
 end IMAGE_SNAP_BY_ORDINAL64;

 IMAGE_SNAP_BY_ORDINAL32: proc (Ordinal)
                          returns (bit (1) aligned byvalue)
                          options(inline reorder) internal;
   dcl Ordinal type DWORD byvalue;
   dcl iand builtin;
   return (iand (Ordinal, IMAGE_ORDINAL_FLAG32) ^= 0);
 end IMAGE_SNAP_BY_ORDINAL32;


 define alias PIMAGE_TLS_CALLBACK
              entry (type PVOID,
                     type DWORD,
                     type PVOID) limited NTAPI;

 define structure
   1 IMAGE_TLS_DIRECTORY64,
     2 StartAddressOfRawData type ULONGLONG,
     2 EndAddressOfRawData   type ULONGLONG,
     2 AddressOfIndex        type PDWORD,
     2 AddressOfCallBacks    type PIMAGE_TLS_CALLBACK,
     2 SizeOfZeroFill        type DWORD,
     2 Characteristics       type DWORD;
 define alias PIMAGE_TLS_DIRECTORY64 handle IMAGE_TLS_DIRECTORY64;

 define structure
   1 IMAGE_TLS_DIRECTORY32,
     2 StartAddressOfRawData type DWORD,
     2 EndAddressOfRawData   type DWORD,
     2 AddressOfIndex        type PDWORD,
     2 AddressOfCallBacks    type PIMAGE_TLS_CALLBACK,
     2 SizeOfZeroFill        type DWORD,
     2 Characteristics       type DWORD;
 define alias PIMAGE_TLS_DIRECTORY32 handle IMAGE_TLS_DIRECTORY32;

 %dcl IMAGE_ORDINAL char ext;
 %dcl IMAGE_SNAP_BY_ORDINAL char ext;
 %if #WIN64 ^= '' %then %do;
 dcl IMAGE_ORDINAL_FLAG type ULONGLONG value (IMAGE_ORDINAL_FLAG64);
 %IMAGE_ORDINAL = 'IMAGE_ORDINAL64';
 define alias  IMAGE_THUNK_DATA type  IMAGE_THUNK_DATA64;
 define alias PIMAGE_THUNK_DATA type PIMAGE_THUNK_DATA64;
 %IMAGE_SNAP_BY_ORDINAL = 'IMAGE_SNAP_BY_ORDINAL64';
 define alias  IMAGE_TLS_DIRECTORY type  IMAGE_TLS_DIRECTORY64;
 define alias PIMAGE_TLS_DIRECTORY type PIMAGE_TLS_DIRECTORY64;
 %end; %else %do;
 dcl IMAGE_ORDINAL_FLAG type ULONG value (IMAGE_ORDINAL_FLAG32);
 %IMAGE_ORDINAL = 'IMAGE_ORDINAL32';
 define alias  IMAGE_THUNK_DATA type  IMAGE_THUNK_DATA32;
 define alias PIMAGE_THUNK_DATA type PIMAGE_THUNK_DATA32;
 %IMAGE_SNAP_BY_ORDINAL = 'IMAGE_SNAP_BY_ORDINAL32';
 define alias  IMAGE_TLS_DIRECTORY type  IMAGE_TLS_DIRECTORY32;
 define alias PIMAGE_TLS_DIRECTORY type PIMAGE_TLS_DIRECTORY32;
 %end;


 define structure
   1 IMAGE_IMPORT_DESCRIPTOR,
     2 * union,
       3 Characteristics    type DWORD,
         /* 0 for terminating null import descriptor */
       3 OriginalFirstThunk type PIMAGE_THUNK_DATA,
         /* RVA to original unbound IAT */
     2 TimeDateStamp  type DWORD,/* 0 if not bound,            */
       /* -1 if bound, and real date\time stamp               */
       /*    in IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT (new BIND) */
       /* O.W. date/time stamp of DLL bound to (Old BIND)     */
     2 ForwarderChain type DWORD,/* -1 if no forwarders */
     2 Name           type DWORD,
     2 FirstThunk     type PIMAGE_THUNK_DATA;
       /* RVA to IAT (if bound this IAT has actual addresses) */
 define alias PIMAGE_IMPORT_DESCRIPTOR handle IMAGE_IMPORT_DESCRIPTOR;


 /* New format import descriptors pointed to by */
 /* DataDirectory[ IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT ] */

 define structure
   1 IMAGE_BOUND_IMPORT_DESCRIPTOR,
     2 TimeDateStamp               type DWORD,
     2 OffsetModuleName            type WORD,
     2 NumberOfModuleForwarderRefs type WORD;
     /* Array of zero or more IMAGE_BOUND_FORWARDER_REF follows */
 define alias PIMAGE_BOUND_IMPORT_DESCRIPTOR
              handle IMAGE_BOUND_IMPORT_DESCRIPTOR;

 define structure
   1 IMAGE_BOUND_FORWARDER_REF,
     2 TimeDateStamp    type DWORD,
     2 OffsetModuleName type WORD,
     2 Reserved         type WORD;
 define alias PIMAGE_BOUND_FORWARDER_REF
              handle IMAGE_BOUND_FORWARDER_REF;


 /* Resource Format. */

 /* Resource directory consists of two counts, following by a         */
 /* variable length array of directory entries. The first count is    */
 /* the number of entries at beginning of the array that have actual  */
 /* names associated with each entry.                                 */
 /* The entries are in ascending order, case insensitive strings.     */
 /* The second count is the number of entries that immediately        */
 /* follow the named entries. This second count identifies the number */
 /* of entries that have 16-bit integer Ids as their name.            */
 /* These entries are also sorted in ascending order.                 */
 /*                                                                   */
 /* This structure allows fast lookup by either name or number, but   */
 /* for any given resource entry only one form of lookup is           */
 /* supported, not both. This is consistant with the syntax of the    */
 /* .RC file and the .RES file.                                       */

 define structure
   1 IMAGE_RESOURCE_DIRECTORY,
     2 Characteristics      type DWORD,
     2 TimeDateStamp        type DWORD,
     2 MajorVersion         type WORD,
     2 MinorVersion         type WORD,
     2 NumberOfNamedEntries type WORD,
     2 NumberOfIdEntries    type WORD;
     /* DirectoryEntries(*) type IMAGE_RESOURCE_DIRECTORY_ENTRY */
 define alias PIMAGE_RESOURCE_DIRECTORY
              handle IMAGE_RESOURCE_DIRECTORY;

 dcl IMAGE_RESOURCE_NAME_IS_STRING   fixed bin(31) value('80000000'xn);
 dcl IMAGE_RESOURCE_DTA_IS_DIRECTORY fixed bin(31) value('80000000'xn);


 /* Each directory contains the 32-bit Name of the entry and an       */
 /* offset, relative to the beginning of the resource directory of    */
 /* the data associated with this directory entry. If the name of the */
 /* entry is an actual text string instead of an integer Id, then the */
 /* high order bit of the name field is set to one and the low order  */
 /* 31-bits are an offset, relative to the beginning of the resource  */
 /* directory of the string, which is of type                         */
 /* IMAGE_RESOURCE_DIRECTORY_STRING. Otherwise the high bit is clear  */
 /* and the low-order 16-bits are the integer Id that identify this   */
 /* resource directory entry. If the directory entry is yet another   */
 /* resource directory (i.e. a subdirectory), then the high order bit */
 /* of the offset field will be set to indicate this. Otherwise the   */
 /* high bit is clear and the offset field points to a resource data  */
 /* entry.                                                            */

 /* PL/I note: there is no way to map the C bit-field declaration to  */
 /* PL/I on a little-endian system. The high bit is actually part of  */
 /* the fourth byte, and the 31-bits of offset are not contiguous.    */

 define structure
   1 IMAGE_RESOURCE_DIRECTORY_ENTRY,
     2 * union,
       /* first variant unmappable - test sign on Name */
       3 Name type DWORD,
       3 Id   type WORD,
     2 * union,
       3 OffsetToData type DWORD;
       /* second variant unmappable - test sign on OffsetToData */
 define alias PIMAGE_RESOURCE_DIRECTORY_ENTRY
              handle IMAGE_RESOURCE_DIRECTORY_ENTRY;


 /* For resource directory entries that have actual string names,     */
 /* the Name field of the directory entry points to an object of the  */
 /* following type. All of these string objects are stored together   */
 /* after the last resource directory entry and before the first      */
 /* resource data object. This minimizes the impact of these variable */
 /* length objects on the alignment of the fixed size directory entry */
 /* objects.                                                          */


 define structure
   1 IMAGE_RESOURCE_DIRECTORY_STRING,
     2 Length     type WORD,
     2 NameString cHAR(1); /* or whatever the length may be */
 define alias PIMAGE_RESOURCE_DIRECTORY_STRING
              handle IMAGE_RESOURCE_DIRECTORY_STRING;


 define structure
   1 IMAGE_RESOURCE_DIR_STRING_U,
     2 Length     type WORD,
     2 NameString WCHAR (1); /* or whatever the length may be */
 define alias PIMAGE_RESOURCE_DIR_STRING_U
              handle IMAGE_RESOURCE_DIR_STRING_U;


 /* Each resource data entry describes a leaf node in the resource    */
 /* directory tree. It contains an offset, relative to the beginning  */
 /* of the resource directory of the data for the resource, a size    */
 /* field that gives the number of bytes of data at that offset, a    */
 /* CodePage that should be used when decoding code point values      */
 /* within the resource data. Typically for new applications the code */
 /* page would be the unicode code page.                              */

 define structure
   1 IMAGE_RESOURCE_DATA_ENTRY,
     2 OffsetToData type DWORD,
     2 Size         type DWORD,
     2 CodePage     type DWORD,
     2 Reserved     type DWORD;
 define alias PIMAGE_RESOURCE_DATA_ENTRY
              handle IMAGE_RESOURCE_DATA_ENTRY;


 /* Load Configuration Directory Entry */

 define structure
   1 IMAGE_LOAD_CONFIG_DIRECTORY32,
     2 Characteristics               type DWORD,
     2 TimeDateStamp                 type DWORD,
     2 MajorVersion                  type WORD,
     2 MinorVersion                  type WORD,
     2 GlobalFlagsClear              type DWORD,
     2 GlobalFlagsSet                type DWORD,
     2 CriticalSectionDefaultTimeout type DWORD,
     2 DeCommitFreeBlockThreshold    type DWORD,
     2 DeCommitTotalFreeThreshold    type DWORD,
     2 LockPrefixTable               type DWORD,
     2 MaximumAllocationSize         type DWORD,
     2 VirtualMemoryThreshold        type DWORD,
     2 ProcessHeapFlags              type DWORD,
     2 ProcessAffinityMask           type DWORD,
     2 CSDVersion                    type WORD,
     2 Reserved1                     type WORD,
     2 EditList                      type DWORD,
     2 Reserved (1)                  type DWORD;
 define alias PIMAGE_LOAD_CONFIG_DIRECTORY32
              handle IMAGE_LOAD_CONFIG_DIRECTORY32;

 define structure
   1 IMAGE_LOAD_CONFIG_DIRECTORY64,
     2 Characteristics               type DWORD,
     2 TimeDateStamp                 type DWORD,
     2 MajorVersion                  type WORD,
     2 MinorVersion                  type WORD,
     2 GlobalFlagsClear              type DWORD,
     2 GlobalFlagsSet                type DWORD,
     2 CriticalSectionDefaultTimeout type DWORD,
     2 DeCommitFreeBlockThreshold    type DWORD,
     2 DeCommitTotalFreeThreshold    type DWORD,
     2 LockPrefixTable               type ULONGLONG,
     2 MaximumAllocationSize         type DWORD,
     2 VirtualMemoryThreshold        type DWORD,
     2 ProcessHeapFlags              type DWORD,
     2 ProcessAffinityMask           type DWORD,
     2 CSDVersion                    type WORD,
     2 Reserved1                     type WORD,
     2 EditList                      type ULONGLONG,
     2 Reserved (1)                  type DWORD;
 define alias PIMAGE_LOAD_CONFIG_DIRECTORY64
              handle IMAGE_LOAD_CONFIG_DIRECTORY64;

 %if #WIN64 ^= '' %then %do;
 define alias IMAGE_LOAD_CONFIG_DIRECTORY
              type IMAGE_LOAD_CONFIG_DIRECTORY64;
 define alias PIMAGE_LOAD_CONFIG_DIRECTORY
              type PIMAGE_LOAD_CONFIG_DIRECTORY64;
 %end; %else %do;
 define alias IMAGE_LOAD_CONFIG_DIRECTORY
              type IMAGE_LOAD_CONFIG_DIRECTORY32;
 define alias PIMAGE_LOAD_CONFIG_DIRECTORY
              type PIMAGE_LOAD_CONFIG_DIRECTORY32;
 %end;

 /* Function table entry format for IA64 images. Function table       */
 /* is pointed to by the IMAGE_DIRECTORY_ENTRY_EXCEPTION directory    */
 /* entry. This definition duplicates the one in ntia64.h             */
 /* for use by portable image file mungers.                           */

 define structure
   1 IMAGE_IA64_RUNTIME_FUNCTION_ENTRY,
     2 BeginAddress      type DWORD,
     2 EndAddress        type DWORD,
     2 UnwindInfoAddress type DWORD;
 define alias PIMAGE_IA64_RUNTIME_FUNCTION_ENTRY
              handle IMAGE_IA64_RUNTIME_FUNCTION_ENTRY;

 /* Function table entry format for MIPS/ALPHA images. Function table */
 /* is pointed to by the IMAGE_DIRECTORY_ENTRY_EXCEPTION directory    */
 /* entry. This definition duplicates ones in ntmips.h and ntalpha.h  */
 /* for use by portable image file mungers.                           */

 define structure
   1 IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY,
     2 BeginAddress     type DWORD,
     2 EndAddress       type DWORD,
     2 ExceptionHandler type DWORD,
     2 HandlerData      type DWORD,
     2 PrologEndAddress type DWORD;
 define alias PIMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY
              handle IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY;

 define structure
   1 IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY,
     2 BeginAddress     type ULONGLONG,
     2 EndAddress       type ULONGLONG,
     2 ExceptionHandler type ULONGLONG,
     2 HandlerData      type ULONGLONG,
     2 PrologEndAddress type ULONGLONG;
 define alias PIMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY
              handle IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY;

 define alias  IMAGE_AXP64_RUNTIME_FUNCTION_ENTRY
              type  IMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY;
 define alias PIMAGE_AXP64_RUNTIME_FUNCTION_ENTRY
              type PIMAGE_ALPHA64_RUNTIME_FUNCTION_ENTRY;

 /* WIN CE Exception table format */

 /* PL/I note: there is no way to map the C bit-field declaration to  */
 /* PL/I on a little-endian system. The high bit is actually part of  */
 /* the fourth byte, and the 22-bits of Funclen are not contiguous.   */
 define structure /* little endian bit layout */
   1 IMAGE_CE_RUNTIME_FUNCTION_ENTRY,
     2 FuncStart     type DWORD,
       /* FuncStart     : 32 */
     2 UnMappable    type DWORD;
       /* PrologLen     :  8 */
       /* FuncLen       : 22 */
       /* ThirtyTwoBit  :  1 */
       /* ExceptionFlag :  1 */
 define alias PIMAGE_CE_RUNTIME_FUNCTION_ENTRY
              handle IMAGE_CE_RUNTIME_FUNCTION_ENTRY;

 %dcl #IA64_ char ext;
 %if #IA64_ ^= '' %then %do;
 define alias  IMAGE_RUNTIME_FUNCTION_ENTRY
              type  IMAGE_IA64_RUNTIME_FUNCTION_ENTRY;
 define alias PIMAGE_RUNTIME_FUNCTION_ENTRY
              type PIMAGE_IA64_RUNTIME_FUNCTION_ENTRY;
 %end; %else %do;
 define alias  IMAGE_RUNTIME_FUNCTION_ENTRY
              type  IMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY;
 define alias PIMAGE_RUNTIME_FUNCTION_ENTRY
              type PIMAGE_ALPHA_RUNTIME_FUNCTION_ENTRY;
 %end;

 /* Debug Format */

 define structure
   1 IMAGE_DEBUG_DIRECTORY,
      2 Characteristics  type DWORD,
      2 TimeDateStamp    type DWORD,
      2 MajorVersion     type WORD,
      2 MinorVersion     type WORD,
      2 Type             type DWORD,
      2 SizeOfData       type DWORD,
      2 AddressOfRawData type DWORD,
      2 PointerToRawData type DWORD;
 define alias PIMAGE_DEBUG_DIRECTORY handle IMAGE_DEBUG_DIRECTORY;

 dcl IMAGE_DEBUG_TYPE_UNKNOWN       fixed bin(31) value(0);
 dcl IMAGE_DEBUG_TYPE_COFF          fixed bin(31) value(1);
 dcl IMAGE_DEBUG_TYPE_CODEVIEW      fixed bin(31) value(2);
 dcl IMAGE_DEBUG_TYPE_FPO           fixed bin(31) value(3);
 dcl IMAGE_DEBUG_TYPE_MISC          fixed bin(31) value(4);
 dcl IMAGE_DEBUG_TYPE_EXCEPTION     fixed bin(31) value(5);
 dcl IMAGE_DEBUG_TYPE_FIXUP         fixed bin(31) value(6);
 dcl IMAGE_DEBUG_TYPE_OMAP_TO_SRC   fixed bin(31) value(7);
 dcl IMAGE_DEBUG_TYPE_OMAP_FROM_SRC fixed bin(31) value(8);
 dcl IMAGE_DEBUG_TYPE_BORLAND       fixed bin(31) value(9);

 define structure
   1 IMAGE_COFF_SYMBOLS_HEADER,
     2 NumberOfSymbols      type DWORD,
     2 LvaToFirstSymbol     type DWORD,
     2 NumberOfLinenumbers  type DWORD,
     2 LvaToFirstLinenumber type DWORD,
     2 RvaToFirstByteOfCode type DWORD,
     2 RvaToLastByteOfCode  type DWORD,
     2 RvaToFirstByteOfData type DWORD,
     2 RvaToLastByteOfData  type DWORD;
 define alias PIMAGE_COFF_SYMBOLS_HEADER
              handle IMAGE_COFF_SYMBOLS_HEADER;

 dcl FRAME_FPO    fixed bin(31) value(0);
 dcl FRAME_TRAP   fixed bin(31) value(1);
 dcl FRAME_TSS    fixed bin(31) value(2);
 dcl FRAME_NONFPO fixed bin(31) value(3);

 define structure /* note: bits ordered for little-endian system */
   1 FPO_DATA,
     2 ulOffStart type DWORD,       /*offset 1st byte of function code*/
     2 cbProcSize type DWORD,       /* # bytes in function */
     2 cdwLocals  type DWORD,       /* # bytes in locals/4 */
     2 cdwParams  type WORD,        /* # bytes in params/4 */
     2 cbProlog   bit(8) unaligned, /* # bytes in prolog */
     2 cbFrame    bit(2) unaligned, /* frame type */
     2 reserved   bit(1) unaligned, /* reserved for future use */
     2 fUseBP     bit(1) unaligned, /* TRUE if EBP has been allocated */
     2 fHasSEH    bit(1) unaligned, /* TRUE if SEH in func */
     2 cbRegs     bit(3) unaligned; /* # regs saved */
 define alias PFPO_DATA handle FPO_DATA;

 dcl SIZEOF_RFPO_DATA fixed bin(31) value(16);

 dcl IMAGE_DEBUG_MISC_EXENAME fixed bin(31) value(1);

 define structure
   1 IMAGE_DEBUG_MISC,
     2 DataType type DWORD, /* type of misc data, see defines */
     2 Length   type DWORD,
       /* total length of record, rounded to four byte multiple */
     2 #Unicode type BOOLEAN, /* TRUE if data is unicode string */
     2 Reserved (3) type BYTE,
     2 Data     (1) type BYTE;  /* Actual data , multiple bytes */
 define alias PIMAGE_DEBUG_MISC handle IMAGE_DEBUG_MISC;


 /* Function table extracted from MIPS/ALPHA images.              */
 /* Does not contain information needed only for runtime support. */
 /* Just those fields for each entry needed by a debugger.        */

 define structure
   1 IMAGE_FUNCTION_ENTRY,
     2 StartingAddress type DWORD,
     2 EndingAddress   type DWORD,
     2 EndOfPrologue   type DWORD;
 define alias PIMAGE_FUNCTION_ENTRY handle IMAGE_FUNCTION_ENTRY;

 define structure
   1 IMAGE_FUNCTION_ENTRY64,
     2 StartingAddress type ULONGLONG,
     2 EndingAddress   type ULONGLONG,
     2 * union,
       3 EndOfPrologue     type ULONGLONG,
       3 UnwindInfoAddress type ULONGLONG;
 define alias PIMAGE_FUNCTION_ENTRY64 handle IMAGE_FUNCTION_ENTRY64;

 /* Debugging information can be stripped from an image file and      */
 /* placed in a separate .DBG file, whose file name part is the same  */
 /* as the image file name part (e.g. symbols for CMD.EXE could be    */
 /* stripped and placed in CMD.DBG). This is indicated by the         */
 /* IMAGE_FILE_DEBUG_STRIPPED flag in the Characteristics field of    */
 /* the file header. The beginning of the .DBG file contains the      */
 /* following structure which captures certain information from the   */
 /* image file. This allows a debug to proceed even if the original   */
 /* image file is not accessable. This header is followed by zero of  */
 /* more IMAGE_SECTION_HEADER structures, followed by zero or more    */
 /* IMAGE_DEBUG_DIRECTORY structures. The latter structures and those */
 /* in the image file contain file offsets relative to the beginning  */
 /* of the .DBG file.                                                 */
 /*                                                                   */
 /* If symbols have been stripped from an image, the IMAGE_DEBUG_MISC */
 /* structure is left in the image file, but not mapped. This allows  */
 /* a debugger to compute the name of the .DBG file, from the name of */
 /* the image in the IMAGE_DEBUG_MISC structure.                      */

 define structure
   1 IMAGE_SEPARATE_DEBUG_HEADER,
     2 Signature          type WORD,
     2 Flags              type WORD,
     2 Machine            type WORD,
     2 Characteristics    type WORD,
     2 TimeDateStamp      type DWORD,
     2 CheckSum           type DWORD,
     2 ImageBase          type DWORD,
     2 SizeOfImage        type DWORD,
     2 NumberOfSections   type DWORD,
     2 ExportedNamesSize  type DWORD,
     2 DebugDirectorySize type DWORD,
     2 SectionAlignment   type DWORD,
     2 Reserved (2)       type DWORD;
 define alias PIMAGE_SEPARATE_DEBUG_HEADER
              handle  IMAGE_SEPARATE_DEBUG_HEADER;

 dcl IMAGE_SEPARATE_DEBUG_SIGNATURE  type WORD value('4944'xn);

 dcl IMAGE_SEPARATE_DEBUG_FLAGS_MASK type WORD value('8000'xn);
 dcl IMAGE_SEPARATE_DEBUG_MISMATCH   type WORD value('8000'xn);
     /* when DBG was updated, the old checksum didn't match. */


 /* The .arch section is made up of headers, each describing an amask */
 /* position/value pointing to an array of IMAGE_ARCHITECTURE_ENTRY's.*/
 /* Each "array" (both the header and entry arrays) are terminiated   */
 /* by a quadword of 0xffffffffL.                                     */
 /*                                                                   */
 /* NOTE: There may be quadwords of 0 sprinkled around and must be    */
 /* skipped.                                                          */

 define structure
   1 IMAGE_ARCHITECTURE_HEADER,
     /* PL/I bit mapping reflects Intel byte order */
     2 *          bit (16),/* MBZ */
     2 AmaskShift bit (8), /* Amask bit in question for this fixup */
     2 *          bit (7), /* MBZ */
     2 AmaskValue bit (1), /* 1 -> code section depends on mask bit   */
                           /* 0 -> new instruction depends on mask bit*/
     2 FirstEntryRVA type DWORD;
       /* RVA into .arch section to array of ARCHITECTURE_ENTRY's */

 define alias PIMAGE_ARCHITECTURE_HEADER
              handle IMAGE_ARCHITECTURE_HEADER;

 define structure
   1 IMAGE_ARCHITECTURE_ENTRY,
     2 FixupInstRVA type DWORD, /* RVA of instruction to fixup */
     2 NewInst      type DWORD; /* fixup instruction (see alphaops.h) */
 define alias PIMAGE_ARCHITECTURE_ENTRY handle IMAGE_ARCHITECTURE_ENTRY;


 /* The following structure defines the new import object.            */
 /* Note the values of the first two fields, which must be set as     */
 /* stated in order to differentiate old and new import members.      */
 /* Following this structure, the linker emits two null-terminated    */
 /* strings used to recreate the import at the time of use. The first */
 /* string is the import's name, the second is the dll's name.        */

 dcl IMPORT_OBJECT_HDR_SIG2 type WORD value ('ffff'xu);

 define structure
   1 IMPORT_OBJECT_HEADER,

     2 Sig1          type WORD, /* Must be IMAGE_FILE_MACHINE_UNKNOWN */
     2 Sig2          type WORD, /* Must be IMPORT_OBJECT_HDR_SIG2. */
     2 Version       type WORD,
     2 Machine       type WORD,
     2 TimeDateStamp type DWORD, /* Time/date stamp */
     2 SizeOfData    type DWORD,
       /* particularly useful for incremental links */
     2 * union,
       3 Ordinal     type WORD, /* if grf & IMPORT_OBJECT_ORDINAL */
       3 Hint        type WORD,

     /* PL/I bit mapping reflects Intel byte order */
     2 Reserved      bit(11),   /* Reserved. Must be zero. */
     2 NameType      bit( 3),   /* IMPORT_NAME_TYPE */
     2 Type          bit( 2);   /* IMPORT_TYPE */

 define ordinal IMPORT_OBJECT_TYPE
  ( IMPORT_OBJECT_CODE  value (0)
  , IMPORT_OBJECT_DATA  value (1)
  , IMPORT_OBJECT_CONST value (2)
  ) prec (31);

 define ordinal IMPORT_OBJECT_NAME_TYPE
   ( IMPORT_OBJECT_ORDINAL         value(0) /* Import by ordinal   */
   , IMPORT_OBJECT_NAME            value(1) /* Import name ==      */
     /* public symbol name. */
   , IMPORT_OBJECT_NAME_NO_PREFIX  value(2) /* Import name ==      */
     /* public symbol name skipping leading ?, @, or optionally _. */
   , IMPORT_OBJECT_NAME_UNDECORATE value(3) /* Import name ==      */
     /* public symbol name skipping leading ?, @, or optionally _  */
     /* and truncating at first @                                  */
  ) prec (31);

 /* End Image Format */


 dcl HEAP_NO_SERIALIZE             fixed bin(31) value('00000001'xn);
 dcl HEAP_GROWABLE                 fixed bin(31) value('00000002'xn);
 dcl HEAP_GENERATE_EXCEPTIONS      fixed bin(31) value('00000004'xn);
 dcl HEAP_ZERO_MEMORY              fixed bin(31) value('00000008'xn);
 dcl HEAP_REALLOC_IN_PLACE_ONLY    fixed bin(31) value('00000010'xn);
 dcl HEAP_TAIL_CHECKING_ENABLED    fixed bin(31) value('00000020'xn);
 dcl HEAP_FREE_CHECKING_ENABLED    fixed bin(31) value('00000040'xn);
 dcl HEAP_DISABLE_COALESCE_ON_FREE fixed bin(31) value('00000080'xn);
 dcl HEAP_CREATE_ALIGN_16          fixed bin(31) value('00010000'xn);
 dcl HEAP_CREATE_ENABLE_TRACING    fixed bin(31) value('00020000'xn);
 dcl HEAP_MAXIMUM_TAG              fixed bin(31) value('0FFF'xn);
 dcl HEAP_PSEUDO_TAG_FLAG          fixed bin(31) value('8000'xn);
 dcl HEAP_TAG_SHIFT                fixed bin(31) value(18);


 HEAP_MAKE_TAG_FLAGS: proc (b, o) returns (type DWORD byvalue)
                      options (inline reorder) internal;
  dcl (b, o) type DWORD byvalue;
  dcl raise2 builtin;
  return (b + raise2 (o, 18));
 end HEAP_MAKE_TAG_FLAGS;


 dcl IS_TEXT_UNICODE_ASCII16          fixed bin(31) value('0001'xn);
 dcl IS_TEXT_UNICODE_REVERSE_ASCII16  fixed bin(31) value('0010'xn);

 dcl IS_TEXT_UNICODE_STATISTICS       fixed bin(31) value('0002'xn);
 dcl IS_TEXT_UNICODE_ERSE_STATISTICS  fixed bin(31) value('0020'xn);

 dcl IS_TEXT_UNICODE_CONTROLS         fixed bin(31) value('0004'xn);
 dcl IS_TEXT_UNICODE_EVERSE_CONTROLS  fixed bin(31) value('0040'xn);

 dcl IS_TEXT_UNICODE_SIGNATURE        fixed bin(31) value('0008'xn);
 dcl IS_TEXT_UNICODE_VERSE_SIGNATURE  fixed bin(31) value('0080'xn);

 dcl IS_TEXT_UNICODE_ILLEGAL_CHARS    fixed bin(31) value('0100'xn);
 dcl IS_TEXT_UNICODE_ODD_LENGTH       fixed bin(31) value('0200'xn);
 dcl IS_TEXT_UNICODE_DBCS_LEADBYTE    fixed bin(31) value('0400'xn);
 dcl IS_TEXT_UNICODE_NULL_BYTES       fixed bin(31) value('1000'xn);

 dcl IS_TEXT_UNICODE_UNICODE_MASK     fixed bin(31) value('000F'xn);
 dcl IS_TEXT_UNICODE_REVERSE_MASK     fixed bin(31) value('00F0'xn);
 dcl IS_TEXT_UNICODE_NOT_UNICODE_MASK fixed bin(31) value('0F00'xn);
 dcl IS_TEXT_UNICODE_NOT_ASCII_MASK   fixed bin(31) value('F000'xn);

 dcl COMPRESSION_FORMAT_NONE          fixed bin(31) value('0000'xn);
 dcl COMPRESSION_FORMAT_DEFAULT       fixed bin(31) value('0001'xn);
 dcl COMPRESSION_FORMAT_LZNT1         fixed bin(31) value('0002'xn);
 dcl COMPRESSION_ENGINE_STANDARD      fixed bin(31) value('0000'xn);
 dcl COMPRESSION_ENGINE_MAXIMUM       fixed bin(31) value('0100'xn);

 /* Only Intel mappings here */

 dcl RtlCompareMemory
     entry (pointer,
            pointer,
            type SIZE_T)
     returns (type SIZE_T byvalue optional)
     NTSYSAPI NTAPI external('RtlCompareMemory');

 RtlEqualMemory: proc (Destination, Source, Length)
                 returns (bit (1) aligned byvalue)
                 options (inline reorder) internal;
   dcl Destination pointer byvalue,
       Source      pointer byvalue,
       Length      fixed bin (31) byvalue;
   dcl compare builtin;
   return (compare (Destination, Source, Length) = 0);
 end RtlEqualMemory;

 RtlMoveMemory: proc (Destination, Source, Length)
                options (inline reorder) internal;
   dcl Destination pointer byvalue,
       Source      pointer byvalue,
       Length      fixed bin (31) byvalue;
   dcl pliover builtin;
   call pliover (Destination, Source, Length);
 end RtlMoveMemory;

 RtlCopyMemory: proc (Destination, Source, Length)
                options (inline reorder) internal;
   dcl Destination pointer byvalue,
       Source      pointer byvalue,
       Length      fixed bin (31) byvalue;
   dcl plimove builtin;
   call plimove (Destination, Source, Length);
 end RtlCopyMemory;

 RtlFillMemory: proc (Destination, Length, Fill)
                options (inline reorder) internal;
   dcl Destination pointer byvalue,
       Length      fixed bin (31) byvalue,
       fill        char (1) byvalue;
   dcl plifill builtin;
   call plifill (Destination, Fill, Length);
 end RtlFillMemory;

 RtlZeroMemory: proc (Destination, Length)
                options (inline reorder) internal;
   dcl Destination pointer byvalue,
       Length      fixed bin (31) byvalue;
   dcl (low, plifill) builtin;
   call plifill (Destination, low(1), Length);
 end RtlZeroMemory;


 dcl
   1 MESSAGE_RESOURCE_ENTRY based,
     2 Length   type WORD,
     2 Flags    type WORD,
     2 Text (1 refer (MESSAGE_RESOURCE_ENTRY.Length)) type BYTE;
 define alias PMESSAGE_RESOURCE_ENTRY pointer;

 dcl MESSAGE_RESOURCE_UNICODE fixed bin(15) value('0001'xn);

 define structure
   1 MESSAGE_RESOURCE_BLOCK,
     2 LowId           type DWORD,
     2 HighId          type DWORD,
     2 OffsetToEntries type DWORD;
 define alias PMESSAGE_RESOURCE_BLOCK handle MESSAGE_RESOURCE_BLOCK;

 dcl
   1 MESSAGE_RESOURCE_DATA based,
    2 NumberOfBlocks type DWORD,
    2 Blocks (1 refer (MESSAGE_RESOURCE_DATA.NumberOfBlocks))
                     type MESSAGE_RESOURCE_BLOCK;
 define alias PMESSAGE_RESOURCE_DATA pointer;

 define structure
   1 OSVERSIONINFOA,
     2 dwOSVersionInfoSize type DWORD,
     2 dwMajorVersion      type DWORD,
     2 dwMinorVersion      type DWORD,
     2 dwBuildNumber       type DWORD,
     2 dwPlatformId        type DWORD,
     2 szCSDVersion        char (128-1) varz;
     /* Maintenance string for PSS usage */
 define alias  POSVERSIONINFOA handle OSVERSIONINFOA;
 define alias LPOSVERSIONINFOA handle OSVERSIONINFOA;

 define structure
   1 OSVERSIONINFOW,
     2 dwOSVersionInfoSize type DWORD,
     2 dwMajorVersion      type DWORD,
     2 dwMinorVersion      type DWORD,
     2 dwBuildNumber       type DWORD,
     2 dwPlatformId        type DWORD,
     2 szCSDVersion        WCHAR (128-1) varz;
     /* Maintenance string for PSS usage */
 define alias  POSVERSIONINFOW handle OSVERSIONINFOW;
 define alias LPOSVERSIONINFOW handle OSVERSIONINFOW;

 %if UNICODE ^= '' %then %do;
   define alias   OSVERSIONINFO type   OSVERSIONINFOW;
   define alias  POSVERSIONINFO type  POSVERSIONINFOW;
   define alias LPOSVERSIONINFO type LPOSVERSIONINFOW;
 %end; %else %do;
   define alias   OSVERSIONINFO type   OSVERSIONINFOA;
   define alias  POSVERSIONINFO type  POSVERSIONINFOA;
   define alias LPOSVERSIONINFO type LPOSVERSIONINFOA;
 %end; /* UNICODE */

 define structure
   1 OSVERSIONINFOEXA,
     2 dwOSVersionInfoSize type DWORD,
     2 dwMajorVersion      type DWORD,
     2 dwMinorVersion      type DWORD,
     2 dwBuildNumber       type DWORD,
     2 dwPlatformId        type DWORD,
     2 szCSDVersion        char (128 - 1) varz,
       /* Maintenance string for PSS usage */
     2 wServicePackMajor   type WORD,
     2 wServicePackMinor   type WORD,
     2 wSuiteMask          type WORD,
     2 wReserved           type WORD;
 define alias  POSVERSIONINFOEXA handle OSVERSIONINFOEXA;
 define alias LPOSVERSIONINFOEXA handle OSVERSIONINFOEXA;

 define structure
   1 OSVERSIONINFOEXW,
     2 dwOSVersionInfoSize type DWORD,
     2 dwMajorVersion      type DWORD,
     2 dwMinorVersion      type DWORD,
     2 dwBuildNumber       type DWORD,
     2 dwPlatformId        type DWORD,
     2 szCSDVersion        WCHAR (128 - 1) varz,
       /* Maintenance string for PSS usage */
     2 wServicePackMajor   type WORD,
     2 wServicePackMinor   type WORD,
     2 wSuiteMask          type WORD,
     2 wReserved           type WORD;
 define alias  POSVERSIONINFOEXW handle OSVERSIONINFOEXW;
 define alias LPOSVERSIONINFOEXW handle OSVERSIONINFOEXW;

 %if UNICODE ^= '' %then %do;
   define alias   OSVERSIONINFOEX type   OSVERSIONINFOEXW;
   define alias  POSVERSIONINFOEX type  POSVERSIONINFOEXW;
   define alias LPOSVERSIONINFOEX type LPOSVERSIONINFOEXW;
 %end; %else %do;
   define alias   OSVERSIONINFOEX type   OSVERSIONINFOEXA;
   define alias  POSVERSIONINFOEX type  POSVERSIONINFOEXA;
   define alias LPOSVERSIONINFOEX type LPOSVERSIONINFOEXA;
 %end; /* UNICODE */



 /* RtlVerifyVersionInfo() conditions */

 dcl VER_EQUAL                       fixed bin(31) value(1);
 dcl VER_GREATER                     fixed bin(31) value(2);
 dcl VER_GREATER_EQUAL               fixed bin(31) value(3);
 dcl VER_LESS                        fixed bin(31) value(4);
 dcl VER_LESS_EQUAL                  fixed bin(31) value(5);
 dcl VER_AND                         fixed bin(31) value(6);
 dcl VER_OR                          fixed bin(31) value(7);

 dcl VER_CONDITION_MASK              fixed bin(31) value(7);
 dcl VER_NUM_BITS_PER_CONDITION_MASK fixed bin(31) value(3);

 /* RtlVerifyVersionInfo() type mask bits */

 dcl VER_MINORVERSION                fixed bin(31) value('0000001'xn);
 dcl VER_MAJORVERSION                fixed bin(31) value('0000002'xn);
 dcl VER_BUILDNUMBER                 fixed bin(31) value('0000004'xn);
 dcl VER_PLATFORMID                  fixed bin(31) value('0000008'xn);
 dcl VER_SERVICEPACKMINOR            fixed bin(31) value('0000010'xn);
 dcl VER_SERVICEPACKMAJOR            fixed bin(31) value('0000020'xn);
 dcl VER_SUITENAME                   fixed bin(31) value('0000040'xn);
 dcl VER_PRODUCT_TYPE                fixed bin(31) value('0000080'xn);

 /* RtlVerifyVersionInfo() os product type values */

 dcl VER_NT_WORKSTATION              fixed bin(31) value('0000001'xn);
 dcl VER_NT_DOMAIN_CONTROLLER        fixed bin(31) value('0000002'xn);
 dcl VER_NT_SERVER                   fixed bin(31) value('0000003'xn);

 /* dwPlatformId defines: */

 dcl VER_PLATFORM_WIN32s             fixed bin(31) value(0);
 dcl VER_PLATFORM_WIN32_WINDOWS      fixed bin(31) value(1);
 dcl VER_PLATFORM_WIN32_NT           fixed bin(31) value(2);

 /* VerifyVersionInfo() macro to set the condition mask */

 VER_SET_CONDITION: proc (_m_, _t_, _c_)
                    returns (type ULONGLONG byvalue optional)
                    options (inline reorder) internal;
   dcl _m_ type ULONGLONG byaddr;
   dcl _t_ type DWORD byvalue;
   dcl _c_ type BYTE byvalue;

   _m_ = VerSetConditionMask (_m_, _t_, _c_);
   return (_m_);
 end VER_SET_CONDITION;

 dcl VerSetConditionMask
     entry (type ULONGLONG,
            type DWORD,
            type BYTE)
     returns (type ULONGLONG byvalue optional)
     NTAPI external('VerSetConditionMask');


 define structure
   1 RTL_CRITICAL_SECTION_DEBUG,
    2 Type                  type WORD,
    2 CreatorBackTraceIndex type WORD,
    2 CriticalSection       handle RTL_CRITICAL_SECTION,
    2 ProcessLocksList      type LIST_ENTRY,
    2 EntryCount            type DWORD,
    2 ContentionCount       type DWORD,
    2 Spare (2)             type DWORD;

 define alias PRTL_CRITICAL_SECTION_DEBUG
              handle RTL_CRITICAL_SECTION_DEBUG;

 dcl RTL_CRITSECT_TYPE fixed bin(31) value(0);
 dcl RTL_RESOURCE_TYPE fixed bin(31) value(1);


 define structure
   1 RTL_CRITICAL_SECTION,
     2 DebugInfo      type PRTL_CRITICAL_SECTION_DEBUG,
     /* The following three fields control entering and exiting */
     /* the critical section for the resource                   */
     2 LockCount      type LONG,
     2 RecursionCount type LONG,
     2 OwningThread   type HANDLE,
                      /* from the thread's ClientId=>UniqueThread */
     2 LockSemaphore  type HANDLE,
     2 SpinCount      type DWORD;
 define alias PRTL_CRITICAL_SECTION handle RTL_CRITICAL_SECTION;

 dcl SEF_DACL_AUTO_INHERIT             type BYTE value ('01'xn);
 dcl SEF_SACL_AUTO_INHERIT             type BYTE value ('02'xn);
 dcl SEF_DEFAULT_DESCRIPTOR_FOR_OBJECT type BYTE value ('04'xn);
 dcl SEF_AVOID_PRIVILEGE_CHECK         type BYTE value ('08'xn);
 dcl SEF_AVOID_OWNER_CHECK             type BYTE value ('10'xn);
 dcl SEF_DEFAULT_OWNER_FROM_PARENT     type BYTE value ('20'xn);
 dcl SEF_DEFAULT_GROUP_FROM_PARENT     type BYTE value ('40'xn);

 dcl WT_EXECUTEDEFAULT                fixed bin(31) value('00000000'xn);
 dcl WT_EXECUTEINIOTHREAD             fixed bin(31) value('00000001'xn);
 dcl WT_EXECUTEINUITHREAD             fixed bin(31) value('00000002'xn);
 dcl WT_EXECUTEINWAITTHREAD           fixed bin(31) value('00000004'xn);
 dcl WT_EXECUTEONLYONCE               fixed bin(31) value('00000008'xn);
 dcl WT_EXECUTEINTIMERTHREAD          fixed bin(31) value('00000020'xn);
 dcl WT_EXECUTELONGFUNCTION           fixed bin(31) value('00000010'xn);
 dcl WT_EXECUTEINPERSISTENTIOTHREAD   fixed bin(31) value('00000040'xn);

 define alias WAITORTIMERCALLBACKFUNC
        entry (type PVOID,
               type BOOLEAN)
        limited NTAPI;

 define alias WORKERCALLBACKFUNC
        entry (type PVOID)
        limited NTAPI;

 define alias APC_CALLBACK_FUNCTION
        entry (type DWORD,
               type PVOID,
               type PVOID)
        limited NTAPI;

 dcl WT_EXECUTEINLONGTHREAD         type DWORD value('00000010'xu);
 dcl WT_EXECUTEDELETEWAIT           type DWORD value('00000008'xu);

 dcl DLL_PROCESS_ATTACH             fixed bin(31) value(1);
 dcl DLL_THREAD_ATTACH              fixed bin(31) value(2);
 dcl DLL_THREAD_DETACH              fixed bin(31) value(3);
 dcl DLL_PROCESS_DETACH             fixed bin(31) value(0);


 /* Defines for the READ flags for Eventlogging */

 dcl EVENTLOG_SEQUENTIAL_READ       type DWORD value('0001'xu);
 dcl EVENTLOG_SEEK_READ             type DWORD value('0002'xu);
 dcl EVENTLOG_FORWARDS_READ         type DWORD value('0004'xu);
 dcl EVENTLOG_BACKWARDS_READ        type DWORD value('0008'xu);


 /* The types of events that can be logged. */
 dcl EVENTLOG_SUCCESS               type WORD value('0000'xu);
 dcl EVENTLOG_ERROR_TYPE            type WORD value('0001'xu);
 dcl EVENTLOG_WARNING_TYPE          type WORD value('0002'xu);
 dcl EVENTLOG_INFORMATION_TYPE      type WORD value('0004'xu);
 dcl EVENTLOG_AUDIT_SUCCESS         type WORD value('0008'xu);
 dcl EVENTLOG_AUDIT_FAILURE         type WORD value('0010'xu);

 /* Defines for the WRITE flags used by Auditing for paired events */
 /* These are not implemented in Product 1 */

 dcl EVENTLOG_START_PAIRED_EVENT    type WORD value('0001'xu);
 dcl EVENTLOG_END_PAIRED_EVENT      type WORD value('0002'xu);
 dcl EVENTLOG_END_ALL_PAIRED_EVENTS type WORD value('0004'xu);
 dcl EVENTLOG_PAIRED_EVENT_ACTIVE   type WORD value('0008'xu);
 dcl EVENTLOG_PAIRED_EVENT_INACTIVE type WORD value('0010'xu);


 /* Structure that defines the header of the Eventlog record.         */
 /* This is the fixed-sized portion before all the variable-length    */
 /* strings, binary  data and pad bytes.                              */
 /*                                                                   */
 /* TimeGenerated is the time it was generated at the client.         */
 /* TimeWritten is the time it was put into the log at the server end.*/

 define structure
   1 EVENTLOGRECORD,
     2 Length        type DWORD,/* Length of full record */
     2 Reserved      type DWORD,/* Used by the service */
     2 RecordNumber  type DWORD,/* Absolute record number */
     2 TimeGenerated type DWORD,/* Seconds since 1-1-1970 */
     2 TimeWritten   type DWORD,/* Seconds since 1-1-1970 */
     2 EventID       type DWORD,
     2 EventType     type WORD,
     2 NumStrings    type WORD,
     2 EventCategory type WORD,
     2 ReservedFlags type WORD,/* For use with paired events(auditing)*/
     2 ClosingRecordNumber type DWORD, /* For use " " "     (auditing)*/
     2 StringOffset  type DWORD,/* Offset from beginning of record */
     2 UserSidLength type DWORD,
     2 UserSidOffset type DWORD,
     2 DataLength    type DWORD,
     2 DataOffset    type DWORD;/* Offset from beginning of record */
 /* Then follow:                  */
 /*                               */
 /*  2 SourceName    WCHAR(*) varz */
 /*  2 Computername  WCHAR(*) varz */
 /*  2 UserSid       type SID      */
 /*  2 Strings (*)   WCHAR(*) varz */
 /*  2 Data (*)      type BYTE     */
 /*  2 Pad           char(*)       */
 /*  2 Length        type DWORD    */

 define alias PEVENTLOGRECORD handle EVENTLOGRECORD;

 /* SS: start of changes to support clustering */

 dcl MAXLOGICALLOGNAMESIZE fixed bin (31) value (256);

 define structure
   1 EVENTSFORLOGFILE,
     2 ulSize           type DWORD,
     2 szLogicalLogFile WCHAR(MAXLOGICALLOGNAMESIZE - 1) varz,
       /* name of the logical file-security/application/system */
     2 ulNumRecords     type DWORD,
	    2 pEventLogRecords handle EVENTLOGRECORD;


 define alias PEVENTSFORLOGFILE handle EVENTSFORLOGFILE;

 define structure
   1 PACKEDEVENTINFO,
     2 ulSize                type DWORD,
       /* total size of the structure */
     2 ulNumEventsForLogFile type DWORD,
       /* number of EventsForLogFile structure that follow */
     2 ulOffsets   pointer; /* to (*) type DWORD */
       /* the offsets from the start of this structure to the */
       /* EVENTSFORLOGFILE structure                          */

 define alias PPACKEDEVENTINFO handle PACKEDEVENTINFO;

 /* SS: end of changes to support clustering */

 dcl DBG_CONTINUE              type DWORD value('00010002'xu);
 dcl DBG_TERMINATE_THREAD      type DWORD value('40010003'xu);
 dcl DBG_TERMINATE_PROCESS     type DWORD value('40010004'xu);
 dcl DBG_CONTROL_C             type DWORD value('40010005'xu);
 dcl DBG_CONTROL_BREAK         type DWORD value('40010008'xu);
 dcl DBG_EXCEPTION_NOT_HANDLED type DWORD value('80010001'xu);

 /* Registry Specific Access Rights. */

 dcl KEY_QUERY_VALUE        type DWORD value('0001'xu);
 dcl KEY_SET_VALUE          type DWORD value('0002'xu);
 dcl KEY_CREATE_SUB_KEY     type DWORD value('0004'xu);
 dcl KEY_ENUMERATE_SUB_KEYS type DWORD value('0008'xu);
 dcl KEY_NOTIFY             type DWORD value('0010'xu);
 dcl KEY_CREATE_LINK        type DWORD value('0020'xu);
 dcl KEY_READ               type DWORD
     value (iand (ior (STANDARD_RIGHTS_READ,
                       KEY_QUERY_VALUE,
                       KEY_ENUMERATE_SUB_KEYS,
                       KEY_NOTIFY),
                  inot(SYNCHRONIZE)));
 dcl KEY_WRITE              type DWORD
     value (iand (ior (STANDARD_RIGHTS_WRITE,
                       KEY_SET_VALUE,
                       KEY_CREATE_SUB_KEY),
                  inot(SYNCHRONIZE)));
 dcl KEY_EXECUTE            type DWORD
     value (iand (KEY_READ, inot (SYNCHRONIZE)));
 dcl KEY_ALL_ACCESS         type DWORD
     value (iand (ior (STANDARD_RIGHTS_ALL,
                       KEY_QUERY_VALUE,
                       KEY_SET_VALUE,
                       KEY_CREATE_SUB_KEY,
                       KEY_ENUMERATE_SUB_KEYS,
                       KEY_NOTIFY,
                       KEY_CREATE_LINK),
                  inot(SYNCHRONIZE)));


 /* Open/Create Options */

 dcl REG_OPTION_RESERVED       type DWORD value('00000000'xu);
     /* Parameter is reserved */

 dcl REG_OPTION_NON_VOLATILE   type DWORD value('00000000'xu);
     /* Key is preserved when system is rebooted */

 dcl REG_OPTION_VOLATILE       type DWORD value('00000001'xu);
     /* Key is not preserved when system is rebooted */

 dcl REG_OPTION_CREATE_LINK    type DWORD value('00000002'xu);
     /* Created key is a  symbolic link */

 dcl REG_OPTION_BACKUP_RESTORE type DWORD value('00000004'xu);
     /* open for backup or restore */
     /* special access rules privilege required */
 dcl REG_OPTION_OPEN_LINK      type DWORD value('00000008'xu);
     /* / Open symbolic link */
 dcl REG_LEGAL_OPTION          type DWORD
     value (ior (REG_OPTION_RESERVED,
                 REG_OPTION_NON_VOLATILE,
                 REG_OPTION_VOLATILE,
                 REG_OPTION_CREATE_LINK,
                 REG_OPTION_BACKUP_RESTORE,
                 REG_OPTION_OPEN_LINK ));


 /* Key creation/open disposition */

 dcl REG_CREATED_NEW_KEY     type DWORD value('00000001'xu);
     /* New Registry Key created */
 dcl REG_OPENED_EXISTING_KEY type DWORD value('00000002'xu);
     /* Existing Key opened */


 /* Key restore flags */

 dcl REG_WHOLE_HIVE_VOLATILE type DWORD value('00000001'xu);
     /* Restore whole hive volatile */
 dcl REG_REFRESH_HIVE        type DWORD value('00000002'xu);
     /* Unwind changes to last flush */
 dcl REG_NO_LAZY_FLUSH       type DWORD value('00000004'xu);
     /* Never lazy flush this hive */
 dcl REG_FORCE_RESTORE       type DWORD value('00000008'xu);
     /* Force the restore process even when we have open handles */
     /* on subkeys                                               */


 /* Notify filter values */

 dcl REG_NOTIFY_CHANGE_NAME       type DWORD value('00000001'xu);
     /* Create or delete (child) */
 dcl REG_NOTIFY_CHANGE_ATTRIBUTES type DWORD value('00000002'xu);
 dcl REG_NOTIFY_CHANGE_LAST_SET   type DWORD value('00000004'xu);
     /* time stamp */
 dcl REG_NOTIFY_CHANGE_SECURITY   type DWORD value('00000008'xu);
 dcl REG_LEGAL_CHANGE_FILTER fixed bin (31)
     value (ior (REG_NOTIFY_CHANGE_NAME,
                 REG_NOTIFY_CHANGE_ATTRIBUTES,
                 REG_NOTIFY_CHANGE_LAST_SET,
                 REG_NOTIFY_CHANGE_SECURITY));


 /* Predefined Value Types. */

 dcl REG_NONE                       type DWORD value(0 );
     /* No value type */
 dcl REG_SZ                         type DWORD value(1 );
     /* Unicode nul terminated string */
 dcl REG_EXPAND_SZ                  type DWORD value(2 );
     /* Unicode nul terminated string */
     /* (with environment variable references) */
 dcl REG_BINARY                     type DWORD value(3 );
     /* Free form binary */
 dcl REG_DWORD                      type DWORD value(4 );
     /* 32-bit number */
 dcl REG_DWORD_LITTLE_ENDIAN        type DWORD value(4 );
     /* 32-bit number (same as REG_DWORD) */
 dcl REG_DWORD_BIG_ENDIAN           type DWORD value(5 );
     /* 32-bit number */
 dcl REG_LINK                       type DWORD value(6 );
     /* Symbolic Link (unicode) */
 dcl REG_MULTI_SZ                   type DWORD value(7 );
     /* Multiple Unicode strings */
 dcl REG_RESOURCE_LIST              type DWORD value(8 );
     /* Resource list in the resource map */
 dcl REG_FULL_RESOURCE_DESCRIPTOR   type DWORD value(9 );
     /* Resource list in the hardware description */
 dcl REG_RESOURCE_REQUIREMENTS_LIST type DWORD value(10);
 dcl REG_QWORD                      type DWORD value(11);
     /* 64-bit number */
 dcl REG_QWORD_LITTLE_ENDIAN        type DWORD value(11);
     /* 64-bit number (same as REG_QWORD) */

 /* Service Types (Bit Mask) */

 dcl SERVICE_KERNEL_DRIVER       fixed bin(31) value('00000001'xn);
 dcl SERVICE_FILE_SYSTEM_DRIVER  fixed bin(31) value('00000002'xn);
 dcl SERVICE_ADAPTER             fixed bin(31) value('00000004'xn);
 dcl SERVICE_RECOGNIZER_DRIVER   fixed bin(31) value('00000008'xn);
 dcl SERVICE_DRIVER              fixed bin(31)
     value (ior (SERVICE_KERNEL_DRIVER,
                 SERVICE_FILE_SYSTEM_DRIVER,
                 SERVICE_RECOGNIZER_DRIVER));

 dcl SERVICE_WIN32_OWN_PROCESS   fixed bin(31) value('00000010'xn);
 dcl SERVICE_WIN32_SHARE_PROCESS fixed bin(31) value('00000020'xn);
 dcl SERVICE_WIN32               fixed bin(31)
     value (ior (SERVICE_WIN32_OWN_PROCESS,
                 SERVICE_WIN32_SHARE_PROCESS));

 dcl SERVICE_INTERACTIVE_PROCESS fixed bin(31) value('00000100'xn);

 dcl SERVICE_TYPE_ALL            fixed bin(31)
     value (ior (SERVICE_WIN32,
                 SERVICE_ADAPTER,
                 SERVICE_DRIVER,
                 SERVICE_INTERACTIVE_PROCESS));


 /* Start Type */

 dcl SERVICE_BOOT_START   fixed bin(31) value('00000000'xn);
 dcl SERVICE_SYSTEM_START fixed bin(31) value('00000001'xn);
 dcl SERVICE_AUTO_START   fixed bin(31) value('00000002'xn);
 dcl SERVICE_DEMAND_START fixed bin(31) value('00000003'xn);
 dcl SERVICE_DISABLED     fixed bin(31) value('00000004'xn);


 /* Error control type */

 dcl SERVICE_ERROR_IGNORE   fixed bin(31) value('00000000'xn);
 dcl SERVICE_ERROR_NORMAL   fixed bin(31) value('00000001'xn);
 dcl SERVICE_ERROR_SEVERE   fixed bin(31) value('00000002'xn);
 dcl SERVICE_ERROR_CRITICAL fixed bin(31) value('00000003'xn);


 /* Define the registry driver node enumerations */

 define ordinal _CM_SERVICE_NODE_TYPE
   ( DriverType               value( 1) /* SERVICE_KERNEL_DRIVER */
   , FileSystemType           value( 2) /* SERVICE_FILE_SYSTEM_DRIVER */
   , AdapterType              value( 4) /* SERVICE_ADAPTER */
   , RecognizerType           value( 8) /* SERVICE_RECOGNIZER_DRIVER */
   , Win32ServiceOwnProcess   value(16) /* SERVICE_WIN32_OWN_PROCESS */
   , Win32ServiceShareProcess value(32) /* SERVICE_WIN32_SHARE_PROCESS*/
     ) prec(31);
 define alias SERVICE_NODE_TYPE type _CM_SERVICE_NODE_TYPE;


 define ordinal _CM_SERVICE_LOAD_TYPE
   ( BootLoad    value(0) /* SERVICE_BOOT_START */
   , SystemLoad  value(1) /* SERVICE_SYSTEM_START */
   , AutoLoad    value(2) /* SERVICE_AUTO_START */
   , DemandLoad  value(3) /* SERVICE_DEMAND_START */
   , DisableLoad value(4) /* SERVICE_DISABLED */
   ) prec(31);
 define alias SERVICE_LOAD_TYPE type _CM_SERVICE_LOAD_TYPE;


 define ordinal _CM_ERROR_CONTROL_TYPE
   ( IgnoreError   value(0) /* SERVICE_ERROR_IGNORE */
   , NormalError   value(1) /* SERVICE_ERROR_NORMAL */
   , SevereError   value(2) /* SERVICE_ERROR_SEVERE */
   , CriticalError value(3) /* SERVICE_ERROR_CRITICAL */
   ) prec(31);
 define alias SERVICE_ERROR_TYPE type _CM_ERROR_CONTROL_TYPE;


 /* IOCTL_TAPE_ERASE definitions */

 dcl TAPE_ERASE_SHORT type DWORD value(0);
 dcl TAPE_ERASE_LONG  type DWORD value(1);

 define structure
   1 TAPE_ERASE,
     2 Type      type DWORD,
     2 Immediate type BOOLEAN;
 define alias PTAPE_ERASE handle TAPE_ERASE;


 /* IOCTL_TAPE_PREPARE definitions */

 dcl TAPE_LOAD    type DWORD value(0);
 dcl TAPE_UNLOAD  type DWORD value(1);
 dcl TAPE_TENSION type DWORD value(2);
 dcl TAPE_LOCK    type DWORD value(3);
 dcl TAPE_UNLOCK  type DWORD value(4);
 dcl TAPE_FORMAT  type DWORD value(5);

 define structure
   1 TAPE_PREPARE,
     2 Operation type DWORD,
     2 Immediate type BOOLEAN;
 define alias PTAPE_PREPARE handle TAPE_PREPARE;


 /* IOCTL_TAPE_WRITE_MARKS definitions */

 dcl TAPE_SETMARKS        type DWORD value(0);
 dcl TAPE_FILEMARKS       type DWORD value(1);
 dcl TAPE_SHORT_FILEMARKS type DWORD value(2);
 dcl TAPE_LONG_FILEMARKS  type DWORD value(3);

 define structure
   1 TAPE_WRITE_MARKS,
     2 Type      type DWORD,
     2 Count     type DWORD,
     2 Immediate type BOOLEAN;
 define alias PTAPE_WRITE_MARKS handle TAPE_WRITE_MARKS;


 /* IOCTL_TAPE_GET_POSITION definitions */

 dcl TAPE_ABSOLUTE_POSITION       type DWORD value(0);
 dcl TAPE_LOGICAL_POSITION        type DWORD value(1);
 dcl TAPE_PSEUDO_LOGICAL_POSITION type DWORD value(2);

 define structure
   1 TAPE_GET_POSITION,
     2 Type      type DWORD,
     2 Partition type DWORD,
     2 Offset    type LARGE_INTEGER;
 define alias PTAPE_GET_POSITION handle TAPE_GET_POSITION;


 /* IOCTL_TAPE_SET_POSITION definitions */

 dcl TAPE_REWIND                type DWORD value(0);
 dcl TAPE_ABSOLUTE_BLOCK        type DWORD value(1);
 dcl TAPE_LOGICAL_BLOCK         type DWORD value(2);
 dcl TAPE_PSEUDO_LOGICAL_BLOCK  type DWORD value(3);
 dcl TAPE_SPACE_END_OF_DATA     type DWORD value(4);
 dcl TAPE_SPACE_RELATIVE_BLOCKS type DWORD value(5);
 dcl TAPE_SPACE_FILEMARKS       type DWORD value(6);
 dcl TAPE_SPACE_SEQUENTIAL_FMKS type DWORD value(7);
 dcl TAPE_SPACE_SETMARKS        type DWORD value(8);
 dcl TAPE_SPACE_SEQUENTIAL_SMKS type DWORD value(9);

 define structure
   1 TAPE_SET_POSITION,
     2 Method    type DWORD,
     2 Partition type DWORD,
     2 Offset    type LARGE_INTEGER,
     2 Immediate type BOOLEAN;
 define alias PTAPE_SET_POSITION handle TAPE_SET_POSITION;


 /* IOCTL_TAPE_GET_DRIVE_PARAMS definitions */

 /* Definitions for FeaturesLow parameter */

 dcl TAPE_DRIVE_FIXED            type DWORD value('00000001'xu);
 dcl TAPE_DRIVE_SELECT           type DWORD value('00000002'xu);
 dcl TAPE_DRIVE_INITIATOR        type DWORD value('00000004'xu);

 dcl TAPE_DRIVE_ERASE_SHORT      type DWORD value('00000010'xu);
 dcl TAPE_DRIVE_ERASE_LONG       type DWORD value('00000020'xu);
 dcl TAPE_DRIVE_ERASE_BOP_ONLY   type DWORD value('00000040'xu);
 dcl TAPE_DRIVE_ERASE_IMMEDIATE  type DWORD value('00000080'xu);

 dcl TAPE_DRIVE_TAPE_CAPACITY    type DWORD value('00000100'xu);
 dcl TAPE_DRIVE_TAPE_REMAINING   type DWORD value('00000200'xu);
 dcl TAPE_DRIVE_FIXED_BLOCK      type DWORD value('00000400'xu);
 dcl TAPE_DRIVE_VARIABLE_BLOCK   type DWORD value('00000800'xu);

 dcl TAPE_DRIVE_WRITE_PROTECT    type DWORD value('00001000'xu);
 dcl TAPE_DRIVE_EOT_WZ_SIZE      type DWORD value('00002000'xu);

 dcl TAPE_DRIVE_ECC              type DWORD value('00010000'xu);
 dcl TAPE_DRIVE_COMPRESSION      type DWORD value('00020000'xu);
 dcl TAPE_DRIVE_PADDING          type DWORD value('00040000'xu);
 dcl TAPE_DRIVE_REPORT_SMKS      type DWORD value('00080000'xu);

 dcl TAPE_DRIVE_GET_ABSOLUTE_BLK type DWORD value('00100000'xu);
 dcl TAPE_DRIVE_GET_LOGICAL_BLK  type DWORD value('00200000'xu);
 dcl TAPE_DRIVE_SET_EOT_WZ_SIZE  type DWORD value('00400000'xu);

 dcl TAPE_DRIVE_EJECT_MEDIA      type DWORD value('01000000'xu);
 dcl TAPE_DRIVE_CLEAN_REQUESTS   type DWORD value('02000000'xu);
 dcl TAPE_DRIVE_SET_CMP_BOP_ONLY type DWORD value('04000000'xu);

 dcl TAPE_DRIVE_RESERVED_BIT     type DWORD value('80000000'xu);
     /* don't use this bit! can't be a low features bit! */
     /* reserved, high features only                     */


 /* Definitions for FeaturesHigh parameter */

 dcl TAPE_DRIVE_LOAD_UNLOAD      type DWORD value('80000001'xu);
 dcl TAPE_DRIVE_TENSION          type DWORD value('80000002'xu);
 dcl TAPE_DRIVE_LOCK_UNLOCK      type DWORD value('80000004'xu);
 dcl TAPE_DRIVE_REWIND_IMMEDIATE type DWORD value('80000008'xu);

 dcl TAPE_DRIVE_SET_BLOCK_SIZE   type DWORD value('80000010'xu);
 dcl TAPE_DRIVE_LOAD_UNLD_IMMED  type DWORD value('80000020'xu);
 dcl TAPE_DRIVE_TENSION_IMMED    type DWORD value('80000040'xu);
 dcl TAPE_DRIVE_LOCK_UNLK_IMMED  type DWORD value('80000080'xu);

 dcl TAPE_DRIVE_SET_ECC          type DWORD value('80000100'xu);
 dcl TAPE_DRIVE_SET_COMPRESSION  type DWORD value('80000200'xu);
 dcl TAPE_DRIVE_SET_PADDING      type DWORD value('80000400'xu);
 dcl TAPE_DRIVE_SET_REPORT_SMKS  type DWORD value('80000800'xu);

 dcl TAPE_DRIVE_ABSOLUTE_BLK     type DWORD value('80001000'xu);
 dcl TAPE_DRIVE_ABS_BLK_IMMED    type DWORD value('80002000'xu);
 dcl TAPE_DRIVE_LOGICAL_BLK      type DWORD value('80004000'xu);
 dcl TAPE_DRIVE_LOG_BLK_IMMED    type DWORD value('80008000'xu);

 dcl TAPE_DRIVE_END_OF_DATA      type DWORD value('80010000'xu);
 dcl TAPE_DRIVE_RELATIVE_BLKS    type DWORD value('80020000'xu);
 dcl TAPE_DRIVE_FILEMARKS        type DWORD value('80040000'xu);
 dcl TAPE_DRIVE_SEQUENTIAL_FMKS  type DWORD value('80080000'xu);

 dcl TAPE_DRIVE_SETMARKS         type DWORD value('80100000'xu);
 dcl TAPE_DRIVE_SEQUENTIAL_SMKS  type DWORD value('80200000'xu);
 dcl TAPE_DRIVE_REVERSE_POSITION type DWORD value('80400000'xu);
 dcl TAPE_DRIVE_SPACE_IMMEDIATE  type DWORD value('80800000'xu);

 dcl TAPE_DRIVE_WRITE_SETMARKS   type DWORD value('81000000'xu);
 dcl TAPE_DRIVE_WRITE_FILEMARKS  type DWORD value('82000000'xu);
 dcl TAPE_DRIVE_WRITE_SHORT_FMKS type DWORD value('84000000'xu);
 dcl TAPE_DRIVE_WRITE_LONG_FMKS  type DWORD value('88000000'xu);

 dcl TAPE_DRIVE_WRITE_MARK_IMMED type DWORD value('90000000'xu);
 dcl TAPE_DRIVE_FORMAT           type DWORD value('A0000000'xu);
 dcl TAPE_DRIVE_FORMAT_IMMEDIATE type DWORD value('C0000000'xu);
 dcl TAPE_DRIVE_HIGH_FEATURES    type DWORD value('80000000'xu);
     /* mask for high features flag */

 define structure
   1 TAPE_GET_DRIVE_PARAMETERS,
     2 ECC                   type BOOLEAN,
     2 Compression           type BOOLEAN,
     2 DataPadding           type BOOLEAN,
     2 ReportSetmarks        type BOOLEAN,
     2 DefaultBlockSize      type DWORD,
     2 MaximumBlockSize      type DWORD,
     2 MinimumBlockSize      type DWORD,
     2 MaximumPartitionCount type DWORD,
     2 FeaturesLow           type DWORD,
     2 FeaturesHigh          type DWORD,
     2 EOTWarningZoneSize    type DWORD;
 define alias PTAPE_GET_DRIVE_PARAMETERS
              handle TAPE_GET_DRIVE_PARAMETERS;


 /* IOCTL_TAPE_SET_DRIVE_PARAMETERS definitions */

 define structure
   1 TAPE_SET_DRIVE_PARAMETERS,
     2 ECC                type BOOLEAN,
     2 Compression        type BOOLEAN,
     2 DataPadding        type BOOLEAN,
     2 ReportSetmarks     type BOOLEAN,
     2 EOTWarningZoneSize type DWORD;
 define alias PTAPE_SET_DRIVE_PARAMETER
              handle TAPE_SET_DRIVE_PARAMETERS;


 /* IOCTL_TAPE_GET_MEDIA_PARAMETERS definitions */

 define structure
   1 TAPE_GET_MEDIA_PARAMETERS,
     2 Capacity       type LARGE_INTEGER,
     2 Remaining      type LARGE_INTEGER,
     2 BlockSize      type DWORD,
     2 PartitionCount type DWORD,
     2 WriteProtected type BOOLEAN;

 define alias PTAPE_GET_MEDIA_PARAMETERS
              handle TAPE_GET_MEDIA_PARAMETERS;


 /* IOCTL_TAPE_SET_MEDIA_PARAMETERS definitions */

 define structure
   1 TAPE_SET_MEDIA_PARAMETERS,
     2 BlockSize type DWORD;

 define alias PTAPE_SET_MEDIA_PARAMETERS
              handle TAPE_SET_MEDIA_PARAMETERS;

 /* IOCTL_TAPE_CREATE_PARTITION definitions */

 dcl TAPE_FIXED_PARTITIONS     fixed bin (31) value (0);
 dcl TAPE_SELECT_PARTITIONS    fixed bin (31) value (1);
 dcl TAPE_INITIATOR_PARTITIONS fixed bin (31) value (2);

 define structure
   1 TAPE_CREATE_PARTITION,
     2 Method type DWORD,
     2 Count  type DWORD,
     2 Size   type DWORD;
 define alias PTAPE_CREATE_PARTITION handle TAPE_CREATE_PARTITION;

 %end;

